#include "../webs.h"
#include <sys/socket.h>
#include <ctype.h>
#include <netinet/in.h>
#include "../../../npcs/VxRulemodule/config.h"

void RefreshRules(webs_t wp, char_t *path, char_t *query);

/* externvoid refresh() */
static int sockWrite(int sockfd,char *str,size_t count)
{
    size_t
        bytesSent=0;

    int
        thisWrite;

    while (bytesSent < count)
    {
       do
          thisWrite=write(sockfd,str,count-bytesSent);
       while ((thisWrite < 0) && (errno == EINTR));

       if (thisWrite <= 0)
          return (thisWrite);

        bytesSent += thisWrite;
        str += thisWrite;
    }
    return (count);
}

void refresh()
{
  int data_read =0;
  char request[1024];
  int rule_fd;


  data_read = sprintf(request, "Method:RULEREFRESH\r\n\r\n");

  printf("Before connectTo\n");

  if((rule_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT )) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
     exit;
   }

  printf("Before sockWrite\n");

  if (data_read != sockWrite(rule_fd, request, data_read))
     {
	(void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf()); 
        exit;
     }

}

int connectTo(char *netaddress, int port)
{

    struct sockaddr_in serverAddr;
    int sockAddrSize;

    int sockOut, retval;

    if ((sockOut = socket(AF_INET, SOCK_STREAM, 0)) == -1)
     {
         return ERROR;
     }

    sockAddrSize = sizeof(struct sockaddr_in);
    bzero((char *) &serverAddr, sockAddrSize);
    serverAddr.sin_family = AF_INET;
    /*serverAddr.sa_len = (u_char) sockAddrSize;*/
    serverAddr.sin_port = htons(port);

    if(((serverAddr.sin_addr.s_addr = inet_addr(netaddress)) == ERROR) &&
       ((serverAddr.sin_addr.s_addr = hostGetByName(netaddress)) == ERROR))
    {
      fprintf (stderr,"Unknown Server Name %s",netaddress);
      close (sockOut);
      return ERROR;

    }
    
    retval = connect(sockOut, (struct sockaddr *) &serverAddr, sockAddrSize);
 
    if(retval == ERROR)
     {
      (void) fprintf (stderr,"connect() to  %s failed !\n",netaddress);
      close(sockOut);
      return ERROR;
     }

    return sockOut;         /* connection OK */
}


void RefreshRules(webs_t wp, char_t *path, char_t *query)
{
    a_assert(websValid(wp));

    websHeader(wp);
 
    if(taskSpawn("refresh",100,0,20000,(FUNCPTR)refresh,0,0,0,0,0,0,0,0,0,0) == ERROR)
      {
        websWrite(wp, T("Error in spawning task<br>"));
      }

    websWrite(wp, T("Rule database refreshed..<br>"));

    websWrite(wp, T("<a href=\"http://128.198.60.32/npcs.htm\">HOME</a>"));

    websFooter(wp);
    websDone(wp, 200);
}