/* upldAndRefresh.c - GoForm to handle file upload */

/*
DESCRIPTION
This GoForm procedure handles http file upload.

*/

#include "../webs.h"
#include <sys/socket.h>
#include <ctype.h>
#include <netinet/in.h>
#include "../../../npcs/VxRulemodule/config.h"


/* forward declarations */
void        upldForm(webs_t wp, char_t * path, char_t * query);
void        refresh();


void upldAndRefresh(webs_t wp, char_t * path, char_t * query) {
    FILE *       fp;
    char_t *     fn;
    char_t *     bn = NULL;
    int          locWrite;
    int          numLeft;
    int          numWrite;
    char         fulfilename[100];
  
    int fdX;

    fulfilename[0] = '\0';

    strcat(fulfilename, "DEV1:\\\\");

    a_assert(websValid(wp));
    websHeader(wp);

    fn = websGetVar(wp, T("filename"), T(""));
    if (fn != NULL && *fn != '\0') {
        if ((int)(bn = gstrrchr(fn, '/') + 1) == 1) {
            if ((int)(bn = gstrrchr(fn, '\\') + 1) == 1) {
                bn = fn;
            }
        }
    }


    /* Append filename to the fullfilename array  */
    strcat(fulfilename, bn);  

    websWrite(wp, T("Filename parameter= %s<br>"), websGetVar(wp, T("filename"), T("")));
    websWrite(wp, T("Filename = %s<br>Size = %d bytes<br>"), bn, wp->lenPostData);
    websWrite(wp, T("Full Filename = %s<br>"), fulfilename);


    if ((fp = fopen((fulfilename == NULL ? "upldForm.bin" : fulfilename), "w+b")) == NULL) {
        websWrite(wp, T("File open failed!<br>"));
    } else {
        websWrite(wp, T("File opened!<br>"));
        locWrite = 0;
        numLeft = wp->lenPostData;
        while (numLeft > 0) {
            numWrite = fwrite(&(wp->postData[locWrite]), sizeof(*(wp->postData)), numLeft, fp);
            if (numWrite < numLeft) {
                websWrite(wp, T("File write failed.<br>  ferror=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes<br>"), ferror(fp), locWrite, numLeft, numWrite, wp->lenPostData);
            break;
            }
            locWrite += numWrite;
            numLeft -= numWrite;
        }

        if (numLeft == 0) {
            if (fclose(fp) != 0) {
                websWrite(wp, T("File close failed.<br>  errno=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes<br>"), errno, locWrite, numLeft, numWrite, wp->lenPostData);
            } else {
                websWrite(wp, T("File Size Written = %d bytes<br>"), wp->lenPostData);
            }
        } else {
            websWrite(wp, T("numLeft=%d locWrite=%d Size=%d bytes<br>"), numLeft, locWrite, wp->lenPostData);
        }
    }


    if(taskSpawn("refresh",100,0,20000,(FUNCPTR)refresh,0,0,0,0,0,0,0,0,0,0) == ERROR)
      {
        websWrite(wp, T("Error in spawning task<br>"));
      }



    websWrite(wp, T("Rule database refreshed..<br>"));


/**************** added by JBP 6/23 ****************/
    websWrite(wp, T("<a href=\"http://128.198.60.32:8000/%s\">Display %s</a><br>"), bn, bn);
    websWrite(wp, T("<a href=\"http://128.198.60.32:8000/npcs.htm\">HOME</a>"));  

/****************************************************/


    websFooter(wp);
    websDone(wp, 200);
}    /* void upldForm(webs_t wp, char_t * path, char_t * query) */

