/* upldForm.c - GoForm to handle file upload */

/*
DESCRIPTION
This GoForm procedure handles http file upload.

*/

#include "../webs.h"
#include <sys/socket.h>
#include <ctype.h>
#include <netinet/in.h>
#include "../../../npcs/VxRulemodule/config.h"
#include <vxworks.h>
#include <timers.h>
#include <stdio.h>


/* forward declarations */
void        upldForm(webs_t wp, char_t * path, char_t * query);
void tvsubtract( struct timeval *out, struct timeval *in );
void        refresh();

/*******************************************************************************
*
* upldForm - GoForm procedure to handle file uploads for upgrading device
*
* This routine handles http file uploads for upgrading device.
*
* RETURNS: OK, or ERROR if the I/O system cannot install the driver.
*/

extern delfile();
extern rmshutdown();
extern rmstartup();
extern unldrulemodule();
extern ldrule1();

void upldForm(webs_t wp, char_t * path, char_t * query) {
    FILE *       fp;
    char_t *     fn;
    char_t *     bn = NULL;
    int          locWrite;
    int          numLeft;
    int          numWrite;
    char         fulfilename[100];
  
    int fdX;

  double retval, val2, diff;
  struct timespec ts;

  char line[80], line2[80];

    fulfilename[0] = '\0';


    strcat(fulfilename, "DEV1:\\\\");


    a_assert(websValid(wp));
    websHeader(wp);

    /*
    if(taskSpawn("rmshutdown",100,0,20000,(FUNCPTR)rmshutdown,0,0,0,0,0,0,0,0,0,0) == ERROR)
      {
	if taskSpawn fails, close fd and return to top of loop 
        websWrite(wp, T("Error in spawning task<br>"));
      }
    websWrite(wp, T("rulemodule shutdown successfully <br>"));
    
     taskDelay(120);

    if(taskSpawn("unldrulemodule",100,0,20000,(FUNCPTR)unldrulemodule,0,0,0,0,0,0,0,0,0,0) == ERROR)
      {

        websWrite(wp, T("Error in spawning task<br>"));
      }
    websWrite(wp, T("rulemodule unloaded successfully <br>"));

     taskDelay(120);

    if(taskSpawn("delfile",100,0,20000,(FUNCPTR)delfile,"DEV1:/VxRulemodule.out",0,0,0,0,0,0,0,0,0) == ERROR)
      {

        websWrite(wp, T("Error in spawning task<br>"));
      }
    websWrite(wp, T("deleted existing rulemodule<br>"));
*/
    taskDelay(120);

    fn = websGetVar(wp, T("filename"), T(""));
    if (fn != NULL && *fn != '\0') {
        if ((int)(bn = gstrrchr(fn, '/') + 1) == 1) {
            if ((int)(bn = gstrrchr(fn, '\\') + 1) == 1) {
                bn = fn;
            }
        }
    }


    /* Append filename to the fullfilename array  */
    strcat(fulfilename, bn);  

    websWrite(wp, T("Filename parameter= %s<br>"), websGetVar(wp, T("filename"), T("")));
    websWrite(wp, T("Filename = %s<br>Size = %d bytes<br>"), bn, wp->lenPostData);
    websWrite(wp, T("Full Filename = %s<br>"), fulfilename);


  if(clock_gettime(CLOCK_REALTIME, &ts))
    {
      printf("clock_gettime: err\n");
    }

  retval = ((double) ts.tv_sec) + ((double) ts.tv_nsec)*1e-9;

   sprintf(line,"%f", retval);

  websWrite(wp, T("retval1=%s<br>"), line);


/*     if ((fp = fopen((bn == NULL ? "upldForm.bin" : bn), "w+b")) == NULL) {  */
    if ((fp = fopen((fulfilename == NULL ? "upldForm.bin" : fulfilename), "w+b")) == NULL) {
        websWrite(wp, T("File open failed!<br>"));
    } else {
        websWrite(wp, T("File opened!<br>"));
        locWrite = 0;
        numLeft = wp->lenPostData;
        while (numLeft > 0) {
            numWrite = fwrite(&(wp->postData[locWrite]), sizeof(*(wp->postData)), numLeft, fp);
            if (numWrite < numLeft) {
                websWrite(wp, T("File write failed.<br>  ferror=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes<br>"), ferror(fp), locWrite, numLeft, numWrite, wp->lenPostData);
            break;
            }
            locWrite += numWrite;
            numLeft -= numWrite;
        }

        if (numLeft == 0) {
            if (fclose(fp) != 0) {
                websWrite(wp, T("File close failed.<br>  errno=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes<br>"), errno, locWrite, numLeft, numWrite, wp->lenPostData);
            } else {
                websWrite(wp, T("File Size Written = %d bytes<br>"), wp->lenPostData);
            }
        } else {
            websWrite(wp, T("numLeft=%d locWrite=%d Size=%d bytes<br>"), numLeft, locWrite, wp->lenPostData);
        }
    }


    if(taskSpawn("refresh",100,0,20000,(FUNCPTR)refresh,0,0,0,0,0,0,0,0,0,0) == ERROR)
      {
        websWrite(wp, T("Error in spawning task<br>"));
      }


  if(clock_gettime(CLOCK_REALTIME, &ts))
    {
      printf("clock_gettime: err\n");
    }
  val2 = ((double) ts.tv_sec) + ((double) ts.tv_nsec)*1e-9;


   sprintf(line2,"%f", val2);

   websWrite(wp, T("ret2=%s<br>"), line);

    websWrite(wp, T("Rule database refreshed..<br>"));


/**************** added by JBP 6/23 ****************/
    websWrite(wp, T("<a href=\"http://128.198.60.32:8000/%s\">Display %s</a><br>"), bn, bn);
    websWrite(wp, T("<a href=\"http://128.198.60.32:8000/npcs.htm\">HOME</a>"));  

/****************************************************/

  /* Load the new module  
    if ( (fdX = open ("DEV1:/VxRulemodule.out", O_RDONLY, 0)) == ERROR) {  
       printf("ERROR\n");
    }
    else {
    loadModule (fdX, LOAD_ALL_SYMBOLS);
    close (fdX);
    }
    
   ldrule1();

    taskDelay(120);
    Start the new rulemodule          
    rmstartup();  

    websWrite(wp, T("rulemodule started successfully <br>"));
*/

    websFooter(wp);
    websDone(wp, 200);
}    /* void upldForm(webs_t wp, char_t * path, char_t * query) */

void RefreshRules(webs_t wp, char_t *path, char_t *query);

/* extern refresh();  */
static int sockWrite(int sockfd,char *str,size_t count)
{
    size_t
        bytesSent=0;

    int
        thisWrite;

    while (bytesSent < count)
    {
       do
          thisWrite=write(sockfd,str,count-bytesSent);
       while ((thisWrite < 0) && (errno == EINTR));

       if (thisWrite <= 0)
          return (thisWrite);

        bytesSent += thisWrite;
        str += thisWrite;
    }
    return (count);
}

void refresh()
{
  int data_read =0;
  char request[1024];
  int rule_fd;


  data_read = sprintf(request, "Method:RULEREFRESH\r\n\r\n");

  printf("Before connectTo\n");

  if((rule_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT )) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
     exit;
   }

  printf("Before sockWrite\n");

  if (data_read != sockWrite(rule_fd, request, data_read))
     {
	(void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf()); 
        exit;
     }

}

int connectTo(char *netaddress, int port)
{

    struct sockaddr_in serverAddr;
    int sockAddrSize;

    int sockOut, retval;

    if ((sockOut = socket(AF_INET, SOCK_STREAM, 0)) == -1)
     {
         return ERROR;
     }

    sockAddrSize = sizeof(struct sockaddr_in);
    bzero((char *) &serverAddr, sockAddrSize);
    serverAddr.sin_family = AF_INET;
    /*serverAddr.sa_len = (u_char) sockAddrSize;*/
    serverAddr.sin_port = htons(port);

    if(((serverAddr.sin_addr.s_addr = inet_addr(netaddress)) == ERROR) &&
       ((serverAddr.sin_addr.s_addr = hostGetByName(netaddress)) == ERROR))
    {
      fprintf (stderr,"Unknown Server Name %s",netaddress);
      close (sockOut);
      return ERROR;

    }
    
    retval = connect(sockOut, (struct sockaddr *) &serverAddr, sockAddrSize);
 
    if(retval == ERROR)
     {
      (void) fprintf (stderr,"connect() to  %s failed !\n",netaddress);
      close(sockOut);
      return ERROR;
     }

    return sockOut;         /* connection OK */
}
