/* net_app.cpp
 * SA1200 Network Application
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: core network application
 *  author: dfh, May 13, 99  Initial version
 *  revisions:
 *  $History: net_app.cpp $
 * 
 * *****************  Version 47  *****************
 * User: Admin        Date: 5/15/00    Time: 1:32p
 * Updated in $/V1.0/SA1_CoreLibs/app_1200
 * merged with IAL change Hudson5-11-00.zip
 * 
 * *****************  Version 45  *****************
 * User: Qabuild      Date: 5/05/00    Time: 11:21a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * remove extern "C" define  for netapp_init()
 * 
 * *****************  Version 44  *****************
 * User: Mffallon     Date: 5/04/00    Time: 1:02p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Initialize the second fast port queued element count to zero.
 * 
 * *****************  Version 43  *****************
 * User: Lhui         Date: 5/02/00    Time: 8:30p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Add extern "C" 
 * 
 * *****************  Version 42  *****************
 * User: Lhui         Date: 4/18/00    Time: 6:30p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Merge with IAL source 4/12/2000
 * 
 * *****************  Version 1  *****************
 * User: Qabuild      Date: 4/18/00    Time: 5:45p
 * Created in $/Bigpine/SDKChanges/CoreLibs/app_1200
 * added from IAL zip file 4/12/00
 * 
 * *****************  Version 41  *****************
 * User: Drjohns1     Date: 3/17/00    Time: 3:44p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Reset fbi & macs before init'ing the libraries
 * 
 * *****************  Version 39  *****************
 * User: Jdguilfo     Date: 2/22/00    Time: 8:42a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Don't change clock speed, due to rev-D board design
 * 
 * *****************  Version 38  *****************
 * User: Dhooper      Date: 1/21/00    Time: 3:37p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * rt_lookup returns int
 * 
 * *****************  Version 37  *****************
 * User: Mffallon     Date: 1/19/00    Time: 4:27p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Add two functions NetApp_ConfigRate176 and NetApp_ConfigRate192.  These
 * functions set the PLL_CFG register as well as configure SDRAM to
 * operate correctly.
 * 
 * *****************  Version 35  *****************
 * User: Drjohns1     Date: 1/07/00    Time: 5:47p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Added uof init callback installation
 * 
 * *****************  Version 34  *****************
 * User: Drjohns1     Date: 1/05/00    Time: 3:42p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * For Bridge: Init SvLib after ucode has been loaded
 * 
 * *****************  Version 33  *****************
 * User: Drjohns1     Date: 1/04/00    Time: 2:40p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Revert to making sysConfig local to the module
 * 
 * *****************  Version 31  *****************
 * User: Drjohns1     Date: 12/17/99   Time: 12:04p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Incorporated rtm and brm into netApp
 * 
 * *****************  Version 30  *****************
 * User: Dhooper      Date: 11/05/99   Time: 8:08a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * only set clock rate 176MHZ for gigabit, eval card
 * 
 * *****************  Version 29  *****************
 * User: Dhooper      Date: 10/15/99   Time: 12:14p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Initialize MACs in big endian mode.
 * 
 * *****************  Version 28  *****************
 * User: Lhui         Date: 10/08/99   Time: 6:46p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * 
 * *****************  Version 27  *****************
 * User: Dhooper      Date: 8/18/99    Time: 11:15a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * put void * arg back in NetAp_Init. call NetApp_Init with NULL for
 * NetApp_GigInit
 * 
 * *****************  Version 26  *****************
 * User: Dhooper      Date: 8/18/99    Time: 10:47a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * remove void* arg to NetApp_Init
 * 
 * *****************  Version 25  *****************
 * User: Dhooper      Date: 8/17/99    Time: 6:07p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * eval card support
 * 
 * *****************  Version 24  *****************
 * User: Drjohns1     Date: 8/05/99    Time: 7:51p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Add a compile option for printf to avoid the UCOS serial port problem 
 * 
 * *****************  Version 23  *****************
 * User: Dhooper      Date: 8/02/99    Time: 2:41p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * NetApp_BigEndian return void
 * 
 * *****************  Version 22  *****************
 * User: Dhooper      Date: 7/30/99    Time: 4:26p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * call fbus configure setting big endian
 * 
 * *****************  Version 21  *****************
 * User: Dhooper      Date: 7/30/99    Time: 3:30p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * default fbi to little endian
 * 
 * *****************  Version 19  *****************
 * User: Dhooper      Date: 7/20/99    Time: 10:10a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * on reset, don't take.give control
 * 
 * *****************  Version 18  *****************
 * User: Hqianx       Date: 7/19/99    Time: 3:30p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Added #ifdef ROUTE to function: rt_addr() and rt_lookup().
 * 
 * *****************  Version 17  *****************
 * User: Dhooper      Date: 7/19/99    Time: 9:57a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * clean up warnings about unused local variables
 * 
 * *****************  Version 16  *****************
 * User: Skornfel     Date: 7/15/99    Time: 2:44p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * move PC=0 functions in start to config_1200
 * 
 * *****************  Version 15  *****************
 * User: Skornfel     Date: 7/13/99    Time: 5:51p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * load routes in NetApp_Init
 * 
 * *****************  Version 13  *****************
 * User: Lhui         Date: 7/06/99    Time: 10:48a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * Add WBSvr_Init 
 * 
 * *****************  Version 12  *****************
 * User: Lhui         Date: 6/22/99    Time: 9:47a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * include ueng.h and rtm.h
 * 
 * *****************  Version 11  *****************
 * User: Skornfel     Date: 6/21/99    Time: 9:41a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * 12 port refdes run
 * 
 * *****************  Version 10  *****************
 * User: Skornfel     Date: 6/14/99    Time: 1:54p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * include route and bridge
 * 
 * *****************  Version 9  *****************
 * User: Dhooper      Date: 6/09/99    Time: 7:08p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * #ifdef UC_BUFFER around the function NetApp_UCLoadBuffer
 * 
 * *****************  Version 8  *****************
 * User: Jdguilfo     Date: 6/09/99    Time: 7:01p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * #ifdef UC_BUFFER, UCLoadBuffer, UCLoadFile
 * 
 * *****************  Version 7  *****************
 * User: Dhooper      Date: 6/08/99    Time: 10:41a
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * separate NetApp_UCLoadFile
 * 
 * *****************  Version 6  *****************
 * User: Dhooper      Date: 6/03/99    Time: 9:24p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * extern sysConf
 * 
 * *****************  Version 5  *****************
 * User: Dhooper      Date: 6/03/99    Time: 1:27p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * add portMask for Start and  Stop, add thread registry
 * 
 * *****************  Version 4  *****************
 * User: Dhooper      Date: 6/02/99    Time: 2:50p
 * Updated in $/dev_1200/SA1_CoreLibs/app_1200
 * move netapp functions to sysconf
 * 
 * *****************  Version 1  *****************
 * User: Dhooper      Date: 5/19/99    Time: 9:59a
 * Created in $/BL5_Plus/SA1_CoreLibs/app_1200
 * app_1200 pre-review
 * 
 * 
 * ---------------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>
#include "mem_map.h"
#include "config_1200.h"
#include "net_app.h"
#include "ueng.h"

#ifdef MAC_21440
#include "BigMacAPI.h"
#endif

#ifdef ROUTE
#ifdef RTM_MVR
#include "rtm_mvr.h"
#else
#include "rtm.h"
#endif
#endif

#ifdef BRIDGE
#include "brm.h"
#endif

#ifdef WB_SVR
int WbSvr_init();
#endif

#ifdef PETH_DRV
#include "end.h"
#include "muxLib.h"
extern "C" {
    extern END_OBJ *pethEndLoad(char *, void *);
}
#endif
// added by Yang S.C 89.8.9 
// used for NetApp_UCLoadBuffer( ) the buffer is delared in app1200/ucld.c
extern   unsigned int HexUofSize__mvrucode ;
extern  unsigned int HexUof__mvrucode[] ;


// single instance containing the system configuration
static SysConf *sysConf;


/*-----------------------------------------------------------------
	NetApp_LoadRoutes
	Load route table, for up to 16 100M ports
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_LoadRoutes()
{
#ifdef ROUTE
#ifndef RTM_MVR
	rt_add("1.1.1.1", "255.0.0.0", 1);						// load route with dest port
	rt_add("2.2.2.2", "255.255.0.0", 2);
	rt_add("3.3.3.3", "255.255.255.0", 3);
	rt_add("4.4.4.4", "255.255.255.255", 4);
	rt_add("16.16.16.16", "255.255.255.255", 5);
	rt_add("17.17.17.17", "255.255.255.0", 6);
	rt_add("18.18.18.18", "255.255.0.0", 7);
	rt_add("19.19.19.19", "255.0.0.0", 8);
	rt_add("8.8.8.8", "255.255.255.255", 8);   // added by Yang 89.8.9 for testing
	rt_add("20.20.20.20", "255.255.255.127", 9);
	rt_add("21.21.21.21", "255.255.255.255", 10);
	rt_add("21.21.21.20", "255.255.255.255", 11);
	rt_add("4.4.4.6", "255.255.255.255", 0);
	rt_add("21.21.21.19", "255.255.255.255", 12);
	rt_add("21.21.21.18", "255.255.255.255", 13);
	rt_add("21.21.21.17", "255.255.255.255", 14);
	rt_add("4.4.4.5", "255.255.255.255", 15);
#endif /* RTM_MVR */
#endif /* ROUTE */
	return(0);
}

int check_route(char * dest, int oport)
{
#ifdef ROUTE
#ifndef RTM_MVR
	if (oport != rt_lookup(dest)){
#ifdef _DBG_PRINT
		printf("rt_lookup failed, dest: %s, output port: %d\n", dest, oport);
#endif
		return(1);
	}
#endif /* RTM_MVR */
#endif /* ROUTE */
	return(0);
}
int NetApp_VerifyRoutes()
{
	check_route("1.1.1.1", 1);
	check_route("2.2.2.2", 2);
	check_route("3.3.3.3", 3);
	check_route("4.4.4.4", 4);
	check_route("16.16.16.16", 5);
	check_route("17.17.17.17", 6);
	check_route("18.18.18.18", 7);
	check_route("19.19.19.19", 8);
	check_route("20.20.20.20", 9);
	check_route("21.21.21.21", 10);
	check_route("21.21.21.20", 11);
	check_route("4.4.4.6", 0);
	check_route("21.21.21.19", 12);
	check_route("21.21.21.18", 13);
	check_route("21.21.21.17", 14);
	check_route("4.4.4.5", 15);

	return(0);
}


/*-----------------------------------------------------------------
	NetApp_ZeroGPRs
	Initialize all microengine A and B bank GPRs to 0
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_ZeroGPRs()
{
	int box, regnum, ctx;

	for (box=0;box<6;box++){
		for (ctx=0;ctx<4;ctx++){

			for (regnum=0;regnum<16;regnum++){
				uEng_writeRelGpr(box, 0, ctx, regnum,0);	// 0 = GPR-A
			}
			for (regnum=0;regnum<16;regnum++){
				uEng_writeRelGpr(box, 1, ctx, regnum,0);	// 1 = GPR-B
			}
		}
	}
	return(0);
}

void NetApp_StateInit()
{
	int i;

	// initialize all GPRs to 0
	NetApp_ZeroGPRs();

#ifdef PETH_DRV
        SramUnit *sram = SRAM_Attach();
        // Initialize XMIT_PWP_VECTOR in SRAM to zero
        if (NULL == sram) {
            printf("Failed to attach to SRAM, cannot initialize XMIT_PWP_VECTOR\n");
        } else {
            sram->clear_bits((XMIT_PWP_VECTOR<<2), 0xffffffff);
        }
#endif PETH_DRV

	// init sram queues
	for(i = 0; i<544; i++){
		SRAM_Write(SRAM_QUEUE_DESCRIPTOR_BASE+i, 0);
	}
	// initialize slow port state
	//
	for(i = 0; i<32; i++){
		SRAM_Write(REC_SLOW_PORT_STATE+i, 0);
	}

	// init scratch
	for(i=0; i<1024; i++){
		Scratch_Write(i, 0);
	}

#ifdef PETH_DRV
        // Set an undocumented bit in the SRAM csr to help out with
        // the read_lock_spin routine in the SramUnit
        unsigned int csr;
        sram->getSRAM_CSR(&csr);
        sram->setSRAM_CSR(csr | (1 << 4));
#endif PETH_DRV

	return;
}

void NetApp_FastPortStateInit()
{
	int i;

	// init scratch task message area  in case it is used for task assignments
	//
	for(i = 0; i<35; i++){
		Scratch_Write(XMIT_TASK_MSG_BASE+i, 0x80000000);
	}


	// initialize fast port count of queued elements
	//
	SRAM_Write(XMIT_FPORT1_ELE_COUNT, 0);
	SRAM_Write(XMIT_FPORT2_ELE_COUNT, 0);


	// initialize fast port indexes at queue descriptor array
	//
	for(i = 0; i<32; i=i+2){
		SRAM_Write(SRAM_QUEUE_DESCRIPTOR_BASE+0x100+i, 1);
	}

	return;
}


/*-----------------------------------------------------------------
	NetApp_BigEndian
	Change FBI and MACs to big endian
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
void NetApp_BigEndian()
{
#ifndef SCOMM
#ifdef MAC_21440
	OctalMACCofigureEndian(0, BIG);	// either Eval Card or Validation Board
#endif

#ifdef MAC_GC82547EB
	GigMACCofigureEndian(BIG);		// Eval Card: default for now is little 
#else
#ifdef MAC_21440
	OctalMACCofigureEndian(1, BIG);	// Validation Board, second octal mac
#endif
#endif

	sysConf->byte_order = 1;
	sysConf->ConfigureFBusInterface();
	return;
#endif
}


/*-----------------------------------------------------------------
	NetApp_UofLoaded
	Gets called whenever UOF is loaded.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_UofLoaded(void *arg)
{
	int retval = 0;
#ifdef BRIDGE
	retval |= !Br_SvInit();		// init the hash & mem services
#endif
	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_Init
	Reset and initialize drivers and microengines.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/

int NetApp_Init(void)
{
	int retval = 0;

	sysConf = SysConf_Attach();
	sysConf->TakeControl();
	retval |= sysConf->Reset(0, ALL_PORTS_MASK);		// don't reset microengines
	retval |= sysConf->Init();							// init libs

	sysConf->nextSymbol = 0;							// start with new import_vars

	NetApp_StateInit();		// init	GPRs=0, scratch=0

    NetApp_BigEndian();     // run in big endian mode

#ifdef BRIDGE
	// install UOF init callback -- currently only useful for BRM
	sysConf->SetUofCb(NetApp_UofLoaded, NULL);

	// initialize bridge manager
	Br_Init();
#endif

	
#ifdef ROUTE
	// initialize route table manager
	RTM_Init();

	// load routes for up to 16 ports
	NetApp_LoadRoutes();
#endif
	sysConf->GiveControl();

#ifdef WB_SVR
	// startup workbench server to use hop, breakpoint, see registers, etc.
	retval |= WbSvr_init();
#endif

#ifdef PETH_DRV
        // Initialize the pseudo ethernet driver
     // mark by Yang S.C for test purpose 89.8.13
     // We put the pseudo driver  codes to separate file PethDrvInit.cpp for easy testing 
    /*    char pethInitStr[3];
        int pethDrvNum;
        END_OBJ *pEnd;
        void *cookie;

        // For each port create a new instance of the driver
        for (pethDrvNum = 0; pethDrvNum < PETH_NUM_DEVS; ++pethDrvNum) {
            sprintf(pethInitStr, "%d:", pethDrvNum);
            cookie = muxDevLoad(pethDrvNum, pethEndLoad, pethInitStr, 0, NULL);
            if (NULL == cookie) {
                printf("Failed to load Pseudo Ethernet driver number %d\n", 
                       pethDrvNum);
                continue;
            }
            
            // Start the driver
            if (OK != muxDevStart(cookie)) {
                printf("Failed to start Pseudo Ethernet driver number %d\n", 
                       pethDrvNum);
                continue;
            }

            // Attach each driver to the ipStack
            if (OK != ipAttach(pethDrvNum, "peth")) {
                printf("Failed to attach device %d to ip stack\n", pethDrvNum);
            }
        }
       */ 
         /*usrNetIfAttach("peth",0,"320.61.47.20")
         printf("\n the usrNetIfAttach !");*/
         
        
#endif

	return(retval);
}






/*-----------------------------------------------------------------
	NetApp_UCLoadBuffer
	Load system parameters from global buffer HexUof.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_UCLoadBuffer( unsigned int *hexUof, unsigned int hexUofSize)
{
	int retval;

	sysConf->TakeControl();
	retval = sysConf->UCLoadBuffer(hexUof, hexUofSize);
	sysConf->GiveControl();

	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_UCLoadFile
	Load system parameters from a file.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_UCLoadFile(char *filename)
{
	int retval;

	sysConf->TakeControl();
	retval = sysConf->UCLoadFile(filename);
	sysConf->GiveControl();

	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_LoadSysParam
	Load system parameters from a file.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_LoadSysParam(char *filename)
{
	int retval;

	sysConf->TakeControl();
	retval = sysConf->Load(filename);
	sysConf->GiveControl();

	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_Reset
	Reset drivers and microengines.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_Reset(unsigned int engine_mask, unsigned int port_mask)
{
	int retval;

//	sysConf->TakeControl();
	// reset uengines, unreset uengines, reset ports
	retval = sysConf->Reset(engine_mask, port_mask);
//	sysConf->GiveControl();

	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_Run
	Run network application. Start drivers and microengines.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_Run(unsigned int engine_mask, unsigned int port_mask)
{
	int retval = 0;

	sysConf->TakeControl();
	// configure fbi and macs
	retval |= sysConf->Configure();
	// set PCs=0, set wakeup voluntary, start uengines
	retval |= sysConf->Start(engine_mask, port_mask);
	sysConf->GiveControl();

	return(retval);
}

/*-----------------------------------------------------------------
	NetApp_Stop
	Stop network application. Stop drivers and microengines.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_Stop(unsigned int engine_mask, unsigned int port_mask)
{
	int retval;

	sysConf->TakeControl();
	
	// reset uengines, unreset uengines, stop and reset ports
	retval = sysConf->Stop(engine_mask, port_mask);
	sysConf->GiveControl();

	return(retval);
}


/*-----------------------------------------------------------------
	NetApp_Start
	Start microengines at PC 0, start ports
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
int NetApp_Start(unsigned int engine_mask, unsigned int port_mask)
{
	int retval;

	sysConf->TakeControl();
	// set PCs=0, set wakeup voluntary, start uengines
	retval = sysConf->Start(engine_mask, port_mask);
	sysConf->GiveControl();

	return(retval);
}

void NetApp_ConfigureFBusInterface()
{
	sysConf->ConfigureFBusInterface();
	return;
}
void NetApp_ConfigRate176()
{
	WRITE_LWORD(CSR_PLL_CFG, MHZ_176);				// set clock rate for eval card
	WRITE_LWORD(SDRAM_MEMCTL0, 0x056682c8);      // set sdram configuration based on clock speed
	WRITE_LWORD(SDRAM_MEMCTL1, 0x12361141);
	WRITE_LWORD(SDRAM_MEMINIT, 0x00122292);
	return;
}

void NetApp_ConfigRate192()
{
	WRITE_LWORD(CSR_PLL_CFG, MHZ_192);				// set clock rate for eval card
	WRITE_LWORD(SDRAM_MEMCTL0, 0x05d982c8); 		// set sdram configuration based on clock speed
	WRITE_LWORD(SDRAM_MEMCTL1, 0x12361141);
	WRITE_LWORD(SDRAM_MEMINIT, 0x00122574);
	return;
}

void NetApp_GigInit()
{
	
	NetApp_Init();
	NetApp_FastPortStateInit();
   NetApp_BigEndian();              // run in big endian mode
   
   // added by Yang 88.8.9 
      // Load the ucode from buffer in /app1200/ucld.c  and start uE 0-5 , start port 0-8 
   	
   	
   	if(NetApp_UCLoadBuffer(HexUof__mvrucode, HexUofSize__mvrucode) != SYSCONF_SUCCESS)
   	 printf("\n The ucload buffer is fialed");
   	else
   	  printf("\n the ucload buffer is succeed"); 
   	  
   	// init the port 0-8 and ue 0-5  , (port 8 is giga port ) 
   	
   	
   	if( NetApp_Run(0x3f, 0x1ff) != SYSCONF_SUCCESS)
   	 printf("\n The netapp run  is fialed");
   	else
   	 printf("\n the  netApp run is succeed"); 
	return;
	
         
	
}


