#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>
 
#include "operators.h"

#if 0
struct operatoritem
{
        char *shortcut;
        char *symbol;
        char *help;
};

struct relationaloperatoritem
{
        char *shortcut;
        char *symbol;
        char *help;
};

struct variableitem
{
        char *command;
        char *help;
};

struct actionitem
{
        char *shortcut;
        char *symbol;
        char *help;
};

#endif

struct operatoritem operatoritems[] =
{
        { "gt",  ">",       "greater than" },
        { "lt",  "<",       "less than" },
        { "ge",  ">=",      "greater than or equal to" },
        { "le",  "<=",       "less than or equal to" },
        { "eq",  "==",       "equal to" },
        { "ne",  "!=",       "not equal to" },
        { "pnd",  "#",       "pound used for string match only" },
        { NULL, NULL, NULL}
};

struct relationaloperatoritem relationaloperatoritems[] =
{
        { "and",  "&&",       "And concatination" },
        { NULL, NULL, NULL}
};

struct variableitem variableitems[] =
{
        { "url",                "Uniform Resource Identifier" },
        { "parameter",          "contains a parameter pattern in arguments passed" },
        { "NumberOfParameters", "input number of patterns" },
        { "XML","XML"},
        { NULL,  NULL}
};

struct actionitem actionitems[] =
{
        { "grantAccess",        "ga",   "Uniform Resource Identifier" },
        { "rejectAccess",       "ra",   "contains a parameter pattern in arguments passed" },
        { "acquirePrivilages",  "ap",   "input number of patterns" },
        { "contact",            "cs",   "input number of patterns" },
        { NULL,  NULL, NULL}
};

struct operatoritem *operator_find(char *cmd)
{
        int i = 0;

        if(!cmd) return(NULL);

        while(operatoritems[i].help)
        {
           if(strcmp(cmd, operatoritems[i].shortcut) == 0 || strcmp(cmd, operatoritems[i].symbol) == 0)
              return &operatoritems[i];
                i++;
        }
        return NULL;
}

struct relationaloperatoritem *relationaloperator_find(char *cmd)
{
        int i = 0;

        if(!cmd) return(NULL);

        while(relationaloperatoritems[i].help)
        {
           if(strcmp(cmd, relationaloperatoritems[i].shortcut) == 0 || strcmp(cmd, relationaloperatoritems[i].symbol) == 0)
              return &relationaloperatoritems[i];
                i++;
        }
        return NULL;
}


struct variableitem *variable_find(char *cmd)
{
        int i = 0;

        if(!cmd) return(NULL);

        while(variableitems[i].help)
        {
                if(strncmp(cmd, variableitems[i].command,3) == 0 )
                        return &variableitems[i];
                i++;
        }
        return NULL;
}

struct actionitem *action_find(char *cmd)
{
        int i = 0;

        if(!cmd) return(NULL);

        while(actionitems[i].help)
        {
           	if(strcmp(cmd, actionitems[i].shortcut) == 0 || strcmp(cmd, actionitems[i].symbol) == 0)
                        return &actionitems[i];
                i++;
        }
        return NULL;
}

