/*
  make
  
  $(prog) -rules rules
  
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>
#include <memlib.h>

#include "pconfig.h"
#include "operators.h"

#define ACS_PATTERN_MAXLEN           256
#define ACS_IDENTNAME_MAXLEN         16

struct sis_ace_expression {
  /* special entry for expression */
  int match;
  
  /* rule pattern */
  char pattern[ACS_PATTERN_MAXLEN];
  struct operatoritem *opitem;
  char variable[ACS_PATTERN_MAXLEN];
  struct actionitem *actitem;
  char actiondescription[ACS_PATTERN_MAXLEN];
  int status; 
};

struct sis_ace_rule_u {
  
  struct sis_ace_expression *expression;
  int num_cond;
};

struct sis_ace_ident {
  char name[ACS_IDENTNAME_MAXLEN];
  char role[ACS_IDENTNAME_MAXLEN];

};

struct sisace_service {
  
  struct sis_ace_ident ident;
  /* rules */
  struct sis_ace_rule_u *rules;
  int num_rules;
};

/*
struct sisace_config {

  struct sisace_service *services;
  int num_services;
};

struct sisace_config config; */

#if 0
/* open a socket to a tcp remote host with the specified port 
   based on code from Warren */
int open_socket(char *host, int port)
{
  int type = SOCK_STREAM;
  struct sockaddr_in sock_out;
  int res;
  struct hostent *hp;  
  
  res = socket(PF_INET, type, 0);
  if (res == -1) {
    return -1;
  }
  
  hp = gethostbyname(host);
  if (!hp) {
    fprintf(stderr,"unknown host: %s\n", host);
    return -1;
  }
  
  memcpy(&sock_out.sin_addr, hp->h_addr, hp->h_length);
  sock_out.sin_port = htons(port);
  sock_out.sin_family = PF_INET;
  
  if (connect(res,(struct sockaddr *)&sock_out,sizeof(sock_out))) {
    close(res);
    fprintf(stderr,"failed to connect to %s - %s\n", 
	    host, strerror(errno));
    return -1;
  }
  
  return res;
}
#endif


struct parse_command;

int parse_rule(struct configfile *cf, void *param)
{
  struct sisace_service *svc = param;
  struct sis_ace_rule_u *rules;
  struct sis_ace_expression *expression;
  struct actionitem *actitem;
  struct relationaloperatoritem *ropitem;
  struct operatoritem *opitem;
  struct variableitem *variableitem;
  char save_token[80];
  
  int i = 0;
  int j = 0;
  

  GET_LPARAN_TOKEN(cf); 

 
  i = svc->num_rules++;
  svc->rules = realloc(svc->rules, sizeof(struct sis_ace_rule_u) *
		       svc->num_rules);
  if (!svc->rules)
    FAIL("no memory\n");
  
  rules = svc->rules + i;
  memset(rules, 0, sizeof(struct sis_ace_rule_u));
  
 Expression:
  j = rules->num_cond++;
  
  rules->expression = realloc(rules->expression, sizeof(struct sis_ace_expression) *
			      rules->num_cond);
  if (!rules->expression)
    FAIL("no memory\n");
  
  expression =  rules->expression + j;
  memset(expression, 0, sizeof(struct sis_ace_expression));
  
  GET_TOKEN(cf); 
  if (is_token_lparan(cf) == 1) {
    expression->match = 0;
  }
  else {
    expression->match = 1;
    GET_LPARAN_TOKEN(cf);
  }
  
  GET_TOKEN(cf);
  
  /* variable name matching should be done here   */
  variableitem = variable_find(cf->token);
  
  if(!variableitem)
    {
      return -1;
    }
  
  strncpy(expression->variable, cf->token, ACS_PATTERN_MAXLEN);
  
  GET_TOKEN(cf);
  opitem = operator_find(cf->token);
  
  if(!opitem)
    {
      return -1;
    }
  
  expression->opitem = opitem;
  
  GET_TOKEN(cf);
  strncpy(expression->pattern, cf->token, ACS_PATTERN_MAXLEN);
  
  GET_RPARAN_TOKEN(cf); 
  
  GET_TOKEN(cf);
  
  
  ropitem = relationaloperator_find(cf->token);
  
  if(!ropitem)
    {
      if (! is_token_rparan(cf)) return -1;
    }else {
      goto Expression;
    }
  
  GET_TOKEN(cf);
  if (strcmp(cf->token, "return"))
    return -1;
  
  GET_TOKEN(cf);
  

  actitem = action_find(cf->token); 
  printf("token=%s\n", cf->token);
  strcpy(save_token, cf->token);
  printf("saveedtoken=%s\n", &save_token);

/*  actitem = action_find(cf->token);  
  actitem = action_find("grantAccess"); 
  printf("actitem->shortcut=%s\n",actitem->shortcut);
  
  if (!actitem)
    {
      fprintf(stderr, " action item error cf->token (%s) return  \n", cf->token);
      return -1;
    }

  expression->actitem = actitem;  
  expression->actitem->shortcut = cf->token;    
  strcpy(expression->actitem->shortcut,save_token); 

  printf("expression shortcut=%s\n", expression->actitem->shortcut);
  printf("comparision %d\n",
          strcmp(expression->actitem->shortcut, save_token));
  
  if (strcmp(cf->token, "contact") == 0 || strcmp(cf->token, "acquirePrivilages") == 0) {
    GET_TOKEN(cf);
    strncat(expression->actiondescription, cf->token, ACS_PATTERN_MAXLEN);
  }
*/
    strcpy(expression->actiondescription, save_token);
  
  return 0;
}

struct parse_command {
  const char *name;
  int (*func) (struct configfile * cf, void *param);
  const char *errmsg;
};

static const char *errmsg = "no error";

static const struct parse_command *
find_command(const char *name, const struct parse_command *cmds)
{
  while (cmds->name) {
/*    if (!strcmp(name, cmds->name)) */
    if (!strcmp(name, cmds->name))
      return cmds;
    else
      ++cmds;
  }
  return NULL;
}

static int
invoke_command(const struct parse_command *cmd,
               struct configfile *cf, void *config)
{
  return cmd->func(cf, config);
}

static const struct parse_command servicecmds[] = {
  {"if", parse_rule, "parsing rule error"},
  {NULL},
};

static int
handle_command(struct configfile *cf, void *config,
               const struct parse_command *cmds)
{
  const struct parse_command *cmd;
  
  if (get_next_token(cf))
    return 0;

  if ((cmd = find_command(cf->token, cmds))) {
    int result;

    if ((result = invoke_command(cmd, cf, config)))
      errmsg = cmd->errmsg;

    cf->token_handled = 1;
    return result;
  }
  
  return 0;
}


static int 
parse_sisrules(struct configfile *cf, void *param)
{
  int i;
  struct sisace_config *config = param;
  struct sisace_service *svc;
  
  
  i = config->num_services++;
  
  config->services = realloc(config->services,
			     sizeof(struct sisace_service) *
			     config->num_services);
  if (!config->services)
    FAIL("no memory\n");
  
  svc = config->services + i;
  memset(svc, 0, sizeof(struct sisace_service));
/*  
  if (get_next_token(cf))
    return -1;
  strncpy(svc->ident.role, cf->token, ACS_IDENTNAME_MAXLEN);
*/  
  if (get_next_token(cf))
    return -1;
  strncpy(svc->ident.name, cf->token, ACS_IDENTNAME_MAXLEN);

  if (get_next_token(cf))
    return -1;
  
  if (cf->token[0] != '{' || strlen(cf->token) != 1)
    return -1;
  
  while (!(feof_configfile(cf))) {
    int result = handle_command(cf, svc, servicecmds);
    if (result)
      FAIL
	("Syntax error in the config file %s (line %d): "
	 "%s\n", cf->name, cf->lineNum, errmsg);
    if (!cf->token_handled)
      break;
  }
  
  if (cf->token[0] != '}')
    return -1;
  
  return 0;
}

static const struct parse_command globalcmds[] = {
  {"Rulemodule", parse_sisrules, "parse_sisrules error"},
  {NULL},
};

int
sisace_parse_config(const char *filename, struct sisace_config  *config)
{
  struct configfile *cf;
  int feof_ret;
  
  memset(config, 0, sizeof(*config));
  
  if (!(cf = open_configfile(filename)))
    exit(1);

  while (!(feof_ret = feof_configfile(cf))) {
    
    int result = handle_command(cf, config, globalcmds);
    if (result)
      FAIL
	("Syntax error in the config file %s (line %d): "
	 "%s\n", cf->name, cf->lineNum, errmsg);
    if (!cf->token_handled)
      FAIL("invalid command %s\n", cf->token);
  }
  
  close_configfile(cf);

  printf("rule file closed\n");  
  return 0;
}

struct sisace_service * getRules(struct sisace_config *config, char *ident)
{
 struct sisace_service *svc;
 int i = 0;
 int found = 0;
 
 for (i = 0; i < config->num_services; i++) {
   svc = &config->services[i];
   if (strcmp(svc->ident.name, ident) == 0) {
     found = 1;
     break;
   }
 }
 
 if (found)
   return svc;
 
 return (struct sisace_service *) NULL;
}

void clean_config(struct sisace_config *config)
{
  int i;

  for (i = 0; i < config->num_services; i++) {
    cfree(config->services);
  }

}

void print_config(struct sisace_config *config)
{
  struct sis_ace_rule_u *rules;
  struct sis_ace_expression *expression;
 struct sisace_service *svc;
  int i, j, k;
  
  for (i = 0; i < config->num_services; i++) {
    svc = &config->services[i];
    
    printf("acs %s { %d\n", svc->ident.name,svc->num_rules);
    
    /* retrieve the rules */
    for (j = 0; j < svc->num_rules; j++) {
      rules = &svc->rules[j];
      printf ("cond in rule %d is %d \n", j, rules->num_cond);
      for (k = 0; k < rules->num_cond; k++) {
	printf("if ( ");
	expression = &rules->expression[k];
	printf("  %s ( %s %s %s ) ", ((expression->match == 0)?" " : "!" ) , expression->variable, expression->opitem->symbol, expression->pattern);
	if (expression->actitem) {
	  printf(" do %s", expression->actitem->shortcut);
	  printf(" %s", expression->actiondescription);
	  printf("\n");
	}
      }
    }
    printf("}\n");
  }
}

int match_pattern(const char *s, const char *pattern)
{
  for (;;) {
    if (!*pattern) return (!*s);
    
    if (*pattern == '*') {
      pattern++;
      
      if (!*pattern) return (1);
      
      if (*pattern != '?' && *pattern != '*') {
        for (; *s; s++) {
          if (*s == *pattern &&
              match_pattern(s + 1, pattern + 1))
            return (1);
        }
        return (0);
      }
      for (; *s; s++) {
        if (match_pattern(s, pattern))
          return (1);
      }
      return (0);
    }
    if (!*s) return (0);
    
    if (*pattern != '?' && *pattern != *s)
      return (0);
    
    s++;
    pattern++;
  }
}

struct testACSRules
{
 char type[ACS_PATTERN_MAXLEN];
 char url[ACS_PATTERN_MAXLEN];
 char parameter[ACS_PATTERN_MAXLEN];
 int numberofparameters;
};


/* int testrules(char *type, char *url, char *parameter, int numberofparameters); */

char * testrules(struct sisace_config  *config,
                 char *type, char *url, char *parameter, int numberofparameters,
                 struct ip_vs_cb_rule_field *rule_fields, int num_rule_fields)
{

        struct sisace_service *svc;
        struct sis_ace_rule_u *rules;
        struct sis_ace_expression *expression;


        int i, j, k;
        int rc;
        int privelageStatus = -1;

        printf("Inside testrules\n");

redo:

        svc = getRules(config, type);

        printf("num_rules=%d",svc->num_rules);

         for (j = 0; j < svc->num_rules; j++) {
             rules = &svc->rules[j];
		printf ("evaluation rule %d \n", j);

             for (k = 0, privelageStatus = -1; k < rules->num_cond; k++) {

		printf ("evaluation cond %d \n", k);
                  expression = &rules->expression[k];

/* Added jayant for XML variables */

                       if(strncmp(expression->variable, "XML",3) == 0 ) {

                          printf("XML expression is %s\n",expression->variable);

                          for(i=0;i < num_rule_fields;i++){
                          if (expression->match = match_pattern(rule_fields[i].name, expression->variable) == 1) 
                            {
                               numberofparameters = atoi(rule_fields[i].value);
                               break;
			     } 
                          else 
                            {
                               numberofparameters = -1;
			    }
                          }
                          printf("After for loop, numberofparameters=%d\n",numberofparameters);
                       }


                  if (strcmp(expression->opitem->shortcut, "pnd") == 0)
                    {
			if (strcmp(expression->variable, "url") == 0) {				
			  printf ("need regular expression match :: match (a\"%s\", \"%s\") return = %d\n ",url, expression->pattern, (expression->status = match_pattern(url, expression->pattern)) );
			  if (expression->match = match_pattern(url, expression->pattern) == 1)
				privelageStatus = 1;
			  else
				privelageStatus = -1;
			 }

                        if (strcmp(expression->variable, "parameter") == 0) {			
			printf("parameter matching \n");
			  printf ("need regular expression match :: match (ad\"%s\", \"%s\") return = %d\n ",parameter, expression->pattern, (expression->status = match_pattern(parameter, expression->pattern)) );

                          if (expression->match = match_pattern(parameter, expression->pattern) == 1) {
				printf ("setting privilage in status to 1 \n");
                                privelageStatus = 1;
			} else {
                                privelageStatus = -1;
			}
                         }

		    }else {
			 if (strcmp(expression->opitem->shortcut, "gt") == 0) {
				printf(" evaluating this ? (%d > %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
				if ( numberofparameters > atoi(expression->pattern) ) {
					printf(" true is > \n");
					privelageStatus = 1;
					}
			  } else  if (strcmp(expression->opitem->shortcut, "lt") == 0) {
				printf(" evaluating this ? (%d < %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
					if ( numberofparameters < atoi(expression->pattern) )
						privelageStatus = 1;
			  } else  if (strcmp(expression->opitem->shortcut, "ge") == 0) {
				printf(" evaluating this ? (%d >= %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
					if ( numberofparameters >= atoi(expression->pattern) )
						privelageStatus = 1;
			  } else  if (strcmp(expression->opitem->shortcut, "le") == 0) {
				printf(" evaluating this ? (%d <= %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
					if ( numberofparameters <= atoi(expression->pattern) )
						privelageStatus = 1;
			  } else  if (strcmp(expression->opitem->shortcut, "eq") == 0) {
				printf(" evaluating this ? (%d == %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
					if ( numberofparameters == atoi(expression->pattern) )
						privelageStatus = 1;
			  } else  if (strcmp(expression->opitem->shortcut, "ne") == 0) {
				printf(" evaluating this ? (%d != %d) ? %d \n", numberofparameters, atoi(expression->pattern), ( numberofparameters > atoi(expression->pattern) ));
					if ( numberofparameters != atoi(expression->pattern) )
						privelageStatus = 1;
			  }
		     } 
		
		
	printf(" current privelage status is %d\n", privelageStatus);
		
		   if (privelageStatus == -1)
			break ;
         } 

	printf(" i am glad to say the privelage status is %d\n", privelageStatus);

             if (privelageStatus == 1) {
                         printf("desc=%s\n",expression->actiondescription);
                         printf("evaluate successfull grant access!!!\n");
                         break;
                 }
                 else {
                         printf("desc=%s\n",expression->actiondescription);
                         printf("evaluate deny access!!!\n");
                 }


    } 

/*    return privelageStatus; */
      return expression->actiondescription;
} 

 
void testrule(char *file, struct sisace_config  *config, 
              struct ip_vs_cb_rule_field *rule_fields, int num_rule_fields)
{
  FILE * fp;
 char  line[120];
  size_t len = 80;
  ssize_t read;
  int ret;
  struct testACSRules tester;

  fp = fopen(file, "r");
  if (fp == NULL)
	return;

  printf("testfile open success\n");

  /* type of test filematch or cgi ? */
  if ((read = getline(line, len, fp)) != -1) {
 	sscanf(line, "%s", &tester.type);
        printf("%s", line);
  }

#if 1
  if ((read = getline(line, len, fp)) != -1) {
        sscanf(line, "%s", &tester.url);
        printf("%s", line);
  }

  if ((read = getline(line, len, fp)) != -1) {
	strcpy(tester.parameter, line);
	tester.parameter[(read - 1)] = '\0';
        printf("%s", line);
  }

  if ((read = getline(line, len, fp)) != -1) {
        sscanf(line, "%d", &tester.numberofparameters);
        printf("%s", line);
  }


  fprintf(stderr, " type %s url %s parameters %s number of parameters %d\n", tester.type, tester.url, tester.parameter, tester.numberofparameters);
#endif


   ret = testrules( config,
                  tester.type, tester.url, tester.parameter,
                  tester.numberofparameters, rule_fields, num_rule_fields);

   printf("ret=%d",ret);  
}




static char *parser_usage[]={
"usage: parser args\n",
" -rules arg      	- set the rights specification rule file, must be ASCII format.\n",
" -testfile arg      	- test the rights specification rules with values specified in the file, must be ASCII format.\n",
NULL
};

void read_rulefile(struct sisace_config  *config)
{
 int rc;
        rc = sisace_parse_config(RULEFILE, config);
 printf("End of read rulefile1\n");

}

void read_rulefile1(struct sisace_config  *config)
{
 int rc;
        rc = sisace_parse_config(RULEFILE1, config);
 printf("End of read rulefile1\n");

}

void read_rulefile2(struct sisace_config  *config)

{
 int rc;
        rc = sisace_parse_config(RULEFILE2, config);
 printf("End of read rulefile2\n");
}

/* int main(int argc, char *argv[]) */
int parsermain()
{
  int badops=0;
  char *infile;
  int rc;
  char *filematch;
  char **pp;
  struct sisace_config config;  
  int num_rule_fields = 4;

struct ip_vs_cb_rule_field rule_fields[] =
{
{"XML:purchase:1.totalAmount:1.", "52000" },
{"XML:purchase:1.subTotal:1.", "50000" },
{"XML:purchase:1.subTotal:2.", "2000" },
{"XML:purchase:1.unitPrice:2.", "200" }
};

  
        read_rulefile(&config);   
  
/*	testrule(TESTFILE1,&config, rule_fields, num_rule_fields );
        printf("testing with rulefile1 finished\n");
        clean_config( &config);
        printf("cleaned rules\n"); 
        read_rulefile2();    
	testrule(TESTFILE2,&config); */ 
       
        rc=0;

 return 1;

 end:
	return -1;
}


