#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>
#include <ioLib.h>

#include "pconfig.h"

int is_token_lparan(struct configfile *cf)
{
  if (cf->token[0] != '(' || strlen(cf->token) != 1)  
    return -1; 
  
  return 1;
}

int is_token_rparan(struct configfile *cf)
{
  if (cf->token[0] != ')' || strlen(cf->token) != 1)
    return -1;
  
  return 1;
}


struct configfile *open_configfile(const char *filename)
{
  struct configfile *cf;
  FILE *fdX;
  
  if (!(cf = malloc(sizeof(*cf))))
    FAIL("no memory\n");


/*   cf->name = strdup(filename); */

    if ( !( fdX = fopen (filename,"r"))) {  
       printf("ERROR opening file\n");
    };

  cf->fp = fdX;  
  cf->position = cf->line;
  cf->lineEnd = cf->line;
  cf->lineNum = 1;
  
  return cf;
}

int get_next_token(struct configfile *cf)
{
  char *p, *tp;
  char c;
  
  for (p = cf->position;; p++) {
    if (p >= cf->lineEnd) {
      if (!fgets(cf->line, MAX_STRING_LEN, cf->fp))
	return -1;

      p = cf->line;
      cf->lineEnd = cf->line + strlen(cf->line);
      cf->lineNum++;
    }
    
    c = *p;
    if (isspace(c))
      continue;
    
    if (c == '\r' || c == '\n')
      continue;
    
    /* get token here */
    tp = cf->token;
    if (c == '"') {
      /* get a quoted string here */
      for (p++; *p != '"';) {
	c = *tp++ = *p++;
	if (c == '\\' && *p == '"')
	  *tp++ = *p++;
	if (p >= cf->lineEnd)
	  return -1;
      }
      p++;    /* skip the last quote symbol */
    } else {
      do {
	*tp++ = *p++;
      } while (!isspace(*p) && !isspecial(*p) && p < cf->lineEnd);
    }
    
    *tp = '\0';
    cf->token_handled = 0;
    cf->position = p;
    
    return 0;
  }
}

int feof_configfile(struct configfile *cf)
{
 int i;

/*  return feof(cf->fp); */
  i = feof(cf->fp);
  return i;
}

void close_configfile(struct configfile *cf)
{
  fclose(cf->fp);
/*  free(cf->name); */
  free(cf);
}

