#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

#define isspecial(c) ((c) == '(' || (c)  == ')')

#define FAIL(msg...)                            \
    do {                                        \
            fprintf(stderr, msg);               \
            exit(1);                            \
    } while (0)

#define GET_TOKEN(cf)                           \
    do {                                        \
            if (get_next_token(cf))             \
                    return -1;                  \
    } while (0)

#define GET_LPARAN_TOKEN(cf);                                    \
    do {                                                        \
            if (get_next_token(cf))                             \
                    return -1;                                  \
            if (cf->token[0] != '(' || strlen(cf->token) != 1)  \
                    return -1;                                  \
    } while (0)


#define GET_RPARAN_TOKEN(cf);                                    \
    do {                                                        \
            if (get_next_token(cf))                             \
                    return -1;                                  \
            if (cf->token[0] != ')' || strlen(cf->token) != 1)  \
                    return -1;                                  \
    } while (0)


#define MAX_STRING_LEN 512
#define TESTFILE "DEV1:\\\\values"
#define TESTFILE1 "DEV1:\\\\values1"
#define TESTFILE2 "DEV1:\\\\values2"
#define RULEFILE "DEV1:\\\\rules"
#define RULEFILE1 "DEV1:\\\\rules1"
#define RULEFILE2 "DEV1:\\\\rules2"
struct configfile {
        char *name;
        FILE *fp;
        char line[MAX_STRING_LEN];
        char *position;
        char *lineEnd;
        int lineNum;
        char token[MAX_STRING_LEN];
        int token_handled;
};

int is_token_lparan(struct configfile *cf);
int is_token_rparan(struct configfile *cf);
struct configfile * open_configfile(const char *filename);
int get_next_token(struct configfile *cf);
int feof_configfile(struct configfile *cf);
void close_configfile(struct configfile *cf);


struct sisace_config {
  /* services */
  struct sisace_service *services;
  int num_services;
};

struct ip_vs_cb_rule_field
{ 
  char  name[512];
  char  value[256];
};

