
#include "rulemodule.h"


/*
** test fuction to see everything required is there or not should not be in the prototype--gkgodava@archie.uccs.edu
*/
void printRule(Rule *rule)
{

  (void) fprintf(stderr, "Routing details are Port %d ClientAddress %x content-length %d Method %s URL %s content_type %s body %s \n%",rule->port, rule->clientaddr,rule->content_length,rule->method, rule->url,rule->content_type,rule->body);


}

/* main entry of rule module*/
/*int main(int argc, char **argv) */
int rulemodule() 
{
   char* shm_addr;           		/* address of shared memory segment.  	*/
   int shm_id;               		/* ID of the shared memory segment.   	*/
   short int port;
   int fd;
   int listeningSocket;
   struct sisace_config config;
   Element     *p_elem;
   Element     *found;

/* variables for data transfer */
  int maxfd, nready;
  struct timeval  tv;
  Rule *rule;
  u_long ret_addr;
  fd_set   readfds;
  char  szbuf[BUFSIZ], szurl[BUFSIZ], szcontenttype[BUFSIZ], *val,szargs[BUFSIZ] ;

   port = 4000;

    /* attach the shared memory segment to our process's address space. */

    /*
    ** most cool Unix will take care of Zombies if we ignore SIGCHLD
    */

    /*
    ** Read rulefile
    */
    read_rulefile(&config);

    /* Initialize switching statistics linked list 
    my_list = list_init();  */


    /* Testing linked list... no more needed */
    my_list = list_init();

#if 0
    /* Initialize a list an insert several numbers to it. */
    my_list = list_init();

    list_add (my_list, "First");
    list_add (my_list, "Second");

    /* Print the content of the list. */
    p_elem = my_list->p_head;
    while (p_elem != NULL)
    {
      printf ("%s<>%g ", p_elem->p_url, p_elem->value);
      p_elem = p_elem->p_next;
    }
    printf ("\n");
    printf ("%d elements in the list.\n", my_list->size);

    list_add (my_list, "First");

    printf("Added duplicate first\n");  

    p_elem = my_list->p_head;
    while (p_elem != NULL)
    {
      printf ("%s<>%g ", p_elem->p_url, p_elem->value);
      p_elem = p_elem->p_next;
    }
    printf ("\n");

#endif

    /*
    ** open the server socket
    */

    if ((listeningSocket = RuleSocket((u_short) port,1000)) == -1) {
        (void) fprintf(stderr,"Failed to create rulemodule server \n");
        return 0;
    }
    printf("created rulemodule server !\n"); 

   for ( ; ; ) {
      fd=accept(listeningSocket,NULL,NULL);
      if (fd < 0)
       {
        /*
        ** either a real error occured or blocking was
        ** interrupted for some reason. only abort execution
        ** if a real error occured
                */
                if (errno != EINTR)
                {
                    (void) fprintf (stderr,"unable to accept!\n");
		    printf ("unable to accept!\n");	
                    perror("accept");
                    close (listeningSocket);
                    return (-1);
                }
                else
                  continue;
       }


  /* if the client does not respond within the timeout limit, zap it  */
  FD_ZERO(&readfds);

   FD_SET(fd, &readfds);
   maxfd = fd + 1;

   tv.tv_sec=150;
   tv.tv_usec=0;

   nready=select(maxfd,&readfds,NULL,NULL,&tv);
   if (nready == 0)
    {
      (void) fprintf(stderr," *** task id %d Timed out in 150 seconds ***\n",taskIdSelf());
      printf("*** task id %d Timed out in 150 seconds ***\n",taskIdSelf());
      continue; 
    }

 /*
 ** get request
 */
 if(FD_ISSET(fd,&readfds))
  {
    /* check whether the packet sent after the connection established has no data -- if so reject it */
 #if 0
    if((sockGets(fd,szbuf,sizeof(szbuf)-1)) <= 0)
        continue;
 #endif
   }

  /*
  ** now we can allocate memory for the Rule  structue as we know it is not a junk request!!
  */
  if ((rule = (struct Rule *) malloc(sizeof(Rule))) == NULL)  continue;

  
  rule->content_length = 0;

  while(sockGets(fd,szbuf,sizeof(szbuf)-1) > 0) {

        val=strchr(szbuf,':');

        if (val)
        {
            /* *val++ = '\0';*/
	    *val++;
		
            if (strncmp("Port",szbuf,strlen("Port")) == 0)
                rule->port = atoi(val);

            if (strncmp("ClientAddr",szbuf,strlen("ClientAddr")) == 0)
                rule->clientaddr = atol(val);

            if (strncmp("Method",szbuf,strlen("Method")) == 0)
                (void) strcpy(rule->method,val);

            if (strncmp("Url",szbuf,strlen("url")) == 0)
                (void) strcpy(szurl,val);

            if (strncmp("Content-Type",szbuf,strlen("Content-Type")) == 0)
                (void) strcpy(szcontenttype,val);

            if (strncmp("Content-Length",szbuf,strlen("Content-Length")) == 0)
                rule->content_length=atoi(val);
        }
    }

/*  Need to shutdown gracefully when received request with Method=SHUTDOWN   */

   (void)  fprintf(stderr,"Checking for shutdown\n");
   (void)  fprintf(stderr,"Method=%s\n",rule->method);

   if (strncmp("SHUTDOWN",rule->method,strlen("SHUTDOWN")) == 0)
   {
/*   Need to release the socket here...Jayant*/
      (void)  fprintf(stderr,"Received request to shutdown...");
      mySocketFree(listeningSocket);
      exit;
   }

/*  Need to refresh rules database with Method=RULEREFRESH   */

   (void)  fprintf(stderr,"Checking for rulerefresh\n");
   (void)  fprintf(stderr,"Method=%s\n",rule->method);

   if (strncmp("RULEREFRESH",rule->method,strlen("RULEREFRESH")) == 0)
   {
     clean_config(&config);
     fprintf(stderr,"After cleaning #services=%d\n", config.num_services);
     read_rulefile(&config);
     fprintf(stderr,"After refresh #services=%d\n", config.num_services);
   }


/*  Need to refresh switching stats list with Method=INITSTATS   */

   (void)  fprintf(stderr,"Checking for init_stats\n");
   (void)  fprintf(stderr,"Method=%s\n",rule->method);

   if (strncmp("INITSTATS",rule->method,strlen("INITSTATS")) == 0)
   {
     init_stats();

     fprintf(stderr,"After init stats\n");
   }


   if(rule->content_length != 0)
   {
     if((rule->body = (char *) malloc(rule->content_length+1)) == NULL)
       {
        (void) fprintf(stderr,"unable to allocate memory for rule->body\n");
        continue;
       }
      sockRead(fd,rule->body,rule->content_length);
    }
     else
       rule->body=NULL;


    if ((rule->url = (char *) malloc(strlen(szurl)+1)) == NULL)
     {
      (void) fprintf(stderr,"unable to allocate memory for rule->url \n");
       continue;
     }

    (void) strcpy(rule->url,szurl);


    if((rule->content_type = (char *) malloc(strlen(szcontenttype)+1)) == NULL)
     {
       (void) fprintf(stderr,"unable to allocate memory for rule->content_type \n");
       continue;
     }

    (void) strcpy(rule->content_type,szcontenttype);

/*problem here: longhua*/
   (void) printRule(rule);

   ret_addr = ruleMatching(rule, &config);

  (void) sprintf(szbuf,"ServerAddress:0x%x\r\nServerName:%s\r\n\r\n",ret_addr,getRealServerName(ret_addr));
  (void)  fprintf(stderr," the return data is  %s",szbuf);
  (void)  fprintf(stderr," 31Mar rulemodule finish\n");   

   sockPuts(fd,szbuf);
 close(fd);


 } /* end of the iterative loop */


}

void rmstartup()
{

    if(taskSpawn("rulemodule",100,0,20000,(FUNCPTR)rulemodule,0,0,0,0,0,0,0,0,0,0) == ERROR) 
      {
        printf("Error in spawning taskrulest");
      }

}

void rmshut()
{
  int data_read =0;
  char request[1024];
  int rule_fd;


  data_read = sprintf(request, "Method:SHUTDOWN\r\n\r\n");

  printf("Before connectTo\n");

  if((rule_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT )) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
     exit;
   }

  printf("Before sockWrite\n");

  if (data_read != sockWrite(rule_fd, request, data_read))
     {
	(void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf()); 
        exit;
     }

}


void refresh()
{
  int data_read =0;
  char request[1024];
  int rule_fd;


  data_read = sprintf(request, "Method:RULEREFRESH\r\n\r\n");

  printf("Before connectTo\n");

  if((rule_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT )) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
     exit;
   }

  printf("Before sockWrite\n");

  if (data_read != sockWrite(rule_fd, request, data_read))
     {
	(void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf()); 
        exit;
     }

}



/* initialize switching stats... */
void init_stats()
{

  (void) fprintf(stderr,"before list_refresh\n");
  list_reset (my_list);
  (void) fprintf(stderr,"after list_refresh\n");
/*
  free (my_list);
  (void) fprintf(stderr,"after free\n");
  my_list = list_init();  */

  (void) fprintf(stderr,"Switching stats initialized\n");

  pop_list();

}



void local_init_stat()
{
  int data_read =0;
  char request[1024];
  int rule_fd;


  data_read = sprintf(request, "Method:INITSTATS\r\n\r\n");

  printf("Before connectTo\n");

  if((rule_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT )) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
     exit;
   }

  printf("Before sockWrite\n");

  if (data_read != sockWrite(rule_fd, request, data_read))
     {
	(void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf()); 
        exit;
     }

}

void pop_list()
{
   Element     *p_elem;
   Element     *found;

    list_add (my_list, "Fifth");
    list_add (my_list, "Sixth");

    /* Print the content of the list. */
    p_elem = my_list->p_head;
    while (p_elem != NULL)
    {
      printf ("%s<>%g ", p_elem->p_url, p_elem->value);
      p_elem = p_elem->p_next;
    }
    printf ("\n");
    printf ("%d elements in the list.\n", my_list->size);

    list_add (my_list, "Fifth");

    printf("Added duplicate first\n");  

    p_elem = my_list->p_head;
    while (p_elem != NULL)
    {
      printf ("%s<>%g ", p_elem->p_url, p_elem->value);
      p_elem = p_elem->p_next;
    }
    printf ("\n");
}

