/**
 * Longhua Nov. 18th, 2001
 * Define wrap around functions for Linux functions gethostbyaddr(), gethostbyname()
 **/

/*The hostent structure is defined in <netdb.h> as follows:
struct hostent 
{
	char    *h_name;        // official name of host 
	char    **h_aliases;    // alias list 
	int     h_addrtype;     // host address type  
	int     h_length;       // length of address  
	char    **h_addr_list;  // list of addresses 
#define	h_addr	h_addr_list[0]	// address, for backward compatiblity  
        unsigned int h_ttl;	// Time to Live in Seconds for this entry 

}
*/
#include <stdio.h>
#include "vx_func.h"


struct hostent *gethostbyname(const char *name)
{

	struct hostent *pHostent = (struct hostent *)malloc(sizeof(struct hostent));
	
	int addr = hostGetByName(name);

	printf("address of h:0x%x\n",&pHostent);
	printf("addr = 0x%x, &addr = 0x%x\n", addr, &addr);
	if (addr != ERROR)
	{
		printf("addr != ERROR");
		pHostent->h_name = name;
		pHostent->h_addrtype = AF_INET;
		pHostent->h_length = sizeof(addr);
		printf("h_length = %d\n",pHostent->h_length);
		pHostent->h_addr_list = (char **)malloc(10);
		pHostent->h_addr = (char *)malloc(sizeof(int));
		memcpy(pHostent->h_addr, &addr, pHostent->h_length);
		printf("h_addr_list:0x%x\n", pHostent->h_addr_list);
		printf("h_addr:0x%x\n", pHostent->h_addr);
		printf("*h_addr:0x%x\n", *pHostent->h_addr);		
		return pHostent;
	}
	free(pHostent);
	return NULL;
}

struct hostent *gethostbyaddr(const char *addr, int len, int type)
{

	struct hostent *pHostent = (struct hostent *)malloc(sizeof(struct hostent));
	char *name = (char *)malloc(10);
	int tempaddr;

	memcpy(&tempaddr, addr, sizeof(int));
	if(hostGetByAddr(tempaddr, name) == OK)
	{
		pHostent->h_name = name;
		pHostent->h_addrtype = type;
		pHostent->h_length = sizeof(int);
		pHostent->h_addr_list = (char **)malloc(10);
		pHostent->h_addr = (char *)malloc(sizeof(int));
		memcpy(pHostent->h_addr, &tempaddr, pHostent->h_length);
		return pHostent;

	
	}
	free(pHostent);
	return NULL;
		
}


struct servent *getservbyname(const char *name, const char *proto)
{
	return NULL;
}

int getline(char *line, int max, FILE *f) {
int nch = 0;
int c;
max = max - 1;			/* leave room for '\0' */

while((c = getc(f)) != EOF)

	{
	if(c == '\n')
		break;

	if(nch < max)
		{
		line[nch] = c;
		nch = nch + 1;
		}
	}

if(c == EOF && nch == 0)
	return EOF;

line[nch] = '\0';
return nch;

}