/* bootConfig.h
 * Definitions of constants related to locating a C-image in memory
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: BootMgr
 * author: jdg 05/03/00
 * revisions:
 * $History: bootConfig.h $
 * 
 * *****************  Version 4  *****************
 * User: Jdguilfo     Date: 10/20/00   Time: 2:27p
 * Updated in $/dev_1200/BoardSupport/BootFlash
 * Merge Boot Manager & Flash Utility, add HPC
 * 
 * *****************  Version 1  *****************
 * User: Jdguilfo     Date: 5/10/00    Time: 4:46p
 * Created in $/dev_1200/BoardSupport/BootMgr
 * Add BootMgr feature
 * 
 * ------------------------------------------------------------------------
 */

#ifndef __BOOTCONFIG_H__
#define __BOOTCONFIG_H__

#define ROM_BASE_ADRS       0x00000000  /* base of writable Flash */
#define ROM_TEXT_ADRS       0x00000070  
#define ROM_SIZE            0x00200000  /* size - start */
                                        /* 2 Meg Bytes */

#define ROM_COPY_SIZE       ROM_SIZE
#define ROM_SIZE_TOTAL      ROM_SIZE    /* total size of Flash ROM */

#define STACK_ADRS          0xC0010000


#endif /* ifndef __BOOTCONFIG_H__ */
