/* bootInit.c
 * Simple C code for copying code/data from flash to SDRAM
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: Bootmgr
 * author: jdg 05/03/00
 * revisions:
 * $History: bootInit.c $
 * 
 * *****************  Version 1  *****************
 * User: Jdguilfo     Date: 5/10/00    Time: 4:46p
 * Created in $/dev_1200/BoardSupport/BootMgr
 * Add BootMgr feature
 * 
 * ------------------------------------------------------------------------
 */

#include "bootConfig.h"

typedef unsigned int UINT;
typedef int      (*FUNCPTR) ();	    
typedef void (*VOIDFUNCPTR) ();  

extern char etext[], edata[], end[];
extern char romL1PTable[];
extern void romInit();
extern void _main();

void copyLongs (register UINT *source, register UINT *destination, UINT nlongs);
static void fillLongs (register  UINT *buf, UINT nlongs, register  UINT val);

#define ROM_OFFSET(addr) ((UINT) addr - (UINT)romInit + ROM_TEXT_ADRS)

void romStart(register UINT startType);
#define ROMTABLESIZE ((UINT)romStart - (UINT)romInit)

void 
romStart(register UINT startType)
{
    volatile FUNCPTR absEntry;
    VOIDFUNCPTR ramfillLongs = fillLongs;

    ((FUNCPTR)ROM_OFFSET(copyLongs))
        (ROM_TEXT_ADRS + ROMTABLESIZE,
         (UINT)romInit + ROMTABLESIZE,
         ((UINT)edata - (UINT)romInit - ROMTABLESIZE) / sizeof(long));

    ramfillLongs(edata, (end-edata)/sizeof(long), 0);

    absEntry = (FUNCPTR) _main  ;			 

    (absEntry) (startType);
}

void 
copyLongs (source, destination, nlongs)
     register  UINT *source;		 
     register  UINT *destination;	 
     UINT nlongs;		 

{
    register  UINT *dstend = destination + nlongs;

    while (destination < dstend)
        *destination++ = *source++;
}

static void 
fillLongs (buf, nlongs, val)
     register  UINT *buf;	 
     UINT nlongs;	 
     register  UINT val;	 

{
    register  UINT *bufend = buf + nlongs;

    while (buf < bufend)
        *buf++ = val;
}
