/* flashUart.h
 * Simple Uart interface for polled-mode operation
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: FUtil
 * author: jdg 05/03/00
 * revisions:
 * $History: flashUart.h $
 * 
 * *****************  Version 7  *****************
 * User: Jdguilfo     Date: 10/26/00   Time: 3:38p
 * Updated in $/dev_1200/BoardSupport/BootFlash
 * Merge serial and HPC versions into one version, see bootMgr.txt for
 * details.
 * 
 * *****************  Version 6  *****************
 * User: Jdguilfo     Date: 10/20/00   Time: 2:27p
 * Updated in $/dev_1200/BoardSupport/BootFlash
 * Merge Boot Manager & Flash Utility, add HPC
 * 
 * *****************  Version 3  *****************
 * User: Jdguilfo     Date: 5/11/00    Time: 10:15a
 * Updated in $/dev_1200/BoardSupport/FlashUtil
 * Flush output before booting OS
 * 
 * *****************  Version 2  *****************
 * User: Jdguilfo     Date: 5/10/00    Time: 4:42p
 * Updated in $/dev_1200/BoardSupport/FlashUtil
 * Add BootMgr feature
 * 
 * *****************  Version 1  *****************
 * User: Jdguilfo     Date: 5/03/00    Time: 4:37p
 * Created in $/dev_1200/BoardSupport/FlashUtil
 * Add new Flash Utility (FUtil)
 * 
 * ------------------------------------------------------------------------
 * This code defines a simple uart interface for polled-mode operation
 * ------------------------------------------------------------------------
 */

#ifndef __FLASHUART_H__
#define __FLASHUART_H__

void uartInit0(unsigned int baud_div);
void outStr(char *str);
unsigned char inChar();
int uartPollInput( char *c );
int uartPollOutput( char c );
void uartFlush();

#define XTAL 3686400
#define uartInit(baud) uartInit0(((XTAL / (16 * (baud))) - 1) & 0x3FF)
#define outChar(c) while(uartPollOutput(c) != 0)

#endif /* ifdef __FLASHUART_H__ */
