#include "genericIO.h"

#include "hpc.h"
#include "flashUart.h"
#include "chip.h"

enum GENERIC_IO_TYPE genericIoType;

static int *data;

void
set_marquee(int *marquee)
{
    data = marquee;
}

void
scroll_marquee()
{
    static int ptr = 0;
    static int ctr = 0;

    if (ctr-- == 0) {
        ctr = 100000;
        IXP1200_REG_WRITE(IXP1200_LED_ADDR, data[ptr]);
        ptr = (ptr + 1) & 1;
    }
}


unsigned char
genericInChar()
{
    switch (genericIoType) {
    case GIT_SERIAL:
        return inChar();
        break;
    case GIT_HPC:
        return hpcGet();
        break;
    }
    return 0;
}

void
genericOutStr(char *str)
{
    switch (genericIoType) {
    case GIT_SERIAL:
        outStr(str);
        break;
    case GIT_HPC:
        hpcSend(str);
        break;
    }
}

void
genericOutChar(char c)
{
    switch (genericIoType) {
    case GIT_SERIAL:
        outChar(c);
        break;
    case GIT_HPC:
        hpcSendChar(c);
        break;
    }
}
