/* consts.h
 * Definition of generic constants
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: FUtil
 * author: jdg 05/03/00
 * revisions:
 * $History: consts.h $
 * 
 * *****************  Version 6  *****************
 * User: Jdguilfo     Date: 11/14/00   Time: 5:21p
 * Updated in $/dev_1200/BoardSupport/BootFlash/host
 * Spectacle Island Port, includes fixes bugs 1226 & 1227, more checks
 * before updating flash util block
 * 
 * *****************  Version 5  *****************
 * User: Shih         Date: 10/04/00   Time: 10:45a
 * Updated in $/dev_1200/BoardSupport/FlashUtil/host
 * change version to V1.2.76
 * 
 * *****************  Version 3  *****************
 * User: Tclancyx     Date: 6/13/00    Time: 10:53a
 * Updated in $/dev_1200/BoardSupport/FlashUtil/host
 * change version to 1.1.76
 * 
 * *****************  Version 2  *****************
 * User: Jdguilfo     Date: 5/11/00    Time: 2:55p
 * Updated in $/dev_1200/BoardSupport/FlashUtil/host
 * Add version info
 * 
 * *****************  Version 1  *****************
 * User: Jdguilfo     Date: 5/03/00    Time: 4:39p
 * Created in $/dev_1200/BoardSupport/FlashUtil/host
 * Add new Flash Utility (FUtil)
 * 
 * ------------------------------------------------------------------------
 */

#ifndef __CONSTS_H__
#define __CONSTS_H__

#define STRING_MAX 350
#define FILE_SIZE_MAX      (8 * 1024 * 1024)
#define DEFAULT_FLASH_SIZE (2 * 1024 * 1024)

/* Flash Utility Magic cookie */
#define BOOTFLASH_COOKIE      0x4274466c
#define BOOTFLASH_COOKIE_ADDR 0x00000014

#define VERSION "1.2.76"

#endif // ifndef __CONSTS_H__
