/* prompt.cpp
 * Primitive routines for prompting users
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: FUtil
 * author: jdg 05/03/00
 * revisions:
 * $History: prompt.cpp $
 * 
 * *****************  Version 1  *****************
 * User: Jdguilfo     Date: 5/03/00    Time: 4:39p
 * Created in $/dev_1200/BoardSupport/FlashUtil/host
 * Add new Flash Utility (FUtil)
 * 
 * ------------------------------------------------------------------------
 */

#include <windows.h>
#include <stdio.h>

#include "consts.h"
#include "prompt.h"

static bool
isWhite(char *buf)
{
    while (1) {
        if ((*buf == '\0') || (*buf == '\n'))
            return true;
        if ((*buf != ' ') && (*buf != '\t'))
            return false;
        buf++;
    }
}

// returns false for exit value (period)
bool 
promptHex(char *prompt, DWORD& val)
{
    char buf[STRING_MAX];
    DWORD newval;

    while (1) {
        fprintf(stdout, "%s (%06X): ",prompt, val);
        fgets(buf, sizeof(buf), stdin);
        if (buf[0] == '.')
            return false;
        if (isWhite(buf))
            return true;
        if (1 == sscanf(buf,"%X", &newval)) {
            val = newval;
            return true;
        }
        fprintf(stdout, "Invalid hex value entered: '%s'.\n", buf);
    }
}

bool 
promptInt(char *prompt, int& val)
{
    char buf[STRING_MAX];
    int newval;

    while (1) {
        fprintf(stdout, "%s (%d): ",prompt, val);
        fgets(buf, sizeof(buf), stdin);
        if (buf[0] == '.')
            return false;
        if (isWhite(buf))
            return true;
        if (1 == sscanf(buf,"%d", &newval)) {
            val = newval;
            return true;
        }
        fprintf(stdout, "Invalid integer value entered: '%s'.\n", buf);
    }
}

bool
promptString(char *prompt, char* val)
{
    char buf[STRING_MAX];

    fprintf(stdout, "%s (%s): ", prompt, val);
    fgets(buf, sizeof(buf), stdin);
    if ((buf[0] == '.') && (buf[1] == '\n'))
        return false;
    if (isWhite(buf))
        return true;
    sscanf(buf, "%s", val);
    return true;
}
