/* romInit.s
 * Startup code for OS-independent module
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ------------------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: BootMgr
 * author: jdg 05/08/00
 * revisions:
 * $History: romInit.s $
; 
; *****************  Version 5  *****************
; User: Jdguilfo     Date: 11/14/00   Time: 5:21p
; Updated in $/dev_1200/BoardSupport/BootFlash
; Spectacle Island Port, includes fixes bugs 1226 & 1227, more checks
; before updating flash util block
; 
; *****************  Version 2  *****************
; User: Jdguilfo     Date: 8/28/00    Time: 6:05p
; Updated in $/dev_1200/BoardSupport/BootMgr
; Add support for multiple OS (cygmon)
 * 
 * ------------------------------------------------------------------------
 * This code initializes as little as possible and then jumps to a C-routine
 * to finish setting up the C environment
 * ------------------------------------------------------------------------
 */

#define FIXADDR(addr) (ROM_BASE_ADRS + (addr) - _iblInit)

#include "bootConfig.h"
#include "chip.h"
#include "os.h"

	.extern _romInit
	.global _iblInit

	.text
	.balign 4

_iblInit:
	LDR	pc, L$_reset_vector
	LDR	pc, L$_undef_vector
	LDR	pc, L$_swi_vector
	LDR	pc, L$_pabort_vector
	LDR	pc, L$_dabort_vector
	.long   BOOTFLASH_COOKIE
	LDR	pc, L$_irq_vector
	LDR	pc, L$_fiq_vector
L$_reset_vector:	.long FIXADDR(_iblStart)
L$_undef_vector:	.long (EXCEPT_ADDR + 0x04)
L$_swi_vector:		.long (EXCEPT_ADDR + 0x08)
L$_pabort_vector:	.long (EXCEPT_ADDR + 0x0c)
L$_dabort_vector:	.long (EXCEPT_ADDR + 0x10)
L$_irq_vector:		.long (EXCEPT_ADDR + 0x18)
L$_fiq_vector:		.long (EXCEPT_ADDR + 0x1c)

		
_iblStart:	

	LDR	r1, L$_IXP1200_GPIO_EN
	MOV	r2, #(GPIO_OWN_CCCC | GPIO_OUTPUT(0))
	STR	r2, [r1]
	LDR	r7, [r1,#+(IXP1200_GPIO_DATA-IXP1200_GPIO_EN)]

	AND	r7, r7, #0x3
	ADD	r0, pc, #(jump_table - . - 8)
	ldr	pc, [r0,r7,LSL#2]
jump_table:
	/* gpio 10 */
ad00:	.long DIAGS_ADDR
ad01:	.long ANGEL_ADDR
ad10:	.long VX_ADDR
ad11:	.long FIXADDR(_romInit)

	.space (ROM_TEXT_ADRS - ROM_BASE_ADRS - (. - _iblInit))
	
#include "boot.s"
