;*************************************************************************
; *
; * BOOTMSGS.H : Header file for the IXP1200 msg strings.
; * 
; * Header file for the IXP1200 msg strings.
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: BOOTMSGS.S $
; 
; *****************  Version 17  *****************
; User: Tepulkow     Date: 11/27/00   Time: 1:36p
; Updated in $/dev_1200/BoardSupport/Diagnostics
; Added support to display rev "C" silicon.
; 
; *****************  Version 15  *****************
; User: Tepulkow     Date: 8/28/00    Time: 5:28p
; Updated in $/dev_1200/BoardSupport/Diagnostics
; Added relocation of the exception vector table to SRAM.
; *
;*************************************************************************
;IXP1200 Validation debug messages

	AREA	MESSAGES, DATA, READONLY

	INCLUDE	H_CONFIG.S
	
	EXPORT	MsgStrgTbl
	EXPORT	EndUartCfg			
	EXPORT	EarlyInitMsg		
	EXPORT	EndEarlyInitMsg		
	EXPORT	BootDiagComplete
	EXPORT	PollBurnIn		
	EXPORT	AckBurnIn		
	EXPORT	UndefInstMsg
	EXPORT	SWIntMsg	
	EXPORT	PrefAbrtMsg	
	EXPORT	DataAbrtMsg	
	EXPORT	Read	
	EXPORT	Expected
	EXPORT	CRLF	
	EXPORT	Nfg		
	EXPORT	CPUrev	
	EXPORT	Silicon
	EXPORT	RevA	
	EXPORT	RevB	
	EXPORT	RevC	
	EXPORT	CoreSpd
	EXPORT	MHZ	
	EXPORT	Spd29	
	EXPORT	Spd36	
	EXPORT	Spd44	
	EXPORT	Spd51	
	EXPORT	Spd58	
	EXPORT	Spd66	
	EXPORT	Spd73	
	EXPORT	Spd81	
	EXPORT	Spd88	
	EXPORT	Spd95	
	EXPORT	Spd103
	EXPORT	Spd110
	EXPORT	Spd117
	EXPORT	Spd132
	EXPORT	Spd147
	EXPORT	Spd154
	EXPORT	Spd162
	EXPORT	Spd165
	EXPORT	Spd176
	EXPORT	Spd191
	EXPORT	Spd199
	EXPORT	SpdNG
	EXPORT	Unknown


MsgStrgTbl
CPUrev				DCB	"IXP1200 revision ", 0
Silicon				DCB	" silicon detected.  ", 0
RevA				DCB	"A", 0
RevB				DCB	"B", 0
RevC				DCB	"C", 0
CoreSpd				DCB	"Core CPU operating at ", 0
MHZ					DCB	"MHz.", &a, &d, 0
Spd29				DCB	"29.49", 0
Spd36				DCB	"36.87", 0
Spd44				DCB	"44.24", 0
Spd51				DCB	"51.61", 0
Spd58				DCB	"58.98", 0
Spd66				DCB	"66.36", 0
Spd73				DCB	"73.73", 0
Spd81				DCB	"81.10", 0
Spd88				DCB	"88.48", 0
Spd95				DCB	"95.85", 0
Spd103				DCB	"103.22", 0
Spd110				DCB	"110.59", 0
Spd117				DCB	"117.97", 0
Spd132				DCB	"132.71", 0
Spd147				DCB	"147.46", 0
Spd154				DCB	"154.83", 0
Spd162				DCB	"162.20", 0
Spd165				DCB	"165.89", 0		;Rev B only
Spd176				DCB	"176.95", 0
Spd191				DCB	"191.69", 0		;Rev B only
Spd199				DCB	"199.07", 0		;Rev B only
SpdNG				DCB "???", 0
Unknown				DCB	"unknown.", &a, &d, 0

EndUartCfg			DCB	"UART configured for diagnostic reporting!!!!", &a, &d, 0
EarlyInitMsg		DCB	"Early Register Init Start...", &a, &d, 0
EndEarlyInitMsg		DCB	"Early Register Init Complete!", &a, &d, 0
BootDiagComplete	DCB	"Boot Diagnostics Sequence Completed!", &a, &d, 0
PollBurnIn			DCB	"Polling GPIO for Burn-in Request...", &a, &d, 0
AckBurnIn			DCB	"Looping on Diagnostic Sequence.", &a, &d, 0
UndefInstMsg		DCB	"OUCH!!! Undefined Instruction encountered!", &a, &d, 0
SWIntMsg			DCB	"OUCH!!! Software Interrupt encountered!", &a, &d, 0
PrefAbrtMsg			DCB	"OUCH!!! Prefetch Abort encountered!", &a, &d, 0
DataAbrtMsg			DCB	"OUCH!!! Data Abort encountered!", &a, &d, 0
Cmplt				DCB	" Test Complete!", &a, &d, 0
Nfg					DCB	" FAILED!!!!", &a, &d, 0
Read				DCB	"Read =", 0
Expected			DCB	", Expected =", 0
CRLF				DCB	&a, &d, 0

	IF	:DEF:	CPUCACHE_EN
	EXPORT	MMUInitMsg			
	EXPORT	EndMMUInitMsg
	EXPORT	BypassMMUInitMsg		
MMUInitMsg			DCB	"Core MMU Init Start...", &a, &d, 0
EndMMUInitMsg		DCB	"Core MMU Init Complete!  Caches and MMU enabled.", &a, &d, 0
BypassMMUInitMsg	DCB	"Core MMU Init Bypassed.  Caches and MMU disabled.", &a, &d, 0
	ENDIF	;CPUCACHE_EN

	IF	:DEF:	FINALCSR_INIT
	EXPORT	FinalInitMsg		
	EXPORT	EndFinalInitMsg		
FinalInitMsg		DCB	"Final Register Init Start...", &a, &d, 0
EndFinalInitMsg		DCB	"Final Register Init Complete!", &a, &d, 0
	ENDIF	;FINALCSR_INIT

	IF	:DEF:	USTORE_TEST
	EXPORT	UcodeLoadTest		
	EXPORT	UcodeLoadTestOK		
	EXPORT	UcodeLoadTestFail
UcodeLoadTest		DCB	"Microengine Ucode Store Test Start...", &a, &d, 0
UcodeLoadTestOK		DCB	"Microengine Ucode Store Test Completed!", &a, &d, 0
UcodeLoadTestFail	DCB	"Microengine Ucode Store Test FAILED!!!!", &a, &d, 0
	ENDIF	;USTORE_TEST

	IF	:DEF:	PCITIMER_TEST
	EXPORT	PCITimerIrqFiqTest
	EXPORT	IRQLEDInfo
	EXPORT	FIQLEDInfo
	EXPORT	EndTimerIrqFiqTest
PCITimerIrqFiqTest	DCB	"PCI Timer/IRQ/FIQ Test Start...", &a, &d, 0
IRQLEDInfo			DCB	"IRQ test will count up at GPIO display.", &a, &d, 0
FIQLEDInfo			DCB	"FIQ test will count down at GPIO display.", &a, &d, 0
EndTimerIrqFiqTest	DCB	"PCI Timer/IRQ/FIQ Test Complete!", &a, &d, 0
	ENDIF	;PCITIMER_TEST

	IF	:DEF:	MEM_TEST
	EXPORT	MemAperTest		
	EXPORT	MemAperFail		
	EXPORT	EndMemAperTest
	EXPORT	MemLoc
	EXPORT	MemSDRAM
	EXPORT	MemSRAM
	EXPORT	MemSRAMEV
	EXPORT	MemScratch
	EXPORT	MemWrite
	EXPORT	MemRead
	EXPORT	MemClear
	EXPORT	MemProgress
	EXPORT	MemVectTest		
	EXPORT	EndMemVectTest
MemAperTest			DCB	"Memory Aperture Tests Start...", &a, &d, 0
MemSDRAM			DCB	"Testing SDRAM Memory:", &a, &d, 0
MemSRAM				DCB	"Testing SRAM Memory:", &a, &d, 0
MemSRAMEV			DCB	"Testing SRAM Exception Vector Memory:", &a, &d, 0
MemScratch			DCB	"Testing Scratch Memory:", &a, &d, 0
MemWrite			DCB	"  Writing  ", 0
MemRead				DCB	"  Reading  ", 0
MemClear			DCB	"  Clearing ", 0
MemProgress			DCB	".", 0
MemAperFail			DCB	"Memory Aperture Test FAILED!!!!.", &a, &d, 0
MemLoc				DCB	&a, &d,"Memory Location ", 0
EndMemAperTest		DCB	"Memory Aperture Tests Complete!", &a, &d, 0
MemVectTest			DCB	"SRAM Exception Table Memory Test Start...", &a, &d, 0
EndMemVectTest		DCB	"SRAM Exception Table Memory Test Complete!", &a, &d, 0
	ENDIF	;MEM_TEST

	IF	:DEF:	ROM_TEST
	EXPORT	RomAddrTest		
	EXPORT	RomAddrTestFail
	EXPORT	EndRomAddrTest
RomAddrTest			DCB	"ROM Device Address Test Start...", &a, &d, 0
RomAddrTestFail		DCB	" = Addr/Data ROM Device Address Test FAILED!!!!.", &a, &d, 0
EndRomAddrTest		DCB	"ROM Device Address Test Complete!", &a, &d, 0
	ENDIF	;ROM_TEST

	IF	:DEF:	UENGINE_TEST
	EXPORT	UengineTest		
	EXPORT	UengineTestEnd
	EXPORT	Meng	
	EXPORT	Ctx		
	EXPORT	Cmplt
UengineTest			DCB	"Micro Engine Functional Test Start...", &a, &d, 0
UengineTestEnd		DCB	"Micro Engine Functional Test Complete!", &a, &d, 0
Meng				DCB	"MicroEngine ", 0
Ctx					DCB	" Context ", 0
	ENDIF	;UENGINE_TEST

	IF	:DEF:	FBUS_TEST
	EXPORT	FbusTest		
	EXPORT	FbusTestEnd		
FbusTest			DCB	"F-Bus Functional Test Start...", &a, &d, 0
FbusTestEnd			DCB	"F-Bus Functional Test Complete!", &a, &d, 0
	ENDIF	;FBUS_TEST

	IF	:DEF:	PCI_TEST
	EXPORT	PCITest			
	EXPORT	PCITestEnd		
PCITest				DCB	"PCI Functional Test Start...", &a, &d, 0
PCITestEnd			DCB	"PCI Functional Test Complete!", &a, &d, 0
	ENDIF	;PCI_TEST

	IF	:DEF:	MAC_TEST
	EXPORT	MACTest				
	EXPORT	MACTestEnd		
	EXPORT	MACTestFail	
	EXPORT	MAC0DID
	EXPORT	MAC0REV
	EXPORT	GMACDID
	EXPORT	GMACREV
MACTest				DCB	"MAC CPU Port Functional Test Start...", &a, &d, 0
MACTestEnd			DCB	"MAC CPU Port Functional Test Complete!", &a, &d, 0
MACTestFail			DCB	"MAC CPU Port Functional Test FAILED!!!!", &a, &d, 0
MAC0DID				DCB	"Device ID read from MAC0 =", 0
MAC0REV				DCB	"Device Revision read from MAC0 =", 0
GMACDID				DCB	"Device ID read from GigaMAC =", 0
GMACREV				DCB	"Device Revision read from GigaMAC =", 0
	ENDIF	;MAC_TEST

	IF	:DEF:	MAC_WRTEST
	EXPORT	MACWRTest				
	EXPORT	MACWRTestEnd		
	EXPORT	MACWRTestFail	
	EXPORT	MACPort	
MACWRTest			DCB	"MAC CPU Port Read/Write Test Start...", &a, &d, 0
MACWRTestEnd		DCB	"MAC CPU Port Read/Write Test Complete!", &a, &d, 0
MACWRTestFail		DCB	"MAC CPU Port Read/Write Test FAILED!!!!", &a, &d, 0
MACPort				DCB	"MAC Port", 0
	ENDIF	;MAC_WRTEST


	END
