;*************************************************************************
; *
; * DIAG.S : Source file for the IXP1200 validation code diags to the User.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: diag.s $
; *
;*************************************************************************

	INCLUDE		H_CONFIG.S

DIAG_IO_PORT	EQU		(0x38400000 + 0x108000)


GoToRTOS1		EQU		0x1		;GPIO 0
GoToRTOS2		EQU		0x2		;GPIO 1
CacheEnable		EQU		0x4		;GPIO 2
RevDpcb			EQU		0x8		;GPIO 3


	MACRO
$label	CfgGpioDiag	$w1, $w2
		mov	$w2, #0xf			;gpio 0-3 as output
		ldr	$w1, =GPIO_PEN		;addr of dir enable reg
		str	$w2, [$w1]			;cfg gpios as outputs/core ctrl
	MEND

	MACRO
$label	OutDiag	$w1, $w2
		ldr	$w2, =DIAG_IO_PORT	;data reg addr to w2
		str	$w1, [$w2]			;data from w1 to gpio port
		DiagDelay	$w2			;slow for user to see
	MEND					

	MACRO
$label	OutData	$w1, $w2
		ldr	$w2, =DIAG_IO_PORT	;data reg addr to w2
		str	$w1, [$w2]			;data from w1 to gpio port
	MEND					
			
	MACRO
$label	OutGpioData	$w1, $w2
	ldr	$w2, =GPIO_PDR		;gpio data reg addr to w2
	str	$w1, [$w2]			;data from w1 to gpio port
	MEND					
			

			MACRO			
$label	DiagDelay	$w1
	IF 	:DEF:	SlowDiag
		IF	:DEF:	CORE162
			ldr	$w1, =0x50000	;
		ENDIF	
		IF	:DEF:	CORE133
			ldr	$w1, =0x18000	;
		ENDIF	
		IF	:DEF:	TSTCLK100
			ldr	$w1, =0x18000	;
		ENDIF	
1			subs	$w1, $w1, #1
			nop
			nop
			bne	%B01
	ENDIF
			MEND

	MACRO
$label	InGpioData	$w1, $w2, $w3, $w4

	ldr	$w2, =GPIO_PEN		;gpio dir reg addr to w2

	ldr	$w3, [$w2]			;dir cfg to w3

	mov	$w4, #0x0			;clear w4

	str	$w4, [$w2]			;cfg gpio to inputs/core ctrl

	DiagDelay	$w4			;slow


	ldr	$w4, =0x1000		;give pullups on gpio a chance to work
1	subs	$w4, $w4, #1
	nop
	nop
	bne	%B01


	ldr	$w4, =GPIO_PDR

	ldr	$w1, [$w4]			;get data

	str	$w3, [$w2]			;restore gpio cfg


	MEND


	END