;*************************************************************************
; *
; * H_21440.S : Equate file for the Intel 21440 Multiport EtherNet 
; * 			Controller registers.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_21440.s $
; *
;*************************************************************************

;Validation Platform IO base addresses for MAC devices

MAC0BASE		EQU		0x38400000
MAC1BASE		EQU		0x38408000


;21440 CSR offsets (multiply byte offsets by 4 for dword addressing)

Chip_Int		EQU		(0x00000000*4)
Int_Stat		EQU		(0x00000001*4)
Int_En			EQU		(0x00000002*4)
Tx_Stat			EQU		(0x00000003*4)
Rx_Stat			EQU		(0x00000004*4)
Port_Ctrl		EQU		(0x00000005*4)
Dev_ID			EQU		(0x00000006*4)
Rev_ID			EQU		(0x00000007*4)
Ser_Com			EQU		(0x00000008*4)
Ffo_Tshd		EQU		(0x00000011*4)
Ffo_Bus			EQU		(0x00000012*4)
Tx_Param		EQU		(0x00000013*4)
Rx_Param		EQU		(0x00000016*4)
Pkt_Max_SizeL	EQU		(0x0000001A*4)
Pkt_Max_SizeH	EQU		(0x0000001B*4)
Ser_mod			EQU		(0x00000021*4)
TxPkt64Cnt		EQU		(0x00000024*4)
TxPkt65Cnt		EQU		(0x00000028*4)
TxPkt128Cnt		EQU		(0x0000002C*4)
TxPkt256Cnt		EQU		(0x00000030*4)
TxPktErrCnt		EQU		(0x00000044*4)
RxPktOvfCnt		EQU		(0x00000084*4)
RxPkt64Cnt		EQU		(0x000000AC*4)
RxPkt65Cnt		EQU		(0x000000B0*4)
RxPkt128Cnt		EQU		(0x000000B4*4)
RxPkt256Cnt		EQU		(0x000000B8*4)
	 
;MAC0 CSR absolute addresses

MAC0_Chip_Int	EQU		MAC0BASE+Chip_Int
MAC0_Port_Ctrl	EQU		MAC0BASE+Port_Ctrl
MAC0_Dev_ID		EQU		MAC0BASE+Dev_ID
MAC0_Rev_ID		EQU		MAC0BASE+Rev_ID


;MAC1 CSR absolute addresses

MAC1_Chip_Int	EQU		MAC1BASE+Chip_Int
MAC1_Port_Ctrl	EQU		MAC1BASE+Port_Ctrl
MAC1_Dev_ID		EQU		MAC1BASE+Dev_ID
MAC1_Rev_ID		EQU		MAC1BASE+Rev_ID


;Read only device data from CSRs

Dev_ID_Data		EQU		0x01
Rev_ID_Data		EQU		0x11



	END