;*************************************************************************
; *
; * H_82547.S : Equate file for the Intel 82547 Dual Port GigaBit EtherNet 
; * 			Controller registers.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_82547.s $
; *
;*************************************************************************

;Validation Platform IO base address for giga MAC devices

GMACBASE		EQU		0x38408000


;CSR offsets (multiply byte offsets by 4 for dword addressing)

GMPort_CtrlL	EQU		(0x00000004*4)
GMPort_CtrlH   	EQU		(0x00000005*4)

GMDev_ID_RevL	EQU		(0x00000006*4)
GMDev_ID_RevH	EQU		(0x00000007*4)

GMTX_Rx_StatL 	EQU		(0x00000008*4)
GMTX_Rx_StatH 	EQU		(0x00000009*4)

GMFfo_ThrshL 	EQU		(0x00000022*4)
GMFfo_ThrshH 	EQU		(0x00000023*4)

GMPort_ModeL   	EQU		(0x00000024*4)
GMPort_ModeH   	EQU		(0x00000025*4)

GMTX_Rx_ParamL 	EQU		(0x00000026*4)
GMTX_Rx_ParamH 	EQU		(0x00000027*4)

TX_PKT_65_CNT0	EQU		(0x00000028*4)
TX_PKT_65_CNT1	EQU		(0x00000029*4)
TX_PKT_65_CNT2	EQU		(0x0000002A*4)
TX_PKT_65_CNT3	EQU		(0x0000002B*4)

GMPkt_Max_Size	EQU		(0x0000002C*4)

TX_ERR_CNT0		EQU		(0x00000044*4)
TX_ERR_CNT1		EQU		(0x00000045*4)
TX_ERR_CNT2		EQU		(0x00000046*4)
TX_ERR_CNT3		EQU		(0x00000047*4)

RX_PKT_65_CNT0	EQU		(0x000000B0*4)
RX_PKT_65_CNT1	EQU		(0x000000B1*4)
RX_PKT_65_CNT2	EQU		(0x000000B2*4)
RX_PKT_65_CNT3	EQU		(0x000000B3*4)

RX_OVF_CNT0		EQU		(0x00000084*4)
RX_OVF_CNT1		EQU		(0x00000085*4)
RX_OVF_CNT2		EQU		(0x00000086*4)
RX_OVF_CNT3		EQU		(0x00000087*4)


;CSR absolute addresses

GMAC_Dev_ID_RevL	EQU		(GMACBASE+GMDev_ID_RevL)
GMAC_Dev_ID_RevH	EQU		(GMACBASE+GMDev_ID_RevH)
GMAC_Pkt_Max_Size	EQU		(GMACBASE+GMPkt_Max_Size)


;Read only device data from CSRs

GMAC_Dev_ID_Data	EQU		0x05



	END