;*************************************************************************
; *
; * H_ARM.S : Equate file for the IXP1200 StrongARM CPU and CoProcessor
; * 			registers.
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_arm.s $
; *
;*************************************************************************

;StrongArm Program Status Register bit definitions...

ARMModeMask				EQU	0x001F	;ARM processor mode mask bits 5:0
SysMode					EQU	0x001F	;Arm system mode
UndMode					EQU	0x001B	;Arm undefined mode
AbtMode					EQU	0x0017	;ARM abort mode
SvcMode					EQU	0x0013	;ARM service mode
IrqMode					EQU	0x0012	;ARM IRQ mode
FiqMode					EQU	0x0011	;ARM FIQ mode
UsrMode					EQU	0x0010	;ARM user mode

ARMTFlag				EQU	0x0020	;ARM thumb execution flag
FiqMask					EQU	0x0040	;ARM FIQ disable
IrqMask					EQU	0x0080	;ARM IRQ disable	


;StrongARM CoProcessor register definitions...

MMUCP					CP 15		;CoProcessor 15 is MMU

MMUIDReg				CN 0		;CP15 ID register
MMUCtlReg				CN 1		;CP15 Control register
MMUXlatTblBaseReg		CN 2		;CP15 Translation Table Base register
MMUDomAccCtlReg			CN 3		;CP15 Domain Access Control register
MMUFaultStatReg			CN 5		;CP15 Fault Status register
MMUFaultAddReg			CN 6		;CP15 Fault Address register
MMUCacheFuncsReg		CN 7		;CP15 Cache Functions register
MMUTLBFuncsReg			CN 8		;CP15 Translation Look Aside Buffer Functions



;MMUIDReg bit definitions...

;MMUCtlReg bit definitions...
ICachen					EQU	0x1000
ROMProt					EQU	0x0200
SysProt					EQU	0x0100
BigEndian				EQU	0x0080
Data26Dis				EQU	0x0020
Except32				EQU	0x0010
WrBuffEn				EQU	0x0008
IDCachen				EQU	0x0004
AlignChkEn				EQU	0x0002
MMUEn					EQU	0x0001

;MMUXlatTblBaseReg bit definitions...
;MMUDomAccCtlReg bit definitions...
;MMUFaultStatReg bit definitions...
;MMUFaultAddReg bit definitions...
;MMUCacheFuncsReg bit definitions...
;MMUTLBFuncsReg bit definitions...

MMUStartCfg				EQU	Data26Dis:OR:Except32

	END
