;*************************************************************************
; *
; * H_CONFIG.S : Configuration file for the IXP1200 boot code.
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_config.s $
; *
;*************************************************************************


;Test Configuration definitions...

;	GBLL	GPIO_TEST		;enable count on GPIO 0-Fh
;GPIO_TEST	SETL	{TRUE}

;	GBLL	GPIO_TEST2		;enable count on GPIO 0-Fh
;GPIO_TEST2	SETL	{TRUE}

	GBLL	CPUREG_TEST		;enable CPU register test
CPUREG_TEST	SETL	{TRUE}

	GBLL	CPUCACHE_EN		;enable cache option
CPUCACHE_EN	SETL	{TRUE}

;	GBLL	FINALCSR_INIT 	;enable late CSR programming
;FINALCSR_INIT	SETL	{TRUE}

	GBLL	MEM_TEST		;enable testing of memory apetures
MEM_TEST	SETL	{TRUE}

;If MEM_TEST is included the following memory areas may be
; individually enabled or disabled...
	GBLL	TEST_DRAM		;enable system SDRAM for test
TEST_DRAM	SETL	{TRUE}

	GBLL	TEST_SRAM		;enable system SRAM for test
TEST_SRAM	SETL	{TRUE}

	GBLL	TEST_SCRATCH	;enable scratch memory for test
TEST_SCRATCH	SETL	{TRUE}

;	GBLL	ROM_TEST		;enable testing of memory apetures
;ROM_TEST	SETL	{TRUE}

	GBLL	MAC_TEST		;enable read of MAC rev_id and chip_id
MAC_TEST	SETL	{TRUE}

	GBLL	MAC_WRTEST		;enable read of MAC rev_id and chip_id
MAC_WRTEST	SETL	{TRUE}

	GBLL	USTORE_TEST		;enable test of 6 ustore areas
USTORE_TEST	SETL	{TRUE}

	GBLL	PCITIMER_TEST	;enable pci timer test (uses fiqs and irqs)
PCITIMER_TEST	SETL	{TRUE}

	GBLL	UENGINE_TEST		;enable test of SDRAM from uEng
UENGINE_TEST	SETL	{TRUE}

; 	GBLL	PCI_TEST
;PCI_TEST	SETL	{TRUE}

 	GBLL	IXBUS_TEST
IXBUS_TEST	SETL	{TRUE}

;System Configuration definitions...

;Select the CSR tables based on input clk if rev A silicon detected. Select one 
; of the three ONLY.

;	GBLL	A_CORE192			;enable CSR programming for 192Mhz timing
;A_CORE192	SETL	{TRUE}

	GBLL	A_CORE177			;enable CSR programming for 177Mhz timing
A_CORE177	SETL	{TRUE}

;	GBLL	A_CORE162			;enable CSR programming for 162Mhz timing
;A_CORE162	SETL	{TRUE}


;Select the CSR tables based on input clk if rev B silicon detected. Select one 
; ONLY.

	GBLL	B_CORE199			;enable CSR programming for 199Mhz timing
B_CORE199	SETL	{TRUE}

;	GBLL	B_CORE192			;enable CSR programming for 192Mhz timing
;B_CORE192	SETL	{TRUE}

;	GBLL	B_CORE177			;enable CSR programming for 177Mhz timing
;B_CORE177	SETL	{TRUE}

;	GBLL	B_CORE162			;enable CSR programming for 162Mhz timing
;B_CORE162	SETL	{TRUE}

  

;	GBLL	SlowDiag		;enable diag delay to make readable by user
;SlowDiag	SETL	{TRUE}


	END