;*************************************************************************
; *
; * H_FBI.S : Equate file for the IXP1200 FBI controller registers.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_fbi.s $
; *
;*************************************************************************

;FBI controller register base and offset definitions...

FBI_BASE_ADDR					EQU	0xB0040000

OFF_IREG						EQU	0x000001E0
OFF_SOP_SEQ_1					EQU	0x00000020
OFF_SOP_SEQ_2					EQU	0x00000024
OFF_ENQUEUE_SEQ1				EQU	0x00000028
OFF_ENQUEUE_SEQ2				EQU	0x0000002C
OFF_INTER_THD_SIG				EQU	0x000001C0
OFF_THREAD_DONE_REG0			EQU	0x00000008
OFF_THREAD_DONE_REG1			EQU	0x0000000C
;OFF_THREAD_DONE_INCR1			EQU	0x00000000		;NCA
;OFF_THREAD_DONE_INCR2			EQU	0x00000000		;NCA
OFF_RCV_RDY_CNT					EQU	0x000000C0
OFF_RCV_RDY_HI					EQU	0x000000C8
OFF_RCV_RDY_LO					EQU	0x000000C4
OFF_RCV_RDY_CTL					EQU	0x000000F8
OFF_RCV_REQ						EQU	0x0000001C
OFF_RCV_CNTL					EQU	0x00000018
OFF_REC_FASTPORT_CTL			EQU	0x00000030
OFF_FLOWCTL_MASK_REG			EQU	0x00000194
OFF_RDYBUS_TEMPLATE_CTL			EQU	0x00000180
OFF_RDYBUS_TEMPLATE_PROG_3		EQU	0x0000018C
OFF_RDYBUS_TEMPLATE_PROG_2	EQU	0x00000188
OFF_RDYBUS_TEMPLATE_PROG_1	EQU	0x00000184
OFF_RDYBUS_SYNC_CNT_DFLT	EQU	0x00000190
OFF_SELF_DESTRUCT				EQU	0x000001D4
;OFF_CYCLE_COUNT				EQU	0x00000000		;NCA
OFF_HASH_MULT_64_HI			EQU	0x00000144
OFF_HASH_MULT_64_LO			EQU	0x00000140
OFF_HASH_MULT_48_HI			EQU	0x0000014C
OFF_HASH_MULT_48_LO			EQU	0x00000148
OFF_SEND_CMD					EQU	0x00000198
OFF_GET_CMD						EQU	0x000001B0
OFF_XMIT_RDY_LO				EQU	0x000000E4
OFF_XMIT_RDY_HI				EQU	0x000000E8
OFF_XMIT_RDY_CTL				EQU	0x000000FC
;OFF_XMIT_VALIDATE			EQU	0x00000000		;NCA
OFF_XMIT_PTR					EQU	0x000000E0


;FBI controller register absolute definitions...

IREG								EQU	FBI_BASE_ADDR+OFF_IREG							
SOP_SEQ_1						EQU	FBI_BASE_ADDR+OFF_SOP_SEQ_1					
SOP_SEQ_2						EQU	FBI_BASE_ADDR+OFF_SOP_SEQ_2					
ENQUEUE_SEQ1					EQU	FBI_BASE_ADDR+OFF_ENQUEUE_SEQ1				
ENQUEUE_SEQ2					EQU	FBI_BASE_ADDR+OFF_ENQUEUE_SEQ2				
INTER_THD_SIG					EQU	FBI_BASE_ADDR+OFF_INTER_THD_SIG				
THREAD_DONE_REG0				EQU	FBI_BASE_ADDR+OFF_THREAD_DONE_REG0			
THREAD_DONE_REG1				EQU	FBI_BASE_ADDR+OFF_THREAD_DONE_REG1			
;THREAD_DONE_INCR1			EQU	FBI_BASE_ADDR+OFF_THREAD_DONE_INCR1		;NCA
;THREAD_DONE_INCR2			EQU	FBI_BASE_ADDR+OFF_THREAD_DONE_INCR2		;NCA
RCV_RDY_CNT						EQU	FBI_BASE_ADDR+OFF_RCV_RDY_CNT				
RCV_RDY_HI						EQU	FBI_BASE_ADDR+OFF_RCV_RDY_HI					
RCV_RDY_LO						EQU	FBI_BASE_ADDR+OFF_RCV_RDY_LO					
RCV_RDY_CTL						EQU	FBI_BASE_ADDR+OFF_RCV_RDY_CTL				
RCV_REQ							EQU	FBI_BASE_ADDR+OFF_RCV_REQ						
RCV_CNTL							EQU	FBI_BASE_ADDR+OFF_RCV_CNTL					
REC_FASTPORT_CTL				EQU	FBI_BASE_ADDR+OFF_REC_FASTPORT_CTL			
FLOWCTL_MASK_REG				EQU	FBI_BASE_ADDR+OFF_FLOWCTL_MASK_REG			
RDYBUS_TEMPLATE_CTL			EQU	FBI_BASE_ADDR+OFF_RDYBUS_TEMPLATE_CTL		
RDYBUS_TEMPLATE_PROG_3		EQU	FBI_BASE_ADDR+OFF_RDYBUS_TEMPLATE_PROG_3
RDYBUS_TEMPLATE_PROG_2		EQU	FBI_BASE_ADDR+OFF_RDYBUS_TEMPLATE_PROG_2
RDYBUS_TEMPLATE_PROG_1		EQU	FBI_BASE_ADDR+OFF_RDYBUS_TEMPLATE_PROG_1
RDYBUS_SYNC_CNT_DFLT			EQU	FBI_BASE_ADDR+OFF_RDYBUS_SYNC_CNT_DFLT	
SELF_DESTRUCT					EQU	FBI_BASE_ADDR+OFF_SELF_DESTRUCT				
;CYCLE_COUNT					EQU	FBI_BASE_ADDR+OFF_CYCLE_COUNT				;NCA
HASH_MULT_64_HI				EQU	FBI_BASE_ADDR+OFF_HASH_MULT_64_HI			
HASH_MULT_64_LO				EQU	FBI_BASE_ADDR+OFF_HASH_MULT_64_LO			
HASH_MULT_48_HI				EQU	FBI_BASE_ADDR+OFF_HASH_MULT_48_HI			
HASH_MULT_48_LO				EQU	FBI_BASE_ADDR+OFF_HASH_MULT_48_LO			
SEND_CMD							EQU	FBI_BASE_ADDR+OFF_SEND_CMD					
GET_CMD							EQU	FBI_BASE_ADDR+OFF_GET_CMD						
XMIT_RDY_LO						EQU	FBI_BASE_ADDR+OFF_XMIT_RDY_LO				
XMIT_RDY_HI						EQU	FBI_BASE_ADDR+OFF_XMIT_RDY_HI				
XMIT_RDY_CTL					EQU	FBI_BASE_ADDR+OFF_XMIT_RDY_CTL				
;XMIT_VALIDATE					EQU	FBI_BASE_ADDR+OFF_XMIT_VALIDATE			;NCA
XMIT_PTR							EQU	FBI_BASE_ADDR+OFF_XMIT_PTR					

;NCA = No Core Access (microengine only)


;IREG register bit definitions...

UEFIQ		EQU	0x80000000	;uEngine FIQ int enable
UEIRQ		EQU	0x40000000	;uEngine IRQ int enable
CINTFIQ	EQU	0x20000000	;CINT IRQ int enable
CINTIRQ	EQU	0x10000000	;CINT FIQ int enable
THD23		EQU	0x00800000	;CINT int status
THD22		EQU	0x00400000	;uEngine thread 23 int request
THD21		EQU	0x00200000	;uEngine thread 22 int request
THD20		EQU	0x00100000	; .
THD19		EQU	0x00080000	; .
THD18		EQU	0x00040000	; .
THD17		EQU	0x00020000	; 
THD16		EQU	0x00010000	; 
THD15		EQU	0x00008000	; 
THD14		EQU	0x00004000	; 
THD13		EQU	0x00002000	; 
THD12		EQU	0x00001000	; 
THD11		EQU	0x00000800	; 
THD10		EQU	0x00000400	; 
THD09		EQU	0x00000200	; 
THD08		EQU	0x00000100	; 
THD07		EQU	0x00000080	; 
THD06		EQU	0x00000040	; 
THD05		EQU	0x00000020	; 
THD04		EQU	0x00000010	; .
THD03		EQU	0x00000008	; .
THD02		EQU	0x00000004	; .
THD01		EQU	0x00000002	;uEngine thread 01 int request
THD00		EQU	0x00000001	;uEngine thread 00 int request
 

;SOP_SEQ_1 register bit definitions...

SOP_SEQ1_MASK	EQU	0x0000000F	;SOP sequence 1


;SOP_SEQ_2 register bit definitions...
	   
SOP_SEQ2_MASK	EQU	0x0000000F	;SOP sequence 2


;ENQUEUE_SEQ_1 register bit definitions...

ENQUEUE_SEQ1_MASK	EQU	0x0000000F	;ENQUEUE sequence 1


;ENQUEUE_SEQ_2 register bit definitions...
	   
ENQUEUE_SEQ2_MASK	EQU	0x0000000F	;ENQUEUE sequence 2


;INTER_THD_SIG register bit definitions...

;????


;THREAD_DONE_REG0 register bit definitions...

;These field encodings pertain to the thread masks below

BSY			EQU	0x0		;Thread busy
NBSY			EQU	0x1		;Thread not busy
NBSYW			EQU	0x2		;Thread not busy but waiting


THD15_MASK		EQU	0xC0000000
THD14_MASK		EQU	0x30000000
THD13_MASK		EQU	0x0C000000
THD12_MASK		EQU	0x03000000
THD11_MASK		EQU	0x00C00000
THD10_MASK		EQU	0x00300000
THD09_MASK		EQU	0x000C0000
THD08_MASK		EQU	0x00030000
THD07_MASK		EQU	0x0000C000
THD06_MASK		EQU	0x00003000
THD05_MASK		EQU	0x00000C00
THD04_MASK		EQU	0x00000300
THD03_MASK		EQU	0x000000C0
THD02_MASK		EQU	0x00000030
THD01_MASK		EQU	0x0000000C
THD00_MASK		EQU	0x00000003


;THREAD_DONE_REG1 register bit definitions...

THD23_MASK		EQU	0x0000C000
THD22_MASK		EQU	0x00003000
THD21_MASK		EQU	0x00000C00
THD20_MASK		EQU	0x00000300
THD19_MASK		EQU	0x000000C0
THD18_MASK		EQU	0x00000030
THD17_MASK		EQU	0x0000000C
THD16_MASK		EQU	0x00000003


;RCV_RDY_CNT register bit definitions...

FCMA					EQU	0x04000000	;Flow control mask	
FRDY2					EQU	0x02000000	;Fast rcv ready 2
FRDY1					EQU	0x01000000	;Fast rcv ready 1
RCV_REQ_CNT_MASK	EQU	0x0000FF00	;Rcv request count
RCV_RDY_CNT_MASK	EQU	0x000000FF	;Rcv ready count


;RCV_RDY_HI register bit definitions...

RR63			EQU	0x80000000	;Rcv fifo ready port 63
RR62			EQU	0x40000000	;Rcv fifo ready port 62
RR61			EQU	0x20000000	; .
RR60			EQU	0x10000000	; .
RR59			EQU	0x08000000	; .
RR58			EQU	0x04000000	;
RR57			EQU	0x02000000	;
RR56			EQU	0x01000000	;
RR55			EQU	0x00800000	;
RR54			EQU	0x00400000	;
RR53			EQU	0x00200000	;
RR52			EQU	0x00100000	;
RR51			EQU	0x00080000	;
RR50			EQU	0x00040000	;
RR49			EQU	0x00020000	;
RR48			EQU	0x00010000	;
RR47			EQU	0x00008000	;
RR46			EQU	0x00004000	;
RR45			EQU	0x00002000	;
RR44			EQU	0x00001000	;
RR43			EQU	0x00000800	;
RR42			EQU	0x00000400	;
RR41			EQU	0x00000200	;
RR40			EQU	0x00000100	;
RR39			EQU	0x00000080	;
RR38			EQU	0x00000040	;
RR37			EQU	0x00000020	;
RR36			EQU	0x00000010	; .
RR35			EQU	0x00000008	; .
RR34			EQU	0x00000004	; .
RR33			EQU	0x00000002	;Rcv fifo ready port 31
RR32			EQU	0x00000001	;Rcv fifo ready port 32


;RCV_RDY_LO register bit definitions...

RR31			EQU	0x80000000	;Rcv fifo ready port 31
RR30			EQU	0x40000000	;Rcv fifo ready port 30
RR29			EQU	0x20000000	; .
RR28			EQU	0x10000000	; .
RR27			EQU	0x08000000	; .
RR26			EQU	0x04000000	;
RR25			EQU	0x02000000	;
RR24			EQU	0x01000000	;
RR23			EQU	0x00800000	;
RR22			EQU	0x00400000	;
RR21			EQU	0x00200000	;
RR20			EQU	0x00100000	;
RR19			EQU	0x00080000	;
RR18			EQU	0x00040000	;
RR17			EQU	0x00020000	;
RR16			EQU	0x00010000	;
RR15			EQU	0x00008000	;
RR14			EQU	0x00004000	;
RR13			EQU	0x00002000	;
RR12			EQU	0x00001000	;
RR11			EQU	0x00000800	;
RR10			EQU	0x00000400	;
RR09			EQU	0x00000200	;
RR08			EQU	0x00000100	;
RR07			EQU	0x00000080	;
RR06			EQU	0x00000040	;
RR05			EQU	0x00000020	;
RR04			EQU	0x00000010	; .
RR03			EQU	0x00000008	; .
RR02			EQU	0x00000004	; .
RR01			EQU	0x00000002	;Rcv fifo ready port 01
RR00			EQU	0x00000001	;Rcv fifo ready port 00


;RCV_RDY_CTL register bit definitions...

FPTM_MASK				EQU	0x00006000	;Fast port thread mode
APW_MASK					EQU	0x00001C00	;Autopush prevent window
APE						EQU	0x00000200	;Autopush enable
APC						EQU	0x00000100	;Autopush control
APDR_MASK				EQU	0x000000C0	;Autopush destination reg
STE						EQU	0x00000020	;Signal thread enable
RCV_SCH_THD_ID_MASK	EQU	0x0000001F	;Rcv sceduler thread ID


;RCV_REQ register bit definitions...

FA					EQU	0x20000000	;Max fifo bus access
TMSG_MASK		EQU	0x18000000	;Thread message

PSL					EQU	0x04000000	;Packet status length

E2					EQU	0x03C00000	;Rcv fifo element #2
E1					EQU	0x003C0000	;Rcv fifo element #1
FS_MASK			EQU	0x00030000	;Fast/slow port mode select
FE					EQU	0x00008000	;Assign 1 or 2 fifo elements
FSP				EQU	0x00001000	;Forced SOP
SIGRS				EQU	0x00000800	;Signal rcv scheduler thread
TID_MASK			EQU	0x000007C0	;Thread ID
RP_MASK			EQU	0x0000003F	;Rcv port


;RCV_CTL register bit definitions...

THMSG_MASK			EQU	0xC0000000	;Thread message
MACPORTTHD_MASK	EQU	0x3F000000	;MAC port number/header
SOPSEQ_MASK			EQU	0x00F00000	;Start of packet sequence #
RF						EQU	0x00080000	;Rcv fail
ROK					EQU	0x00040000	;Rcv OK
_2E_MASK				EQU	0x0003C000	;Second element
_1E_MASK				EQU	0x00003C00	;First element
RCV_EF				EQU	0x00000200	;Elements filled
SN						EQU	0x00000100	;Sequence number
VALID_BYTES_MASK	EQU	0x000000FC	;# of valid bytes in rcv fifo
EOP					EQU	0x00000002	;End of packet
SOP					EQU	0x00000001	;Start of packet
						

;REC_FASTPORT_CTL register bit definitions...

FP2_HDR_THD_ID_MASK	EQU	0x000F8000	;fast port 2 hdr proc thd ID
FP2_BODY_THD_MASK		EQU	0x00007C00	;fast port 2 bdy proc thd ID
FP1_HDR_THD_ID_MASK	EQU	0x000003E0	;fast port 1 hdr proc thd ID
FP1_BODY_THD_MASK		EQU	0x0000001F	;fast port 1 bdy proc thd ID


;FLOWCTL_MASK register bit definitions...

FLWCTL_MAC_MASK	EQU	0x00000700	;Flow control MAC mask
FLWCTL_MAC_0		EQU	0x00000700	;Flow control MAC 0
FLWCTL_MAC_1		EQU	0x00000600	;Flow control MAC 1
FLWCTL_MAC_2		EQU	0x00000500	;Flow control MAC 2
FLWCTL_MAC_3		EQU	0x00000400	;Flow control MAC 3
FLWCTL_MAC_4		EQU	0x00000300	;Flow control MAC 4
FLWCTL_MAC_5		EQU	0x00000200	;Flow control MAC 5
FLWCTL_MAC_6		EQU	0x00000100	;Flow control MAC 6
FLWCTL_MAC_7		EQU	0x00000000	;Flow control MAC 7
FLOWCTL_MASK		EQU	0x000000FF	;Flow control mask


;RDYBUS_TEMPLATE_CTL register bit definitions...

ER			EQU	0x00000800	;Enable ready bus sequencer
TM			EQU	0x00000400	;MAC timing mode
FM			EQU	0x00000200	;Fbus mode
MS			EQU	0x00000100	;Master/slave
ML			EQU	0x00000080	;Multi IXP1200 mode
ST			EQU	0x00000040	;Status mode


;RDYBUS_TEMPLATE_PROG_3 register bit definitions...

RB_INSTR_11_MASK	EQU	0xFF000000	;Ready bus instruction 11
RB_INSTR_10_MASK	EQU	0x00FF0000	;Ready bus instruction 10
RB_INSTR_09_MASK	EQU	0x0000FF00	;Ready bus instruction 9
RB_INSTR_08_MASK	EQU	0x000000FF	;Ready bus instruction 8


;RDYBUS_TEMPLATE_PROG_2 register bit definitions...

RB_INSTR_07_MASK	EQU	0xFF000000	;Ready bus instruction 7
RB_INSTR_06_MASK	EQU	0x00FF0000	;Ready bus instruction 6
RB_INSTR_05_MASK	EQU	0x0000FF00	;Ready bus instruction 5
RB_INSTR_04_MASK	EQU	0x000000FF	;Ready bus instruction 4


;RDYBUS_TEMPLATE_PROG_1 register bit definitions...

RB_INSTR_03_MASK	EQU	0xFF000000	;Ready bus instruction 3
RB_INSTR_02_MASK	EQU	0x00FF0000	;Ready bus instruction 2
RB_INSTR_01_MASK	EQU	0x0000FF00	;Ready bus instruction 1
RB_INSTR_00_MASK	EQU	0x000000FF	;Ready bus instruction 0


;RDYBUS_SYNC_CNT_DFLT register bit definitions...

RDYBUS_TIMER_MASK	EQU	0x0000FFFF	;Min # Fbus cycles each 
						; iteration of the ready bus
						; sequencer
;SELF_DESTRUCT register bit definitions...

;HASH_MULT_64_HI register bit definitions...

;HASH_MULT_64_LO register bit definitions...

;HASH_MULT_48_HI register bit definitions...

;HASH_MULT_48_LO register bit definitions...

;SEND_CMD register bit definitions...

SEND_MSGS_MASK		EQU	0x0000FFFF	;inter IXP1200 com send reg


;GET_CMD register bit definitions...

;XMIT_RDY_LO register bit definitions...

TR31			EQU	0x80000000	;Tx fifo ready port 31
TR30			EQU	0x40000000	;Tx fifo ready port 30
TR29			EQU	0x20000000	; .
TR28			EQU	0x10000000	; .
TR27			EQU	0x08000000	; .
TR26			EQU	0x04000000	;
TR25			EQU	0x02000000	;
TR24			EQU	0x01000000	;
TR23			EQU	0x00800000	;
TR22			EQU	0x00400000	;
TR21			EQU	0x00200000	;
TR20			EQU	0x00100000	;
TR19			EQU	0x00080000	;
TR18			EQU	0x00040000	;
TR17			EQU	0x00020000	;
TR16			EQU	0x00010000	;
TR15			EQU	0x00008000	;
TR14			EQU	0x00004000	;
TR13			EQU	0x00002000	;
TR12			EQU	0x00001000	;
TR11			EQU	0x00000800	;
TR10			EQU	0x00000400	;
TR09			EQU	0x00000200	;
TR08			EQU	0x00000100	;
TR07			EQU	0x00000080	;
TR06			EQU	0x00000040	;
TR05			EQU	0x00000020	;
TR04			EQU	0x00000010	; .
TR03			EQU	0x00000008	; .
TR02			EQU	0x00000004	; .
TR01			EQU	0x00000002	;Tx fifo ready port 01
TR00			EQU	0x00000001	;Tx fifo ready port 00


;XMIT_RDY_HI register bit definitions...

TR63			EQU	0x80000000	;Tx fifo ready port 63
TR62			EQU	0x40000000	;Tx fifo ready port 62
TR61			EQU	0x20000000	; .
TR60			EQU	0x10000000	; .
TR59			EQU	0x08000000	; .
TR58			EQU	0x04000000	;
TR57			EQU	0x02000000	;
TR56			EQU	0x01000000	;
TR55			EQU	0x00800000	;
TR54			EQU	0x00400000	;
TR53			EQU	0x00200000	;
TR52			EQU	0x00100000	;
TR51			EQU	0x00080000	;
TR50			EQU	0x00040000	;
TR49			EQU	0x00020000	;
TR48			EQU	0x00010000	;
TR47			EQU	0x00008000	;
TR46			EQU	0x00004000	;
TR45			EQU	0x00002000	;
TR44			EQU	0x00001000	;
TR43			EQU	0x00000800	;
TR42			EQU	0x00000400	;
TR41			EQU	0x00000200	;
TR40			EQU	0x00000100	;
TR39			EQU	0x00000080	;
TR38			EQU	0x00000040	;
TR37			EQU	0x00000020	;
TR36			EQU	0x00000010	; .
TR35			EQU	0x00000008	; .
TR34			EQU	0x00000004	; .
TR33			EQU	0x00000002	;Tx fifo ready port 33
TR32			EQU	0x00000001	;Tx fifo ready port 32


;XMIT_RDY_CTL register bit definitions...

TV_MASK		EQU	0xFFFF0000	;Tfifo valad flag mask
TV15			EQU	0X80000000	;Tfifo 15 valid flag
TV14			EQU	0X40000000	;Tfifo 14 valid flag
TV13			EQU	0X20000000	; .
TV12			EQU	0X10000000	; .
TV11			EQU	0X08000000	; .
TV10			EQU	0X04000000	;
TV09			EQU	0X02000000	;
TV08			EQU	0X01000000	;
TV07			EQU	0X00800000	;
TV06			EQU	0X00400000	;
TV05			EQU	0X00200000	;
TV04			EQU	0X00100000	; .
TV03			EQU	0X00080000	; .
TV02			EQU	0X00040000	; .
TV01			EQU	0X00020000	;Tfifo 1 valid flag
TV00			EQU	0X00010000	;Tfifo 0 valid flag
TX_EF			EQU	0x00000400
EAP			EQU	0x00000200
AP_REG_MASK	EQU	0x000000FF


;XMIT_PTR register bit definitions...

TX_REM_PTR_MASK		EQU	0x0000000F	;Transmit remove pointer mask



	END
