;*************************************************************************
; *
; * H_MENG.S : Equate file for the IXP1200 Microengine registers.
; * 		   
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_meng.s $
; *
;*************************************************************************

;MicroEngine register definitions...

;MicroEngine base addresses...

MENG0_BASE_ADDR		EQU	0xB0000000
MENG1_BASE_ADDR		EQU	0xB0000800
MENG2_BASE_ADDR		EQU	0xB0001000
MENG3_BASE_ADDR		EQU	0xB0001800
MENG4_BASE_ADDR		EQU	0xB0002000
MENG5_BASE_ADDR		EQU	0xB0002800


;uEngine register offsets...

USTORE_ADDR				EQU	0x00000000
USTORE_DATA				EQU	0x00000004
ALU_OUTPUT				EQU	0x00000008
ACTIVE_CTX_STS			EQU	0x00000010
EN_SRAM_JOURN			EQU	0x00000018
CTX_ARB_CNTL			EQU	0x00000024
CTX_ENABLES				EQU	0x00000028
CC_ENABLE				EQU	0x0000002C
CTX_0_STATUS			EQU	0x00000034
CTX_1_STATUS			EQU	0x00000038
CTX_2_STATUS			EQU	0x0000003C
CTX_3_STATUS			EQU	0x00000040
CTX_0_SIG_EVENTS		EQU	0x00000044
CTX_1_SIG_EVENTS		EQU	0x00000048
CTX_2_SIG_EVENTS		EQU	0x0000004C
CTX_3_SIG_EVENTS		EQU	0x00000050
CTX_0_WAKE_EVENTS		EQU	0x00000054
CTX_1_WAKE_EVENTS		EQU	0x00000058
CTX_2_WAKE_EVENTS		EQU	0x0000005C
CTX_3_WAKE_EVENTS		EQU	0x00000060


;USTORE_ADDR Register bit definitions...

ECS				EQU	0x00000400
UADR_MASK		EQU	0x000003FF
USTORE_SIZE		EQU	0x00000400
;USTORE_SIZE		EQU	0x0000000F	;ccli size! for debug only


;USTORE_DATA Register bit definitions...

;ALU_OUTPUT Register bit definitions...

;ACTIVE_CTX_STS Register bit definitions...

ACTXPC_MASK		EQU	0x00001FF8
AB					EQU	0x00000004
ACNO				EQU	0x00000003


;EN_SRAM_JOURN Register bit definitions...

JE				EQU	0x00000002


;CTX_ARB_CNTL Register bit definitions...

PCTX_MASK			EQU	0x00000030
NCTX_MASK			EQU	0x0000000C


;CTX_ENABLES Register bit definitions...

C3				EQU	0x00000800
C2				EQU	0x00000400
C1				EQU	0x00000200
C0				EQU	0x00000100


;CC_ENABLE Register bit definitions...

PR				EQU	0x00002000
CU				EQU	0x00001000



;CTX_0_STATUS Register bit definitions...
;CTX_1_STATUS Register bit definitions...
;CTX_2_STATUS Register bit definitions...
;CTX_3_STATUS Register bit definitions...

CR_MASK		EQU	0x00001800
RR				EQU	0x00000400
CTXPC_MASK	EQU	0x000003FF


;CTX_0_SIG_EVENTS Register bit definitions...
;CTX_1_SIG_EVENTS Register bit definitions...
;CTX_2_SIG_EVENTS Register bit definitions...
;CTX_3_SIG_EVENTS Register bit definitions...

S2_SIG				EQU	0x00000100
S1_SIG				EQU	0x00000080
PC_SIG				EQU	0x00000040
SE_SIG				EQU	0x00000020
AP_SIG				EQU	0x00000010
TD_SIG				EQU	0x00000008
FB_SIG				EQU	0x00000004
SD_SIG				EQU	0x00000002
SR_SIG				EQU	0x00000001


;CTX_0_WAKE_EVENTS Register bit definitions...
;CTX_1_WAKE_EVENTS Register bit definitions...
;CTX_2_WAKE_EVENTS Register bit definitions...
;CTX_3_WAKE_EVENTS Register bit definitions...

S2_WAK				EQU	0x00000200
S1_WAK				EQU	0x00000100
PC_WAK				EQU	0x00000080
SE_WAK				EQU	0x00000040
AP_WAK				EQU	0x00000020
TD_WAK				EQU	0x00000010
FB_WAK				EQU	0x00000008
SD_WAK				EQU	0x00000004
SR_WAK				EQU	0x00000002
VS_WAK				EQU	0x00000001


	END
