;*************************************************************************
; *
; * H_PCI.S : Equate file for the IXP1200 StrongARM core PCI registers.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: H_PCI.S $
; 
; *****************  Version 9  *****************
; User: Tepulkow     Date: 12/05/00   Time: 10:40a
; Updated in $/dev_1200/BoardSupport/Diagnostics
; Fixed bit definitions for PCI_RESET csr.
; *
;*************************************************************************

;StrongARM core PCI register base and offset definitions...

SACPCI_BASE_ADDR					EQU	0x42000000

OFF_VEN_ID							EQU	0x000
OFF_DEV_ID							EQU	0x002
OFF_PCICFG_CMD						EQU	0x004
OFF_PCICFG_STATUS					EQU	0x006
OFF_REV_ID							EQU	0x008
OFF_CLASS_CODE						EQU	0x00A
OFF_CACHE_LNSIZE					EQU	0x00C
OFF_LAT_TMR							EQU	0x00D
OFF_HDR_TYPE						EQU	0x00E
OFF_BIST							EQU	0x00F
OFF_PCI_CSR_MEM_BASE_ADDR			EQU	0x010
OFF_PCI_CSR_IO_BASE_ADDR			EQU	0x014
OFF_PCI_SDRAM_BASE_ADDR				EQU	0x018
OFF_PCI_SUBSYS_VEN_ID				EQU	0x02C
OFF_SUBSYS_ID						EQU	0x02E
OFF_CAP_PTR							EQU	0x034
OFF_INT_PIN							EQU	0x03D
OFF_MIN_GNT							EQU	0x03E
OFF_MAX_LAT							EQU	0x03F
OFF_I2O_INB_FIFO					EQU	0x040
OFF_I2O_OUTB_FIFO					EQU	0x044
OFF_MAILBOX0						EQU	0x050
OFF_MAILBOX1						EQU	0x054
OFF_MAILBOX2						EQU	0x058
OFF_MAILBOX3						EQU	0x05C
OFF_DOORBELL 						EQU	0x060
OFF_DOORBELL_SETUP					EQU	0x064
OFF_CAP_PTR_EXT						EQU	0x070
OFF_PWR_MGT							EQU	0x074
OFF_PCI_RESET						EQU	0x07C
OFF_DMA1_BYTECNT					EQU	0x080
OFF_DMA1_PCI_ADDR					EQU	0x084
OFF_DMA1_SDRAM_ADDR					EQU	0x088
OFF_DMA1_DESC_PTR					EQU	0x08C
OFF_DMA1_CTL						EQU	0x090
OFF_DMA_INTER_MODE					EQU	0x09C
OFF_DMA2_BYTECNT					EQU	0x0A0
OFF_DMA2_PCI_ADDR					EQU	0x0A4
OFF_DMA2_SDRAM_ADDR					EQU	0x0A8
OFF_DMA2_DESC_PTR					EQU	0x0AC
OFF_DMA2_CTL						EQU	0x0B0
OFF_PCI_CSR_BASE_ADDR_MSK			EQU	0x0F8
OFF_PCI_SDRAM_BASE_ADDR_MSK			EQU	0x100
OFF_I2O_INB_FLST_HPTR				EQU	0x120
OFF_I2O_INB_PLIST_TPTR				EQU	0x124
OFF_I2O_OUTB_PLIST_HPTR				EQU	0x128
OFF_I2O_OUTB_FLIST_TPTR				EQU	0x12C
OFF_I2O_INB_FLIST_CNT				EQU	0x130
OFF_I2O_OUTB_PLIST_CNT				EQU	0x134
OFF_I2O_INB_PLIST_CNT				EQU	0x138
OFF_PCI_SACORE_CTL					EQU	0x13C
OFF_PCI_ADDR_EXT		   			EQU	0x140
OFF_PREFETCH_MEM_RANGE				EQU	0x144
OFF_DOOBELL_PCI_MASK				EQU	0x150
OFF_DOOBELL_SACORE_MASK				EQU	0x154
OFF_IRQ_STAT						EQU	0x180
OFF_IRQ_RAW_STAT					EQU	0x184
OFF_IRQ_EN							EQU	0x188
OFF_IRQ_EN_SET			   			EQU	0x188
OFF_IRQ_EN_CLR						EQU	0x18C
OFF_IRQ_SOFT						EQU	0x190
OFF_FIQ_STAT						EQU	0x280
OFF_FIQ_RAW_STAT					EQU	0x284
OFF_FIQ_EN							EQU	0x288
OFF_FIQ_EN_SET			   			EQU	0x288
OFF_FIQ_EN_CLR						EQU	0x28C
OFF_FIQ_SOFT						EQU	0x290
OFF_TIMER_1_LOAD					EQU	0x300
OFF_TIMER_1_VAL						EQU	0x304
OFF_TIMER_1_CTRL					EQU	0x308
OFF_TIMER_1_CLR						EQU	0x30C
OFF_TIMER_2_LOAD					EQU	0x320
OFF_TIMER_2_VAL						EQU	0x324
OFF_TIMER_2_CTRL					EQU	0x328
OFF_TIMER_2_CLR						EQU	0x32C
OFF_TIMER_3_LOAD					EQU	0x340
OFF_TIMER_3_VAL						EQU	0x344
OFF_TIMER_3_CTRL					EQU	0x348
OFF_TIMER_3_CLR						EQU	0x34C
OFF_TIMER_4_LOAD					EQU	0x360
OFF_TIMER_4_VAL						EQU	0x364
OFF_TIMER_4_CTRL					EQU	0x368
OFF_TIMER_4_CLR						EQU	0x36C


;StrongARM core PCI register absolute definitions...

VEN_ID						EQU	SACPCI_BASE_ADDR+OFF_VEN_ID						
DEV_ID						EQU	SACPCI_BASE_ADDR+OFF_DEV_ID						
PCICFG_CMD					EQU	SACPCI_BASE_ADDR+OFF_PCICFG_CMD					
PCICFG_STATUS				EQU	SACPCI_BASE_ADDR+OFF_PCICFG_STATUS				
REV_ID						EQU	SACPCI_BASE_ADDR+OFF_REV_ID						
CLASS_CODE					EQU	SACPCI_BASE_ADDR+OFF_CLASS_CODE					
CACHE_LNSIZE				EQU	SACPCI_BASE_ADDR+OFF_CACHE_LNSIZE				
LAT_TMR						EQU	SACPCI_BASE_ADDR+OFF_LAT_TMR						
HDR_TYPE					EQU	SACPCI_BASE_ADDR+OFF_HDR_TYPE					
BIST						EQU	SACPCI_BASE_ADDR+OFF_BIST							
PCI_CSR_MEM_BASE_ADDR		EQU	SACPCI_BASE_ADDR+OFF_PCI_CSR_MEM_BASE_ADDR	
PCI_CSR_IO_BASE_ADDR		EQU	SACPCI_BASE_ADDR+OFF_PCI_CSR_IO_BASE_ADDR	
PCI_SDRAM_BASE_ADDR			EQU	SACPCI_BASE_ADDR+OFF_PCI_SDRAM_BASE_ADDR		
PCI_SUBSYS_VEN_ID			EQU	SACPCI_BASE_ADDR+OFF_PCI_SUBSYS_VEN_ID		
SUBSYS_ID					EQU	SACPCI_BASE_ADDR+OFF_SUBSYS_ID					
CAP_PTR						EQU	SACPCI_BASE_ADDR+OFF_CAP_PTR						
INT_PIN						EQU	SACPCI_BASE_ADDR+OFF_INT_PIN						
MIN_GNT						EQU	SACPCI_BASE_ADDR+OFF_MIN_GNT						
MAX_LAT						EQU	SACPCI_BASE_ADDR+OFF_MAX_LAT						
I2O_INB_FIFO				EQU	SACPCI_BASE_ADDR+OFF_I2O_INB_FIFO				
I2O_OUTB_FIFO				EQU	SACPCI_BASE_ADDR+OFF_I2O_OUTB_FIFO				
MAILBOX0					EQU	SACPCI_BASE_ADDR+OFF_MAILBOX0					
MAILBOX1					EQU	SACPCI_BASE_ADDR+OFF_MAILBOX1					
MAILBOX2					EQU	SACPCI_BASE_ADDR+OFF_MAILBOX2					
MAILBOX3					EQU	SACPCI_BASE_ADDR+OFF_MAILBOX3					
DOORBELL 					EQU	SACPCI_BASE_ADDR+OFF_DOORBELL 					
DOORBELL_SETUP				EQU	SACPCI_BASE_ADDR+OFF_DOORBELL_SETUP			
CAP_PTR_EXT					EQU	SACPCI_BASE_ADDR+OFF_CAP_PTR_EXT				
PWR_MGT						EQU	SACPCI_BASE_ADDR+OFF_PWR_MGT						
PCI_RESET					EQU	SACPCI_BASE_ADDR+OFF_PCI_RESET					
DMA1_BYTECNT				EQU	SACPCI_BASE_ADDR+OFF_DMA1_BYTECNT				
DMA1_PCI_ADDR				EQU	SACPCI_BASE_ADDR+OFF_DMA1_PCI_ADDR				
DMA1_SDRAM_ADDR				EQU	SACPCI_BASE_ADDR+OFF_DMA1_SDRAM_ADDR			
DMA1_DESC_PTR				EQU	SACPCI_BASE_ADDR+OFF_DMA1_DESC_PTR				
DMA1_CTL					EQU	SACPCI_BASE_ADDR+OFF_DMA1_CTL					
DMA_INTER_MODE				EQU	SACPCI_BASE_ADDR+OFF_DMA_INTER_MODE			
DMA2_BYTECNT				EQU	SACPCI_BASE_ADDR+OFF_DMA2_BYTECNT				
DMA2_PCI_ADDR				EQU	SACPCI_BASE_ADDR+OFF_DMA2_PCI_ADDR				
DMA2_SDRAM_ADDR				EQU	SACPCI_BASE_ADDR+OFF_DMA2_SDRAM_ADDR			
DMA2_DESC_PTR				EQU	SACPCI_BASE_ADDR+OFF_DMA2_DESC_PTR				
DMA2_CTL					EQU	SACPCI_BASE_ADDR+OFF_DMA2_CTL					
PCI_CSR_BASE_ADDR_MSK		EQU	SACPCI_BASE_ADDR+OFF_PCI_CSR_BASE_ADDR_MSK	
PCI_SDRAM_BASE_ADDR_MSK		EQU	SACPCI_BASE_ADDR+OFF_PCI_SDRAM_BASE_ADDR_MSK
I2O_INB_FLST_HPTR			EQU	SACPCI_BASE_ADDR+OFF_I2O_INB_FLST_HPTR		
I2O_INB_PLIST_TPTR			EQU	SACPCI_BASE_ADDR+OFF_I2O_INB_PLIST_TPTR		
I2O_OUTB_PLIST_HPTR			EQU	SACPCI_BASE_ADDR+OFF_I2O_OUTB_PLIST_HPTR		
I2O_OUTB_FLIST_TPTR			EQU	SACPCI_BASE_ADDR+OFF_I2O_OUTB_FLIST_TPTR		
I2O_INB_FLIST_CNT			EQU	SACPCI_BASE_ADDR+OFF_I2O_INB_FLIST_CNT		
I2O_OUTB_PLIST_CNT			EQU	SACPCI_BASE_ADDR+OFF_I2O_OUTB_PLIST_CNT		
I2O_INB_PLIST_CNT			EQU	SACPCI_BASE_ADDR+OFF_I2O_INB_PLIST_CNT		
PCI_SACORE_CTL				EQU	SACPCI_BASE_ADDR+OFF_PCI_SACORE_CTL			
PCI_ADDR_EXT				EQU	SACPCI_BASE_ADDR+OFF_PCI_ADDR_EXT				
PREFETCH_MEM_RANGE			EQU	SACPCI_BASE_ADDR+OFF_PREFETCH_MEM_RANGE		
DOOBELL_PCI_MASK			EQU	SACPCI_BASE_ADDR+OFF_DOOBELL_PCI_MASK			
DOOBELL_SACORE_MASK			EQU	SACPCI_BASE_ADDR+OFF_DOOBELL_SACORE_MASK		
IRQ_STAT					EQU	SACPCI_BASE_ADDR+OFF_IRQ_STAT		
IRQ_RAW_STAT				EQU	SACPCI_BASE_ADDR+OFF_IRQ_RAW_STAT	
IRQ_EN						EQU	SACPCI_BASE_ADDR+OFF_IRQ_EN			
IRQ_EN_SET			   		EQU	SACPCI_BASE_ADDR+OFF_IRQ_EN_SET		
IRQ_EN_CLR					EQU	SACPCI_BASE_ADDR+OFF_IRQ_EN_CLR		
IRQ_SOFT					EQU	SACPCI_BASE_ADDR+OFF_IRQ_SOFT		
FIQ_STAT					EQU	SACPCI_BASE_ADDR+OFF_FIQ_STAT		
FIQ_RAW_STAT				EQU	SACPCI_BASE_ADDR+OFF_FIQ_RAW_STAT	
FIQ_EN						EQU	SACPCI_BASE_ADDR+OFF_FIQ_EN			
FIQ_EN_SET			   		EQU	SACPCI_BASE_ADDR+OFF_FIQ_EN_SET		
FIQ_EN_CLR					EQU	SACPCI_BASE_ADDR+OFF_FIQ_EN_CLR		
FIQ_SOFT					EQU	SACPCI_BASE_ADDR+OFF_FIQ_SOFT		
TIMER_1_LOAD				EQU	SACPCI_BASE_ADDR+OFF_TIMER_1_LOAD	
TIMER_1_VAL					EQU	SACPCI_BASE_ADDR+OFF_TIMER_1_VAL		
TIMER_1_CTRL				EQU	SACPCI_BASE_ADDR+OFF_TIMER_1_CTRL	
TIMER_1_CLR					EQU	SACPCI_BASE_ADDR+OFF_TIMER_1_CLR		
TIMER_2_LOAD				EQU	SACPCI_BASE_ADDR+OFF_TIMER_2_LOAD	
TIMER_2_VAL					EQU	SACPCI_BASE_ADDR+OFF_TIMER_2_VAL		
TIMER_2_CTRL				EQU	SACPCI_BASE_ADDR+OFF_TIMER_2_CTRL	
TIMER_2_CLR					EQU	SACPCI_BASE_ADDR+OFF_TIMER_2_CLR		
TIMER_3_LOAD				EQU	SACPCI_BASE_ADDR+OFF_TIMER_3_LOAD	
TIMER_3_VAL					EQU	SACPCI_BASE_ADDR+OFF_TIMER_3_VAL		
TIMER_3_CTRL				EQU	SACPCI_BASE_ADDR+OFF_TIMER_3_CTRL	
TIMER_3_CLR					EQU	SACPCI_BASE_ADDR+OFF_TIMER_3_CLR		
TIMER_4_LOAD				EQU	SACPCI_BASE_ADDR+OFF_TIMER_4_LOAD	
TIMER_4_VAL					EQU	SACPCI_BASE_ADDR+OFF_TIMER_4_VAL		
TIMER_4_CTRL				EQU	SACPCI_BASE_ADDR+OFF_TIMER_4_CTRL	
TIMER_4_CLR					EQU	SACPCI_BASE_ADDR+OFF_TIMER_4_CLR		



;VEN_ID register bit definitions...
;DEV_ID register bit definitions...
;PCICFG_CMD register bit definitions...
;PCICFG_STATUS register bit definitions...
;REV_ID register bit definitions...
;CLASS_CODE register bit definitions...
;CACHE_LNSIZE register bit definitions...
;LAT_TMR register bit definitions...
;HDR_TYPE register bit definitions...
;BIST register bit definitions...
;PCI_CSR_MEM_BASE_ADDR register bit definitions...
;PCI_CSR_IO_BASE_ADDR register bit definitions...
;PCI_SDRAM_BASE_ADDR register bit definitions...
;PCI_SUBSYS_VEN_ID register bit definitions...
;SUBSYS_ID register bit definitions...
;CAP_PTR register bit definitions...
;INT_PIN register bit definitions...
;MIN_GNT register bit definitions...
;MAX_LAT register bit definitions...
;I2O_INB_FIFO register bit definitions...
;I2O_OUTB_FIFO register bit definitions...
;MAILBOX0 register bit definitions...
;MAILBOX1 register bit definitions...
;MAILBOX2 register bit definitions...
;MAILBOX3 register bit definitions...
;DOORBELL register bit definitions...
;DOORBELL_SETUP register bit definitions...
;CAP_PTR_EXT register bit definitions...
;PWR_MGT register bit definitions...

;PCI_RESET register bit definitions...

SACORE_RST		EQU	0x80000000
PCI_RST			EQU	0x40000000
SRAM_RST		EQU	0x20000000
SDRAM_RST		EQU	0x00040000
FXCMD_RST		EQU	0x00020000
FBI_RST			EQU	0x00010000
EXT_RST			EQU	0x00008000
PCIBUS_RST		EQU	0x00004000
MENG5_RST		EQU	0x00000020
MENG4_RST		EQU	0x00000010
MENG3_RST		EQU	0x00000008
MENG2_RST		EQU	0x00000004
MENG1_RST		EQU	0x00000002
MENG0_RST		EQU	0x00000001


;DMA1_BYTECNT register bit definitions...
;DMA1_PCI_ADDR register bit definitions...
;DMA1_SDRAM_ADDR register bit definitions...
;DMA1_DESC_PTR register bit definitions...
;DMA1_CTL register bit definitions...
;DMA_INTER_MODE register bit definitions...
;DMA2_BYTECNT register bit definitions...
;DMA2_PCI_ADDR register bit definitions...
;DMA2_SDRAM_ADDR register bit definitions...
;DMA2_DESC_PTR register bit definitions...
;DMA2_CTL register bit definitions...
;PCI_CSR_BASE_ADDR_MSK register bit definitions...
;PCI_SDRAM_BASE_ADDR_MSK register bit definitions...
;I2O_INB_FLST_HPTR register bit definitions...
;I2O_INB_PLIST_TPTR register bit definitions...
;I2O_OUTB_PLIST_HPTR register bit definitions...
;I2O_OUTB_FLIST_TPTR register bit definitions...
;I2O_INB_FLIST_CNT register bit definitions...
;I2O_OUTB_PLIST_CNT register bit definitions...
;I2O_INB_PLIST_CNT register bit definitions...
;PCI_SACORE_CTL register bit definitions...
;PCI_ADDR_EXT register bit definitions...
;PREFETCH_MEM_RANGE register bit definitions...
;DOOBELL_PCI_MASK register bit definitions...
;DOOBELL_SACORE_MASK register bit definitions...

;IRQ_STAT register bit definitions...
;IRQ_RAW_STAT register bit definitions...
;IRQ_EN register bit definitions...
;IRQ_EN_SET register bit definitions...	
;IRQ_EN_CLR register bit definitions...	
;IRQ_SOFT register bit definitions...	
;FIQ_STAT register bit definitions...	
;FIQ_RAW_STAT register bit definitions...
;FIQ_EN register bit definitions...		
;FIQ_EN_SET register bit definitions...	
;FIQ_EN_CLR register bit definitions...	
;FIQ_SOFT register bit definitions...	
;The following bit definitions apply to all of the irq/fiq registers above

DPE				EQU	0x80000000
RTA				EQU	0x40000000
RMA				EQU	0x20000000
DPED			EQU	0x10000000
DTE				EQU	0x08000000
IIP				EQU	0x02000000
SDPAR			EQU	0x01000000
RSERR			EQU	0x00800000
SBIST			EQU	0x00400000
DMA2NB			EQU	0x00200000
DMA1NB			EQU	0x00100000
PIL				EQU	0x00040000
DMA2			EQU	0x00020000
DMA1			EQU	0x00010000
DFH				EQU	0x00008000
T4				EQU	0x00000080
T3				EQU	0x00000040
T2				EQU	0x00000020
T1				EQU	0x00000010
SI				EQU	0x00000002

;TIMER_N_LOAD register bit definitions...

TMR_LD_MASK		EQU	0x00FFFFFF

;TIMER_N_VAL register bit definitions...

;TIMER_N_CTRL register bit definitions...

TMR_EN			EQU	0x00000080
TMR_PERIODIC	EQU	0x00000040
TMR_FREERUN		EQU	0x00000000
TMR_CLK_MASK	EQU	0x0000000C
TMR_CLK_0		EQU	0x00000000
TMR_CLK_16		EQU	0x00000004
TMER_CLK_256	EQU	0x00000008

;TIMER_N_CLR register bit definitions...	


	END