;*************************************************************************
; *
; * H_SDRAM.S : Equate file for the IXP1200 SDRAM controller registers.
; * 		   
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_sdram.s $
; *
;*************************************************************************

;SDRAM controller register definitions...
                        
SDRM_BASE_ADDR		EQU	0xFF000000

OFF_SDRM_CSR		EQU 0x00
OFF_SDRM_MEMCTL0	EQU	0x04
OFF_SDRM_MEMCTL1	EQU	0x08
OFF_SDRM_MEMINIT	EQU	0x0C

SDRM_CSR			EQU SDRM_BASE_ADDR+OFF_SDRM_CSR		
SDRM_MEMCTL0		EQU	SDRM_BASE_ADDR+OFF_SDRM_MEMCTL0	
SDRM_MEMCTL1		EQU	SDRM_BASE_ADDR+OFF_SDRM_MEMCTL1	
SDRM_MEMINIT		EQU	SDRM_BASE_ADDR+OFF_SDRM_MEMINIT	


;SDRM_CSR Register bit definitions...

;interrupt and error status bits in upper word
;read status and write ones to location to clear.

PINTR				EQU	0x01000000	; Parity interrupt
ASBPERR				EQU	0x00040000	; ASB parity error
PCIPERR				EQU	0x00020000	; PCI parity error
TBXPERR				EQU	0x00010000	; Tbox parity error


;read write contol bits.

ENFIFOTST			EQU	0x00008000	; Enable fifo ram test
PINTREN				EQU	0x00000400	; Enable interrupt on parity
IRQINTREN			EQU	0x00000200	; Enable interrupt to IRQ
FIQINTREN			EQU	0x00000100	; Enable interrupt to FIQ
ASBPEN				EQU	0x00000040	; Enable ASB parity checking
PCIPEN				EQU	0x00000020	; Enable PCI parity checking
TBXPEN				EQU	0x00000010	; Enable TBOX parity checking
PGENEN				EQU	0x00000008	; Enable parity generation
PEVEN				EQU	0x00000004	; Generate even parity
BIGEND				EQU	0x00000002	; Enable big endian
SDRAMINIT			EQU	0x00000001	; Start SDRAM init


;SDRM_MEMCTL0 Register bit definitions...

RFRSHCNT_MASK		EQU	0x0FFF0000	;Refresh count
BURSTL_MASK			EQU	0x0000F000	;Burst length
CASL_MASK			EQU	0x00000F00	;CAS latenct
RADDRWIDTH_MASK		EQU	0x000000F0	;Row address width
CADDRWIDTH_MASK		EQU	0x0000000F	;Col address width


;SDRM_MEMCTL1 Register bit definitions...

TRWT_MASK			EQU	0xF0000000	;Read write turn around time
TDPL_MASK			EQU	0x0F000000	;Data in to precharge latency
TDQZ_MASK			EQU	0x00F00000	;DQM data out disable latency
TRC_MASK			EQU	0x000F0000	;Bank cycle time
TRRD_MASK			EQU	0x0000F000	;Bank to bank delay time (ras to ras delay)
TRCD_MASK			EQU	0x00000F00	;RAS to CAS delay
TRM_MASK			EQU	0x000000F0	;RAS minimum time (min cycles bank can be open)
TRP_MASK			EQU	0x0000000F	;Precharge time (to ras delay)


;SDRM_MEMINIT Register bit definitions...

TRSC_MASK			EQU	0x00F00000	;
INIT_REFRSH_MASK	EQU	0x000F0000	;Initialization refresh
INIT_DLY			EQU	0x0000FFFF	;Initialization delay


	END








			
