;*************************************************************************
; *
; * H_SRAM.S : Equate file for the IXP1200 SRAM controller registers.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: h_sram.s $
; *
;*************************************************************************
                        
;SRAM controller register base and offset definitions...

SRAM_BASE_ADDR				EQU	0x38000000

OFF_SRAM_CSR				EQU	0x00
OFF_SRAM_AUTO_BASE			EQU	0x04
OFF_SRAM_AUTO_PTR			EQU	0x08
OFF_SRAM_AUTO_END			EQU	0x0C
OFF_SRAM_TEST_MOD			EQU	0x10
OFF_SRAM_SLOW_CFG			EQU	0x20
OFF_SRAM_FLASH_CFG			EQU	0x24
OFF_SRAM_MAC_CFG			EQU	0x28
OFF_SRAM_CMD_FIFO_ADDR		EQU	0x80


;SRAM controller register absolute definitions...

SRAM_CSR					EQU	SRAM_BASE_ADDR+OFF_SRAM_CSR				
SRAM_AUTO_BASE				EQU	SRAM_BASE_ADDR+OFF_SRAM_AUTO_BASE		
SRAM_AUTO_PTR				EQU	SRAM_BASE_ADDR+OFF_SRAM_AUTO_PTR			
SRAM_AUTO_END				EQU	SRAM_BASE_ADDR+OFF_SRAM_AUTO_END			
SRAM_TEST_MOD				EQU	SRAM_BASE_ADDR+OFF_SRAM_TEST_MOD			
SRAM_SLOW_CFG				EQU	SRAM_BASE_ADDR+OFF_SRAM_SLOW_CFG			
SRAM_FLASH_CFG				EQU	SRAM_BASE_ADDR+OFF_SRAM_FLASH_CFG		
SRAM_MAC_CFG				EQU	SRAM_BASE_ADDR+OFF_SRAM_MAC_CFG			
SRAM_CMD_FIFO_ADDR			EQU	SRAM_BASE_ADDR+OFF_SRAM_CMD_FIFO_ADDR


;SRAM_CSR Register bit definitions...

CFT				EQU	0x00040000	;Command fifo test enable
FLWT			EQU	0x00010000	;Flowthrough SRAM enable
BKW				EQU	0x00008000	;Bank switch wait enable
MF_MASK			EQU	0x00007000	;flash mem config mask
_8MF			EQU	0x00004000	;8MB flash mem cfg
_4MF			EQU	0x00002000	;4MB flash mem cfg
_2MF			EQU	0x00001000	;2MB flash mem cfg
MSR_MASK		EQU	0x00000F00	;SRAM mem config mask
_8MSR			EQU	0x00000800	;8MB sram mem cfg
_4MSR			EQU	0x00000400	;4MB sram mem cfg
_2MSR			EQU	0x00000200	;2MB sram mem cfg
_1MSR			EQU	0x00000100	;1MB sram mem cfg
RLAM			EQU	0x00000010	;ASB readlock achieved mask
IRQ				EQU	0x00000008	;IRQ enable
FIQ				EQU	0x00000004	;FIQ enable
RLRS			EQU	0x00000002	;ASB readlock retry achieved status
RLS				EQU	0x00000001	;ASB readlock achieved status


;SRAM_AUTO_BASE Register bit definitions...

;SRAM_AUTO_PTR Register bit definitions...

;SRAM_AUTO_END Register bit definitions...

;SRAM_TEST_MOD Register bit definitions...

;SRAM_SLOW_CFG Register bit definitions...

FCT_MASK		EQU	0x0000FF00	;Flash cycle time
MCT_MASK		EQU	0x000000FF	;Asynch IO (MAC) cycle time


;SRAM_FLASH_CFG Register bit definitions...
				
BRWA_MASK		EQU	0xFF000000	;Flash read/write assert
BRWD_MASK		EQU	0x00FF0000	;Flash read/write deassert
BCEA_MASK		EQU	0x0000FF00	;Flash enable assert
BCED_MASK		EQU	0x000000FF	;Flash enable deassert


;SRAM_MAC_CFG Register bit definitions...

SRWA_MASK		EQU	0xFF000000	;Asynch IO (MAC) read/write assert
SRWD_MASK		EQU	0x00FF0000	;Asynch IO (MAC) read/write deassert
SEA_MASK		EQU	0x0000FF00	;Asynch IO (MAC) enable assert
SED_MASK		EQU	0x000000FF	;Asynch IO (MAC) enable deassert


;SRAM_CMD_FIFO_ADDR Register bit definitions...


	END
