;*************************************************************************
; *
; * IRQFIQ.S : Source file for FIQ and IRQ interrupt handlers
; * 		   
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: irqfiq.s $
; *
;*************************************************************************

;Header file includes...
	INCLUDE	H_SASYS.S
	INCLUDE	H_PCI.S

;External used procedures...
	EXPORT	FIQHandler
	EXPORT	IRQHandler


	AREA	Interrupt, CODE, READONLY

IRQHandler
	ldr	r2, =INTR_IRQ			;retrieve irq info
	b	CommonHandler

FIQHandler
	ldr	r2, =INTR_FIQ			;retrieve fiq info 

CommonHandler
	ldr	r1, [r2]				;retrieve INT info 
	ands	r1, r1, #PCIIRQ		;isolate PCI INT
	beq	SpuriousINT				;if not PCI INT then spurious

	ldr	r1, [r5]				;else load the PCI INT status
	ands	r1, r1, r6			;r6 contains the timer being tested
	beq	SpuriousINT				;if not expected timer then spurious

	ldr	r1,	=INTR_IRQ
	cmp	r1, r2					;is this an IRQ service?
	bne	IsFIQ 					;if not must be FIQ,
	add	r7, r7, #1				;else, inc r7 to indicate irq was serviced
	b	ContinueCommon

IsFIQ
	sub	r7, r7, #1				;dec r7 to indicate fiq was serviced

ContinueCommon
	str	r6, [r4, #4] 			;clear the timer's INT (data is "don't care")
	b	IRQHandlerExit			;time to leave
	
SpuriousINT

;If spurious INT is handled put code here

IRQHandlerExit
	subs	pc, r14, #4			;return to interrupted code

	END


