;*************************************************************************
; *
; * MMUINIT.S : Source file for OEM system initialization routines.
; * 		   
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: mmuinit.s $
; *
;*************************************************************************


	AREA	MMUINIT, CODE

	INCLUDE	H_ARM.S
	INCLUDE	MMUMACRO.S
	INCLUDE	H_CONFIG.S
	
	IMPORT	PutHexc1


	IF	:DEF:	CPUCACHE_EN

	EXPORT	CacheOn
	EXPORT	CacheOff

DmnCtrl	EQU	0x3


CacheOn
	mov	r12,lr
	readControl	r0
	ands	r0, r0, #MMUEn
	bne	ExitCacheOn							;if the cache is already on exit

	SETUPMMU	r1, r2, r3, r4, r5, r6		;this will set up the xlate table
	ldr	r0, =TTB_BASE
	writeTBase	r0							;set ttb base addr
	ldr	r0, =DmnCtrl
	writeDomainControl r0					;set domain attribs
	flushIDTlb								;
	flushDcache
	flushIcache
	ldr	r1, =IDCachen:OR:ICachen:OR:MMUEn

LoopCacheOn
	readControl	r0
	orr	r0, r0, r1
	writeControl r0							;enable the MMU and caches
;	readControl	r0
;	ands	r0, r0, r1
;	cmp	r0, r1 
;	bne	LoopCacheOn

ExitCacheOn
	mov	pc, r12								;return to caller


CacheOff
	mov	r12,lr
	readControl	r0
	ands	r0, r0, #MMUEn
	beq	ExitCacheOff						;if the cache is already off exit

	flushIDTlb								;else flush all
	flushDcache
	flushIcache
	ldr	r1, =IDCachen:OR:ICachen:OR:MMUEn

LoopCacheOff
	readControl	r0
	bic	r0, r0, r1
	writeControl r0							;and disable the MMU
;	readControl	r0
;	ands	r0, r0, r1
;	bne	LoopCacheOn

ExitCacheOff
	mov	pc, r12								;return to caller

	ENDIF	;CPUCACHE_EN

	END
