;*************************************************************************
; *
; * OEMTABLE.S : Source file for the IXP1200 OEM platfom data.
; * 		   
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: OEMTABLE.S $
; 
; *****************  Version 23  *****************
; User: Tepulkow     Date: 8/28/00    Time: 5:28p
; Updated in $/dev_1200/BoardSupport/Diagnostics
; Added relocation of the exception vector table to SRAM.
; *
;*************************************************************************

;IXP1200 register initialization...

	AREA	IXP1200INIT,	DATA, READONLY

	INCLUDE	H_SDRAM.S
	INCLUDE	H_FBI.S
	INCLUDE	H_SASYS.S
	INCLUDE	H_MENG.S
	INCLUDE	H_PCI.S
	INCLUDE	H_SRAM.S
	INCLUDE	H_ARM.S
	INCLUDE	MMUMACRO.S
	INCLUDE	H_CONFIG.S
	INCLUDE	H_21440.S
	INCLUDE	H_82547.S

	EXPORT	EarlyInitTblA
	EXPORT	EarlyInitTblB
	EXPORT	RevASpeedTbl
	EXPORT	RevBSpeedTbl


	IF	:DEF:	FINALCSR_INIT
	EXPORT	FinalInitTbl
	ENDIF	;FINALCSR_INIT


RevASpeedTbl
	IF	:DEF:	A_CORE192
	DCD	PLL_CTL,	Core192Mhz
	ENDIF	;A_CORE192
	IF	:DEF:	A_CORE177
	DCD	PLL_CTL,	Core177Mhz
	ENDIF	;A_CORE177
	IF	:DEF:	A_CORE162
	DCD	PLL_CTL,	Core162Mhz
	ENDIF	;A_CORE162
; End of table indicator...
	DCD	0xFFFFFFFF


RevBSpeedTbl
	IF	:DEF:	B_CORE199
	DCD	PLL_CTL,	BCore199Mhz
	ENDIF	;B_CORE199
	IF	:DEF:	B_CORE192
	DCD	PLL_CTL,	BCore192Mhz
	ENDIF	;B_CORE192
	IF	:DEF:	B_CORE177
	DCD	PLL_CTL,	BCore177Mhz
	ENDIF	;B_CORE177
	IF	:DEF:	B_CORE162
	DCD	PLL_CTL,	BCore162Mhz
	ENDIF	;B_CORE162
; End of table indicator...
	DCD	0xFFFFFFFF



EarlyInitTblA

	IF	:DEF:	A_CORE192

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x4C520F07		;
	DCD	SRAM_SLOW_CFG,		0x00001859

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x05D982C8
	DCD	SDRM_MEMCTL1,		0x12361141
	DCD	SDRM_MEMINIT,		0x00122574
	DCD	SDRM_CSR	,		SDRAMINIT

	ENDIF	;A_CORE192

	IF	:DEF:	A_CORE177

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x4C520F07		;
	DCD	SRAM_SLOW_CFG,		0x00001859

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x056682C8
	DCD	SDRM_MEMCTL1,		0x12361141
	DCD	SDRM_MEMINIT,		0x00122292
	DCD	SDRM_CSR	,		SDRAMINIT
		
	ENDIF	;A_CORE177

	IF	:DEF:	A_CORE162

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x3e440c06		;
	DCD	SRAM_SLOW_CFG,		0x0000184A

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x04F382C8
	DCD	SDRM_MEMCTL1,		0x12351141
	DCD	SDRM_MEMINIT,		0x00121FAF
	DCD	SDRM_CSR	,		SDRAMINIT

;	DCD	RDYBUS_SYNC_CNT_DFLT,	0x80
		
	ENDIF	;A_CORE162

;EAP (ebable autopush) eroneous after reset on Ax and BX silicon...
	DCD	XMIT_RDY_CTL,		0x0				;This csr unpredictable after reset
											; so set to published default value.
	DCD	RCV_RDY_CTL,		0x0				;This csr unpredictable after reset
											; so set to published default value.
	DCD	RCV_RDY_CNT,		0x0				;This csr unpredictable after reset
											; so set to published default value.
; End of table indicator...
	DCD	0xFFFFFFFF



EarlyInitTblB

	IF	:DEF:	B_CORE199

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x4C520F07		;
	DCD	SRAM_SLOW_CFG,		0x00001859

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x061282C8
	DCD	SDRM_MEMCTL1,		0x12361141
	DCD	SDRM_MEMINIT,		0x001226DF
	DCD	SDRM_CSR	,		SDRAMINIT

	ENDIF	;B_CORE199

	IF	:DEF:	B_CORE192

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x4C520F07		;
	DCD	SRAM_SLOW_CFG,		0x00001859

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x05D982C8
	DCD	SDRM_MEMCTL1,		0x12361141
	DCD	SDRM_MEMINIT,		0x00122574
	DCD	SDRM_CSR	,		SDRAMINIT

	ENDIF	;B_CORE192

	IF	:DEF:	B_CORE177

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x4C520F07		;
	DCD	SRAM_SLOW_CFG,		0x00001859

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x056682C8
	DCD	SDRM_MEMCTL1,		0x12361141
	DCD	SDRM_MEMINIT,		0x00122292
	DCD	SDRM_CSR	,		SDRAMINIT
		
	ENDIF	;B_CORE177

	IF	:DEF:	B_CORE162

; Do the SRAM registers...
	DCD	SRAM_CSR,			BKW:OR:_8MF:OR:_2MSR:OR:RLAM
	DCD	SRAM_FLASH_CFG,		0x18180400		;chip anomaly inner bytes swapped
	DCD	SRAM_MAC_CFG,		0x3e440c06		;
	DCD	SRAM_SLOW_CFG,		0x0000184A

; Do the SDRAM registers...
	DCD	SDRM_MEMCTL0,		0x04F382C8
	DCD	SDRM_MEMCTL1,		0x12351141
	DCD	SDRM_MEMINIT,		0x00121FAF
	DCD	SDRM_CSR	,		SDRAMINIT
		
	ENDIF	;B_CORE162

;EAP (ebable autopush) eroneous after reset on Ax and BX silicon...
	DCD	XMIT_RDY_CTL,		0x0				;This csr unpredictable after reset
											; so set to published default value.
	DCD	RCV_RDY_CTL,		0x0				;This csr unpredictable after reset
											; so set to published default value.
	DCD	RCV_RDY_CNT,		0x0				;This csr unpredictable after reset
											; so set to published default value.
; End of table indicator...
	DCD	0xFFFFFFFF



	IF	:DEF:	FINALCSR_INIT
FinalInitTbl

; End of table indicator...
	DCD	0xFFFFFFFF
	ENDIF	;FINALCSR_INIT


	IF	:DEF:	PCITIMER_TEST
Load_Val	EQU	0x09E4F580	;use this for physical board tes

	EXPORT	TimerCSRTbl

TimerCSRTbl
; PCI Timer test register init...

	DCD	TIMER_1_LOAD,		Load_Val
	DCD	TIMER_1_CTRL,		TMR_PERIODIC:OR:TMR_CLK_0
	DCD	TIMER_1_CLR	,		0x0

	DCD	TIMER_2_LOAD,		Load_Val
	DCD	TIMER_2_CTRL,		TMR_PERIODIC:OR:TMR_CLK_0
	DCD	TIMER_2_CLR	,		0x0

	DCD	TIMER_3_LOAD,		Load_Val
	DCD	TIMER_3_CTRL,		TMR_PERIODIC:OR:TMR_CLK_0
	DCD	TIMER_3_CLR	,		0x0

	DCD	TIMER_4_LOAD,		Load_Val
	DCD	TIMER_4_CTRL,		TMR_PERIODIC:OR:TMR_CLK_0
	DCD	TIMER_4_CLR	,		0x0

; End of table indicator...
	DCD	0xFFFFFFFF

	ENDIF	;PCITIMER_TEST

	IF	:DEF:	MEM_TEST

	EXPORT	SRAMEVTestTbl
SRAMEVTestTbl
; Syntax : DCD	MemBaseAddr,	MemApertureSize,	ASCIIStringDescriptor

	IF	:DEF:	TEST_SRAM
	IMPORT	MemSRAMEV
	DCD	JumpTblBase,	JumpTblSize,	MemSRAMEV
	ENDIF		;TEST_SRAM

; End of table indicator...
	DCD	0xFFFFFFFF


	EXPORT	MemTestTbl
MemTestTbl
; System memory apertures to test...
; Syntax : DCD	MemBaseAddr,	MemApertureSize,	ASCIIStringDescriptor

	IF	:DEF:	TEST_DRAM
	IMPORT	MemSDRAM
	DCD	DRAMBase,	DRAMSize,	MemSDRAM
	ENDIF		;TESTDRAM

	IF	:DEF:	TEST_SRAM
	IMPORT	MemSRAM
	DCD	SRAMRWBase,	(SRAMRWSize-JumpTblSize),	MemSRAM	
	ENDIF		;TEST_SRAM

	IF	:DEF:	TEST_SCRATCH
	IMPORT	MemScratch
	DCD	ScratchBase,	ScratchSize,	MemScratch
	ENDIF		;TEST_SCRATCH

; End of table indicator...
	DCD	0xFFFFFFFF
	ENDIF	;MEM_TEST


	IF	:DEF:	MAC_WRTEST
;*************************************************************************
;
; MACPortTbl : Table of MAC device information used in the MAC port 
;				uniqueness test.  The uniqueness test determines that the
;				mac ports specified in this table are uniquely addressable
;				validating address lines, data lines, and io decoding.
;				The table format is as follows:
;
;		MAC0ADDRESS, MAC0PORTCOUNT, MAC0PORTSIZE
;		MAC1ADDRESS, MAC1PORTCOUNT, MAC1PORTSIZE
;		MAC2ADDRESS, MAC2PORTCOUNT, MAC1PORTSIZE
;			.				.			.
;			.				.			.
;			.				.			.
;		MAC(N-1)ADDRESS, MAC(N-1)PORTCOUNT, MAC(N-1)PORTSIZE
;		MACNADDRESS, MACNPORTCOUNT, MACNPORTSIZE
;		0xFFFFFFFF	;end of table indicator
;
;		Where:
;			MACNADDRESS = 	IO address of the register in the first port
;							 to be used in the test.
;			MACNPORTCOUNT = Number of ports in this MAC device.
;			MACNPORTSIZE = 	Size of the IO address occupied by eac port
;							in this MAC device.
;
;*************************************************************************
	EXPORT	MACPortTbl	
MACPortTbl

	DCD		MAC0BASE+Pkt_Max_SizeL, 	0x8, 0x1000

	DCD		GMACBASE+GMPkt_Max_Size,	0x2, 0x1000

	DCD		0xFFFFFFFF

	ENDIF ;MAC_WRTEST
			 
	END
