;*************************************************************************
; *
; * FBOX_PROTO.UC : Micro code source file for micro engine (fbox)  
; * 				functional test.
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; *
;*************************************************************************
	; FBOX PROTOTYPE TEST
	;
	;
	;
	.xfer_order $_0 $_1 $_2 $_3 $_4 $_5 $_6 $_7
	.xfer_order $$_0 $$_1 $$_2 $$_3 $$_4 $$_5 $$_6 $$_7
	; INITIALIZATION CONDITIONS FOR THIS TEST:
	;
	; thread PCs must be initialized to 0
	; all contexts enabled
	; sdram and sram controllers must be programmed to some arbitrary configuration
	;
	;

#define	  word_cnt_1	0x1
#define	  word_cnt_2	0x2
#define	  word_cnt_3	0x3
#define	  word_cnt_4	0x4
#define	  word_cnt_8	0x8

		br=ctx[ 1, ctx_1_startup#]
		br=ctx[ 2, ctx_2_startup#]
		br=ctx[ 3, ctx_3_startup#]
		immed[ sram_base, 0x100]
	        br[test#]
	ctx_1_startup#:
		immed[ sram_base, 0x200]
	        br[test#]
	ctx_2_startup#:
		immed[ sram_base, 0x300]
	        br[test#]
	ctx_3_startup#:
		immed[ sram_base, 0x400]
	        br[test#]
	test#:
	; signal start of test for this context
	        immed[$_0, 1]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	; ************************** REGISTER TEST *****************************
		immed_w0[ r0, 0xaaaa ]		; r0 = xxxxAAAA
		immed_w1[ r0, 0x5555 ]		; r0 = 5555AAAA
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		; touch all other GPRs
		alu[ r1, --, b, r0 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		; touch all other GPRs
		alu[ r2, --, b, r1 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r3, --, ~b, r2 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r4, --, b, r3 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r5, --, ~b, r4 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r6, --, b, r5 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r7, --, ~b, r6 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r8, --, b, r7 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r9, --, ~b, r8 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r10, --, ~b, r9 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r11, --, b, r10 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r12, --, ~b, r11 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r13, --, ~b, r12 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r14, --, b, r13 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r15, --, ~b, r14 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r16, --, ~b, r15 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r17, --, b, r16 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r18, --, ~b, r17 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r19, --, ~b, r18 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r20, --, b, r19 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r21, --, ~b, r20 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r22, --, ~b, r21 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r23, --, b, r22 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r24, --, ~b, r23 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r25, --, ~b, r24 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r26, --, b, r25 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r27, --, ~b, r26 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r28, --, ~b, r27 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r29, --, b, r28 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		nop;
		nop;
		alu[ r30, --, ~b, r29 ]
		; insert 2 nops to avoid using datapath bypasses when fetching source operand below
		alu[ --, r0, xor, r30]
	        br!=0[error#]
	; signal completion of register test
	reg_test_done#:
	        immed[$_0, 2]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
		; SRAM test
		alu[ $_0, --, b, r0 ]
		alu[ $_1, --, b, r1 ]
		alu[ $_2, --, b, r2 ]
		alu[ $_3, --, b, r3 ]
		alu_shf[ $_4, r4, -, 0,  0 ]
		alu_shf[ $_5, 0, +, r5,  0 ]
		alu_shf[ $_6, r6, +, 0,  0 ]
		alu_shf[ $_7, r7, -, 0,  0 ]
		sram[ write, $_0, 1, sram_base, word_cnt_1 ]
		sram[ write, $_1, 2, sram_base, word_cnt_3 ]
		sram[ write, $_4, 5, sram_base, word_cnt_4 ], ctx_swap
	; signal completion of sram_write
	        immed[$_0, 3]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;sram read
		sram[ read, $_0, 1, sram_base, word_cnt_1 ]
		sram[ read, $_1, 2, sram_base, word_cnt_3 ]
		sram[ read, $_4, 5, sram_base, word_cnt_4 ], ctx_swap
	; signal completion of sram_read
	        immed[$_0, 4]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;sram compare
		alu[ --, $_0, xor, r0 ]
		br!=0[error#]
		alu[ --, $_1, xor, r1 ]
		br!=0[error#]
		alu[ --, $_2, xor, r2 ]
		br!=0[error#]
		alu[ --, $_3, xor, r3 ]
		br!=0[error#]
		alu[ --, $_4, xor, r4 ]
		br!=0[error#]
		alu[ --, $_5, xor, r5 ]
		br!=0[error#]
		alu[ --, $_6, xor, r6 ]
		br!=0[error#]
		alu[ --, $_7, xor, r7 ]
		br!=0[error#]
	; signal completion of sram_compare
	sram_test_done#:
	        immed[$_0, 5]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
		; SDRAM test
		alu[ $$_0, --, b, r0 ]
		alu[ $$_1, --, b, r1 ]
		alu[ $$_2, --, b, r2 ]
		alu[ $$_3, --, b, r3 ]
		alu_shf[ $$_4, r4, -, 0,  0 ]
		alu_shf[ $$_5, 0, +, r5,  0 ]
		alu_shf[ $$_6, r6, +, 0,  0 ]
		alu_shf[ $$_7, r7, -, 0,  0 ]
		sdram[ write, $$_0, 1, sram_base, word_cnt_1 ]
		sdram[ write, $$_2, 2, sram_base, word_cnt_2 ]
		sdram[ write, $$_6, 4, sram_base, word_cnt_1 ], ctx_swap
	; signal completion of sdram_write
	        immed[$_0, 6]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;sdram read
		sdram[ read, $$_0, 1, sram_base, word_cnt_1 ]
		sdram[ read, $$_2, 2, sram_base, word_cnt_2 ]
		sdram[ read, $$_6, 4, sram_base, word_cnt_1 ], ctx_swap
	; signal completion of sdam_read
	        immed[$_0, 7]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;sdram compare
		alu[ --, $$_0, xor, r0 ]
		br!=0[error#]
		alu[ --, $$_1, xor, r1 ]
		br!=0[error#]
		alu[ --, $$_2, xor, r2 ]
		br!=0[error#]
		alu[ --, $$_3, xor, r3 ]
		br!=0[error#]
		alu[ --, $$_4, xor, r4 ]
		br!=0[error#]
		alu[ --, $$_5, xor, r5 ]
		br!=0[error#]
		alu[ --, $$_6, xor, r6 ]
		br!=0[error#]
		alu[ --, $$_7, xor, r7 ]
		br!=0[error#]
	; signal completion of sdram_compare
	sdram_test_done#:
	        immed[$_0, 8]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
		; scratchtest
		alu[ $_0, --, b, r0 ]					; restore xfer0.  The others are still OK.
		scratch[ write, $_0, 1, sram_base, word_cnt_1 ]
		scratch[ write, $_1, 2, sram_base, word_cnt_3 ]
		scratch[ write, $_4, 5, sram_base, word_cnt_4 ], ctx_swap
	; signal completion of scratch_write
	        immed[$_0, 9]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;scratch read
		scratch[ read, $_0, 1, sram_base, word_cnt_1 ]
		scratch[ read, $_1, 2, sram_base, word_cnt_3 ]
		scratch[ read, $_4, 5, sram_base, word_cnt_4 ], ctx_swap
	; signal completion of scratch_read
	        immed[$_0, 10]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;scratch compare
		alu[ --, $_0, xor, r0 ]
		br!=0[error#]
		alu[ --, $_1, xor, r1 ]
		br!=0[error#]
		alu[ --, $_2, xor, r2 ]
		br!=0[error#]
		alu[ --, $_3, xor, r3 ]
		br!=0[error#]
		alu[ --, $_4, xor, r4 ]
		br!=0[error#]
		alu[ --, $_5, xor, r5 ]
		br!=0[error#]
		alu[ --, $_6, xor, r6 ]
		br!=0[error#]
		alu[ --, $_7, xor, r7 ]
		br!=0[error#]
	; signal completion of scratch_compare
	scratch_test_done#:
	        immed[$_0, 11]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	; start hash test
	        immed[$_0, 1]
	        immed[$_1, 0]
		csr[ write, $_0, hash_multiplier_64_lo ]
		csr[ write, $_1, hash_multiplier_64_hi ], ctx_swap
	; signal completion of csr write
	        immed[$_0, 12]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	; csr read and compare
		csr[ read, $_0, hash_multiplier_64_lo ]
		csr[ read, $_1, hash_multiplier_64_hi ], ctx_swap
		alu_shf[--, $_0, xor, 1, 0]
	        br!=0[error#]
		alu_shf[--, $_1, xor, 0, 0]
	        br!=0[error#]
	; signal completion of csr read
	        immed[$_0, 13]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
		hash3_64[ $_2 ], ctx_swap
	; signal completion of hash
	        immed[$_0, 14]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	; hash compare
		alu[ --, $_2, xor, r2 ]
		br!=0[error#]
		alu[ --, $_3, xor, r3 ]
		br!=0[error#]
		alu[ --, $_4, xor, r4 ]
		br!=0[error#]
		alu[ --, $_5, xor, r5 ]
		br!=0[error#]
		alu[ --, $_6, xor, r6 ]
		br!=0[error#]
		alu[ --, $_7, xor, r7 ]
		br!=0[error#]
	; signal completion of hash compare
	        immed[$_0, 15]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	;;;;; skip of ithread for now
		br[done#]
	; test interthread signal
		br=ctx[ 1, ctx_1_ithread#]
		br=ctx[ 2, ctx_2_ithread#]
		br=ctx[ 3, ctx_3_ithread#]
	ctx_0_ithread#:
		fast_wr[1, inter_thd_sig]
		ctx_arb[inter_thread]
	; signal completion of inter thread
	        immed[$_0, 16]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	        br[continue#]
	ctx_1_ithread#:
		ctx_arb[inter_thread]
		fast_wr[2, inter_thd_sig]
	; signal completion of inter thread
	        immed[$_0, 16]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	        br[continue#]
	ctx_2_ithread#:
		ctx_arb[inter_thread]
		fast_wr[3, inter_thd_sig]
	; signal completion of inter thread
	        immed[$_0, 16]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	        br[continue#]
	ctx_3_ithread#:
		ctx_arb[inter_thread]
		fast_wr[0, inter_thd_sig]
	; signal completion of inter thread
	        immed[$_0, 16]
		sram[ write, $_0, 0, sram_base, word_cnt_1 ], ctx_swap
	        br[continue#]
	continue#:
		br[ done# ]	; failing to branch dumps us into error code
	error#:
		; if we're here, an error occurred.  print out error signature
		; Note r0 is expected to contain the error status code
		; output to sram error status code bracketed by "BADDBADD" words
		immed[ r1, 0xbadd ]
		immed_w1[ r1, 0xbadd ]
		alu[ $_0, --, b, r1 ]
		alu[ $_1, --, b, r1 ]
		alu[ $_2, --, b, r0 ]
		alu[ $_3, --, b, r0 ]
		alu[ $_4, --, b, r0 ]
		alu[ $_5, --, b, r1 ]
		alu[ $_6, --, b, r1 ]
		alu[ $_7, --, b, r1 ]
		sram[ write, $_0, 0, sram_base, word_cnt_8 ]
		br[ error# ]	; branch back to repeat error pattern
	done#:
		nop
		nop
		nop
	        ctx_arb[voluntary]
		nop
		nop
		br[done#]
