;*************************************************************************
; *
; * ixbus.s : Source file for IX bus tests and routines.
; * 
; * 
; *
; * ---------------------------------------------------------------------	
; *                                                                      
; *                  I N T E L   P R O P R I E T A R Y                   
; *                                                                      
; *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
; *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
; *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
; *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
; *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
; *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
; *     THE PRIOR WRITTEN PERMISSION OF :                                
; *                                                                      
; *                        INTEL  CORPORATION                            
; *                                                                     
; *                     2200 MISSION COLLEGE BLVD                        
; *                                                                      
; *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
; *                                                                      
; * ---------------------------------------------------------------------
; *
; * system: IXP1200
; * subsystem: Diagnostics
; * author: tep
; * revisions:
; * $History: ixbus.s $
; *
;*************************************************************************

;Header file includes...
	INCLUDE	H_SASYS.S
	INCLUDE	H_MENG.S
	INCLUDE	DIAG.S
	INCLUDE	H_CONFIG.S
	INCLUDE	H_PCI.S
	INCLUDE	MMUMACRO.S
	INCLUDE	COMMACRO.S
	INCLUDE	H_21440.S
	INCLUDE	H_82547.S
	INCLUDE	H_FBI.S

;External messages...
	IMPORT	ixbtest1	
	IMPORT	ixbthelp1
	IMPORT	ixbthelp2
	IMPORT	ixbthelp3
	IMPORT	ixbthelp3a
	IMPORT	ixbthelp4
	IMPORT	ixbthelp5
	IMPORT	ixbthelp5a
	IMPORT	ixbthelp6
	IMPORT	ixbthelp7
	IMPORT	ixbthelp8
	IMPORT	ixbthelp9
	IMPORT	ixbthelp10
	IMPORT	ixbthelp11
	IMPORT	ixbthelp13
	IMPORT	ixbthelp14
	IMPORT	ixbthelp12
	IMPORT	ixbtstat1
	IMPORT	ixbtstat1a
	IMPORT	ixbtrestrt
	IMPORT	ixbtpaused
	IMPORT	ixbtclear
	IMPORT	ixbtclearall
	IMPORT	ixbtquit
	IMPORT	ixbtlib
	IMPORT	ixbtint
	IMPORT	ixbtext
	IMPORT	CRLF
	IMPORT	ixbtstat10
	IMPORT	ixbtstat10a
	IMPORT	ixbtstat11
	IMPORT	ixbtstat12
	IMPORT	ixbtstat13
	IMPORT	ixbtstat14
	IMPORT	ixbtstgs	
	IMPORT	ixbtlbm		
	IMPORT	ixbtints	
	IMPORT	ixbtexts	
	IMPORT	ixbtmm		
	IMPORT	ixbtgig		
	IMPORT	ixbtoct		
	IMPORT	ixbtcur 	
	IMPORT	ixbtpause
	IMPORT	ixbtrun
	IMPORT	ixbtfptx 	
	IMPORT	ixbtfprx 	
	IMPORT	ixbtnorun 	
	IMPORT	ixbtbursting 	

;External procedures...
	IMPORT	InitDwordCSRs
	IMPORT	uStoreLoad
	IMPORT	UARTSendString
	IMPORT	GetBytec1

;Procedures used externally found in this module...
	IF	:DEF:	IXBUS_TEST
	EXPORT	ixbus_test
	ENDIF		;IXBUS_TEST

;Equates for this file and test..
IxbTestStackBase	EQU	DRAMBase+DRAMSize-SZ_16K


PORTCOUNT	EQU	8
FPORTCOUNT	EQU	2
PORTADRSZ	EQU	0x1000
FPORTADRSZ	EQU	0x1000
PORTADRLIM	EQU	MAC0BASE + (PORTCOUNT * PORTADRSZ)
FPORTADRLIM	EQU	GMACBASE + (FPORTCOUNT * FPORTADRSZ)

TestPktOff	EQU	0x800		;offset into sdram where pkt lib starts (bytes)
TestPktSz	EQU	64			;length of test pkt (bytes)
TestPktSzQw	EQU	(TestPktSz/8) ;length of test pkt (qwords)

TestPktQty	EQU	25			;number of unique pkts in pkt lib
TestPktBase	EQU	(DRAMBase + TestPktOff)
PktLibSz	EQU	(TestPktSz * TestPktQty)
TestPktEnd	EQU	(TestPktBase + PktLibSz)
TestDataInc	EQU	1
TestDataDec	EQU	0x10000
TestDatSeed	EQU	0xFFFF0000

OStatTxOff		EQU	0x00
OStatTxBase		EQU	ScratchBase + OStatTxOff 
OStatTxLimit	EQU	(OStatTxBase + (1 * 4))
OStatRxOff		EQU	OStatTxOff + 0x40
OStatRxBase		EQU	(ScratchBase + OStatRxOff)
OStatRxLimit	EQU	(OStatRxBase + (16 * 4))
OStatErOff		EQU	OStatTxOff + 0x80
OStatErBase		EQU	(ScratchBase + OStatErOff)
OStatErLimit	EQU	(OStatErBase + (16 * 4))
OStatClOff		EQU	OStatTxOff + 0xC0

GStatTxOff		EQU	0x100
GStatTxBase		EQU	ScratchBase + GStatTxOff 
GStatTxLimit	EQU	(GStatTxBase + (1 * 4))
GStatRxOff		EQU	GStatTxOff + 0x40
GStatRxBase		EQU	(ScratchBase + GStatRxOff)
GStatRxLimit	EQU	(GStatRxBase + (16 * 4))
GStatErOff		EQU	GStatTxOff + 0x80
GStatErBase		EQU	(ScratchBase + GStatErOff)
GStatErLimit	EQU	(GStatErBase + (16 * 4))
GStatClOff		EQU	GStatTxOff + 0xC0
GStatClBase		EQU	(ScratchBase + GStatClOff)
GStatClLimit	EQU	(GStatClBase + (16 * 4))

IXbusTestFlags	EQU	(ScratchBase + 0x200)
GigamacFlag		EQU	0x1
ExtLoopFlag		EQU	0x2
RunTestFlag		EQU	0x4
BurstTestFlag	EQU	0x8

Pause		EQU	"p"
Status		EQU	"s"
StatusAll	EQU	"S"
Resume		EQU	"r"
Exit		EQU	"x"
Help		EQU	"h"
Clear		EQU	"c"
ClearAll	EQU	"C"
Library		EQU	"d"
IntLoop		EQU	"i"
ExtLoop		EQU	"e"
Gigamac		EQU	"g"
Octalmac	EQU	"o"
TestMode	EQU	"t"
Query		EQU	"q"
Burst		EQU	"b"
Settings	EQU	"?"

StatRegBaseClr		EQU		0x400	;read these and regs are reset
StatTxRdyCtl		EQU	(ScratchBase + 4) 

;StatRegBase		EQU		0x400	;read these and regs are reset
;StatRegBase			EQU		0x800	;read tese and regs are NOT reset


;*************************************************************************
; Macro to check the state of the fp enable flag.
; Returns: 	ZF set if fp disabled
;			ZF clear if fp enabled
;*************************************************************************
	MACRO 
$label	ChkGigFlg	$w1, $w2
	ldr		$w1, =IXbusTestFlags
	ldr		$w2, [$w1]
	tst		$w2, #GigamacFlag
	MEND

;*************************************************************************
; Macro to check the state of the loopback mode flag.
; Returns: 	ZF set if internal loopback mode
;			ZF clear if external loopback mode
;*************************************************************************
	MACRO 
$label	ChkLoopFlg	$w1, $w2
	ldr		$w1, =IXbusTestFlags
	ldr		$w2, [$w1]
	tst		$w2, #ExtLoopFlag
	MEND

;*************************************************************************
; Macro to check the state of the runtest flag.
; Returns: 	ZF set if internal test is paused
;			ZF clear if test is running
;*************************************************************************
	MACRO 
$label	ChkRunFlg	$w1, $w2
	ldr		$w1, =IXbusTestFlags
	ldr		$w2, [$w1]
	tst		$w2, #RunTestFlag
	MEND

;*************************************************************************
; Macro to push all registers onto the stack.
; Assumes R13 is valid stack pointer.
;*************************************************************************
	MACRO 
$label	pusha
	stmfd	r13!, {r0-r12,r14}
	MEND																		

;*************************************************************************
; Macro to pop all registers off the stack.
; Assumes R13 is valid stack pointer.
;*************************************************************************
	MACRO 
$label	popa
	ldmfd	r13!, {r0-r12,r14}
	MEND



	AREA	ixbus,	CODE

	IF	:DEF:	IXBUS_TEST
	
;*************************************************************************
;
; ixbus_test : Highest level routine that comprises the IXbus test.
;
;	Passed:	Nothing.
;
;	Uses:	R0
;
;	Assumes: Nothing.
;
;*************************************************************************
ixbus_test
	ldr		r13, =IxbTestStackBase
	stmfd	r13!, {lr}			;save lr

	bl		InitIXtestFlags		;init flags for test parms

	bl		InitPktLib			;set up the packet data

	bl		InitMacDevices		;init mac CSRs for data transfer

	bl		LoadAllUstore		;load all uengine ustore
	
	bl		EnableAllThds		;initiate all contexts to run

	bl		ClearAllStat		;clear scratch parm area

	bl		MonitorTest			;monitor scratch parms and report

	bl		DisableAllThds		;shut down all contexts

	bl		KillMacDevices		;disable mac ports

	bl		CsrCleanup			;perform ixp1200 csr housekeeping

	adrl	r0, ixbtquit
	bl		UARTSendString

	ldmfd	r13!, {pc}			;return to caller


	LTORG

	
;*************************************************************************
;
; InitPktLib : Routine called to create the packet library in SDRAM that
;				will be used in the IXbus test.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R4 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
InitPktLib
	ldr		r0, =TestDatSeed	;data seed
	ldr		r1,	=TestDataDec	;data dec value
	ldr		r2, =TestDataInc	;data inc value
	ldr		r3,	=TestPktBase	;base addr pkt lib
	ldr		r4,	=TestPktEnd		;end addr of lib area

PktDataInitLoop
	str		r0, [r3], #0x4		;store pkt data to mem and inc ptr
	add		r0, r0, r2			;modify data
	sub		r0, r0, r1			;ditto
	cmp		r3, r4				;end of fill?
	ble		PktDataInitLoop		;if not loop back for more
								;else...
	ldr		r3,	=TestPktBase	;base addr pkt lib
	mov		r0, #0				;init pkt count var
	ldr		r1, =TestPktSzQw	;will store pkt size in qword

PktHdrInitLoop
	str		r0, [r3]			;store pkt # into packet
	str		r1, [r3, #0x4]		;store pkt size into packet
	add		r0, r0, #1			;inc pkt #
	add		r3, r3, #64			;inc data ptr to next pkt
	cmp		r3, r4				;end of pkt lib?
	ble		PktHdrInitLoop		;if not loop back for more

	mov		pc, lr				;return to caller




;*************************************************************************
;
; InitMacDevices : Routine called to initialize MAC device CSRs (all ports).
;
; SetMacCsrs : Enter here with R0 contents = caller selected init table.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R5 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
InitMacDevices
	adrl	r0, OctMacInitTbl	;assume octal init table
	ChkGigFlg	r4, r5
	beq		SetMacCsrs	
	adrl	r0, GigMacInitTbl	;gigabit init table

SetMacCsrs
	ldr		r4,	=PORTADRSZ		;mac io ptr inc val
	ldr		r5, =PORTADRLIM		;port io limit
	ChkGigFlg	r1, r3
	beq		%F01	
	ldr		r4,	=FPORTADRSZ		;mac io ptr inc val
	ldr		r5, =FPORTADRLIM	;port io limit
	
1
	ldr		r3, =MAC0BASE		;ptr to mac io
	ChkGigFlg	r1, r2
	beq		%F04
	ldr		r3, =GMACBASE		;ptr to mac io
4
	ldr		r1, [r0], #4		;table entry (reg addr) to r1, then r0=r0+4
	cmp		r1, #0xFFFFFFFF		;check end of table?
	beq		%F02				;if so we are done

	ldr		r2, [r0], #4		;else, load reg with init data, then r0=r0+4
3	str		r2, [r1, r3]		;and init chip reg
	add		r3, r3, r4			;point to next port
	cmp		r3, r5				;hit all ports?
	blt		%B03				;if not then cont.	

	b		%B01

2
	mov		pc, lr				;return to caller


;*************************************************************************
;
; LoadAllUstore : Routine called to download uCode to the Engines for the 
;					IXbus test.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2, R4, R8-R10 contents destroyed.
;
;	Assumes: Ucode files are included at the appropriate labels.
;
;*************************************************************************
LoadAllUstore
	stmfd	r13!, {lr}			;save lr

;cycle the F-Boxs into reset...
	ldr     r9, =PCI_RESET			;PCI reset reg addr
	ldr     r8, =0x3F 				;all uEngines in reset
	str     r8, [r9]        		;

    LDR	R10, =MENG0_BASE_ADDR 

LoadNextUstore

;Disable Event Wake_up for this Fbox (ctx0-3) 
    MOV	R0, #0 
    STR	R0, [R10,#CTX_0_WAKE_EVENTS]	
    STR	R0, [R10,#CTX_1_WAKE_EVENTS] 	
    STR	R0, [R10,#CTX_2_WAKE_EVENTS] 	
    STR	R0, [R10,#CTX_3_WAKE_EVENTS] 	

;Disable Ctx_enables for Fbox 
    STR	R0, [R10,#CTX_ENABLES] 	

;Download the code to uStore...
; first assume is rx code
	adrl	r0, rx_ucode_start		;start address of ucode
	adrl	r4, rx_ucode_end					
	ldr		r9, =MENG3_BASE_ADDR	;engines 0-3 get rx code
	cmp		r10, r9
	ble		LoadIt

; else assume is rxsch code
	adrl	r0, rxsch_ucode_start	;start address of ucode
	adrl	r4, rxsch_ucode_end

; check for gigamac support
	ChkGigFlg	r9, r3
	beq		CheckMeng4				;if not giga leave as octal

	adrl	r0, rxschfp_ucode_start	;else point to gigamac code
	adrl	r4, rxschfp_ucode_end

CheckMeng4
	ldr		r9, =MENG4_BASE_ADDR	;engine 4 gets rx sched code
	cmp		r10, r9
	beq		LoadIt

; finally must be tx code
	adrl	r0, tx_ucode_start		;start address of ucode
	adrl	r4, tx_ucode_end		;engine 5 gets tx code
	ChkGigFlg	r9, r3
	beq		LoadIt					;if not giga leave as octal

	adrl	r0, txfp_ucode_start	;start address of ucode
	adrl	r4, txfp_ucode_end		;engine 5 gets tx code

LoadIt

	IMPORT	rxschdfp
	IMPORT	rxschd
	IMPORT	txfp
	IMPORT	tx
	IMPORT	rx
	pusha
	mov		r2, r0
	adrl	r1, rxschfp_ucode_start
	adrl	r0, rxschdfp
	cmp		r2, r1
	beq		printit
	adrl	r1, txfp_ucode_start
	adrl	r0, txfp
	cmp		r2, r1
	beq		printit
	adrl	r1, tx_ucode_start
	adrl	r0, tx
	cmp		r2, r1
	beq		printit
	adrl	r1, rxsch_ucode_start
	adrl	r0, rxschd
	cmp		r2, r1
	beq		printit
	adrl	r1, rx_ucode_start
	adrl	r0, rx
	cmp		r2, r1
	beq		printit

printit
	bl		UARTSendString
	popa

	add		r1, r10, #USTORE_ADDR	;ustore addres
	sub		r2, r4, r0				;length of ucode block
	mov		r2, r2, LSR #0x2		;div length by 4 for dword
	bl		uStoreLoad				;load the code
	add		r10, r10, #0x800

	ldr		r0, =MENG5_BASE_ADDR
	cmp		r10, r0
	ble		LoadNextUstore

	ldmfd	r13!, {pc}			;return to caller
	

	LTORG


;*************************************************************************
;
; EnableAllThds : Routine called to enable all uEngine threads and begin 
;					packet transmission.
;
;	Passed:	Nothing.
;
;	Uses:	R0, R2, R8-R10 contents destroyed.
;
;	Assumes: Ucode files have been downloaded to the uEngines.
;
;*************************************************************************
EnableAllThds

;cycle the F-Box out of reset...
	ldr     r9, =PCI_RESET			;PCI reset reg addr
	ldr     r8, =0x0 				;uEngines out of reset
	str     r8, [r9]				;now Uengine out of reset 
	
    LDR	R10, =MENG0_BASE_ADDR 

ExecNextUeng

;clear bit10 of Ustore_address CSR (use tbox_icl address instead)
    MOV    R2, #0    				; <10> = enable bit, <9:0> address 
    STR    R2, [R10] 

;set CTX_ARB_CNTL 
    STR     R2, [R10,#CTX_ARB_CNTL] 

;set CTX_STATUS 
    STR     R2, [R10,#CTX_0_STATUS] 
    STR     R2, [R10,#CTX_1_STATUS] 
    STR     R2, [R10,#CTX_2_STATUS] 
    STR     R2, [R10,#CTX_3_STATUS] 

;Enable Event Wake_up for this Fbox (ctx0-3) 
    LDR	R0, =0x1
    STR	R0, [R10,#CTX_0_WAKE_EVENTS] 
    STR	R0, [R10,#CTX_1_WAKE_EVENTS] 
    STR	R0, [R10,#CTX_2_WAKE_EVENTS] 
    STR	R0, [R10,#CTX_3_WAKE_EVENTS] 

;Enable Ctx_enables for Fbox 
    LDR	R0, =0xf00 
    STR	R0, [R10,#CTX_ENABLES] 


	add		r10, r10, #0x800
	ldr		r0,	=MENG5_BASE_ADDR
	cmp		r10, r0
	ble		ExecNextUeng

	mov		pc, lr


;*************************************************************************
;
;	MonitorTest: Serial port console routine for ixbus test
;
;	Passed:	Nothing.
;
;	Uses:	R0-R1 contents destroyed.
;
;	Assumes: IXbus test is running.
;
;	Use:
;		p = pause transmit thread(s)
;		s = current mac status to console
;		S = all mac status to console
;		r = resume ixbus test
;		x = exit the ixbus test
;		h = command summary help
;		c = clear current mac status parameters
;		C = clear all mac status parameters
;		d = display packet lib data
;		i = set internal loopback mode
;		e = set external loopback mode
;		o = set for octal mac test
;		g = set for gigamac test
;		t = test mode
;		b = single t-fifo
;		? = display test settings
;
;*************************************************************************
MonitorTest
	stmfd	r13!, {lr}			;save lr

	bl		HelpSummary
	bl		DisplaySettings

PollConsole		
	bl	GetBytec1
	ldrb	r1, =Burst
	cmp	r0, r1
	beq	isBurst
	ldrb	r1, =Query
	cmp	r0, r1
	beq	isQuery
	ldrb	r1, =Pause
	cmp	r0, r1
	beq	isPauseTest
	ldrb	r1, =Status
	cmp	r0, r1
	beq	isStatusReport
	ldrb	r1, =StatusAll
	cmp	r0, r1
	beq	isStatusReportAll
	ldrb	r1, =Resume
	cmp	r0, r1
	beq	isResumeTest
	ldrb	r1, =Exit
	cmp	r0, r1
	beq	isExitTest
	ldrb	r1, =Help
	cmp	r0, r1
	beq	isHelpSummary
	ldrb	r1, =Clear
	cmp	r0, r1
	beq	isClearStat
	ldrb	r1, =ClearAll
	cmp	r0, r1
	beq	isClearAllStat
	ldrb	r1, =Library
	cmp	r0, r1
	beq	isLibraryDisp
	ldrb	r1, =IntLoop
	cmp	r0, r1
	beq	isIntLoop
	ldrb	r1, =ExtLoop
	cmp	r0, r1
	beq	isExtLoop
	ldrb	r1, =Octalmac
	cmp	r0, r1
	beq	isOctalmac
	ldrb	r1, =Gigamac
	cmp	r0, r1
	beq	isGigamac
	ldrb	r1, =TestMode
	cmp	r0, r1
	beq	isTestMode
	ldrb	r1, =Settings
	cmp	r0, r1
	beq	isSettings
	b	PollConsole


isBurst
	bl	BurstOne
	b	PollConsole
isQuery
	bl	Query_xmit
	b	PollConsole
isTestMode
	bl	ContTestMode
	b	PollConsole
isPauseTest
	bl	PauseTest
	b	PollConsole
isStatusReport
	bl	StatusReport
	b	PollConsole
isStatusReportAll
	bl	StatusReportAll
	b	PollConsole
isResumeTest
	bl	ResumeTest
	b	PollConsole
isHelpSummary
	bl	HelpSummary
	b	PollConsole
isClearStat
	bl	ClearStat
	b	PollConsole
isClearAllStat
	bl	ClearAllStat
	b	PollConsole
isLibraryDisp
	bl	LibraryDisp
	b	PollConsole
isIntLoop
	bl	SetIntLoop
	b	PollConsole
isExtLoop
	bl	SetExtLoop
	b	PollConsole
isOctalmac
	bl	SetOctalmac
	b	PollConsole
isGigamac
	bl	SetGigamac
	b	PollConsole
isSettings
	bl	DisplaySettings
	b	PollConsole
isExitTest
	bl	DisableAllThds
	ldmfd	r13!, {pc}			;return to caller


;DEBUG------------------------------------------------------------

PortRegAddrTbl
	DCD		Port_Ctrl
	DCD		Tx_Param
	DCD		Rx_Param
	DCD		Ffo_Bus
	DCD		Ser_mod
	DCD		Tx_Stat
	DCD		Rx_Stat
	DCD		TxPktErrCnt+StatRegBaseClr
	DCD		RxPktOvfCnt+StatRegBaseClr
	DCD		TxPkt65Cnt+StatRegBaseClr+0xC
	DCD		TxPkt65Cnt+StatRegBaseClr+0x8
	DCD		TxPkt65Cnt+StatRegBaseClr+0x4
	DCD		TxPkt65Cnt+StatRegBaseClr+0x0
	DCD		RxPkt65Cnt+StatRegBaseClr+0xC
	DCD		RxPkt65Cnt+StatRegBaseClr+0x8
	DCD		RxPkt65Cnt+StatRegBaseClr+0x4
	DCD		RxPkt65Cnt+StatRegBaseClr+0x0
	DCD		0xFFFFFFFF

FPortRegAddrTbl
	DCD		GMPort_CtrlL
	DCD		GMPort_CtrlH
	DCD		GMTX_Rx_StatL
	DCD		GMTX_Rx_StatH
	DCD		GMPort_ModeL
	DCD		GMPort_ModeH
	DCD		GMTX_Rx_ParamL
	DCD		GMTX_Rx_ParamH
	DCD		TX_PKT_65_CNT0+StatRegBaseClr
	DCD		TX_PKT_65_CNT1+StatRegBaseClr
	DCD		TX_PKT_65_CNT2+StatRegBaseClr
	DCD		TX_PKT_65_CNT3+StatRegBaseClr
	DCD		RX_PKT_65_CNT0+StatRegBaseClr
	DCD		RX_PKT_65_CNT1+StatRegBaseClr
	DCD		RX_PKT_65_CNT2+StatRegBaseClr
	DCD		RX_PKT_65_CNT3+StatRegBaseClr
	DCD		TX_ERR_CNT0+StatRegBaseClr
	DCD		TX_ERR_CNT1+StatRegBaseClr
	DCD		TX_ERR_CNT2+StatRegBaseClr
	DCD		TX_ERR_CNT3+StatRegBaseClr
	DCD		RX_OVF_CNT0+StatRegBaseClr
	DCD		RX_OVF_CNT1+StatRegBaseClr
	DCD		RX_OVF_CNT2+StatRegBaseClr
	DCD		RX_OVF_CNT3+StatRegBaseClr
	DCD		0xFFFFFFFF

MengRegAddrTbl
	DCD		CTX_ENABLES			
	DCD		CTX_0_STATUS			
	DCD		CTX_1_STATUS		
	DCD		CTX_2_STATUS		
	DCD		CTX_3_STATUS		
;	DCD		CTX_0_SIG_EVENTS	
;	DCD		CTX_1_SIG_EVENTS	
;	DCD		CTX_2_SIG_EVENTS	
;	DCD		CTX_3_SIG_EVENTS	
;	DCD		CTX_0_WAKE_EVENTS
;	DCD		CTX_1_WAKE_EVENTS
;	DCD		CTX_2_WAKE_EVENTS
;	DCD		CTX_3_WAKE_EVENTS
	DCD		0xFFFFFFFF


Query_xmit
	stmfd	r13!, {lr}			;save lr


;START misc reg output for debug...

	ldr		r3, =MAC0BASE+0x8000
	ldr		r4, =MAC0BASE
  	adrl	r2, PortRegAddrTbl	;byte address of table
	mov		r5, #0x1000
1	
	ldr		r1, [r2], #4		;load data and inc to next dword
	cmp		r1, #0xFFFFFFFF		;check end of table?
	beq		%F03				;if so we are done
	add		r1, r1, r4			;address reg in port 0
2
	ldrb	r0, [r1]			;read port
	PutHexStack
	add		r1, r1, r5
	cmp		r1, r3
	blt		%B02
	adrl	r0, CRLF			;
	printfs
	printfs
	b		%B01				;loop till done
3
	printfs
	printfs


;START misc reg output for FP debug...

	ldr		r3, =GMACBASE+0x2000
	ldr		r4, =GMACBASE
  	adrl	r2, FPortRegAddrTbl	;byte address of table
	mov		r5, #0x1000
7	
	ldr		r1, [r2], #4		;load data and inc to next dword
	cmp		r1, #0xFFFFFFFF		;check end of table?
	beq		%F09				;if so we are done
	add		r1, r1, r4			;address reg in port 0
8
	ldrb	r0, [r1]			;read port
	PutHexStack
	add		r1, r1, r5
	cmp		r1, r3
	blt		%B08
	adrl	r0, CRLF			;
	printfs
	printfs
	b		%B07				;loop till done
9
	printfs
	printfs



	ldr		r3, =MENG5_BASE_ADDR+0x7FF
	ldr		r4, =MENG0_BASE_ADDR
	mov		r5, #0x800
  	adrl	r2, MengRegAddrTbl	;byte address of table
4	
	ldr		r1, [r2], #4		;load data and inc to next dword
	cmp		r1, #0xFFFFFFFF		;check end of table?
	beq		%F06				;if so we are done
	add		r1, r1, r4			;address reg in port 0
5
	ldr		r0, [r1]			;read port
	PutHexStack
	add		r1, r1, r5
	cmp		r1, r3
	blt		%B05
	adrl	r0, CRLF			;
	printfs
	printfs
	b		%B04				;loop till done
6

	adrl	r0, CRLF
	printfs

	ldr		r1, =ScratchBase+0x000
	ldr		r3, =ScratchBase+0x204

dumploop
	ldr		r0, [r1], #4
	PutHexStack			

	mov		r4, r1
	ands	r4, r4, #0xF
	bne		NoCrlf

	adrl	r0, CRLF
	printfs
NoCrlf
	cmp		r1, r3
	blt		dumploop

	adrl	r0, CRLF
	printfs

	IMPORT	rcvrdylo
	adrl	r0, rcvrdylo
	printfs
	ldr		r1, =(RCV_RDY_LO)
	ldr		r0, [r1]
	PutHexStack			
	adrl	r0, CRLF
	printfs

	IMPORT	xmitrdylo
	adrl	r0, xmitrdylo
	printfs
	ldr		r1, =(XMIT_RDY_LO)
	ldr		r0, [r1]
	PutHexStack			
	adrl	r0, CRLF
	printfs

	IMPORT	xmitrdyctl
	adrl	r0, xmitrdyctl
	printfs
	ldr		r1, =(XMIT_RDY_CTL)
	ldr		r0, [r1]
	PutHexStack			
	adrl	r0, CRLF
	printfs

	IMPORT	xmitptr
	adrl	r0, xmitptr
	printfs
	ldr		r1, =(XMIT_PTR)
	ldr		r0, [r1]
	PutHexStack			
	adrl	r0, CRLF
	printfs

	IMPORT	rcvrdycnt
	adrl	r0, rcvrdycnt
	printfs
	ldr		r1, =(RCV_RDY_CNT)
	ldr		r0, [r1]
	PutHexStack			
	adrl	r0, CRLF
	printfs

;END misc reg output for debug...
	ldmfd	r13!, {pc}			;return to caller


;DEBUG------------------------------------------------------------


;*************************************************************************
;
; PauseTest : Routine called to pause IXbus test by disabling the transmit
;				thread(s).
;
;	Passed:	Nothing.
;
;	Uses:	R0, R10 contents destroyed.
;
;	Assumes: IXbus test is running.
;
;*************************************************************************
PauseTest
	stmfd	r13!, {lr}			;save lr

	ldr	r0, =(IXbusTestFlags)
	ldr	r1, =RunTestFlag
	ldr	r2,	[r0]
	bic	r2, r2, r1
	str	r2, [r0]

	adrl	r0, ixbtpaused		;function intro banner
	bl		UARTSendString

	ldmfd	r13!, {pc}			;return to caller


	LTORG


;*************************************************************************
;
; StatusReport : Routine to display packet statistics from scratch memory.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R5 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
StatusReport
	stmfd	r13!, {lr}			;save lr
	
	ChkGigFlg	r0, r1
	bne	FPStat

	adrl	r0, ixbtstat1		;function intro banner
	printfs

	ldr		r1, =OStatTxBase	;base addr of port rx stat
	ldr		r2, =OStatRxBase	;base addr of port rx stat
	ldr		r3, =OStatErBase	;base addr of port error stat
	ldr		r4, =0x0			;port count var
	ldr		r5, =PORTCOUNT		;limit

StatLoop1
	adrl	r0, ixbtstat10
	printfs
	mov		r0, r4
	PutHexStack			
	adrl	r0, ixbtstat11
	printfs
	ldr		r0, [r1]
	mov		r0, r0, LSL #1
	PutHexStack			
	adrl	r0, ixbtstat12
	printfs
	ldr		r0, [r2], #0x4 
	PutHexStack			
	adrl	r0, ixbtstat13
	printfs
	ldr		r0, [r3], #0x4
	PutHexStack			
	adrl	r0, CRLF
	printfs
	add		r4, r4, #0x1
	cmp		r4, r5
	blt		StatLoop1

	adrl	r0, CRLF
	printfs
	ldmfd	r13!, {pc}			;return to caller


FPStat
	adrl	r0, ixbtstat1a		;function intro banner
	printfs

	ldr		r1, =GStatRxBase	;base addr of port rx stat
	ldr		r2, =GStatErBase	;base addr of port error stat
	ldr		r3, =GStatClBase	;base addr of port cancel stat
	ldr		r4, =0x0			;port count var
	ldr		r5, =16				;limit is # of rcv thrds
	ldr		r6, =0				;accumulate rx pkts in r6

StatLoop2
	adrl	r0, ixbtstat10a		;thread #
	printfs
	mov		r0, r4
	PutHexStack			
	adrl	r0, ixbtstat12
	printfs
	ldr		r0, [r1], #0x4		;rx pkts
	add		r6, r6, r0
	PutHexStack			
	adrl	r0, ixbtstat13
	printfs
	ldr		r0, [r2], #0x4 		;data errors
	PutHexStack			
	adrl	r0, ixbtstat14
	printfs
	ldr		r0, [r3], #0x4		;cancels
	PutHexStack			
	adrl	r0, CRLF
	printfs
	add		r4, r4, #0x1
	cmp		r4, r5
	blt		StatLoop2

	adrl	r0, CRLF
	printfs


	adrl	r0, ixbtfptx
	printfs
	ldr		r1, =GStatTxBase	;base addr of port tx stat
	ldr		r2, [r1]
	mov		r0, r2, LSL #4		;multiply by 16
	PutHexStack			
	adrl	r0, CRLF
	printfs
	
	adrl	r0, ixbtfprx
	printfs
	mov		r0, r6
	PutHexStack			
	adrl	r0, CRLF
	printfs

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; StatusReportAll : Routine to display packet statistics from scratch 
;					for all MAC devices.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R5 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
StatusReportAll
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags	;addr of flags
	ldr		r1, [r0]			;get flags
	pusha
	mov		r2, #0				;
	str		r2,	[r0]			;indicate octal mac
	bl		StatusReport		;dump status
	ldr		r0, =IXbusTestFlags
	mov		r2, #1
	str		r2,	[r0]			;indicate gigamac
	bl		StatusReport		;report status
	ldr		r0, =IXbusTestFlags
	popa
	str		r2,	[r0]			;restore original flags

	ldmfd	r13!, {pc}			;return to caller
	

;*************************************************************************
;
; ResumeTest : Routine called to restart IXbus test by enabling the transmit
;				thread(s).
;
;	Passed:	Nothing.
;
;	Uses:	R0, R10 contents destroyed.
;
;	Assumes: IXbus test has been paused.
;
;*************************************************************************
ResumeTest
	stmfd	r13!, {lr}			;save lr

InOctMode
	ldr	r0, =(IXbusTestFlags)
	ldr	r2,	[r0]
	ldr	r1, =RunTestFlag
	orr	r2, r2, r1
	str	r2, [r0]

	adrl	r0, ixbtrestrt		;function intro banner
	bl		UARTSendString

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; BurstOne : Routine called to transmit one tfifo of packets and stop.
;
;	Passed:	Nothing.
;
;	Uses:	R0, R10 contents destroyed.
;
;	Assumes: IXbus test has been paused.
;
;*************************************************************************
BurstOne
	stmfd	r13!, {lr}			;save lr

	adrl	r0, ixbtbursting
	bl		UARTSendString
	ldr	r0, =(IXbusTestFlags)
	ldr	r1, =BurstTestFlag
	ldr	r2,	[r0]
	orr	r2, r2, r1
	str	r2, [r0]

	bl	StatusReport
	
	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; HelpSummary : Routine called to display the console command summary.
;
;	Passed:	Nothing.
;
;	Uses:	R0 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
HelpSummary
	stmfd	r13!, {lr}			;save lr
	adrl	r0, ixbthelp1
	bl		UARTSendString
	adrl	r0, ixbthelp2
	bl		UARTSendString
	adrl	r0, ixbthelp3
	bl		UARTSendString
	adrl	r0, ixbthelp3a
	bl		UARTSendString
	adrl	r0, ixbthelp4
	bl		UARTSendString
	adrl	r0, ixbthelp5
	bl		UARTSendString
	adrl	r0, ixbthelp5a
	bl		UARTSendString
	adrl	r0, ixbthelp6
	bl		UARTSendString
	adrl	r0, ixbthelp7
	bl		UARTSendString
	adrl	r0, ixbthelp8
	bl		UARTSendString
	adrl	r0, ixbthelp9
	bl		UARTSendString
	adrl	r0, ixbthelp10
	bl		UARTSendString
	adrl	r0, ixbthelp11
	bl		UARTSendString
	adrl	r0, ixbthelp13
	bl		UARTSendString
	adrl	r0, ixbthelp14
	bl		UARTSendString
	adrl	r0, ixbthelp12
	bl		UARTSendString
	ldmfd	r13!, {pc}			;return to caller




;*************************************************************************
;
; ClearAllStat 	: Routine called to clear the packet statistic data area
;					for all macs.
; ClearStat 	: Routine called to clear the packet statistic data area
;					for the mac currently enabled.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R3 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
ClearAllStat
	stmfd	r13!, {lr}			;save lr
	adrl	r0, ixbtclearall	;function intro banner
	bl		UARTSendString
	ldr		r0, =OStatTxBase
	ldr		r1, =GStatClLimit
	b		ContClear

ClearStat
	stmfd	r13!, {lr}			;save lr
	adrl	r0, ixbtclear		;function intro banner
	bl		UARTSendString
	ldr		r0, =OStatTxBase		;assume octal mac mode
	ldr		r1, =OStatErLimit
	ChkGigFlg	r2, r3			;check mac mode
	beq		ContClear			;zf set is octal

	ldr		r0, =GStatTxBase		;else clear fp parms
	ldr		r1, =GStatClLimit

ContClear
	mov		r2, #0

ClearLoop1
	str		r2, [r0], #4
	cmp		r0, r1
	blt		ClearLoop1

	ldmfd	r13!, {pc}			;return to caller


	LTORG


;*************************************************************************
;
; DisplaySettings : Routine called to the current test settings.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
DisplaySettings
	stmfd	r13!, {lr}			;save lr

	adrl	r0, ixbtstgs
	printfs

	adrl	r0, ixbtlbm
	printfs
	adrl	r0, ixbtints
	ChkLoopFlg	r1, r2
	beq		%F01
	adrl	r0, ixbtexts
1
	printfs

	adrl	r0, ixbtmm
	printfs
	adrl	r0, ixbtoct
	ChkGigFlg	r1, r2
	beq		%F02
	adrl	r0, ixbtgig
2
	printfs
	
	adrl	r0, ixbtcur
	printfs
	adrl	r0, ixbtpause
	ChkRunFlg	r1, r2
	beq		%F03
	adrl	r0, ixbtrun
3
	printfs

	adrl	r0, CRLF
	printfs

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; LibraryDisp : Routine called to dump the packet library from SDRAM to 
;				the console.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
LibraryDisp
	stmfd	r13!, {lr}			;save lr
	adrl	r0, ixbtlib
	bl		UARTSendString

	ldr		r1, =TestPktBase
	ldr		r2,	=TestPktEnd

libdisploop
	ldr		r0, [r1], #4
	PutHexStack			
	adrl	r0, CRLF
	printfs
	cmp		r1, r2
	blt		libdisploop

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; SetIntLoop : Routine called to set mac mode to internal loop back.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
SetIntLoop
	stmfd	r13!, {lr}				;save lr

	adrl	r0,	OctMacIntLoopTbl	;assume octal mac
	ChkGigFlg	r1, r2				;test mac flag
	beq		%F01					;zf set is octal mac
	adrl	r0,	GigMacIntLoopTbl	;else is gig mac
1
	bl		SetMacCsrs				;set the mac csrs
	bl		ClrExtLoopFlg 			;clr the ext mode flag
	adrl	r0, ixbtint 			;address of msg
	bl		UARTSendString			;inform the user
	ldmfd	r13!, {pc}				;return to caller


;*************************************************************************
;
; SetExtLoop : Routine called to set mac mode to external loop back.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
SetExtLoop
	stmfd	r13!, {lr}				;save lr
	adrl	r0,	OctMacExtLoopTbl	;assume octal mac
	ChkGigFlg	r1, r2				;test mac flag
	beq		%F01					;zf set is octal mac
	adrl	r0,	GigMacExtLoopTbl	;else is gig mac
1
	bl		SetMacCsrs 				;set the mac csrs
	bl		SetExtLoopFlg 			;set the ext mode flag
	adrl	r0, ixbtext				;address of msg
	bl		UARTSendString			;inform the user
	ldmfd	r13!, {pc}				;return to caller


;*************************************************************************
;
; SetOctalmac : Routine to setup IXbus test to use the octalmac. 
;
;	Passed:	Nothing.
;
;	Uses:	R?-R? contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
SetOctalmac
	stmfd	r13!, {lr}			;save lr

	bl		DisableAllThds		;shut down all contexts

	bl		KillMacDevices		;disable mac ports

	bl		CsrCleanup			;perform ixp1200 csr housekeeping

	bl		ClrGigamacFlg

	bl		InitMacDevices		;init mac CSRs for data transfer

	ChkLoopFlg	r0, r1			;default mac init is int loop
	beq		%F01				;test here to see if ext mode set

	bl		SetExtLoop
1
	bl		LoadAllUstore		;load all uengine ustore
	
	bl		EnableAllThds		;initiate all contexts to run

	bl		ClearStat

	IMPORT	octalmode
	adrl	r0, octalmode
	bl		UARTSendString

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; SetGigamac : Routine to setup IXbus test to use the gigamac.
;
;	Passed:	Nothing.
;
;	Uses:	R?-R? contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
SetGigamac
	stmfd	r13!, {lr}			;save lr

	bl		DisableAllThds		;shut down all contexts

	bl		KillMacDevices		;disable current mac ports

	bl		CsrCleanup			;perform ixp1200 csr housekeeping

	bl		SetGigamacFlg		;indicate fp enable

	bl		InitMacDevices		;init fp mac CSRs for data transfer

	ChkLoopFlg	r0, r1			;default mac init is int loop
	beq		%F01				;test here to see if ext mode set

	bl		SetExtLoop
1
	bl		LoadAllUstore		;load all uengine ustore
	
	bl		EnableAllThds		;initiate all contexts to run

	bl		ClearStat

	IMPORT	gigamode
	adrl	r0, gigamode
	bl		UARTSendString

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; ClrGigamacFlg : Routine to clear fast port flag indicating use of octal
;					mac. 
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
ClrGigamacFlg
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags
	ldr		r2, [r0]
	ldr		r1, =GigamacFlag
	bic		r2, r2, r1
	str		r2, [r0]

	ldmfd	r13!, {pc}			;return to caller


	LTORG


;*************************************************************************
;
; SetGigamacFlg : Routine to set flag indicating use of fast port.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
SetGigamacFlg
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags
	ldr		r2, [r0]
	ldr		r1, =GigamacFlag
	orr		r2, r2, r1
	str		r2, [r0]

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; ClrExtLoopFlg : Routine to clear external loop flag indicating use of
;					internal loopback function. 
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
ClrExtLoopFlg
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags
	ldr		r2, [r0]
	ldr		r1, =ExtLoopFlag
	bic		r2, r2, r1
	str		r2, [r0]


	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; SetExtLoopFlg : Routine to set external loop flag indicating use of 
;					external loopback function.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
SetExtLoopFlg
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags
	ldr		r2, [r0]
	ldr		r1, =ExtLoopFlag
	orr		r2, r2, r1
	str		r2, [r0]


	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; InitIXtestFlags : Routine to init flag dword in scratch mem.
;					Defaults to octal MAC, internal loop back, pause test. 
;
;	Passed:	Nothing.
;
;	Uses:	R0-R1 contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
InitIXtestFlags
	stmfd	r13!, {lr}			;save lr

	ldr		r0, =IXbusTestFlags
	ldr		r1, =0xA5A50000		;paused, octal, internal
	str		r1, [r0]


	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; KillMacDevices : Routine called to disable mac devices.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
KillMacDevices
	stmfd	r13!, {lr}			;save lr
	adrl	r0,	OctMacDisTbl
	ChkGigFlg	r1, r2
	beq		%F01
	adrl	r0,	GigMacDisTbl
1
	bl		SetMacCsrs 
	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; CsrCleanup : Routine called to program system csrs on test exit.
;
;	Passed:	Nothing.
;
;	Uses:	R0-R2 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
CsrCleanup
	stmfd	r13!, {lr}			;save lr
	adrl	r0,	CsrCleanupTbl
	bl		InitDwordCSRs 
	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; DisableAllThds : Routine called to halt the IXbus test by disabling all 
;					threads.
;
;	Passed:	Nothing.
;
;	Uses:	R0, R10 contents destroyed.
;
;	Assumes: Nothing.
;
;*************************************************************************
DisableAllThds
	stmfd	r13!, {lr}			;save lr

	ldr		r10,	=MENG0_BASE_ADDR

ExecNextDis

;Disable Event Wake_up for this Fbox (ctx0-3) 
    MOV	R0, #0 
    STR	R0, [R10,#CTX_0_WAKE_EVENTS]	
    STR	R0, [R10,#CTX_1_WAKE_EVENTS] 	
    STR	R0, [R10,#CTX_2_WAKE_EVENTS] 	
    STR	R0, [R10,#CTX_3_WAKE_EVENTS] 	

;Disable Ctx_enables for Fbox 
    STR	R0, [R10,#CTX_ENABLES] 	

	add		r10, r10, #0x800
	ldr		r0,	=MENG5_BASE_ADDR
	cmp		r10, r0
	ble		ExecNextDis

	ldmfd	r13!, {pc}			;return to caller


;*************************************************************************
;
; ContTestMode : Routine to  
;
;	Passed:	Nothing.
;
;	Uses:	R?-R? contents destroyed
;
;	Assumes: Nothing.
;
;*************************************************************************
ContTestMode
	stmfd	r13!, {lr}			;save lr

	bl		PauseTest
	bl		ClearAllStat
	bl		ResumeTest

	ldr		r0, =OStatRxBase
	ldr		r2,	=0x1FFFF
	ChkGigFlg	r3, r4
	beq		%F01

	ldr		r0, =GStatRxBase

;Poll UART for user requests...
1
	ldr		r5, =Status
	ldr     r1,=UART_USR		;address of uart status register
	ldr     r3,[r1]				;get uart status
	tst     r3,#RCV				;receive fifo ready?
	beq     %F03
	ldrb    r4,[r1,#0x800]		;else read the character
	cmp		r4, r5
	beq		isStatRep
	ldr		r5, =Exit
	cmp		r4, r5
	beq		isExittest

;Read rx status and check # of pkts...
3
	ldr		r1, [r0]			;load # of tx pkts
	cmp		r1, r2				;hit the limit?
	blt		%B01				;spin til we do

;Hit the number of pkts so toggle mac mode...
	ChkGigFlg	r1, r3			;mac mode test (gig or oct)
	beq		%F02
	
	stmfd	r13!, {r0, r2}
	bl		SetOctalmac			;if in gig mode then set octal
	ldmfd	r13!, {r0, r2}
	ldr		r0, =OStatRxBase
	b		%B01

2	
	stmfd	r13!, {r0, r2}
	bl		SetGigamac			;if in octal mode then set gig
	ldmfd	r13!, {r0, r2}
	ldr		r0, =GStatRxBase
	b		%B01

;User request to dump status...
isStatRep
	stmfd	r13!, {r0, r2}
	bl		StatusReport
	ldmfd	r13!, {r0, r2}
	b		%B03

;User request to exit ContTestMode...
isExittest
	ldmfd	r13!, {pc}			;return to caller



	LTORG


;*************************************************************************
;
; OctMacInitTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
OctMacInitTbl
	DCD		Port_Ctrl,	0x07	;reset device
	DCD		Port_Ctrl,	0x00	;disable ports
	DCD		Ffo_Bus,	0x02	;64 bit fifo bus
	DCD		Rx_Param,	0x90	;
	DCD		Tx_Param,	0x10	;
	DCD		Ser_mod,	0x28	;full dpx mode and int loop back
	DCD		Port_Ctrl,	0x18	;enable tx and rx
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; OctMacDisTbl : Table of MAC CSR address and data to disable
;					each port after test concludes.
;
;*************************************************************************
OctMacDisTbl
	DCD		Port_Ctrl,	0x07	;disable ports, reset device
	DCD		Port_Ctrl,	0x00	;disable ports, remove reset
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; OctMacIntloopTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
OctMacIntLoopTbl
	DCD		Port_Ctrl,	0x07	;reset device
	DCD		Port_Ctrl,	0x00	;disable ports
	DCD		Ffo_Bus,	0x02	;64 bit fifo bus
	DCD		Rx_Param,	0x90	;
	DCD		Tx_Param,	0x10	;
	DCD		Ser_mod,	0x28	;full dpx mode and int loop back
	DCD		Port_Ctrl,	0x18	;enable tx and rx
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; OctMacExtLoopTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
OctMacExtLoopTbl
	DCD		Port_Ctrl,	0x07	;reset device
	DCD		Port_Ctrl,	0x00	;disable ports
	DCD		Ffo_Bus,	0x02	;64 bit fifo bus
	DCD		Rx_Param,	0x90	;
	DCD		Tx_Param,	0x10	;
	DCD		Ser_mod,	0x08	;full dpx mode and ext loop back
	DCD		Port_Ctrl,	0x18	;enable tx and rx
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; GigMacInitTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
GigMacInitTbl
	DCD		GMPort_CtrlL,	0x07	;disable and reset port
	DCD		GMPort_CtrlH,	0x00	;
	DCD		GMPort_CtrlL,	0x00	;disable port and remove reset 
	DCD		GMPort_CtrlH,	0x00	;
	DCD		GMPort_ModeL,	0x21	;enable int loopback, GPCS mode
	DCD		GMPort_ModeH,	0x08	;64 bit fifo bus
	DCD		GMTX_Rx_ParamL,	0x01	;pad disable
	DCD		GMTX_Rx_ParamH,	0x80	;crc remove
	DCD		GMFfo_ThrshL,	0x03
	DCD		GMFfo_ThrshH,	0x7B
	DCD		GMPort_CtrlL,	0x18	;enable tx and rx
	DCD		GMPort_CtrlH,	0x00	;
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; GigMacDisTbl : Table of MAC CSR address and data to disable
;					each port after test concludes.
;
;*************************************************************************
GigMacDisTbl
	DCD		GMPort_CtrlL,	0x07	;disable ports, reset device
	DCD		GMPort_CtrlH,	0x00	;
	DCD		GMPort_CtrlL,	0x00	;disable ports, remove reset
	DCD		GMPort_CtrlH,	0x00	;
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; GigMacIntloopTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
GigMacIntLoopTbl
	DCD		GMPort_CtrlL,	0x00	;disable tx rx
	DCD		GMPort_CtrlH,	0x00	;
	DCD		GMPort_ModeL,	0x21	;enable int loopback, GPCS mode
	DCD		GMPort_ModeH,	0x08	;64 bit fifo bus
	DCD		GMPort_CtrlL,	0x18	;re-enable the tx and rx
	DCD		GMPort_CtrlH,	0x00	;
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; GigMacExtLoopTbl : Table of MAC CSR address and data to be programmed into
;					each port used in the IXbus test.
;
;*************************************************************************
GigMacExtLoopTbl
	DCD		GMPort_CtrlL,	0x00	;disable tx rx
	DCD		GMPort_CtrlH,	0x00	;
	DCD		GMPort_ModeL,	0x01	;disable int loopback
	DCD		GMPort_ModeH,	0x08	;64 bit fifo bus
	DCD		GMPort_CtrlL,	0x18	;re-enable tx rx
	DCD		GMPort_CtrlH,	0x00	;
	DCD		0xFFFFFFFF				

;*************************************************************************
;
; CsrCleanupTbl : Table of 1200 CSR address and data to be programmed
;					before exiting the IXbus test.
;
;*************************************************************************
CsrCleanupTbl
	DCD		RDYBUS_TEMPLATE_CTL		, 0x0	
	DCD		RDYBUS_TEMPLATE_PROG_3	, 0x0
	DCD		RDYBUS_TEMPLATE_PROG_2	, 0x0
	DCD		RDYBUS_TEMPLATE_PROG_1	, 0x0
	DCD		RCV_RDY_CTL				, 0x0	
	DCD		XMIT_RDY_CTL			, 0x0	
	DCD		RCV_RDY_CNT				, 0x0	
	DCD		0xFFFFFFFF				


	LTORG


;*************************************************************************
;
; The following included files contain the uCode that will be downloaded 
;	to the uEngines for the IXbus test.  There are three files:
;
;		1) receive.s: 	Receive thread uCode 
;		2) rcvsched.s: 	Receive scheduler thread uCode 
;		3) rcvschedfp.s:Receive scheduler thread uCode fast port
;		4) transmit.s: 	Transmit thread uCode 
;
;*************************************************************************
rx_ucode_start
	INCLUDE	receive.s
rx_ucode_end
	
rxsch_ucode_start
	INCLUDE	rcvsched.s
rxsch_ucode_end

rxschfp_ucode_start
	INCLUDE	rcvschedfp.s
rxschfp_ucode_end

tx_ucode_start
	INCLUDE	transmit.s
tx_ucode_end

txfp_ucode_start
	INCLUDE	transmitfp.s
txfp_ucode_end

	ENDIF	;IXBUS_TEST

	END