/* HPCSerial.h - Intel IXP1200 HPC Serial Port header file */

/* Copyright 2000 Intel Corp. */

/*
modification history
--------------------
01a,27Jun00,jdg  written from ixp1200Sio.h, version 01c
*/

#ifndef __INCHPCSerialh 
#define __INCHPCSerialh 

#define HPC_TX_BUFF_SIZE 128

typedef struct HPC_SERIAL_CHAN
    {
    /* must be first */

    SIO_CHAN	sio;		/* standard SIO_CHAN element */

    /* callbacks */

    STATUS	(*getTxChar) ();  /* installed Tx callback routine */
    STATUS	(*putRcvChar) (); /* installed Rx callback routine */
    void *	getTxArg;	      /* argument to Tx callback routine */
    void *	putRcvArg;	      /* argument to Rx callback routine */

    UINT32	channelMode;	  /* such as INT, POLL modes */
    int     channelNum;       /* HPC channel number */
    unsigned char txBuf[HPC_TX_BUFF_SIZE];
                              /* Buffer used to coalesce Tx requests */
    } HPC_SERIAL_CHAN;


/* function declarations */


IMPORT void hpcsDevInit (HPC_SERIAL_CHAN *pChan);
IMPORT void hpcsDevInit2 (HPC_SERIAL_CHAN *pChan);

#endif /* __INCHPCSerialh */
