/* configNet.h - Network configuration header file */

/* Copyright 1984-1998 Wind River Systems, Inc. */

/*
modification history
--------------------
01d,05Jan00,jdg  Added support for EEV ethernet
01c,05mar98,jpd  tidied comments.
01b,06dec97,tam	 added comments about END load string modification.
01a,27sep97,rlp	 written.
*/
 
#ifndef INCnetConfigh
#define INCnetConfigh

#include "vxWorks.h"
#include "end.h"

#define DEC_LOAD_FUNC	dec21x4xEndLoad		/* driver external interface */
#define DEC_BUFF_LOAN	1			/* enable buffer loaning */

#define INTEL_LOAD_FUNC eeVEndLoad
#define INTEL_BUFF_LOAN 1

/*
 * The initialization string format is:
 *
 * <devAdrs>:<PCIadrs>:<ivec>:<ilevel>:<memBase>:<memSize>:<userFlags>:<offset>
 */

/* 
 * Default END load string: initialized for a DEC21143 based Ethernet device.
 * This load string is eventually modified to match the Ethernet chip actually
 * detected on the PCI bus (cf sysDec21x4xPciInit() in sysEnd.c) 
 */

#define	DEC_LOAD_STRING	"0x00:0x00:0x00:0x00:-1:0x00:0x40000000:2"
#define INTEL_LOAD_STRING "0:0"


#ifdef INCLUDE_DEC
IMPORT END_OBJ* DEC_LOAD_FUNC (char *, void *);
#endif
#ifdef INCLUDE_EEV
IMPORT END_OBJ* INTEL_LOAD_FUNC (char *, void *);
#endif

END_TBL_ENTRY endDevTbl [] =
{
#ifdef INCLUDE_DEC
    { 0, DEC_LOAD_FUNC, DEC_LOAD_STRING, DEC_BUFF_LOAN, NULL, FALSE},
#endif
#ifdef INCLUDE_EEV
    { 0, INTEL_LOAD_FUNC, INTEL_LOAD_STRING, INTEL_BUFF_LOAN, NULL, FALSE},
#endif
    { 0, END_TBL_END, NULL, 0, NULL, FALSE},
};

#endif /* INCnetConfigh */
