/* flash28.h - header for 28F0X0 FLASH memory devices */

/* Copyright 1994-1996 Wind River Systems, Inc. */

/*
modification history
--------------------
01d,18jun99,jdg  added support for 28F800 parts
01c,26jan96,dzb  added casts for CMD constants.
01b,24feb94,dzb  added device codes for different flash devices.
01a,10feb94,dzb  created.
*/

/*
DESCRIPTION
This file contains header information for 28F0X0 FLASH memory devices.
*/

#ifndef __INCflash28h
#define __INCflash28h

#ifdef __cplusplus
extern "C" {
#endif

/* defines */

#define	FLASH28_CMD_READ_MEM		(FLASH_DEF) 0x00000000
#define	FLASH28_CMD_READ_ID		    (FLASH_DEF) 0x90909090
#define	FLASH28_CMD_ERASE_SETUP		(FLASH_DEF) 0x20202020
#define	FLASH28_CMD_ERASE		    (FLASH_DEF) 0x20202020
#define FLASH28_CMD_ERASE_CONFIRM   (FLASH_DEF) 0xd0d0d0d0
#define	FLASH28_CMD_ERASE_VERIFY	(FLASH_DEF) 0xa0a0a0a0
#define	FLASH28_CMD_PROG_SETUP		(FLASH_DEF) 0x40404040
#define	FLASH28_CMD_PROG_VERIFY		(FLASH_DEF) 0xc0c0c0c0
#define	FLASH28_CMD_RESET		    (FLASH_DEF) 0xffffffff

#define FLASH_28F800B           0x93          /* devide code 28F800-B */
#define FLASH_28F800T           0x92          /* device code 28F800-T */
#define FLASH_28F320B           0x97          /* device code 28F320-B */
#define FLASH_28F320T           0x96          /* device code 28F320-T */
#define FLASH_28F256			0xa1	      /* device code 28F256 */
#define FLASH_28F512			0x25	      /* device code 28F512 */
#define FLASH_28F010			0xa7	      /* device code 28F010 */
#define FLASH_28F020			0x2a	      /* device code 28F020 */
 
#ifdef __cplusplus
}
#endif

#endif /* __INCflash28h */
