/* flashUtil.h - Defines some constants and prototypes for flash utility */

/* Copyright 1999 Intel Corp. */

/*
modification history
--------------------
01a,09jul99,jdg  created
*/

/*
 * This module contains the constants and prototypes for generic
 * flash utility functions. These should be OS independent.
 */


#ifndef INCflashUtilh
#define INCflashUtilh


#if     (FLASH_WIDTH == 1)
#define FLASH_TYPE       UINT8
#endif  /* FLASH_WIDTH */

#if     (FLASH_WIDTH == 2)
#define FLASH_TYPE       UINT16
#endif  /* FLASH_WIDTH */

#if     (FLASH_WIDTH == 4)
#define FLASH_TYPE       UINT32
#endif  /* FLASH_WIDTH */

#define FTYPE_NONE 0

UINT8 flashTypeGet (UINT32 flash_offset);
STATUS flashErase (UINT32 flash_offset);
STATUS flashWrite
    (
    FLASH_TYPE * pFB,		/* string to be copied; use <value> if NULL */
    int size,			    /* size to program in bytes */
    int flash_offset,		/* byte offset into flash memory */
    FLASH_TYPE value		/* value to program */
    );
STATUS flashNextBlock (UINT32 *flash_offset);

#endif INCflashUtilh
