/* hpcFsFunc.h - RPC functions for HPCFS */

/* Copyright 1996-1998 Wind River Systems, Inc.; Copyright 2000 Intel Corp. */

/*
modification history
--------------------
01a,29Jun00,jdg  written
*/

/*
DESCRIPTION

This library provides the RPC functions used by HPCFS. Each function consists of
two parts: one that is called by the app, and one that completes the call from
the app. 
*/

#include "hpcFs.h"

int hpcFuncInit(int channel_num);
int hpcfsFuncOpen(int pmode, int pperm, char *name, int *channel);
int hpcfsFuncDel(char *name);
int hpcfsFuncClose(int channel);
int hpcfsFuncRead(int channel, char *userBuf, int maxBytes, int *actuallyRead);
int hpcfsFuncWrite(int channel, char *userBuf, int maxBytes, int *actWritten);
int hpcfsFuncIoctl(int channel, int request, int arg, int *resultArg);



/*
#define MAX_CHANNELS 256
#define MAKE_CHANNEL(x) ((x) << 24)
#define GET_CHANNEL(x) (((unsigned int)(x)) >> 24)
#define REMOVE_CHANNEL(x) ((x) & ((1 << 24) - 1))

extern HPCFS_CHANNEL_DESC* hpcfsChannel[MAX_CHANNELS];

void hpcfsTxSend (char *buf1, int size1, char *buf2, int size2);

#define HPCFS_IS_VALID(channel) (hpcfsChannel[(channel)] != NULL)

typedef enum {
    HPC_FS_FUNC_OPEN,
    HPC_FS_FUNC_WRITE,
    HPC_FS_FUNC_READ
} HPC_FS_FUNC;
*/
