/* ixp1200Pci.c - Intel IXP1200 PCI Unit driver */
/* Copyright 1998 Wind River Systems, Inc.; Copyright 1999 Intel Corp. */

/*
modification history
--------------------
01a,24apr00,drj  extracted from ixp1200Pci.c, version 01c
*/

#ifndef INCixp1200pcih
#define INCixp1200pcih

enum PciBarId{CSR_BAR=0, IO_BAR, SD_BAR, NO_BAR};

typedef struct {
    UINT32 size;
    UINT32 address;
} PciBar;

typedef struct {
    int bus;
    int device;
    int func;
    BOOL error;
    UINT16 vendor_id;
    UINT16 device_id;
    PciBar bar[7];
} PciDevice;

#if defined(__cplusplus)
extern "C"
{
#endif				/* __cplusplus */
extern PciDevice *pciInfoGet(unsigned short device);
#if defined(__cplusplus)
}
#endif				/* __cplusplus */

#endif				/* ifndef INCixp1200pcih */
