/* -*-C-*-
 *
 * $Revision: 1 $
 *   $Author: Hqianx $
 *     $Date: 8/17/99 4:16p $
 *
 * Copyright (c) 1996 Advanced RISC Machines Limited.
 * All Rights Reserved.
 *
 *   Project: ANGEL
 *
 *     Title: Device tables -- just one serial device for now.
 */

#include "devdriv.h"

/*
 * Headers declaring the angel_DeviceEntry struct for each device
 * should be included here:
 */

#include "serial.h"             /* serial device */

/*
 * The master device table - one entry per device
 * ORDER AND NUMBER OF ENTRIES MUST MATCH enum DeviceIdent IN devices.h
 */
const struct angel_DeviceEntry * const angel_Device[DI_NUM_DEVICES] = {
  &angel_SerialDevice
};


/*
 * The interrupt handler table - one entry per handler.
 *
 * DE_NUM_INT_HANDLERS must be set in devdriv.h to the number of
 * entries in this table.
 */

#if (DE_NUM_INT_HANDLERS>0)

const struct angel_IntHandlerEntry angel_IntHandler[DE_NUM_INT_HANDLERS] = {
  { angel_SerialIntHandler, SER_DEV_IDENT_0 }
};

#endif


/*
 * The poll handler table - one entry per handler 
 *
 * DE_NUM_POLL_HANDLERS must be set in devdriv.h to the number of
 * entries in this table. Nope, untrue. 
 */


/* EOF devices.c */
