; platform.s
;
;------------------------------------------------------------
;                                                                      
;                  I N T E L   P R O P R I E T A R Y                   
;                                                                      
;     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;     THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                      
;                        INTEL  CORPORATION                            
;                                                                     
;                     2200 MISSION COLLEGE BLVD                        
;                                                                      
;               SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                      
;------------------------------------------------------------
; system: SA1200
; subsystem: Angel Debug Monitor
; author: Henry Qian 01/29/99
; revisions:
;
; 03/31/00 - Dan White - added Rev B0 changes
; 04/25/00 - Dan White - added 200MHz changes
;


 IF :LNOT: :DEF: __address_h
__address_h             EQU     1

BIT0                    EQU     0x00000001
BIT1                    EQU     0x00000002
BIT2                    EQU     0x00000004
BIT3                    EQU     0x00000008
BIT4                    EQU     0x00000010
BIT5                    EQU     0x00000020
BIT6                    EQU     0x00000040
BIT7                    EQU     0x00000080
BIT8                    EQU     0x00000100
BIT9                    EQU     0x00000200
BIT10                   EQU     0x00000400
BIT11                   EQU     0x00000800
BIT12                   EQU     0x00001000
BIT13                   EQU     0x00002000
BIT14                   EQU     0x00004000
BIT15                   EQU     0x00008000
BIT16                   EQU     0x00010000
BIT17                   EQU     0x00020000
BIT18                   EQU     0x00040000
BIT19                   EQU     0x00080000
BIT20                   EQU     0x00100000
BIT21                   EQU     0x00200000
BIT22                   EQU     0x00400000
BIT23                   EQU     0x00800000
BIT24                   EQU     0x01000000
BIT25                   EQU     0x02000000
BIT26                   EQU     0x04000000
BIT27                   EQU     0x08000000
BIT28                   EQU     0x10000000
BIT29                   EQU     0x20000000
BIT30                   EQU     0x40000000
BIT31                   EQU     0x80000000

ALL_BITS                EQU     0xFFFFFFFF
        
SZ_1K                   EQU     0x00000400
SZ_4K                   EQU     0x00001000
SZ_8K                   EQU     0x00002000
SZ_16K                  EQU     0x00004000
SZ_32K                  EQU     0x00008000
SZ_64K                  EQU     0x00010000
SZ_128K                 EQU     0x00020000
SZ_256K                 EQU     0x00040000
SZ_512K                 EQU     0x00080000

SZ_1M                   EQU     0x00100000
SZ_2M                   EQU     0x00200000
SZ_4M                   EQU     0x00400000
SZ_8M                   EQU     0x00800000
SZ_16M                  EQU     0x01000000
SZ_32M                  EQU     0x02000000
SZ_64M                  EQU     0x04000000
SZ_128M                 EQU     0x08000000
SZ_256M                 EQU     0x10000000
SZ_512M                 EQU     0x20000000

SZ_1G                   EQU     0x40000000


; --------------------------------
; SA1200 physical memory addresses
; --------------------------------

ROMBase                 EQU     0x00000000
ROMSize                 EQU     SZ_1M

SRAMBase                EQU     0x10000000
SRAMSize                EQU     (SZ_512M + SZ_256M)

PCILocalBase            EQU     0x42000000
PCILocalSize            EQU     SZ_1M

PCIConfigTypeOneBase    EQU     0x52000000
PCIConfigTypeOneSize    EQU     SZ_32M

PCIConfigTypeZeroBase   EQU     0x53000000
PCIConfigTypeZeroSize   EQU     SZ_32M

PCIIOBase               EQU     0x54000000
PCIIOSize               EQU     SZ_1M

PCIMemBase              EQU     0x60000000
PCIMemSize              EQU     SZ_512M

ARMCOREBase             EQU     0x90000000
ARMCORESize             EQU     SZ_1M

AMBABase                EQU     0xB0000000
AMBASize                EQU     SZ_1M

DRAMBaseForUEng         EQU     0xC0000000
DRAMBaseForUEngSize     EQU     0x01800000 ; 24 Mb

DRAMBase                EQU     0xC1800000 ; Leave first 24Mb for microcode to use.
DRAMSize                EQU     SZ_8M

DRAMPrefetchBase        EQU     0xD0000000
DRAMPrefetchSize        EQU     DRAMSize

DRAMFlushBase           EQU     0xE0000000
DRAMFlushSize           EQU     DRAMSize

DRAMControlBase         EQU     0xFF000000
DRAMControlSize         EQU     SZ_1M


; ----------------------------
; MMU Virtual SA1200 Addresses
; ----------------------------

DRAM_BASE               EQU     0x00000000
DRAM_SIZE               EQU     DRAMSize

ROM_BASE                EQU     0x08000000
ROM_SIZE                EQU     ROMSize

SRAM_BASE               EQU     SRAMBase
SRAM_SIZE               EQU     SZ_8M


; ================
; SA1200 REGISTERS
; ================

; --------------------------
; PLL Configuration Register
; --------------------------
PLL_CFG                 EQU     0x90000C00

; PLL_CFG Constants @ 3.6864 MHz
;
PLL_A_CLK_29MHz           EQU     0x00
PLL_A_CLK_36MHz           EQU     0x01
PLL_A_CLK_44MHz           EQU     0x02
PLL_A_CLK_51MHz           EQU     0x03
PLL_A_CLK_58MHz           EQU     0x04
PLL_A_CLK_66MHz           EQU     0x05
PLL_A_CLK_73MHz           EQU     0x06
PLL_A_CLK_81MHz           EQU     0x07
PLL_A_CLK_88MHz           EQU     0x08
PLL_A_CLK_95MHz           EQU     0x09
PLL_A_CLK_103MHz          EQU     0x0A
PLL_A_CLK_110MHz          EQU     0x0B
PLL_A_CLK_117MHz          EQU     0x0C
PLL_A_CLK_132MHz          EQU     0x0D
PLL_A_CLK_147MHz          EQU     0x0E
PLL_A_CLK_154MHz          EQU     0x0F
PLL_A_CLK_162MHz          EQU     0x10
PLL_A_CLK_176MHz          EQU     0x11
PLL_A_CLK_191MHz          EQU     0x12

PLL_CLK_29MHz           EQU     0x00
PLL_CLK_36MHz           EQU     0x01
PLL_CLK_44MHz           EQU     0x02
PLL_CLK_51MHz           EQU     0x03
PLL_CLK_58MHz           EQU     0x04
PLL_CLK_66MHz           EQU     0x05
PLL_CLK_73MHz           EQU     0x06
PLL_CLK_81MHz           EQU     0x07
PLL_CLK_88MHz           EQU     0x08
PLL_CLK_95MHz           EQU     0x09
PLL_CLK_103MHz          EQU     0x0A
PLL_CLK_110MHz          EQU     0x0B
PLL_CLK_132MHz          EQU     0x0C
PLL_CLK_147MHz          EQU     0x0D
PLL_CLK_154MHz          EQU     0x0E
PLL_CLK_162MHz          EQU     0x0F
PLL_CLK_165MHz          EQU     0x10
PLL_CLK_176MHz          EQU     0x11
PLL_CLK_192MHz          EQU     0x12
PLL_CLK_200MHz          EQU     0x13


; ------------------------------
; FBI Control & Status Registers
; ------------------------------
IREG                    EQU     0xB00401E0

; IREG Contants
UEFIQ_ENABLE            EQU     BIT31
UEIRQ_ENABLE            EQU     BIT30
CINTFIQ_ENABLE          EQU     BIT29
CINTIRQ_ENABLE          EQU     BIT28
CINT_BIT                EQU     BIT27
BREAKPOINT              EQU     BIT24

; --------------------------
; Master Interrupt Registers
; --------------------------
FIQ                     EQU     0x90001000
IRQ                     EQU     0x90001400

; FIQ Status Constants
F_UART                  EQU     BIT8
F_SDRAM                 EQU     BIT7
F_RTC                   EQU     BIT6
F_SRAM                  EQU     BIT5
F_UENG                  EQU     BIT4
F_CINT                  EQU     BIT3
F_PCI                   EQU     BIT2

; IRQ Status Constants
I_UART                  EQU     BIT8
I_SDRAM                 EQU     BIT7
I_RTC                   EQU     BIT6
I_SRAM                  EQU     BIT5
I_UENG                  EQU     BIT4
I_CINT                  EQU     BIT3
I_PCI                   EQU     BIT2

; ------------------------------
; GPIO Enable and data Registers
; ------------------------------
GPIO_EN                 EQU     0x90001800
GPIO_DATA               EQU     0x90001C00

; ------------------------
; Real Time Clock Register
; ------------------------
RTC_DIV                 EQU     0x90002000
RTC_TINT                EQU     0x90002400
RTC_TVAL                EQU     0x90002800
RTC_CNTR                EQU     0x90002C00
RTC_ALM                 EQU     0x90003000

; RTC_DIV Register Constant
RTC_INT_RESET           EQU     BIT18
RTC_INT_ENABLE          EQU     BIT17
RTC_WRITE_ENABLE        EQU     BIT16

; ----
; UART
; ----
UART_SR                 EQU     0x90003400
UART_CR                 EQU     0x90003800
UART_DR                 EQU     0x90003C00

; UART Status Register Constants
UART_TX_FIFO_FULL       EQU     BIT7
UART_RX_FIFO_FULL       EQU     BIT6
UART_TX_FIFO_EMPTY      EQU     BIT5
UART_RX_READY           EQU     BIT4
UART_RX_OVERRUN         EQU     BIT3
UART_TX_READY           EQU     BIT2
UART_FRAMING_ERR        EQU     BIT1
UART_PARITY_ERR         EQU     BIT0

; UART Control Register Contants
UART_INT_SELECT          EQU     BIT9
UART_INT_CLEAR          EQU     BIT9
UART_TX_INT_ENABLE      EQU     BIT8
UART_ENABLE_BIT         EQU     BIT7
UART_DATA_BITS_8        EQU     (BIT6 | BIT5)
UART_RX_INT_ENABLE      EQU     BIT4
UART_STOP_BIT_1         EQU     BIT3
UART_PARITY_ENABLE      EQU     BIT1
UART_BREAK              EQU     BIT0

; Clock frequency for UART

 IF :DEF: SA1200_A0
UART_CLOCK              EQU     100000000/32
 ELSE
UART_CLOCK              EQU     3686400
 ENDIF

BAUD_9600               EQU     ((UART_CLOCK/16/9600)-1) << 16
BAUD_19200              EQU     ((UART_CLOCK/16/19200)-1) << 16
BAUD_38400              EQU     ((UART_CLOCK/16/38400)-1) << 16
BAUD_57600              EQU     ((UART_CLOCK/16/57600)-1) << 16
BAUD_115200             EQU     ((UART_CLOCK/16/115200)-1) << 16

;UART_CR_VALUE           EQU     (BAUD_9600 + UART_ENABLE_BIT + UART_DATA_BITS_8)
;UART_CR_VALUE           EQU     0x1300E0

CLEAR_BAUD_RATE_FIELD   EQU     (0x3FF << 16)

; UART Data Register with Error Status
UART_DATA_FRMING_ERR    EQU     BIT10
UART_DATA_RX_OVERRUN    EQU     BIT9
UART_DATA_PARITY_ERR    EQU     BIT8


; ----------------
; PCI Control Unit
; ----------------
CSR_BASE                EQU         0x42000000

PCI_VENDOR_ID           EQU         0x00
PCI_DEVICE_ID           EQU         0x02
PCI_COMMAND             EQU         0x04
PCI_STATUS              EQU         0x06
PCI_REV_ID              EQU         0x08
PCI_CLASS_ID            EQU         0x09
PCI_LATENCY             EQU         0x0D
PCI_MEM_BAR             EQU         0x10
PCI_CSR_BAR             EQU         0x10
PCI_IO_BAR              EQU         0x14
PCI_DRAM_BAR            EQU         0x18
PCI_OUT_INT_STATUS      EQU         0x30
PCI_OUT_INT_MASK        EQU         0x34
PCI_INT_LINE            EQU         0x3C
MAILBOX_0               EQU         0x50
MAILBOX_1               EQU         0x54
MAILBOX_2               EQU         0x58
MAILBOX_3               EQU         0x5C
DOORBELL                EQU         0x60
DOORBELL_SETUP          EQU         0x64
ROM_BYTE_WRITE          EQU         0x68
CAP_PTR_EXT             EQU         0x70
PWR_MGMT                EQU         0x74
PCI_RESET               EQU         0x7C
CHAN_1_BYTE_COUNT       EQU         0x80
CHAN_1_PCI_ADDR         EQU         0x84
CHAN_1_DRAM_ADDR        EQU         0x88
CHAN_1_DESC_PTR         EQU         0x8C
CHAN_1_CONTROL          EQU         0x90
DMA_INF_MODE            EQU         0x9C
CHAN_2_BYTE_COUNT       EQU         0xA0
CHAN_2_PCI_ADDR         EQU         0xA4
CHAN_2_DRAM_ADDR        EQU         0xA8
CHAN_2_DESC_PTR         EQU         0xAC
CHAN_2_CONTROL          EQU         0xB0
CSR_BASE_ADDR_MASK      EQU         0xF8
CSR_BASE_ADDR_OFF       EQU         0xFC
DRAM_BASE_ADDR_MASK     EQU         0x100
DRAM_BASE_ADDR_OFF      EQU         0x104
ROM_BASE_ADDR_MASK      EQU         0x108
DRAM_TIMING             EQU         0x10C
DRAM_ADDR_SIZE_0        EQU         0x110
DRAM_ADDR_SIZE_1        EQU         0x114
DRAM_ADDR_SIZE_2        EQU         0x118
DRAM_ADDR_SIZE_3        EQU         0x11C
I2O_IFH                 EQU         0x120
I2O_IPT                 EQU         0x124
I2O_OPH                 EQU         0x128
I2O_OFT                 EQU         0x12C
I2O_IFC                 EQU         0x130
I2O_OPC                 EQU         0x134
I2O_IPC                 EQU         0x138
SA_CONTROL              EQU         0x13C
PCI_ADDR_EXT            EQU         0x140
PREFETCH_RANGE          EQU         0x144
PCI_ABITOR_STATUS       EQU         0x148
DBELL_PCI_MASK          EQU         0x150
DBELL_SA_MASK           EQU         0x154
IRQ_STATUS              EQU         0x180 
IRQ_RAW_STATUS          EQU         0x184 
IRQ_ENABLE              EQU         0x188 
IRQ_ENABLE_SET          EQU         0x188 
IRQ_ENABLE_CLEAR        EQU         0x18C 
IRQ_SOFT                EQU         0x190 
FIQ_STATUS              EQU         0x280 
FIQ_RAW_STATUS          EQU         0x284 
FIQ_ENABLE              EQU         0x288 
FIQ_ENABLE_SET          EQU         0x288 
FIQ_ENABLE_CLEAR        EQU         0x28C 
FIQ_SOFT                EQU         0x290 
TIMER_1_LOAD            EQU         0x300 
TIMER_1_VALUE           EQU         0x304 
TIMER_1_CONTROL         EQU         0x308 
TIMER_1_CLEAR           EQU         0x30C 
TIMER_2_LOAD            EQU         0x320 
TIMER_2_VALUE           EQU         0x324 
TIMER_2_CONTROL         EQU         0x328 
TIMER_2_CLEAR           EQU         0x32C 
TIMER_3_LOAD            EQU         0x340 
TIMER_3_VALUE           EQU         0x344 
TIMER_3_CONTROL         EQU         0x348 
TIMER_3_CLEAR           EQU         0x34C 
TIMER_4_LOAD            EQU         0x360 
TIMER_4_VALUE           EQU         0x364 
TIMER_4_CONTROL         EQU         0x368 
TIMER_4_CLEAR           EQU         0x36C 

; ----------------------------
; PCI_RESET Register Constants
; ----------------------------

UENG0_RST               EQU         BIT0
UENG1_RST               EQU         BIT1
UENG2_RST               EQU         BIT2
UENG3_RST               EQU         BIT3
UENG4_RST               EQU         BIT4
UENG5_RST               EQU         BIT5
PCIRST_RST              EQU         BIT14
EXT_RST                 EQU         BIT15
FBI_RST                 EQU         BIT16
FXCMD_RST               EQU         BIT17
SDRAM_RST               EQU         BIT18
SRAM_RST                EQU         BIT29
PCI_RST                 EQU         BIT30
SACORE_RST              EQU         BIT31

; ------------------------------
; ARM control register constants
; ------------------------------
INIT_COMPLETE           EQU         BIT0
PCI_NRESET              EQU         BIT9
PCI_CFN                 EQU         BIT31
ROM_TIMING              EQU         0x0fff0000
ROM_SETUP               EQU         0x04aa0000
SA_CTL_COMPLETE         EQU         (INIT_COMPLETE | PCI_NRESET)

; ---------------
; Interrupt Flags
; ---------------
SOFT_INT                EQU         BIT1
TIMER1_INT              EQU         BIT4
TIMER2_INT              EQU         BIT5
TIMER3_INT              EQU         BIT6
TIMER4_INT              EQU         BIT7
DOORBELL_INT            EQU         BIT15
DMA1_INT                EQU         BIT16
DMA2_INT                EQU         BIT17
PCI_IRQ_L_INT           EQU         BIT18
DMA1_NOT_BUSY_INT       EQU         BIT20
DMA2_NOT_BUSY_INT       EQU         BIT21
START_BIST_INT          EQU         BIT22
SERR_INT                EQU         BIT23
SDRAM_PARITY_INT        EQU         BIT24
I2O_INPOST_INT          EQU         BIT25
DISCARD_TIMER_INT       EQU         BIT27
DATA_PARITY_INT         EQU         BIT28
PCI_MASTER_ABORT_INT    EQU         BIT29
PCI_TARGET_ABORT_INT    EQU         BIT30
PCI_PARITY_INT          EQU         BIT31

; -------------------------------
; Timer Control Register Constant
; -------------------------------
TIMER_ENABLE            EQU         BIT7
TIMER_MODE              EQU         BIT6

OS_TIMER                EQU         3

; the following timers vary depending on board rev, so,
;  if they ever get used, they must be made into variables
;  varying on IXP1200_SysCpuRev.
; IF :DEF: SA1200_A0
;mSEC_1                  EQU         (100000000 / 1000)
; ELSE
;mSEC_1                  EQU         (162200000 / 1000)
; ENDIF
;mSEC_5                  EQU         (mSEC_1 * 5)
;mSEC_10                 EQU         (mSEC_1 * 10)
;mSEC_100                EQU         (mSEC_1 * 100)
;SEC_1                   EQU         (mSEC_1 * 1000)

; --------------
; SRAM Registers
; --------------

SRAM_CSR                EQU         0x38000000
SRAM_SLOW_CONFIG        EQU         0x38000020
SRAM_BOOT_CONFIG        EQU         0x38000024
SRAM_SLOWPORT_CONFIG    EQU         0x38000028

; ------------------
; SRAM CSR constants
; ------------------

SRAM_CFT                EQU         BIT18
SRAM_MAC                EQU         BIT17
SRAM_FLWT               EQU         BIT16
SRAM_BKW                EQU         BIT15
SRAM_8MF                EQU         BIT14
SRAM_4MF                EQU         BIT13
SRAM_2MF                EQU         BIT12
SRAM_8MSR               EQU         BIT11
SRAM_4MSR               EQU         BIT10
SRAM_2MSR               EQU         BIT9 
SRAM_1MSR               EQU         BIT8
SRAM_RLAM               EQU         BIT4
SRAM_IRQ                EQU         BIT3
SRAM_FIQ                EQU         BIT2
SRAM_RLRS               EQU         BIT1
SRAM_RLS                EQU         BIT0

 IF :DEF: SA1200_A0
SRAM_CSR_VALUE          EQU         (SRAM_8MF + SRAM_8MSR)
SRAM_SLOW_CONFIG_VALUE  EQU         0x00000B0D
SRAM_BOOT_CONFIG_VALUE  EQU         0x090A0501
SRAM_SLOWPORT_CONFIG_V  EQU         0x0B0C0703
 ELSE
SRAM_CSR_VALUE          EQU         (SRAM_8MF + SRAM_8MSR)         
SRAM_SLOW_CONFIG_VALUE  EQU         0x0000184A
SRAM_SLOW_CONFIG_V_165  EQU         0x00001852
SRAM_BOOT_CONFIG_VALUE  EQU         0x18180400
SRAM_SLOWPORT_CONFIG_V  EQU         0x3E440C06
SRAM_SLOPORT_CFG_V_165  EQU         0x454B0E07
 ENDIF

; ---------------
; SDRAM Registers
; ---------------

SDRAM_CSR               EQU         0xFF000000
SDRAM_MEMCTL0           EQU         0xFF000004
SDRAM_MEMCTL1           EQU         0xFF000008
SDRAM_MEMINIT           EQU         0xFF00000C

; -------------------
; SDRAM CSR Constants
; -------------------

SDRAM_EN_FTST           EQU         BIT15
SDRAM_EN_INT            EQU         BIT10
SDRAM_EN_IRQ            EQU         BIT9
SDRAM_EN_FIQ            EQU         BIT8
SDRAM_EN_CPE            EQU         BIT6
SDRAM_EN_PCIPE          EQU         BIT5
SDRAM_EN_UEPE           EQU         BIT4
SDRAM_GENPAR            EQU         BIT3
SDRAM_EVENPAR           EQU         BIT2
SDRAM_TF_BENDN          EQU         BIT1
SDRAM_INIT              EQU         BIT0

 IF :DEF: SA1200_A0
SDRAM_CSR_VALUE         EQU         (SDRAM_INIT + SDRAM_EVENPAR)
SDRAM_MEMCTL0_VALUE     EQU         0x050082B9
SDRAM_MEMCTL1_VALUE     EQU         0x21282252
SDRAM_MEMINIT_VALUE     EQU         0x00000000
 ELSE
SDRAM_CSR_VALUE         EQU         0x00000001
SDRAM_MEMCTL0_VALUE_165 EQU         0x04F482C8
SDRAM_MEMCTL1_VALUE_165 EQU         0x12262252
SDRAM_MEMINIT_VALUE_165 EQU         0x00EF1FAF
SDRAM_MEMCTL0_VALUE     EQU         0x061A82C8
SDRAM_MEMCTL1_VALUE     EQU         0x12361141
SDRAM_MEMINIT_VALUE     EQU         0x00122710
 ENDIF

;define initial clock values
CCCR_INIT_VALUE_A       EQU          (PLL_A_CLK_162MHz)
CCCR_INIT_VALUE         EQU          (PLL_CLK_200MHz)
    
 ENDIF  ; __address_h

        END ; end of file
