/* sysInit.c
*
*------------------------------------------------------------
*                                                                      
*                  I N T E L   P R O P R I E T A R Y                   
*                                                                      
*     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
*     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
*     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
*     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
*     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
*     THE PRIOR WRITTEN PERMISSION OF :                                
*                                                                      
*                        INTEL  CORPORATION                            
*                                                                     
*                     2200 MISSION COLLEGE BLVD                        
*                                                                      
*               SANTA  CLARA,  CALIFORNIA  95052-8119                  
*                                                                      
*------------------------------------------------------------
* system: SA1200
* subsystem: uCOS
* author: Henry Qian 05/07/99
* revisions:
*
*/
#include <stdio.h>
#include "os.h"  /* uC/OS interface */
#include "udbg_cmd.h"
#include "uload_cmd.h"
#include "net_cmd.h"
extern "C" void rtos_unit_test_Friver_main(void);
extern "C" void ucosmacmain(void);
extern int main_scomm(int, char**);

int argcFromMain;
char** argvFromMain;


void sysInit(void)
{
    // Connect library functions to command line console
    //
    consoleConnect(udbg_cmd);
    consoleConnect(uload_cmd);
    // consoleConnect(net_cmd);

#ifdef MAC_DRIVER_TEST
    ucosmacmain();
#endif

#ifdef F_DRIVER_TEST
    rtos_unit_test_Friver_main();
#endif

#ifdef SCOMM_Test
    main_scomm(argcFromMain, argvFromMain);
#endif

}
extern "C" void NetApp_Init(void);

void NetApp_main(void)
{
	NetApp_Init();
	return;
}


int main(int argc, char** argv)
{
    argcFromMain = argc;
    argvFromMain = argv;

    /* Start uC/OS and run userInit in root task
     * with highest priority.  After userInit()
     * returns, root task commits suicide.
     */
#ifdef SCOMM
    ucosStart(NetApp_main, NO_CONSOLE);
#else
      ucosStart(sysInit, USE_CONSOLE);
#endif

    /* ucosStart() doesn't return. */
}


/* end of file */