/* udbg_cmd.h
 *
 *------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 * system: SA1200
 * subsystem: console
 * author: Henry Qian 05/07/99
 * revisions:
 *
 */
#ifndef UDBG_CMD_H
#define UDBG_CMD_H

#include "os.h"

extern ConsoleCommand udbg_cmd[];

#ifdef __cplusplus
extern "C" {
#endif

    // uDebug Library functions
    //
    void InitDebugLib(char*);
    void DeleteDebugLib(char*);
    void ResetUeng(char* param);
    void StartUeng(char* param);
    void PauseUeng(char* param);
    void ResumeUeng(char* param);
    void GetActiveUeng(char*);
    void SetUengPC(char* param);
    void GetUengPC(char* param);
    void SetUthdPC(char* param);
    void GetUthdPC(char* param);
    void SetUword(char* param);
    void GetUword(char* param);
    void SetNumUword(char* param);
    void GetNumUword(char* param);
    void SetBP(char* param);
    void ShowBP(char* param);
    void ClearBP(char* param);
    void ClearAllBP(char* param);
    void SetGPR(char* param);
    void GetGPR(char* param);
    void SetSRAM_WrXfer(char* param);
    void GetSRAM_WrXfer(char* param);
    void SetSRAM_RdXfer(char* param);
    void GetSRAM_RdXfer(char* param);
    void SetSDRAM_WrXfer(char* param);
    void GetSDRAM_WrXfer(char* param);
    void SetSDRAM_RdXfer(char* param);
    void GetSDRAM_RdXfer(char* param);
    void GetUengStatus(char* param);
    void HopUeng(char* param);
    void SetFree_uStore(char* param);
    void GetFree_uStore(char*);

    // Control thin layer functions
    //
    void Cntl_RegControl(char* param);
    void Cntl_RegInitUof(char* param);
    void Cntl_GiveControl(char* param);
    void Cntl_TakeControl(char* param);
    void Cntl_InitUof(char* param);
    void Cntl_Reset(char*param);
    void Cntl_Start(char*param);
    void Cntl_Pause(char*param);
    void Cntl_Resume(char*param);
    void Cntl_Hop(char*param);

#ifdef __cplusplus
}
#endif

#endif /* UDBG_CMD_H */

/* end of file, leave blank line at end */
