/* coprocessor.h
 *
 *
 * --------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------
 * system: SA1200
 * subsystem: uHAL 
 * author: Henry Qian 4/9/99
 * revisions:
 *
 */

#ifndef COPROC_H
#define COPROC_H

#ifdef __cplusplus
extern "C" {
#endif

    void SAr_EnableCache(void);
    void SAir_EnableICache(void);
    void SAir_EnableDCache(void);
    void SAir_EnableWriteBuffer(void);

    void SAr_DisableCache(void);
    void SAir_DisableICache(void);
    void SAir_DisableDCache(void);
    void SAir_DisableWriteBuffer(void);

    unsigned int SAr_ReadControlReg(void);
    void SAr_WriteControlReg(unsigned int);
    unsigned int SAr_ReadTTBase(void);
    void SAr_WriteTTBase(unsigned int);
    unsigned int SAr_ReadDomainControlReg(void);
    void SAr_WriteDomainControlReg(unsigned int);
    unsigned int SAr_ReadFaultStatuslReg(void);
    void SAr_WriteFaultStatusReg(unsigned int);
    unsigned int SAr_ReadFaultAddressReg(void);
    void SAr_WriteFaultAddressReg(unsigned int);
    void SAr_Flush_IC_DC(void);
    void SAr_Flush_ICache(void);
    void SAr_Flush_DCache(void);
    void SAr_FlushDCacheEntry(char*);
    void SAr_CleanDCacheEntry(char*);
    void SAr_DrainWriteBuffer(void);
    void SAr_Flush_ITB_DTB(void);
    void SAr_Flush_DTB(void);
    void SAr_Flush_DTB_Entry(void);
    void SAr_EnableClockSwitch(void);
    void SAr_DisableClockSwitch(void);
    void SAr_Disable_nMCLK(void);
    void SAr_WaitForInterrupt(void);

#ifdef __cplusplus
}
#endif


#endif /* COPROC_H */

/* end of file */
