; coprocessor.s
;
;------------------------------------------------------------
;                                                                      
;                  I N T E L   P R O P R I E T A R Y                   
;                                                                      
;     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;     THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                      
;                        INTEL  CORPORATION                            
;                                                                     
;                     2200 MISSION COLLEGE BLVD                        
;                                                                      
;               SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                      
;------------------------------------------------------------
; system: SA1200
; subsystem: uHAL
; author: Henry Qian 04/13/99
; revisions:
;

    INCLUDE	mmumacro.s

    AREA    uHAL_Cache, CODE, READONLY

; Routines to enable memory management with the following cache options:
;
;   no caches enabled
;   no caches with write buffering
;   Icache only
;   Icache only with write buffering
;   Dcache only
;   Dcache only with write buffering
;   I and Dcache 
;   I and Dcache with write buffering
;
; PLEASE NOTE: Dcache with no write buffering still uses the WB for copyback


; Read the mmu state from the Co-processor
    EXPORT SAr_ReadControlReg
SAr_ReadControlReg
	RDCP15_Control  a1
	MOV	pc, lr


; Write the mmu state to the Co-processor
    EXPORT SAr_WriteControlReg
SAr_WriteControlReg
	WRCP15_Control  a1
    NOP
    NOP
    NOP
	MOV	pc, lr


; Read Translation Table Base reg.
    EXPORT SAr_ReadTTBase
SAr_ReadTTBase
    RDCP15_TTBase   a1
	MOV	pc, lr


; Write Translation Table Base reg.
    EXPORT SAr_WriteTTBase
SAr_WriteTTBase
    WRCP15_TTBase   a1
	MOV	pc, lr


; Read Domain Access Control reg.
    EXPORT SAr_ReadDomainControlReg
SAr_ReadDomainControlReg
    RDCP15_DAControl    a1
	MOV	pc, lr


; Write Domain Access Control reg.
    EXPORT SAr_WriteDomainControlReg
SAr_WriteDomainControlReg
    WRCP15_DAControl    a1
	MOV	pc, lr



; Read Fault Status reg. 
    EXPORT SAr_ReadFaultStatuslReg
SAr_ReadFaultStatuslReg
    RDCP15_FaultStatus  a1
	MOV	pc, lr


; Write Fault Status reg.
    EXPORT SAr_WriteFaultStatusReg
SAr_WriteFaultStatusReg
    WRCP15_FaultStatus  a1
	MOV	pc, lr


; Read Fault Address reg. 
    EXPORT SAr_ReadFaultAddressReg
SAr_ReadFaultAddressReg
    RDCP15_FaultAddress a1
	MOV	pc, lr


; Write Fault Address reg.
    EXPORT SAr_WriteFaultAddressReg
SAr_WriteFaultAddressReg
    WRCP15_FaultAddress a1
	MOV	pc, lr


; Flush ICache + DCache
    EXPORT SAr_Flush_IC_DC
SAr_Flush_IC_DC
    WRCP15_FlushIC_DC   a1
	MOV	pc, lr


; Flush ICache
    EXPORT SAr_Flush_ICache
SAr_Flush_ICache
    WRCP15_FlushIC  a1
	MOV	pc, lr

; Flush DCache
    EXPORT SAr_Flush_DCache
SAr_Flush_DCache
    WRCP15_FlushDC  a1
	MOV	pc, lr


; Flush DCache entry
    EXPORT SAr_FlushDCacheEntry
SAr_FlushDCacheEntry
    WRCP15_CacheFlushDentry a1
	MOV	pc, lr


; Clean DCache entry
    EXPORT SAr_CleanDCacheEntry
SAr_CleanDCacheEntry
    WRCP15_CleanDCentry a1
	MOV	pc, lr

; Drain Write Buffer 
    EXPORT SAr_DrainWriteBuffer
SAr_DrainWriteBuffer
    WRCP15_DrainWriteBuffer a1
	MOV	pc, lr



; Flush ITB + DTB
    EXPORT SAr_Flush_ITB_DTB
SAr_Flush_ITB_DTB
    WRCP15_FlushITB_DTB a1
	MOV	pc, lr


; Flush ITB
    EXPORT SAr_Flush_ITB
SAr_Flush_ITB
    WRCP15_FlushITB a1
	MOV	pc, lr


; Flush DTB
    EXPORT SAr_Flush_DTB
SAr_Flush_DTB
    WRCP15_FlushDTB a1
	MOV	pc, lr


; Flush DTB entry
    EXPORT SAr_Flush_DTB_Entry
SAr_Flush_DTB_Entry
    WRCP15_FlushDTBentry    a1
	MOV	pc, lr


; Enable Clock Switching
    EXPORT SAr_EnableClockSwitch
SAr_EnableClockSwitch
    WRCP15_EnableClockSW    a1
	MOV	pc, lr


; Disable Clock Switching
    EXPORT SAr_DisableClockSwitch
SAr_DisableClockSwitch
    WRCP15_DisableClockSW   a1
	MOV	pc, lr


; Disable nMCLK output
    EXPORT SAr_Disable_nMCLK
SAr_Disable_nMCLK
    WRCP15_DisablenMCLK a1
	MOV	pc, lr


; Wait for Interrupt
    EXPORT SAr_WaitForInterrupt
SAr_WaitForInterrupt
    WRCP15_WaitInt  a1
	MOV	pc, lr



    END
