; except_h.s
;
;------------------------------------------------------------
;                                                                      
;                  I N T E L   P R O P R I E T A R Y                   
;                                                                      
;     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;     THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                      
;                        INTEL  CORPORATION                            
;                                                                     
;                     2200 MISSION COLLEGE BLVD                        
;                                                                      
;               SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                      
;------------------------------------------------------------
; system: SA1200
; subsystem: uHAL
; author: Henry Qian 04/08/99
; revisions:
;

NoIRQ		EQU	0x80		; Bit 7 of cspr
NoFIQ		EQU	0x40		; Bit 6 of cspr
NoInt		EQU	(NoIRQ | NoFIQ) ; Both

AllIRQs		EQU	0xFF		; Mask for interrupt controller

IrqV		EQU	0x18

ModeMask	EQU	0x1F		; /* Processor mode in CPSR */

SVC32Mode	EQU	0x13
IRQ32Mode	EQU	0x12
FIQ32Mode	EQU	0x11
User32Mode	EQU	0x10
Abort32Mode	EQU	0x17
Undef32Mode	EQU	0x1B

UserStackSize	EQU	0x4000
SVCStackSize	EQU	0x20000
IRQStackSize	EQU	0x2000
UndefStackSize	EQU	0x400
FIQStackSize	EQU	0x400
AbortStackSize	EQU	0x400

;/* SWIs known to uHAL */
SWI_EnterOS	EQU	0x16

;/* SWIs used by uHAL when running under DEMON */
SWI_WriteC	EQU	0x00
SWI_ReadC	EQU	0x04
SWI_Exit	EQU	0x11
SWI_Time	EQU	0x63

	END				; End of file
