/* platform.c
 *
 *
 * --------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------
 * system: SA1200
 * subsystem: uHAL 
 * author: Henry Qian 4/9/99
 * revisions:
 *
 */
#include "platform.h"
#include "timer.h"
#include "interrupts.h"
#include "uart.h"
#include "heap.h"
#include "pci.h"

#ifdef __cplusplus
extern "C" {
   void __cpp_initialise(void);
}
#endif

#ifdef __cplusplus
extern "C" {
#endif

    void SAir_PlatformInit(void);

#ifdef __cplusplus
}
#endif

/*
**  void SAir_PlatformInit(void)
**
**  DESCRIPTION
**      Platform specific system initialization.
**  
**  RETURNS
**      None.
*/
void SAir_PlatformInit(void)
{
    /* Initialize and disable all external and internal interrupts */
    /* SA_InitIRQ(); */
    /* SA_InitFIQ(); */

	/* reset the COM port */
	SAr_ResetPort(BAUD_19200);

    /* printf("Hello 111\n"); */

	/* build the devnode tree */
	/* SAr_BuildDevNodeTree(); */

	/* Initialize the timers */
	/* SAr_ResetTimers(); */

    /* Initialize memory heep for malloc() and free() */
    SAr_InitHeap();

    /* Scan all devices on PCI bus */
    /* SAr_BuildDevNodeTree(); */

#ifdef __cplusplus
    /* Statically declared class constructors
     * are called here, if there's any.
     */
    if (__cpp_initialise != 0)
        __cpp_initialise();
#endif
}

/* end of file */
