/* timer.h
 *
 *------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 * system: SA1200
 * subsystem: uHAL
 * author: Henry Qian 04/09/99
 * revisions:
 *
 */
#ifndef TIMER_H
#define TIMER_H

#include "interrupts.h"

#define TMR1        1
#define TMR2        2
#define TMR3        3
#define TMR4        4
#define MAX_TIMER   4

#define T_FREE      0
#define T_ONESHOT   1
#define T_INTERVAL  2

/* Pointer to function with no arguments returning void */
typedef void (*PFV)(void);

typedef struct {
	unsigned int type;
    unsigned int tickUnitTime;
    unsigned int ticks;
    unsigned int ticksleft;
    unsigned int expire;
    PFV handler;    /* User Routine */
} SAis_Timer;


#ifdef __cplusplus
extern "C" {
#endif

    void SAr_ResetTimers(void);
    int SAr_InitTimer(  unsigned int timer,
                        unsigned int type,
                        unsigned int tickUnitTime,
                        unsigned int ticks,
                        PFV handler);
    int SAr_StartTimer(unsigned int timer);
    int SAr_StopTimer(unsigned int timer);
    int SAr_SetTimerTicks(unsigned int timer, unsigned int ticks);
    int SAr_GetTimerTicksLeft(unsigned int timer, unsigned int* ticks);

#ifdef __cplusplus
}
#endif


#endif // TIMER_H

/* end of file */
