/* uart.h
 *
 *------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 * system: SA1200
 * subsystem: uHAL
 * author: Henry Qian 04/09/99
 * revisions:
 *
 */
#ifndef UART_H
#define UART_H

#include <stdarg.h>

#ifdef __cplusplus
extern "C" {
#endif

    void SAr_ResetPort(unsigned int baud);
    void SAr_putchar(unsigned char ch);
    unsigned int SAr_getchar(void);
    unsigned int SAr_GetStatus(void);
    void SAr_PutString(char *string);
    int _printf(const char* format, ...);
    int vsprintf(char* buffer, const char *fmt0, va_list ap);
    char* gets(char* buf);

#ifdef __cplusplus
}
#endif

#endif /* UART_H */

/* end of file */

