/* rs_udbg_status.h
 * Remote Services Debug Library - Return status definitions
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Eric Walker
 * revisions:
 * $History: rs_udbg_status.h $
 * 
 * *****************  Version 3  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:45
 * Updated in $/dev_1200/Include
 * Add copyright or make consistent
 * 
 */ 

#ifndef RS_UDBG_STATUS_H
#define RS_UDBG_STATUS_H

enum rs_status {
	RS_SUCCESS=0x0,         /* call succeeded */
	RS_BADPARAM=0x8600,		/* bad parameter */
	RS_VERSMISMATCH,	    /* rpc versions not compatible */
	RS_PROGUNAVAIL,         /* program not available */
	RS_PROGVERSMISMATCH,    /* program version mismatched */
	RS_PROCUNAVAIL,         /* procedure unavailable */
	RS_SYSTEMERROR,         /* generic "other problem" */
    RS_NOMEMORY,            /* memeory not available */
    RS_UDPCANTREGPROG,      /* can't register with UDP */
    RS_TCPCANTREGPROG,      /* can't register with TCP */
	RS_UNKNOWNSERVER,       /* unknown remote name */
	RS_UNKNOWNPROTO,        /* unkown protocol */
	RS_TIMEOUT,				/* time out */
	RS_ERROR};

#endif  /* RS_UDBG_STATUS_H */