/* utl_crc.h
 * CRC checksum utility
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Linker/Loader utility
 *  author: drj Dec 31, 97  Initial version
 *  revisions:
 *  $History: utl_crc.h $
 * 
 * *****************  Version 5  *****************
 * User: Drjohns1     Date: 11/29/99   Time: 9:48a
 * Updated in $/dev_1200/Include
 * 
 * *****************  Version 2  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:20p
 * Updated in $/development/common
 * update COPYRIGHT
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 3/05/99    Time: 9:06p
 * Created in $/users/Johnson/SA1200/scomm
 * 
 * *****************  Version 5  *****************
 * User: Drjohns1     Date: 5/21/98    Time: 2:20p
 * Updated in $/base_level2/ucld
 * Updated copyright header
 * 
 * *****************  Version 4  *****************
 * User: Johnsondes   Date: 4/13/98    Time: 5:27p
 * Updated in $/base_level2/ucld
 * Encapsulated the UOF objects into seperate chunk
 * 
 * *****************  Version 3  *****************
 * User: Johnsondes   Date: 1/22/98    Time: 2:18p
 * Updated in $/base_level1/ucld/src
 * Changed "Apps" to "Image" and "Func" to "label'
 *
 * ---------------------------------------------------------------------
 */
#ifndef __UTL_CRC_H__
#define __UTL_CRC_H__

#include <stdio.h>

#ifdef __cplusplus
extern "C"{
#endif

unsigned int Crc_Calc(unsigned int reg, int ch);
unsigned int Crc_FileChecksum(FILE *fp);
unsigned int Crc_StrChecksum(char *charPtr, int numChar);
unsigned int Crc_FposChecksum(FILE *fp, unsigned int nBytes);

#ifdef __cplusplus
}
#endif

#endif	/* __UTL_CRC_H__ */
