//////////////////////////////////////////////////////////////////////////////
//           INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//      Copyright (c) 1999-2000 Intel Corporation.  All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// $Source: /mnt/bigpine/src/FE/FEAPI/IXP1200/MicroCode/src/Attic/Sv_Lock.uc,v $
// $Revision: 1 $
// $Date: 4/18/00 5:06p $
//
// Description:
//    This file contains two service routines that implement the
//    sram [read_lock] and sram [write_unlock] commands.  It is
//    intended that these be called as PendedCallouts from the core
//    so that the core can block if the read_lock blocks.
//
// Entry Points:
//   LockSv_ReadLock
//   LockSv_WriteUnlock

//////////////////////////////////////////////////////////////////////////////
// Routine: LockSv_ReadLockImp()
//
// Parameters:
//    addr, $xfer1   - The address in SRAM to lock
//
// Description:
//    Performs an sram[read_lock] on the given address in SRAM
//
// Returns:
//    The value read from the lock
//
// Register usage:
//    $xfer1 - per the standard service thread utilities, this is used
//             for both input and output
// Comments:
//
LockSv_ReadLockImp#:
    sram[read_lock, $xfer1, $xfer1, 0, 1], ctx_swap
	br[Sv_Return#]


//////////////////////////////////////////////////////////////////////////////
// Routine: LockSv_WriteUnlockImp()
//
// Parameters:
//    addr, $xfer1   - the address to unlock
//    value, $xfer2  - the value to write into the lock
// Description:
//
// Returns:
//
// Register usage:
//
// Comments:
//
LockSv_WriteUnlockImp#:
    sram[write_unlock, $xfer2, $xfer1, 0, 1], ctx_swap
    br[Sv_Return#]
