;------------------------------------------------------------------------------------
;                                                                      
;                   I N T E L   P R O P R I E T A R Y                   
;                                                                       
;      COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;      THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                       
;                         INTEL  CORPORATION                            
;                                                                      
;                      2200 MISSION COLLEGE BLVD                        
;                                                                       
;                SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                       
;------------------------------------------------------------------------------------

/*
$History: bit_swiz.uc $
 * 
 * *****************  Version 21  *****************
 * User: Shih         Date: 10/04/00   Time: 10:58a
 * Updated in $/dev_1200/MicroCode/examples
 * change version to V1.2.76
 * 
 * *****************  Version 20  *****************
 * User: Tclancyx     Date: 6/13/00    Time: 10:30a
 * Updated in $/dev_1200/MicroCode/examples
 * change version to 1.1.76
 * 
 * *****************  Version 16  *****************
 * User: Qabuild      Date: 7/19/99    Time: 3:12p
 * Updated in $/dev_1200/MicroCode/examples
 * add ctx_arb[voluntary] so WorkBench play better on hardware
 * 
 * *****************  Version 15  *****************
 * User: Rparen1x     Date: 6/22/99    Time: 10:17a
 * Updated in $/dev_1200/MicroCode/examples
 * 
 * *****************  Version 13  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:24p
 * Updated in $/development/ucode/examples
 * update COPYRIGHT
 * 
 * *****************  Version 12  *****************
 * User: Rparen1x     Date: 12/24/98   Time: 5:27p
 * Updated in $/development/ucode/examples
 * Updated to BL5
 * 
 * *****************  Version 11  *****************
 * User: Rshukla1     Date: 5/21/98    Time: 5:43p
 * Updated in $/base_level2/ucode/examples
 * The .import is removed. Keep it simple.
 * 
 * *****************  Version 10  *****************
 * User: Rshukla1     Date: 5/20/98    Time: 4:05p
 * Updated in $/base_level2/ucode/examples
 * Intel Copyright notice Added and Digital Copyright Notice deleted
 * 
 * *****************  Version 9  *****************
 * User: Rparent      Date: 5/12/98    Time: 3:42p
 * Updated in $/base_level2/ucode/examples
 * Another test check-in
 * 
 * *****************  Version 8  *****************
 * User: Rparent      Date: 5/12/98    Time: 3:26p
 * Updated in $/base_level2/ucode/examples
*/
;----------------------------------------------------------------------
; bit_swiz.uc 
; Version = 1.2.76
; reverse the order of bits in each byte of a longword
;
;
; system: SA1200
; subsystem: bridge utility microcode
; usage: example
; author: dfh 9/23/97
; revisions:
;
; ---------------------------SA1200 microcode--------------------------	
;
; Prerequisite Register Usage:
;	symbol
;   addr_lw		- longword containing address bits to be reversed
;
; Description:
;   For bridges converting between (802.3 or 802.4) and (802.5 or FDDI)
;   the bits of the 48 bit LAN address must be reversed on a per byte basis 
;	Thus bit 7 goes to bit 0, 6 to 1, 5 to 2, ...., 0 to 7.
;   This ucode performs the bit swizzle for a longword. 
;	It can be repeated 3 times for the full SA and DA
;
bit_swiz_begin#:
	immed_w1[mask, 0x0101]
	immed_w0[mask, 0x0101]								; mask starts at bit 0
	alu[temp, addr_lw, AND, mask]						;select bit 0 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, <<rot7]	;insert bit 0 to bit 7
	alu_shf[temp, addr_lw, AND, mask, <<rot1]			;select bit 1 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, <<rot5]	;insert bit 1 to bit 6
	alu_shf[temp, addr_lw, AND, mask, <<rot2]			;select bit 2 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, <<rot3]	;insert bit 2 to bit 5
	alu_shf[temp, addr_lw, AND, mask, <<rot3]			;select bit 3 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, <<rot1]	;insert bit 3 to bit 4
	alu_shf[temp, addr_lw, AND, mask, <<rot4]			;select bit 4 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, >>rot1]	;insert bit 4 to bit 3
	alu_shf[temp, addr_lw, AND, mask, <<rot5]			;select bit 5 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, >>rot3]	;insert bit 5 to bit 2
	alu_shf[temp, addr_lw, AND, mask, <<rot6]			;select bit 6 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, >>rot5]	;insert bit 6 to bit 1
	alu_shf[temp, addr_lw, AND, mask, <<rot7]			;select bit 7 of each byte
	alu_shf[swizzled_lw, swizzled_lw, OR, temp, >>rot7]	;insert bit 7 to bit 0

done#:	
	ctx_arb[voluntary]
        alu[--, 0, B, iterate]		; interactively set this to >0 to iterate
	br>0[bit_swiz_begin#]
; else 
	br[done#]

