;------------------------------------------------------------------------------------
;                                                                      
;                   I N T E L   P R O P R I E T A R Y                   
;                                                                       
;      COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;      THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                       
;                         INTEL  CORPORATION                            
;                                                                      
;                      2200 MISSION COLLEGE BLVD                        
;                                                                       
;                SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                       
;------------------------------------------------------------------------------------
; lwalign.uc
; Version = 1.2.76
; align longwords from memory into general purpose registers
;
;
; system: SA1200
; subsystem: microcode
; usage: example
; author: dfh 6/23/97
; revisions:
;	dfh 1/29/97	dbl_shf now requires shift right
;
; ---------------------------SA1200 microcode--------------------------
;
; Prerequisite Register Usage:
;	symbol
;   address	- memory address containing byte alignemnt
;	$unaligned1	- $unaligned3 hold 2 longwords that are unaligned 
;
; +-----------+-----------+-----------+
; |$unaligned1|$unaligned2|$unaligned3|
; +-----------+-----------+-----------+
;					 |
;					 v
;    +-----------+-----------+
;    |  aligned1 |  aligned2 |			address<1:0>= 3
;    +-----------+-----------+
;
;       +-----------+-----------+
;       |  aligned1 |  aligned2 |		address<1:0> = 2
;       +-----------+-----------+
;
;          +-----------+-----------+
;          |  aligned1 |  aligned2 |	address<1:0> = 1
;          +-----------+-----------+
;
;             +-----------+-----------+
;             |  aligned1 |  aligned2 |	address<1:0> = 0
;             +-----------+-----------+

; Description:
;   the dbl_shf operation is used read 2 source longwords at a time, shift them right
;   and load the resulting righthand longword in to a result register
;
;   in this example, you have read $unaligned1-$unaligned3 from memory and need to extract
;   the two longwords aligned

	alu_shf[shift, 0x1F, AND, address, <<3]		; convert address<1:0> 1,2,or3 to 8,16,or24
	alu[temp, shift, B, $$unaligned1]			; temp = left longword, shift sets up indirect
	dbl_shf[aligned1, temp, $unaligned2, >>indirect]	; first longword result
	alu[temp, shift, B, $unaligned2]
	dbl_shf[aligned2, temp, $unaligned3, >>indirect]	; second longword result

; transactor - kill cycles
  end#:
	nop
	ctx_arb[voluntary]
	br[end#]


