;------------------------------------------------------------------------------------
;                                                                      
;                   I N T E L   P R O P R I E T A R Y                   
;                                                                       
;      COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
;      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
;      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
;      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
;      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
;      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
;      THE PRIOR WRITTEN PERMISSION OF :                                
;                                                                       
;                         INTEL  CORPORATION                            
;                                                                      
;                      2200 MISSION COLLEGE BLVD                        
;                                                                       
;                SANTA  CLARA,  CALIFORNIA  95052-8119                  
;                                                                       
;------------------------------------------------------------------------------------
; swap.uc
; Version = 1.2.76
; longword endian swap
;
;
; system: SA1200
; subsystem: utility microcode
; usage: example
; author: dfh 6/19/97
; revisions:
;
; ---------------------------SA1200 microcode--------------------------
;
; Prerequisite Register Usage:
; Rbuf = ABCD 	where A, B, C, D are bytes
;
alu_shf[Rswap, 0, B, Rbuf, <<rot8]		; Rswap = BCDA
ld_field[Rswap, 1010, Rbuf, <<rot24]	; rot DABC insert DxBx
;
; result Rswap = DCBA

; transactor - consume cycles
done#:	
	ctx_arb[voluntary]
  	br[done#]


; ARM comparable code
; R0 = A, B, C, D
; EOR	R1, R0, R0, ROR #16		; R1 = A^C, B^D, C^A, D^B
; BIC	R1, R1, $0xff0000			; R1 = A^C, 0, C^A, D^B
; MOV	R0, R0, ROR #8			; R0 = D, A, B, C
; EOR	R0, R0, R1, LSR #8		; R0 = D, C, B, A


	
