// ports_evalcard1.h
// port speeds for the first IXP1200 early Eval Cards 

//	MAC 0 is 21440 Octal Port 100Mbit MAC
//	MAC 1 is IXF1002 Dual port Gigabit MAC

// FAST_PORT2 must be defined in order to run both gigabit ports


// for IXP1200 evaluation boards, slow ports are placed in the low end macs

// this defines the ranges for slow and fast ports
#define SLOW_PORT_LO 0
#define SLOW_PORT_HI 7
#define FAST_PORT_LO 8
#define FAST_PORT_HI 9


#ifdef FAST_PORT2						; if running two gigabit ports 
	#define RDYBUS_PROG1 0x000000d6		; tx rdy mac 1 == d6. flow control == 0x00
	#define RDYBUS_PROG2 0x00000000
	#define RDYBUS_PROG3 0x00000000
#else									; running 8 10/100 + 1 gigabit port
	#define RDYBUS_PROG1 0x00fb0000		; rx rdy mac 0 == 0xfb. flow control == 0x00
	#define RDYBUS_PROG2 0x00d70000		; tx rdy mac 0 and 1 == 0xd7, flow control (executes faster than nop)
	#define RDYBUS_PROG3 0x00000000		; flow control (executes faster than nop)
#endif
