// xmit_fill_8x100.uc
//		3 tx_fill threads, 8 ports x 100Mbit
//		used on 2 microengines
//		1 microengine takes even tfifo elements, the other takes odd tfifo elements
//		each element is statically bound to a port.

//		each microengine: define personality  ODD or not ODD
//
		
tx_fill#:
#define_eval THREAD0 FID*4
#define_eval THREAD1 FID*4+1
#define_eval THREAD2 FID*4+2
#define_eval THREAD3 FID*4+3
#define EOP_AND_SOP 3
#define PORT_INFO_SOP_BIT 18
#define PASS 0
#define FAIL 1
#define TOP_BUF_BYTE_OFFSET 0

.local pwp_addr tfifo_entry port bank_mask bank queue_descriptor_base pkt_buffer_base buf_descriptor_base const_0 const_3f bit15on bit20on port_info head_ptr tail_ptr ele_remaining buf_offset last_mpkt_byte_cnt prev_entry $queue_descriptor0 $queue_descriptor1 $packet_link0 $packet_link1 $tfifo_ctl_wd0 $tfifo_ctl_wd1 queue_offset return_status bit20_15on skip_bit_on


//-------------------------------end macros----------------------------------------

.xfer_order $queue_descriptor0 $queue_descriptor1 $packet_link0 $packet_link1 $tfifo_ctl_wd0 $tfifo_ctl_wd1


StartUp#:
	tx_100m_fill_init[queue_descriptor_base, pkt_buffer_base, buf_descriptor_base,	
				$tfifo_ctl_wd1, bank_mask, @port0_in_prog, @port1_in_prog, 
				@port2_in_prog, @port3_in_prog, @port4_in_prog, @port5_in_prog, 
				@port6_in_prog, @port7_in_prog, pwp_addr, const_0, skip_bit_on, 
				const_3f, bit15on, bit20on, bit20_15on, SRAM_QUEUE_DESCRIPTOR_BASE, 
				SDRAM_PKT_BUFFER_BASE, SRAM_BUFF_DESCRIPTOR_BASE, 
				XMIT_PWP_VECTOR, SKIP_BIT_SET, THREAD1]


.while(1)					; loop forever

.local skip_flag

	br=ctx[2, read2#]		; read the next assignment for this thread
	br=ctx[3, read3#]
read1#:	
	sem_flip[@assign1]		; We finished the last assignment	
	tx_assignment_read[queue_offset, port, skip_flag, tfifo_entry, @assign1, 
						const_0, skip_bit_on, PORT_TO_TFIFO_MULT]
	br[process_assignment#]
read2#:
	sem_flip[@assign2]		; We finished the last assignment			
	tx_assignment_read[queue_offset, port, skip_flag, tfifo_entry, @assign2, 
						const_0, skip_bit_on, PORT_TO_TFIFO_MULT]
	br[process_assignment#]
read3#:
	sem_flip[@assign3]		; We finished the last assignment			
	tx_assignment_read[queue_offset, port, skip_flag, tfifo_entry, @assign3, 
						const_0, skip_bit_on, PORT_TO_TFIFO_MULT]

process_assignment#:


	.if (skip_flag != SKIP_BIT_SET)
		tx_portinfo_restore[port_info, ele_remaining, buf_offset, bank, last_mpkt_byte_cnt,	TOP_BUF_BYTE_OFFSET,
			base_buf_offset, bank_mask, port, const_3f, @port0_in_prog, @port1_in_prog, 
			@port2_in_prog, @port3_in_prog, @port4_in_prog, @port5_in_prog, 
			@port6_in_prog, @port7_in_prog, @port0_buf_addr, @port1_buf_addr, @port2_buf_addr,
			@port3_buf_addr, @port4_buf_addr, @port5_buf_addr, @port6_buf_addr,
			@port7_buf_addr, PORT_TO_TFIFO_MULT]

.endlocal ; skip_flag

		// Check for special case.  The last mpacket for this port could have been a  
		// SOP mpacket that wasn't transmitted because the MAC was not ready.
		.if (!(port_info & (1<<PORT_INFO_SOP_BIT)))

			// Check to see if we are in the middle of outputting a packet, or if we
			// are to start a new packet
			.if (ele_remaining == 0)								; if no elements left in last packet
				tx_packetlinklist_read[$queue_descriptor0, $queue_descriptor1, head_ptr, $packet_link0, 
					$packet_link1, tail_ptr, ele_remaining, bank, buf_offset, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET,
					queue_descriptor_base, queue_offset, buf_descriptor_base, bank_mask, const_3f]
				tx_packetlinklist_update[$queue_descriptor0, $queue_descriptor1, queue_descriptor_base, 
					tail_ptr, queue_offset, $packet_link0, port]				; update linked list
				.if (ele_remaining == 1)						; if sop and eop
					tx_last_mpkt_xfr[bank, buf_offset, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET,
						tfifo_entry, bit20on, bit20_15on, pkt_buffer_base, 
						SDRAM_VALIDATE]
					ctx_arb[voluntary]
					tx_status_set[$tfifo_ctl_wd0, last_mpkt_byte_cnt, EOP_AND_SOP, port]	
					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, 
						PORT_TO_TFIFO_MULT, SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS) 	;if good validate
						tx_ll_buf_free[$queue_descriptor0, bit20on, bank, buf_descriptor_base, 16]
					.else 							;could not validate 
						tx_portinfo_sop_save[@port0_in_prog, @port1_in_prog, @port2_in_prog, 
							@port3_in_prog, @port4_in_prog, @port5_in_prog, @port6_in_prog, 
							@port7_in_prog, @port0_buf_addr, @port1_buf_addr, @port2_buf_addr,
							@port3_buf_addr, @port4_buf_addr, @port5_buf_addr, @port6_buf_addr,
							@port7_buf_addr, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET, 
							ele_remaining, bank, buf_offset, port, PORT_INFO_SOP_BIT, PORT_TO_TFIFO_MULT] 
						tx_portvect_modify[@local_pwp, port, 1] ; set bit number "port"
					.endif							; could not validate
				.else								; sop, but not eop
					tx_portvect_modify[@local_pwp, port, 1] ; set bit number "port"
					// If not EOP then send data, save port info, and increment 
					// mpackets cnt for next mpacket
					tx_mpkt_xfr[TOP_BUF_BYTE_OFFSET, bank, buf_offset, tfifo_entry, 
						bit20_15on, bit20on, pkt_buffer_base, 8]	; make 8x8 byte xfers = 64 bytes
					tx_status_set[$tfifo_ctl_wd0, const_0, 0xfd, port]

					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, 
						PORT_TO_TFIFO_MULT, SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS) 	;if good validate
						tx_portinfo_save[@port0_in_prog, @port1_in_prog, @port2_in_prog, 
							@port3_in_prog, @port4_in_prog, @port5_in_prog, @port6_in_prog, 
							@port7_in_prog, @port0_buf_addr, @port1_buf_addr, @port2_buf_addr,
							@port3_buf_addr, @port4_buf_addr, @port5_buf_addr, @port6_buf_addr,
							@port7_buf_addr, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET,
							ele_remaining, bank, buf_offset, port, PORT_TO_TFIFO_MULT] 
					.else 							;could not validate 
						tx_portinfo_save_no_decr[@port0_in_prog, @port1_in_prog, 
							@port2_in_prog, @port3_in_prog, @port4_in_prog, @port5_in_prog, 
							@port6_in_prog, @port7_in_prog, @port0_buf_addr, @port1_buf_addr, 
							@port2_buf_addr, @port3_buf_addr, @port4_buf_addr, @port5_buf_addr, 
							@port6_buf_addr, @port7_buf_addr, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET, 
							ele_remaining, bank, buf_offset, port, PORT_INFO_SOP_BIT] 
					.endif							; could not validate

				.endif							; ele_remaining == 1
			.else								; not sop						
				ctx_arb[voluntary]
				.if(ele_remaining == 1)			; if NOT SOP, but EOP
					tx_last_mpkt_xfr[bank, buf_offset, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET,
						tfifo_entry, bit20on, bit20_15on, pkt_buffer_base,
						SDRAM_VALIDATE]
					tx_status_set[$tfifo_ctl_wd0, last_mpkt_byte_cnt, 0x2, port] 
					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, 
						PORT_TO_TFIFO_MULT, SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS) 	;if good validate
						tx_ll_buf_free[base_buf_offset, bit20on, bank, buf_descriptor_base, 0]
						tx_portinfo_update[@port0_in_prog, @port1_in_prog, @port2_in_prog, 
							@port3_in_prog, @port4_in_prog, @port5_in_prog, @port6_in_prog, 
							@port7_in_prog, port_info, port, PORT_TO_TFIFO_MULT, PORT_INFO_SOP_BIT]	
						//clear local pwp bit for this port
						tx_portvect_modify[@local_pwp, port, 0] ; clear bit number "port"
					.endif							; could not validate

				.else											; NOT SOP and NOT EOP
					tx_mpkt_xfr[TOP_BUF_BYTE_OFFSET, bank, buf_offset, tfifo_entry, 
						bit20_15on, bit20on, pkt_buffer_base, 8] ; make 8x8byte xfers = 64 bytes
					tx_status_set[$tfifo_ctl_wd0, const_0, 0xfc, port] ;no eop, no sop
					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, 
						PORT_TO_TFIFO_MULT, SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS) 	;if good validate
						tx_portinfo_update[@port0_in_prog, @port1_in_prog, @port2_in_prog, 
							@port3_in_prog, @port4_in_prog, @port5_in_prog, @port6_in_prog, 
							@port7_in_prog, port_info, port, PORT_TO_TFIFO_MULT, PORT_INFO_SOP_BIT]	
					.endif
				.endif	; ele_remaining == 1 (EOP)
			.endif		; ele_remaining == 0 (SOP)
		.else 			; port_info[25] = 1

			// SPECIAL CASE - PORT WAS NOT READY 
			// The data is already in the TFIFO from our last attempt to xmit this SOP mpacket
			// so we do not xfer it to the TFIFO again.  If the xmit design changes, and 
			// 10/100 ports are not mapped directly to TFIFO elements, then the following 
			// code should change to transfer the data to the TFIFO.
			.if (ele_remaining == 1)						; if sop and eop
				#if (SDRAM_VALIDATE == 1)		; if dual validate then we need dram signal sent to tfifo
					tx_last_mpkt_xfr[bank, buf_offset, last_mpkt_byte_cnt, TOP_BUF_BYTE_OFFSET, tfifo_entry, bit20on, bit20_15on, pkt_buffer_base, SDRAM_VALIDATE]
				#endif
				ctx_arb[voluntary]
				tx_status_set[$tfifo_ctl_wd0, last_mpkt_byte_cnt, EOP_AND_SOP, port]
				.local out_return_status
					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, PORT_TO_TFIFO_MULT, 
						SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS) ;if good validate
						tx_ll_buf_free[base_buf_offset, bit20on, bank, buf_descriptor_base, 0]
						tx_portinfo_update[@port0_in_prog, @port1_in_prog, @port2_in_prog, @port3_in_prog, 
							@port4_in_prog, @port5_in_prog, @port6_in_prog, @port7_in_prog, 
							port_info, port, PORT_TO_TFIFO_MULT, PORT_INFO_SOP_BIT]	
						tx_portvect_modify[@local_pwp, port, 0] ; clear bit number "port"
					.endif
				.endlocal
			.else												; sop, but not eop
				//set local pwp for this port
				// If not EOP then send data, save port info, and increment 
				// mpackets cnt for next mpacket
				#if (SDRAM_VALIDATE == 1)		; if dual validate then we need dram signal sent to tfifo
					tx_mpkt_xfr[TOP_BUF_BYTE_OFFSET, bank, buf_offset, tfifo_entry, bit20_15on, bit20on, pkt_buffer_base, 1]
				#endif
				tx_status_set[$tfifo_ctl_wd0, const_0, 0xfd, port]
				.local out_return_status
					tfifo_100m_validate[return_status, tfifo_entry, $tfifo_ctl_wd0, bit15on, 
						PORT_TO_TFIFO_MULT, SDRAM_VALIDATE, THREAD1, THREAD2, THREAD3, PASS, FAIL]
					.if (return_status == PASS)
							tx_portinfo_update[@port0_in_prog, @port1_in_prog, @port2_in_prog, 
								@port3_in_prog, @port4_in_prog, @port5_in_prog, @port6_in_prog, 
								@port7_in_prog, port_info, port, PORT_TO_TFIFO_MULT, PORT_INFO_SOP_BIT]		
					.endif
				.endlocal
			.endif							; ele_remaining == 1

		.endif			; port_info[25] == 1 (try to xmit sop mpacket again)


transmit_done#:

	.else	; we were given a "skip tfifo element" assignment
		tfifo_element_skip_nordy[tfifo_entry,  pkt_buffer_base, bit15on, 
						SDRAM_VALIDATE, FID, THREAD1, THREAD2, THREAD3]
	.endif			; skip_flag != SKIP_BIT_SET
.endw	
nop					; bug fix.  last instruction might not get downloaded by loader
.endlocal
