// context assignments, ports and next threads
#if (UENGINE_ID == 0)
	#define PORT_NUMS 8,8,8,8
	#define NEXT_CTX0_TID 4
	#define NEXT_CTX1_TID 5
	#define NEXT_CTX2_TID 6
	#define NEXT_CTX3_TID 7
#elif (UENGINE_ID == 1)
	#define PORT_NUMS 8,8,8,8
	#define NEXT_CTX0_TID 1
	#define NEXT_CTX1_TID 2
	#define NEXT_CTX2_TID 3
	#define NEXT_CTX3_TID 0
#elif (UENGINE_ID == 2)
	#define PORT_NUMS 8,8,8,8
	#define NEXT_CTX0_TID 12
	#define NEXT_CTX1_TID 13
	#define NEXT_CTX2_TID 14
	#define NEXT_CTX3_TID 15
#elif (UENGINE_ID == 3)
	#define PORT_NUMS 8,8,8,8
	#define NEXT_CTX0_TID 9
	#define NEXT_CTX1_TID 10
	#define NEXT_CTX2_TID 11
	#define NEXT_CTX3_TID 8
#endif


#define CORE_STACK_INTF1 18					// output interface for queueing to core


// packet buffers
#define DESC_SIZE 4						// size of descriptor
#define PKBUF_SIZE 256					// quadword size of packet buffer

// even receive microengines use freelist 0 and low sdram bank
#if ((UENGINE_ID & 1) == 0)
	#define FREELIST_ID 0
	#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
#else
	#ifdef ALT_BANKS
// odd receive microengines use freelist 1 and high sdram bank
		#define FREELIST_ID 1
		#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_HIGH_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
	#else
		#define FREELIST_ID 0
		#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
	#endif
#endif

// define Q handles for the 2 fast port queues
#define Q_HANDLE_LO Q_CIRCULAR_8, XMIT_FPORT1_ELE_COUNT, SRAM_QUEUE_DESCRIPTOR_BASE, XMIT_FPORT_DESCRIPTOR_BASE
#define Q_HANDLE_HI Q_CIRCULAR_8, XMIT_FPORT2_ELE_COUNT, SRAM_QUEUE_DESCRIPTOR_BASE, XMIT_FPORT_DESCRIPTOR_BASE_2


