/* GigChipRg.h
 * 
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS         
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: GigMacDriver
 * author: sk, Jan 99 Initial version
 * $History: GigChipRg.h $
 * 
 * *****************  Version 12  *****************
 * User: Dmwhite      Date: 12/15/00   Time: 8:36a
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * change ID of EC gig chip
 * 
 * *****************  Version 11  *****************
 * User: Dmwhite      Date: 12/13/00   Time: 11:03a
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * added multipacket feature
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 8/04/99    Time: 4:53p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * Corrected the types for the fuctions to work with the regs
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 7/16/99    Time: 2:44p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 4/28/99    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * FIRST VERSION OF THE DRIVER 
 * lightly tested on NT 
 
 * ---------------------------------------------------------------------
 */

//  chip:
//  1. Identification and revision number register --- port 0 only

#ifndef GIG_MAC_CHIP_REGS
#define GIG_MAC_CHIP_REGS

class GigMacChipRegs{
public:

	GigMacChipRegs(GigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "GigMacChipRegs CTOR" << endl;
	};

	~GigMacChipRegs(){};

	inline unsigned short GetIdentificationRevision()const { return IdentificationRevisionF();};

	inline unsigned int GetIdentificationRevisionMRID()const { return ( IdentificationRevisionF() >> MRID_SH) & MRID_MSK;};
	inline unsigned int GetIdentificationRevisionSRID()const { return ( IdentificationRevisionF() >> SRID_SH) & SRID_MSK;};
	inline unsigned int GetIdentificationRevisionDID()const { return ( IdentificationRevisionF() >> DID_SH) & DID_MSK;};

private:

	inline unsigned int IdentificationRevisionF()const {return _ControlRegs.GetIdentificationRevision();};

/*
Identification and Revision Register
Mnemonic: ID_REV
Address: 06H - 07H

The identification and revision register is valid only in port 0.

Bit		Name Bit	# Bit Description
MRID	15:12		Main revision ID. This number is incremented for subsequent 82547EB revisions.
SRID	11:8		Sub revision ID. This number is incremented for subsequent 82547EB steps within the
					current revision.
DID		7:0			Device ID.

Access Rules Register access R
Value after reset XX05H
*/

enum IdentificationRevisionShifts{
	MRID_SH =	12,	
	SRID_SH =	8,
	DID_SH  =	0
	
};

enum IdentificationRevisionMasks{
	MRID_MSK = 0xf,
	SRID_MSK = 0xf,
	DID_MSK  = 0xff
	};

#define IXF1002_EC_MRID 0x01

GigMacControlRegs & _ControlRegs;

};

#endif //GIG_MAC_CHIP_REGS 

