/* GigCtrlRg.h
 * 
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS              
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: GigMacDriver
 * author: sk, Jan 99 Initial version
 * $History: GigCtrlRg.h $
 * 
 * *****************  Version 7  *****************
 * User: Tclancyx     Date: 8/20/99    Time: 7:02p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * Change reference to iostream::operator<<(void *) to (unsigned int)
 * since vxWorks doesn't seem to be able to print a pointer to void
 * 
 * *****************  Version 6  *****************
 * User: Skornfel     Date: 7/30/99    Time: 3:10p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * controls 21640 on SA1200 eval board
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 7/16/99    Time: 2:45p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 3  *****************
 * User: Skornfel     Date: 4/28/99    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * FIRST VERSION OF THE DRIVER 
 * lightly tested on NT 
 
 * ---------------------------------------------------------------------
 */

#ifndef GIG_MAC_CONTROL_REGS
#define GIG_MAC_CONTROL_REGS



class GigMacControlRegs{

public:
//friend
static
void * operator new(size_t size, void * ptr ){ return ptr; }
//friend
static
void operator delete( void * ptr){ return; }


	GigMacControlRegs(){
		//cout << "GigMacControlRegs CTOR" << endl;
	};

	~GigMacControlRegs(){};

//--------------------------------------------------------------------
//GETs
//Base Registers 
inline unsigned short int GetInterruptStatus() const {			//INT_STT		00H-01H	R	2
	return InterruptStatus+(InterruptStatus1<<8);
}; 			
inline unsigned short int GetInterruptEnable() const {			//INT_EN		02H-03H	RW	2
	return InterruptEnable+(InterruptEnable1<<8);
}; 		
inline unsigned short int GetPortControl() const {				//PORT_CTR		04H-05H	RW	2
	return PortControl+(PortControl1<<8);
};						
inline unsigned short int GetIdentificationRevision() const {	//ID_REV		06H-07H	R	2
	return IdentificationRevision+(IdentificationRevision1<<8);
};
inline unsigned short int GetTransmitReceiveStatus() const {	//TX_RX_STT		08H-09H	R	2
	return TransmitReceiveStatus+(TransmitReceiveStatus1<<8);
};
inline unsigned   int GetTransmitCounterOverflowStatus() const 	{//TX_OV_STT		0AH-0DH	R	4
		return	TransmitCounterOverflowStatus+
				(TransmitCounterOverflowStatus1<<8)+
			    (TransmitCounterOverflowStatus2<<16)+
				(TransmitCounterOverflowStatus3<<24);
};	
inline unsigned   int GetReceiveCounterOverflowStatus() const 	{//RX_OV_STT		0EH-11H	R	4
		return	ReceiveCounterOverflowStatus+
				(ReceiveCounterOverflowStatus1<<8)+
			    (ReceiveCounterOverflowStatus2<<16)+
				(ReceiveCounterOverflowStatus3<<24);
};

//Configuration Registers 										
inline unsigned  short int GetTransmitReceiveErrorMode() const {//TX_RX_ERR		20H-21H	RW	2
		return TransmitReceiveErrorMode+(TransmitReceiveErrorMode1<<8);
};
inline unsigned  short int GetFIFOThreshold() const {			//FFO_TSHD		22H-23H	RW	2
		return FIFOThreshold+(FIFOThreshold1<<8);
};						
inline unsigned  short int GetPortWorkingMode() const { 		//PORT_MODE		24H-25H	RW	2
		return PortWorkingMode+(PortWorkingMode1<<8);
};
inline unsigned  short int GetTransmitReceiveParameter() const {//TX_RX_PARAM	26H-27H	RW	2
		return TransmitReceiveParameter+(TransmitReceiveParameter1<<8);
};
inline unsigned  short int GetTransmitThreshold() const {		//TX_TSHD		28H-29H	RW	2
		return TransmitThreshold+(TransmitThreshold1<<8);
};
inline unsigned  short int GetTransmitFlowControlPauseTime() const{//PAUSE_TIME	2AH-2BH	RW	2
		return TransmitFlowControlPauseTime+(TransmitFlowControlPauseTime1<<8);
};
inline unsigned  short int GetMaximumPacketSize() const {		//PKT_MAX_SIZE	2CH-2DH	RW	2
		return MaximumPacketSize+(MaximumPacketSize1<<8);
};
inline unsigned  short int GetInterPacketGapValue() const {		//IPG_VAL		2EH-2FH	RW	2
		return InterPacketGapValue+(InterPacketGapValue1<<8);
};
inline unsigned  int GetMACAddress() const {return  MACAddress;};//FIX  IT LATER	//MAC_ADD		30H-35H	RW	6
inline unsigned  short int GetVLANTagLengthType() const {		//VLAN_TAG		36H-37H	RW	2
		return VLANTagLengthType+(VLANTagLengthType1<<8);
};				
inline unsigned  int GetTransmitCounterOverflowMask() const {	//TX_OV_MSK		38H-3BH	RW	4
		return TransmitCounterOverflowMask+(TransmitCounterOverflowMask1<<8)
			      +(TransmitCounterOverflowMask2<<16)+(TransmitCounterOverflowMask3<<24);
};				
inline unsigned  int GetReceiveCounterOverflowMask() const 	{	//RX_OV_MSK		3CH-3FH	RW	4
		return ReceiveCounterOverflowMask+(ReceiveCounterOverflowMask1<<8)
			      +(ReceiveCounterOverflowMask2<<16)+(ReceiveCounterOverflowMask3<<24);
};				

//GMII Management Access Registers (used in GMII mode)			
inline unsigned  short int GetGMIIManagementAccess() const {	//GMII_MNG_ACC	4AH-4BH	2 During GMII automatic access (GMIRY = 0) R, otherwise R/W.	
	return GMIIManagementAccess+(GMIIManagementAccess1<<8);
};
inline unsigned  short int GetGMIIManagementData() const {
		return GMIIManagementData+(GMIIManagementData1<<8);		//GMII_MNG_DAT	4CH-4DH	2 During GMII automatic access (GMII_MNG_ACC<GMIRY> = 0) R, otherwise R/W	
};

//GMII Management Register Set (used in GPCS mode)				
inline unsigned  short int GetGMIIControl() const {				//GMII_CTL		50H-51H	2 Bits 9, 12, 14, 15 R/W, bits 6, 7, 8, 10, 11, 13 R.
		return GMIIControl+(GMIIControl1<<8);
}; 						
inline unsigned  short int GetGMIIStatus() const {				//GMII_STT		52H-53H	2 R	
		return GMIIStatus+(GMIIStatus1<<8);
}; 						
inline unsigned  short int GetANAdvertisement() const {			//AN_ADV		58H-59H	2 Bits 7, 8, 12, 13, 15 R/W. Bits 6:0, 9, 10, 11, 14, R.	
		return ANAdvertisement+(ANAdvertisement1<<8);
}; 		
inline unsigned  short int GetANLinkPartnerAbilityBasePage() const {//AN_PRT_ABL	5AH-5BH	2 R	
		return ANLinkPartnerAbilityBasePage+(ANLinkPartnerAbilityBasePage1<<8);
};											
inline unsigned  short int GetANExpansion() const {				//AN_EXP		5CH-5DH	2 R	
		return  ANExpansion+(ANExpansion1<<8);
}; 					
inline unsigned  short int GetANNextPageTransmit() const {		//AN_NP_TR		5EH-5FH	2 Bits 15, 13:0 R/W. Bit 14, 11 R.	
		return ANNextPageTransmit+(ANNextPageTransmit1<<8);
};	  
inline unsigned  short int GetANLinkPartnerReceiveNextPage() const {//AN_PRT_NP		60H-61H	2 R
		return ANLinkPartnerReceiveNextPage+(ANLinkPartnerReceiveNextPage1<<8);
}; 											
inline unsigned  short int GetExtendedStatus() const {			//GMII_EXT_STT	6EH-6FH	2 R	
		return ExtendedStatus+(ExtendedStatus1<<8);
}; 			
inline unsigned  short int GetGPCSstatus() const {				//GPCS_STT		70H-71H	2 R	  
		return GPCSstatus+(GPCSstatus1<<8);
}; 						


/*
inline void SetTransmitFlowControlPauseTime(unsigned short int val){
		TransmitFlowControlPauseTime = val & 0xff;
		TransmitFlowControlPauseTime1 = (val & 0xff00) >> 8;
};
*/
//SETs
//Base Registers
inline void SetInterruptEnable(unsigned short int val){		//INT_EN		02H-03H	RW	2
		InterruptEnable = val & 0xff;
		InterruptEnable1 = (val & 0xff00) >> 8;
};
inline void SetPortControl(unsigned  short int val){
		PortControl = val & 0xff;
		PortControl1 = (val & 0xff00) >> 8;
};	
//Configuration Registers 										
inline void SetTransmitReceiveErrorMode(unsigned  int val){ //TX_RX_ERR		20H-21H	RW	2
		TransmitReceiveErrorMode = val & 0xff;
		TransmitReceiveErrorMode1 = (val & 0xff00) >>8;
};
inline void SetFIFOThreshold(unsigned  int val){			//FFO_TSHD		22H-23H	RW	2
		FIFOThreshold = val & 0xff;
		FIFOThreshold1 = (val & 0xff00) >> 8;	
};						
inline void SetPortWorkingMode(unsigned  int val){			//PORT_MODE		24H-25H	RW	2
		PortWorkingMode = val & 0xff;
		PortWorkingMode1 = (val & 0xff00) >> 8;
}; 					
inline void SetTransmitReceiveParameter(unsigned  int val){ //TX_RX_PARAM	26H-27H	RW	2
		TransmitReceiveParameter = val & 0xff;
		TransmitReceiveParameter1 = (val & 0xff00) >>8;
};
inline void SetTransmitThreshold(unsigned  int val){		//TX_TSHD		28H-29H	RW	2
		TransmitThreshold = val & 0xff;
		TransmitThreshold1 = (val & 0xff00) >>8;
};				
inline void SetTransmitFlowControlPauseTime(unsigned  int val){ //PAUSE_TIME	2AH-2BH	RW	2
		TransmitFlowControlPauseTime = val & 0xff;
		TransmitFlowControlPauseTime1 = (val & 0xff00) >> 8;
};
inline void SetMaximumPacketSize(unsigned  int val){			//PKT_MAX_SIZE	2CH-2DH	RW	2
		MaximumPacketSize = val & 0xff;
		MaximumPacketSize1 = (val & 0xff00) >>8;
};				
inline void SetInterPacketGapValue(unsigned  int val){			//IPG_VAL		2EH-2FH	RW	2
		InterPacketGapValue = val & 0xff;
		InterPacketGapValue1 = (val & 0xff00) >>8;
};			
inline void SetMACAddress(unsigned  int val){ MACAddress=val; };//FIXLATER			//MAC_ADD		30H-35H	RW	6
inline void SetVLANTagLengthType(unsigned  int val){ 			//VLAN_TAG		36H-37H	RW	2
		VLANTagLengthType = val & 0xff;
		VLANTagLengthType1 = (val & 0xff00) >> 8;
};			
inline void SetTransmitCounterOverflowMask(unsigned  int val){	//TX_OV_MSK		38H-3BH	RW	4
		TransmitCounterOverflowMask  = val & 0xff;
		TransmitCounterOverflowMask1 = (val & 0xff00) >>8;
		TransmitCounterOverflowMask2 = (val & 0xff0000) >>16;
		TransmitCounterOverflowMask3 = (val & 0xff000000) >> 24;
};	
inline void SetReceiveCounterOverflowMask(unsigned  int val){ 	//RX_OV_MSK		3CH-3FH	RW	4
		ReceiveCounterOverflowMask  = val & 0xff;
		ReceiveCounterOverflowMask1 = (val & 0xff00)>>8;
		ReceiveCounterOverflowMask2 = (val & 0xff0000) >> 16;
		ReceiveCounterOverflowMask3 = (val & 0xff000000) >> 24;
}; 

//GMII Management Access Registers (used in GMII mode)			
inline void SetGMIIManagementAccess(unsigned  int val){			//GMII_MNG_ACC	4AH-4BH	2 During GMII automatic access (GMIRY = 0) R, otherwise R/W.	
		GMIIManagementAccess = val & 0xff;
		GMIIManagementAccess1 = (val & 0xff00) >> 8;
};		
inline void SetGMIIManagementData(unsigned  int val){			//GMII_MNG_DAT	4CH-4DH	2 During GMII automatic access (GMII_MNG_ACC<GMIRY> = 0) R, otherwise R/W	
		GMIIManagementData = val & 0xff;
		GMIIManagementData1 = (val & 0xff00) >>8;
}; 			

//GMII Management Register Set (used in GPCS mode)				
inline void SetGMIIControl(unsigned  int val){					//GMII_CTL		50H-51H	2 Bits 9, 12, 14, 15 R/W, bits 6, 7, 8, 10, 11, 13 R.	
		GMIIControl = val & 0xff;
		GMIIControl1 = (val & 0xff00) >>8;
}; 							
inline void SetANAdvertisement(unsigned  int val){				//AN_ADV		58H-59H	2 Bits 7, 8, 12, 13, 15 R/W. Bits 6:0, 9, 10, 11, 14, R.
		ANAdvertisement = val & 0xff;
		ANAdvertisement1 = (val & 0xff00) >> 8;
}; 						
inline void SetANNextPageTransmit(unsigned  int val){			//AN_NP_TR		5EH-5FH	2 Bits 15, 13:0 R/W. Bit 14, 11 R.		 
		ANNextPageTransmit = val & 0xff;
		ANNextPageTransmit1 = (val & 0xff00) >> 8;
};			



//SK DEBUG/DEVELOPmnt
inline void SetInterruptStatus(unsigned short int  val){ InterruptStatus = val;};		
//SK






////////////////////////////////////////
//GBG Prints


void RegPrint(){

cout << hex << "----------------->" << endl 
<<" InterruptStatus               " << GetInterruptStatus() << endl
<<" InterruptEnable               " << GetInterruptEnable() << endl													
<<" PortControl                   " << GetPortControl() << endl							
;

};


void Show(){

cout << hex
<< "##################" << (unsigned int)(&InterruptStatus) << "####################" << endl

//<<" Base Registers " << endl
<<" InterruptStatus               " << GetInterruptStatus() << endl
<<" InterruptEnable               " << GetInterruptEnable() << endl													
<<" PortControl                   " << GetPortControl() << endl										
<<" IdentificationRevision        " << GetIdentificationRevision() << endl 									
<<" TransmitReceiveStatus         " << GetTransmitReceiveStatus() << endl									
<<" TransmitCounterOverflowStatus " << GetTransmitCounterOverflowStatus() << endl
<<" ReceiveCounterOverflowStatus  " << GetReceiveCounterOverflowStatus() << endl
//<<" Configuration Registers"  << endl
<<" TransmitReceiveErrorMode      " << GetTransmitReceiveErrorMode() << endl	
<<" FIFOThreshold                 " << GetFIFOThreshold() << endl													
<<" PortWorkingMode               " << GetPortWorkingMode() << endl															
<<" TransmitReceiveParameter      " << GetTransmitReceiveParameter() << endl												
<<" TransmitThreshold             " << GetTransmitThreshold() << endl	
<<" TransmitFlowControlPauseTime  " << GetTransmitFlowControlPauseTime() << endl	
<<" MaximumPacketSize             " << GetMaximumPacketSize() << endl	
<<" InterPacketGapValue           " << GetInterPacketGapValue() << endl	
<<" MACAddress                    " << GetMACAddress() << endl	
<<" VLANTagLengthType             " << GetVLANTagLengthType() << endl	
<<" TransmitCounterOverflowMask   " << GetTransmitCounterOverflowMask() << endl	
<<" ReceiveCounterOverflowMask    " << GetReceiveCounterOverflowMask() << endl	
//<<" GMII Management Access Registers (used in GMII mode) " << endl 
<<" GMIIManagementAccess          " << GetGMIIManagementAccess() << endl										
<<" GMIIManagementData            " << GetGMIIManagementData() << endl										
//<<" GMII Management Register Set (used in GPCS mode)" << endl 
<<" GMIIControl                   " << GetGMIIControl() << endl
<<" GMIIStatus                    " << GetGMIIStatus() << endl
<<" ANAdvertisement               " << GetANAdvertisement() << endl
<<" ANLinkPartnerAbilityBasePage  " << GetANLinkPartnerAbilityBasePage() << endl
<<" ANExpansion                   " << GetANExpansion() << endl
<<" ANNextPageTransmit            " << GetANNextPageTransmit() << endl
<<" ANLinkPartnerReceiveNextPage  " << GetANLinkPartnerReceiveNextPage() << endl 
<<" ExtendedStatus                " << GetExtendedStatus() << endl 	
<<" GPCSstatus                    " << GetGPCSstatus() << endl 	  
;
};
//

/////SK private:
public:

/*
GIGMAC
Register Mapping lists each CSR register name, 
mnemonic, address offset, and the section that describes the register.

Register Description					Mnemonic		I/O		Section	
														Address
														Offset   
	
Register Description Mnemonic I/O Address Section
Base Registers ------												3.2.2
Interrupt status register				INT_STT			00H-01H		3.2.2.1
Interrupt enable register				INT_EN			02H-03H		3.2.2.2
Port control register					PORT_CTR		04H-05H		3.2.2.3
Identification and revision number reg	ID_REV			06H-07H		3.2.2.4
Transmit and receive status register	TX_RX_STT		08H-09H		3.2.2.5
Transmit counter overflow status reg	TX_OV_STT		0AH-0DH		3.2.2.6
Receive counter overflow status regi	RX_OV_STT		0EH-11H		3.2.2.7

Configuration Registers -----										3.2.3
Transmit and receive error mode reg		TX_RX_ERR		20H-21H		3.2.3.1
FIFO threshold register					FFO_TSHD		22H-23H		3.2.3.2
Port working mode register				PORT_MODE		24H-25H		3.2.3.3
Transmit and receive parameter register TX_RX_PARAM		26H-27H		3.2.3.4
Transmit threshold register				TX_TSHD			28H-29H		3.2.3.5
Transmit flow-control pause time reg	PAUSE_TIME		2AH-2BH		3.2.3.6
Maximum packet size register			PKT_MAX_SIZE	2CH-2DH		3.2.3.7
Inter packet gap value					IPG_VAL			2EH-2FH		3.2.3.8
MAC address register					MAC_ADD			30H-35H		3.2.3.9
VLAN tag length/type register			VLAN_TAG		36H-37H		3.2.3.10
Transmit counter overflow mask register TX_OV_MSK		38H-3BH		3.2.3.11
Receive counter overflow mask register	RX_OV_MSK		3CH-3FH		3.2.3.12

GMII Management Access Registers (used in GMII mode)------			3.2.4
GMII management access register			GMII_MNG_ACC	4AH-4BH		3.2.4.1
GMII management data register			GMII_MNG_DAT	4CH-4DH		3.2.4.2

GMII Management Register Set (used in GPCS mode)------				3.2.5
GMII Control register					GMII_CTL		50H-51H		3.2.5.1
GMII Status register					GMII_STT		52H-53H		3.2.5.2
AN advertisement register				AN_ADV			58H-59H		3.2.5.3
AN link partner ability base page reg	AN_PRT_ABL		5AH-5BH		3.2.5.4
AN expansion register					AN_EXP			5CH-5DH		3.2.5.5
AN next page transmit register			AN_NP_TR		5EH-5FH		3.2.5.6	  
AN link partner receive next page register AN_PRT_NP	60H-61H		3.2.5.7
Extended status register				GMII_EXT_STT	6EH-6FH		3.2.5.8
GPCS status register					GPCS_STT		70H-71H		3.2.5.9  

*/


//--------------------------------------------------------------------------------------------------
///  the real regs map may look like 8 bit regs on 32 bit addresses 

//Base Registers 											
unsigned int InterruptStatus,       InterruptStatus1;			//INT_STT		00H-01H	R	2
unsigned int InterruptEnable,       InterruptEnable1; 			//INT_EN		02H-03H	RW	2
unsigned int PortControl,           PortControl1;				//PORT_CTR		04H-05H	RW	2
unsigned int IdentificationRevision,IdentificationRevision1;	//ID_REV		06H-07H	R	2
unsigned int TransmitReceiveStatus, TransmitReceiveStatus1;		//TX_RX_STT		08H-09H	R	2

unsigned int TransmitCounterOverflowStatus;			//TX_OV_STT		0AH-0DH	R	4
unsigned int TransmitCounterOverflowStatus1;
unsigned int TransmitCounterOverflowStatus2;
unsigned int TransmitCounterOverflowStatus3;

unsigned int ReceiveCounterOverflowStatus;			//RX_OV_STT		0EH-11H	R	4
unsigned int ReceiveCounterOverflowStatus1;
unsigned int ReceiveCounterOverflowStatus2;
unsigned int ReceiveCounterOverflowStatus3;

unsigned int PADIt1[14];                                        //					2+4+4+4+4		

//Configuration Registers 										
unsigned int TransmitReceiveErrorMode,	TransmitReceiveErrorMode1;		//TX_RX_ERR		20H-21H	RW	2
unsigned int FIFOThreshold,				FIFOThreshold1;					//FFO_TSHD		22H-23H	RW	2
unsigned int PortWorkingMode,			PortWorkingMode1; 				//PORT_MODE		24H-25H	RW	2
unsigned int TransmitReceiveParameter,	TransmitReceiveParameter1;		//TX_RX_PARAM	26H-27H	RW	2
unsigned int TransmitThreshold,			TransmitThreshold1;				//TX_TSHD		28H-29H	RW	2
unsigned int TransmitFlowControlPauseTime,TransmitFlowControlPauseTime1;	//PAUSE_TIME	2AH-2BH	RW	2
unsigned int MaximumPacketSize,			MaximumPacketSize1;				//PKT_MAX_SIZE	2CH-2DH	RW	2
unsigned int InterPacketGapValue,		InterPacketGapValue1;			//IPG_VAL		2EH-2FH	RW	2

unsigned int MACAddress;							//MAC_ADD		30H-35H	RW	6
unsigned int MACAddress1;
unsigned int MACAddress2;
unsigned int MACAddress3;
unsigned int MACAddress4;
unsigned int MACAddress5;

unsigned int VLANTagLengthType,	VLANTagLengthType1;	//VLAN_TAG		36H-37H	RW	2
unsigned int TransmitCounterOverflowMask;			//TX_OV_MSK		38H-3BH	RW	4
unsigned int TransmitCounterOverflowMask1;
unsigned int TransmitCounterOverflowMask2;
unsigned int TransmitCounterOverflowMask3;
unsigned int ReceiveCounterOverflowMask; 			//RX_OV_MSK		3CH-3FH	RW	4
unsigned int ReceiveCounterOverflowMask1;
unsigned int ReceiveCounterOverflowMask2;
unsigned int ReceiveCounterOverflowMask3;

unsigned int PADIt3[10];								//					2+4+4

//GMII Management Access Registers (used in GMII mode)			
unsigned int GMIIManagementAccess,	GMIIManagementAccess1;	//GMII_MNG_ACC	4AH-4BH	2 During GMII automatic access (GMIRY = 0) R, otherwise R/W.	
unsigned int GMIIManagementData,	GMIIManagementData1; 	//GMII_MNG_DAT	4CH-4DH	2 During GMII automatic access (GMII_MNG_ACC<GMIRY> = 0) R, otherwise R/W	

unsigned int PADIt5[2];							//					2

//GMII Management Register Set (used in GPCS mode)				
unsigned int GMIIControl,					GMIIControl1; 			//GMII_CTL		50H-51H	2 Bits 9, 12, 14, 15 R/W, bits 6, 7, 8, 10, 11, 13 R.	
unsigned int GMIIStatus,					GMIIStatus1; 			//GMII_STT		52H-53H	2 R	

unsigned int PADIt6[4];  //	

unsigned int ANAdvertisement,				ANAdvertisement1; 		//AN_ADV		58H-59H	2 Bits 7, 8, 12, 13, 15 R/W. Bits 6:0, 9, 10, 11, 14, R.	
unsigned int ANLinkPartnerAbilityBasePage,	ANLinkPartnerAbilityBasePage1;//AN_PRT_ABL	5AH-5BH	2 R	
unsigned int ANExpansion,					ANExpansion1; 			//AN_EXP		5CH-5DH	2 R	
unsigned int ANNextPageTransmit,			ANNextPageTransmit1;	//AN_NP_TR		5EH-5FH	2 Bits 15, 13:0 R/W. Bit 14, 11 R.		  
unsigned int ANLinkPartnerReceiveNextPage,	ANLinkPartnerReceiveNextPage1;//AN_PRT_NP		60H-61H	2 R

unsigned int PADIt7[12];								//4+4+4

unsigned int ExtendedStatus,	ExtendedStatus1;	//GMII_EXT_STT	6EH-6FH	2 R	
unsigned int GPCSstatus,		GPCSstatus1; 		//GPCS_STT		70H-71H	2 R	  
//----------------------------------------------------------------------------------------

};


#endif //GIG_MAC_CONTROL_REGS 

