/* GigDrv.h
 * 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS         
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: GigMacDriver
 * author: sk, Jan 99 Initial version
 * $History: GigDrv.h $
 * 
 * *****************  Version 20  *****************
 * User: Dmwhite      Date: 12/18/00   Time: 10:21a
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * do runtime check for multipacket
 * 
 * *****************  Version 19  *****************
 * User: Dmwhite      Date: 12/15/00   Time: 2:34p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * a little cleanup of debug outputs
 * 
 * *****************  Version 18  *****************
 * User: Dmwhite      Date: 12/15/00   Time: 2:18p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * Multipacket feature
 * 
 * *****************  Version 17  *****************
 * User: Dmwhite      Date: 12/14/00   Time: 3:52p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * new gig mac multipacket feature
 * 
 * *****************  Version 15  *****************
 * User: Qabuild      Date: 4/07/00    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * OS==VXWORKS , UCOS
 * 
 * *****************  Version 14  *****************
 * User: Skornfeld    Date: 4/07/00    Time: 3:38p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 10  *****************
 * User: Skornfel     Date: 9/07/99    Time: 2:14p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * Changed the default to LITTLE ending
 * 
 * *****************  Version 9  *****************
 * User: Skornfel     Date: 8/03/99    Time: 5:42p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 8/03/99    Time: 5:31p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 8/03/99    Time: 5:12p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * Renamed Globals duplicated in OctalMAC
 * 
 * *****************  Version 6  *****************
 * User: Skornfel     Date: 7/30/99    Time: 3:10p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * controls 21640 on SA1200 eval board
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 7/16/99    Time: 2:45p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 3  *****************
 * User: Skornfel     Date: 4/28/99    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * FIRST VERSION OF THE DRIVER 
 * lightly tested on NT 
 * 
  * ---------------------------------------------------------------------
 */

#ifndef GIG_MAC_DRIVER
#define GIG_MAC_DRIVER

#include "GigMacAPI.h "
#include "GigPort.h"
#include "GigEvDs.h"
//#include "fdrvcom.h"
//#include "bmint.h"
#include "GigChipRg.h"

#include "TS.h"

//GHS
#ifdef GHS
#include "c:/tornado/target/h/intLib.h"
#endif  //GHS

#ifdef LAB
GigMacControlRegs * GGLOB_CONTROL_REGS[NUM_OF_PORTS];
GigMacNetStats    * GGLOB_NETSTAS_REGS[NUM_OF_PORTS];
GigMacNetStats    * GGLOB_NETSTAS_REGS_CL[NUM_OF_PORTS];
#endif 

//Global test area SK - netstats and control regs "emulator"
#ifndef LAB
GigMacControlRegs GGLOB_CONTROL_REGS[NUM_OF_PORTS];
GigMacNetStats    GGLOB_NETSTAS_REGS[NUM_OF_PORTS];
GigMacNetStats    GGLOB_NETSTAS_REGS_CL[NUM_OF_PORTS];
#endif

static PortPtrs  P;   //Array of driver Port pointers

/*	Interrupt Handling Sequence

Following interrupt, the subsequent sequence must be used to reset the interrupt:
1.	If both ports are sharing the same interrupt line, perform steps 2 to 4 for each port that
	generates an interrupt.
2.	Read the port interrupt status register (INT_STT) and act according to the interrupt cause.
3.	If the packet event bit is set (INT_STT<PKEVE>), read the transmit and receive status register
	(TX_RX_STT) and act according to the interrupt cause. If the counter overflow bit is set
	(INT_STT<OVFC>), read the counter overflow status registers (TX_OV_STT and
	RX_OV_STT) to find out which counter has reached its highest possible value.
4.	If the port was programmed to stop or underflowed while TX_RX_ERR<unfs=1>, resume
	transmission by writing a value.
*/

//--------------------------------------------------------------------
///#ifdef INT

//volatile int int_storage=0xaa;
// This storage provides one time buffer(per port) for the 
// values of the registers on the time of the interrupt.
// For the later, sufficient buffering or some other queueing
// mechanism needed 
volatile int chip_int_source=0; //virtual
volatile int gint_count=0;
volatile int gdrv_count=0;
volatile int port_int_stat[2]={0,0};
volatile int tx_rx_stat[2]={0,0};

//tested on ucos Semaphore  SemDispachEvent and changed
// to the pointer and dynamic creation to determine the creation time 
Semaphore  * GSemDispachEvent; 



//--
#if (OS==UCOS)
int
#endif
//--




GISR (void){
		for(int port=0; port<NUM_OF_PORTS; port++){
			//if ( chip_int_source & (1 << port)){
				//volatile int	
				port_int_stat[port] |= GGLOB_CONTROL_REGS[port] _CALL_ InterruptStatus;
				if ( port_int_stat[port] )chip_int_source |= (port+1);//simulate

				if ( (port_int_stat[port] & 0x200) == 200)/*PKEV*/ 
					//volatile int	
					tx_rx_stat[port] |= GGLOB_CONTROL_REGS[port] _CALL_ TransmitReceiveStatus;	
				if ( (port_int_stat[port] & 0x2000) == 0x2000)/*OVFC*/ 
					//	
					P.ptr_RxMsgDptr[port]->CopyStatsAndClear();	
			//}
		}
	//int read = GGLOB_CONTROL_REGS[1]->GetInterruptStatus();//NOT WORKING on QNX	 
	gint_count++;
	GSemDispachEvent->Give(); //ucos DO it for VXWORKS or NT
	return (0); //0;
};



class GigMacDriver{

private:
	unsigned long int *mac_base;	//MAC base address pointetr
	char *memory_base;				//storage for the mem base

	inline void ConnectInterrupt(){
#ifdef INT
#if (OS==VXWORKS)

	int status =
	intConnect(
		    (VOIDFUNCPTR *)9,//interrupt vector to attach to    
		    (VOIDFUNCPTR )GISR,			//VOIDFUNCPTR routine to be called  
		    0				//parameter to be passed to routine 
	);
	cout <<"status = " << status << endl;
	status=intEnable(9);	
	cout <<"status = " << status << endl;
#endif
#if (OS==QNX)
		unsigned long reg_val;
	
		// Enable interrupt on the PCI
		PCIread_local_reg (0x4c, &reg_val);
		PCIwrite_local_reg (0x4c, reg_val | 0x41);
		cout << "PLX Interrupt enabled" << endl;

		// attach PCI interrrupt - g_ds is used to locate the data segment
		int	
		i_int_id = PCIhint_attach (&ISR, FP_SEG(&g_ds));
		if (i_int_id == -1){
			cout <<"Unable to attach interrupt handler" << endl;
			return;
		}
		cout<< " Interrupt attached .. Handler installed" << i_int_id << endl; 	
#endif
#endif
	};


public:



	GigMacDriver(int mac_base=0x38408000){

				
		This = this;
		GSemDispachEvent = new Semaphore();    ////ucos
#if (OS==UCOS)
		EventDispatcherThread = new Thread(HandleInterrupt,9);
#else //UCOS
		EventDispatcherThread = new Thread(HandleInterrupt);
#endif //UCOS
		//cout << "GigMacDriver CTOR" << endl;

#ifdef LAB	
#ifdef INT

#endif //INT

		//GigMacControlRegs * 
		GGLOB_CONTROL_REGS[0] = new((void *)mac_base       ) GigMacControlRegs; 
		GGLOB_CONTROL_REGS[1] = new((void *)((unsigned long *)mac_base+ 0x400)) GigMacControlRegs; 
	
		GGLOB_NETSTAS_REGS[0] = new ((void *)((unsigned long *)mac_base+ 0x200)) GigMacNetStats;
		GGLOB_NETSTAS_REGS[1] = new ((void *)((unsigned long *)mac_base+ 0x600)) GigMacNetStats;

		GGLOB_NETSTAS_REGS_CL[0] = new ((void *)((unsigned long *)mac_base+ 0x100)) GigMacNetStats;
		GGLOB_NETSTAS_REGS_CL[1] = new ((void *)((unsigned long *)mac_base+ 0x500)) GigMacNetStats;




/*		cout << (int *) GGLOB_CONTROL_REGS[0] << endl; 
		cout << (int *) GGLOB_CONTROL_REGS[1] << endl;
		cout << (int *) GGLOB_NETSTAS_REGS[0] << endl; 
		cout << (int *) GGLOB_NETSTAS_REGS[1] << endl; 
*/


#endif

#ifdef INT
		ConnectInterrupt();
#endif 

		for (int port =0; port<NUM_OF_PORTS; port++)
#ifndef LAB
	    	P.ptr_RxMsgDptr[port] = new GigMacPort(port,&GGLOB_CONTROL_REGS[port],&GGLOB_NETSTAS_REGS[port], &GGLOB_NETSTAS_REGS_CL[port]);
#else
    	    P.ptr_RxMsgDptr[port] = new GigMacPort(port,GGLOB_CONTROL_REGS[port],GGLOB_NETSTAS_REGS[port], GGLOB_NETSTAS_REGS_CL[port]);
#endif


	    ChipSCRs = new GigMacChipRegs((P.ptr_RxMsgDptr[0])->GetPortControlRegs());
        if ( IXF1002_EC_MRID != ChipSCRs->GetIdentificationRevisionMRID())
        {// Set MLTPKT mode in all but IXF1002-EC)
            for (int port =0; port<NUM_OF_PORTS; port++)
            {
//                printf("DID = %x\n",ChipSCRs->GetIdentificationRevisionDID());
  //              printf("MRID = %x\n",ChipSCRs->GetIdentificationRevisionMRID());
    //            printf("SRID = %x\n",ChipSCRs->GetIdentificationRevisionSRID());
                ((P.ptr_RxMsgDptr[port])->GetPortRegs()).SetPortWorkingModeMLTPKT();
            }
        }
      //  printf("ID = %x\n",ChipSCRs->GetIdentificationRevisionDID());
        //printf("MRID = %x\n",ChipSCRs->GetIdentificationRevisionMRID());
        //printf("SRID = %x\n",ChipSCRs->GetIdentificationRevisionSRID());
        EventDispatcher = new GigMacEventDispatcher(P);
	
	};

	~GigMacDriver(){
		
		for (int port =0; port<NUM_OF_PORTS; port++){ delete P.ptr_RxMsgDptr[port]; }
		

		delete ChipSCRs;
		delete EventDispatcher;
	
	};

// SendPort & ReceivePort - will be implemented as a part of programmible 
//ASIC macrocode or "HARD" ASIC logic
//
	inline void
	SendPort(int port){
	}
//
	inline void
	ReceivePort(int port){
	}

//-------
	
	inline RmonHostStats *
	GetPortRmonHostStatistics(int port){
		return P.ptr_RxMsgDptr[port]->GetRmonHostStatistics();
	}

	inline RmonEtherStats *
	GetPortRmonEtherStatistics(int port){
		return P.ptr_RxMsgDptr[port]->GetRmonEtherStatistics();
	}

	inline SnmpStats *
	GetPortSnmpStatistics(int port){
		return P.ptr_RxMsgDptr[port]->GetSnmpStatistics();
	}


//
	inline void
	StartPort (int port, int tx_rx=0)/*direction to start TX / RX) later */ {
		P.ptr_RxMsgDptr[port]->Start();
	}
 
	inline void 
	StopPort (int port, int tx_rx=0) /*direction to start TX / RX) later */ {
		P.ptr_RxMsgDptr[port]->Stop();
	}
        
	inline void 
	RestartPort (int port) {
		P.ptr_RxMsgDptr[port]->Restart();
	}
        
	inline void 
	ResetPort (int port) {
		P.ptr_RxMsgDptr[port]->Reset();
	} 

	inline void 
	ConfigurePort (int port) {
		P.ptr_RxMsgDptr[port]->Configure();
	} 
//
	inline void
	StartAll (void){
		for(int port=0; port<NUM_OF_PORTS; port++)StartPort(port); 
	}
 
	inline void 
	StopAll (void) {
		for(int port=0; port<NUM_OF_PORTS; port++)StopPort(port); 
	}
        
	inline void 
	RestartAll (void) {
		for(int port=0; port<NUM_OF_PORTS; port++)RestartPort(port); 
	}
        
	inline void 
	ResetAll (void) {
		for(int port=0; port<NUM_OF_PORTS; port++)ResetPort(port); 
	} 

	inline void 
	ConfigureAll (void) {
		for(int port=0; port<NUM_OF_PORTS; port++)ConfigurePort(port); 
	} 

	inline void 
	PassConfigurationToPort(int port,
							BusWidth bus_width=BUS_WIDTH_64          /*BUS_WIDTH_32*/,
							int /*FIFO_Threshold*/ rx_threshold=0x7  /*THRESHOLD_128THRESHOLD_64*/, 
							int /*FIFO_Threshold*/ tx_threshold=0x7  /*THRESHOLD_64 THRESHOLD_128*/
							) {
		P.ptr_RxMsgDptr[port]->PassConfiguration(bus_width, rx_threshold, tx_threshold );
	};
	
	inline void
	PassEndianToMAC( Endian order=LITTLE ){
		for (int port =0; port<2; port++)P.ptr_RxMsgDptr[port]->PassEndian( order );
	};  

//
	
static 	inline void 
	HandleInterrupt (void) {
	  for(;;){
		GSemDispachEvent->Take();
		gdrv_count ++;
		This->
		EventDispatcher->Dispatch();
	  }
	} 

private:
GigMacChipRegs	*ChipSCRs;
GigMacEventDispatcher *EventDispatcher;
static GigMacDriver  * This;
Thread * EventDispatcherThread;
};


static GigMacDriver * GigMAC;
extern "C" void MAC_ISR(void){GigMAC->HandleInterrupt ();};

#endif //GIG_MAC_DRIVER 
