/* GigIntRg.h
 * 
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS                  
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: GigMacDriver
 * author: sk, Jan 99 Initial version
 * $History: GigIntRg.h $
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 7/16/99    Time: 2:45p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * 
 * *****************  Version 3  *****************
 * User: Skornfel     Date: 4/28/99    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * FIRST VERSION OF THE DRIVER 
 * lightly tested on NT 
 
 * ---------------------------------------------------------------------
 */
#ifndef GIG_MAC_INTERRUPT_REGS
#define GIG_MAC_INTERRUPT_REGS
//  interrupt :
//  1. Interrupt status register 
//  2. Interrupt enable register


class GigMacInterruptRegs{
public:

	GigMacInterruptRegs(GigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "GigMacInterruptRegs CTOR" << endl;
	};

	~GigMacInterruptRegs(){};

/*
	STOPE_SH=	14,		
	OVFCE_SH=	13,		
	LNCHE_SH=	12,
	TXOKE_SH=	10,	
	PKERE_SH=	9,	
	RXOKE_SH=	8,
	ANERE_SH=	7,
	PGRCE_SH=   6
*/

	inline unsigned short int GetInterruptStatus()const { return InterruptStatusF();};

	inline unsigned int GetInterruptStatusSTOP()const { return ( InterruptStatusF() >> STOP_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusOVFC()const { return ( InterruptStatusF() >> OVFC_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusLNCH()const { return ( InterruptStatusF() >> LNCH_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXOK()const { return ( InterruptStatusF() >> TXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPKEV()const { return ( InterruptStatusF() >> PKEV_SH) & INT_STAT_MSK;};	
	inline unsigned int GetInterruptStatusRXOK()const { return ( InterruptStatusF() >> RXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusANER()const { return ( InterruptStatusF() >> ANER_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPGRC()const { return ( InterruptStatusF() >> PGRC_SH) & INT_STAT_MSK;};
	
	inline unsigned int GetInterruptStatusSTOP(short int val)const { return ( val >> STOP_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusOVFC(short int val)const { return ( val >> OVFC_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusLNCH(short int val)const { return ( val >> LNCH_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXOK(short int val)const { return ( val >> TXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPKEV(short int val)const { return ( val >> PKEV_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusRXOK(short int val)const { return ( val >> RXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusANER(short int val)const { return ( val >> ANER_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPGRC(short int val)const { return ( val >> PGRC_SH) & INT_STAT_MSK;};

//

	inline unsigned short int GetInterruptEnable()const { return InterruptEnableF();};

	inline unsigned int GetInterruptStatusSTOPE()const { return ( InterruptStatusF() >> STOPE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusOVFCE()const { return ( InterruptStatusF() >> OVFCE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusLNCHE()const { return ( InterruptStatusF() >> LNCHE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXOKE()const { return ( InterruptStatusF() >> TXOKE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPKEVE()const { return ( InterruptStatusF() >> PKEVE_SH) & INT_STAT_MSK;};	
	inline unsigned int GetInterruptStatusRXOKE()const { return ( InterruptStatusF() >> RXOKE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusANERE()const { return ( InterruptStatusF() >> ANERE_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusPGRCE()const { return ( InterruptStatusF() >> PGRCE_SH) & INT_STAT_MSK;};
	
	inline void SetInterruptEnable(unsigned short int val){ InterruptEnableF(val);};

	inline void SetInterruptEnableSTOPE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << STOPE_SH));};
	inline void SetInterruptEnableOVFCE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << OVFCE_SH));};
	inline void SetInterruptEnableLNCHE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << LNCHE_SH));};
	inline void SetInterruptEnableTXOKE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << TXOKE_SH));};
	inline void SetInterruptEnablePKEVE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << PKEVE_SH));};
	inline void SetInterruptEnableRXOKE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << RXOKE_SH));};

	inline void SetInterruptEnableANERE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << ANERE_SH));};
	inline void SetInterruptEnablePGRCE() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << PGRCE_SH));};


private:

	inline unsigned int InterruptStatusF()const {return _ControlRegs.GetInterruptStatus();};
	inline unsigned int InterruptEnableF()const {return _ControlRegs.GetInterruptEnable();};
	inline void InterruptEnableF(unsigned short int val){_ControlRegs.SetInterruptEnable(val);};
    

/*

Interrupt Status Register
Mnemonic: INT_STT
Address: 00H - 01H

The interrupt status register handles information regarding events that cause an interrupt. A specific
event sets a bit if it was programmed to generate an interrupt in the interrupt enable register (INT_EN).
Reading this register will reset all the bits, except for PKEV and OVFC bits. These bits are reset
only when the asserted bits in the relevant status registers are reset by read.
BitName		Bit #	Bit Description
			15		RESERVED
STOP		14		Port stop.
					Indicates that transmit or receive path is in the stop state, following disable programming in
					the port control register. If both transmit and receive paths are programmed to be stopped,
					this bit is set when they both reach the stop state.
OVFC		13		Counter overflow.
					Indicates that at least one network statistic counter has reached its highest possible value. This
					bit is a logical OR of all bits in the counter overflow status registers (see Section 3.2.2.6 and
					Section 3.2.2.7).
LNCH		12		Link change.
					Indicates that a link change has occurred while working in GPCS mode. The actual link
					status is reported in the GMII status register GMII_STT<LNKSTT> (see Section 3.2.5.2).
			11		RESERVED
TXOK		10		Transmit OK.
					Indicates successful packet transmission.
PKEV		9		Packet event.
					A logical OR of all the bits in the transmit and receive status register (TX_RX_STT),
					excluding the packet count (PKC) bits. Upon receive events, this bit is set only after the
					packet is fully received by the chip.
RXOK		8		Receive OK.
					Indicates that a packet has been received without error. This bit is set only after the packet
					is fully received by the chip.
ANER		7		Auto-Negotiation error.
					Indicates that the link partner advertises that it does not support full-duplex operation, and
					that Auto-Negotiation was restarted.
PGRC		6		Page received.
					Indicates that a base or next page has been received during Auto-Negotiation process.
			5:0		RESERVED
			
Access Rules Register access R
Value after reset 0000H

*/
enum InterruptStatusShifts{
	STOP_SH=	14,		
	OVFC_SH=	13,		
	LNCH_SH=	12,
	TXOK_SH=	10,	
	PKEV_SH=	9,	
	RXOK_SH=	8,
	ANER_SH=	7,
	PGRC_SH=   6
};

enum InterruptStatusMasks{
	INT_STAT_MSK =0x1
	};
/*

Interrupt Enable Register
Mnemonic: INT_EN
Address: 02H - 03H

Each bit in this register, when set to 1, enables the generation of an interrupt when the
corresponding event occurs. The event causing the interrupt will be reported in the interrupt status
register (INT_STT).

Bit Name	Bit #	Bit Description
			15		RESERVED
STOPE		14		Port stop interrupt enable.
OVFCE		13		Counter overflow interrupt enable.
LNCHE		12		Link change interrupt enable.
			11		RESERVED
TXOKE		10		Transmit OK interrupt enable.
PKEVE		9		Packet event interrupt enable.
RXOKE		8		Receive OK interrupt enable.
ANERE		7		Auto-Negotiation error interrupt enable.
PGRCE		6		Page received interrupt enable.
			5:0		RESERVED

Access Rules Register access R/W
Value after reset 0000H
*/

enum InterruptEnableShifts{
	STOPE_SH=	14,		
	OVFCE_SH=	13,		
	LNCHE_SH=	12,
	TXOKE_SH=	10,	
	PKEVE_SH=	9,	
	RXOKE_SH=	8,
	ANERE_SH=	7,
	PGRCE_SH=   6

};

enum InterruptEnableMasks{
	INT_ENB_MSK =0x1
	};


GigMacControlRegs & _ControlRegs;

};

#endif //GIG_MAC_INTERRUPT_REGS 
