/* SnmpStats.h
 * 
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS                  
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jan 99 Initial version
 * $History: SNMPST.H $
 * 
 * *****************  Version 3  *****************
 * User: Skornfel     Date: 4/28/99    Time: 3:49p
 * Updated in $/dev_1200/SA1_CoreLibs/GigaMAC_GC82547EB
 * FIRST VERSION OF THE DRIVER 
 * lightly tested on NT 
 * 
  */

#ifndef GIG_MAC_SNMP_STATS
#define GIG_MAC_SNMP_STATS


#include "GigNetStat.h"

class SnmpStats{


public:
	SnmpStats(GigMacNetStats & stats):_MacNetStats(stats){
		//cout << "SnmpStats CTOR" << endl;
	};

	~SnmpStats(){}; 

	inline SnmpStats * GetSnmpCounters()			{return this;};

	inline void UpdateSnmpCounters() {
		CalculateFramesTransmittedOK();		
		CalculateFramesReceivedOK();			
		CalculateFramesCheckSequenceErrors();
		CalculateOctetsTransmittedOK();		
		CalculateOctetsReceivedOK();			
		CalculateFrameTooLongErrors();		
		CalculateMulticastFramesXmittedOK();	
		CalculateBroadcastFramesReceivedOK();
		CalculateMulticastFramesReceivedOK();
		CalculateBroadcastFramesXmittedOK();	
		CalculatePauseFramesTransmitted();	
		CalculatePauseFramesReceived();		
	};

	inline unsigned int GetFramesTransmittedOK()		{return FramesTransmittedOK;};
	inline unsigned int GetFramesReceivedOK()			{return FramesReceivedOK;};
	inline unsigned int GetFramesCheckSequenceErrors()	{return FramesCheckSequenceErrors;};
	inline unsigned int GetOctetsTransmittedOK()		{return OctetsTransmittedOK;};
	inline unsigned int GetOctetsReceivedOK()			{return OctetsReceivedOK;};
	inline unsigned int GetFrameTooLongErrors()			{return FrameTooLongErrors;};
	inline unsigned int GetMulticastFramesXmittedOK()	{return MulticastFramesXmittedOK;};
	inline unsigned int GetBroadcastFramesReceivedOK()	{return BroadcastFramesReceivedOK;};
	inline unsigned int GetMulticastFramesReceivedOK()	{return MulticastFramesReceivedOK;};
	inline unsigned int GetBroadcastFramesXmittedOK()	{return BroadcastFramesXmittedOK;};
	inline unsigned int GetPauseFramesTransmitted()		{return PauseFramesTransmitted;};
	inline unsigned int GetPauseFramesReceived()		{return PauseFramesReceived;};



	inline void CalculateFramesTransmittedOK()		{ FramesTransmittedOK = _MacNetStats.GetTxUniOkCnt() + _MacNetStats.GetTxMltOkCnt() + _MacNetStats.GetTxBrdOkCnt();};
	inline void CalculateFramesReceivedOK()			{ FramesReceivedOK = _MacNetStats.GetRxUniOkCnt() + _MacNetStats.GetRxMltOkCnt() + _MacNetStats.GetRxBrdOkCnt();;};
	inline void CalculateFramesCheckSequenceErrors(){ FramesCheckSequenceErrors = _MacNetStats.GetRxNormCrcCnt();};
	inline void CalculateOctetsTransmittedOK()		{ OctetsTransmittedOK = _MacNetStats.GetTxOctOkCnt();};
	inline void CalculateOctetsReceivedOK()			{ OctetsReceivedOK = _MacNetStats.GetRxOctOkCnt();};
	inline void CalculateFrameTooLongErrors()		{ FrameTooLongErrors = _MacNetStats.GetRxLongOkCnt() + _MacNetStats.GetRxLongCrcCnt();};
	inline void CalculateMulticastFramesXmittedOK()	{ MulticastFramesXmittedOK = _MacNetStats.GetTxMltOkCnt();};
	inline void CalculateBroadcastFramesReceivedOK(){ BroadcastFramesReceivedOK = _MacNetStats.GetRxBrdOkCnt();};
	inline void CalculateMulticastFramesReceivedOK(){ MulticastFramesReceivedOK = _MacNetStats.GetRxMltOkCnt();};
	inline void CalculateBroadcastFramesXmittedOK()	{ BroadcastFramesXmittedOK = _MacNetStats.GetTxBrdOkCnt();};
	inline void CalculatePauseFramesTransmitted()	{ PauseFramesTransmitted = _MacNetStats.GetRxPauseCnt();};
	inline void CalculatePauseFramesReceived()		{ PauseFramesReceived = _MacNetStats.GetTxPauseCnt();};

	inline void Show(){
cout 

           << "FramesTransmittedOK          " << FramesTransmittedOK   << endl
           << "FramesReceivedOK             " << FramesReceivedOK   << endl
           << "FramesCheckSequenceErrors    " << FramesCheckSequenceErrors   << endl
           << "OctetsTransmittedOK          " << OctetsTransmittedOK  << endl
           << "OctetsReceivedOK             " << OctetsReceivedOK  << endl
           << "FrameTooLongErrors           " << FrameTooLongErrors  << endl
           << "MulticastFramesXmittedOK     " << MulticastFramesXmittedOK  << endl
           << "BroadcastFramesReceivedOK    " << BroadcastFramesReceivedOK  << endl
           << "MulticastFramesReceivedOK    " << MulticastFramesReceivedOK   << endl
           << "BroadcastFramesXmittedOK     " << BroadcastFramesXmittedOK  << endl
           << "PauseFramesTransmitted       " << PauseFramesTransmitted  << endl
           << "PauseFramesReceived          " << PauseFramesReceived << endl;
	}

private:


public:
//BigMacNetStats NetStats;

//SNMP Counters
//lets see later if int is not long enought


unsigned int FramesTransmittedOK;		//TX_UNI_OK_CNT + TX_MLT_OK_CNT + TX_BRD_OK_CNT
unsigned int FramesReceivedOK;			//RX_UNI_OK_CNT + RX_MLT_OK_CNT + RX_BRD_OK_CNT
unsigned int FramesCheckSequenceErrors;	//RX_NORM_CRC_CNT
unsigned int OctetsTransmittedOK;		//TX_OCT_OK_CNT
unsigned int OctetsReceivedOK;			//RX_OCT_OK_CNT
unsigned int FrameTooLongErrors;		//RX_LONG_OK_CNT + RX_LONG_CRC_CNT
unsigned int MulticastFramesXmittedOK;	//TX_MLT_OK_CNT
unsigned int BroadcastFramesReceivedOK;	//RX_BRD_OK_CNT
unsigned int MulticastFramesReceivedOK;	//RX_MLT_OK_CNT
unsigned int BroadcastFramesXmittedOK;	//TX_BRD_OK_CNT
unsigned int PauseFramesTransmitted;	//TX_PAUSE_CNT
unsigned int PauseFramesReceived;		//RX_PAUSE_CNT

private:
GigMacNetStats & _MacNetStats;

};


#endif //GIG_MAC_SNMP_STATS 

