/* BigMacChipSCR.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMCHPSCR.H $
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:05p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:33p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_CHIP_CSR
#define BIG_MAC_CHIP_CSR



class BigMacChipSCR{

public:
	BigMacChipSCR(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacChipSCR CTOR" << endl;/*ChipInterruptSummary=0x10;*/
	};
	~BigMacChipSCR(){};

	inline unsigned char
	GetChipInterruptSummary (void){	return ChipInterruptSummaryF();}


	inline unsigned char
	GetDeviceIdentificationNumber (void){ return DeviceIdentificationNumberF();}


	inline unsigned char
	GetRevisionIdentificationNumber (void){	return RevisionIdentificationNumberF();}



private:

	inline unsigned char ChipInterruptSummaryF()const {return _ControlRegs.GetChipInterruptSummary();};
	inline unsigned char DeviceIdentificationNumberF()const {return _ControlRegs.GetDeviceIdentificationNumber();};
	inline unsigned char RevisionIdentificationNumberF()const {return _ControlRegs.GetRevisionIdentificationNumber();};

     



/*ChipInterruptSummary
This register handles the interrupt status of all the ports. A set bit indicates that the
corresponding port has generated an interrupt, and several bits located in its port
status register have been set. A bit will reset when the corresponding port interrupt
resets. The interrupt summary register is valid only in port 0.

Register access R
Value after reset 00H

INT7	7	Port 7 interrupt
INT6	6	Port 6 interrupt
INT5	5	Port 5 interrupt
INT4	4	Port 4 interrupt
INT3	3	Port 3 interrupt
INT2	2	Port 2 interrupt
INT1	1	Port 1 interrupt
INT0	0	Port 0 interrupt
*/
//unsigned char ChipInterruptSummary;								//CHIP_INT 00H VAlid only on port 0

/*
DeviceIdentificationNumber
The device ID register is valid only in port 0.

Register access R
Value after reset 01H

DID		7:0		Device ID.


*/

//unsigned char DeviceIdentificationNumber;						//DEV_ID 06H //3.2.2.7

/*
RevisionIdentificationNumber
The revision ID register is valid only in port 0.

Register access R

MRID	7:4		Main revision ID. This number is incremented for subsequent
				21440 revisions.
SRID	3:0		Sub revision ID. This number is incremented for subsequent
				21440 steps within the current revision.
*/
//unsigned char RevisionIdentificationNumber;						//REV_ID 07H //3.2.2.8


BigMacControlRegs & _ControlRegs;

};


#endif //BIG_MAC_CHIP_CSR
