/* BigMacEventDispatcher.h
 * BigMacDriver Port Dispetcher file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMEVDSP.H $
 * 
 * *****************  Version 9  *****************
 * User: Skornfel     Date: 6/24/99    Time: 3:53p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 21440 ISV board support removed 
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 6/09/99    Time: 8:03p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * runs on1200 eval board
 * supports two 21440 macs with 16 ports
 * in both non interrupt and interrupt modes   
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_DSTR
#define BIG_MAC_DSTR

//HH#include "BigMacChipSCR.h"
//HH#include "BigMacPort.h"

#include "bmchpscr.h"
#include "bmport.h"


class BigMacEventDispatcher{

public:
	BigMacEventDispatcher(IntRegestersShadow & IntRegShad,BigMacChipSCR &chipSCRs, PortPtrs &ports)
		:_IntRegShad(IntRegShad),_ChipSCRs(chipSCRs),_ArrPort_prts(ports){
		//cout << "BigMacEventDispatcher CTOR" << endl;
	};
	
	~BigMacEventDispatcher(){};

	inline void
	Dispatch(void){

	//cout << " dispatch ISR if any" << endl;
 
		//8 bit SCR
		for(int port=0; port<8; port++){

#ifndef LAB
			if ( _ChipSCRs.GetChipInterruptSummary() & (1 << port))
#endif
#ifdef INT
////			extern volatile int chip_int_source;
			if ( _IntRegShad.chip_int_source & (1 << port))
#endif				
			{
				//cout << "interrupt from port" << port << endl;
			    //Do something about IT
#ifdef INT
				 _IntRegShad.chip_int_source = _IntRegShad.chip_int_source & ~( 1<< port); //Clear the bit
#endif	
                _ArrPort_prts.ptr_RxMsgDptr[port]->HandleInterrupt();

			};
		};
	};


private:
BigMacChipSCR &_ChipSCRs;
PortPtrs & _ArrPort_prts;   // Arrays of Port pointes
IntRegestersShadow & _IntRegShad;
};



#endif //BIG_MAC_DSTR 
