/* BigMacFIFO.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMFIFO.H $
 * 
 * *****************  Version 13  *****************
 * User: Dmwhite      Date: 12/08/00   Time: 3:08p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * added ixf440 
 * 
 * *****************  Version 12  *****************
 * User: Dmwhite      Date: 11/15/00   Time: 10:08a
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * add ixf440
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_FIFO
#define BIG_MAC_FIFO

class BigMacFIFO{

public:
	BigMacFIFO(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacFIFO CTOR" << endl;
	};
	~BigMacFIFO(){};


	inline unsigned char GetFIFOThreshold()const { return FIFOThresholdF();};

	inline unsigned int GetFIFOThresholdTTH()const { return ( FIFOThresholdF() >> TTH_SH) & FIFO_THR_MSK;};
	inline unsigned int GetFIFOThresholdRTH()const { return ( FIFOThresholdF() >> RTH_SH) & FIFO_THR_MSK;};

	
	inline void SetFIFOThreshold(unsigned char val){ FIFOThresholdF(val);};

	inline void SetFIFOThresholdTTH(unsigned char val) {
		//FIFOThreshold &= ~(FIFO_THR_MSK<<TTH_SH); FIFOThreshold |= ((val&0xf)<<TTH_SH);
		FIFOThresholdF (FIFOThresholdF() & ~(FIFO_THR_MSK<<TTH_SH)); 
		FIFOThresholdF (FIFOThresholdF() | ((val&0xf)<<TTH_SH));
	};
	inline void SetFIFOThresholdRTH (unsigned char val) {
		//FIFOThreshold &= ~(FIFO_THR_MSK<<RTH_SH); FIFOThreshold |= ((val&0xf)<<RTH_SH);
		FIFOThresholdF (FIFOThresholdF() & ~(FIFO_THR_MSK<<RTH_SH)); 
		FIFOThresholdF (FIFOThresholdF() | ((val&0xf)<<RTH_SH));
	};

//--


	inline unsigned char GetFIFOBusMode()const { return FIFOBusModeF();};

	inline unsigned int GetFIFOBusModeHRYD()const { return ( FIFOBusModeF() >> HRYD_SH) & FIFO_MOD_MSK;};
	inline unsigned int GetFIFOBusModeBWID()const { return ( FIFOBusModeF() >> BWID_SH) & FIFO_MOD_MSK;};
	inline unsigned int GetFIFOBusModeBEND()const { return ( FIFOBusModeF() >> BEND_SH) & FIFO_MOD_MSK;};
	inline unsigned int GetFIFOBusModeSPLT()const { return ( FIFOBusModeF() >> SPLT_SH) & FIFO_MOD_MSK;};

	
	inline void SetFIFOBusMode(unsigned char val){ FIFOBusModeF(val);};

	inline void SetFIFOBusModeHRYD() {   FIFOBusModeF ( FIFOBusModeF() |(FIFO_MOD_MSK << HRYD_SH));};
	inline void SetFIFOBusModeBWID() {   FIFOBusModeF ( FIFOBusModeF() |(FIFO_MOD_MSK << BWID_SH));};
	inline void SetFIFOBusModeBEND() {   FIFOBusModeF ( FIFOBusModeF() |(FIFO_MOD_MSK << BEND_SH));};
	inline void SetFIFOBusModeSPLT() {   cout << "in SetFIFOBusModeSPLT" << endl;
                                         FIFOBusModeF ( FIFOBusModeF() |(FIFO_MOD_MSK << SPLT_SH));};



private:

	inline unsigned char FIFOThresholdF()const {return _ControlRegs.GetFIFOThreshold();};
	inline void FIFOThresholdF(unsigned char val){_ControlRegs.SetFIFOThreshold(val);};

	inline unsigned char FIFOBusModeF()const {return _ControlRegs.GetFIFOBusMode();};
	inline void FIFOBusModeF(unsigned char val){_ControlRegs.SetFIFOBusMode(val);};
     

/*FIFOThreshold
The FIFO threshold register handles the transmit and receive FIFO threshold.

Register access R/W
Value after reset 77H

TTH 7:4	This field defines the minimum amount of free space required
			in the transmit FIFO in order to assert the txrdy signal. The
			effective threshold in bytes is equal to 8  (TTH + 1). A value
			of 0 is not allowed.
RTH 3:0	This field defines the minimum amount of data required in the
			receive FIFO in order to assert the rxrdy signal. The effective
			threshold in bytes is equal to 8  (RTH + 1). A value of 0 is
			not allowed.
Register field value	Effective threshold		Register field value	Effective threshold
(RTH or TTH)			(bytes)					(RTH or TTH)			(bytes)

0						not allowed				8						72
1						16						9						80
2						24						10						88
3						32						11						96
4						40						12						104
5						48						13						112
6						56						14						120
7						64						15						128

  */

enum FIFOThresholdShifts{
	TTH_SH=	4,	
	RTH_SH=	0		
};

enum FIFOThresholdMasks{
	FIFO_THR_MSK =0xf
	};
		
	
	
//unsigned char FIFOThreshold;									//FFO_TSHD 11H //3.2.3.1

/*FIFOBusMode
The FIFO bus mode register controls the FIFO bus mode of work.

Register access R/W
Value after reset 00H

#if this is an IXF440
		7:5		RESERVED
SPLT    4       Bit meaningful for MAC0 only
                split mode
        3       Reserved
#else
		7:3		RESERVED
#endif
HRYD	2		Header ready disable.
				When set, the rxrdy signal will not be asserted when a packet
				header is in FIFO, but only according to FIFO threshold values.
BWID	1		Bus width.
				Defines the number of bits used on the FIFO bus. When set, 64
				bits are used. When reset, the lower 32 bits are used.
BEND	0		Big or little endian mode.
				Defines the byte ordering mode on the FIFO bus. When set, the
				port uses the big endian mode. When reset, the little endian
				mode is used.
*/

enum FIFOBusModeShifts{
    SPLT_SH=    4,
    HRYD_SH=	2,	
	BWID_SH=	1,
	BEND_SH=	0
	
};

enum FIFOBusModeMasks{
	FIFO_MOD_MSK =0x1
	};



//unsigned char FIFOBusMode;										//FFO_BUS 12H //3.2.3.2
BigMacControlRegs & _ControlRegs;

};


#endif //BIG_MAC_FIFO 
