/* BigMacInterrupt.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMINT.H $
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * BigMacInterrupt
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_INTERRUPT
#define BIG_MAC_INTERRUPT



class BigMacInterrupt{

public:
	BigMacInterrupt(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacInterrupt CTOR" << endl;/*InterruptStatus=0xff;test*/
	};
	~BigMacInterrupt(){};



	inline unsigned char GetInterruptStatus()const { return InterruptStatusF();};

	inline unsigned int GetInterruptStatusSTOP()const { return ( InterruptStatusF() >> STOP_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusOVFC()const { return ( InterruptStatusF() >> OVFC_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusLNCH()const { return ( InterruptStatusF() >> LNCH_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXER()const { return ( InterruptStatusF() >> TXER_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXOK()const { return ( InterruptStatusF() >> TXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusRXEV()const { return ( InterruptStatusF() >> RXEV_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusRXOK()const { return ( InterruptStatusF() >> RXOK_SH) & INT_STAT_MSK;};

	
	inline unsigned int GetInterruptStatusSTOP(int val)const { return ( val >> STOP_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusOVFC(int val)const { return ( val >> OVFC_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusLNCH(int val)const { return ( val >> LNCH_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXER(int val)const { return ( val >> TXER_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusTXOK(int val)const { return ( val >> TXOK_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusRXEV(int val)const { return ( val >> RXEV_SH) & INT_STAT_MSK;};
	inline unsigned int GetInterruptStatusRXOK(int val)const { return ( val >> RXOK_SH) & INT_STAT_MSK;};

//

	inline unsigned char GetInterruptEnable()const { return InterruptEnableF();};

	inline unsigned int GetInterruptEnableSTOP()const { return ( InterruptEnableF() >> STOP_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableOVFC()const { return ( InterruptEnableF() >> OVFC_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableLNCH()const { return ( InterruptEnableF() >> LNCH_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableTXER()const { return ( InterruptEnableF() >> TXER_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableTXOK()const { return ( InterruptEnableF() >> TXOK_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableRXEV()const { return ( InterruptEnableF() >> RXEV_SH) & INT_ENB_MSK;};
	inline unsigned int GetInterruptEnableRXOK()const { return ( InterruptEnableF() >> RXOK_SH) & INT_ENB_MSK;};
	
	inline void SetInterruptEnable(unsigned char val){ InterruptEnableF(val);};

	inline void SetInterruptEnableSTOP() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << STOP_SH));};
	inline void SetInterruptEnableOVFC() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << OVFC_SH));};
	inline void SetInterruptEnableLNCH() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << LNCH_SH));};
	inline void SetInterruptEnableTXER() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << TXER_SH));};
	inline void SetInterruptEnableTXOK() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << TXOK_SH));};
	inline void SetInterruptEnableRXEV() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << RXEV_SH));};
	inline void SetInterruptEnableRXOK() {   InterruptEnableF (InterruptEnableF() |(INT_ENB_MSK << RXOK_SH));};


private:

	inline unsigned char InterruptStatusF()const {return _ControlRegs.GetInterruptStatus();};
	inline unsigned char InterruptEnableF()const {return _ControlRegs.GetInterruptEnable();};
	inline void InterruptEnableF(unsigned char val){_ControlRegs.SetInterruptEnable(val);};
     

/*
InterruptStatus
The interrupt status register handles information regarding events that cause an
interrupt. A specific event sets a bit if it was programmed to generate an interrupt in
the interrupt enable register (INT_EN).
Reading this register will reset all the bits, except for the TXER and RXEV bits.
These bits are reset only when the corresponding status register is read.

Register access R
Value after reset 00H


		7		RESERVED
STOP	6		Port stop.
				Indicates that transmit or receive path is in the stop state,
				following disable programming in the port control register. If
				both transmit and receive paths are programmed to be stopped,
				this bit is set when they both reach the stop state.
OVFC	5		Counter overflow.
				Indicates that at least one management counter has reached its
				highest possible value (and is stuck there). The overflowed
				counter needs to be reset to prevent further interrupt.
LNCH	4		Link change.
				Indicates that a link change has occurred while working in
				SYM mode. The actual link status is reported in the link status
				register.
TXER	3		Transmit error.
				A logical OR bit for all the bits in the transmit error status
				register.
TXOK	2		Transmit OK.
				Indicates successful packet transmission.
RXEV	1		Receive event.
				A logical OR of all the bits in the receive status register. This bit
				is set only after the packet is fully received by the chip.
RXOK	0		Receive OK.
				Indicates that a packet has been received without error. This bit
				is set only after the packet is fully transferred onto the chip.

*/
enum InterruptStatusShifts{
	STOP_SH=	6,	
	OVFC_SH=	5,		
	LNCH_SH=	4,	
	TXER_SH=	3,		
	TXOK_SH=	2,		
	RXEV_SH=	1,		
	RXOK_SH=	0	
};

enum InterruptStatusMasks{
	INT_STAT_MSK =0x1
	};
	 
//unsigned char InterruptStatus;									//INT_STT 01H //3.2.2.2

/*
InterruptEnable
Each bit in this register enables the generation of an interrupt when the
corresponding event occurs. The event causing the interrupt will be reported in the
interrupt status register (INT_STT).

Register access R/W
Value after reset 00H

		7		RESERVED
STOPE	6		Port stop interrupt enable
OVFCE	5		Counter overflow interrupt enable
LNCHE	4		Line change interrupt enable
TXERE	3		Transmit error interrupt enable
TXOKE	2		Transmit OK interrupt enable
RXEVE	1		Receive event interrupt enable
RXOKE	0		Receive OK interrupt enable
*/
enum InterruptEnableShifts{
	STOPE_SH=	6,		
	OVFCE_SH=	5,		
	LNCHE_SH=	4,
	TXERE_SH=	3,	
	TXOKE_SH=	2,	
	RXEVE_SH=	1,	
	RXOKE_SH=	0
};

enum InterruptEnableMasks{
	INT_ENB_MSK =0x1
	};

//unsigned char InterruptEnable;									//INT_EN 02H //3.2.2.3
BigMacControlRegs & _ControlRegs;
};



#endif //BIG_MAC_INTERRUPT
