/* BigMacPort.h
 * BigMacDriver Port file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMPORT.H $
 * 
 * *****************  Version 26  *****************
 * User: Admin        Date: 12/22/00   Time: 11:59a
 * Updated in $/V1.2/SA1_CoreLibs/OctalMAC_21440
 * remove sysboardgetid
 * 
 * *****************  Version 24  *****************
 * User: Dmwhite      Date: 12/08/00   Time: 3:08p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * added ixf440 
 * 
 * *****************  Version 23  *****************
 * User: Dmwhite      Date: 11/15/00   Time: 10:17a
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * add ixf440
 * 
 * *****************  Version 21  *****************
 * User: Qabuild      Date: 4/18/00    Time: 5:17p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * update from IAL zip file 4/12/00
 * 
 * *****************  Version 19  *****************
 * User: Mffallon     Date: 1/11/00    Time: 3:09p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * Set fifo threshold.
 * 
 * *****************  Version 18  *****************
 * User: Skornfel     Date: 10/06/99   Time: 5:34p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * All "bad" packets filtered out on RX
 * 
 * *****************  Version 17  *****************
 * User: Skornfel     Date: 9/21/99    Time: 3:51p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * MAC ports in to FULL duplex MODE
 * 
 * *****************  Version 16  *****************
 * User: Tclancyx     Date: 9/03/99    Time: 1:34p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * interrupts disabled o the ports
 * 
 * *****************  Version 14  *****************
 * User: Dhooper      Date: 7/23/99    Time: 4:46p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 
 * *****************  Version 13  *****************
 * User: Skornfel     Date: 7/23/99    Time: 4:19p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * Added OctalMACCofigureEndian(int mac, Endian order); //order=LITTLE
 * interface 
 * 
 * *****************  Version 12  *****************
 * User: Skornfel     Date: 6/24/99    Time: 3:53p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 21440 ISV board support removed 
 * 
 * *****************  Version 11  *****************
 * User: Skornfel     Date: 6/15/99    Time: 4:03p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * CRC remove on RX 
 * 
 * *****************  Version 10  *****************
 * User: Skornfel     Date: 6/09/99    Time: 8:03p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * runs on1200 eval board
 * supports two 21440 macs with 16 ports
 * in both non interrupt and interrupt modes   
 * 
 * *****************  Version 9  *****************
 * User: Skornfel     Date: 5/27/99    Time: 10:42a
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * QNX support  removed
 * Dual mac support added 
 * ISR for dual mac needs some work
 * Extern "C" api changed
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 5/24/99    Time: 4:22p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_PORT
#define BIG_MAC_PORT

//HH#include "BigMacNetStats.h"

//HH#include "RmonHostStats.h"
//HH#include "RmonEtherStats.h"
//HH#include "SnmpStats.h"
//HH#include "BigMacControlRegs.h"

//HH#include "BigMacPortControl.h"
//HH#include "BigMacFIFO.h"
//HH#include "BigMacReceive.h"
//HH#include "BigMacTransmit.h"
//HH#include "BigMacInterrupt.h"
//HH#include "BigMacSerial.h"
//
#include "bmnetst.h"

#include "rmonhtst.h"
#include "rmonetst.h"
#include "snmpst.h"
#include "bmctrlrg.h"

#include "bmprtc.h"
#include "bmfifo.h"
#include "bmrx.h"
#include "bmtx.h"
#include "bmint.h"
#include "bmser.h"

 

//Extern NeworkControl STABS
extern void PortStop(int port); 
extern void LinkChange(int port, unsigned char link_tatus_reg);
extern void TransmitError(int port, unsigned char tx_err_stat_reg);
extern void TransmitOk(int port);
extern void ReceiveEvent(int port, unsigned char rx_stat_reg);
extern void ReceiveOk(int port);
extern void CounterOverflow(int port, SnmpStats &SnmpBeforeClear, 
							          RmonHostStats	&RmonHostBeforeClear, 
									  RmonEtherStats &RmonEtherBeforeClear);


enum NumPorts{
	NUM_OF_PORTS =8
};


class IntRegestersShadow{  //may be extended to the circular Queue later 
public:
int chip_int_source;
int port_int_stat[8];
int port_rx_stat[8];
int port_tx_stat[8];
//Semaphore  * SemDispachEvent; later
};



class BigMacPort{

public:


	BigMacPort(IntRegestersShadow & IntRegShad, int port, void * ctrl_regs, void * net_regs, void * net_regs_clear)
		:_IntRegShad(IntRegShad){
		//cout << "BigMacPort " << port << " CTOR" << endl;
		Port = port;
        Bus_width    =  BUS_WIDTH_64;//(SI_BOARD == sysBoardIDGet()) ? BUS_SPLIT : BUS_WIDTH_64;		/*BUS_WIDTH_32 qq */ 
        Rx_threshold =THRESHOLD_128;	/*THRESHOLD_64*/ 
        Tx_threshold =THRESHOLD_64;		/*THRESHOLD_128*/
		Order = LITTLE ;				/*BIG*/
		Split_mode = SPLIT_MODE_OFF ;//(SI_BOARD == sysBoardIDGet()) ? SPLIT_MODE_ON : SPLIT_MODE_OFF ;	/*SPLIT_MODE_ON (IXF440 only)*/
		
//SK separetly maped copies of net_regs 100(Read&REset) and 200(Read) maped
		PortMacNetStats			= new(net_regs) BigMacNetStats;
		PortMacNetStatsClear	= new(/*test net_regs*/net_regs_clear) BigMacNetStats;
		PortMacNetStatsShadow   = new (/*test net_regs*/&PtrPortMacNetStatsShadowInstance) BigMacNetStats;
		PortMacControlRegs      = new(ctrl_regs) BigMacControlRegs;
		
		PortSnmpCounters		= new SnmpStats(*PortMacNetStats);
		PortRmonHostCounters	= new RmonHostStats(*PortMacNetStats);
		PortRmonEtherCounters	= new RmonEtherStats(*PortMacNetStats);

		PortSnmpCountersBeforeClear		= new SnmpStats(*PortMacNetStatsShadow);
		PortRmonHostCountersBeforeClear	= new RmonHostStats(*PortMacNetStatsShadow);
		PortRmonEtherCountersBeforeClear= new RmonEtherStats(*PortMacNetStatsShadow);

		
		PortControl				= new BigMacPortControl(*PortMacControlRegs);
		PortFIFO				= new BigMacFIFO(*PortMacControlRegs);
		PortReceive				= new BigMacReceive(*PortMacControlRegs);
		PortTransmit			= new BigMacTransmit(*PortMacControlRegs);
		PortInterrupt			= new BigMacInterrupt(*PortMacControlRegs);
		PortSerial				= new BigMacSerial(*PortMacControlRegs);

		//PortMacControlRegs->Show();
		

	};

	~BigMacPort(){

		delete PortMacControlRegs;
		
		delete PortSnmpCounters;
		delete PortRmonHostCounters;
		delete PortRmonEtherCounters;

		delete PortSnmpCountersBeforeClear;
		delete PortRmonHostCountersBeforeClear;
		delete PortRmonEtherCountersBeforeClear;
		
		delete PortMacNetStats;
		delete PortMacNetStatsClear;
		
		delete PortControl;
		delete PortFIFO;
		delete PortReceive;
		delete PortTransmit;
		delete PortInterrupt;
		delete PortSerial;
	};


	void Configure(void);

	inline  BigMacControlRegs &
	GetPortControlRegs(){return *PortMacControlRegs;};

	inline void
	Start ( int tx_rx = RX_AND_TX ){ // direction to start (bitwise OR of TX / RX)

		//configure the port
		Configure();
	
		//enable RX and/or TX
		if (tx_rx == RX_AND_TX)
			PortControl->SetPortControl(
//			//(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXSTT_SH) | 
		    (BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXEN_SH)  | 
			(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::RXEN_SH)  );

		if (tx_rx == RX)
			PortControl->SetPortControl(
			(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::RXEN_SH)  );

		if (tx_rx == TX)
			PortControl->SetPortControl(
//			//(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXSTT_SH) | 
		    (BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXEN_SH)  );


	}
 
	inline void 
	Stop ( int tx_rx = RX_AND_TX ) {

    //Stop the port /*BMreset_bits (PORT_CTR, port, (TXSTT | TXEN | RXEN) );*/
	
		if (tx_rx == RX_AND_TX){
			PortControl->ClearPortControlTXSTT(); 
			PortControl->ClearPortControlTXEN(); 
			PortControl->ClearPortControlRXEN();
		}

		if (tx_rx == RX){
			PortControl->ClearPortControlRXEN();
		}

		if (tx_rx == TX){
			PortControl->ClearPortControlTXSTT(); 
			PortControl->ClearPortControlTXEN(); 
		}
	
	}
        
	inline void 
	Restart ( int tx_rx = RX_AND_TX ) {
	//reconfigure the port
	Configure();
    /*BMwrite_bits (PORT_CTR, port, (TXSTT | TXEN | RXEN) );    */
    //PortControl->SetPortControl(0x18); 
//TEMP
//    PortControl->SetPortControlTXSTT(); 
	//PortControl->SetPortControlTXEN(); 
	//PortControl->SetPortControlRXEN();  
	
	//OR   not a logical OR .... SK
		//enable RX and/or TX
		if (tx_rx == RX_AND_TX)
			PortControl->SetPortControl(
//			//(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXSTT_SH) | 
		    (BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXEN_SH)  | 
			(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::RXEN_SH)  );

		if (tx_rx == RX)
			PortControl->SetPortControl(
			(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::RXEN_SH)  );

		if (tx_rx == TX)
			PortControl->SetPortControl(
//			//(BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXSTT_SH) | 
		    (BigMacPortControl::PORT_CTRL_MSK << BigMacPortControl::TXEN_SH)  );


	}
        
	inline void 
	Reset (void) {

	// in order to avoid a known bug in BM, don't write the reset bits at the
	// same time	/*	BMwrite_bits (PORT_CTR, port, CTRST ); 	BMwrite_bits (PORT_CTR, port, CNRST ); */
	PortControl->SetPortControlCTRST(); 
	PortControl->SetPortControlCNRST();  
	PortControl->SetPortControlPTRST(); //SK  
	
	}                                                                   

	inline void
	CopyStatsAndClear(){
		PortMacNetStatsClear->CopyBigMacNetStatsAndClear(PtrPortMacNetStatsShadowInstance);
	};


	inline void 
	PassConfiguration( BusWidth bus_width=BUS_WIDTH_64,          /*BUS_WIDTH_32*/
					   FIFO_Threshold rx_threshold=THRESHOLD_128,/*THRESHOLD_64*/ 
					   FIFO_Threshold tx_threshold=THRESHOLD_64  /*THRESHOLD_128*/
					 ) {
		Bus_width    = bus_width;       
		Rx_threshold = rx_threshold;    
		Tx_threshold = tx_threshold;
	};     

	inline void
	PassEndian(	 Endian order=LITTLE ){
		Order = order; 
	};  


	inline void
	HandleInterrupt(){
//!!!!!!!!!!!!!!!!!!!!!!!! later
//disable MAC ISR
//copy shadow to local
//clear shadow
//enable mac
// and then process with function		




//dbg get real regs later 
unsigned char link_status_reg;
unsigned char tx_err_stat_reg;
unsigned char rx_stat_reg;

#ifdef INT
//extern volatile int port_int_stat[8];
#endif


	//read port  InterruptStatus and ....-->

	//STOP	6		Port stop. - was programmed to be stopped(TX & RX BOTH ONLY)... analyse ...restart
	//
	//			Indicates that transmit or receive path is in the stop state,
	//			following disable programming in the port control register. If
	//			both transmit and receive paths are programmed to be stopped,
	//			this bit is set when they both reach the stop state.
	//
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusSTOP() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusSTOP(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			PortStop(Port);	
		};


	//OVFC	5		Counter overflow - at least one counter .. must!! reset .. 
	//
	//			Indicates that at least one management counter has reached its
	//			highest possible value (and is stuck there). The overflowed
	//			counter needs to be reset to prevent further interrupt.

#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusOVFC() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusOVFC(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			cout << "GetInterruptStatusOVFC - counter overflow " << endl << endl;
			// read from address 100 all couters - rest the conter
			// inform that conter overflow happen possibly pass the last updated structure to MIB ?
		////	P[Port]

		//PortMacNetStatsClear->CopyBigMacNetStatsAndClear(PtrPortMacNetStatsShadowInstance);
		//moved to 
		//CopyStatsAndClear ();
		//called from ISR
		PortSnmpCountersBeforeClear->UpdateSnmpCounters();
		PortRmonHostCountersBeforeClear->UpdateHostCounters();
		PortRmonEtherCountersBeforeClear->UpdateEtherCounters();

			CounterOverflow(Port, 
							*PortSnmpCountersBeforeClear, 
							*PortRmonHostCountersBeforeClear, 
							*PortRmonEtherCountersBeforeClear);
		};

		
	//LNCH	4		Link change - in SYM mode ..link cahge!... see LinkStatus Reg .. do
	//
	//			Indicates that a link change has occurred while working in
	//			SYM mode. The actual link status is reported in the link status
	//			register.
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusLNCH() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusLNCH(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			LinkChange(Port , link_status_reg);	
		};


	//TXER	3		Transmit error.
	//			A logical OR bit for all the bits in the transmit error status
	//			register.
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusTXER() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusTXER(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			TransmitError(Port , tx_err_stat_reg);	
		};


	//TXOK	2		Transmit OK.  ok.... next packet...
	//
	//			Indicates successful packet transmission.
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusTXOK() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusTXOK(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			TransmitOk(Port);	
		};


	//RXEV	1		Receive event.
	//
	//			A logical OR of all the bits in the receive status register. This bit
	//			is set only after the packet is fully received by the chip.
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusRXEV() )
#endif
#ifdef INT
		if ( PortInterrupt->GetInterruptStatusRXEV(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			ReceiveEvent(Port , rx_stat_reg);
		};
		

	//RXOK	0		Receive OK.   ....ok give me next
	//
	//			Indicates that a packet has been received without error. This bit
	//			is set only after the packet is fully transferred onto the chip.
#ifndef LAB
		if ( PortInterrupt->GetInterruptStatusRXOK() )
#endif
#ifdef INT 
		if ( PortInterrupt->GetInterruptStatusRXOK(_IntRegShad.port_int_stat[Port]) )
#endif
		{
			ReceiveOk(Port);
		};	
#ifdef INT 
		_IntRegShad.port_int_stat[Port]=0;
#endif
	
	}

	inline RmonHostStats *
	GetRmonHostStatistics(){
		PortRmonHostCounters->UpdateHostCounters();
		return PortRmonHostCounters->GetHostCounters();
	}

	inline RmonEtherStats *
	GetRmonEtherStatistics(){
		PortRmonEtherCounters->UpdateEtherCounters();
		return PortRmonEtherCounters->GetEtherCounters();
	}

	inline SnmpStats *
	GetSnmpStatistics(){
		PortSnmpCounters->UpdateSnmpCounters();
		return PortSnmpCounters->GetSnmpCounters();
	}


private:

BigMacNetStats		*PortMacNetStats;
BigMacNetStats      *PortMacNetStatsClear;
BigMacNetStats		 PtrPortMacNetStatsShadowInstance;
BigMacNetStats      *PortMacNetStatsShadow;
BigMacControlRegs	*PortMacControlRegs;
SnmpStats			*PortSnmpCounters;
RmonHostStats		*PortRmonHostCounters;
RmonEtherStats		*PortRmonEtherCounters;
SnmpStats		    *PortSnmpCountersBeforeClear;
RmonHostStats		*PortRmonHostCountersBeforeClear;
RmonEtherStats		*PortRmonEtherCountersBeforeClear;
BigMacPortControl	*PortControl;
BigMacFIFO			*PortFIFO;
BigMacReceive		*PortReceive;
BigMacTransmit		*PortTransmit;
BigMacInterrupt		*PortInterrupt;
BigMacSerial		*PortSerial;
int Port;
//for Bus_width, Rx_threshold, Tx_threshold  and SplitMode configuration
BusWidth Bus_width;       
FIFO_Threshold Rx_threshold;    
FIFO_Threshold Tx_threshold; 
Endian Order;   
SplitMode Split_mode;   
IntRegestersShadow & _IntRegShad;
};



void BigMacPort::Configure(void){
// Configure the port driver will use settings for the 

#ifdef INT 
//	InterruptEnableReg
//
//	PortInterrupt->SetInterruptEnable(0x0); //clear
///SK	PortInterrupt->SetInterruptEnableSTOP(); 
///SK	PortInterrupt->SetInterruptEnableOVFC(); 
//	PortInterrupt->SetInterruptEnableLNCH(); 
//	PortInterrupt->SetInterruptEnableTXER(); 
//	PortInterrupt->SetInterruptEnableTXOK(); 
///SK	PortInterrupt->SetInterruptEnableRXEV(); 
///SK	PortInterrupt->SetInterruptEnableRXOK(); 
#endif //INT 

//	PortControlReg  --- PLEASE LEAVE THIS FOR Start/Restart/.....

//	SerialCommandReg
//
//	PortSerial->SetSerialCommand(0x0);//clear
//	PortSerial->SetSerialCommandMDM();
//	PortSerial->SetSerialCommandMDIO();
//	PortSerial->SetSerialCommandMDC();
//	PortSerial->SetSerialCommandBKP();
//	PortSerial->SetSerialCommandFCT();
	
//	FIFOThresholdReg
//	
	PortFIFO->SetFIFOThreshold(0x0); //clear
	PortFIFO->SetFIFOThresholdTTH(Tx_threshold); 
	PortFIFO->SetFIFOThresholdRTH(Rx_threshold); 

//	FIFOBusModeReg
//	
	PortFIFO->SetFIFOBusMode(0x0); //clear
//	PortFIFO->SetFIFOBusMode(0x11); //clear
//	PortFIFO->SetFIFOBusModeHRYD();
    if (BUS_WIDTH_64 == Bus_width){
        PortFIFO->SetFIFOBusModeBWID();
    }
    if (Split_mode)	{
        PortFIFO->SetFIFOBusModeSPLT();
    }


    if (Order)/*if bigendian*/PortFIFO->SetFIFOBusModeBEND();

//	TransmitParametersReg
//	
//	PortTransmit->SetTransmitParameters(0x0);//clear
//	PortTransmit->SetTransmitParametersSPM(); 
//	PortTransmit->SetTransmitParametersXOND();
//	PortTransmit->SetTransmitParametersFLCE();
//	PortTransmit->SetTransmitParametersCRCD();
//	PortTransmit->SetTransmitParametersPADD();
   

//	TransmitErrorModeReg
//	
//	PortTransmit->SetTransmitErrorMode(0x0); //clear
//	PortTransmit->SetTransmitErrorModeXCLS();
//	PortTransmit->SetTransmitErrorModeLCLS();
//	PortTransmit->SetTransmitErrorModeUNFS();


//	TransmitPacketSendingThresholdAndBackoffLimitReg
//
//	PortTransmit->SetTransmitPacketThresholdBackoffLimit(0x0);//clear 
//	PortTransmit->SetTransmitPacketThresholdBackoffLimitBKL(10);
	PortTransmit->SetTransmitPacketThresholdBackoffLimitTSD(0xf);


//	ReceiveParametersReg
//
//	PortReceive->SetReceiveParameters(0x0);//Clear
	PortReceive->SetReceiveParametersCRCR();
//	PortReceive->SetReceiveParametersHRPL();
//	PortReceive->SetReceiveParametersHDRS(0x0);


//	ReceiveFilteringModeReg	
//
    PortReceive->SetReceiveFilteringMode(0x0);//clear
	//PortReceive->SetReceiveFilteringModePFLC();
	//PortReceive->SetReceiveFilteringModePMER();
	//PortReceive->SetReceiveFilteringModePRTL();
	//PortReceive->SetReceiveFilteringModePSRT();
	//PortReceive->SetReceiveFilteringModePDRB();
	//PortReceive->SetReceiveFilteringModePCRC();
	//PortReceive->SetReceiveFilteringModePOVF();

//	TransmitFlowControlPauseTimeReg 
//
//	PortTransmit->SetTransmitFlowControlPauseTime(0x0);//set


//	MaximumPacketSizeReg 
//
//	PortReceive->SetMaximumPacketSize( 1518 );	

//	SerialModeReg 
//
//	PortSerial->SetSerialMode(0x0);//clear
//	PortSerial->SetSerialModeILPK();
//	PortSerial->SetSerialModeELPK();
#ifndef PETH_DRV
	PortSerial->SetSerialModeFDX();
#endif
//	PortSerial->SetSerialModeSCR();
//	PortSerial->SetSerialModeSYP();


//	PhysicalAddressReg 	
//
//	InterruptEnableReg
//
//	PortInterrupt->SetInterruptEnable(0x0); //clear
//	PortInterrupt->SetInterruptEnableSTOP(); 
//	PortInterrupt->SetInterruptEnableOVFC(); 
//	PortInterrupt->SetInterruptEnableLNCH(); 
//	PortInterrupt->SetInterruptEnableTXER(); 
//	PortInterrupt->SetInterruptEnableTXOK(); 
//	PortInterrupt->SetInterruptEnableRXEV(); 
//	PortInterrupt->SetInterruptEnableRXOK(); 




};

class PortPtrs {
	public:
	BigMacPort * ptr_RxMsgDptr[NUM_OF_PORTS];
	};


#endif //BIG_MAC_PORT 

