/* BigMacPortControl.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMPRTC.H $
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_PORT_CONTROL
#define BIG_MAC_PORT_CONTROL

class BigMacPortControl{

public:
	BigMacPortControl(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacPortControl CTOR" << endl;
	};
	~BigMacPortControl(){};

	inline unsigned char GetPortControl()const { return PortControlF();};

	inline unsigned int GetPortControlTXSTT()const { return ( PortControlF() >> TXSTT_SH) & PORT_CTRL_MSK;};
	inline unsigned int GetPortControlTXEN()const  { return ( PortControlF() >> TXEN_SH) & PORT_CTRL_MSK;};
	inline unsigned int GetPortControlRXEN()const  { return ( PortControlF() >> RXEN_SH) & PORT_CTRL_MSK;};
	inline unsigned int GetPortControlPTRST()const { return ( PortControlF() >> PTRST_SH) & PORT_CTRL_MSK;};
	inline unsigned int GetPortControlCTRST()const { return ( PortControlF() >> CTRST_SH) & PORT_CTRL_MSK;};
	inline unsigned int GetPortControlCNRST()const { return ( PortControlF() >> CNRST_SH) & PORT_CTRL_MSK;};
	
	inline void SetPortControl(unsigned char val){ PortControlF( val );};

	inline void SetPortControlTXSTT() {   PortControlF (PortControlF() | (PORT_CTRL_MSK << TXSTT_SH));};
	inline void SetPortControlTXEN()  {   PortControlF (PortControlF() | (PORT_CTRL_MSK << TXEN_SH));};
	inline void SetPortControlRXEN()  {   PortControlF (PortControlF() | (PORT_CTRL_MSK << RXEN_SH));};
	inline void SetPortControlPTRST() {   PortControlF (PortControlF() | (PORT_CTRL_MSK << PTRST_SH));};
	inline void SetPortControlCTRST() {   PortControlF (PortControlF() | (PORT_CTRL_MSK << CTRST_SH));};
	inline void SetPortControlCNRST() {   PortControlF (PortControlF() | (PORT_CTRL_MSK << CNRST_SH));};

	inline void ClearPortControl(){ PortControlF( 0x0 );};

	inline void ClearPortControlTXSTT() {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << TXSTT_SH));};
	inline void ClearPortControlTXEN()  {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << TXEN_SH));};
	inline void ClearPortControlRXEN()  {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << RXEN_SH));};
	inline void ClearPortControlPTRST() {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << PTRST_SH));};
	inline void ClearPortControlCTRST() {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << CTRST_SH));};
	inline void ClearPortControlCNRST() {   PortControlF (PortControlF() & ~(PORT_CTRL_MSK << CNRST_SH));};


//moved to do logical or on the bits
enum PortControlShifts{
	TXSTT_SH=	5,		
	TXEN_SH =	4,
	RXEN_SH =	3,	
	PTRST_SH=	2,	
	CTRST_SH=	1,	
	CNRST_SH=	0
};

enum PortControlMasks{
	PORT_CTRL_MSK =0x1
	};

private:

	
	inline unsigned char PortControlF()const {return _ControlRegs.GetPortControl();};
	inline void PortControlF(unsigned char val){_ControlRegs.SetPortControl(val);};
     

/*
PortControl
The port control register handles all the control bits of the port.

Register access R/W
Value after reset 00H

		7:6		RESERVED
TXSTT	5		Transmit restart.
				When set, the chip restarts the transmission process after
				stopping due to a transmit error. The TXSTT is a trigger bit
				(does not require reset before setting).
TXEN	4		Transmit enable.
				When this bit is set, the port enters the working mode. When
				reset, the port completes transmission of the packet currently
				processed, and then stops. Stop state is reported in the STOP bit
				located in the interrupt status register (INT_STT).
RXEN	3		Receive enable.
				When this bit is set, the port enters the working mode. When
				reset, the port completes reception of the packet currently
				processed, and then stops. Stop state is reported in the STOP bit
				located in the interrupt status register (INT_STT).
PTRST	2		Port reset.
				When set, this bit causes the transmit and receive logic to reset.
CTRST	1		Control reset.
				When set, this bit resets all the registers, except PORT_CTR, to
				their default values. Transmit and receive logic are also reset.
CNRST	0		Counter reset.
				When set, this bit resets all the network statistic counters. The
				reset process takes 100 cycles. During this time, the counters
				and PORT_CTR must not be accessed. This bit must not be set
				together with the CTRST bit.



enum PortControlShifts{
	TXSTT_SH=	5,		
	TXEN_SH =	4,
	RXEN_SH =	3,	
	PTRST_SH=	2,	
	CTRST_SH=	1,	
	CNRST_SH=	0,
};

enum PortControlMasks{
	PORT_CTRL_MSK =0x1
	};
*/	
//unsigned char PortControl;										//PORT_CTR 05H //3.2.2.6
BigMacControlRegs & _ControlRegs;
};


#endif //BIG_MAC_PORT_CONTROL
