/* BigMacReceive.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMRX.H $
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 6/24/99    Time: 3:53p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 21440 ISV board support removed 
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_RECEIVE
#define BIG_MAC_RECEIVE




class BigMacReceive{

public:
	BigMacReceive(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacPortReceive CTOR" << endl;
	};
	~BigMacReceive(){};

//


	inline unsigned char GetReceiveStatus()const { return ReceiveStatusF();};

	inline unsigned int GetReceiveStatusFLC()const { return ( ReceiveStatusF() >> FLC_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusMER()const { return ( ReceiveStatusF() >> MER_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusRTL()const { return ( ReceiveStatusF() >> RTL_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusSRT()const { return ( ReceiveStatusF() >> SRT_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusDRB()const { return ( ReceiveStatusF() >> DRB_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusCRC()const { return ( ReceiveStatusF() >> CRC_SH) & RX_STAT_MSK;};
	inline unsigned int GetReceiveStatusOVF()const { return ( ReceiveStatusF() >> OVF_SH) & RX_STAT_MSK;};

//

	inline unsigned char GetReceiveParameters()const { return ReceiveParametersF();};

	inline unsigned int GeReceiveParametersCRCR()const { return ( ReceiveParametersF() >> CRCR_SH) & RX_PARM_CRCR_MSK;};
	inline unsigned int GetReceiveParametersHRPL()const { return ( ReceiveParametersF() >> HRPL_SH) & RX_PARM_HRPL_MSK;};
	inline unsigned int GetReceiveParametersHDRS()const { return ( ReceiveParametersF() >> HDRS_SH) & RX_PARM_HDRS_MSK;};
	

	inline void SetReceiveParameters(unsigned char val){ ReceiveParametersF(val);};

	inline void SetReceiveParametersCRCR() {   ReceiveParametersF (ReceiveParametersF() | (RX_PARM_CRCR_MSK << CRCR_SH));};
	inline void SetReceiveParametersHRPL() {   ReceiveParametersF (ReceiveParametersF() | (RX_PARM_HRPL_MSK << HRPL_SH));};
	inline void SetReceiveParametersHDRS(unsigned char val) {
		ReceiveParametersF( ReceiveParametersF() & ~(RX_STAT_MSK<<HDRS_SH)); 
		ReceiveParametersF( ReceiveParametersF() | ((val&0xf)<<HDRS_SH));
	};



//

	inline unsigned char GetReceiveFilteringMode()const { return ReceiveFilteringModeF();};

	inline unsigned int GetReceiveFilteringModePFLC()const { return ( ReceiveFilteringModeF() >> PFLC_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePMER()const { return ( ReceiveFilteringModeF() >> PMER_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePRTL()const { return ( ReceiveFilteringModeF() >> PRTL_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePSRT()const { return ( ReceiveFilteringModeF() >> PSRT_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePDRB()const { return ( ReceiveFilteringModeF() >> PDRB_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePCRC()const { return ( ReceiveFilteringModeF() >> PCRC_SH) & RX_FILT_MOD_MSK;};
	inline unsigned int GetReceiveFilteringModePOVF()const { return ( ReceiveFilteringModeF() >> POVF_SH) & RX_FILT_MOD_MSK;};
	
	inline void SetReceiveFilteringMode(unsigned char val){ ReceiveFilteringModeF (val);};

	inline void SetReceiveFilteringModePFLC() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PFLC_SH));};
	inline void SetReceiveFilteringModePMER() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PMER_SH));};
	inline void SetReceiveFilteringModePRTL() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PRTL_SH));};
	inline void SetReceiveFilteringModePSRT() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PSRT_SH));};
	inline void SetReceiveFilteringModePDRB() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PDRB_SH));};
	inline void SetReceiveFilteringModePCRC() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << PCRC_SH));};
	inline void SetReceiveFilteringModePOVF() {   ReceiveFilteringModeF (ReceiveFilteringModeF() | (RX_FILT_MOD_MSK << POVF_SH));};


//short int reg
	inline short int	GetMaximumPacketSize() const { return MaximumPacketSizeF(); };
	inline 	void SetMaximumPacketSize( short int val ) { MaximumPacketSizeF (val); };


private:

	
	inline unsigned char ReceiveStatusF()const {return _ControlRegs.GetReceiveStatus();}

	inline unsigned char ReceiveParametersF()const {return _ControlRegs.GetReceiveParameters();}
	inline void ReceiveParametersF(unsigned char val){_ControlRegs.SetReceiveParameters(val);};

	inline unsigned char ReceiveFilteringModeF()const {return _ControlRegs.GetReceiveFilteringMode();}
	inline void ReceiveFilteringModeF(unsigned char val){_ControlRegs.SetReceiveFilteringMode(val);};

	inline unsigned short int MaximumPacketSizeF()const {return _ControlRegs.GetMaximumPacketSize();};
	inline void MaximumPacketSizeF(unsigned short int val){_ControlRegs.SetMaximumPacketSize(val);};




/*
ReceiveStatus
This register reports events that have occurred during packet reception. All bits are
reset upon reading this register. The bits in this register are set only if the receive
logic is programmed to pass packets with the corresponding event in the receive
filtering mode register (RX_FILT_MOD). If a packet with multiple errors is to be
passed and not all the corresponding bits in the receive filtering mode register
(RX_FILT_MOD) are set, none of the bits in this register are set. The receive status
is also appended to the end of the packet in the receive FIFO.

Register access R
Value after reset 00H

FLC		7		Flow control packet.
				Indicates that a flow-control packet was received.
		6		RESERVED
MER		5		MII error.
				Indicates either that a symbol error was detected in the SYM
				mode or that an MII error signal was asserted in the MII mode
				during packet reception.
RTL		4		Too long packet.
				Indicates that a packet longer than the maximum allowable size
				has been received.
SRT		3		Short packet.
				Indicates that a packet shorter than 64 bytes has been received.
DRB		2		Alignment error.
				Indicates that a packet was received with CRC and framing
				errors.
CRC		1		CRC error.
				Indicates that a packet was received with a CRC error but
				without a framing error.
OVF		0		FIFO overflow.
				Indicates that there was not enough space available in the
				receive FIFO during packet reception.

*/

enum ReceiveStatusShifts{
	FLC_SH=	7,		
	//6
	MER_SH=	5,		
	RTL_SH=	4,
	SRT_SH=	3,	
	DRB_SH=	2,	
	CRC_SH=	1,	
	OVF_SH=	0
};

enum ReceiveStatusMasks{
	RX_STAT_MSK =0x1
};




//unsigned char ReceiveStatus;									//RECV_STT 04H //3.2.2.5

/*
ReceiveParameters
The receive parameters register defines the receive data flow on the FIFO bus.


Register access R/W
Value after reset 10H

CRCR	7		CRC remove.
				When set, the last four bytes of the received packet will not be
				transferred onto the FIFO bus. Packets shorter than 4 bytes will
				cause invalid data to appear on the FIFO bus.
HRPL	6		Header replay.
				When set, packet header is transferred twice onto the FIFO bus.
				If this bit is set, the RX_FILT_MOD<PCRC> bit should be
				reset.
HDRS	5:0		Header size.
				Header size is used for the header replay function and for rxrdy
				signal assertion (even if the header replay function is disabled).
				The header size is calculated in bytes as 4  HDRS (valid
				values: 4 <= HDRS <= 48).
*/

enum ReceiveParametersShifts{
	CRCR_SH=	7,		
	HRPL_SH=	6,		
	HDRS_SH=	5
};

enum ReceiveParametersMasks{
	RX_PARM_CRCR_MSK =0x1,
	RX_PARM_HRPL_MSK =0x1,
	RX_PARM_HDRS_MSK =0x3f
};

//unsigned char ReceiveParameters;								//RX_PARAM 16H	//3.2.3.6

/*
ReceiveFilteringMode
When a packet with a specific event is programmed to be passed, the corresponding
packets are not discarded and are transferred as regular packets. The status is
reported in the receive status register (RECV_STT) and can generate an interrupt
according to the interrupt enable register (INT_EN).
If a specific event is not programmed to enable reception of a packet, the
corresponding packets are discarded from the receive FIFO. Failure will be reported
onto the rxfail signal if the packet has already started to be transferred onto the FIFO
bus. If a packet with multiple errors is to be passed, all corresponding bits must be

Register access R/W
Value after reset 00H

PFLC	7		Pass flow-control packets.
		6		RESERVED
PMER	5		Pass packets with MII error.
PRTL	4		Pass too long packets.
PSRT	3		Pass short packets.
PDRB	2		Pass alignment error packets.
PCRC	1		Pass CRC error packets.
POVF	0		Pass FIFO overflow.

*/

enum ReceiveFilteringModeShifts{
	PFLC_SH=	7,		
	//6
	PMER_SH=	5,		
	PRTL_SH=	4,
	PSRT_SH=	3,	
	PDRB_SH=	2,	
	PCRC_SH=	1,	
	POVF_SH=	0
};

enum ReceiveFilteringModeMasks{
	RX_FILT_MOD_MSK =0x1
	};


//unsigned char ReceiveFilteringMode;								//RX_FILT_MOD 17H //3.2.3.7

/*
MaximumPacketSize
This register controls the maximum allowed packet size.

Register access R/W
Value after reset 1518 (decimal)

MPS		15:0	Packets received with a longer size are treated as too long
				packets.
*/

//unsigned short int MaximumPacketSize;								//PKT_MAX_SIZE 1AH  1BH //3.2.3.9

BigMacControlRegs & _ControlRegs;

};


#endif //BIG_MAC_RECEIVE 
