/* BigMacSerial.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMSER.H $
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */


#ifndef BIG_MAC_SERIAL
#define BIG_MAC_SERIAL


class BigMacSerial{

public:
	BigMacSerial(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacSerial CTOR" << endl;
	};
	~BigMacSerial(){};





	inline unsigned char GetSerialCommand()const { return SerialCommandF();};

	inline unsigned int GetSerialCommandMDM() const { return ( SerialCommandF() >> MDM_SH) & SER_COM_MSK;};
	inline unsigned int GetSerialCommandMDIO()const { return ( SerialCommandF() >> MDIO_SH) & SER_COM_MSK;};
	inline unsigned int GetSerialCommandMDC() const { return ( SerialCommandF() >> MDC_SH) & SER_COM_MSK;};
	inline unsigned int GetSerialCommandBKP() const { return ( SerialCommandF() >> BKP_SH) & SER_COM_MSK;};
	inline unsigned int GetSerialCommandFCT() const { return ( SerialCommandF() >> FCT_SH) & SER_COM_MSK;};
	
	inline void SetSerialCommand(unsigned char val){ SerialCommandF(val);};

	inline void SetSerialCommandMDM()  {   SerialCommandF (SerialCommandF() | (SER_COM_MSK << MDM_SH));};
	inline void SetSerialCommandMDIO() {   SerialCommandF (SerialCommandF() | (SER_COM_MSK << MDIO_SH));};
	inline void SetSerialCommandMDC()  {   SerialCommandF (SerialCommandF() | (SER_COM_MSK << MDC_SH));};
	inline void SetSerialCommandBKP()  {   SerialCommandF (SerialCommandF() | (SER_COM_MSK << BKP_SH));};
	inline void SetSerialCommandFCT()  {   SerialCommandF (SerialCommandF() | (SER_COM_MSK << FCT_SH));};



//
	inline unsigned char GetSerialMode()const { return SerialModeF();};

	inline unsigned int GetSerialModeILPK()  const { return ( SerialModeF() >> ILPK_SH) & SER_MOD_MSK;};
	inline unsigned int GetSerialModeELPK()  const { return ( SerialModeF() >> ELPK_SH) & SER_MOD_MSK;};
	inline unsigned int GetSerialModeFDX_SH()const { return ( SerialModeF() >> FDX_SH) & SER_MOD_MSK;};
	inline unsigned int GetSerialModeSCR()   const { return ( SerialModeF() >> SCR_SH) & SER_MOD_MSK;};
	inline unsigned int GetSerialModeSYP()   const { return ( SerialModeF() >> SYP_SH) & SER_MOD_MSK;};
	
	inline void SetSerialMode(unsigned char val){ SerialModeF(val);};

	inline void SetSerialModeILPK() {   SerialModeF ( SerialModeF() | (SER_MOD_MSK << ILPK_SH));};
	inline void SetSerialModeELPK() {   SerialModeF ( SerialModeF() | (SER_MOD_MSK << ELPK_SH));};
	inline void SetSerialModeFDX()  {   SerialModeF ( SerialModeF() | (SER_MOD_MSK << FDX_SH));};
	inline void SetSerialModeSCR()  {   SerialModeF ( SerialModeF() | (SER_MOD_MSK << SCR_SH));};
	inline void SetSerialModeSYP()  {   SerialModeF ( SerialModeF() | (SER_MOD_MSK << SYP_SH));};

//

	//100Base-X link status. Set if the line link is OK while in the SYM mode.
	inline int   GetLinkStatus(){return (LinkStatusF() & LNK100_MSK);}; 


//
//it is not hocked up at this point 
	inline void  SetPhysicalAddress(unsigned char part0,
									unsigned char part1,
									unsigned char part2,
									unsigned char part3,
									unsigned char part4,
									unsigned char part5){
		PhysicalAddress0=part0;
		PhysicalAddress1=part1;
		PhysicalAddress2=part2;
		PhysicalAddress3=part3;
		PhysicalAddress4=part4;
		PhysicalAddress5=part5;
	
	};		

	inline unsigned char GetPhysicalAddress0(){return PhysicalAddress0;};		//PHY_ADD 28H  2DH //3.2.4.3
	inline unsigned char GetPhysicalAddress1(){return PhysicalAddress1;};		//PHY_ADD 28H  2DH //3.2.4.3
	inline unsigned char GetPhysicalAddress2(){return PhysicalAddress2;};		//PHY_ADD 28H  2DH //3.2.4.3
	inline unsigned char GetPhysicalAddress3(){return PhysicalAddress3;};		//PHY_ADD 28H  2DH //3.2.4.3
	inline unsigned char GetPhysicalAddress4(){return PhysicalAddress4;};		//PHY_ADD 28H  2DH //3.2.4.3
	inline unsigned char GetPhysicalAddress5(){return PhysicalAddress5;};		//PHY_ADD 28H  2DH //3.2.4.3

private:

	inline unsigned char SerialCommandF()const {return _ControlRegs.GetSerialCommand();};
	inline void SerialCommandF(unsigned char val){_ControlRegs.SetSerialCommand(val);};

	inline unsigned char SerialModeF()const {return _ControlRegs.GetSerialMode();};
	inline void SerialModeF(unsigned char val){_ControlRegs.SetSerialMode(val);};

	inline unsigned char LinkStatusF()const {return _ControlRegs.GetLinkStatus();};

	//PhysicalAddress functions to be determened

/*SerialCommand
The serial command register handles the control of the serial interface.

Register access R/W
Value after reset 00H

		7:6		RESERVED
MDM		5		MII data mode.
				When set, the mdio signal is in the output mode. When reset,
				the mdio signal is in the input mode.
				This bit is effective only in port 0.
MDIO	4		MII data IO.
				During write access to the MII management, the value written
				to this bit is driven onto the mdio signal. During read access,
				the mdio signal value is latched into this bit.
				This bit is effective only in port 0.
MDC		3		MII management clock.
				The value written to this bit is driven onto the mdc signal. Each
				new written value must remain stable for at least 200 ns.
				This bit is effective only in port 0.
BKP		2		Backpressure mode.
				When set, a transmission is generated upon reception of each
				packet to force a collision while the port is in the half-duplex
				mode.
FCT		1		Flow-control packet trigger.
				When set, this bit initiates a flow-control packet transmission to
				the remote node, as defined in the 802.3 IEEE Standard, while
				the port is in the full-duplex mode. This bit can be used only if
				the XON disable bit on transmit parameters register
				(TX_PARAM) is set.
		0		RESERVED
*/


enum SerialCommandShifts{
	MDM_SH=	5,		
	MDIO_SH =	4,
	MDC_SH =	3,	
	BKP_SH =	2,	
	FCT_SH =	1	
};

enum SerialCommandMasks{
	SER_COM_MSK =0x1
	};
//unsigned char SerialCommand;

/*SerialMode
The serial mode register controls the serial interface mode of work.

Register access R/W
Value after reset 00H

		7:6		RESERVED
ILPK	5		Internal loopback mode.
				When set, the port is disconnected from the line and all the
				transmitted packets are sent back to the receive side. Packets are
				not transmitted onto the line (except in the SYM mode) and
				packets received from the line are rejected.
ELPK	4		External loopback mode.
				When set, packets are being received and transmitted
				simultaneously. This mode is usable only when the external
				logic is programmed to loopback packets.
FDX		3		Full-duplex mode.
				When set, packets are being received and transmitted
				simultaneously.
		2		RESERVED
SCR		1		Scrambler mode.
				If a SYM-100Base-TX PHY is connected, this bit must be set,
				and if a SYM-100Base-FX PHY is connected, this bit must be
				reset. This bit is used only if the SYP bit is set.
SYP		0		MII/SYM port mode.
				This bit defines the MII/SYM port mode. If an MII PHY device
				is connected, this bit must be reset. If a SYM PHY device is
				connected, this bit must be set.
*/

enum SerialModeShifts{
	ILPK_SH=	5,		
	ELPK_SH =	4,
	FDX_SH =	3,	
	//-	2,	
	SCR_SH=	1,	
	SYP_SH=	0
};

enum SerialModeMasks{
	SER_MOD_MSK =0x1
	};

//unsigned char SerialMode;										//SER_MOD 21H //3.2.4.1

/*LinkStatus
The link status register indicates the link status.
Register access R

		7:1		RESERVED
LNK100	0		100Base-X link status.
				Set if the line link is OK while in the SYM mode.

*/

enum LinkStatusMask{
	LNK100_MSK=	0x1
};


//unsigned char LinkStatus;										//LNK_STT 22H //3.2.4.2

/*
PhysicalAddress
The physical address register contains the Ethernet physical address of the port. This
address is inserted to transmitted flow-control packets in the source address field.

Register access R/W

EAD		47:0	Port Ethernet address.
*/
////SIZE
unsigned char PhysicalAddress0;									//PHY_ADD 28H  2DH //3.2.4.3
unsigned char PhysicalAddress1;									//PHY_ADD 28H  2DH //3.2.4.3
unsigned char PhysicalAddress2;									//PHY_ADD 28H  2DH //3.2.4.3
unsigned char PhysicalAddress3;									//PHY_ADD 28H  2DH //3.2.4.3
unsigned char PhysicalAddress4;									//PHY_ADD 28H  2DH //3.2.4.3
unsigned char PhysicalAddress5;									//PHY_ADD 28H  2DH //3.2.4.3

BigMacControlRegs & _ControlRegs;

};


#endif //BIG_MAC_SERIAL 
