/* BigMacTransmit.h
 * BigMacDriver file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: BMTX.H $
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 6/24/99    Time: 3:53p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 21440 ISV board support removed 
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_TRANSMIT
#define BIG_MAC_TRANSMIT



class BigMacTransmit{

public:
	BigMacTransmit(BigMacControlRegs & regs):_ControlRegs(regs){
		//cout << "BigMacPortTransmit CTOR" << endl;
	};
	~BigMacTransmit(){};

//

	inline unsigned char GetTransmitStatus()const { return TransmitStatusF();};

	inline unsigned int GetTransmitStatusPKC()const { return ( TransmitStatusF() >> PKC_SH) & TX_STAT_PACK_CNT_MSK;};
	inline unsigned int GetTransmitStatusXCL()const { return ( TransmitStatusF() >> XCL_SH) & TX_STAT_MSK;};
	inline unsigned int GetTransmitStatusLCL()const { return ( TransmitStatusF() >> LCL_SH) & TX_STAT_MSK;};
	inline unsigned int GetTransmitStatusUNF()const { return ( TransmitStatusF() >> UNF_SH) & TX_STAT_MSK;};

//

	inline unsigned char GetTransmitParameters()const { return TransmitParametersF();};

	inline unsigned int GetTransmitParametersSPM()const { return ( TransmitParametersF() >> SPM_SH) & TX_PARM_MSK;};
	inline unsigned int GetTransmitParametersXOND()const { return ( TransmitParametersF() >> XOND_SH) & TX_PARM_MSK;};
	inline unsigned int GetTransmitParametersFLCE()const { return ( TransmitParametersF() >> FLCE_SH) & TX_PARM_MSK;};
	inline unsigned int GetTransmitParametersCRCD()const { return ( TransmitParametersF() >> CRCD_SH) & TX_PARM_MSK;};
	inline unsigned int GetTransmitParametersPADD()const { return ( TransmitParametersF() >> PADD_SH) & TX_PARM_MSK;};

	inline void SetTransmitParameters(unsigned char val){ TransmitParametersF (val);};

	inline void SetTransmitParametersSPM()  {   TransmitParametersF( TransmitParametersF() | (TX_PARM_MSK << SPM_SH));};
	inline void SetTransmitParametersXOND() {   TransmitParametersF( TransmitParametersF() | (TX_PARM_MSK << XOND_SH));};
	inline void SetTransmitParametersFLCE() {   TransmitParametersF( TransmitParametersF() | (TX_PARM_MSK << FLCE_SH));};
	inline void SetTransmitParametersCRCD() {   TransmitParametersF( TransmitParametersF() | (TX_PARM_MSK << CRCD_SH));};
	inline void SetTransmitParametersPADD() {   TransmitParametersF( TransmitParametersF() | (TX_PARM_MSK << PADD_SH));};

	
//
	
	inline unsigned char GetTransmitErrorMode()const { return TransmitErrorModeF();};

	inline unsigned int GetTransmitErrorModeXCLS()const { return ( TransmitErrorModeF() >> XCLS_SH) & TX_ERR_MOD_MSK;};
	inline unsigned int GetTransmitErrorModeLCLS()const { return ( TransmitErrorModeF() >> LCLS_SH) & TX_ERR_MOD_MSK;};
	inline unsigned int GetTransmitErrorModeUNFS()const { return ( TransmitErrorModeF() >> UNFS_SH) & TX_ERR_MOD_MSK;};

	inline void SetTransmitErrorMode(unsigned char val){ TransmitErrorModeF(val);};

	inline void SetTransmitErrorModeXCLS() {   TransmitErrorModeF (TransmitErrorModeF() | (TX_ERR_MOD_MSK << XCLS_SH));};
	inline void SetTransmitErrorModeLCLS() {   TransmitErrorModeF (TransmitErrorModeF() | (TX_ERR_MOD_MSK << LCLS_SH));};
	inline void SetTransmitErrorModeUNFS() {   TransmitErrorModeF (TransmitErrorModeF() | (TX_ERR_MOD_MSK << UNFS_SH));};


//

	inline unsigned char GetTransmitPacketThresholdBackoffLimit()const {
		return TransmitPacketThresholdBackoffLimitF();
	};

	inline unsigned int GetTransmitPacketThresholdBackoffLimitBKL()const {
		return ( TransmitPacketThresholdBackoffLimitF() >> BKL_SH) & TX_THLD_MSK;
	};
	inline unsigned int GetTransmitPacketThresholdBackoffLimitTSD()const {
		return ( TransmitPacketThresholdBackoffLimitF() >> TSD_SH) & TX_THLD_MSK;
	};

	
	inline void SetTransmitPacketThresholdBackoffLimit(unsigned char val){ 
		TransmitPacketThresholdBackoffLimitF(val);
	};

	inline void SetTransmitPacketThresholdBackoffLimitBKL(unsigned char val) {
		TransmitPacketThresholdBackoffLimitF( TransmitPacketThresholdBackoffLimitF() & ~(TX_THLD_MSK<<BKL_SH)); 
		TransmitPacketThresholdBackoffLimitF( TransmitPacketThresholdBackoffLimitF() | ((val&0xf)<<BKL_SH));
	};
	inline void SetTransmitPacketThresholdBackoffLimitTSD(unsigned char val) {
		TransmitPacketThresholdBackoffLimitF( TransmitPacketThresholdBackoffLimitF() & ~(TX_THLD_MSK<<TSD_SH)); 
		TransmitPacketThresholdBackoffLimitF( TransmitPacketThresholdBackoffLimitF() | ((val&0xf)<<TSD_SH));
	};


//
	inline short int	GetTransmitFlowControlPauseTime() const { return TransmitFlowControlPauseTimeF(); };
	inline 	void SetTransmitFlowControlPauseTime( short int val ) { TransmitFlowControlPauseTimeF(val); };

private:
	
	inline unsigned char TransmitStatusF()const { return _ControlRegs.GetTransmitStatus();};

	inline unsigned char TransmitParametersF()const { return _ControlRegs.GetTransmitParameters();};
	inline void TransmitParametersF(unsigned char val){ _ControlRegs.SetTransmitParameters(val);};


	inline unsigned char TransmitErrorModeF()const { return _ControlRegs.GetTransmitErrorMode();};
	inline void TransmitErrorModeF(unsigned char val){ _ControlRegs.SetTransmitErrorMode(val);};


	inline unsigned char TransmitPacketThresholdBackoffLimitF()const {
		return _ControlRegs.GetTransmitPacketSendingThresholdAndBackoffLimit();
	};
	inline void TransmitPacketThresholdBackoffLimitF(unsigned char val){
		_ControlRegs.SetTransmitPacketSendingThresholdAndBackoffLimit(val);
	};

	
	inline unsigned short int TransmitFlowControlPauseTimeF()const {return _ControlRegs.GetTransmitFlowControlPauseTime();};
	inline void TransmitFlowControlPauseTimeF(unsigned short int val){_ControlRegs.SetTransmitFlowControlPauseTime(val);};


/*
TransmitStatus
This register handles the causes for transmit stops. All bits, except PKC bits, are
reset upon reading this register. The bits in this register are set only if packet
transmission is programmed to be stopped following the corresponding error in the
transmit error mode register (TX_ERR_MOD).

Register access R
Value after reset 00H

PKC		7:6		Packet count.
				Indicates the number of packets currently stored in the transmit
				FIFO. The packet count is incremented while loading the first
				byte of a packet and decremented following transmission of a
				packet. The packet count can get a maximum value of 2.
		5:3		RESERVED
XCL		2		Excessive collision.
				Indicates that a packet was sent 16 times unsuccessfully due to
				consecutive collisions.
LCL		1		Late collision.
				Indicates that a collision has occurred after transmission of 64
				bytes.
UNF		0		FIFO underflow.
				Indicates that data was not available in the transmit FIFO
				during packet transmission, after transmission of 64 bytes.
*/


enum TransmitStatusShifts{
	PKC_SH=	6,	
	XCL_SH=	2,	
	LCL_SH=	1,	
	UNF_SH=	0
};

enum TransmitStatusMasks{
	TX_STAT_PACK_CNT_MSK =0x3,
	TX_STAT_MSK =0x1
};
	
	
//unsigned char TransmitStatus;									//TXMT_STT 03H //3.2.2.4

/*
TransmitParameters
The transmit parameters register handles the control of the transmit serial interface.

Register access R/W
Value after reset 00H


		7:5		RESERVED
SPM		4		Single packet mode.
				When set, a packet is loaded in the transmit FIFO only after the
				previous packet was fully transmitted without any error.
XOND	3		XON disable.
				When set, a flow-control packet will not be sent upon flct{i}
				signal deassertion.
FLCE	2		Flow-control mode enable.
				When set, transmission is stopped in the full-duplex mode while
				receiving flow-control packets.
CRCD	1		CRC appending disable.
				When set, packets are transmitted without padding or CRC
				appending to the end of the packet. This field is ignored if the
				txasis signal is asserted during the start of packet loading.
PADD	0		Padding appending disable.
				When set, short packets are transmitted without the addition of
				bytes complementing their sizes to 64 bytes. When the CRCD
				bit is set, this bit is ignored. This field is ignored if the txasis
				signal is asserted during the start of packet loading.
*/


enum TransmitParametersShifts{
	SPM_SH=		4,
	XOND_SH=	3,	
	FLCE_SH=	2,	
	CRCD_SH=	1,	
	PADD_SH=	0
};

enum TransmitParametersMasks{
	TX_PARM_MSK =0x1
};


//unsigned char TransmitParameters;								//TX_PARAM 13H //3.2.3.3

/*
TransmitErrorMode
The transmit error mode register controls the events that cause transmission stop. If,
during packet transmission, an error occurs and the corresponding bit is set, the
transmit FIFO is flushed, and transmission stops. The error is then reported in the
transmit error status register (TERR_STT), and can generate an interrupt according
to the interrupt enable register (INT_EN).

Register access R/W
Value after reset 00H

		7:3		RESERVED
XCLS	2		Stop transmission after excessive collisions.
				When set, packet retransmission stops after 16 attempts. When
				reset, packets will always be retransmitted following a collision
				until a successful transmission is achieved.
LCLS	1		Stop transmission after late collision.
				When set, transmission stops if a collision occurs after
				transmission of 64 bytes. When reset, the packet will be flushed
				from the transmit FIFO and the following packet will be
				transmitted.
UNFS	0		Stop transmission after FIFO underflow.
				When set, transmission stops if an underflow occurs after
				transmission of 64 bytes. When reset, the packet will be flushed
				from the transmit FIFO, and the following packet will be
				transmitted.

*/

enum TransmitErrorModeShifts{
	XCLS_SH=	2,	
	LCLS_SH=	1,	
	UNFS_SH=	0
};

enum TransmitErrorModeMasks{
	TX_ERR_MOD_MSK =0x1
};


//unsigned char TransmitErrorMode;								//TX_ERR_MOD 14H //3.2.3.4

/*
TransmitPacketSendingThresholdAndBackoffLimit
The transmit threshold and backoff register handles the control of the transmit serial
interface, including the time lapse between a collision and the transmission
following it.

Register access R/W
Value after reset A3H

BKL		7:4		Backoff limit.
				This is the maximum number used in the retransmission time
				algorithm following a collision. Lower numbers will cause
				faster retransmission times. According to Ethernet standard,
				this value must be programmed to be 10 (decimal).
TSD		3:0		Packet transmission threshold.
				Packet transmission starts when the amount of data in the
				transmit FIFO is larger than or equal to the threshold, or the
				entire packet enters onto the FIFO. The effective threshold in
				bytes is equal to 8  TSD + 4. If the sum of effective serial
				threshold and the effective parallel threshold is larger than 230
				bytes, the transmission can start before threshold is reached to
				prevent deadlock. A value of 0 is not allowed.


Packet transmission		Effective threshold		Packet transmission		Effective threshold
threshold				(bytes)					threshold				(bytes)


0						not allowed				8						68
1						12						9						76
2						20						10						84
3						28						11						92
4						36						12						100
5						44						13						108
6						52						14						116
7						60						15						124

*/

enum TransmitPacketThresholdBackoffLimitShifts{
	BKL_SH=	4,	
	TSD_SH=	0		
};

enum TransmitPacketThresholdBackoffLimitMasks{
	TX_THLD_MSK =0xf
};


//unsigned char TransmitPacketThresholdBackoffLimit;	//TX_TSHD_BOFF 15H //3.2.3.5

/*
TransmitFlowControlPauseTime
The transmit pause time register handles the time field used in the flow-control
packets.

Register access R/W

PSTM	15:0	Indicates the number of slot times during which the remote
				mode cannot send packets. This field is inserted into the
				transmitted flow-control packets.

*/

//unsigned short int TransmitFlowControlPauseTime;						//PAUSE_TIME 18H  19H //3.2.3.8


BigMacControlRegs & _ControlRegs;
};



#endif //BIG_MAC_TRANSMIT

