/*
ͻ
    Copyright (c) 1996                                                     
    by Digital Equipment Corporation, Maynard, Mass.                       
    All Rights Reserved.                                                   
                                                                            
    The information in this software is subject to change  without  notice 
    and  should  not  be  construed  as  a commitment by Digital Equipment 
    Corporation.                                                            
ͼ 
*/

#ifndef general_h
#define general_h

// function return values
#define PASS    0
#define FAIL    1
#define UNKNOWN 2

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef BYTE IEEE_address[6];

// Ethernet header format
typedef struct EthernetHeader
{
    IEEE_address    Destination;
    IEEE_address    Source;
    WORD            TypeLength;
}  EthernetHeader;

// flow-contorl packet info
#define FC_OP_0      0x00
#define FC_OP_1      0x01
#define FC_TYPE_0    0x88
#define FC_TYPE_1    0x08
#define FC_DEST_0    0x01
#define FC_DEST_1    0x80
#define FC_DEST_2    0xc2
#define FC_DEST_3    0x00
#define FC_DEST_4    0x00
#define FC_DEST_5    0x01

typedef struct TestHeader {
    BYTE NicNumber;
    BYTE PortInfo; // The leftmost but is the transmitting side (0 for DUT, 1 for PC)
                   // The remaining 7 bits are port number
    WORD PacketNumber;
} TestHeader;

typedef struct TestHeader_6Byte {
    WORD          dummy; // must be zeroes
    TestHeader    tid;
} TestHeader_6Byte;  // we use only 4 bytes out of the source address field

// general chip & board info
#define BM_CHIPS_NUM 2					// number bm of chips on board
#define GM_CHIPS_NUM 0					// number gm of chips on board
#define BM_PORTS_PER_CHIP 8
#define GM_PORTS_PER_CHIP 2
#define BM_PORTS_NUM BM_PORTS_PER_CHIP*BM_CHIPS_NUM		// total number of BM active ports
#define GM_PORTS_NUM GM_PORTS_PER_CHIP*GM_CHIPS_NUM		// total number of BM active ports
#define CHIPS_NUM (BM_CHIPS_NUM + GM_CHIPS_NUM)
#define PORTS_NUM (BM_PORTS_NUM + GM_PORTS_NUM)  	// total number of active ports on board

#define CONTROLLER_NAME "/bm/tcontroller"

// common file names
#define CHKR_RX_D_FILE	 "dut_buf.data"
#define CHKR_RX_C_FILE	 "dut_buf.ctrl"
#define CHKR_TX_D_FILE	 "dut_buf.data.tx"
#define CHKR_TX_C_FILE	 "dut_buf.ctrl.tx"
#define CHKR_REGS_FILE	 "dut_buf.regs"
#define CHKR_MODE_FILE	 "dut_buf.mode"
#define CHKR_SCRIPT_FILE "script"
#define TX_RAM_FILE		  "dut_tx_ram"
#define SET_REG_FILE	  "set_file"

#define DATA_DIR_PATTERN	   "n%dp%d"
#define DATA_PATH_PATTERN 	   "/usr/chkr/"
#define DEFAULT_FILE_BASE  "default"
#define NEW_SCRIPT_FILE    "new_script"
#define TABLE_FILE "GPCStable.txt"               //table of GPCS symbol values
// devices
#define BM_DEV 0
#define GM_DEV 1
#define BM_ALT_DEV 2
#define BG_ALT_DEV 3
#define SER_ALT_DEV 3
#define BM_DEVICE_NAME		"BM"
#define GM_DEVICE_NAME		"GM"
#define ALTERA_DEVICE_NAME  "ALT"

#define DUT_AGENT_BASE      100

#define my_delay(xxxx)  { int cccc; for (cccc=0; cccc<xxxx; cccc++); }
#define W_DELAY 300

TestHeader extract_TestHeader(char *data);
void diffclock (struct timespec *big, struct timespec *small, struct timespec *diff);
int check_create_path (char *path);
int file2buff (char *filename, DWORD *len, char **buff);
DWORD set_bit_val (DWORD bit_val ,DWORD dw_mask);
DWORD get_bit_val (DWORD bit_val ,DWORD dw_mask);
void log_msg(char *p_pc_msg);
void log_test_result(char *p_pc_source, char *p_pc_desc, int p_i_result, char *p_pc_note);

#endif
