/*
ͻ
    Copyright (c) 1996                                                     
    by Digital Equipment Corporation, Maynard, Mass.                       
    All Rights Reserved.                                                   
                                                                            
    The information in this software is subject to change  without  notice 
    and  should  not  be  construed  as  a commitment by Digital Equipment 
    Corporation.                                                            
ͼ 
*/
#ifndef _PCI_OP_H_
#define _PCI_OP_H_

#include "general.h"
#include <sys/types.h>


#define PLX_DEVICE_ID                0x9050           
#define PLX_VENDOR_ID                0x10b5          

#define DC21x4x_VENDOR_ID				 0x1011
#define DC21040_DEVICE_ID                0x2  // Tulip2
#define DC21041_DEVICE_ID                0x14 // Tulip3
#define DC21140_DEVICE_ID                0x9  // Fasternet
#define DC21143_DEVICE_ID                0x19  // Greenet


typedef struct PCI_reg_desc_s {
	int len; // length of register, in bytes
	char *desc; // register's description
} PCI_reg_desc;

extern PCI_reg_desc PCIregs[0x40]; //defined in pci_reg.c or pci_op.c
extern PCI_reg_desc LocalRegs[0x64];

int PCIinit (int device_id, int vendor_id);
int PCIend ();
int PCIread_reg (int offset, unsigned long *value);
int PCIwrite_reg (int offset, unsigned long value);
int PCIread_local_reg (int offset, unsigned long *value);
int PCIwrite_local_reg (int offset, unsigned long value);
int PCIread_mem (unsigned long addr, unsigned long *contents);
int PCIwrite_mem (unsigned long addr, unsigned long contents);

int PCIget_local_conf (unsigned long **addr);
int PCIget_base_addr (int range, unsigned long mem_offset, unsigned long size, unsigned char **addr);


int PCIhint_attach (pid_t ( far *handler)(void), unsigned ds);
int PCIhint_enable ();
int PCIhint_disable ();

#endif