/* SnmpStats.h
 * BigMacDriver SNMP Statistics file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: BigMacDriver
 * author: sk, Jun 98 Initial version
 * $History: SNMPST.H $
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 6/24/99    Time: 3:53p
 * Updated in $/dev_1200/SA1_CoreLibs/OctalMAC_21440
 * 21440 ISV board support removed 
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 4/07/99    Time: 3:47p
 * Updated in $/development/BigMAC_21440
 * 1 adopted to ucos
 * 2 SemDispachEvent = new Semaphore(); insted of creating on the stack
 * 3 ISR algoritm changed to "OR" 
 * 
 * *****************  Version 5  *****************
 * User: Skornfel     Date: 2/12/99    Time: 3:44p
 * Updated in $/development/BigMAC_21440
 * BL5 implemented 
 * code still have QNX calls and   #ifdefs , but not tested on QNX
 * Tested on NT/VxWorks
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 1/27/99    Time: 11:40a
 * Updated in $/development/BigMAC_21440
 * just to move working directory to my new computer
 * 1.Some BL5 staff implemented
 * 2. VxWorks port
 * 3...
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 12/02/98   Time: 5:07p
 * Updated in $/BL3_Release/BigMAC_21440
 * Base Level 4 driver - runs on QNX(21440) and NT(simulated)
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 8/10/98    Time: 10:08a
 * Updated in $/base_level3/BigMAC
 * General Driver Structure complete, Not testted on HW or Transactor
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 6/24/98    Time: 6:34p
 * Created in $/base_level3/BigMAC
 * Just to save My typing it is not MAC Driver yet
 * 
 * ---------------------------------------------------------------------
 */

#ifndef BIG_MAC_SNMP_STATS
#define BIG_MAC_SNMP_STATS


//HH#include "BigMacNetStats.h"
#include "bmnetst.h"

class SnmpStats{


public:
	SnmpStats(BigMacNetStats & stats):_MacNetStats(stats){
		//cout << "SnmpStats CTOR" << endl;
	};

	~SnmpStats(){}; 

	inline SnmpStats * GetSnmpCounters()			{return this;};

	inline void UpdateSnmpCounters() {
		CalculateFramesTransmittedOK();		
		CalculateSingleCollisionFrames();	
		CalculateMultipleCollisionFrames();	
		CalculateFramesReceivedOK();			
		CalculateFramesCheckSequenceErrors();
		CalculateAlignmentErrors();			
		CalculateOctetsTransmittedOK();		
		CalculateFramesWithDeferredXmissions();
		CalculateLateCollisions();			
		CalculateFramesAbortedDueToXSColls();
		CalculateOctetsReceivedOK();			
		CalculateFrameTooLongErrors();		
		CalculateMulticastFramesXmittedOK();	
		CalculateBroadcastFramesReceivedOK();
		CalculateMulticastFramesReceivedOK();
		CalculateBroadcastFramesXmittedOK();	
		CalculatePauseFramesTransmitted();	
		CalculatePauseFramesReceived();		
	};

	inline unsigned int GetFramesTransmittedOK()		{return FramesTransmittedOK;};
	inline unsigned int GetSingleCollisionFrames()		{return SingleCollisionFrames;};
	inline unsigned int GetMultipleCollisionFrames()	{return MultipleCollisionFrames;};
	inline unsigned int GetFramesReceivedOK()			{return FramesReceivedOK;};
	inline unsigned int GetFramesCheckSequenceErrors()	{return FramesCheckSequenceErrors;};
	inline unsigned int GetAlignmentErrors()			{return AlignmentErrors;};
	inline unsigned int GetOctetsTransmittedOK()		{return OctetsTransmittedOK;};
	inline unsigned int GetFramesWithDeferredXmissions(){return FramesWithDeferredXmissions;};
	inline unsigned int GetLateCollisions()				{return LateCollisions;};
	inline unsigned int GetFramesAbortedDueToXSColls()	{return FramesAbortedDueToXSColls;};
	inline unsigned int GetOctetsReceivedOK()			{return OctetsReceivedOK;};
	inline unsigned int GetFrameTooLongErrors()			{return FrameTooLongErrors;};
	inline unsigned int GetMulticastFramesXmittedOK()	{return MulticastFramesXmittedOK;};
	inline unsigned int GetBroadcastFramesReceivedOK()	{return BroadcastFramesReceivedOK;};
	inline unsigned int GetMulticastFramesReceivedOK()	{return MulticastFramesReceivedOK;};
	inline unsigned int GetBroadcastFramesXmittedOK()	{return BroadcastFramesXmittedOK;};
	inline unsigned int GetPauseFramesTransmitted()		{return PauseFramesTransmitted;};
	inline unsigned int GetPauseFramesReceived()		{return PauseFramesReceived;};



	inline void CalculateFramesTransmittedOK()		{ FramesTransmittedOK = _MacNetStats.GetTxUniOkCnt() + _MacNetStats.GetTxMltOkCnt() + _MacNetStats.GetTxBrdOkCnt();};
	inline void CalculateSingleCollisionFrames()	{ SingleCollisionFrames = _MacNetStats.GetTxScolCnt();};
	inline void CalculateMultipleCollisionFrames()	{ MultipleCollisionFrames = _MacNetStats.GetTxMcolCnt();};//GetRxMcolCnt SK!!!
	inline void CalculateFramesReceivedOK()			{ FramesReceivedOK = _MacNetStats.GetRxUniOkCnt() + _MacNetStats.GetRxMltOkCnt() + _MacNetStats.GetRxBrdOkCnt();;};
	inline void CalculateFramesCheckSequenceErrors(){ FramesCheckSequenceErrors = _MacNetStats.GetRxNormCrcCnt();};
	inline void CalculateAlignmentErrors()			{ AlignmentErrors = _MacNetStats.GetRxNormAliCnt();};
	inline void CalculateOctetsTransmittedOK()		{ OctetsTransmittedOK = _MacNetStats.GetTxOctOkCnt();};
	inline void CalculateFramesWithDeferredXmissions(){ FramesWithDeferredXmissions = _MacNetStats.GetTxDeferCnt();};
	inline void CalculateLateCollisions()			{ LateCollisions = _MacNetStats.GetTxLcolCnt();};
	inline void CalculateFramesAbortedDueToXSColls(){ FramesAbortedDueToXSColls = _MacNetStats.GetTxLcolCnt();};
	inline void CalculateOctetsReceivedOK()			{ OctetsReceivedOK = _MacNetStats.GetRxOctOkCnt();};
	inline void CalculateFrameTooLongErrors()		{ FrameTooLongErrors = _MacNetStats.GetRxLongOkCnt() + _MacNetStats.GetRxLongCrcCnt();};
	inline void CalculateMulticastFramesXmittedOK()	{ MulticastFramesXmittedOK = _MacNetStats.GetTxMltOkCnt();};
	inline void CalculateBroadcastFramesReceivedOK(){ BroadcastFramesReceivedOK = _MacNetStats.GetRxBrdOkCnt();};
	inline void CalculateMulticastFramesReceivedOK(){ MulticastFramesReceivedOK = _MacNetStats.GetRxMltOkCnt();};
	inline void CalculateBroadcastFramesXmittedOK()	{ BroadcastFramesXmittedOK = _MacNetStats.GetTxBrdOkCnt();};
	inline void CalculatePauseFramesTransmitted()	{ PauseFramesTransmitted = _MacNetStats.GetRxPauseCnt();};
	inline void CalculatePauseFramesReceived()		{ PauseFramesReceived = _MacNetStats.GetTxPauseCnt();};

	inline void Show(){
cout 

           << "FramesTransmittedOK          " << FramesTransmittedOK   << endl
           << "SingleCollisionFrames        " << SingleCollisionFrames  << endl
           << "MultipleCollisionFrames      " << MultipleCollisionFrames  << endl
           << "FramesReceivedOK             " << FramesReceivedOK   << endl
           << "FramesCheckSequenceErrors    " << FramesCheckSequenceErrors   << endl
           << "AlignmentErrors              " << AlignmentErrors   << endl
           << "OctetsTransmittedOK          " << OctetsTransmittedOK  << endl
           << "FramesWithDeferredXmissions  " << FramesWithDeferredXmissions  << endl
           << "LateCollisions               " << LateCollisions  << endl
           << "FramesAbortedDueToXSColls    " << FramesAbortedDueToXSColls   << endl
           << "OctetsReceivedOK             " << OctetsReceivedOK  << endl
           << "FrameTooLongErrors           " << FrameTooLongErrors  << endl
           << "MulticastFramesXmittedOK     " << MulticastFramesXmittedOK  << endl
           << "BroadcastFramesReceivedOK    " << BroadcastFramesReceivedOK  << endl
           << "MulticastFramesReceivedOK    " << MulticastFramesReceivedOK   << endl
           << "BroadcastFramesXmittedOK     " << BroadcastFramesXmittedOK  << endl
           << "PauseFramesTransmitted       " << PauseFramesTransmitted  << endl
           << "PauseFramesReceived          " << PauseFramesReceived << endl;
	}

private:


public:
//BigMacNetStats NetStats;

//SNMP Counters
//lets see later if int is not long enought


unsigned int FramesTransmittedOK;		//TX_UNI_OK_CNT + TX_MLT_OK_CNT + TX_BRD_OK_CNT
unsigned int SingleCollisionFrames;		//TX_SCOL_CNT
unsigned int MultipleCollisionFrames;	//RX_MCOL_CNT
unsigned int FramesReceivedOK;			//RX_UNI_OK_CNT + RX_MLT_OK_CNT + RX_BRD_OK_CNT
unsigned int FramesCheckSequenceErrors;	//RX_NORM_CRC_CNT
unsigned int AlignmentErrors;			//RX_NORM_ALI_CNT
unsigned int OctetsTransmittedOK;		//TX_OCT_OK_CNT
unsigned int FramesWithDeferredXmissions;//TX_DEFER_CNT
unsigned int LateCollisions;			//TX_LCOL_CNT
unsigned int FramesAbortedDueToXSColls;	//TX_XCOL_CNT
unsigned int OctetsReceivedOK;			//RX_OCT_OK_CNT
unsigned int FrameTooLongErrors;		//RX_LONG_OK_CNT + RX_LONG_CRC_CNT
unsigned int MulticastFramesXmittedOK;	//TX_MLT_OK_CNT
unsigned int BroadcastFramesReceivedOK;	//RX_BRD_OK_CNT
unsigned int MulticastFramesReceivedOK;	//RX_MLT_OK_CNT
unsigned int BroadcastFramesXmittedOK;	//TX_BRD_OK_CNT
unsigned int PauseFramesTransmitted;	//TX_PAUSE_CNT
unsigned int PauseFramesReceived;		//RX_PAUSE_CNT

private:
BigMacNetStats & _MacNetStats;

};


#endif //BIG_MAC_SNMP_STATS 

