#ifndef THREAD_SIGNAL
#define THREAD_SIGNAL

//#define VX_WORKS
// #define WIN32


#ifdef WIN32
#include<wtypes.h>
#include<WINBASE.H>


class Semaphore{

public:
	Semaphore ()         { SemaphoreHandle = CreateSemaphore( NULL, 0, 100, NULL);};
	Semaphore (int state){ SemaphoreHandle = CreateSemaphore( NULL, state, 100, NULL);};

	~Semaphore(){CloseHandle(SemaphoreHandle);};
	
	inline void
	Take(){
		Status = WaitForSingleObject(SemaphoreHandle, INFINITE);
	};

	inline void
	Give(){
		ReleaseSemaphore( SemaphoreHandle, 1, NULL );
	};

private:
	HANDLE SemaphoreHandle;
	unsigned int Status;
	
};



class Thread{

public:
	Thread (void (*runfunction)()){ RunFunction = runfunction; dwThreadParm = 1; Run();};

	~Thread(){CloseHandle(ThreadHandle);};
	
	//DWORD
	//ThreadFunc(LPDWORD lpdwParm){
	//	(*RunFunction)();
	//	return 0;
	//};

	inline void
	Run(){
		ThreadHandle = CreateThread
			( NULL,			//NO SECURITY
		    0,				//DEF STACK SIZE
			(LPTHREAD_START_ROUTINE) RunFunction, //Thread to run
			&dwThreadParm,	// ARG to thread
			0,				//DEF Creation flags
			&dwThreadId);	//returns thread id

		//SetThreadPriority(ThreadHandle, THREAD_PRIORITY_TIME_CRITICAL);
	};
    HANDLE GetThreadHandle() const {return ThreadHandle;};

private:
	HANDLE ThreadHandle;
	DWORD dwThreadId;
	DWORD dwThreadParm;
	void (*RunFunction)();

};


#endif //WIN32



#ifdef VX_WORKS
#include <semLib.h>
#include <taskLib.h>
#include <semaphore.h>
class Semaphore{

#ifdef POSIX
public:
	Semaphore ()         { ReturnVal = sem_init(&SemaphoreHandle, 0,0);};
	Semaphore (int state){ ReturnVal = sem_init(&SemaphoreHandle,0, state);};

	~Semaphore(){sem_destroy(&SemaphoreHandle);};
	
	inline void
	Take(){ReturnVal = sem_wait(&SemaphoreHandle);   
	};

	inline void
	Give(){
		ReturnVal = sem_post(&SemaphoreHandle );
	};

	inline int
	GetReturnCode (){
		return ReturnVal;	
	};
 
private:
    sem_t   SemaphoreHandle;
    int ReturnVal;
};

 
#else
public:
	Semaphore ()         { SemaphoreHandle = semCCreate( SEM_Q_FIFO, 0);};
	Semaphore (int state){ SemaphoreHandle = semCCreate( SEM_Q_FIFO, state);};

	~Semaphore(){semDelete(SemaphoreHandle);};
	
	inline void
	Take(){
		ReturnVal = semTake(SemaphoreHandle, WAIT_FOREVER);
	};

	inline void
	Give(){
		ReturnVal = semGive( SemaphoreHandle );
	};

	inline int
	GetReturnCode (){
		return ReturnVal;	
	};
 
private:
	SEM_ID SemaphoreHandle;
	int ReturnVal;
};

#endif

class Thread{

public:
	Thread (void (*runfunction)()){ RunFunction = runfunction; Run();};

	~Thread(){taskDelete(ThreadHandle);};
	
	//DWORD
	//ThreadFunc(LPDWORD lpdwParm){
	//	(*RunFunction)();
	//	return 0;
	//};

	inline void
	Run(){
		ThreadHandle = taskSpawn
			( NULL,			//task name tn will be assigned
		    80,//100,            //Priority
			0,              //option word
			8096, //1024,			//stack size bytes
			(FUNCPTR) RunFunction, //Thread to run
			0,0,0,0,0,0,0,0,0,0				//args
			);	//returns thread id

		//SetThreadPriority(ThreadHandle, THREAD_PRIORITY_TIME_CRITICAL);
	};
	Get_ThreadId() const {return ThreadHandle;};

private:
	int ThreadHandle;
	void (*RunFunction)();
};

#endif //VX_WORKS


#endif //THREAD_SIGNAL
