CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

LIB		= $(LIB_DIR)\pciComm.a
TEST		= $(LIB_DIR)\vxWorks_pciCommTest.o

TGT_DIR=$(WIND_BASE)/target

include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

LIBRARIES = $(LIB_DIR)/pciComm.a
	
	
INCLUDE = \
	-I../../utils \
	-I../../osApi \
	-I../../include \
	-I../../BoardSupport/VxWorks/ixp1200eb \
	-I../core_utils 

ADDED_C++FLAGS  = -w -Wall -pedantic -DSA_1200 -DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS \
 -D__unix $(INCLUDE)

TEST_OBJS = 	pcitest.o

LIB_OBJS = 	pci.o devnode.o pciinit.o pcisignal.o \
		pcishow.o pcimail.o pcimsgq.o pciaccess.o

.SUFFIXES: .o .cpp .c .h .hxx

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe : lib

all : lib test

lib : $(LIB)

test : $(TEST)

$(LIB) : $(LIB_OBJS)
	@ if not exist "$(LIB_DIR)/$(NULL)" mkdir "$(LIB_DIR)"
	$(AR) -rc $(LIB) $(LIB_OBJS)

$(TEST): $(TEST_OBJS) lib
	ldarm --whole-archive -r -o pcitestx.o $(TEST_OBJS) $(LIBRARIES)
	nmarm pcitestx.o | munch > __CtorDtorx.c
	$(CC)  $(DBG_FLAG) -c -traditional __CtorDtorx.c -o __CtorDtorx.o
	ldarm -o $@ -r __CtorDtorx.o pcitestx.o

clean_lib :
	$(RM) $(LIB_OBJS) $(LIB)

clean_test :
	$(RM) $(TEST) $(TEST_OBJS) pcitestx.o __CtorDtorx.c __CtorDtorx.o

clean	: clean_lib clean_test
	$(RM) $(LIB_OBJS) $(LIB) $(TEST) $(TEST_OBJS)
