/* Test_Utilities.c
 * 
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: System Test
 * author: Lai-Wah Hui March 6, 98 Initial version
 * revisions:
 * $History: Test_Utilities.cpp $
 * 
 * *****************  Version 9  *****************
 * User: Lhui         Date: 4/30/99    Time: 3:46p
 * Updated in $/Internal/qa-tests/C-Utilities
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 11/11/98   Time: 10:00a
 * Updated in $/development/qa-test/C-Utilities
 * Add support for automation tests
 * 
 * *****************  Version 4  *****************
 * User: Drjohns1     Date: 6/19/98    Time: 2:39p
 * Updated in $/base_level3/qa-test/C-Utilities
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 5/20/98    Time: 6:29p
 * Updated in $/base_level2/qa-test/C-Utilities
 * Replace Digital copyright with Intel copyright statement
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 3/13/98    Time: 5:06p
 * Updated in $/base_level1/qa-test/C-Utilities
 * Add VxWork main function
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 3/11/98    Time: 10:16a
 * Created in $/base_level1/qa-test/C-Utilities
 */ 
#include <stdio.h>
#include "Test_Utilities.h"
#ifdef VxWorkTest 
#include "xact.h"
#endif


/*-----------------------------------------------------------------------------
   Function: 	TestCntInc
   Description: 
   Returns: 
   Uses:
   Modifies:
-----------------------------------------------------------------------------*/
int TestCntInc(int Reset, int cnt)
{
    static AllCnt=0;
    if(Reset)
        AllCnt = 0;
    else
        AllCnt = AllCnt+ cnt;
    
    return(AllCnt);
}

/*-----------------------------------------------------------------------------
   Function: 	FailCntInc
   Description: 
   Returns: 
   Uses:
   Modifies:
-----------------------------------------------------------------------------*/
int FailCntInc(int Reset, int cnt)
{
    static FailCnt=0;

    if(Reset)
        FailCnt = 0;
    else
        FailCnt = FailCnt + cnt;

    return(FailCnt);
}


/*-----------------------------------------------------------------------------
   Function: 	Utilities_Register
   Description: 
   Returns: 
   Uses:
   Modifies:
-----------------------------------------------------------------------------*/

int Utilities_Register()
{
    if (!XACT_register_console_function("FailCntInc", FailCntInc, 0, 2) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("TestCntInc", TestCntInc, 0, 2) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    return (1);

}

#ifdef VxWorkTest
int VxWorkmain( int argc, char *argv[] )
	{
	
	if ( transactor_init() == FALSE )
		return 0;	// error occurred

	/* start up the console */
	console( argc, argv );

	transactor_exit();

	return TRUE;
	}

int SA1200CoreTest(char *testind)
	{

	
	if ( transactor_init() == FALSE )
		return 0;	// error occurred

	XACT_ExecuteCommandStr(testind);

	transactor_exit();

	return TRUE;
	}


#endif

