CPU		= ARMSA110
TOOL		= gnu
INCLUDE = \
-I../../include \
-I../../utils \
-I../uclo \
-I../../Win32DevTools/ucld \
-I../xact_io \
-I../libd \
-I../msgq \
-I../driver \
-I../sv_libs \
-I../pci_driver \
-I../ueng \
-I../debug_1200 \
-I../../share/RemoteServices




ADDED_C++FLAGS  = -w -Wall -pedantic -Dast_parse -Dxactor_build -DVxWorkTest \
 -DLIBD_TEST -DSVLIB_TEST -DUDEBUG -DRS_UDEBUG\
 -Dext_model_port -DUSE_AMBAIO -DUCLO_TEST -Dno_uca_code_gen -Dnew_sdram -Dbuild_without_main \
 -DVX_WORKS -DXACT -DUENGINE_DRIVER -D__unix -DIOSTYLE=AMBAIO\
 $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
default		: $(DEMO_DIR)
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)
default		: $(DEMO_DIR)

CORE_debug			:
			$(CC) -g $(C++FLAGS) -c ../uclo/uclo.c 
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_bits.c
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_crc.c 
			$(CC) -g $(C++FLAGS) -c ../xact_io/xact_api.cpp 
			$(CC) -g $(C++FLAGS) -c ../xact_io/ambaio.cpp 
			$(CC) -g $(C++FLAGS) -c uclo_test.cpp 
			$(CC) -g $(C++FLAGS) -c Test_Utilities.cpp
			$(CC) -g $(C++FLAGS) -c test_registration.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/sem.c
			$(CC) -g $(C++FLAGS) -c ../../utils/thread.c
			$(CC) -g $(C++FLAGS) -c ../../utils/delay.c
			$(CC) -g $(C++FLAGS) -c ../libd/libd.c
			$(CC) -g $(C++FLAGS) -c ../libd/test_lib.c
			$(CC) -g $(C++FLAGS) -c ../msgq/msgq.cpp
			$(CC) -g $(C++FLAGS) -c ../msgq/msgqmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../driver/UcommDriver.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/hashsv.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/memsv.cpp
			$(CC) -g $(C++FLAGS) -c svlib_tests.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_proc.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_xdr.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_svc.c
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pci.c 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/devnode.c 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciinit.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcishow.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcimail.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcimsgq.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciaccess.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciTest.cpp  
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcisignal.cpp 
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng.cpp
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng_clib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_lib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_clib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_umm.cpp
			$(CC) -g $(C++FLAGS) -c udbg_test.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/control.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_clnt.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_xdr.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udbg_interface.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_svc.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_xdr.c
			$(CC) -g $(C++FLAGS) -c rs_udbg_TestServer.cpp


			ldarm -o archmodel.o -r \
			../../vxworks_lib/debug/archmodelOUT.o \
			ueng.o \
			ueng_clib.o \
			udbg_lib.o \
			udbg_clib.o \
			udbg_umm.o \
			udbg_test.o \
			control.o \
			rs_uDbg_events_clnt.o \
			rs_uDbg_events_xdr.o \
			rs_udbg_interface.o \
			rs_udebug_svc.o \
			rs_udebug_xdr.o \
			rs_udbg_TestServer.o \
			uclo.o \
			utl_bits.o \
			utl_crc.o \
			xact_api.o \
                        ambaio.o \
			uclo_test.o \
			Test_Utilities.o \
			test_registration.o \
			sem.o \
			thread.o \
			libd.o \
			test_lib.o \
			UcommDriver.o \
			msgq.o \
			msgqmgr.o \
			poolmgr.o \
                        hashsv.o \
                        memsv.o \
                        svlib_tests.o \
			xact_registration.o \
                        rs_proc.o \
			rs_xact_xdr.o \
                        rs_xact_svc.o  \
			pci.o \
			devnode.o \
			pciinit.o \
			pcishow.o \
			pcimail.o \
			pcimsgq.o \
			pciaccess.o \
			pciTest.o \
			delay.o \
 			pcisignal.o 


			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/debug/AMBA_SA1200Core.o -r __CtorDtor.o archmodel.o

CORE_release		:
			$(CC) $(C++FLAGS) -c ../uclo/uclo.c 
			$(CC) $(C++FLAGS) -c ../../utils/utl_bits.c
			$(CC) $(C++FLAGS) -c ../../utils/utl_crc.c 
			$(CC) $(C++FLAGS) -c ../xact_io/xact_api.cpp 
			$(CC) $(C++FLAGS) -c ../xact_io/ambaio.cpp 
			$(CC) $(C++FLAGS) -c uclo_test.cpp 
			$(CC) $(C++FLAGS) -c Test_Utilities.cpp
			$(CC) $(C++FLAGS) -c test_registration.cpp
			$(CC) $(C++FLAGS) -c ../../utils/sem.c
			$(CC) $(C++FLAGS) -c ../../utils/thread.c
			$(CC) $(C++FLAGS) -c ../../utils/delay.c
			$(CC) $(C++FLAGS) -c ../libd/libd.c
			$(CC) $(C++FLAGS) -c ../libd/test_lib.c
			$(CC) $(C++FLAGS) -c ../msgq/msgq.cpp
			$(CC) $(C++FLAGS) -c ../msgq/msgqmgr.cpp
			$(CC) $(C++FLAGS) -c ../driver/UcommDriver.cpp
			$(CC) $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) $(C++FLAGS) -c ../sv_libs/hashsv.cpp
			$(CC) $(C++FLAGS) -c ../sv_libs/memsv.cpp
			$(CC) $(C++FLAGS) -c svlib_tests.cpp
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_proc.c
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_xdr.c
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_svc.c
			$(CC) $(C++FLAGS) -c ../pci_driver/pci.c 
			$(CC) $(C++FLAGS) -c ../pci_driver/devnode.c 
			$(CC) $(C++FLAGS) -c ../pci_driver/pciinit.cpp 
			$(CC) $(C++FLAGS) -c ../pci_driver/pcishow.cpp 
			$(CC) $(C++FLAGS) -c ../pci_driver/pcimail.cpp 
			$(CC) $(C++FLAGS) -c ../pci_driver/pcimsgq.cpp 
			$(CC) $(C++FLAGS) -c ../pci_driver/pciaccess.cpp 
			$(CC) $(C++FLAGS) -c ../pci_driver/pciTest.cpp  
			$(CC) $(C++FLAGS) -c ../pci_driver/pcisignal.cpp 
			$(CC) $(C++FLAGS) -c ../ueng/ueng.cpp
			$(CC) $(C++FLAGS) -c ../ueng/ueng_clib.cpp
			$(CC) $(C++FLAGS) -c ../debug_1200/udbg_lib.cpp
			$(CC) $(C++FLAGS) -c ../debug_1200/udbg_clib.cpp
			$(CC) $(C++FLAGS) -c ../debug_1200/udbg_umm.cpp
			$(CC) $(C++FLAGS) -c udbg_test.cpp
			$(CC) $(C++FLAGS) -c ../debug_1200/control.cpp
			$(CC) $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_clnt.c
			$(CC) $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_xdr.c
			$(CC) $(C++FLAGS) -c ../../share/rs_udebug/rs_udbg_interface.cpp
			$(CC) $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_svc.c
			$(CC) $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_xdr.c
			$(CC) $(C++FLAGS) -c rs_udbg_TestServer.cpp



			ldarm -o archmodel.o -r \
			../../vxworks_lib/archmodelOUT.o \
			ueng.o \
			ueng_clib.o \
			udbg_lib.o \
			udbg_clib.o \
			udbg_umm.o \
			udbg_test.o \
			control.o \
			rs_uDbg_events_clnt.o \
			rs_uDbg_events_xdr.o \
			rs_udbg_interface.o \
			rs_udebug_svc.o \
			rs_udebug_xdr.o \
			rs_udbg_TestServer.o \
			uclo.o \
			utl_bits.o \
			utl_crc.o \
			xact_api.o \
                        ambaio.o \
			uclo_test.o \
			Test_Utilities.o \
			test_registration.o \
			sem.o \
			thread.o \
			libd.o \
			test_lib.o \
			xact_registration.o \
			UcommDriver.o \
			hashsv.o \
                        memsv.o \
			poolmgr.o \
			msgq.o \
			msgqmgr.o \
                        svlib_tests.o \
                        rs_proc.o \
			rs_xact_xdr.o \
                        rs_xact_svc.o \
			pci.o \
			devnode.o \
			pciinit.o \
			pcishow.o \
			pcimail.o \
			pcimsgq.o \
			pciaccess.o \
			delay.o \
			pciTest.o \
			pcisignal.o 

			nmarm archmodel.o | munch > __CtorDtor.c
				$(CC) -g $(C++FLAGS) -c ../uclo/uclo.c 
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_bits.c
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_crc.c 
			$(CC) -g $(C++FLAGS) -c ../xact_io/xact_api.cpp 
			$(CC) -g $(C++FLAGS) -c ../xact_io/ambaio.cpp 
			$(CC) -g $(C++FLAGS) -c uclo_test.cpp 
			$(CC) -g $(C++FLAGS) -c Test_Utilities.cpp
			$(CC) -g $(C++FLAGS) -c test_registration.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/sem.c
			$(CC) -g $(C++FLAGS) -c ../../utils/thread.c
			$(CC) -g $(C++FLAGS) -c ../../utils/delay.c
			$(CC) -g $(C++FLAGS) -c ../libd/libd.c
			$(CC) -g $(C++FLAGS) -c ../libd/test_lib.c
			$(CC) -g $(C++FLAGS) -c ../msgq/msgq.cpp
			$(CC) -g $(C++FLAGS) -c ../msgq/msgqmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../driver/UcommDriver.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/hashsv.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/memsv.cpp
			$(CC) -g $(C++FLAGS) -c svlib_tests.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_proc.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_xdr.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_svc.c
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pci.c 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/devnode.c 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciinit.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcishow.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcimail.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcimsgq.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciaccess.cpp 
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pciTest.cpp  
			$(CC) -g $(C++FLAGS) -c ../pci_driver/pcisignal.cpp 
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng.cpp
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng_clib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_lib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_clib.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_umm.cpp
			$(CC) -g $(C++FLAGS) -c  udbg_test.cpp
			$(CC) -g $(C++FLAGS) -c ../debug_1200/control.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_clnt.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_xdr.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udbg_interface.cpp
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_svc.c
			$(CC) -g $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_xdr.c
			$(CC) -g $(C++FLAGS) -c rs_udbg_TestServer.cpp
		$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/AMBA_SA1200Core.o -r __CtorDtor.o archmodel.o

clean		: 
		$(RM) *.o

