/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* hal_console.h
 * register console functions so they can be called from cmd line
 *
 *
 * system: SA1200
 * subsystem: core build
 * author: Don Hooper 5/17/98
 * revisions:
  * 
 * 
 */ 
#ifndef HAL_CONSOLE_H
#define HAL_CONSOLE_H

#include "delay.h"

extern int hal_model_initialize ();

extern unsigned int csr_set(char *unit, char *reg, unsigned int val);
extern unsigned int csr_get(char *unit, char *reg);
extern unsigned int sdram_write(unsigned int lwaddr, unsigned int val);
extern unsigned int sdram_read(unsigned int lwaddr);
extern unsigned int sram_write(unsigned int lwaddr, unsigned int val);
extern unsigned int sram_read(unsigned int lwaddr);

extern void sram_push(unsigned short queue, unsigned int addr);
extern void sram_pop(unsigned short queue, unsigned int addr);

extern void sram_set_bits(unsigned int lwaddr, unsigned int value);
extern void sram_clear_bits(unsigned int lwaddr, unsigned int value);

extern void sram_read_lock(unsigned int lwaddr, unsigned int *value);
extern void sram_write_unlock(unsigned int lwaddr, unsigned int value);

extern unsigned int sram_test_and_clear_bits(unsigned int lwaddr, unsigned int setval);
extern unsigned int sram_test_and_set_bits(unsigned int lwaddr, unsigned int setval);

extern int hal_testall();

extern bool Locked(void); 
extern bool LockRetry(void); 



#endif		// HAL_CONSOLE_H