/* hw_svlib_tests.cpp
 *
 ** ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Xact_IO
 * author: Don Hooper 1/29/98
 * revisions:
 * $History
 * 
 * 
 */ 
/*=================================================================*/

#include <stdio.h>
#include "ueng.h"
#include "debug_1200.h"
#include "debug_1200.hxx"
//#include "hal_sram.h"
//#include "sram_man.h"
#include "config_1200.h"
#include "uclo.h"
#include "memsv.h"
#include "hashsv.h"
#include "ts.h"
#include "thread.h"

int libdInitialized = 0;
extern "C" int NetApp_Init(void);
extern "C" int NetApp_Run(unsigned int engine_mask, unsigned int port_mask);
//
// 2-way sync memory service library test
//
extern void svlib_testCase_1();
extern void svlib_testCase_2();
extern void svlib_testCase_3();
extern void svlib_testCase_4();
extern void svlib_testCase_5();
extern void svlib_testCase_11();
extern void svlib_testCase_12();
extern void svlib_testCase_13();
extern void svlib_testCase_14();
extern void svlib_testCase_21();
extern void svlib_testCase_22();
extern void svlib_testCase_23();
extern void svlib_testCase_24();
extern void svlib_testCase_25();
extern void svlib_testCase_26();
extern void svlib_testCase_27();
extern void svlib_testCase_28();
extern void svlib_testCase_29();
extern void svlib_testCase_33();
extern void svlib_testCase_43();
extern void svlib_testCase_101();
extern void svlib_testCase_102();
extern void svlib_testCase_103();
extern void svlib_testCase_104();
extern void svlib_testCase_105();
extern void svlib_testCase_111();
extern void svlib_testCase_112();
extern void svlib_testCase_113();
extern void svlib_testCase_114();
extern void svlib_testCase_133();
extern void svlib_testall();


void *uclo_handle;			// microcode loader handle


int svlibInit(char *UofFn)
{
	int status, i, retval;

	if(UofFn == NULL){
		//Assume WB control -- should be called after the WB has loaded the UOF
		SysConf *sysConf = SysConf_Attach();
		if(!sysConf || (!(uclo_handle = sysConf->getUcloHandle()))){
			printf("ERROR: Cannot init svlib.. UOF not loaded\n");
			return(-1);
		}
	}
	else{
		if((status = NetApp_Init())) return(status);
		if (status = UcLo_LoadObjFile(&uclo_handle, UofFn)){
			return(status);							// return uclo error
		}

		status = UcLo_WriteUimageAll(uclo_handle);

		// start NetApp_Run once -  do we need to start ueng? Yes!
		if((retval = NetApp_Run(0x3f, 0xfff))) { 
			printf("ERROR: NetApp_Run() returned: %d\n", retval);
			return(retval);
		} else {
			printf("Call NetApp_Run()..\n");
			libdInitialized = 1;
		}
	}
	return(0);
}


//
// registered with Transactor
// This function is intended to be launched at command line
//
int svlibTest(int testCase)
{
    Thread* TestCaseTh;

    switch (testCase)
    {
        case 1:
			svlib_testCase_1();
            break;

        case 2:
			svlib_testCase_2();
            break;

        case 3:
			svlib_testCase_3();
            break;

        case 4:
            svlib_testCase_4();
            break;
 
        case 5:
            svlib_testCase_5();
            break;

        case 11:
            svlib_testCase_11();
            break;

        case 12:
            svlib_testCase_12();
            break;

        case 13:
            svlib_testCase_13();
            break;

        case 14:
            svlib_testCase_14();
            break;

        case 21:
            svlib_testCase_21();
            break;

        case 22:
            svlib_testCase_22();
            break;

        case 23:
            svlib_testCase_23();
            break;

        case 24:
            svlib_testCase_24();
            break;
 
        case 25:
            svlib_testCase_25();
            break;

        case 26:
            svlib_testCase_26();
            break;

        case 27:
            svlib_testCase_27();
            break;

        case 28:
            svlib_testCase_28();
            break;

        case 29:
            svlib_testCase_29();
            break;

        case 33:
            svlib_testCase_33();
            break;

#if 0	// ignore multi-threaded cases, for know

        case 34:
            // TestCaseTh = new  Thread(testCase_1);
            // TestCaseTh = new  Thread(testCase_2);
            break;

        case 35:
            // TestCaseTh = new  Thread(testCase_1);
            // TestCaseTh = new  Thread(testCase_2);
            // TestCaseTh = new  Thread(testCase_3);
            // TestCaseTh = new  Thread(testCase_4);
            // TestCaseTh = new  Thread(testCase_5);
            // TestCaseTh = new  Thread(testCase_11);
            // TestCaseTh = new  Thread(testCase_12);
            // TestCaseTh = new  Thread(testCase_13);
            // TestCaseTh = new  Thread(testCase_14);
    	break;
#endif

        case 43:
            svlib_testCase_43();
            break;

#if 0
        case 44:
            // TestCaseTh = new  Thread(testCase_21);
            // TestCaseTh = new  Thread(testCase_22);
            break;

        case 45:
            // TestCaseTh = new  Thread(testCase_21);
            // TestCaseTh = new  Thread(testCase_22);
            // TestCaseTh = new  Thread(testCase_23);
            // TestCaseTh = new  Thread(testCase_24);
            // TestCaseTh = new  Thread(testCase_25);
            // TestCaseTh = new  Thread(testCase_26);
            // TestCaseTh = new  Thread(testCase_27);
            // TestCaseTh = new  Thread(testCase_28);
            // TestCaseTh = new  Thread(testCase_29);
            break;
#endif

        case 101:
            svlib_testCase_101();
            break;

        case 102:
            svlib_testCase_102();
            break;

        case 103:
            svlib_testCase_103();
            break;

        case 104:
            svlib_testCase_104();
            break;
 
        case 105:
            svlib_testCase_105();
            break;

        case 111:
            svlib_testCase_111();
            break;

        case 112:
            svlib_testCase_112();
            break;

        case 113:
            svlib_testCase_113();
            break;

        case 114:
            svlib_testCase_114();
            break;

        case 133:
            svlib_testCase_133();
            break;
#if 0

        case 134:
            // TestCaseTh = new  Thread(testCase_101);
            // TestCaseTh = new  Thread(testCase_102);
            break;

        case 135:
            // TestCaseTh = new  Thread(testCase_101);
            // TestCaseTh = new  Thread(testCase_102);
            // TestCaseTh = new  Thread(testCase_103);
            // TestCaseTh = new  Thread(testCase_104);
            // TestCaseTh = new  Thread(testCase_105);
            // TestCaseTh = new  Thread(testCase_111);
            // TestCaseTh = new  Thread(testCase_112);
            // TestCaseTh = new  Thread(testCase_113);
            // TestCaseTh = new  Thread(testCase_114);
            break;
#endif

        default:
            printf("ERROR: bad test case.\n");
            break;
    }
	return(0);
}


void svlib_testall(char *UofFn) {

svlibTest(1);
svlibTest(2);
svlibTest(3);
svlibTest(4);
svlibTest(5);
svlib_testCase_21();
svlib_testCase_22();
svlib_testCase_23();
svlib_testCase_24();
svlib_testCase_25();
svlib_testCase_26();
svlib_testCase_27();
svlib_testCase_29();
svlib_testCase_43();
svlib_testCase_103();
svlib_testCase_104();
svlib_testCase_105();
return;

}


/*------------------------------------------------------------------------
    testCase_1
        2-way synch MemSv_TestAndSet() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_1()
{
	int retval;
    printf(" -- MemSv_TestAndSet() (testCase_1) ----------------------\n");

    SRAM_Write(0x400, 0xFFFF0000);
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x51);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    int outArg;
    msvTASIn msvTASInArg = {0xDEADBEEF, (void*)0x400};

	// do we need to start ueng?
	// if((retval = NetApp_Run(0x3f, 0xfff))) return(retval);
    
	retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
    else
        printf("ERROR: MemSv_TestAndSet() failed\n");
    retval = SRAM_Read(0x400);
	printf("sram 0x400 == %x\n", retval);
     
    MemSv_Close(libHandle);
    return;
}

/*------------------------------------------------------------------------
    testCase_2
        2-way synch MemSv_BZero() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_2()
{
	int retval;	
    printf(" -- MemSv_BZero() (testCase_2) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
        SRAM_Write((0x410 + ii), 0xA5A5A5A5);

    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x52);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

	int outArg;
    msvBuf msvBufInArg = {0x10<<2, (void*)(0x410<<2)};

    retval = MemSv_BZero(libHandle, &msvBufInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BZero()\n");
    else
        printf("ERROR: MemSv_BZero() failed\n");
	
    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_3
        2-way synch MemSv_BCopy() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_3()
{
    printf(" -- MemSv_BCopy() (testCase_3) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
    {
        SRAM_Write((0x430 + ii), 0x33333333);
        SRAM_Write((0x440 + ii), 0x44444444);
    }

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x53);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

	int outArg;
    msvBCopyIn msvBCopyInArg = {0x10<<2, (void*)(0x430<<2), (void*)(0x440<<2)};

    retval = MemSv_BCopy(libHandle, &msvBCopyInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BCopy()\n");
    else
        printf("ERROR: MemSv_BCopy() failed\n");

    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_4
        2-way synch MemSv_Gather() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_4()
{
	printf(" -- MemSv_Gather() (testCase_4) --------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffers
        SRAM_Write((0x450 + ii), 0x55555555);
        SRAM_Write((0x460 + ii), 0x66666666);
    }

    // source buffer description
    SRAM_Write((0x470 + 0), (0x10<<2));
    SRAM_Write((0x470 + 1), (0x450<<2));
    SRAM_Write((0x470 + 2), (0x10<<2));
    SRAM_Write((0x470 + 3), (0x460<<2));

    // destination buffer
    for (ii = 0; ii < 0x20; ii++)
        SRAM_Write(0x480 + ii, 0x0);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x54);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    msvGatherIn msvGatherInArg = {2, (void*)0x470, (void*)0x480};

    retval = MemSv_Gather(libHandle, &msvGatherInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Gather()\n");
    else
        printf("ERROR: MemSv_Gather() failed\n");

    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_5
        2-way synch MemSv_Scatter() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_5()
{
    printf(" -- MemSv_Scatter() (testCase_5) -------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffer
        SRAM_Write((0x500 + ii), 0x77777777);
        SRAM_Write((0x510 + ii), 0x88888888);
        // destination buffer
        SRAM_Write((0x530 + ii),0x00000000);
        SRAM_Write((0x540 + ii),0x00000000);
    }

    // destination buffer description
    SRAM_Write((0x520 + 0), (0x10<<2));
    SRAM_Write((0x520 + 1), (0x530<<2));
    SRAM_Write((0x520 + 2), (0x10<<2));
    SRAM_Write((0x520 + 3), (0x540<<2));

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x55);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    msvScatterIn msvScatterInArg = {2, (void*)0x500, (void*)0x520};

    retval = MemSv_scatter(libHandle, &msvScatterInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Scatter()\n");
    else
        printf("ERROR: MemSv_Scatter() failed\n");

    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_11
        2-way synch HashSv_LdMult48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_11()
{
    printf(" -- HashSv_LdMult48() (testCase_11) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x61);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};

    retval = HashSv_LdMult48(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult48()\n");
    else
        printf("ERROR: HashSv_LdMult48() failed\n");

    HashSv_Close(libHandle);
	return;
}

/*------------------------------------------------------------------------
    testCase_12
        2-way synch HashSv_LdMult64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_12()
{
    printf(" -- HashSv_LdMult64() (testCase_12) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x62);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};

    retval = HashSv_LdMult64(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult64()\n");
    else
        printf("ERROR: HashSv_LdMult64() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_13
        2-way synch HashSv_Exec48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_13()
{
    printf(" -- HashSv_Exec48() (testCase_13) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x63);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec48(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec48()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec48() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_14
        2-way synch HashSv_Exec64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_14()
{
    printf(" -- HashSv_Exec64() (testCase_14) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x64);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec64(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec64()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec64() failed\n");

    HashSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_21
        2-way asynch MemSv_TestAndSet() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_21()
{
    printf(" -- MemSv_TestAndSet() (testCase_21) ---------------------\n");

    SRAM_Write(0x400, 0xFFFF0000);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x71);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    int outArg;
    msvTASIn msvTASInArg = {0xDEADBEEF, (void*)0x400};

    retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
    else
        printf("ERROR: MemSv_TestAndSet() failed\n");

    MemSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_22
        2-way asynch MemSv_BZero() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_22()
{
    printf(" -- MemSv_BZero() (testCase_22) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
        SRAM_Write((0x410 + ii),0xA5A5A5A5);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x72);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    msvBuf msvBufInArg = {0x10<<2, (void*)(0x410<<2)};

    retval = MemSv_BZero(libHandle, &msvBufInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BZero()\n");
    else
        printf("ERROR: MemSv_BZero() failed\n");

    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_23
        2-way asynch MemSv_BCopy() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_23()
{
    printf(" -- MemSv_BCopy() (testCase_23) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
    {
        SRAM_Write((0x430 + ii), 0x33333333);
        SRAM_Write((0x440 + ii), 0x44444444);
    }

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x73);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    msvBCopyIn msvBCopyInArg = {0x10<<2, (void*)(0x430<<2), (void*)(0x440<<2)};

    retval = MemSv_BCopy(libHandle, &msvBCopyInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BCopy()\n");
    else
        printf("ERROR: MemSv_BCopy() failed\n");

    MemSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_24
        2-way asynch MemSv_Gather() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_24()
{
    printf(" -- MemSv_Gather() (testCase_24) --------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffers
        SRAM_Write((0x450 + ii), 0x55555555);
        SRAM_Write((0x460 + ii), 0x66666666);
    }

    // source buffer description
    SRAM_Write((0x470 + 0), (0x10<<2));
    SRAM_Write((0x470 + 1), (0x450<<2));
    SRAM_Write((0x470 + 2), (0x10<<2));
    SRAM_Write((0x470 + 3), (0x460<<2));

    // destination buffer
    for (ii = 0; ii < 0x20; ii++)
        SRAM_Write((0x480 + ii), 0);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x74);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    msvGatherIn msvGatherInArg = {2, (void*)0x470, (void*)0x480};

    retval = MemSv_Gather(libHandle, &msvGatherInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Gather()\n");
    else
        printf("ERROR: MemSv_Gather() failed\n");

    MemSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_25
        2-way asynch MemSv_Scatter() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_25()
{
    printf(" -- MemSv_Scatter() (testCase_25) -------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffer
        SRAM_Write((0x500 + ii), 0x77777777);
        SRAM_Write((0x510 + ii), 0x88888888);
        // destination buffer
        SRAM_Write((0x530 + ii), 0x00000000);
        SRAM_Write((0x530 + ii), 0x00000000);
    }

    // destination buffer description
    SRAM_Write((0x520 + 0), (0x10<<2));
    SRAM_Write((0x520 + 1), (0x530<<2));
    SRAM_Write((0x520 + 2), (0x10<<2));
    SRAM_Write((0x520 + 3), (0x540<<2));

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x75);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    msvScatterIn msvScatterInArg = {2, (void*)0x500, (void*)0x520};

    retval = MemSv_scatter(libHandle, &msvScatterInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Scatter()\n");
    else
        printf("ERROR: MemSv_Scatter() failed\n");

    MemSv_Close(libHandle);
	return;
}

/*------------------------------------------------------------------------
    testCase_26
        2-way asynch HashSv_LdMult48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_26()
{
    printf(" -- HashSv_LdMult48() (testCase_26) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x81);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};

    retval = HashSv_LdMult48(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult48()\n");
    else
        printf("ERROR: HashSv_LdMult48() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_27
        2-way asynch HashSv_LdMult64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_27()
{
    printf(" -- HashSv_LdMult64() (testCase_27) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x82);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};

    retval = HashSv_LdMult64(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult64()\n");
    else
        printf("ERROR: HashSv_LdMult64() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_28
        2-way asynch HashSv_Exec48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_28()
{
    printf(" -- HashSv_Exec48() (testCase_28) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x83);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec48(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec48()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec48() failed\n");

    HashSv_Close(libHandle);
	return;
}

/*------------------------------------------------------------------------
    testCase_29
        2-way asynch HashSv_Exec64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_29()
{
    printf(" -- HashSv_Exec64() (testCase_29) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x84);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec64(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec64()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec64() failed\n");

    HashSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_31
        only has .ind test file
        called two different micro code functions sequentially
    return:
  ------------------------------------------------------------------------*/

/*------------------------------------------------------------------------
    testCase_32
        only has .ind test file
        called two same micro code functions sequentially
    return:
  ------------------------------------------------------------------------*/

/*------------------------------------------------------------------------
    testCase_33
        2-way synch MemSv_TestAndSet() call (10 times)
    return:
  ------------------------------------------------------------------------*/

void svlib_testCase_33()
{
    printf(" -- MemSv_TestAndSet() (testCase_33) ---------------------\n");


    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x85);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_PEND_CALL;

    int outArg;

    // initialize the location to keep test result
    int numOfTestPassed = 0;
    SRAM_Write(0x401, numOfTestPassed);

    for (int ii = 0; ii < 10; ii++)
    {
        printf(" -- call function %dth time\n", ii+1);
        SRAM_Write(0x400, 0xFFFF0000);
        msvTASIn msvTASInArg = {0xDEADA5A5, (void*)0x400};

        retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
        if ((retval >= 0) && (retval <= 7))
        {
            numOfTestPassed++;
            SRAM_Write(0x401, numOfTestPassed);
            printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
        }
        else
            printf("ERROR: MemSv_TestAndSet() failed\n");
    }

    MemSv_Close(libHandle);
	return; 
}

/*------------------------------------------------------------------------
    testCase_43
        2-way asynch MemSv_TestAndSet() call (10 times)
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_43()
{
    printf(" -- MemSv_TestAndSet() (testCase_43) ---------------------\n");

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x86);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_SYNC_CALL;

    int outArg;

    // initialize the location to keep test result
    int numOfTestPassed = 0;
    SRAM_Write(0x401, numOfTestPassed);

    for (int ii = 0; ii < 10; ii++)
    {
        printf(" -- call function %dth time\n", ii+1);
        SRAM_Write(0x400, 0xFFFF0000);
        msvTASIn msvTASInArg = {0xDEADA5A5, (void*)0x400};

        retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
        if ((retval >= 0) && (retval <= 7))
        {
            numOfTestPassed++;
            SRAM_Write(0x401, numOfTestPassed);
            printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
        }
        else
            printf("ERROR: MemSv_TestAndSet() failed\n");
    }

    MemSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_101
        1-way synch MemSv_TestAndSet() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_101()
{
    printf(" -- MemSv_TestAndSet() (testCase_101) ----------------------\n");

    SRAM_Write(0x400, 0xFFFF0000);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x51);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    int outArg;
    msvTASIn msvTASInArg = {0xDEADBEEF, (void*)0x400};

    retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
    else
        printf("ERROR: MemSv_TestAndSet() failed\n");

    MemSv_Close(libHandle);
	return;
}

/*------------------------------------------------------------------------
    testCase_102
        1-way synch MemSv_BZero() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_102()
{
    printf(" -- MemSv_BZero() (testCase_102) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
        SRAM_Write((0x410 + ii),0xA5A5A5A5);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x52);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    msvBuf msvBufInArg = {0x10<<2, (void*)(0x410<<2)};

    retval = MemSv_BZero(libHandle, &msvBufInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BZero()\n");
    else
        printf("ERROR: MemSv_BZero() failed\n");

    MemSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_103
        1-way synch MemSv_BCopy() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_103()
{
    printf(" -- MemSv_BCopy() (testCase_103) ---------------------------\n");

    for (int ii = 0; ii < 0x10; ii++)
    {
        SRAM_Write((0x430 + ii), 0x33333333);
        SRAM_Write((0x440 + ii), 0x44444444);
    }

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x53);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    msvBCopyIn msvBCopyInArg = {0x10<<2, (void*)(0x430<<2), (void*)(0x440<<2)};

    retval = MemSv_BCopy(libHandle, &msvBCopyInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_BCopy()\n");
    else
        printf("ERROR: MemSv_BCopy() failed\n");

    MemSv_Close(libHandle);
	return;
}


/*------------------------------------------------------------------------
    testCase_104
        1-way synch MemSv_Gather() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_104()
{
    printf(" -- MemSv_Gather() (testCase_104) --------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffers
		SRAM_Write((0x450 + ii), 0x55555555);
		SRAM_Write((0x460 + ii), 0x66666666);
    }

    // source buffer description
    SRAM_Write((0x470 + 0), (0x10<<2));
    SRAM_Write((0x470 + 1), (0x450<<2));
    SRAM_Write((0x470 + 2), (0x10<<2));
    SRAM_Write((0x470 + 3), (0x460<<2));

    // destination buffer
    for (ii = 0; ii < 0x20; ii++)
        SRAM_Write((0x480 + ii), 0x0);

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x54);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    msvGatherIn msvGatherInArg = {2, (void*)0x470, (void*)0x480};

    retval = MemSv_Gather(libHandle, &msvGatherInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Gather()\n");
    else
        printf("ERROR: MemSv_Gather() failed\n");

    MemSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_105
        1-way synch MemSv_Scatter() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_105()
{
    printf(" -- MemSv_Scatter() (testCase_105) -------------------------\n");

    int ii;
    for (ii = 0; ii < 0x10; ii++)
    {
        // source buffer
        SRAM_Write((0x500 + ii), 0x77777777);
        SRAM_Write((0x510 + ii), 0x88888888);
        // destination buffer
        SRAM_Write((0x530 + ii), 0x00000000);
        SRAM_Write((0x540 + ii), 0x00000000);
    }

    // destination buffer description
    SRAM_Write((0x520 + 0), (0x10<<2));
    SRAM_Write((0x520 + 1), (0x530<<2));
    SRAM_Write((0x520 + 2), (0x10<<2));
    SRAM_Write((0x520 + 3), (0x540<<2));

    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x55);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    msvScatterIn msvScatterInArg = {2, (void*)0x500, (void*)0x520};

    retval = MemSv_scatter(libHandle, &msvScatterInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: MemSv_Scatter()\n");
    else
        printf("ERROR: MemSv_Scatter() failed\n");

    MemSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_111
        1-way synch HashSv_LdMult48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_111()
{
    printf(" -- HashSv_LdMult48() (testCase_111) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x61);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};

    retval = HashSv_LdMult48(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult48()\n");
    else
        printf("ERROR: HashSv_LdMult48() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_112
        1-way synch HashSv_LdMult64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_112()
{
    printf(" -- HashSv_LdMult64() (testCase_112) ----------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x62);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};

    retval = HashSv_LdMult64(libHandle, &hsv_DataInArg);
    if ((retval >= 0) && (retval <= 7))
        printf("SUCCESSSUCCESS: HashSv_LdMult64()\n");
    else
        printf("ERROR: HashSv_LdMult64() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_113
        1-way synch HashSv_Exec48() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_113()
{
    printf(" -- HashSv_Exec48() (testCase_113) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x63);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    hsv_Data hsv_DataInArg = {0x1234, 0x56789ABC};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec48(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec48()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec48() failed\n");

    HashSv_Close(libHandle);
	return;

}

/*------------------------------------------------------------------------
    testCase_114
        1-way synch HashSv_Exec64() call.
    return:
  ------------------------------------------------------------------------*/
void svlib_testCase_114()
{
    printf(" -- HashSv_Exec64() (testCase_114) ------------------------\n");

    int retval;
    LibHandle* libHandle = HashSv_Init(uclo_handle, 0x64);
    if (libHandle == 0)
    {
		printf("ERROR: HashSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    hsv_Data hsv_DataInArg = {0x12345678, 0x9ABCDEF0};
    hsv_Data hsv_DataOutArg = {0, 0};

    retval = HashSv_Exec64(libHandle, &hsv_DataInArg, &hsv_DataOutArg);
    if ((retval >= 0) && (retval <= 7))
    {
        printf("SUCCESSSUCCESS: HashSv_Exec64()\n");
        printf("return: %08X  %08X\n", hsv_DataOutArg.hi32, hsv_DataOutArg.lo32);
    }
    else
        printf("ERROR: HashSv_Exec64() failed\n");

    HashSv_Close(libHandle);
	return;

}


/*------------------------------------------------------------------------
    testCase_133
        1-way synch MemSv_TestAndSet() call (10 times)
    return:
  ------------------------------------------------------------------------*/

void svlib_testCase_133()
{
    printf(" -- MemSv_TestAndSet() (testCase_133) ---------------------\n");


    int retval;
    LibHandle* libHandle = MemSv_Init(uclo_handle, 0x85);
    if (libHandle == 0)
    {
		printf("ERROR: MemSv_Init() failed\n");
        return;
    }

    libHandle->tid = 0;
    libHandle->flag = SVLIB_ASYNC_CALL;

    int outArg;

    // initialize the location to keep test result
    int numOfTestPassed = 0;
    SRAM_Write(0x401, numOfTestPassed);

    for (int ii = 0; ii < 10; ii++)
    {
        printf(" -- call function %dth time\n", ii+1);
        SRAM_Write(0x400, 0xFFFF0000);
        msvTASIn msvTASInArg = {0xDEADA5A5, (void*)0x400};

        retval = MemSv_TestAndSet(libHandle, &msvTASInArg, &outArg);
        if ((retval >= 0) && (retval <= 7))
        {
            numOfTestPassed++;
            SRAM_Write(0x401, numOfTestPassed);
            printf("SUCCESSSUCCESS: MemSv_TestAndSet() return: %x\n", outArg);
        }
        else
            printf("ERROR: MemSv_TestAndSet() failed\n");
    }

    MemSv_Close(libHandle);
	return;
}


// end of file

