CPU		= ARMSA110
TOOL		= gnu
INCLUDE = \
-I../../include \
-I../../utils \
-I../../share/RemoteServices


ADDED_C++FLAGS  = -w -Wall -pedantic -Dast_parse -Dxactor_build -DVxWorkTest \
 -Dno_uca_code_gen -DSTANDALONE -Dnew_sdram -Dbuild_without_main \
 -DVX_WORKS -DXACT -D__unix -DIOSTYLE=AMBAIO\
 $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
default		: $(DEMO_DIR)
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)
default		: $(DEMO_DIR)

CORE_debug			:
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_proc.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_xdr.c
			$(CC) -g $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_svc.c
			$(CC) -g $(C++FLAGS) -c ../../utils/sem.c
			$(CC) -g $(C++FLAGS) -c ../../utils/thread.c
			$(CC) -g $(C++FLAGS) -c ../../utils/delay.c
			$(CC) -g $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) -g $(C++FLAGS) -c test_registration.cpp


			ldarm -o archmodel.o -r \
			../../vxworks_lib/debug/rs_archmodelOUT.o \
            		rs_proc.o \
			rs_xact_xdr.o \
            		rs_xact_svc.o \
			 sem.o \
			 thread.o \
			 delay.o \
			 test_registration.o \
			 poolmgr.o 



			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/debug/RemoteSimulation.o -r __CtorDtor.o archmodel.o

CORE_release		:
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_proc.c
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_xdr.c
			$(CC) $(C++FLAGS) -c ../../share/RemoteServices/rs_xact_svc.c
			$(CC) $(C++FLAGS) -c ../../utils/sem.c
			$(CC) $(C++FLAGS) -c ../../utils/thread.c
			$(CC) $(C++FLAGS) -c ../../utils/delay.c
			$(CC) $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) $(C++FLAGS) -c test_registration.cpp



			ldarm -o archmodel.o -r \
			../../vxworks_lib/rs_archmodelOUT.o \
        		 rs_proc.o \
			 rs_xact_xdr.o \
                         rs_xact_svc.o \
			 sem.o \
			 thread.o \
			 delay.o \
			 test_registration.o \
			 poolmgr.o 
 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/RemoteSimulation.o -r __CtorDtor.o archmodel.o

clean		: 
		$(RM) *.o

