/* systemInit.cpp
 *
 *------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Initialization
 * author: Henry Qian 05-04-99
 * revisions:
 * $History: systemInit.cpp $
 * 
 * *****************  Version 6  *****************
 * User: Rparen1x     Date: 6/30/99    Time: 3:25p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * 
 * *****************  Version 5  *****************
 * User: Rparen1x     Date: 6/30/99    Time: 11:30a
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * changed DriverInit to FDriver_Init
 * 
 * *****************  Version 3  *****************
 * User: Hqianx       Date: 5/04/99    Time: 7:19p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * 
 * *****************  Version 2  *****************
 * User: Hqianx       Date: 5/04/99    Time: 12:21p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 *
 */
#include "xact.h"
#include "ambaio.h"

#define INC_AMBAIO  0x01
#define INC_FDRIVER 0x02

extern "C" void  FDriver_Init();
extern unsigned int AMBAIO_InitDone;
unsigned int system_InitDone;

#ifdef __cplusplus
extern "C" {
#endif
void systemInit_Thread(int flag);
#ifdef __cplusplus
}
#endif


/*
**  void systemInit(void)
**
**  DESCRIPTION
**      This function is intented to be called from Transactor script.
**      In order to do that, it must be done in another thread
**      other than the transcator thread.
**
**  RETURNS
**      0: error
**      1: sucess
*/
void systemInit(void)
{
    FDriver_Init();
 
    system_InitDone = 1;
}

void systemInit_Thread(int flag)
{
    system_InitDone = 0;
    AMBAIO_InitDone = 0;

    // ambaIoInit() spawns itself as a thread, seperated
    // Transactor's.  It needs to be sure ambaIoInit() is
    // done before other system initialization start.
    //
    if (flag & INC_AMBAIO)
    {
        ambaIoInit();
	    while(AMBAIO_InitDone == 0)
        {
            printf(",");
            XACT_ExecuteCommandStr("go 1");
        }
    }

    if (flag & INC_FDRIVER)
    {
        Thread* TestCaseTh = new Thread((PFV)systemInit);
	    while(system_InitDone == 0)
        {
            printf(".");
            XACT_ExecuteCommandStr("go 1");
        }
    }
}

// end of file
