/* test_registration.cpp
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: UCLO Test
 * author: Lai-Wah Hui 2/16/98
 * revisions:
 * $History
 * 
 * 
 */ 

/*=================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef STANDALONE
#include "uclo_test.h"
#include "Test_Utilities.h"
#endif

/* instructions
	1. define ext_model_port as a compiler switch when compiling safe_xact
	2. "													   " rtm_registration
 */


// function prototype to register functions with transactor
//
extern int XACT_register_console_function( char *function_name,
										void *function_ptr,
										int num_char_ptr_args,
										int num_uint_args );


/* functions called by transactor to foreign model */


/* this routine will be called to initialize the foreign model after */
/* the transactor "init" command has successfully executed.  Returning 0 */
/* will result in a transactor error. */
#ifndef STANDALONE
int UcLo_Test_initialize()
{


    if (!XACT_register_console_function("UcLo_TestInit", UcLo_TestInit, 0, 0) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("UcLo_LoadObjFileTest",UcLo_LoadObjFileTest, 1, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}
    if (!XACT_register_console_function("UcLo_MapObjFileTest",UcLo_MapObjFileTest, 1, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}


    if (!XACT_register_console_function("UcLo_WriteUImageAllTest",UcLo_WriteUImageAllTest, 0, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}


    if (!XACT_register_console_function("UcLo_BindSymbolTest",UcLo_BindSymbolTest, 2, 2) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("UcLo_WriteUImagePageTest",UcLo_WriteUImagePageTest, 1, 2) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("UcLo_WriteUImageTest",UcLo_WriteUImageTest, 1, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("UcLo_VerifyUImageTest",UcLo_VerifyUImageTest, 1, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    if (!XACT_register_console_function("UcLo_VerifyUengineTest",UcLo_VerifyUengineTest,0, 2) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}
  
    if (!XACT_register_console_function("UcLo_GetUFuncIdTest",UcLo_GetUFuncIdTest, 1, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}
    
    if (!XACT_register_console_function("UcLo_TestEnd", UcLo_TestEnd, 0, 1) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}
    if (!XACT_register_console_function("UcLo_GetObjIndex", UcLo_GetObjIndex, 0, 0) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}


    return Utilities_Register();
}
#endif

/* this routine will be called prior to each transactor simulation event */
/* It can be used to deposit state values into the transactor model prior */
/* to simulating the next event.  Returning 0 results in an error. */

#ifdef STANDALONE
extern int foreign_model_initialize()
{
	return (1);
}
extern int foreign_model_pre_sim()
{
	return(1);
}



/* this routine will be called subsequent to each transactor simulation event. */
/* It can be used to query transactor simulation state, in order to copy it */
/* into the foreign model simulator. */
extern int foreign_model_post_sim()
{
	return(1);
}

/* this routine will be called just prior to exiting the simulator. */
/* The routine allows the foreign model to clean up, close files, etc */
/* before shutting down the program. */
int foreign_model_exit()
{
    return(1);
}

/* this routine will be called whenever the simulator is reset. */
int foreign_model_reset()
{
    return(1);
}

#endif
#ifdef VX_WORKS
#define DIR_TERM        '/'
char *getExeDir(char *argv0, char *out)
	{
	char *cp;
	int len;

	if(!out) return(NULL);

	if((cp = strrchr(argv0, DIR_TERM)))
		{
		cp++;
		len = (int) (cp - argv0);
		strncpy(out, argv0, len);
		out[len] = '\0';
		return(out);
		}
	
	*out = '\0';
	return(NULL);
	}

#endif
