/* Uclo_test.h
 *
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Uclo testing
 * author: Lai-Wah Hui 2/28/98
 * revisions:
 * $History: uclo_test.h $
 * 
 * *****************  Version 6  *****************
 * User: Lhui         Date: 5/20/98    Time: 6:29p
 * Updated in $/base_level2/qa-test/uclo_tests
 * Replace Digital copyright with Intel copyright statement
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 3/19/98    Time: 7:26p
 * Updated in $/base_level1/qa-test/uclo_tests
 * Add compile switch
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 3/13/98    Time: 6:09p
 * Updated in $/base_level1/qa-test/uclo_tests
 * Add compile switch
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 3/13/98    Time: 5:14p
 * Updated in $/base_level1/qa-test/uclo_tests
 * Add test cases
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 3/11/98    Time: 10:12a
 * Updated in $/base_level1/qa-test/uclo_tests
 * Add test cases
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 3/02/98    Time: 3:02p
 * Created in $/base_level1/qa-test/uclo_tests
 * Init. check-in
 * 
 */ 
#ifndef UCLO_Test_H
#define UCLO_Test_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>


/* MAIN TEST ROUTINGS   */

#if defined(__cplusplus)
extern "C"
{
#endif

/* FUNCTIONs DEFINITION */
extern int UcLo_TestInit();
extern int UcLo_LoadObjFileTest(char *path, unsigned int DeleteObj );
extern int UcLo_TestEnd(unsigned int index);
extern int UcLo_MapObjFileTest(char *path, unsigned int DeleteObj );
extern int UcLo_WriteUImageAllTest(unsigned int index);
extern int UcLo_BindSymbolTest(char *ImageName, char *SymbolName, unsigned int SymbolVal,unsigned int index);
extern int UcLo_WriteUImagePageTest(char *ImageName, unsigned int PageNumber,unsigned int index);
extern int UcLo_GetUFuncIdTest(char *FunctionName,unsigned int index);
extern int UcLo_WriteUImageTest(char *ImageName,unsigned int index);
extern int UcLo_VerifyUImageTest(char *ImageName,unsigned int index);
extern int UcLo_VerifyUengineTest(const int uEngNum,unsigned int index); 
extern int UcLo_GetObjIndex();    
#ifndef STANDALONE 
extern int UcLo_Test_initialize();
#endif
//
/* other defintions */
#define TRUE    1
#define FALSE   0
#if defined(__cplusplus)
}
#endif



#endif /* UCLO_TEST_H */
