/* udbg_test.cpp
 * Ucode Debug Library
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: Debug Library
 *  author: drj, Sep. 28,98  Initial version
 *  revisions:
 *  $History: udbg_test.cpp $
 * 
 * *****************  Version 59  *****************
 * User: Dmwhite      Date: 5/02/00    Time: 10:41a
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * don't octalmaccreatedriver if os==win_32
 * 
 * *****************  Version 56  *****************
 * User: Lhui         Date: 10/04/99   Time: 5:11p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * Fix for new udbg_reset prototype
 * 
 * *****************  Version 54  *****************
 * User: Lhui         Date: 6/18/99    Time: 6:08p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * Update for new control API
 * 
 * *****************  Version 53  *****************
 * User: Dhooper      Date: 6/03/99    Time: 9:02p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * use attach to get sysConf
 * 
 * *****************  Version 52  *****************
 * User: Dhooper      Date: 5/12/99    Time: 6:19p
 * Updated in $/dev_1200/SA1_CoreLibs/SA1200core_Build
 * explicit IOSTYLE around CSR access
 * 
 * *****************  Version 50  *****************
 * User: Qabuild      Date: 4/30/99    Time: 2:24p
 * Updated in $/Internal/qa-tests/uDebugCtrl
 * 
 * *****************  Version 48  *****************
 * User: Lhui         Date: 4/22/99    Time: 5:35p
 * Updated in $/development/qa-test/uDebugCtrl
 * Add a delay parameter to  rs_udebug/control  hop functions. 
 * 
 * *****************  Version 47  *****************
 * User: Tclancyx     Date: 4/13/99    Time: 3:48p
 * Updated in $/development/qa-test/uDebugCtrl
 * clean-up warning for handle
 * 
 * *****************  Version 46  *****************
 * User: Qabuild      Date: 4/09/99    Time: 5:39p
 * Updated in $/development/qa-test/uDebugCtrl
 * Uses extern "C" for OctalMACCreateDriver().
 * 
 * *****************  Version 45  *****************
 * User: Tclancyx     Date: 4/09/99    Time: 11:39a
 * Updated in $/development/qa-test/uDebugCtrl
 * unsigned int delay = 0;
 * 
 * *****************  Version 44  *****************
 * User: Hqianx       Date: 4/09/99    Time: 12:46p
 * Updated in $/development/qa-test/uDebugCtrl
 * uses extern OctalMACStatus.
 * 
 * *****************  Version 43  *****************
 * User: Hqianx       Date: 4/09/99    Time: 12:21p
 * Updated in $/development/qa-test/uDebugCtrl
 * Rename OctalMACStarted to OctalMACStatus.
 * 
 * *****************  Version 42  *****************
 * User: Tclancyx     Date: 4/08/99    Time: 3:17p
 * Updated in $/development/qa-test/uDebugCtrl
 * Added OctalMACCreateDriver() here temporarily.
 * 
 * *****************  Version 41  *****************
 * User: Tclancyx     Date: 4/07/99    Time: 10:19a
 * Updated in $/development/qa-test/uDebugCtrl
 * 
 * *****************  Version 40  *****************
 * User: Tclancyx     Date: 4/06/99    Time: 5:28p
 * Updated in $/development/qa-test/uDebugCtrl
 * add AmbaRead and AmbaWrite functions
 * 
 * *****************  Version 39  *****************
 * User: Tclancyx     Date: 4/02/99    Time: 3:23p
 * Updated in $/development/qa-test/uDebugCtrl
 * fix CNTL_ problems
 * 
 * *****************  Version 38  *****************
 * User: Tclancyx     Date: 3/30/99    Time: 8:46a
 * Updated in $/development/qa-test/uDebugCtrl
 * regsiter console functions for CNTL_
 * 
 * *****************  Version 37  *****************
 * User: Qabuild      Date: 3/25/99    Time: 2:47p
 * Updated in $/development/qa-test/uDebugCtrl
 * bug fix
 * 
 * *****************  Version 36  *****************
 * User: C-tclancy    Date: 3/25/99    Time: 11:46a
 * Updated in $/development/qa-test/uDebugCtrl
 * bug fix
 * 
 * *****************  Version 35  *****************
 * User: C-tclancy    Date: 3/24/99    Time: 4:32p
 * Updated in $/development/qa-test/uDebugCtrl
 * add five CNTL_ wrapper functions
 * 
 * *****************  Version 34  *****************
 * User: Ajsteven     Date: 3/24/99    Time: 2:52p
 * Updated in $/development/qa-test/uDebugCtrl
 * add function wrappers for CNTL_
 * 
 * *****************  Version 33  *****************
 * User: Qabuild      Date: 3/23/99    Time: 10:21a
 * Updated in $/development/qa-test/uDebugCtrl
 * 
 * *****************  Version 32  *****************
 * User: Lhui         Date: 3/23/99    Time: 9:22a
 * Updated in $/development/qa-test/uDebugCtrl
 * Change debug.h to debug_1200.h
 * 
 * *****************  Version 31  *****************
 * User: Tclancyx     Date: 3/19/99    Time: 9:51a
 * Updated in $/development/qa-test/uDebugCtrl
 * bug fix - fill Data64 with bad data to ensure the ReadMem64 works
 * 
 * *****************  Version 29  *****************
 * User: Hqianx       Date: 3/18/99    Time: 12:52p
 * Updated in $/development/debug
 * Renamed udbg_lib.h to debug.h
 * 
 * *****************  Version 28  *****************
 * User: Tclancyx     Date: 3/10/99    Time: 11:24a
 * Updated in $/development/udebug
 * fix WriteMem64 test wrap
 * 
 * *****************  Version 27  *****************
 * User: Drjohns1     Date: 3/04/99    Time: 5:42p
 * Updated in $/development/udebug
 * 
 * *****************  Version 26  *****************
 * User: Tclancyx     Date: 3/04/99    Time: 5:16p
 * Updated in $/development/udebug
 * add getnumuword
 * 
 * *****************  Version 25  *****************
 * User: Tclancyx     Date: 3/04/99    Time: 8:48a
 * Updated in $/development/udebug
 * add setCount and getCount for reading a number of words
 * 
 * *****************  Version 24  *****************
 * User: Tclancyx     Date: 3/02/99    Time: 5:01p
 * Updated in $/development/udebug
 * udbg test support for Get and Set PCs on ueng basis
 * 
 * *****************  Version 23  *****************
 * User: Tclancyx     Date: 3/02/99    Time: 9:33a
 * Updated in $/development/udebug
 * add - setUengPCs and getUengPCs
 * 
 * *****************  Version 22  *****************
 * User: Tclancyx     Date: 3/01/99    Time: 1:23p
 * Updated in $/development/udebug
 * getUengPC test
 * 
 * *****************  Version 21  *****************
 * User: Drjohns1     Date: 2/24/99    Time: 6:45p
 * Updated in $/development/udebug
 * 
 * *****************  Version 20  *****************
 * User: Tclancyx     Date: 2/22/99    Time: 5:58p
 * Updated in $/development/udebug
 * add HopUeng test
 * 
 * *****************  Version 19  *****************
 * User: Drjohns1     Date: 2/12/99    Time: 6:35p
 * Updated in $/development/udebug
 * Updated for auto_ambio and multi-chip related changes
 * 
 * *****************  Version 18  *****************
 * User: Drjohns1     Date: 2/09/99    Time: 8:06p
 * Updated in $/development/udebug
 * 
 * *****************  Version 17  *****************
 * User: Drjohns1     Date: 2/09/99    Time: 7:22p
 * Updated in $/development/udebug
 * Updated for auto sim ambio read/write
 * 
 * *****************  Version 16  *****************
 * User: Drjohns1     Date: 2/09/99    Time: 2:38p
 * Updated in $/development/udebug
 * Updated for blocking ambaio read/write
 * 
 * *****************  Version 15  *****************
 * User: Tclancyx     Date: 1/26/99    Time: 10:55a
 * Updated in $/development/udebug
 * add functions to read 64 hi and lo
 * 
 * *****************  Version 13  *****************
 * User: Drjohns1     Date: 1/20/99    Time: 7:37p
 * Updated in $/development/udebug
 * Fixed pause & isActive problems
 * 
 * *****************  Version 12  *****************
 * User: Drjohns1     Date: 1/18/99    Time: 5:32p
 * Updated in $/development/udebug
 * Udated for new features and misc changes
 * 
 * *****************  Version 11  *****************
 * User: Tclancyx     Date: 1/18/99    Time: 3:00p
 * Updated in $/development/udebug
 * add return code for GetPC
 * 
 * *****************  Version 10  *****************
 * User: Tclancyx     Date: 1/12/99    Time: 4:00p
 * Updated in $/development/udebug
 * add return code to functions
 * 
 * *****************  Version 9  *****************
 * User: Drjohns1     Date: 12/11/98   Time: 12:35p
 * Updated in $/development/udebug
 * Completed chnages for reading/writing read & write xfer registers
 * 
 * *****************  Version 8  *****************
 * User: Drjohns1     Date: 12/09/98   Time: 1:01p
 * Updated in $/development/udebug
 * Added APIs for reading and write-xfer reg. and writing read-xfer reg.
 * 
 * *****************  Version 7  *****************
 * User: Drjohns1     Date: 12/07/98   Time: 9:31p
 * Updated in $/development/udebug
 * Initial release
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 10/29/98   Time: 7:46p
 * Created in $/users/Johnson/SA1200/udebug
 * 
 * ---------------------------------------------------------------------
 */
#include <iostream.h>
#include <stdio.h>
#include "config_1200.h"
#include "debug_1200.h"
#include "debug_1200.hxx"
#include "cntl.h"
#include "sem.h"
#include "thread.h"
#include "xact.h"
#include "Xact_API.h"
#include "BigMacAPI.h"

// #include "


extern "C" void cmdThread(void *);
void bkPtCallback(unsigned short breakpointId, unsigned char ctx);


uDbg_Bank_T RegBank;
uDbg_uStoreFree_T FreeU;
uDbg_BkptArray_T BkptArray;
uDbg_Bkpt_T Bkpt;
unsigned int Pc, Data, Status, Addr, Data64[2], tempData64[2];
unsigned int globalDebugHandle;

// for set and get count 
static int count = -1;

void bkPtCallback(unsigned short breakpointId, unsigned char ueng,
				  unsigned char ctx, void *myData)
{
	printf("\n\n @@@@@@ BREAKPOINT: BreakpointId=%d, Micro-engine=%d, Context %d stopped! @@@@@@\n",
		breakpointId, ueng, ctx); fflush(stdout);
	fflush(stdout);
	return;
}


void lstBreak()
{
   uDbg_Bkpt_T *bp;
   for(int i = 0; i < BkptArray.len; i++){
      bp = &BkptArray.bkpts[i];
	  printf("Breakpoint: id=%d, uEng=%d, activeCtxMask=0x%x, uAddr=0x%x\n",
	          bp->id, bp->uEng, (bp->ctx & 0xf), bp->uAddr);
   }
   return;
}


#ifdef __cplusplus
extern "C" {
#endif
const int MAX_DBGOBJS = 10;
Debug *DbgObjs[MAX_DBGOBJS];

inline void printData32()
{
	printf("0x%x\n", Data);
	fflush(stdout);
	return;
}

inline void printData64()
{
	printf("Data Returned: 0x%x 0x%x\n", Data64[0], Data64[1]);
	fflush(stdout);
	return;
}

int uWord(int handle)
{
   return(Data);
}

int getStatus(int handle)
{
   return(Status);
}

int CSRdata(int handle)
{
   return(Data);
}

int data32(int handle)
{
   return(Data);
}

int getPC(int handle)
{
   return(Pc);
}

int getUengPC(int handle)
{
   return(Pc);
}

void prnData32(int handle)
{
   printData32();
   return;
}

void prnData64(int handle)
{
   printData64();
   return;
}

inline int getData64Lo(int handle)
{
	return Data64[0];
}

inline int getData64Hi(int handle)
{
	return Data64[1];
}

inline void setRegBank(char *bank)
{
	if((bank) && *bank == 'b' || *bank == 'B') RegBank = UDBG_GPR_B_BANK;
	else RegBank = UDBG_GPR_A_BANK;
	return;
}

int  SimGo(unsigned int cycle)
{
   char cmdStr[16];

   sprintf(cmdStr,"go %d", cycle);

   /* execute the str as a console command */
   return(XACT_ExecuteCommandStr(cmdStr));
}

int getDbgHandle(Debug *obj)
{
   for(int i = 0; i < MAX_DBGOBJS; i++)
      if(DbgObjs[i] == NULL){
		 DbgObjs[i] = obj;
		 return(i);
	  }
   cout << "Sorry, maximum debug objects exceeded\n";
   return(-1);
}

Debug *rmDbgObj(int h)
{
	if(h >= 0 && h < MAX_DBGOBJS){
	   Debug *obj = DbgObjs[h];
       DbgObjs[h] = NULL;
	   return(obj);
	}
   cout << "Invalid debug handle\n";
   return(NULL);
}


Debug *getDbgObj(int h)
{
	if(h >= 0 && h < MAX_DBGOBJS)
      return(DbgObjs[h]);
   cout << "Invalid debug handle\n";
   return(NULL);
}

unsigned int newDbg()
{
   int h;
#if (OS!=WIN_32)
   OctalMACCreateDriver(0);
#endif
   Debug *dbgObj = new Debug(&FreeU);
   if((h = getDbgHandle(dbgObj)) < 0){
	   delete(dbgObj);
	   return(-1);
   }
   // set global for CNTL_ calls
   globalDebugHandle = (unsigned int)dbgObj;
   return (h);
   
}

int delDbg(int handle)
{
   Debug *dbgObj;

   if((dbgObj = rmDbgObj(handle)) == NULL) return(-1);
   delete(dbgObj);
   return(0);
}


int resetUeng(int handle, int uengMask)
{
   Debug *obj;
   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->ResetUeng(uengMask,0);
}


int startUeng(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->StartUeng(uengMask);
}


int hopUeng(int handle, int uEng, unsigned int delay)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->HopUeng((unsigned int *)&uEng, delay); 
}


int pauseUeng(int handle, int uengMask, int delay)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PauseUeng(uengMask, delay);
}

int resumeUeng(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->ResumeUeng(uengMask);
}


int setUthreadsPC(int handle, int uengMask, int ctxMask, int pc)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->SetUthreadsPC(uengMask, ctxMask, pc);
}


int getUthreadPC(int handle, int uengMask, int ctx)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->GetUthreadPC(uengMask, ctx, (unsigned int *)&Pc);
   return Pc;
}


int setUengPCs(int handle, int uEng, int pc)
{
	Debug *obj;
	int temp[3];
	temp[0] = pc;
	temp[1] = pc;
	temp[2] = pc;
	temp[3] = pc;
	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return obj->SetUengPCs((unsigned int)uEng, (unsigned int *)&temp);
}


int getUengPCs(int handle, int ueng, int pc)
{
	Debug *obj;
	int pc_array[3];
	int tmp;

	if((obj = getDbgObj(handle)) == NULL) return(-1);
	// GetUengPCs(unsigned char uEng, unsigned int *upc)
	obj->GetUengPCs((unsigned int)ueng, (unsigned int *)&pc_array);
	switch(pc)
	{
	case 0: tmp = pc_array[0]; break; 
	case 1: tmp = pc_array[1]; break; 
	case 2: tmp = pc_array[2]; break; 
	case 3: tmp = pc_array[3]; break; 
    }

	return tmp;
}

int setCount(int cnt)
{
	count = cnt;
	return 0;
}

int getCount(void)
{
	return count;
}

int isUengActive(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return(obj->IsUengActive(uengMask));
}

int getActiveUengs(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return(obj->GetActiveUengs(uengMask));
}

#if ((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))

int getCSR(int handle, int csr)
{
   Debug *obj;
   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Data = 0xdeadface;
   obj->GetCSR(csr, (unsigned int *)&Data);
   return(0);
}

int setCSR(int handle, int csr, int data)
{
   Debug *obj;
   if((obj = getDbgObj(handle)) == NULL) return(-1);
   obj->SetCSR(csr, data);
   return(0);
}

#endif		//((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))

int getUword(int handle, int uEng, int uWordAddr)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Data = 0xdeadface;
   return obj->GetUword(uEng, (unsigned int)uWordAddr, (unsigned int *)&Data);
}


int getNumUword(int handle, int uEng, int uWordAddr, int numWords)
{
   Debug *obj;

   // int word[1023];

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Data = 0xdeadface;
   return obj->GetUword(uEng, (unsigned int)uWordAddr, (unsigned int *)&Data);
}


int setUword(int handle, int uengMask, int uWordAddr, int data)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->SetUword(uengMask, (unsigned int)uWordAddr, data);
}

int setNumUword(int handle, int uengMask, int uWordAddr, int numWords, int data)
{
   Debug *obj;

   int word[20];
   
   for(int count = 0; count < numWords; count++)
	   word[count] = data;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->SetNumUword(uengMask, (unsigned int)uWordAddr, (unsigned short)numWords, 
	   (unsigned int *)word);
}


int dbgCmdDone(int handle)
{
   return(1);
}


int setBreak(int handle, int ueng, int activeCtxMask, int breakOnCtx, int upc)
{
   Debug *obj;
   uDbg_CTX_T breakIf;
   int stpUengMask = 0x3f;			// stop all uengines

   switch(breakOnCtx){
      case 0: breakIf = UDBG_CTX0; break;
      case 1: breakIf = UDBG_CTX1; break;
      case 2: breakIf = UDBG_CTX2; break;
      case 3: breakIf = UDBG_CTX3; break;
      default: breakIf = UDBG_CTXANY; break;
   }
   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Bkpt.uEng = (unsigned char)ueng;
   Bkpt.ctx = (unsigned short)(activeCtxMask & 0xf);
   Bkpt.uAddr = (unsigned short)upc;
   Bkpt.breakIfCtx = breakIf;
   Bkpt.stpOnBrkUengMask = stpUengMask;
   return obj->SetBreakpoint(&Bkpt);
}


int showBreak(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->ShowBreakpoints(uengMask, &BkptArray);
}


int listBreak(int handle)
{
   lstBreak();
   return(0);
}

int cont(int handle)
{
   Debug *obj;
   unsigned int uEngMask;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   uEngMask = 1 << (Bkpt.uEng+1);
   return obj->ResumeUeng(uEngMask);
}

int clrAllBreak(int handle, int uengMask)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->ClearAllBreakpoints(uengMask);
}

int clrBreak(int handle)
{
   Debug *obj;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->ClearBreakpoint(Bkpt.id);
}

int getMem32(int handle, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Data = 0xdeadface;
   return obj->ReadMem32((unsigned int)memAddr, (unsigned int *)&Data, cnt);
}

int setMem32(int handle, int memAddr, int data)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->WriteMem32(memAddr, (unsigned int *)&data, cnt);
}


int getMem64(int handle, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   // init to bad data
   Data64[0] = 0xdeadface;
   Data64[1] = 0xdeadface;
   return obj->ReadMem64((unsigned int)memAddr, Data64, cnt);
}

int setMem64(int handle, int memAddr, int dataH, int dataL)
{
   Debug *obj;
   int Data[8];
   int cnt;

   if((obj = getDbgObj(handle)) == NULL) return(-1);

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   // stuff data array for multiple counts
   Data[0] = dataL;
   Data[1] = dataH;
   Data[2] = dataL;
   Data[3] = dataH;
   Data[4] = dataL;
   Data[5] = dataH;	
   return obj->WriteMem64((unsigned int)memAddr, (unsigned int*)&Data, cnt);
}



int setRelGpr(char *bank, int handle, int ueng, int ctx, int memAddr,
			  int data)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   setRegBank(bank);
   return obj->PutRelGPR(ueng, ctx, RegBank, memAddr,
						(unsigned int *)&data, cnt);
}


int getRelGpr(char *bank, int handle, int ueng, int ctx, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   setRegBank(bank);
   Data = 0xdeadface;
   return obj->GetRelGPR(ueng, ctx, RegBank,(unsigned int)memAddr,
						(unsigned int *)&Data, cnt);
}


int setRelSramWrXfer(int handle, int ueng, int ctx, int memAddr, int data)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSRAM_WrXfer(ueng, ctx, (unsigned int)memAddr, (unsigned int *)&data, cnt);
}

int getRelSramWrXfer(int handle, int ueng, int ctx, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
  //  Data = 0xdeadface;
   return obj->GetRelSRAM_WrXfer(ueng, ctx,(unsigned int)memAddr, (unsigned int *)&Data, cnt);
}

int setRelSramRdXfer(int handle, int ueng, int ctx, int memAddr, int data)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSRAM_RdXfer(ueng, ctx,(unsigned int)memAddr, (unsigned int *)&data, cnt);
}

int getRelSramRdXfer(int handle, int ueng, int ctx, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 1; 
   } else { 
	   cnt = count; 
   }

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   Data = 0xdeadface;
   return obj->GetRelSRAM_RdXfer(ueng, ctx, (unsigned int)memAddr, (unsigned int *)&Data, cnt);
}


int setRelSdramWrXfer(int handle, int ueng, int ctx, int memAddr, int dataL)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = dataL;
   Data64[1] = 0xcccccccc;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSDRAM_WrXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}


int getRelSdramRdXfer(int handle, int ueng, int ctx, int memAddr)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = 0xdeadface;
   Data64[1] = 0xdeadface;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->GetRelSDRAM_RdXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}

// This is for legacy code. Don't use this, since it always sets the high
// word 0xcccccccc.
int setRelSdramRdXfer(int handle, int ueng, int ctx, int memAddr, int dataL)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = dataL;
   Data64[1] = 0xcccccccc;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSDRAM_RdXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}


// Set the low word
int setRelSdramRdXferLo(int handle, int ueng, int ctx, int memAddr, int dataL)
{
   Debug *obj;
   int cnt;

   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = dataL;
   Data64[1] = 0xcccccccc;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSDRAM_RdXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}


// Set the hi word
int setRelSdramRdXferHi(int handle, int ueng, int ctx, int memAddr, int dataHi)
{
   Debug *obj;
   int cnt;
   
   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = 0xcccccccc;
   Data64[1] = dataHi;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->PutRelSDRAM_RdXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}


int getRelSdramWrXfer(int handle, int ueng, int ctx, int memAddr)
{
   Debug *obj;
   int cnt;	

   if (count == -1) { 
	   cnt = 2; 
   } else { 
	   cnt = count; 
   }

   Data64[0] = 0xdeadface;
   Data64[1] = 0xdeadface;

   if((obj = getDbgObj(handle)) == NULL) return(-1);
   return obj->GetRelSDRAM_WrXfer(ueng, ctx,(unsigned int)memAddr, Data64, cnt);
}

////////////////////////////////////
// control function tests
////////////////////////////////////

int CNTLCreateHandle(void) {
	int handle = 0;

	Debug *obj;
   
	if((obj = getDbgObj(handle)) == NULL) return(-1);

	return handle;
}

int CNTLReleaseHandle(void) {
	int handle = 0;
	return handle;
}

int CNTLGiveControl(int handle, int ueng) {

	Debug *obj;
	SysConf *sysConf = SysConf_Attach();

	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return(sysConf->GiveControl());

}

int CNTLTakeControl(int handle, int ueng) {
	
	Debug *obj;
	SysConf *sysConf = SysConf_Attach();

	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return(sysConf->TakeControl());
}

int CNTLReset(int handle, int ueng, unsigned int pMask) {

	Debug *obj;   
	printf("The Current debug handle = 0x%x\n", globalDebugHandle);

	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return CNTL_Reset((void *)globalDebugHandle, (unsigned int)ueng, pMask,0 );
}


int CNTLPause(int handle, int ueng,unsigned int pMask) {
   
	Debug *obj;  	
	unsigned int delay = 0;
   
	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return CNTL_Pause((void *)globalDebugHandle, ueng, pMask, delay);
}

int CNTLStart(int handle, int ueng,unsigned int pMask) {
   
	Debug *obj;  	
   
	if((obj = getDbgObj(handle)) == NULL) return(-1);
	return CNTL_Start((void *)globalDebugHandle, (unsigned int)ueng, pMask);
}


////////////////////////////////////
// Amba R/W functions
////////////////////////////////////
#if ((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))

int AMBA_Read(int addr, int data){
	WRITE_LWORD(addr, data); 
	return 1;
}

int AMBA_Write(int addr, int data){
	WRITE_LWORD(addr, data); 
	// setUword(addr, data);
	return 1;
}

#endif		//((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))

int uDbg_Test_LibInit()
{
   cout <<"Initializing debug library\n";

    FreeU.freeUpc[0] = 48;
	FreeU.freeUpc[1] = 48;
	FreeU.freeUpc[2] = 48;
	FreeU.freeUpc[3] = 48;
	FreeU.freeUpc[4] = 48;
	FreeU.freeUpc[5] = 48;

	FreeU.freeSize[0] = 724;
	FreeU.freeSize[1] = 724;
	FreeU.freeSize[2] = 724;
	FreeU.freeSize[3] = 724;
	FreeU.freeSize[4] = 724;
	FreeU.freeSize[5] = 724;

    Bkpt.callback = bkPtCallback;
    Bkpt.usrData = NULL;
    BkptArray.len = 0;

   if (!XACT_register_console_function("newDbg", newDbg, 0, 0) ){
      fprintf(stderr,"XACT_register_console_function() newDbg failed\n");
      return(0);
   }

   if (!XACT_register_console_function("delDbg", delDbg, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() delDbg failed\n");
      return(0);
   }

   if (!XACT_register_console_function("resetEngines", resetUeng, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() resetEngines failed\n");
      return(0);
   }

   if (!XACT_register_console_function("startEngines", startUeng, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() startEngines failed\n");
      return(0);
   }

   if (!XACT_register_console_function("pauseThreads", pauseUeng, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() pauseThreads failed\n");
      return(0);
   }

   if (!XACT_register_console_function("hopUeng", hopUeng, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() pauseThreads failed\n");
      return(0);
   }

   if (!XACT_register_console_function("resumeThreads", resumeUeng, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() resumeThreads failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getUthreadPC", getUthreadPC, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() getUthreadPC failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setUthreadsPC", setUthreadsPC, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() setUthreadsPC failed\n");
      return(0);
   }

   if (!XACT_register_console_function("isUengActive", isUengActive, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() isUengActive failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getActiveUengs", getActiveUengs, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() isUengActive failed\n");
      return(0);
   }	

   if (!XACT_register_console_function("getStatus", getStatus, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() getStatus failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getPC", getPC, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() getPC failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getCount", getCount, 0, 0) ){
      fprintf(stderr,"XACT_register_console_function() getPC failed\n");
      return(0);
   }
   
   if (!XACT_register_console_function("setCount", setCount, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() getPC failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getUengPCs", getUengPCs, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() getPC failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setUengPCs", setUengPCs, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() getPC failed\n");
      return(0);
   }

#if ((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))
   
   if (!XACT_register_console_function("setCSR", setCSR, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() setCSR failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getCSR", getCSR, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() getCSR failed\n");
      return(0);
   }
	if (!XACT_register_console_function("AMBA_Read", AMBA_Read , 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() AMBA_Read failed\n");
      return(0);
   }

	if (!XACT_register_console_function("AMBA_Write", AMBA_Write , 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() AMBA_Write failed\n");
      return(0);
   }

#endif		//((IOSTYLE==HARDWARE)||(IOSTYLE==AMBAIO))

   if (!XACT_register_console_function("CSRdata", CSRdata, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() CSRdata failed\n");
      return(0);
   }

   if (!XACT_register_console_function("data32", data32, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() data32 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("uWord", uWord, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() uWord failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setUword", setUword, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() setUword failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setNumUword", setNumUword, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setUword failed\n");
      return(0);
   } 	


   if (!XACT_register_console_function("getUword", getUword, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() getUword failed\n");
      return(0);
   }


   if (!XACT_register_console_function("dbgCmdDone", dbgCmdDone, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() dbgCmdDone failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setBreak", setBreak, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setBreak failed\n");
      return(0);
   }

   if (!XACT_register_console_function("showBreak", showBreak, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() showBreak failed\n");
      return(0);
   }

   if (!XACT_register_console_function("listBreak", listBreak, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() listBreak failed\n");
      return(0);
   }

   if (!XACT_register_console_function("cont", cont, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() cont failed\n");
      return(0);
   }

   if (!XACT_register_console_function("clrAllBreak", clrAllBreak, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() clrAllBreak failed\n");
      return(0);
   }

   if (!XACT_register_console_function("clrBreak", clrBreak, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() clrBreak failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getMem32", getMem32, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() getMem32 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setMem32", setMem32, 0, 3) ){
      fprintf(stderr,"XACT_register_console_function() setMem32 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getMem64", getMem64, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() getMem64 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setMem64", setMem64, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() setMem64 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("prnData32", prnData32, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() prnData32 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("prnData64", prnData64, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() prnData64 failed\n");
      return(0);
   }

   
   if (!XACT_register_console_function("getData64Lo", getData64Lo, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() prnData64 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getData64Hi", getData64Hi, 0, 1) ){
      fprintf(stderr,"XACT_register_console_function() prnData64 failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setRelGpr", setRelGpr, 1, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelGpr failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getRelGpr", getRelGpr, 1, 4) ){
      fprintf(stderr,"XACT_register_console_function() getRelGpr failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setRelSramWrXfer", setRelSramWrXfer, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSramWrXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getRelSramWrXfer", getRelSramWrXfer, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() getRelSramWrXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setRelSramRdXfer", setRelSramRdXfer, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSramRdXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getRelSramRdXfer", getRelSramRdXfer, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() getRelSramRdXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setRelSdramWrXfer", setRelSdramWrXfer, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSdramWrXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getRelSdramWrXfer", getRelSdramWrXfer, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() getRelSdramWrXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("getRelSdramRdXfer", getRelSdramRdXfer, 0, 4) ){
      fprintf(stderr,"XACT_register_console_function() getRelSdramRdXfer failed\n");
      return(0);
   }

   if (!XACT_register_console_function("setRelSdramRdXfer", setRelSdramRdXfer, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSdramRdXfer failed\n");
      return(0);
   }

	if (!XACT_register_console_function("setRelSdramRdXferLo", setRelSdramRdXferLo, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSdramRdXfer failed\n");
      return(0);
   }


	if (!XACT_register_console_function("setRelSdramRdXferHi", setRelSdramRdXferHi, 0, 5) ){
      fprintf(stderr,"XACT_register_console_function() setRelSdramRdXfer failed\n");
      return(0);
   }


	if (!XACT_register_console_function("CNTLGiveControl", CNTLGiveControl, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() CNTLGiveControl failed\n");
      return(0);
   }   	

	if (!XACT_register_console_function("CNTLTakeControl", CNTLTakeControl, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() CNTLTakeControl failed\n");
      return(0);
   }

	if (!XACT_register_console_function("CNTLReset", CNTLReset, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() CNTLReset failed\n");
      return(0);
   }

	if (!XACT_register_console_function("CNTLPause", CNTLPause, 0, 2) ){
      fprintf(stderr,"XACT_register_console_function() CNTLPause failed\n");
      return(0);
   }

	if (!XACT_register_console_function("CNTLStart", CNTLStart , 0, 2) ){
      fprintf(stderr,"XACT_register_console_function()  CNTLStart failed\n");
      return(0);
   }


   cout <<"uDbg_Test_LibInit completed\n";
   cout.flush();
   return(1);
}


#ifdef __cplusplus
}
#endif
