CPU		= ARMSA110
TOOL		= gnu
INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../debug_1200 \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils \
-I../msgQ


ADDED_C++FLAGS  = -w -Wall -pedantic -DVxWorkTest \
-DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DVXWORKS -DROUTE -DFBUS_DEV0_TYPE=0 -DFBUS_DEV1_TYPE=1 -DMAC_21440 \
-DMAC_GC82547EB -DWB_SVR -DFBUS_DEVICE_COUNT=2 -D__unix -DPETH_DRV -DPETH_NUM_DEVS=8 -DRTM_MVR $(INCLUDE)
# -DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DROUTE -DVXWORKS -DUCOMM_DRIVER -DMAC_21440 -DFBUS_DEVICE_COUNT=2 -D__unix $(INCLUDE)
#-DMAC_21440

TGT_DIR=$(WIND_BASE)/target
default		: $(DEMO_DIR)
#include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

default		: $(DEMO_DIR)

NetApp_DBG	:

			if not exist "../../vxworks_lib" mkdir "../../vxworks_lib"
			if not exist "../../vxworks_lib/debug" mkdir "../../vxworks_lib/debug"
			$(CC) -g -c ../core_utils/intlibvx.s
			$(CC) -g $(C++FLAGS) -c hw_svlib_tests.cpp
			$(CC) -g $(C++FLAGS) -c ../hal_1200/hal_sram.cpp 
			$(CC) -g $(C++FLAGS) -c ../hal_1200/hal_sdram.cpp 
			$(CC) -g $(C++FLAGS) -c ../hal_1200/hal_fbi.cpp 
			$(CC) -g $(C++FLAGS) -c version.cpp
			$(CC) -g $(C++FLAGS) -c ../app_1200/net_app.cpp 
			$(CC) -g $(C++FLAGS) -c ../app_1200/mvr_ucld.c 
			$(CC) -g $(C++FLAGS) -c ../app_1200/config_1200.cpp 
			$(CC) -g $(C++FLAGS) -c ../app_1200/tstapi.cpp 
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/rtm.cpp 	
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/Trie.cpp 	
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/TrieManager.cpp
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/PortManager.cpp
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/RouteTable.cpp
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/rtm_test.cpp
			$(CC) -g $(C++FLAGS) -c ../rtm-mvr/rtm_console.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_bits.c
			$(CC) -g $(C++FLAGS) -c ../../utils/utl_crc.c 
			$(CC) -g $(C++FLAGS) -c ../../osApi/sem.c
			$(CC) -g $(C++FLAGS) -c ../../osApi/thread.c
			$(CC) -g $(C++FLAGS) -c ../../osApi/delay.c
			$(CC) -g $(C++FLAGS) -c ../../utils/sram_man.cpp
			$(CC) -g $(C++FLAGS) -c ../uclo/uclo.c
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_lib.cpp  
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_umm.cpp  
			$(CC) -g $(C++FLAGS) -c ../debug_1200/udbg_clib.cpp  
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../debug_1200/control.cpp
			$(CC) -g $(C++FLAGS) -c ../octalmac_21440/macdrv.cpp
			$(CC) -g $(C++FLAGS) -c ../octalmac_21440/PseudoDrvEnd.cpp
			$(CC) -g $(C++FLAGS) -c ../gigamac_gc82547eb/gigmac.cpp
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_uDbg_events_clnt.c
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_uDbg_events_xdr.c
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_udbg_interface.cpp
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_udebug_svc.c
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_udebug_xdr.c
			$(CC) -g $(C++FLAGS) -D_DBG_PRINT -c ../../share/rs_udebug/rs_udbg_init.cpp
			$(CC) -g $(C++FLAGS) -c ../libd/libd.cpp
			$(CC) -g $(C++FLAGS) -c ../libd/libd_router.cpp
			$(CC) -g $(C++FLAGS) -c ../libd/libd_exec.cpp
			$(CC) -g $(C++FLAGS) -c ../msgq/msgq.cpp
			$(CC) -g $(C++FLAGS) -c ../msgq/msgqmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../driver/UcommDriver.cpp
			$(CC) -g $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/hashsv.cpp
			$(CC) -g $(C++FLAGS) -c ../sv_libs/memsv.cpp
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng.cpp
			$(CC) -g $(C++FLAGS) -c ../ueng/ueng_clib.cpp

			ldarm -o netapp.o -r \
			intlibvx.o \
			rtm.o \
			Trie.o \
			TrieManager.o \
			PortManager.o \
			RouteTable.o \
			rtm_test.o \
			rtm_console.o \
			version.o \
			config_1200.o \
			tstapi.o \
			net_app.o \
			hal_sram.o \
			hal_sdram.o \
			hal_fbi.o \
			ueng.o \
			ueng_clib.o \
			uclo.o \
			utl_bits.o \
			utl_crc.o \
			sem.o \
			thread.o \
			delay.o \
			sram_man.o \
			udbg_lib.o \
			udbg_clib.o \
			udbg_umm.o \
			control.o \
			rs_uDbg_events_clnt.o \
			rs_uDbg_events_xdr.o \
			rs_udbg_interface.o \
			rs_udebug_svc.o \
			rs_udebug_xdr.o \
			rs_udbg_init.o \
			libd_router.o \
			libd_exec.o \
			libd.o \
			msgq.o \
			msgqmgr.o \
			UcommDriver.o \
			poolmgr.o \
			hashsv.o \
			memsv.o \
			hw_svlib_tests.o \
			mvr_ucld.o \
			gigmac.o \
			macdrv.o \
			PseudoDrvEnd.o

			nmarm netapp.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/debug/VxWorks_MVR.o -r __CtorDtor.o netapp.o


NetApp_REL		: 	
			if not exist "../../vxworks_lib" mkdir "../../vxworks_lib"
			$(CC)  -c ../core_utils/intlibvx.s
			$(CC)  $(C++FLAGS) -c ../hal_1200/hal_sram.cpp 
			$(CC)  $(C++FLAGS) -c ../hal_1200/hal_sdram.cpp 
			$(CC)  $(C++FLAGS) -c ../hal_1200/hal_fbi.cpp
			$(CC)  $(C++FLAGS) -c version.cpp  
			$(CC)  $(C++FLAGS) -c ../app_1200/config_1200.cpp 
			$(CC)  $(C++FLAGS) -c ../app_1200/tstapi.cpp 
			$(CC)  $(C++FLAGS) -c ../app_1200/net_app.cpp 
			$(CC)  $(C++FLAGS) -c ../app_1200/mvr_ucld.c 
			$(CC)  $(C++FLAGS) -c ../../utils/utl_bits.c
			$(CC)  $(C++FLAGS) -c ../../utils/utl_crc.c 
			$(CC)  $(C++FLAGS) -c ../../utils/sem.c
			$(CC)  $(C++FLAGS) -c ../../utils/thread.c
			$(CC)  $(C++FLAGS) -c ../../utils/delay.c
			$(CC)  $(C++FLAGS) -c ../../utils/sram_man.cpp
			$(CC)  $(C++FLAGS) -c ../uclo/uclo.c
			$(CC)  $(C++FLAGS) -c ../debug_1200/udbg_lib.cpp  
			$(CC)  $(C++FLAGS) -c ../debug_1200/udbg_umm.cpp  
			$(CC)  $(C++FLAGS) -c ../debug_1200/udbg_clib.cpp  
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_clnt.c
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_uDbg_events_xdr.c
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_udbg_interface.cpp
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_svc.c
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_udebug_xdr.c
			$(CC)  $(C++FLAGS) -c ../../share/rs_udebug/rs_udbg_init.cpp
			$(CC)  $(C++FLAGS) -c ../debug_1200/control.cpp
			$(CC)  $(C++FLAGS) -c ../octalmac_21440/macdrv.cpp
			$(CC)  $(C++FLAGS) -c ../octalmac_21440/PseudoDrvEnd.cpp
			$(CC)  $(C++FLAGS) -c ../gigamac_gc82547eb/gigmac.cpp
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/rtm.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/Trie.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/TrieManager.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/PortManager.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/RouteTable.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/rtm_test.cpp 
			$(CC)  $(C++FLAGS) -c ../rtm-mvr/rtm_console.cpp 		
			$(CC)  $(C++FLAGS) -c ../libd/libd.cpp
			$(CC)  $(C++FLAGS) -c ../libd/libd_router.cpp
			$(CC)  $(C++FLAGS) -c ../libd/libd_exec.cpp
			$(CC)  $(C++FLAGS) -c ../msgq/msgq.cpp
			$(CC)  $(C++FLAGS) -c ../msgq/msgqmgr.cpp
			$(CC)  $(C++FLAGS) -c ../driver/UcommDriver.cpp
			$(CC)  $(C++FLAGS) -c ../../utils/poolmgr.cpp
			$(CC)  $(C++FLAGS) -c ../sv_libs/hashsv.cpp
			$(CC)  $(C++FLAGS) -c ../sv_libs/memsv.cpp
			$(CC)  $(C++FLAGS) -c hw_svlib_tests.cpp
			$(CC)  $(C++FLAGS) -c ../ueng/ueng.cpp
			$(CC)  $(C++FLAGS) -c ../ueng/ueng_clib.cpp

			ldarm -o netapp.o -r \
			intlibvx.o \
			rtm.o \
			Trie.o \
			TrieManager.o \
			PortManager.o \
			RouteTable.o \
			rtm_test.o \
			rtm_console.o \
			version.o \
			rs_uDbg_events_clnt.o \
			rs_uDbg_events_xdr.o \
			rs_udbg_interface.o \
			rs_udebug_svc.o \
			rs_udebug_xdr.o \
			rs_udbg_init.o \
			config_1200.o \
			tstapi.o \
			net_app.o \
			hal_sram.o \
			hal_sdram.o \
			hal_fbi.o \
			ueng.o \
			ueng_clib.o \
			uclo.o \
			utl_bits.o \
			utl_crc.o \
			sem.o \
			thread.o \
			delay.o \
			sram_man.o \
			udbg_lib.o \
			udbg_clib.o \
			udbg_umm.o \
			control.o \
			libd.o \
			libd_router.o \
			libd_exec.o \
			msgq.o \
			msgqmgr.o \
			UcommDriver.o \
			poolmgr.o \
			hashsv.o \
			memsv.o \
			hw_svlib_tests.o \
			gigmac.o \
			macdrv.o \
			PseudoDrvEnd.o \
			mvr_ucld.o


			nmarm netapp.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o ../../vxworks_lib/VxWorks_MVR.o -r __CtorDtor.o netapp.o
			

			$(AR) -rc ../../vxworks_lib/VxWorks_Gig_mvr.a \
			intlibvx.o \
			rtm.o \
			Trie.o \
			TrieManager.o \
			PortManager.o \
			RouteTable.o \
			rtm_test.o \
			rtm_console.o \
			version.o \
			rs_uDbg_events_clnt.o \
			rs_uDbg_events_xdr.o \
			rs_udbg_interface.o \
			rs_udebug_svc.o \
			rs_udebug_xdr.o \
			rs_udbg_init.o \
			config_1200.o \
			tstapi.o \
			net_app.o \
			hal_sram.o \
			hal_sdram.o \
			hal_fbi.o \
			ueng.o \
			ueng_clib.o \
			uclo.o \
			utl_bits.o \
			utl_crc.o \
			sem.o \
			thread.o \
			delay.o \
			sram_man.o \
			udbg_lib.o \
			udbg_clib.o \
			udbg_umm.o \
			control.o \
			libd.o \
			libd_router.o \
			libd_exec.o \
			msgq.o \
			msgqmgr.o \
			UcommDriver.o \
			poolmgr.o \
			hashsv.o \
			memsv.o \
			hw_svlib_tests.o \
			gigmac.o \
			macdrv.o \
			PseudoDrvEnd.o \
			mvr_ucld.o
						

		
clean		: 
		$(RM) *.o

