CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../debug_1200 \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils \
-I../msgQ


ADDED_C++FLAGS  = -w -Wall -pedantic -DVxWorkTest \
-DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DVXWORKS -DROUTE \
-DRTM -DMAC_21440 -DWB_SVR -DFBUS_DEVICE_COUNT=2 \
-D__unix -DUCLO_PCI -DSCOMM_HPC $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

TST_OBJS = hw_svlib_tests.o version.o
VX_NETAPP = $(LIB_DIR)/VxWorksNetapps.o

LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/hal_1200.a \
	  $(LIB_DIR)/utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/uclo.a \
	  $(LIB_DIR)/ueng.a \
	  $(LIB_DIR)/debug_1200.a \
	  $(LIB_DIR)/libd.a \
	  $(LIB_DIR)/msgq.a \
	  $(LIB_DIR)/rtm.a \
	  $(LIB_DIR)/brm.a \
	  $(LIB_DIR)/app_1200.a \
	  $(LIB_DIR)/sv_libs.a \
	  $(LIB_DIR)/rs_udebug.a \
	  $(LIB_DIR)/scomm.a \
	  $(LIB_DIR)/octalmac_21440.a \
	  $(LIB_DIR)/gigmac.a \
	  $(LIB_DIR)/pciComm.a \
	  $(LIB_DIR)/ucommdriver.a


.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe: $(VX_NETAPP)

NetApps : $(VX_NETAPP)

$(VX_NETAPP) : $(TST_OBJS) Libs
	ldarm --whole-archive -r -o netapps.o $(TST_OBJS) $(LIBRARIES)
	nmarm netapps.o | munch > __CtorDtorx.c
	$(CC)  -c -traditional __CtorDtorx.c
	ldarm -o $(VX_NETAPP) -r __CtorDtorx.o netapps.o


Libs:
	@make -f vxworks_CoreLibs.mak CCMODE=$(CCMODE)

clean : 
	@$(RM) $(VX_NETAPP) $(TST_OBJS) __CtorDtorx.o netapps.o 

clean_all: clean
	@make -s -f vxworks_CoreLibs.mak CCMODE=$(CCMODE) clean

