CPU		= ARMSA110
TOOL		= gnu
ADDED_C++FLAGS  = -Wall -pedantic -Dast_parse -Dxactor_build -DVxWorkTest\
 -Dext_model_port -DUCLO_TEST -Dno_uca_code_gen -Dbuild_without_main
#ADDED_C++FLAGS  = -Wall -Dast_parse -Dxactor_build -DVxWorkTest


TGT_DIR=$(WIND_BASE)/target
default		: $(DEMO_DIR)



include $(TGT_DIR)/h/make/defs.bsp

include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

default		: $(DEMO_DIR)

#$(DEMO_DIR)	: .neverbuilt
release		:.neverbuilt
	         $(CC) $(C++FLAGS) -c ast_parse.cpp 
			$(CC) $(C++FLAGS) -c base_obj.cpp
			$(CC) $(C++FLAGS) -c c_interp.cpp
 			$(CC) $(C++FLAGS) -c data.cpp
			$(CC) $(C++FLAGS) -c debug.cpp 
			$(CC) $(C++FLAGS) -c dos_key.cpp
			$(CC) $(C++FLAGS) -c fbi.cpp 
			$(CC) $(C++FLAGS) -c fbox.cpp 
			$(CC) $(C++FLAGS) -c lst_util.cpp 
			$(CC) $(C++FLAGS) -c mem.cpp 
			$(CC) $(C++FLAGS) -c mem_man.cpp 
			$(CC) $(C++FLAGS) -c model_state.cpp  
#			$(CC) $(C++FLAGS) -c name_list.cpp 
			$(CC) $(C++FLAGS) -c re.cpp 
			$(CC) $(C++FLAGS) -c safexact.cpp 
			$(CC) $(C++FLAGS) -c sdram_cntl.cpp  
			$(CC) $(C++FLAGS) -c sim.cpp 
			$(CC) $(C++FLAGS) -c sram_cntl.cpp 
			$(CC) $(C++FLAGS) -c veriport.cpp 
			$(CC) $(C++FLAGS) -c xact_main.cpp 
	   	        $(CC) -mcpu=strongarm110 -mapcs-32 -ansi -nostdinc \
				-DRW_MULTI_THREAD -D_REENTRANT -O2 -mno-sched-prolog\
				 -fno-builtin -fvolatile  -I/h   -I. \
                                -I$(TGT_DIR)\config\all -I$(TGT_DIR)/h \
                                -I$(TGT_DIR)/src/config -I$(TGT_DIR)/src/drv\
			        -DCPU=ARMSA110\
                                -Wall -Dast_parse -Dxactor_build -DVxWorkTest -c name_list.cpp 
			$(CC) $(C++FLAGS) -I..\ucld -I..\tool\xact_io -c ..\uclo\uclo.c 
			$(CC) $(C++FLAGS) -c ..\ucld\utl_bits.c
			$(CC) $(C++FLAGS) -c ..\ucld\utl_crc.c 
			$(CC) $(C++FLAGS) -I..\..\safe_xactor -I..\tool\common -c ..\tool\xact_io\xact_api.cpp 
			$(CC) $(C++FLAGS) -I..\uclo -c ..\tool\test\uclo_test\uclo_test_1.c 

			ldarm -o archmodel.o -r ast_parse.o\
			base_obj.o\
			c_interp.o code_gen.o core_obj.o\
			data.o debug.o dos_key.o\
			fbi.o fbox.o\
			lst_util.o mem.o mem_man.o\
			model_state.o name_list.o re.o\
			safexact.o sdram_cntl.o	sim.o\
			rtm_registration.o uclo.o utl_bits.o utl_crc.o\
			xact_api.o uclo_test_1.o\
			sram_cntl.o veriport.o xact_main.o 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o archmodelOUT.o -r __CtorDtor.o archmodel.o


debug		:.neverbuilt

	         $(CC) $(C++FLAGS) -c ast_parse.cpp -g 
			$(CC) $(C++FLAGS) -c base_obj.cpp -g
#			$(CC) $(C++FLAGS) -c bw_utils.cpp -g 
			$(CC) $(C++FLAGS) -c c_interp.cpp -g
			$(CC) $(C++FLAGS) -c data.cpp -g
			$(CC) $(C++FLAGS) -c debug.cpp -g
			$(CC) $(C++FLAGS) -c dos_key.cpp -g
			$(CC) $(C++FLAGS) -c fbi.cpp -g
			$(CC) $(C++FLAGS) -c fbox.cpp -g 
#			$(CC) $(C++FLAGS) -c gen_pars.cpp -g
			$(CC) $(C++FLAGS) -c lst_util.cpp -g 
			$(CC) $(C++FLAGS) -c mem.cpp -g
			$(CC) $(C++FLAGS) -c mem_man.cpp -g 
			$(CC) $(C++FLAGS) -c model_state.cpp -g  
#			$(CC) $(C++FLAGS) -c name_list.cpp -g
			$(CC) $(C++FLAGS) -c re.cpp -g
			$(CC) $(C++FLAGS) -c safexact.cpp -g 
			$(CC) $(C++FLAGS) -c sdram_cntl.cpp -g  
			$(CC) $(C++FLAGS) -c sim.cpp -g
			$(CC) $(C++FLAGS) -c sram_cntl.cpp -g 
			$(CC) $(C++FLAGS) -c veriport.cpp -g 
			$(CC) $(C++FLAGS) -c xact_main.cpp -g 
	   	        $(CC) -mcpu=strongarm110 -mapcs-32 -ansi -nostdinc \
				-DRW_MULTI_THREAD -D_REENTRANT -O2 -mno-sched-prolog\
				 -fno-builtin -fvolatile  -I/h   -I. \
                                -I$(TGT_DIR)\config\all -I$(TGT_DIR)/h \
                                -I$(TGT_DIR)/src/config -I$(TGT_DIR)/src/drv\
			        -DCPU=ARMSA110\
                                -Wall -Dast_parse -Dxactor_build -DVxWorkTest -c name_list.cpp -g 
			$(CC) $(C++FLAGS) -I..\ucld -I..\tool\xact_io -c ..\uclo\uclo.c -g 
			$(CC) $(C++FLAGS) -c ..\ucld\utl_bits.c -g 
			$(CC) $(C++FLAGS) -c ..\ucld\utl_crc.c -g 
			$(CC) $(C++FLAGS) -I..\..\safe_xactor -I..\tool\common -c ..\tool\xact_io\xact_api.cpp -g 
			$(CC) $(C++FLAGS) -I..\uclo -c ..\tool\xact_io\uclo_test_1.c -g 


			ldarm -o archmodel.o -r ast_parse.o\
			base_obj.o\
			c_interp.o\
			data.o debug.o dos_key.o\
			fbi.o fbox.o\
			lst_util.o mem.o mem_man.o\
			model_state.o name_list.o re.o\
			safexact.o sdram_cntl.o	sim.o\
			rtm_registration.o uclo.o utl_bits.o utl_crc.o\
			xact_api.o uclo_test_1.o\
			sram_cntl.o veriport.o xact_main.o -g 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o archmodelOUT.o -r __CtorDtor.o archmodel.o

Dbg_uclo_test:
	$(CC) $(C++FLAGS) -c ..\rtm\src\rtm_registration.c -g 
			$(CC) $(C++FLAGS) -I..\ucld -I..\tool\xact_io -c ..\uclo\uclo.c -g 
			$(CC) $(C++FLAGS) -c ..\ucld\utl_bits.c -g 
			$(CC) $(C++FLAGS) -c ..\ucld\utl_crc.c -g 
			$(CC) $(C++FLAGS) -I..\..\safe_xactor -I..\tool\common -c ..\tool\xact_io\xact_api.cpp -g 
			$(CC) $(C++FLAGS) -I..\uclo -c ..\tool\test\uclo_test\uclo_test_1.c -g 

			ldarm -o archmodel.o -r ast_parse.o\
			base_obj.o\
			c_interp.o\
			data.o debug.o dos_key.o\
			fbi.o fbox.o\
			lst_util.o mem.o mem_man.o\
			model_state.o name_list.o re.o\
			safexact.o sdram_cntl.o	sim.o\
			rtm_registration.o uclo.o utl_bits.o utl_crc.o\
			xact_api.o uclo_test_1.o\
			sram_cntl.o veriport.o xact_main.o -g 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o archmodelOUT.o -r __CtorDtor.o archmodel.o


one_release:
#			$(CC) $(C++FLAGS) -c ..\uca\bw_utils.cpp 

			ldarm -o archmodel.o -r ast_parse.o\
			base_obj.o bw_utils.o\
			c_interp.o  core_obj.o\
			data.o debug.o dos_key.o\
			fbi.o fbox.o gen_pars.o\
			lst_util.o mem.o mem_man.o\
			model_state.o name_list.o re.o\
			safexact.o sdram_cntl.o	sim.o\
			rtm_registration.o uclo.o utl_bits.o utl_crc.o\
			xact_api.o uclo_test_1.o\
			sram_cntl.o veriport.o xact_main.o -g 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o archmodelOUT.o -r __CtorDtor.o archmodel.o


one_debug:
			$(CC) $(C++FLAGS) -c ..\uca\gen_pars.cpp -g

			ldarm -o archmodel.o -r ast_parse.o\
			base_obj.o bw_utils.o\
			c_interp.o\
			data.o debug.o dos_key.o\
			fbi.o fbox.o gen_pars.o\
			lst_util.o mem.o mem_man.o\
			model_state.o name_list.o re.o\
			safexact.o sdram_cntl.o	sim.o\
			rtm_registration.o uclo.o utl_bits.o utl_crc.o\
			xact_api.o uclo_test_1.o\
			sram_cntl.o veriport.o xact_main.o -g 

			nmarm archmodel.o | munch > __CtorDtor.c
			$(CC)  -c -traditional __CtorDtor.c
			ldarm -o archmodelOUT.o -r __CtorDtor.o archmodel.o


exe		:

.neverbuilt	:

clean		: 
		$(RM) *.o

