/* xactio_cfg.c
 * register main_rtm() so it can be called at the transactor cmd line
 *
  * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: Xact_IO
 * author: Don Hooper 1/29/98
 * revisions:
 * $History
 * 
 * 
 */ 

/*=================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef ext_model_port
/* instructions
	1. define ext_model_port as a compiler switch when compiling safe_xact
	2. "													   " rtm_registration
 */


/* function prototype to register functions with transactor
*/
int XACT_register_console_function( char *function_name,
										void *function_ptr,
										int num_char_ptr_args,
										int num_uint_args );


/* functions called by transactor to foreign model */

extern int testLib_consoleCmd();
extern void TempMain();

/* this routine will be called to initialize the foreign model after */
/* the transactor "init" command has successfully executed.  Returning 0 */
/* will result in a transactor error. */
int foreign_model_initialize()
{
	if (!XACT_register_console_function("TempMain", TempMain, 0, 0) ){
            fprintf(stderr,"XACT_register_console_function() failed\n");
			return(0);
	}

    testLib_consoleCmd();

#ifndef WIN32
    UcLo_Test_initialize();
#endif

    return(1);
}


/* this routine will be called prior to each transactor simulation event */
/* It can be used to deposit state values into the transactor model prior */
/* to simulating the next event.  Returning 0 results in an error. */
int foreign_model_pre_sim()
{
	return(1);
}



/* this routine will be called subsequent to each transactor simulation event. */
/* It can be used to query transactor simulation state, in order to copy it */
/* into the foreign model simulator. */
int foreign_model_post_sim()
{
	return(1);
}
/* this routine will be called subsequent to each transactor simulation event. */
/* It can be used to query transactor simulation state, in order to copy it */
/* into the foreign model simulator. */
int foreign_model_exit()
{
	return(1);
}


#endif	// ext_model_port
