/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* br_loader.h
 * load or delete routes through a console function or called from transactor
 * script file
 *
 *
 * system: SA1200
 * subsystem: Bridge Managment
 * author: Rajendra Shukla 02/26/99
 * revisions:
 * $History: br_loader.h $
 * 
 * *****************  Version 14  *****************
 * User: Kalkunte     Date: 9/05/00    Time: 1:33p
 * Updated in $/dev_1200/SA1_CoreLibs/bridge
 * Adding 
 * - L2 filter and port configuration
 * - Software hash routines to avoid using hardware hash unit
 * 
 * *****************  Version 1  *****************
 * User: Kalkunte     Date: 8/31/00    Time: 5:32p
 * Created in $/users/kalkunte/bridge
 * Bridge with L2 filter
 * 
 * *****************  Version 10  *****************
 * User: Rshukla1     Date: 4/08/99    Time: 11:50a
 * Updated in $/development/bridge
 * 
 * *****************  Version 9  *****************
 * User: Rshukla1     Date: 4/08/99    Time: 9:45a
 * Updated in $/development/bridge
 * 
 * *****************  Version 8  *****************
 * User: Rshukla1     Date: 4/02/99    Time: 10:06a
 * Updated in $/development/bridge
 * Library added
 * 
 * *****************  Version 7  *****************
 * User: Rshukla1     Date: 4/01/99    Time: 1:15p
 * Updated in $/development/bridge
 * 
 * *****************  Version 6  *****************
 * User: Qabuild      Date: 3/24/99    Time: 9:04a
 * Updated in $/development/bridge
 * Updated bridge project again.  Wrong path in links area for debug and
 * release of bridge.exe
 * 
 * *****************  Version 5  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:16p
 * Updated in $/development/bridge
 * update COPYRIGHT
 * 
 * *****************  Version 1  *****************
 * User: Rshukla1     Date: 3/03/99    Time: 9:44a
 * Created in $/development/bridge
 * initial bridge managment files
 * 
 */ 
#ifndef BR_LOADER_H
#define BR_LOADER_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifndef WIN32
#define CLEAR "clear"
#else
#define CLEAR "cls"
#endif

#define TRUE	1
#define FALSE	0


/* FUNCTIONs DEFINITION */
extern int br_fwd_add( unsigned int, unsigned int, int ); // add a route

extern int br_lookup(unsigned int ,   // upper 16 bits destination address
            unsigned short ,  // next 32 bits destination address
            int  // port on which this packet was recived
              );
/* other defintions */

#define MALLOC malloc


#endif /* BR_LOADER_H */
