#ifndef	__IX_ASL_TYPES_H__
#define	__IX_ASL_TYPES_H__

/*
**			INTEL CORPORATION PROPRIETARY INFORMATION
**	This software is supplied under the terms of a license agreement or
**	nondisclosure agreement with Intel Corporation and may not be copied
**	or disclosed except in accordance with the terms of that agreement.
**		Copyright (C) 2000 Intel Corporation. All rights Reserved.
*/

#include <sys/types.h>

#ifdef	__cplusplus
extern "C" {
#endif

/** Some functions never return.
    Using this tag in the prototype of a function that does
    not return will help GCC optimize code around that call,
    and will help get rid of meaningless warnings, and provide
    more meaningful warnings if appropriate.
    See the GCC documentation for details.
 */
#ifndef	__GNUC__
#define	NORETURN
#else /*__GNUC__*/
#define	NORETURN	 __attribute__((noreturn))
#endif/*__GNUC__*/

/** Some functions have printf-like variable argument lists.
    Using this tag in the prototype of a function that parses
    a string just like "printf" will help GCC provide warnings
    about mismatches between printf format parameters and the
    parameter types provided.
    See the GCC documentation for details.
*/
#ifndef	__GNUC__
#define	PRINTFLIKE(f,v)
#else /*__GNUC__*/
#define	PRINTFLIKE(f,v)	__attribute((format(printf,(f),(v))))
#endif/*__GNUC__*/

/* there is no consistant "spelling" for integers that
 * are guaranteed to be at least 32, 48, or 64 bits.
 */
#ifdef WIN32
typedef unsigned __int64	ix_48bit;
typedef unsigned __int64	ix_64bit;
#else
typedef unsigned long long  ix_48bit;
typedef unsigned long long  ix_64bit;
#endif

typedef struct ix_s_hash48      ix_hash48;
typedef struct ix_s_hash64      ix_hash64;

#ifdef	__cplusplus
};
#endif

#endif/*__IX_ASL_TYPES_H__*/
