/*--------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *
 *--------------------------------------------------------------------------*/
/*
 * Library for handling interrupts for drivers in an OS-independent way
 * Assembly routine support for the vxWorks version, using gnu assembler
 */
/*
 * Edit History
 *
 * $Log: /development/common/lst_util.h $
 * 
*/

/* Exported internal functions */
	.globl _int_lock
	.globl _int_unlock

	.text
	.balign 4

/*
	Disable and enable IRQ and FIQ preserving current CPU mode.

*/
	
/***********************************
*
* int_lock()
*
* Lock out IRQ and FIQ interrupts while preserving current CPU mode
*
* returns:	int containing old IRQ/FIQ masks
*/

_int_lock:	
	MRS	r1, cpsr
	AND	r0, r1, #0xC0
	ORR	r1, r1, #0xC0
	MSR	cpsr, r1
	MOV	pc, lr

/***********************************
*
* int_unlock(int prev_val)
*
* Reset state of IRQ and FIQ bits to previous state 
* while preserving current CPU mode
*
* returns:	void
*/

_int_unlock:
	MRS	r1, cpsr
	BIC	r1, r1, #0xC0
	ORR	r1, r1, r0
	MSR	cpsr, r1
	MOV	pc, lr
