/* udbg_umm.h
 * Ucode Debug Library
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: Debug Library
 *  author: drj, June 16,98  Initial version
 *  revisions:
 *  $History: udbg_umm.h $
 * 
 * *****************  Version 13  *****************
 * User: Ewalker      Date: 11/17/00   Time: 3:04p
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * Using MAX_USTORE_PER_SEG in tests instead of obsolete UENG_MAX_USTORE.
 * 
 * *****************  Version 12  *****************
 * User: Drjohns1     Date: 10/20/00   Time: 5:05p
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * Support for C0
 * 
 * *****************  Version 10  *****************
 * User: Dmwhite      Date: 4/05/00    Time: 4:37p
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * took out some unwanted comments
 * 
 * *****************  Version 8  *****************
 * User: Drjohns1     Date: 1/24/00    Time: 10:57a
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * 
 * *****************  Version 6  *****************
 * User: Drjohns1     Date: 11/03/99   Time: 7:14p
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * Fixed available ustore bug 
 * 
 * *****************  Version 4  *****************
 * User: Drjohns1     Date: 6/02/99    Time: 1:27p
 * Updated in $/dev_1200/SA1_CoreLibs/debug_1200
 * Modification per code-review
 * 
 * *****************  Version 3  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:23p
 * Updated in $/development/debug_1200
 * update COPYRIGHT
 * 
 * *****************  Version 2  *****************
 * User: Drjohns1     Date: 1/26/99    Time: 3:37p
 * Updated in $/development/udebug
 * Partitioned debug library
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 1/26/99    Time: 3:29p
 * Created in $/development/udebug
 * Debug library partitioning
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 1/21/99    Time: 2:27p
 * Created in $/development/ueng
 * Partitioned debug library to create ueng interface library (ueng.lib)
 * 
 * *****************  Version 6  *****************
 * User: Drjohns1     Date: 12/07/98   Time: 9:31p
 * Updated in $/development/udebug
 * Initial release
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 11/06/98   Time: 11:22a
 * Created in $/users/Johnson/SA1200/udebug
 * 
 * 
 * ---------------------------------------------------------------------
 */
#ifndef __UDBG_UMM_H
#define __UDBG_UMM_H

#include "ueng.h"

static const unsigned int MIN_UBLOCK_SIZE = 8;
static const unsigned int MAX_UBLOCKS = MAX_USTORE_PER_SEG/MIN_UBLOCK_SIZE;

class uStoreMM{
public:
   uStoreMM(unsigned int freeUaddr, unsigned int freeSize, unsigned int blockSize = MIN_UBLOCK_SIZE);

   uStoreMM(unsigned int freeUaddr, unsigned int freeSize,
				   unsigned int seg2FreeUaddr, unsigned int seg2FreeSize,
				   unsigned int blockSize);

   void defineFreeRegion(unsigned int freeUaddr, unsigned int freeSize, unsigned blockSize);
   void uStoreFreeBlock(int uAddr);
   int uStoreAllocBlock(int uSeg=1);

private:
	unsigned int startUaddr, lastBlk, seg2StartUaddr, seg2LastBlk;
	unsigned int numBlks, blkSize, seg2NumBlks, seg2BlkSize;
	char blocks[MAX_UBLOCKS];
	char seg2Blocks[MAX_UBLOCKS];

	int uStoreMM::allocSeg1Block(void);
	int uStoreMM::allocSeg2Block(void);
};

#endif					// __UDBG_UMM_H, leave next blank line
