BDIR = ..\..\bin
UCA = $(BDIR)\uca
UCLD = $(BDIR)\ucld


ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

CPU		= ARMSA110
TOOL		= gnu
INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils 

ADDED_C++FLAGS  = -w -Wall -pedantic -Dast_parse -Dxactor_build -DVxWorkTest \
 -DOS=VXWORKS -DIOSTYLE=HARDWARE -Dext_model_port -Dno_uca_code_gen -Dnew_sdram \
 -Dbuild_without_main -DVX_WORKS -DXACT -DFBUS_DEVICE_COUNT=2 -D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
#include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)


VX_UDBGTEST = $(LIB_DIR)\vxWorks_udbgTest.o
TST_OBJS = hop.o udbg_test.o

LIBRARIES 	= $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/hal_1200.a \
	  $(LIB_DIR)/utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/uclo.a \
	  $(LIB_DIR)/ueng.a \
	  $(LIB_DIR)/debug_1200.a \
	  $(LIB_DIR)/libd.a \
	  $(LIB_DIR)/msgq.a \
	  $(LIB_DIR)/pciComm.a \
	  $(LIB_DIR)/ucommdriver.a


.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.uc.list :
	$(UCA) -VER=2 -g $?
	@ echo ""

hop.c : hop.list
	$(UCLD) -c hop.list -o $@

hop.uof : hop.list
	$(UCA) -VER=2 -g hop.uc
	$(UCLD) -c hop.list -o $@

lib : debug_1200

debug_1200 :
	make -f vxworks_debug_1200.mak CCMODE=$(CCMODE)

exe : $(VX_UDBGTEST)


$(VX_UDBGTEST) : $(TST_OBJS) hop.uof
	ldarm --whole-archive -r -o udbgtest.o $(TST_OBJS) $(LIBRARIES)
	nmarm udbgtest.o | munch > __CtorDtor.c
	$(CC)  -c -traditional __CtorDtor.c
	ldarm -o $@ -r __CtorDtor.o udbgtest.o

clean : 
	$(RM) $(TST_OBJS) $(VX_UDBGTEST) udbgtest.o __CtorDtor.c __CtorDtor.o

