/* ContextDstr.h
 * Fdriver Rx Source Dispetcher file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: FDriver
 * author: sk, Feb 98 Initial version
 * $History: ContextDstr.h $
 * 
 * *****************  Version 22  *****************
 * User: Drjohns1     Date: 10/30/00   Time: 1:55p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Fixed SCR #1052 -- Missing interrupts/Shrimp messages
 * 
 * *****************  Version 17  *****************
 * User: Tclancyx     Date: 8/20/99    Time: 7:02p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Change reference to iostream::operator<<(void *) to (unsigned int)
 * since vxWorks doesn't seem to be able to print a pointer to void
 * 
 * *****************  Version 15  *****************
 * User: Skornfel     Date: 6/28/99    Time: 11:40a
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Runs on 1200 if SA_1200 defined, use multithreaded model.
 * Tested with ISR attached directly to int 10. To attach to "ueng"
 * Interrupt change one line in .cpp file
 * 
 * *****************  Version 14  *****************
 * User: Skornfel     Date: 4/29/99    Time: 5:28p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Added #define ONE_RX_THREAD it will make driver to work in sequential
 * way,  and use three threads instead of 26
 * 
 * *****************  Version 13  *****************
 * User: Skornfel     Date: 3/25/99    Time: 7:25p
 * Updated in $/development/driver
 * adopted to UCOS
 * 
 * *****************  Version 9  *****************
 * User: Skornfel     Date: 3/16/99    Time: 2:37p
 * Updated in $/development/driver
 * . New for BL5:  HoldTxToEngine(int engine) and ResumeTxToEngine(int
 * engine)
 * . lots of small changes by other developers broke the Unit testing -
 * Fixed
 * . "multi chip" configuration changes made by other developers will not
 * really work(just for info) 
 * 
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 5/21/98    Time: 2:21p
 * Updated in $/base_level2/Driver
 * COPYRIGHT (c)  1998 BY  INTEL  CORPORATION
 * 
 * *****************  Version 6  *****************
 * User: Skornfeld    Date: 5/04/98    Time: 12:46p
 * Updated in $/base_level2/Driver
 * The same functionality compare to
 * the previous Check In. Fixed locks
 * and Queue. No output to the console.
 * 
 * *****************  Version 5  *****************
 * User: Skornfeld    Date: 4/17/98    Time: 10:52a
 * Updated in $/base_level2/Driver
 * BL2 Driver  
 * 
 * *****************  Version 4  *****************
 * User: Skornfeld    Date: 3/10/98    Time: 6:50p
 * Updated in $/base_level1/Driver
 * Digial Headers, Code cleaup, comments 
 * 
 * *****************  Version 3  *****************
 * User: Skornfeld    Date: 3/09/98    Time: 5:35p
 * Updated in $/base_level1/Driver
 * ---------------------------------------------------------------------
 */

#ifndef CONTEXT_DSTR
#define CONTEXT_DSTR

//#include <new.h>
#include "GboxContext.h"
#include "MessageDstr.h"


//SK thread in the future

// Class encapsulates the Context Dispatch on RX from  _uThreds
// Provides the Dispatch Method for the driver to get the context
// to Serve.
// 


class RxCnxtDispatcher{

public:
	RxCnxtDispatcher(unsigned int & ireg,
					 EngineLockManagement & elm,
//#ifdef ONE_RX_THREAD
					 MsgStateMachinePtrs & arr_rx_disp_ptrs
#ifndef ONE_RX_THREAD
					 ,MsgStateSemaphores & msg_sate_semaphores
#endif //ONE_RX_THREAD
					 )
		:_Ireg(ireg),
		_Elm(elm),
//#ifdef ONE_RX_THREAD
		_ArrRxDisp_prts(arr_rx_disp_ptrs)
#ifndef ONE_RX_THREAD
		,_RxMsgStateSemaphores(msg_sate_semaphores)
#endif //ONE_RX_THREAD		
	{cout << " CTOR RxCnxtDispatcher IReg @ "  << ((unsigned int)&_Ireg) << endl;};

	~RxCnxtDispatcher(){};
	
    // The Dispatch Method for the driver to get the context
    // to Serve.
    // 
	inline void
	Dispatch(void){

		_IregShadow=_Ireg;							//copy sources
		// preserve bits <31:24>, clear bit<23:0>
		_Ireg = _IregShadow & 0xf8ffffff;			//IREG bits <26:0> are write-one-to-clear
		//cout << "<------------- _Ireg " << _IregShadow << endl;

		_IregShadow &= 0xffffff;					//mask out bits <31:24> 
		//service the ueng interrupts
		for(int bit=0; bit<BITS_IN_CSR; bit++){
			if ( _IregShadow & (1 << bit)){

				//check, if holded remove bit from SCR/IREG
				//LATER CHECK FOR IREG _Elm.CheckForAccept(bit);
				 _IregShadow = _IregShadow & ~( 1<< bit); //Clear the source from Shadow

#ifdef ONE_RX_THREAD
                  fix it (_ArrRxDisp_prts.ptr_RxMsgDptr[bit])->FBoxToCoreDispatch();
#else  //ONE_RX_THREAD
				 _RxMsgStateSemaphores.ptr_Semaphore[bit]->Give();
#endif //ONE_RX_THREAD
			};
		};
	};

	
	//Show the interrupt sourse Reg
	//
	inline void Show(){ cout << "IRR " << _IregShadow << "\n" ;}

	//Get the pointer to the State Macine by instance
	//
	inline RxMsgDispatcher *
	GetInstance( int instance ){
		return _ArrRxDisp_prts.ptr_RxMsgDptr[instance];
	};


private:
	unsigned int _IregShadow;
	unsigned int & _Ireg;						// interrupt sourse Reg(shadow?)
	EngineLockManagement & _Elm;				// Engine lock objact
	//RxMsgDispetcher & _RxMsgDptr;
///#ifdef ONE_RX_THREAD
	MsgStateMachinePtrs & _ArrRxDisp_prts;		// Arrays of pointes to state machines
#ifndef  ONE_RX_THREAD
	MsgStateSemaphores & _RxMsgStateSemaphores;	// Semaphores to unblock RX threads
#endif //ONE_RX_THREAD
};



#endif // CONTEXT_DSTR