/*
 * DbgSock.h
 * Fdriver Debug Interface Source file 
 *-------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
*---------------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: FDriver
 * author: sk, Feb 98 Initial version
 * $History: DbgSock.h $
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 3/25/99    Time: 7:25p
 * Updated in $/development/driver
 * adopted to UCOS
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 3/16/99    Time: 2:39p
 * Updated in $/development/driver
 * . New for BL5:  HoldTxToEngine(int engine) and ResumeTxToEngine(int
 * engine)
 * . lots of small changes by other developers broke the Unit testing -
 * Fixed
 * . "multi chip" configuration changes made by other developers will not
 * really work(just for info) 
 * 
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 5/21/98    Time: 2:21p
 * Updated in $/base_level2/Driver
 * COPYRIGHT (c)  1998 BY  INTEL  CORPORATION
 */






#include <iostream.h>
#include <strstrea.h>


#include <sys/types.h>
#include <winsock.h>				/* <sys/socket.h> */
#include <stdio.h>
#include <string.h>
#include <io.h>




class Socket{

public:

	Socket(char host[], int port, int len){
		Port=port;
		blen=len;
		SysInit();
		Create(host);
		Connect();
	};

	~Socket(){
		Destroy();
	};


	inline void
	SendSrting(ostrstream & send_stream){
		Send(send_stream.str(),send_stream.pcount());
//		send_stream.clear();
//		send_stream.put(' ');
//		Send("****>",5);
//		Send(send_stream.str(),send_stream.pcount());
	}; 



	inline void
	Send(char * buf, int len){
		send(sock, buf, len, 0);
	};


	inline void 
	SysInit(void){
	
		// initialize winsock.dll 
		wVersionRequested = MAKEWORD(1, 1); 
		err = WSAStartup(wVersionRequested, &wsaData); 
 
		if (err != 0){ 
 			cout << "couldn't find a useable winsock.dll" << endl;
			return; 
		}
 
		// Confirm that the Windows Sockets DLL supports 1.1. 
		// Note that if the DLL supports versions greater  
		// than 1.1 in addition to 1.1, it will still return  
		// 1.1 in wVersion since that is the version we  requested. 
		//
 		if ( LOBYTE( wsaData.wVersion ) != 1 || HIBYTE( wsaData.wVersion ) != 1 ){ 

			cout << "Unable to initialize WinSock Version 1.1\n" << endl ;
			WSACleanup();
			err = -1;
			return; 
		} 

		/* The Windows Sockets DLL is acceptable. Proceed. */ 

	};


	inline void 
	Create(char host[] ){

		/* Create a TCP socket */

		sock = socket (PF_INET, SOCK_STREAM, 0);
		if (sock < 0){
			cout << "cannot open socket" << endl;
		    err=-1 ;return;//exit (1);
		}

		hp = gethostbyname (host);
		if (hp == 0 && (sin.sin_addr.s_addr = inet_addr (host)) == -1){
			cout <<  host << " unkown host\n"  << endl;
		    err=-1 ;return;//exit (2);
		}

		/* Fill in the hostent structure */

		if (hp != 0)
			memcpy (&sin.sin_addr, hp->h_addr, hp->h_length);

		sin.sin_family 	= PF_INET;
		sin.sin_port 	= htons ((short)Port);
		//blen            = LEN;


		/* Set the size of the socket send and receive buffers to blen */
 
		if (setsockopt (sock, SOL_SOCKET, SO_SNDBUF,
			    (char *) &blen, sizeof (blen)) < 0){
			cout << "setsockopt SO_SNDBUF failed" << endl;
			err=-1 ;return;//exit (1);
		}

		if (setsockopt (sock, SOL_SOCKET, SO_RCVBUF,
                    (char*) &blen, sizeof (blen)) < 0){
			cout << "setsockopt SO_RCVBUF failed" << endl;
			err=-1 ;return;//exit (1);
		}
	};


	inline void 
		Destroy(){
		    close (sock);
	};


	inline void
	Connect(){

		/* Connect to the server */

		if (connect (sock, (SOCKADDR *) &sin, sizeof (sin)) < 0){
    		printf ("connect failed: host %s port %d\n", inet_ntoa (sin.sin_addr),
			ntohs (sin.sin_port));
			err=-1 ;
			return;
		}
	};

	inline int GetErr(){ return err;};

private:

	int Port;
    struct sockaddr_in	sin;
    int    sock;
    int	   blen; 		/* maximum size of socket-level send buffer */
    struct hostent  *hp;

    int err; 	
	WORD wVersionRequested; 
    WSADATA wsaData; 

};

