/* InQueue.h
 * Fdriver Incoming Queueing file 
 *
 * ---------------------------------------------------------------------        
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: FDriver
 * author: sk, Apr 98 Initial version
 * $History: InQueue.h $
 * 
 * *****************  Version 11  *****************
 * User: Skornfel     Date: 6/28/99    Time: 11:43a
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Runs on 1200 if SA_1200 defined, use multithreaded model.
 * Tested with ISR attached directly to int 10. To attach to "ueng"
 * Interrupt change one line in .cpp file
 * 
 * *****************  Version 10  *****************
 * User: Skornfel     Date: 3/25/99    Time: 7:25p
 * Updated in $/development/driver
 * adopted to UCOS
 * 
 * *****************  Version 6  *****************
 * User: Skornfel     Date: 3/16/99    Time: 2:39p
 * Updated in $/development/driver
 * . New for BL5:  HoldTxToEngine(int engine) and ResumeTxToEngine(int
 * engine)
 * . lots of small changes by other developers broke the Unit testing -
 * Fixed
 * . "multi chip" configuration changes made by other developers will not
 * really work(just for info) 
 * 
 * 
 * *****************  Version 4  *****************
 * User: Skornfel     Date: 5/21/98    Time: 2:21p
 * Updated in $/base_level2/Driver
 * COPYRIGHT (c)  1998 BY  INTEL  CORPORATION
 * 
 * *****************  Version 3  *****************
 * User: Skornfeld    Date: 5/05/98    Time: 2:35p
 * Updated in $/base_level2/Driver
 * can't make templatized queue work with ccarm sorry.. 
 * 
 * *****************  Version 2  *****************
 * User: Skornfeld    Date: 5/04/98    Time: 12:46p
 * Updated in $/base_level2/Driver
 * The same functionality compare to
 * the previous Check In. Fixed locks
 * and Queue. No output to the console.
 * 
 * *****************  Version 1  *****************
 * User: Skornfeld    Date: 4/17/98    Time: 10:51a
 * Created in $/base_level2/Driver
 * One way  massages from Core to the uThreads Queued by Driver 
 * 
 * ---------------------------------------------------------------------
 */

#ifndef INQUE
#define INQUE



#include <iostream.h>
#include "MessageHead.h"
#include "TS.h" 
#define inline 
//---------------------------------------------------------------------------------------------------------------------------

enum {MAX=20};  //Queue Size
//SK template <class T>
class CircQueue{

public: 

	CircQueue():_Tail(0),_Head(MAX){ queFull= NOT_FULL; Lock.Give();};//{Buf[MAX]=NULL;};
	~CircQueue(){};
	


	//Store the object on the Queue
    //
	// return 0 on Success, -OR-  1 on errror
	inline int
	Qstore (/*T*/MessageHeader q){
    Lock.Take();// "L O C K"

       //check for spase on the queue
	   if (_Tail+1 == _Head || ( _Tail+1 == MAX && ! _Head)){
	   	   //cout << "----> LIST FULL - error" << endl;
    Lock.Give();// "U N L O C K"
		   	WaitIfQueueFull();   //return 1;             // no space
	   };

	   Buf[_Tail]=q;             //copy to the queue
	   _Tail++;                  //increment tail 
	   if (_Tail==MAX) _Tail =0; //loop back
	   //cout << "[" << _Tail << "]" << endl;
    Lock.Give();  // "U N L O C K"
	Signal.Give();//"S i g n a l"
#ifdef DEBUG_SOK
{   ostrstream STRM;
    STRM << "STORED ON THE QUEUE" << endl;Sockets[24]->SendSrting(STRM);
}
#endif
	   return 0;                 //ok - it is on the queue now
   };




   // Retrive ME - Get the pointer to the element, so the element can be acessed
   // and "delete" the element of the queue 
   //
   //
   // return pinter to the element on Success err=0, -OR-  err=1 on errror
   inline /*T*/MessageHeader  
   Qretrive(int &err){
   Lock.Take();// "L O C K"
   //cout << "ENTER QUEUE RETRIVE" << endl;

   	   if(_Head == MAX) _Head =0; //loop back

	   if(_Head == _Tail) {
		   //cout << "  NOTING IN THE QUEUE - return with 'zero'" << endl;
   Lock.Give();// "U N L O C K"
		   err = 1;
		   return Buf[_Head];     //nothing to retreve -previous one junk
		   //but you will never hit this return if WaitForMessage() used!!!!!
	   };

       //"delete" the element of the queue 
	   _Head++;

   Lock.Give();// "U N L O C K"
   ReleaseWaItIfQueueWasFull(); // let sender know that atleast one element out of the peviosly full queue
   err =0;
#ifdef DEBUG_SOK
{  ostrstream STRM;
   STRM << "QUEUE RETRIVED" << endl;Sockets[24]->SendSrting(STRM);
}   
#endif
   return Buf[_Head - 1];

   };

	
   inline void
	   WaitForMessage(){
	   Signal.Take();
   };


private:
enum { NOT_FULL,FULL };

	inline void 
	WaitIfQueueFull(){
		//cout << "w WAIT ON FULL QUEUE" << endl;
#ifdef DEBUG_SOK
{		ostrstream STRM;
		STRM << "w WAIT ON FULL QUEUE" << endl;Sockets[24]->SendSrting(STRM);
}
#endif
		queFull = FULL;
		Release.Take();

		//cout << "w OUT OF WAIT ON THE FULL QUEUE" << endl;
#ifdef DEBUG_SOK
{		ostrstream STRM;
		STRM << "w OUT OF WAIT ON THE FULL QUEUE" << endl;Sockets[24]->SendSrting(STRM);
}
#endif
	};

	inline void 
	ReleaseWaItIfQueueWasFull(){

		if(queFull == FULL){
//			cout << "r RELEASE QUEUE FULL DETECT" << endl;
#ifdef DEBUG_SOK
{			ostrstream STRM;
			STRM << "r RELEASE QUEUE FULL DETECT" << endl;Sockets[24]->SendSrting(STRM);
}
#endif
			queFull = NOT_FULL;
			Release.Give();
//			cout << "r RELEASE QUEUE FULL DONE" << endl;
#ifdef DEBUG_SOK
{			ostrstream STRM;
			STRM << "r RELEASE QUEUE FULL DONE" << endl;Sockets[24]->SendSrting(STRM);
}
#endif
		};
	};


private:
	 Semaphore Lock;   // "L O C K"  to be safe with threads
	 Semaphore Signal; // "S i g n a l" the "receiver"
	 Semaphore Release;// "Signal/unblock than next message can go into the queue
	 int queFull;	   // Full queue indication	
     /*T*/MessageHeader Buf[MAX+1];     //second one is zero
     int _Tail;        //Tail
     int _Head;        //Head
};


//-------------------------------------------------------------------------------------------------------------------------

//creatre the Queue
/*CircQueue<class Char> Q;*/

#endif //INQUE




































































