/* dispetch.cpp
 * Fdriver Port file 
 *
 * ---------------------------------------------------------------------        
 *  Copyright Digital Equipment Corporation 1997-1998. All rights reserved.
 *
 *  Restricted  Rights:  Use,  duplication,  or  disclosure by the U.S.
 *  Government is subject to restrictions  as set forth in subparagraph
 *  (c)(1)(ii) of DFARS 252.227-7013,  or  in FAR 52.227-19,  or in FAR
 *  52.227-14 Alt. III, as applicable.
 *
 *  This software  is  proprietary  to  and  embodies  the confidential
 *  technology  of  Digital  Equipment  Corporation.  Possession,  use,
 *  or copying of this software and  media  is authorized only pursuant
 *  to  a  valid  written   license   from  Digital  or  an  authorized
 *  sublicensor.
 * ---------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: FDriver
 * author: sk, Feb 98 Initial version
 * $History: UcommDriver.cpp $
 * 
 * *****************  Version 26  *****************
 * User: Dmwhite      Date: 5/09/00    Time: 9:34a
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * more ostype cleanup
 * 
 * *****************  Version 22  *****************
 * User: Skornfel     Date: 10/13/99   Time: 10:55a
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Corrected to support OS type and IOSTYLE
 * 
 * *****************  Version 20  *****************
 * User: Qabuild      Date: 7/16/99    Time: 4:02p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * 
 * *****************  Version 19  *****************
 * User: Qabuild      Date: 7/09/99    Time: 3:15p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * serge, changed the intConnect to uEng_intConnect
 * 
 * *****************  Version 18  *****************
 * User: Qabuild      Date: 7/07/99    Time: 6:15p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * added #ifndefs SA_1200 to take out dead code
 * 
 * *****************  Version 17  *****************
 * User: Skornfel     Date: 6/28/99    Time: 4:19p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * removed NO_LIB defenition
 * 
 * *****************  Version 16  *****************
 * User: Skornfel     Date: 6/28/99    Time: 11:43a
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Runs on 1200 if SA_1200 defined, use multithreaded model.
 * Tested with ISR attached directly to int 10. To attach to "ueng"
 * Interrupt change one line in .cpp file
 * 
 * *****************  Version 11  *****************
 * User: Skornfel     Date: 4/29/99    Time: 5:28p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * Added #define ONE_RX_THREAD it will make driver to work in sequential
 * way,  and use three threads instead of 26
 * 
 * *****************  Version 10  *****************
 * User: Qabuild      Date: 4/28/99    Time: 4:31p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * moved DriverISR up . Placed it before extern "C" void FDriver_Init 
 * 
 * *****************  Version 8  *****************
 * User: Skornfel     Date: 4/26/99    Time: 5:02p
 * Updated in $/dev_1200/SA1_CoreLibs/driver
 * added      void FDriver_Init();  interface
 * 
 * *****************  Version 7  *****************
 * User: Skornfel     Date: 3/31/99    Time: 4:37p
 * Updated in $/development/driver
 * commented out 
 * "Semaphore HOLD; HOLD.Take(); "
 * which needed for unit testing only
 * 
 * *****************  Version 6  *****************
 * User: Skornfel     Date: 3/25/99    Time: 7:25p
 * Updated in $/development/driver
 * adopted to UCOS
 * 
 * *****************  Version 2  *****************
 * User: Skornfel     Date: 3/16/99    Time: 2:37p
 * Updated in $/development/driver
 * . New for BL5:  HoldTxToEngine(int engine) and ResumeTxToEngine(int
 * engine)
 * . lots of small changes by other developers broke the Unit testing -
 * Fixed
 * . "multi chip" configuration changes made by other developers will not
 * really work(just for info) 
 * 
 * 
 * *****************  Version 1  *****************
 * User: Skornfel     Date: 3/16/99    Time: 2:21p
 * Created in $/development/driver
 * RENAMED DISPITCH.CPP
 * 
 * *****************  Version 19  *****************
 * User: Drjohns1     Date: 3/05/99    Time: 8:54p
 * Updated in $/development/driver
 * Updated for generic interrupt functions
 * 
 * *****************  Version 18  *****************
 * User: Drjohns1     Date: 2/12/99    Time: 6:09p
 * Updated in $/development/driver
 * Updated for multi-chip/auto_ambio related changes
 * 
 * *****************  Version 16  *****************
 * User: Hqianx       Date: 9/17/98    Time: 4:19p
 * Updated in $/base_level3/driver
 * Added AMBA IO Interface.
 * 
 * *****************  Version 15  *****************
 * User: Drjohns1     Date: 6/17/98    Time: 2:49p
 * Updated in $/base_level3/Driver
 * Linux/GNU port
 * 
 * *****************  Version 13  *****************
 * User: C-hqian      Date: 5/13/98    Time: 3:26p
 * Updated in $/base_level2/Driver
 * Commented out line:  Semaphore HOLD; HOLD.Take().
 * 
 * *****************  Version 12  *****************
 * User: Skornfeld    Date: 5/05/98    Time: 11:01a
 * Updated in $/base_level2/Driver
 * fix for .............
 * #ifdef WIN32
 * #include <strstrea.h>
 * #else
 * #include <strstream.h>
 * #endif
 * 
 * *****************  Version 11  *****************
 * User: Skornfeld    Date: 5/05/98    Time: 10:04a
 * Updated in $/base_level2/Driver
 * 
 * *****************  Version 10  *****************
 * User: Skornfeld    Date: 5/04/98    Time: 12:46p
 * Updated in $/base_level2/Driver
 * The same functionality compare to
 * the previous Check In. Fixed locks
 * and Queue. No output to the console.
 * 
 * *****************  Version 9  *****************
 * User: Skornfeld    Date: 4/17/98    Time: 10:52a
 * Updated in $/base_level2/Driver
 * BL2 Driver  
 * 
 * *****************  Version 7  *****************
 * User: Skornfeld    Date: 3/10/98    Time: 6:50p
 * Updated in $/base_level1/Driver
 * Digial Headers, Code cleaup, comments 
 * ---------------------------------------------------------------------
 */
//!!!!!
/*****
	To MAKE driver with 3 threads instead of 27 
	#define ONE_RX_THREAD it will make driver to work in sequential way
	Base level five functionality such as:
	1. FDriver->HoldTxToEngine(int  engine);   // engine to hold 
	2. FDriver->ResumeTxToEngine(int  engine);  // resume previously bolded engine
	will not function properly in 3 thread mode; instead
	the call for the particular engine may block all engines in most of cases
*****/ 
//#define ONE_RX_THREAD
//#define UENGINE_DRIVER
//#define NO_LIB //not integrated


#ifdef NO_LIB
#define UENGINE_DRIVER	// to make XactIoSignalDone happy
#define TEST			// unit test
#define TEST_SIMPLE     // simple one thred unit test 
//OR
//#define DEBUG_SOK		// define sockets and run threaded tests 
#endif

#include "iostyle.h"
#include "ostype.h"

#if (IOSTYLE == HARDWARE) 
#define SA_1200
#endif

#if (IOSTYLE == AMBAIO) 
#define USE_AMBAIO
#endif

#if (IOSTYLE == XACTIO)
#define CORE_SIGNAL_DONE 201// 5 bits core to thread signal
#endif
 
#include <iostream.h>

#ifdef WIN32
#include <strstrea.h>
#else
#if (OS!=UCOS)
//#include <strstream.h>
#endif //UCOS
#endif

#include "mem_map.h"
#define STEP 4 // in Words (4) or in Bytes (16)

unsigned int CSR;

#ifndef NO_LIB
#include "core_io.h"
#include "xact.h"
#include "ambaio.h"
#endif

#ifndef SA_1200
#include "Xact_API.h"
#endif



#include "UcommDriver.h"


//-------------------------------------------------------------------------------------------------------------
//statics
Driver * 
Driver::This=0;
MsgStateMachinePtrs
Driver::S={0};
int 
Driver::ThreadRun=0;
//functions
inline void
EngineLockManagement::ReleaseEngine(int engine){
			EngineHoldInicator[engine]=NORMAL_EXECUTION;
			Lock[engine].Reset();//Give();
			//restore thread indicators;
			ThreadIndicator[(engine*4+0)]=NORMAL_EXECUTION;
			ThreadIndicator[(engine*4+1)]=NORMAL_EXECUTION;
			ThreadIndicator[(engine*4+2)]=NORMAL_EXECUTION;
			ThreadIndicator[(engine*4+3)]=NORMAL_EXECUTION;
			//call unblocked states
			//RxCnxtDispatcher
			for(int bit=0; bit<24; bit++){
				if ( storedEvents & (1 << bit)){
					storedEvents = storedEvents & ~( 1<< bit); //Clear the bit
#ifdef ONE_RX_THREAD
                    (_ArrRxDisp_prts.ptr_RxMsgDptr[bit])->FBoxToCoreDispatch();
#else  //ONE_RX_THREAD
				    (_RxMsgStateSemaphores.ptr_Semaphore[bit])->Give();
#endif //ONE_RX_THREAD

				};
			};
};

//--------------------------------------------------------------------------------------------------------------
//Global Pointer to the Driver
//
Driver * FDriver;
//--------------------------------------------------------------------------------------------------------------
//if unit test
#ifdef NO_LIB
#include "UcommDriverTest_cpp.h" 
#endif
//---------------------------------------------------------------------------------------------------------------
//extern "C" FDriver interface
//
extern "C" void FDriver_PutMsg( int * msg , int thread){

MessageHeader * CoreToFboxHeader = (MessageHeader *)msg;
//CoreToFboxHeader->Show();
CoreToFboxHeader->SockShow(thread);
	FDriver->TxMessage(thread, *CoreToFboxHeader);
}


extern "C" void FDriver_PutMsgQue( int * msg , int thread){

MessageHeader * CoreToFboxHeader = (MessageHeader *)msg;
//CoreToFboxHeader->Show();
CoreToFboxHeader->SockShow(thread);
	FDriver->TxMessageQue(thread, *CoreToFboxHeader);
}


//FDriver->HoldTxToEngine(int  engine);   // engine to hold 
//and
//FDriver->ResumeTxToEngine(int  engine);  // resume previously bolded engine

extern "C" void FDriver_HoldTxToEngine(int engine){
	FDriver->HoldTxToEngine(engine);
};


extern "C" void FDriver_ResumeTxToEngine(int engine){
	FDriver->ResumeTxToEngine(engine);
};

//--------------------------------------------------------------------------------------------------------------
//Drivers entry point for Transactor to call on IRR Request
//OR 1200 ISR 
#ifdef SA_1200
extern "C" void DriverIsr(int param){           
		FDriver->Isr();
        return; // 0;
}
#else //SA_1200
extern "C" void DriverIsr(int param){                       //Driver,s ISR emulation
        //THD
        FDriver->RxUnblock();				//unblock the Rx thread	
        //FDriver->RxDispetch();			// or call directly
        return; // 0;
}
#endif SA_1200
//-------------------------------------------------------------------------------------------------------------- 
typedef void (*ISR_FUNC)(int);
extern "C" int uEng_intConnect(int index, unsigned int intMask, ISR_FUNC isr, int param);

extern "C" void FDriver_Init(){
    FDriver = new Driver;

#ifndef WIN32
	//initial test
	int status =
		//intConnect((VOIDFUNCPTR *)10,(VOIDFUNCPTR )DriverIsr,0);cout <<"intConnect status = " << status << endl;
		uEng_intConnect(0, 0xffffff, (ISR_FUNC)DriverIsr, 0);cout <<"intConnect status = " << status << endl;
		//uEng_intConnect(10, 0xffffff, (ISR_FUNC)DriverIsr, 0);
		//uEng_intConnect(SAINT_UENG, UENG_IRQ_BITS, DriverIsr, 0);
		//dj:	FIQ_Connect(MICRO_THREAD, (PFV)DriverIsr);




#endif	
	
	//#ifndef NO_LIB

//#endif
}

//---------------------------------------------------------------------------------------------------------------
#ifndef WIN32
void DriverNoIsr(void){
unsigned int *  _Ireg=0xb00401e0;
unsigned int	_IregShadow=*_Ireg;			//copy sources
				_IregShadow &= 0xffffff;	//mask out bits 31-25 
				*_Ireg |=_IregShadow;       //clear
};
#endif

extern "C" void FDriver_Delete(){

#ifndef WIN32

	int status =
		intConnect((VOIDFUNCPTR *)10,(VOIDFUNCPTR )DriverNoIsr,0);cout <<"intConnect status = " << status << endl;
	    //uEng_intConnect(10, 0xffffff, (ISR_FUNC)DriverIsr, 0);
		//uEng_intConnect(SAINT_UENG, UENG_IRQ_BITS, DriverIsr, 0);
		//dj:	FIQ_Connect(MICRO_THREAD, (PFV)DriverIsr);


#endif	



    delete FDriver;
}

//---------------------------------------------------------------------------------------------------------------


extern "C" void FDriver_MboxShow(int box){
	FDriver->MboxShow(box);
}

//---------------------------------------------------------------------------------------------------------------

//#ifndef NO_LIB
//// old style DriverInit .. i will keep it for now
//void DriverInit(){
//
//    FDriver = new Driver;
//
//    FIQ_Connect(MICRO_THREAD, (PFV)DriverIsr);
//}
//#endif //NO_LIB old style DriverInit .. i will keep it for now
//-----------------------------
//------------------------------------------------------------------------------

int FDriver_Test_Counter=0;
MessageHeader  CoreToFboxHeader;

extern "C" void FDriver_Test_Set(int function=1, int source=0x51,
								 int wd1=0x11111111,
								 int wd2=0x22222222,
								 int wd3=0x33333333){
    
	CoreToFboxHeader.SetFunction(function);
	CoreToFboxHeader.SetDataWord1(wd1);
	CoreToFboxHeader.SetDataWord2(wd2);
	CoreToFboxHeader.SetDataWord3(wd3);
}
extern "C" void FDriver_Test(int destonation=0, int way=1, int queue=0){
	FDriver_Test_Counter++;
	cout << "FDriver_Test"<<FDriver_Test_Counter<<"{" << endl;
  
	CoreToFboxHeader.SetFunction(0x1); //Bzero
	//
	CoreToFboxHeader.SetDataWord1(0x11111111);
	CoreToFboxHeader.SetDataWord2(0x22222222);
	CoreToFboxHeader.SetDataWord3(0x33333333);

	//CoreToFboxHeader.SetDest(0x1);
	if (way==1)CoreToFboxHeader.SetOneWayRequest();
	if (way==2)CoreToFboxHeader.SetTwoWayRequest();

	//
	if (queue==0)FDriver->TxMessage   (destonation, CoreToFboxHeader);
	if (queue==1)FDriver->TxMessageQue(destonation, CoreToFboxHeader);
	cout << endl << "}"<< "FDriver_Test"<<FDriver_Test_Counter << endl;
}

extern "C" void FDriver_ATest(){

	FDriver_Test_Counter++;
	cout << "FDriver_ATest"<<FDriver_Test_Counter<<"{" << endl;
	//
	CoreToFboxHeader.SetHeader(0xa0510000); 	
	CoreToFboxHeader.SetDataWord1(0xdeadbeef);
	CoreToFboxHeader.SetDataWord2(0x00000400);
	CoreToFboxHeader.SetDataWord3(0x00000000);

	for(int i=0; i<4; i++){
		*((unsigned int *)0x10001000) = 0xffff0000;
		FDriver->TxMessage   (i, CoreToFboxHeader);
		cout << "*((unsigned int *)0x10001000=="  << (int)*((unsigned int *)0x10001000) << endl;
	};

	cout << endl << "}"<< "FDriver_ATest"<<FDriver_Test_Counter << endl;

}

//--------------------------------------------------------------------------------




//-----------------------------------------------------------------------------------------------------------------

#ifdef NO_LIB
// main for NT and unit test
// extern "C" void ucosmain(){
void rtosmain(){
int box;
    FDriver = new Driver;
	//Semaphore::Show();
	//FDriver->MboxAllShow();
	//for(box=0; box< 24 ; box++)FDriver->MboxShow(box);

#ifdef TEST
//---------------------
// run unit test


#ifdef DEBUG_SOK
// run emulation threads
Thread _uCodeThread(uCodeThread);
Thread _CoreThread(CoreThread);
// hold it alive
Semaphore HOLD; HOLD.Take();
#endif



#ifdef TEST_SIMPLE 
// run simle test without threads and sockets
simple_test();
#endif


//--------------------
#endif  //TEST

for(box=0; box< 24 ; box++)FDriver_MboxShow(box);
}
#endif  //NO_LIB












































