/* hal_sdram.cpp
 * SA1200 Hardware Absraction Library -- SDRAM
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: HAL
 *  author: dfh, Feb 24, 99  Initial version
 *  revisions:
 *  $History: hal_sdram.cpp $
 * 
 * *****************  Version 12  *****************
 * User: Dmwhite      Date: 4/05/00    Time: 4:37p
 * Updated in $/dev_1200/SA1_CoreLibs/hal_1200
 * took out some unwanted comments
 * 
 * *****************  Version 8  *****************
 * User: Dhooper      Date: 5/14/99    Time: 9:25a
 * Updated in $/BL5_Plus/SA1_CoreLibs/hal_1200
 * change SRAM, SDRAM, FBI_Init to SRAM, SDRAM, FBI_Attach
 * 
 * *****************  Version 7  *****************
 * User: Dhooper      Date: 5/11/99    Time: 5:24p
 * Updated in $/dev_1200/SA1_CoreLibs/hal_1200
 * don't initialize val to 0 on read and write
 * 
 * *****************  Version 6  *****************
 * User: Dhooper      Date: 5/10/99    Time: 12:35p
 * Updated in $/dev_1200/SA1_CoreLibs/hal_1200
 * init function call
 * 
 * *****************  Version 4  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:41p
 * Updated in $/development/hal_1200
 * update COPYRIGHT
 * 
 * *****************  Version 3  *****************
 * User: Dhooper      Date: 3/08/99    Time: 6:40p
 * Updated in $/development/hal_1200
 * add console read write functions
 * 
 * *****************  Version 2  *****************
 * User: Dhooper      Date: 3/02/99    Time: 6:50p
 * Updated in $/development/hal_1200
 * add boilerplate
 * 
 * ---------------------------------------------------------------------
 */

#include "hal_sdram.h"



static SdramUnit	*sdram = (SdramUnit *)SDRAM_CSR_BASE;

/*-----------------------------------------------------------------
	SDRAM_Attach
	Return a pointer to the SDRAM instance
	returns: SdramUnit	*
	uses:
	modifies:
  -----------------------------------------------------------------*/
SdramUnit *SDRAM_Attach()
{
	return(sdram);
}


/*-----------------------------------------------------------------
	SDRAM_Write
	Write val to sdram longword  address lwaddr
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/

void SDRAM_Write(unsigned int lwaddr, unsigned int val)
{
	SDRAM_WRITE(lwaddr, val);
	return;
}


/*-----------------------------------------------------------------
	SDRAM_Read
	Read val read sdram longword  address addr
	returns: data from memory location
	uses:
	modifies: sdram
  -----------------------------------------------------------------*/
unsigned int SDRAM_Read(unsigned int lwaddr)
{
	unsigned int val;
	SDRAM_READ(lwaddr, &val);
	return(val);
}
// end of file, leave next blank line
