#include "hdbm.uc"
#include "hdbm_testMap.h"

#define DB_HANDLE PRIM_TABLE_BASE, PRIM_INDX_START_BIT, PRIM_INDX_BIT_LEN, COL_INDX_START_BIT, COL_INDX_BIT_LEN, COL_SHF_BITS, COL_TABLE_BASE, KEYDATA_SD_BASE


_main#:


.local testNum  status stat2 rtn_addr badKey, goodKey, key_lo key_hi key2_lo key2_hi data_ptr data2 $hashMul_lo $hashMul_hi ptab_base ptab_indx_start_bit ptab_indx_bit_len ctab_indx_start_bit ctab_indx_bit_len ctab_shf_bits ctab_base keydata_base
	move(ptab_base, PRIM_TABLE_BASE);
	move(ptab_indx_start_bit, PRIM_INDX_START_BIT);
	move(ptab_indx_bit_len, PRIM_INDX_BIT_LEN);

	move(ctab_indx_start_bit, COL_INDX_START_BIT);
	move(ctab_indx_bit_len, COL_INDX_BIT_LEN);
	move(ctab_shf_bits, COL_SHF_BITS);
	move(ctab_base, COL_TABLE_BASE);
	move(keydata_base, KEYDATA_SD_BASE);

	immed32(data_ptr, 0);
	immed32(status, 1);
	immed32(stat2, 0);

	move(badKey_lo, BAD_KEY_LO);
	move(badKey_hi, BAD_KEY_HI);

	move(goodKey_lo, GOOD_KEY_LO);
	move(goodKey_hi, GOOD_KEY_HI);

	//setup hardware hash multiplier
//	br!=ctx[0, exit#]
	br!=ctx[0, begTest1#]
	immed32($hashMul_lo, HASH_MULT_LO);
	immed32($hashMul_hi, HASH_MULT_HI);
	csr[write, $hashMul_lo, hash_multiplier_48_lo]
	csr[write, $hashMul_hi, hash_multiplier_48_hi]
	csr[write, $hashMul_lo, hash_multiplier_64_lo]
	csr[write, $hashMul_hi, hash_multiplier_64_hi]

begTest1#:
	immed32(testNum, 1);
	// this key should exist
	move(key_lo, goodKey_lo);
	move(key_hi, goodKey_hi);

	// this key should not exist
	move(key2_lo, badKey_lo);
	move(key2_hi, badKey_hi);

    br[_biLookup48#], defer[1]
    load_addr[rtn_addr, endTest1#]
endTest1#:
	.if(status != 0)
		br[failed#]
	.endif

	.if(data_ptr != GOOD_DATA)
		br[failed#]
	.endif

	.if(stat2 == 0)
		br[failed#]
	.endif


begTest2#:
	immed32(testNum, 2);
	move(key_lo, badKey_lo);
	move(key_hi, badKey_hi);
    br[_lookup48#], defer[1]
    load_addr[rtn_addr, endTest2_a#]

endTest2_a#:
	.if(status == 0)
		br[failed#]
	.endif

endTest2_b#:
	// this key should exist
	move(key_lo, goodKey_lo);
	move(key_hi, goodKey_hi);
    br[_lookup48#], defer[1]
    load_addr[rtn_addr, endTest2#]
endTest2#:
	.if(status != 0)
		br[failed#]
	.endif



success#:
	nop
	nop
	ctx_arb[voluntary]
	br[success#]

failed#:
	nop
	nop
	ctx_arb[voluntary]
	br[failed#]


_lookup48#:
	hdbm_lookup48(status, data_ptr, key_hi, key_lo, ptab_base, ptab_indx_start_bit, ptab_indx_bit_len, ctab_indx_start_bit, ctab_indx_bit_len, ctab_shf_bits, ctab_base, keydata_base);
//	hdbm_lookup64(status, data_ptr, key_hi, key_lo, ptab_base, ptab_indx_start_bit, ptab_indx_bit_len, ctab_indx_start_bit, ctab_indx_bit_len, ctab_shf_bits, ctab_base, keydata_base);
    rtn[rtn_addr]

_biLookup48#:
    hdbm_dual_lookup48(status, stat2, data_ptr, data2, key_hi, key_lo, key2_hi, key2_lo, DB_HANDLE);
//    hdbm_dual_lookup64(status, stat2, data_ptr, data2, key_hi, key_lo, key2_hi, key2_lo, DB_HANDLE);
    rtn[rtn_addr]

exit#:
	nop
	nop
	nop
	ctx_arb[kill]
	nop
	nop
	br[exit#]

.endlocal
