CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g -DHDBM_DEBUG
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

VX_HDBMTEST = $(LIB_DIR)\vxWorks_hdbmTest.o


INCLUDE =-I../../utils \
	-I../../osApi \
	-I../../include \
	-I../../BoardSupport/VxWorks/ixp1200eb \
	-I../ix_hash \
	-I../core_utils



ADDED_C++FLAGS  = -w -Wall -pedantic -Dast_parse -DVxWorkTest \
 -DOS=VXWORKS -DIOSTYLE=HARDWARE -DWB_SVR -DVX_WORKS -DVXWORKS \
 -DXACT -DFBUS_DEVICE_COUNT=2 -D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

HDBMTST_OBJS = hdbm_test.o mtRandGen.o


LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/hal_1200.a \
	  $(LIB_DIR)/utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/uclo.a \
	  $(LIB_DIR)/ueng.a \
	  $(LIB_DIR)/libd.a \
	  $(LIB_DIR)/pciComm.a \
	  $(LIB_DIR)/ucommDriver.a \
	  $(LIB_DIR)/msgq.a \
	  $(LIB_DIR)/sv_libs.a \
	  $(LIB_DIR)/app_1200.a \
	  $(LIB_DIR)/octalmac_21440.a \
	  $(LIB_DIR)/gigMac.a \
	  $(LIB_DIR)/rtm.a \
	  $(LIB_DIR)/debug_1200.a \
	  $(LIB_DIR)/rs_udebug.a \
	  $(LIB_DIR)/scomm.a \
	  $(LIB_DIR)/hdbm.a \
	  $(LIB_DIR)/ixp_hash.a \
	  $(LIB_DIR)/brm.a \

.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	@ echo "Compling $?"
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo "ccxxx"

.c.o :
	@ echo "Compling $?"
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo "cccc"

.uc.list :
	@ echo "Assembling $?"
	$(UCA) $(DBG_FLAG) $?
	@ echo "ucucuc"


exe : all

all : $(VX_HDBMTEST)

test : $(VX_HDBMTEST)

lib : hdbm

hdbm:
	make -f vxworks_hdbm.mak CCMODE=DEBUG

$(VX_HDBMTEST) : $(HDBMTST_OBJS) lib
	ldarm --whole-archive -r -o hdbm_testx.o $(HDBMTST_OBJS) $(LIBRARIES)
	nmarm hdbm_testx.o | munch > __CtorDtorx.c
	$(CC)  $(DBG_FLAG) -c -traditional __CtorDtorx.c -o __CtorDtorx.o
	ldarm -o $@ -r __CtorDtorx.o hdbm_testx.o

clean : 
	$(RM)  $(HDBMTST_OBJS) $(VX_HDBMTEST) hdbm_testx.o __CtorDtorx.o
