#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include "utils.h"
#include "uclo.h"
#include "libd.h"
#include "umsg.h"
#include "ostype.h"
#include "libdTest.h"

void *LibdHandle;

// InArg: <desc(len, addr)>
// outArg: <desc(len, addr)>
int echo(void *inArg, void *outArg)
{
   shrimpArgDesc_T *inArgDesc = (shrimpArgDesc_T *)inArg;
   shrimpArgDesc_T *outArgDesc = (shrimpArgDesc_T *)outArg;

   printf("srv: Echoing...\n");
   if(!inArg || !outArg){
	   printf("srv: Invalid arguments passed to Echo!\n");
	   return(1);
   }
	outArg = inArg;
   return(0);
}


// InArg: <uofBuf(word_1), uofSize(word_0)>
// outArg: <none>
int loadUof(void *inArg, void *outArg)
{
   unsigned int uofSize;
   void *uofBuf, *uofHandle=NULL;
   shrimpArgDesc_T *argDesc = (shrimpArgDesc_T *)inArg;

   printf("srv: Loading UOF...\n");

   if(!inArg || !outArg){
	   printf("srv: Invalid arguments to passed to LoadUof!\n");
	   return(1);
   }

   uofSize  = argDesc->len;
   uofBuf  = argDesc->addr;

   if(UcLo_MapObjAddr(&uofHandle, uofBuf, uofSize, 1) != UCLO_SUCCESS){
	   printf("srv: UcLo_MapObjAddr failed!\n");
	   return(1);
   }
   LibD_SetUofHandle(LibdHandle, uofHandle);
   printf("srv: UOF loaded\n");
   return(0);
}


// InArg: <operand2(word_1), operand1(word_0)>
// outArg: <result(word_0)>
int add(void *inArg, void *outArg)
{
   unsigned int op1, op2, *inargs, *outargs = (unsigned int *)outArg;

   printf("srv: Adding...\n");

   if(!inArg || !outArg){
	   printf("srv: Invalid arguments to passed to Add!\n");
	   return(1);
   }
   inargs = (unsigned int *)inArg;

   //printf("add: inArg(0x%x 0x%x)\n", inargs[1], inargs[0]); fflush(stdout);
   op1  = inargs[0];
   op2  = inargs[1];
   printf("srv: Adding %d and %d...\n", op1, op2);
   outargs[0] = op1 + op2;

   return(0);
}


void startSrv()
{
	int wait = 1;

    LibdHandle = LibD_Init(NULL, SRV_DESTID);

#ifdef LIBD_PCI
	int myPciDevNum, extDevNum = 1;
	myPciDevNum = LibD_GetLocalPciDevNum();
	if(myPciDevNum == extDevNum) extDevNum = 0;

	printf("MyPciDevId = %d, ExtPciDev = %d\n", myPciDevNum, extDevNum);
	// route these destination through the PCI device.
    if(LibD_AssignExtDestId(LIBD_DEST_PCI, extDevNum, TSTAPP_BEG_DESTID,
		TSTAPP_NUMDESTID) != LIBD_SUCCESS){
		printf("Fail: cannot assign external PCI device %d\n", extDevNum);
		return;
	}
#else
	int extDevNum = 2;
    if(LibD_AssignExtDestId(LIBD_DEST_SERIAL, extDevNum, TSTAPP_BEG_DESTID,
		TSTAPP_NUMDESTID) != LIBD_SUCCESS){
		printf("Fail: cannot assign external PCI device %d\n", extDevNum);
		return;
	}
#endif

    LibD_RegisterCallback(LibdHandle, UOF_FUNCID, loadUof, 20, 0);
    LibD_RegisterCallback(LibdHandle, ADD_FUNCID, add, 8, 4);
    LibD_RegisterCallback(LibdHandle, ECHO_FUNCID, echo, ECHOMAXLEN, ECHOMAXLEN);

    // just hang around while the dispatcher does all the work
	while(1){
       LibD_ProcessMsgQ(LibdHandle, wait);
	}
   return;
}


#if (OS == UCOS)
void main_srv(void);
static int Argc;
static char **Argv;

int main(int argc, char** argv)
{
    Argc = argc;
    Argv = argv;

    /* Start uC/OS and run userInit in root task
     * with highest priority.  After userInit()
     * returns, root task commits suicide.
     */
    ucosStart(startSrv, NO_CONSOLE);

    /* ucosStart() doesn't return. */
   return 0;
}
#endif

#if (OS == WIN_32)
int main(int argc, char **argv)
{
	startSrv();
	return(0);
}
#endif


