CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

VX_LIBDTEST_SRV = $(LIB_DIR)\vxWorks_libdTest_srv.o
VX_LIBDTEST_CLNT = $(LIB_DIR)\vxWorks_libdTest_clnt.o

INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils 


ADDED_C++FLAGS  = -w -Wall -pedantic -Dast_parse -Dxactor_build -DVxWorkTest \
 -DOS=VXWORKS -DIOSTYLE=HARDWARE -Dext_model_port -Dno_uca_code_gen -Dnew_sdram \
 -Dbuild_without_main -DVX_WORKS -DXACT -DLIBD_PCI -DFBUS_DEVICE_COUNT=2 -D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
#include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

LIBDTST_SRV_OBJS = libdTest_srv.o
LIBDTST_CLNT_OBJS = libdTest_clnt.o

LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/hal_1200.a \
	  $(LIB_DIR)/utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/uclo.a \
	  $(LIB_DIR)/ueng.a \
	  $(LIB_DIR)/libd.a \
	  $(LIB_DIR)/pciComm.a \
	  $(LIB_DIR)/ucommDriver.a \
	 $(LIB_DIR)/msgq.a
	

.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.uc.list :
	$(UCA) $(DBG_FLAG) $?
	@ echo ""


exe : all

srv :  $(VX_LIBDTEST_SRV)

clnt : $(VX_LIBDTEST_CLNT)

all : clnt srv

libd:
	make -f vxworks_libd.mak CCMODE=DEBUG

$(VX_LIBDTEST_SRV) : $(LIBDTST_SRV_OBJS) libd
	ldarm --whole-archive -r -o libdTest_srvx.o $(LIBDTST_SRV_OBJS) $(LIBRARIES)
	nmarm libdTest_srvx.o | munch > __CtorDtorx.c
	$(CC)  $(DBG_FLAG) -c -traditional __CtorDtorx.c -o __CtorDtorx.o
	ldarm -o $@ -r __CtorDtorx.o libdTest_srvx.o
	$(RM) __CtorDtorx.o libdTest_srvx.o __CtorDtorx.c

$(VX_LIBDTEST_CLNT) : $(LIBDTST_CLNT_OBJS) libd
	ldarm --whole-archive -r -o libdTest_clntx.o $(LIBDTST_CLNT_OBJS) $(LIBRARIES)
	nmarm libdTest_clntx.o | munch > __CtorDtor.c
	$(CC)  $(DBG_FLAG) -c -traditional __CtorDtor.c -o __CtorDtor.o
	ldarm -o $@ -r __CtorDtor.o libdTest_clntx.o
	$(RM) __CtorDtor.o libdTest_clntx.o __CtorDtor.c

clean : 
	$(RM)  $(LIBDTST_CLNT_OBJS) $(LIBDTST_SRV_OBJS) $(VX_LIBDTEST_SRV) $(VX_LIBDTEST_CLNT)
