/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

//endian.cpp

#include "endian.h"

unsigned long htonl(unsigned long in)
{
#if BYTE_ORDER == LITTLE_ENDIAN
	return(swap4(in));
#else
	return(in);
#endif
}


unsigned short htons (unsigned short in)
{
#if BYTE_ORDER == LITTLE_ENDIAN
	return(swap2(in));
#else
	return(in);
#endif
}


unsigned long ntohl (unsigned long in)
{
#if BYTE_ORDER == LITTLE_ENDIAN
	return(swap4(in));
#else
	return(in);
#endif
}


unsigned short ntohs(unsigned short in)
{
#if BYTE_ORDER == LITTLE_ENDIAN
	return(swap2(in));
#else
	return(in);
#endif
}
