/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* endian.h
 * short and long word endian swaps
 *
 *
 * system: SA1200
 * subsystem: packet_gen
 * author: Don Hooper 4/15/98
 * revisions:
 * $History endian.h $
 * 
 * *****************  Version 1  *****************
 * User: Hooper       Date: 2/06/98    Time: 11:47 a
 * Created in $/base_level2/packet_gen
 * short and long word endian swaps
 * 
 */

/*
  Definitions for byte order,
  according to byte significance from low address to high.
 */
#define LITTLE_ENDIAN   1234    // least-significant byte first (Intel, Alpha, Vax)
#define BIG_ENDIAN      4321    // most-significant byte first (IBM, Sun)

// MIPS may use either endian, compiler tells us which.
#define BYTE_ORDER      LITTLE_ENDIAN

#define swap2(in) (((in>>8) & 0xff) | (in<<8))
#define swap4(in) (((in>>24) & 0xff) | ((in>>8) & 0xff00) | ((in<<8) & 0xff0000) | (in<<24))

unsigned long htonl(unsigned long in);
unsigned short htons (unsigned short in);
unsigned long ntohl (unsigned long in);
unsigned short ntohs(unsigned short in);