/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* fdevice.cpp
 * fdevice class methods, common to receive and transmit
 *
 *
 * system: SA1200
 * subsystem: packet_gen
 * author: Don Hooper 3/18/99
 * revisions:
 * $History fdevice.cpp $
 * 
 * 
 */
#include "fmon.h"
#include "fdevice.h"

/*-----------------------------------------------------------------
	FDevice::FDevice
	description: Constructor. Initialize FDevice. Variables common to receive and transmit.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
FDevice::FDevice()
{
	port_ctl_l_dly = 0xF;
	port_ctl_l_dly1 = 0xF;
	port_ctl_l_dly2 = 0xF;
	port_ctl_l_dly3 = 0xF;

	rdyctl_l_dly = 0xF;
	rdyctl_l_dly1 = 0xF;
	rdyctl_l_dly2 = 0xF;
	rdyctl_l_dly3 = 0xF;
	
	rdyctl_4_l_dly = 1;
	rdyctl_4_l_dly1 = 1;
	rdyctl_4_l_dly2 =1;
	rdyctl_4_l_dly3 = 1;

	fps_dly = 0;
	fps_dly1 = 0;
	fps_dly2 = 0;
	fps_dly3 = 0;

	gpio_dly = 0;
	gpio_dly1 = 0;
	gpio_dly2 = 0;
	gpio_dly3 = 0;

}


/*-----------------------------------------------------------------
	FDevice::PinDelayChains
	description: Delay pin values in a 3 cycle pipe.
	returns:
	uses:
	modifies:
  -----------------------------------------------------------------*/
void FDevice::PinDelayChains()
{
	// delay chains to simulate logic delay
	if (fm.fbus_mac_count < 3){
		port_ctl_l_dly3 = port_ctl_l_dly2;
		port_ctl_l_dly2 = fm.pctl_val;
		rdyctl_l_dly3 = rdyctl_l_dly2;
		rdyctl_l_dly2 = fm.rdyctl_l_val;
		rdyctl_4_l_dly3 = rdyctl_4_l_dly2;
		rdyctl_4_l_dly2 = fm.rdyctl_4_l_val;
		fps_dly3 = fps_dly2;
		fps_dly2 = fm.fps_val;
		gpio_dly3 = gpio_dly2;
		gpio_dly2 = fm.gpio_val;
	}else{
		port_ctl_l_dly3 = port_ctl_l_dly2;
		port_ctl_l_dly2 = port_ctl_l_dly1;
		port_ctl_l_dly1 = fm.pctl_val;
		rdyctl_l_dly3 = rdyctl_l_dly2;
		rdyctl_l_dly2 = rdyctl_l_dly1;
		rdyctl_l_dly1 = fm.rdyctl_l_val;
		rdyctl_4_l_dly3 = rdyctl_4_l_dly2;
		rdyctl_4_l_dly2 = rdyctl_4_l_dly1;
		rdyctl_4_l_dly1 = fm.rdyctl_4_l_val;
		fps_dly3 = fps_dly2;
		fps_dly2 = fm.fps_val;
		gpio_dly3 = gpio_dly2;
		gpio_dly2 = gpio_dly1;
		gpio_dly1 = fm.gpio_val;
	}
	return;
}



