/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* fdevice.h
 * fdevice class definition, common to receive and transmit
 *
 *
 * system: SA1200
 * subsystem: packet_gen
 * author: Don Hooper 3/18/99
 * revisions:
 * $History fdevice.h $
 * 
 * 
 */

#ifndef FDEVICE_H
#define FDEVICE_H

enum fbus_returns{ FBUS_SUCCESS = 1, FBUS_ILLEGAL_BUS_SIZE, FBUS_WRONG_NUMBER_OF_MACS };


class FDevice{
public:
	int port_ctl_l_dly;
	int port_ctl_l_dly1;
	int port_ctl_l_dly2;
	int port_ctl_l_dly3;

	int rdyctl_l_dly;
	int rdyctl_l_dly1;
	int rdyctl_l_dly2;
	int rdyctl_l_dly3;

	int rdyctl_4_l_dly;
	int rdyctl_4_l_dly1;
	int rdyctl_4_l_dly2;
	int rdyctl_4_l_dly3;

	int fps_dly;
	int fps_dly1;
	int fps_dly2;
	int fps_dly3;

	int gpio_dly;
	int gpio_dly1;
	int gpio_dly2;
	int gpio_dly3;

	int port_sel_dly2;
	int port_sel_dly3;

	unsigned char my_id;

	FDevice();
	void PinDelayChains();
private:
};



#endif		// FDEVICE_H