/* ------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------------------------*/

/* fileio.h
 * fileio class for use by transactor command line functions
 *
 *
 * system: SA1200
 * subsystem: packet_gen
 * author: Don Hooper 3/25/98
 * revisions:
 * $History fileio.h $
 * 
 * 
 */ 
#ifndef FILEIO_H
#define FILEIO_H

#include <stdio.h>

#define MAX_FILEPTRS			64

enum io_returns { FILEIO_SUCCESS = 1, FILEIO_FOPEN_FAIL = -1,  FILEIO_FILEPTR_LIMIT = -2};

class FileIo {
public:
	FILE *open_files[MAX_FILEPTRS];			// file pointers
	int outfptr_valid[MAX_FILEPTRS];
	int next_fptr_index;

	FileIo();
	int FOpen(char *fname, char *mode);
	int FClose(int fptr);
private:
};

#endif		// FILEIO_H