//////////////////////////////////////////////////////////////////////////////
//		    INTEL CORPORATION PROPRIETARY INFORMATION	
//  This software is supplied under the terms of a license agreement or 
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//      Copyright (c) 2000 Intel Corporation. All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// $Source: /mnt/bigpine/src/oem/IXP1200/CoreLibs/rtm-mvr/Attic/RTMException.h,v $
// $Revision: 2 $
// $Date: 5/02/00 3:35p $
//
// Description:
//     This file declares the Exception classes used in the RTM implementation
//
//////////////////////////////////////////////////////////////////////////////

#ifndef _EXCEPTION_H_
#define _EXCEPTION_H_

#include <exception>

////////////////////////////////////////////////////////////////////////////////
//  Name: InvalidPortException - An exception thrown when an invalid port is
//                               passed into a method.
////////////////////////////////////////////////////////////////////////////////
class InvalidPortException : exception {
    // Intentionally empty.  Useful only for its type.
};

////////////////////////////////////////////////////////////////////////////////
//  Name: OutOfTriesException - An exception thrown when there are no more 
//                              available tries in the system
////////////////////////////////////////////////////////////////////////////////
class OutOfTriesException : exception {
    // Intentionally empty.  Useful only for its type.
};

////////////////////////////////////////////////////////////////////////////////
//  Name: OutOfRoutesException - An exception thrown when there are no more 
//                               SDRAM route entries available in the system
////////////////////////////////////////////////////////////////////////////////
class OutOfRoutesException : exception {
    // Intentionally empty.  Useful only for its type.
};

////////////////////////////////////////////////////////////////////////////////
//  Name: InvalidRouteException - An exception thrown when an invalid route is
//                                specified
////////////////////////////////////////////////////////////////////////////////
class InvalidRouteException : exception {
    // Intentionally empty.  Useful only for its type.
};


#endif //_EXCEPTION_H_