/* uclo_dev.h
 * Ucode Object File Loader Library Development Header
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Linker/Loader utility
 *  author: drj Dec 31, 97  Initial version
 *  revisions:
 *  $History: uclo_dev.h $
 * 
 * *****************  Version 12  *****************
 * User: Drjohns1     Date: 11/15/00   Time: 3:45p
 * Updated in $/dev_1200/SA1_CoreLibs/uclo
 * Added uC support
 * 
 * *****************  Version 5  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:24p
 * Updated in $/development/uclo
 * update COPYRIGHT
 * 
 * *****************  Version 4  *****************
 * User: Drjohns1     Date: 5/21/98    Time: 2:26p
 * Updated in $/base_level2/uclo
 * Updated copyright header
 * 
 * *****************  Version 3  *****************
 * User: Johnsondes   Date: 4/13/98    Time: 5:28p
 * Updated in $/base_level2/uclo
 * Encapsulated the UOF object into seperate chunk
 * 
 * *****************  Version 2  *****************
 * User: Johnsondes   Date: 2/20/98    Time: 8:22p
 * Updated in $/base_level1/uclo
 * Changed export_label to export_func, added functionality for
 * export_table and function args length
 * 
 * *****************  Version 1  *****************
 * User: Johnsondes   Date: 2/11/98    Time: 7:18p
 * Created in $/base_level1/uclo
 * Seperated utility function from loader library.
 *
 * ---------------------------------------------------------------------
 */
#ifndef __UCLO_DEV_H
#define __UCLO_DEV_H 1

#include "uof.h"

#define UCLO_MAXFUNC 128
#define UCLO_MIN_UOF_SIZE 24

typedef struct uclo_bindFuncTable_S{
   char                 *bindName;
   short                uEngFlag;
   short                funcEndAddr;
   uof_exportFunc_T     *expFunc;
}uclo_bindFuncTable_T;


typedef struct uclo_objHandle_S{
   uof_encapUofObj_T        encapUofObj; 
   uof_strTab_T             strTable;
   uof_encapFeng_T          encapFengImage[UOF_MAX_FENGINES];
   uof_encapFeng_T          uniqueFengImage[UOF_MAX_FENGINES];
   uclo_bindFuncTable_T     bindFuncTab[UCLO_MAXFUNC];
   uof_initMemTab_T			initMemTab;
   char                     *fBuf;
   int                      numUniqueImage;
   int						objLoaded;
   int                      numBindFunc;
   int						readOnly;
}uclo_objHandle_T;

#endif		/* __UCLO_DEV_H */
