/* uclo_utl.h
 * Ucode Object File utilities
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Linker/Loader utility
 *  author: drj Dec 31, 97  Initial version
 *  revisions:
 *  $History: uclo_utl.h $
 * 
 * *****************  Version 15  *****************
 * User: Drjohns1     Date: 11/21/00   Time: 1:26p
 * Updated in $/dev_1200/SA1_CoreLibs/uclo
 * Added retrieval of variables memory segments values
 * 
 * *****************  Version 14  *****************
 * User: Drjohns1     Date: 11/15/00   Time: 3:45p
 * Updated in $/dev_1200/SA1_CoreLibs/uclo
 * Added uC support
 * 
 * *****************  Version 7  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:24p
 * Updated in $/development/uclo
 * update COPYRIGHT
 * 
 * *****************  Version 6  *****************
 * User: Drjohns1     Date: 5/21/98    Time: 2:26p
 * Updated in $/base_level2/uclo
 * Updated copyright header
 * 
 * *****************  Version 5  *****************
 * User: Johnsondes   Date: 4/13/98    Time: 5:28p
 * Updated in $/base_level2/uclo
 * Encapsulated the UOF object into seperate chunk
 * 
 * *****************  Version 4  *****************
 * User: Johnsondes   Date: 3/12/98    Time: 5:58p
 * Updated in $/base_level1/uclo
 * Added function UcLoUtl_prnUwords
 * 
 * *****************  Version 3  *****************
 * User: Johnsondes   Date: 2/20/98    Time: 8:22p
 * Updated in $/base_level1/uclo
 * Changed export_label to export_func, added functionality for
 * export_table and function args length
 * 
 * *****************  Version 2  *****************
 * User: Johnsondes   Date: 2/12/98    Time: 2:22p
 * Updated in $/base_level1/uclo
 * Corrected typo in function definition
 * 
 * *****************  Version 1  *****************
 * User: Johnsondes   Date: 2/11/98    Time: 7:18p
 * Created in $/base_level1/uclo
 * Seperated utility function from loader library.
 *
 * ---------------------------------------------------------------------
 */
#ifndef __UCLO_UTL_H__
#define __UCLO_UTL_H__

#include "uclo_dev.h"

#ifdef __cplusplus
extern "C"{
#endif


void UcLoUtl_prnChunkHdr(FILE *fp, uof_chunkHdr_T *chunkHdr);
void UcLoUtl_prnUofObj(FILE *fp, uof_objHdr_T *objHdr, uof_chunkHdr_T *chunkHdr);
void UcLoUtl_prnGenToolId(FILE *fp, uof_GTID_T *genToolId);
void UcLoUtl_prnGenToolId(FILE *fp, uof_GTID_T *genToolId);
void UcLoUtl_prnStrTable(FILE *fp, uclo_objHandle_T *objHandle);
void UcLoUtl_prnInitMemTable(FILE *fp, uclo_objHandle_T *objHandle);
void UcLoUtl_prnVarMemSeg(FILE *fp, uclo_objHandle_T *objHandle);
void UcLoUtl_uEngToStr(short uEngFlags, char *uEngStr);
void UcLoUtl_uThreadTypToStr(short uThreadTypes, char *srv, char *auton);
void UcLoUtl_uThreadToStr(short uThreads, char *uThreadsStr);
void UcLoUtl_prnImage(FILE *fp, uof_strTab_T *strTable, uof_Image_T *image);
void UcLoUtl_prnEncapUofObj(FILE *fp, uclo_objHandle_T *objHandle);
void UcLoUtl_prnImpVar(FILE *fp, uof_strTab_T *strTable, uof_importVar_T *importVar);
void UcLoUtl_prnUcVar(FILE *fp, uof_strTab_T *strTable, uof_ucVar_T *ucVar);
void UcLoUtl_prnExpFunc(FILE *fp, uof_strTab_T *strTable, uof_exportFunc_T *exportFunc);
void UcLoUtl_prnEncapPage(FILE *fp, uof_strTab_T *strTable, uof_encapPage_T *encapPage, unsigned int numUwrds);
void UcLoUtl_prnEncapImage(FILE *fp, uclo_objHandle_T *objHandle, unsigned int numUwrds);
void UcLoUtl_prnNUwords(FILE *fp, uof_encapPage_T *encapPage, unsigned int begAddr, unsigned int numUwrds);
int UcLoUtl_numOfChunkHdrType(uof_encapUofObj_T *encapUofObj, char *chunkId);

char *UcLo_getString(uof_strTab_T *strTable, int strOffset);	/* in module uclo.c */

#ifdef __cplusplus
}
#endif

#endif		/* __UCLO_UTL_H__ */
