CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../debug_1200 \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils \
-I../msgQ


ADDED_C++FLAGS  = -w -Wall -pedantic -DVxWorkTest \
-DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DVXWORKS -DROUTE \
-DBRIDGE -DMAC_21440 -DWB_SVR -DFBUS_DEVICE_COUNT=2 \
-D__unix -DUCLO_PCI $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

EXAM_OBJS = uclo_exam.o
VX_UCLO_EXAM = $(LIB_DIR)/Vx_UcloExam.o

LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/hal_1200.a \
	  $(LIB_DIR)/utils.a \
	  $(LIB_DIR)/uclo.a \
	  $(LIB_DIR)/ueng.a \
	  $(LIB_DIR)/pciComm.a \
	  $(LIB_DIR)/ucommDriver.a \
	  $(LIB_DIR)/libd.a \
	  $(LIB_DIR)/msgq.a

.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe: $(VX_UCLO_EXAM)


$(VX_UCLO_EXAM) : $(EXAM_OBJS) $(LIBRARIES)
	ldarm --whole-archive -r -o exam.o $(EXAM_OBJS) $(LIBRARIES)
	nmarm exam.o | munch > __CtorDtorx.c
	$(CC)  -c -traditional __CtorDtorx.c
	ldarm -o $(VX_UCLO_EXAM) -r __CtorDtorx.o exam.o

clean : 
	@$(RM) $(VX_UCLO_EXAM) $(EXAM_OBJS) __CtorDtorx.o exam.o 


