/* Rs_Control.H
 *
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services
 * author: Lai-Wah Hui 6/22/98
 * revisions:
 * $History: rs_control.h $
 * 
 * *****************  Version 9  *****************
 * User: Lhui         Date: 5/14/99    Time: 10:14a
 * Updated in $/dev_1200/Share/RemoteServices
 * Add support for xact_clock_with_remainder(),
 * xact_define_callback_default_go_clock_domain and
 * xact_stop_execution_at_clk 
 * 
 * *****************  Version 7  *****************
 * User: Lhui         Date: 4/13/99    Time: 8:15p
 * Updated in $/development/RemoteServices
 * Add supports for XACT_Define_Automatic_Sim_Halt
 * 
 * *****************  Version 6  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:47p
 * Updated in $/development/RemoteServices
 * update COPYRIGHT
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 2/01/99    Time: 7:22p
 * Updated in $/development/RemoteServices
 * Add supports for XACT_get_fifo_handle & XACT_Define_Callback_Ref_Status
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 12/18/98   Time: 4:02p
 * Updated in $/development/RemoteServices
 * Add support for xact_get|set_fifo_state_value
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 12/14/98   Time: 6:20p
 * Updated in $/development/RemoteServices
 * Add support for new transactor functions
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 9/14/98    Time: 6:03p
 * Updated in $/base_level3/RemoteServices
 * Add support for 4 new transactor functions:
 * XACTAPI XACT_find_wildcard_state_name()
 * XACTAPI XACT_Define_Callback_Init_Sim();
 * XACTAPI XACT_Define_Callback_Sim_Reset();
 * XACTAPI XACT_Define_Callback_Restore( );
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 7/28/98    Time: 10:39a
 * Created in $/base_level3/RemoteServices
 * Init. check-in
 * 
 */ 
#ifndef Rs_Control_H
#define Rs_Control_H

#define NameLen 128

/*
 *  This structure contains pointers to client callback functions 
 */
typedef struct {
		void (*Xact_Callback_Set_Prompt)();
		char *(*Xact_Callback_Get_Console_Input)();
		void (*Xact_Callback_Output_Message)();
		void (*Xact_Callback_Create_Chip)();
		void (*Xact_Callback_Load_Ucode)();
		void (*Xact_Callback_Breakpoint)();
		void (*Xact_Callback_Breakpoint_Event)();
		void (*Xact_Callback_State_Transition)();
		void (*Xact_Callback_Cancel_State_Transition)();
		void (*Xact_Callback_Init_Sim)();
		void (*Xact_Callback_Sim_Reset)();
		void (*Xact_Callback_Restore)();
		void (*Xact_Callback_RefStatus)();
		void (*Xact_Callback_Sim_Halt)();
		void (*Xact_Callback_Go_Clk_Domain)();

 }tCk_functions, *ptCk_functions;


typedef struct{
	CLIENT *cl;
	char  server[NameLen];
    ptCk_functions pCk_functions;
}tRs_Client, *tpRs_Client;

#if defined(__cplusplus)
extern "C"
{
#endif
int Rs_GetStatus(int *result);

#if defined(__cplusplus)
}
#endif
#endif




