/* RemoteSample.h
 *
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Simulation Extension DLL example
 * author: Lai-Wah Hui 8/6/98
 * revisions:
 * $History: RemoteSample.h $
 * 
 * *****************  Version 3  *****************
 * User: Qabuild      Date: 5/21/99    Time: 7:45p
 * Updated in $/dev_1200/Share/Samples/RemoteSimInterface
 * Update
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 4/09/99    Time: 5:38p
 * Created in $/development/Samples/RemoteSimExt
 * 
 * *****************  Version 5  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:16p
 * Updated in $/development/Samples/SimExtensionDLL
 * update COPYRIGHT
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 10/12/98   Time: 9:51a
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add comments
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 10/12/98   Time: 9:51a
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add ..\common\sim.c into the project
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 9/18/98    Time: 9:54p
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add support for remote transactor calls
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 8/07/98    Time: 8:01p
 * Created in $/base_level3/Samples/SimExtensionDLL
 * Add remote supports
 * 
 */ 
#ifndef RemoteSample_H
#define RemoteSample_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <OncRpc32.h>
#include <pmap_clnt.h>
#include "rssimext.h"

/* Remote sample routines   */

#if defined(__cplusplus)
extern "C"
{
#endif

/* FUNCTIONs DEFINITION */
extern int RemoteInit(char *Server, unsigned ProgID);
extern int PrintRemoteMessage();
extern int Rs_GetStatus();
extern int rs_foreign_model_initialize();
extern int rs_foreign_model_pre_sim();
extern int rs_foreign_model_post_sim();
extern int rs_foreign_model_exit();

//
/* other defintions */
#define TRUE    1
#define FALSE   0
#if defined(__cplusplus)
}
#endif


#endif /* RemoteSample_H */
