/* rsSimExt.c: Implementation of the foreign_model stubs for remote 
 *             procedure transactor functions.  
 *             
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: Remote Services
 * author: Lai-Wah Hui 10/1/98
 * revisions:
 * $History: rssimext_clnt.c $
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 4/09/99    Time: 5:38p
 * Created in $/development/Samples/RemoteSimExt
 * 
 * *****************  Version 3  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:16p
 * Updated in $/development/Samples/SimExtensionDLL
 * update COPYRIGHT
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 10/12/98   Time: 4:16p
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add comments
 */
#include <stdio.h>
#ifdef WIN32
#include <OncRpc32.h>
#else
#include <rpc/rpc.h>
#endif
#include "rssimext.h"


/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };


/*
 * function:    rs_foreign_model_initialize_1
 * description: call rs_foreign_model_initialize_1 on the server 
 */

int *
rs_foreign_model_initialize_1(argp, clnt)
	char **argp;		/* IN: host name of the remote system */
	CLIENT *clnt;		/* IN: client handle */
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_FOREIGN_MODEL_INITIALIZE, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


/*
 * function:    rs_foreign_model_pre_sim_1
 * description: call rs_foreign_model_pre_sim_1 on the server
 */


int *
rs_foreign_model_pre_sim_1(argp, clnt)
	char **argp;		 /* IN: character string */ 
	CLIENT *clnt;		 /* IN: client handle    */
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_FOREIGN_MODEL_PRE_SIM, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


/*
 * function:   rs_foreign_model_post_sim_1
 * description: call rs_foreign_model_post_sim_1 on the server
 */


int *
rs_foreign_model_post_sim_1(argp, clnt)
	char **argp;		 /* IN: character string */ 
	CLIENT *clnt;		 /* IN: client handle    */
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_FOREIGN_MODEL_POST_SIM, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


/*
 * function:    rs_foreign_model_exit_1
 * description: call rs_foreign_exit_1 on the server
 */

int *
rs_foreign_model_exit_1(argp, clnt)
	char **argp;		 /* IN: character string */ 
	CLIENT *clnt;		 /* IN: client handle    */
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_FOREIGN_MODEL_EXIT, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

