#include <stdio.h>
#ifdef WIN32
#include <OncRpc32.h>
#else
#include <rpc/rpc.h>
#endif
#include "rsSimExt.h"


bool_t
xdr_RS_CLK_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_CLK_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_statevalue(xdrs, objp)
	XDR *xdrs;
	statevalue *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, MAXBUFLEN, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_statedata(xdrs, objp)
	XDR *xdrs;
	statedata *objp;
{
	if (!xdr_int(xdrs, &objp->handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_varintarr(xdrs, objp)
	XDR *xdrs;
	varintarr *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->pdata.pdata_val, (u_int *)&objp->pdata.pdata_len, MAXBUFLEN, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_handle(xdrs, objp)
	XDR *xdrs;
	handle *objp;
{
	if (!xdr_string(xdrs, &objp->name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->array_index)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_wildcard_state(xdrs, objp)
	XDR *xdrs;
	wildcard_state *objp;
{
	if (!xdr_string(xdrs, &objp->rtn_name_buf, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->status)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_ucodeload(xdrs, objp)
	XDR *xdrs;
	ucodeload *objp;
{
	if (!xdr_string(xdrs, &objp->chip_name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->fbox_num)) {
		return (FALSE);
	}
	if (!xdr_string(xdrs, &objp->ucode_file, MAXPATH)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_breakevent(xdrs, objp)
	XDR *xdrs;
	breakevent *objp;
{
	if (!xdr_string(xdrs, &objp->chip_name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->fbox_num)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->pc)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->contextmask)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_state_transition_ck(xdrs, objp)
	XDR *xdrs;
	state_transition_ck *objp;
{
	if (!xdr_int(xdrs, &objp->handle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->callback_priority)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->usercontext)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_state_info(xdrs, objp)
	XDR *xdrs;
	state_info *objp;
{
	if (!xdr_string(xdrs, &objp->state_name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->width)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->array_length)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_state_handle(xdrs, objp)
	XDR *xdrs;
	state_handle *objp;
{
	if (!xdr_u_int(xdrs, &objp->array_handle)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->array_index)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_set_array_state_value(xdrs, objp)
	XDR *xdrs;
	set_array_state_value *objp;
{
	if (!xdr_state_handle(xdrs, &objp->array_handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_set_state_value(xdrs, objp)
	XDR *xdrs;
	set_state_value *objp;
{
	if (!xdr_int(xdrs, &objp->state_handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}


