/* server_foreign_model.c: implementation of server version
 *                   of foreign model sample.
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: Remote Simulation Extension DLL example
 * author: Lai-Wah Hui 8/4/98
 * revisions:
 * $History: Server_Foreign_Model.c $
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 4/09/99    Time: 5:38p
 * Created in $/development/Samples/RemoteSimExt
 * 
 * *****************  Version 5  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:16p
 * Updated in $/development/Samples/SimExtensionDLL
 * update COPYRIGHT
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 10/12/98   Time: 4:16p
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add comments
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 10/12/98   Time: 9:51a
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Add ..\common\sim.c into the project
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 10/05/98   Time: 3:34p
 * Updated in $/base_level3/Samples/SimExtensionDLL
 * Code cleanup
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 9/18/98    Time: 9:55p
 * Created in $/base_level3/Samples/SimExtensionDLL
 * Add support for remote transactor calls
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 8/07/98    Time: 8:01p
 * Created in $/base_level3/Samples/SimExtensionDLL
 * Add remote supports
 */ 

#include <stdio.h>
#ifdef WIN32
#include <OncRpc32.h>
#else
#include <rpc/rpc.h>
#endif
#include "rssimext.h"
#include "rsxact_dll.h"
#include "remote_services.h"
#include "thread.h"
/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 50, 0 };
int ConnectToXact(char *XactServer);
int DisconnecFromXact();

int state_context;
RS_XACT_HANDLE hSimTime;

/*
 * Remote verson of "rs_foreign_model_initialize_1"
 * you can put your foreign model initialization code 
 */

int *
rs_foreign_model_initialize_1(char **XactServer)
{
    
	static int result =1; /* must be static! */
    RS_XACT_HANDLE hSimTime;
    printf("xactServer = %s, RsSimExt_Client = %d\n", *XactServer, RsSimExt_Client);
    if(ConnectToXact(*XactServer) != RS_SUCCESS){
        printf("ConnectToXact failed\n");
        result=0;
    }

    hSimTime = RS_XACT_get_handle("sim.time", -1);
    printf("hSimTime=%x\n", hSimTime);
    if(hSimTime == RS_INVALID_XACT_HANDLE)
        printf("ErrorError - RS_XACT_get_handle failed\n");

    return &result;

}


/*
 * Remote verson of "rs_foreign_model_pre_sim_1"
 */

int *
rs_foreign_model_pre_sim_1(char **msg)
{
	static int result=1; /* must be static! */
    int status;
    unsigned int value;
    printf("enter rs_foreign_model_pre_sim_1\n");
	/* your pre simulation event code */
    status = RS_XACT_get_state_value(hSimTime, &value);
    printf("sim.time = %d\n",value);
	return (&result);


}

/*
 * Remote verson of "rs_foreign_model_post_sim_1"
 */

int *
rs_foreign_model_post_sim_1(char **msg)
{
	static int result=1; /* must be static! */
    int status;
    char buf[64];
	/* your post simulation event code */
    status = RS_XACT_find_wildcard_state_name("art.amba_xact_enable", buf, 64);
    if(status == 1) 
         printf("return buf=%s, status = %d\n", buf, status);
    else
        printf("status = %d\n", status);
    printf("test clock cycle\n");
    printf("FBOX cycle = %d\n",RS_XACT_clock_cycle(CLK_FBOX));
    printf("FBUS cycle = %d\n",RS_XACT_start_of_cycle(CLK_FBUS));
    printf("PCI cycle = %d\n",RS_XACT_start_of_cycle(CLK_PCI));
    return (&result);


}

/*
 * Remote verson of "rs_foreign_model_exit_1"
 */

int *
rs_foreign_model_exit_1(char **msg)
{
	static int result=1; /* must be static! */
	/* your simulation cleanup code */
	printf("rs_foreign_model_exit\n");
	return (&result);


}

