#include <stdio.h>
#ifdef WIN32
#include <OncRpc32.h>
#else
#include <rpc/rpc.h>
#endif
#include "xact_server.h"

/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

int *
rs_xact_get_handle_1(argp, clnt)
	handle *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_HANDLE, xdr_handle, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_delete_handle_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_DELETE_HANDLE, xdr_int, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


varintarr *
rs_xact_get_state_value_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	static varintarr res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_STATE_VALUE, xdr_int, argp, xdr_varintarr, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_start_of_cycle_1(argp, clnt)
	RS_CLK_TYPE *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_START_OF_CYCLE, xdr_RS_CLK_TYPE, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_clock_cycle_1(argp, clnt)
	RS_CLK_TYPE *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_CLOCK_CYCLE, xdr_RS_CLK_TYPE, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


state_info *
rs_xact_get_state_info_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	static state_info res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_STATE_INFO, xdr_int, argp, xdr_state_info, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


varintarr *
rs_xact_get_array_state_value_1(argp, clnt)
	state_handle *argp;
	CLIENT *clnt;
{
	static varintarr res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_ARRAY_STATE_VALUE, xdr_state_handle, argp, xdr_varintarr, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_set_state_value_1(argp, clnt)
	set_state_value *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_SET_STATE_VALUE, xdr_set_state_value, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_set_array_state_value_1(argp, clnt)
	set_array_state_value *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_SET_ARRAY_STATE_VALUE, xdr_set_array_state_value, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_gethostname_1(argp, clnt)
	char **argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_GETHOSTNAME, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


wildcard_state *
rs_xact_find_wildcard_state_name_1(argp, clnt)
	char **argp;
	CLIENT *clnt;
{
	static wildcard_state res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_FIND_WILDCARD_STATE_NAME, xdr_wrapstring, argp, xdr_wildcard_state, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


stat_char *
rs_xact_get_stat_characteristic_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	static stat_char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_STAT_CHARACTERISTIC, xdr_int, argp, xdr_stat_char, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


get_bucket_data_OArg *
rs_xact_get_stat_bucket_data_1(argp, clnt)
	get_bucket_data_IArg *argp;
	CLIENT *clnt;
{
	static get_bucket_data_OArg res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_STAT_BUCKET_DATA, xdr_get_bucket_data_IArg, argp, xdr_get_bucket_data_OArg, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


varintarr *
rs_xact_get_fifo_state_value_1(argp, clnt)
	state_handle *argp;
	CLIENT *clnt;
{
	static varintarr res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_FIFO_STATE_VALUE, xdr_state_handle, argp, xdr_varintarr, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_set_fifo_state_value_1(argp, clnt)
	set_array_state_value *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_SET_FIFO_STATE_VALUE, xdr_set_array_state_value, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
rs_xact_get_fifo_handle_1(argp, clnt)
	handle *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, RS_XACT_GET_FIFO_HANDLE, xdr_handle, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

