#include <stdio.h>
#ifdef WIN32
#include <OncRpc32.h>
#else
#include <rpc/rpc.h>
#endif
#include "xact_server.h"


bool_t
xdr_RS_META_TAG_UNIT_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_META_TAG_UNIT_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_RS_META_TAG_CMD_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_META_TAG_CMD_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_RS_META_TAG_SIG_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_META_TAG_SIG_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_RS_META_TAG_UPDATE_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_META_TAG_UPDATE_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_meta_tag_ref(xdrs, objp)
	XDR *xdrs;
	rs_meta_tag_ref *objp;
{
	if (!xdr_string(xdrs, &objp->chip_name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_RS_META_TAG_UNIT_TYPE(xdrs, &objp->dest_unit)) {
		return (FALSE);
	}
	if (!xdr_RS_META_TAG_CMD_TYPE(xdrs, &objp->cmd_type)) {
		return (FALSE);
	}
	if (!xdr_RS_META_TAG_SIG_TYPE(xdrs, &objp->sig_type)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->fbox_pc)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->fbox)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->ctx)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->fbox_to_be_signaled)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->ctx_to_be_signaled)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->word_cnt)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->ending_addr)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->rmw)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->creation_time)) {
		return (FALSE);
	}
	if (!xdr_RS_META_TAG_UPDATE_TYPE(xdrs, &objp->update_type)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->qin_cycle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->qout_cycle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->process_cycle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->signal_cycle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->wakeup_cycle)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_RS_CLK_TYPE(xdrs, objp)
	XDR *xdrs;
	RS_CLK_TYPE *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_statevalue(xdrs, objp)
	XDR *xdrs;
	statevalue *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, MAXBUFLEN, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_statedata(xdrs, objp)
	XDR *xdrs;
	statedata *objp;
{
	if (!xdr_int(xdrs, &objp->handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_varintarr(xdrs, objp)
	XDR *xdrs;
	varintarr *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->pdata.pdata_val, (u_int *)&objp->pdata.pdata_len, MAXBUFLEN, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_handle(xdrs, objp)
	XDR *xdrs;
	handle *objp;
{
	if (!xdr_string(xdrs, &objp->name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->array_index)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_wildcard_state(xdrs, objp)
	XDR *xdrs;
	wildcard_state *objp;
{
	if (!xdr_string(xdrs, &objp->rtn_name_buf, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->status)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_state_info(xdrs, objp)
	XDR *xdrs;
	state_info *objp;
{
	if (!xdr_string(xdrs, &objp->state_name, MAXBUFLEN)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->width)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->array_length)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_state_handle(xdrs, objp)
	XDR *xdrs;
	state_handle *objp;
{
	if (!xdr_u_int(xdrs, &objp->array_handle)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->array_index)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_set_array_state_value(xdrs, objp)
	XDR *xdrs;
	set_array_state_value *objp;
{
	if (!xdr_state_handle(xdrs, &objp->array_handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_set_state_value(xdrs, objp)
	XDR *xdrs;
	set_state_value *objp;
{
	if (!xdr_int(xdrs, &objp->state_handle)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->value.value_val, (u_int *)&objp->value.value_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_stat_str(xdrs, objp)
	XDR *xdrs;
	rs_stat_str *objp;
{
	if (!xdr_string(xdrs, &objp->name, ~0)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_get_bucket_data_IArg(xdrs, objp)
	XDR *xdrs;
	get_bucket_data_IArg *objp;
{
	if (!xdr_int(xdrs, &objp->stat_handle)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->bucket_index)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_get_bucket_data_OArg(xdrs, objp)
	XDR *xdrs;
	get_bucket_data_OArg *objp;
{
	if (!xdr_int(xdrs, &objp->num_bucket_samples)) {
		return (FALSE);
	}
	if (!xdr_rs_stat_str(xdrs, &objp->bucket_title)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_stat_char(xdrs, objp)
	XDR *xdrs;
	stat_char *objp;
{
	if (!xdr_int(xdrs, &objp->min_sample)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->max_sample)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->num_samples)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->sampled_sum)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->min_bucket_value)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->max_bucket_value)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->bucket_size)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->num_buckets)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->titled_buckets)) {
		return (FALSE);
	}
	if (!xdr_rs_stat_str(xdrs, &objp->stat_title)) {
		return (FALSE);
	}
	if (!xdr_rs_stat_str(xdrs, &objp->unit_specifier)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	return (TRUE);
}


