/* rs_ScMsg.h
 * Remote Services Debug Library - Serial communication definitions
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui 3/15/99
 * revisions:
 * $History: rs_ScMsg.h $
 * 
 * *****************  Version 26  *****************
 * User: Ewalker      Date: 9/29/00    Time: 12:28p
 * Updated in $/dev_1200/Share/rs_udebug
 * Changed default timeout from 15 to 5 seconds
 * 
 * *****************  Version 24  *****************
 * User: Ewalker      Date: 9/08/00    Time: 17:37
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 23  *****************
 * User: Ewalker      Date: 9/07/00    Time: 17:54
 * Updated in $/dev_1200/Share/rs_udebug
 * adjust scomm timeouts on target - RTC clock use is currently not right
 * 
 * *****************  Version 22  *****************
 * User: Ewalker      Date: 9/07/00    Time: 16:25
 * Updated in $/dev_1200/Share/rs_udebug
 * Decrease timeouts
 * 
 * *****************  Version 21  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:39
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 * *****************  Version 20  *****************
 * User: Ewalker      Date: 8/31/00    Time: 17:35
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 19  *****************
 * User: Ewalker      Date: 8/30/00    Time: 17:54
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 18  *****************
 * User: Ewalker      Date: 8/28/00    Time: 16:15
 * Updated in $/dev_1200/share/rs_udebug
 * Cleanup and added support for PCI debug connection
 * 
 * *****************  Version 17  *****************
 * User: Dmwhite      Date: 4/05/00    Time: 4:37p
 * Updated in $/dev_1200/Share/rs_udebug
 * took out some unwanted comments
 * 
 * *****************  Version 14  *****************
 * User: Lhui         Date: 10/22/99   Time: 2:33p
 * Updated in $/dev_1200/Share/rs_udebug
 * Fix a bug in GetMemSize function
 * 
 * *****************  Version 12  *****************
 * User: Lhui         Date: 7/16/99    Time: 4:15p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for uDbg_UpdateFreeUstore & uDbg_DefineFreeUstore
 * 
 * *****************  Version 10  *****************
 * User: Lhui         Date: 4/22/99    Time: 5:41p
 * Updated in $/development/rs_udebug
 * Add a delay parameter to  rs_udebug/control  hop functions. 
 * 
 * *****************  Version 9  *****************
 * User: Lhui         Date: 4/07/99    Time: 5:08p
 * Updated in $/development/rs_udebug
 * Fix bugs in rs_uDbg_GetUengPCs and rs_uDbg_InitLib 
 * 
 * *****************  Version 8  *****************
 * User: Hqianx       Date: 4/02/99    Time: 6:48p
 * Updated in $/development/rs_udebug
 * 
 * *****************  Version 7  *****************
 * User: Lhui         Date: 4/02/99    Time: 2:47p
 * Updated in $/development/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 6  *****************
 * User: Lhui         Date: 3/29/99    Time: 6:04p
 * Updated in $/development/rs_udebug
 * Add supports for debug control functions (start & hop)
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 3/23/99    Time: 6:37p
 * Updated in $/development/rs_udebug
 * Code cleanup and bug fixing
 * 
 * *****************  Version 4  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:48p
 * Updated in $/development/rs_udebug
 * update COPYRIGHT
 * 
 * *****************  Version 3  *****************
 * User: Qabuild      Date: 3/19/99    Time: 4:12p
 * Updated in $/development/rs_udebug
 * update makefile dependencies
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 3/19/99    Time: 1:17p
 * Updated in $/development/rs_udebug
 * Add supports for Scomm.lib
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 3/18/99    Time: 5:58p
 * Created in $/development/rs_udebug
 * Add supports for scomm.lib
 */ 
  
#ifndef RS_SCMSG_H
#define RS_SCMSG_H	

#include <string.h>

#include "scomm.h"
#include "rs_udebug.h"
#include "rs_uDbg_events.h"

#define Sc_CLIENT int

typedef bool_t (*RTN_T)();
typedef bool_t (*ARGRTN_T)(Sc_CLIENT *clnt, void *argp, int Flag);
typedef char   *(*LOCALRTN_T)(void *argp);
typedef char *(*LOCAL_FUNC)(void*);

enum Sc_PortSupport {
	HostComPort_1=0,
	HostComPort_2,
	TargetComPort_1,
	TargetComPort_2
};
	
enum Sc_msg_type {
	RS_FUNCTION=100,
	RS_REPLY,
	RS_DATA_COMPLETED
};

#ifdef _DEBUG
#define SCOMM_DEFAULT_TIMEOUT  (3600)       /* one hour */
enum ScommTimeouts { 
    ScommSendReplyTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvReplyTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendArgsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvArgsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendResultsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvResultsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommConnectTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendFunctionTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommInfiniteTimeout = 86400000  /* long very time */
};
#else
#define SCOMM_DEFAULT_TIMEOUT  (5)   /* 5 seconds */
enum ScommTimeouts { 
    ScommSendReplyTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvReplyTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendArgsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvArgsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendResultsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommRecvResultsTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommConnectTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommSendFunctionTimeout = SCOMM_DEFAULT_TIMEOUT,
    ScommInfiniteTimeout = 86400000  /* long very time */
};
#endif

struct Sc_Msg_T {
	int MsgType;
	union {
		unsigned int FunctionID;
		unsigned int Reply;
	}Arg; 
};

typedef struct Sc_Msg_T Sc_Msg_T;

#define CheckScommError(res) (res < 0)

#ifndef bzero 
#define bzero(addr, size) memset(addr, 0, size)
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Client support argument functions */

bool_t
Sc_Get_xdr_rs_uDbg_uEngStatus_T(Sc_CLIENT *clnt, rs_uDbg_uEngStatus_T *objp, int Flag);
bool_t
Sc_Get_xdr_rs_uDbg_GetuEngStatus_T(Sc_CLIENT *clnt, rs_uDbg_GetuEngStatus_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Handle_T(Sc_CLIENT *clnt, rs_uDbg_Handle_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Bkpt_T(Sc_CLIENT *clnt, rs_uDbg_Bkpt_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_BPoint_T(Sc_CLIENT *clnt, rs_uDbg_BPoint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_BreakPoint_T(Sc_CLIENT *clnt, rs_uDbg_BreakPoint_T *objp, int Flag);
bool_t
Sc_Get_xdr_int(Sc_CLIENT *clnt, void *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_uStoreFree_T(Sc_CLIENT *clnt, rs_uDbg_uStoreFree_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_One_uint_T(Sc_CLIENT *clnt, rs_uDbg_One_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Two_uint_T(Sc_CLIENT *clnt, rs_uDbg_Two_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Three_uint_T(Sc_CLIENT *clnt, rs_uDbg_Three_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Mem_T(Sc_CLIENT *clnt, rs_uDbg_Mem_T *objp, int Flag);
bool_t
sc_xdr_wrapstring(Sc_CLIENT *clnt, char *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_CSR_T(Sc_CLIENT *clnt, rs_uDbg_CSR_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Reg_T(Sc_CLIENT *clnt, rs_uDbg_Reg_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_GetThPC_T(Sc_CLIENT *clnt, rs_uDbg_GetThPC_T *objp, int Flag);
bool_t
Sc_Get_xdr_rs_uDbg_ShowBreakpts_T(Sc_CLIENT *clnt, rs_uDbg_ShowBreakpts_T *objp, int Flag);
bool_t
Sc_Get_xdr_rs_uDbg_Status_T(Sc_CLIENT *clnt, rs_uDbg_Status_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_uWord_T(Sc_CLIENT *clnt, rs_uDbg_uWord_T *objp, int Flag);
bool_t
Sc_xdr_rs_CNTL_InitUof_T(Sc_CLIENT *clnt, rs_CNTL_InitUof_T *objp, int Flag);
bool_t
Sc_xdr_rs_string_T(Sc_CLIENT *clnt, rs_string_T *objp, int Flag);
bool_t 
Sc_Get_xdr_rs_uDbg_GetMemSize_T(Sc_CLIENT *clnt,rs_uDbg_GetMemSize_T *obp, int Flag);
bool_t
Sc_xdr_rs_uDbg_FiFo_T(Sc_CLIENT *clnt, rs_uDbg_FiFo_T *objp, int Flag);

/* Server support argument functions */

bool_t
Sc_xdr_rs_uDbg_uEngStatus_SetRes_T(Sc_CLIENT *clnt, rs_uDbg_uEngStatus_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_GetuEngStatus_SetRes_T(Sc_CLIENT *clnt, rs_uDbg_GetuEngStatus_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Handle_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Handle_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Bkpt_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Bkpt_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_BPoint_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_BPoint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_BreakPoint_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_BreakPoint_T *objp, int Flag);
bool_t
Sc_xdr_SetRes_int(Sc_CLIENT *clnt, unsigned int *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_uStoreFree_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_uStoreFree_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_One_uint_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_One_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Two_uint_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Two_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Three_uint_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Three_uint_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_uWord_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_uWord_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Mem_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Mem_T *objp, int Flag);
bool_t
sc_xdr_GetArg_wrapstring(Sc_CLIENT *clnt, char *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_CSR_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_CSR_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Reg_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Reg_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_GetThPC_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_GetThPC_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_ShowBreakpts_SetRes_T(Sc_CLIENT *clnt, rs_uDbg_ShowBreakpts_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Status_SetRes_T(Sc_CLIENT *clnt, rs_uDbg_Status_T *objp, int Flag);
bool_t
Sc_xdr_rs_CNTL_InitUof_GetArg_T(Sc_CLIENT *clnt, rs_CNTL_InitUof_T *objp, int Flag);
bool_t
Sc_xdr_rs_string_GetArg_T(Sc_CLIENT *clnt, rs_string_T *objp, int Flag);
bool_t
Sc_xdr_rs_uDbg_Bkpt_CK_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_Bkpt_CK_T *objp,int Flag);
bool_t
Sc_xdr_rs_uDbg_Bkpt_CK_T(Sc_CLIENT *clnt, void *objp, int Flag);
bool_t 
Sc_xdr_rs_uDbg_GetMemSize_SetRes_T(Sc_CLIENT *clnt,rs_uDbg_GetMemSize_T *obp, int Flag);
bool_t
Sc_xdr_rs_uDbg_FiFo_GetArg_T(Sc_CLIENT *clnt, rs_uDbg_FiFo_T *objp, int Flag);

/* Client functions */

int *rs_udbg_initlib_sc(rs_uDbg_uStoreFree_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_delelib_sc(rs_uDbg_Handle_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_resetueng_sc(rs_uDbg_Two_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_startueng_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_pauseueng_sc(rs_uDbg_Two_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_resumeueng_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_isuengactive_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_getactiveuengs_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuthreadpc_sc(rs_uDbg_GetThPC_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_setuthreadspc_sc(rs_uDbg_Three_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_setuengpc_sc(rs_uDbg_Mem_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuengpc_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuword_sc(rs_uDbg_uWord_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_setuword_sc(rs_uDbg_uWord_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getnumuword_sc(rs_uDbg_uWord_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_setnumuword_sc(rs_uDbg_uWord_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_writemem32_sc(rs_uDbg_Mem_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readmem32_sc(rs_uDbg_Mem_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_writemem64_sc(rs_uDbg_Mem_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readmem64_sc(rs_uDbg_Mem_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_setbreakpoint_sc(rs_uDbg_BreakPoint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_ShowBreakpts_T *rs_udbg_showbreakpoints_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_clearallbreakpoints_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_clearbreakpoint_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getcsr_sc(rs_uDbg_CSR_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_setcsr_sc(rs_uDbg_CSR_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_putrelgpr_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelgpr_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_putrelsram_wrxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_putrelsdram_wrxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_putrelsram_rdxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_putrelsdram_rdxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsram_wrxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsdram_wrxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsram_rdxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsdram_rdxfer_sc(rs_uDbg_Reg_T *argp, Sc_CLIENT *clnt);
rs_uDbg_GetuEngStatus_T *rs_udbg_getuengstatus_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_hopueng_sc(rs_uDbg_Two_uint_T *argp, Sc_CLIENT *clnt);
int *rs_xact_command_sc(rs_string_T *argp, Sc_CLIENT *clnt);
int *rs_cntl_inituof_sc(rs_CNTL_InitUof_T *argp, Sc_CLIENT *clnt);
int *rs_cntl_reset_sc(rs_uDbg_Three_uint_T *argp, Sc_CLIENT *clnt);
int *rs_cntl_pause_sc(rs_uDbg_Three_uint_T *argp, Sc_CLIENT *clnt);
int *rs_cntl_resume_sc(rs_uDbg_Two_uint_T *argp, Sc_CLIENT *clnt);
int *rs_cntl_start_sc(rs_uDbg_Two_uint_T *argp, Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_cntl_hop_sc(rs_uDbg_Three_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_clrresetueng_sc(rs_uDbg_One_uint_T *argp,Sc_CLIENT *clnt);
int *rs_udbg_definefreeustore_sc(rs_uDbg_Three_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_updatefreeustore_sc(rs_uDbg_One_uint_T *argp, Sc_CLIENT *clnt);
int *rs_udbg_writefifo_tx_sc(rs_uDbg_FiFo_T *argp,Sc_CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readfifo_rx_sc(rs_uDbg_FiFo_T *argp,Sc_CLIENT *clnt);
rs_uDbg_GetMemSize_T *rs_udbg_getsysmemsize_sc(rs_uDbg_Handle_T *argp, Sc_CLIENT *clnt);

/* Client callback (event) functions */

int *rs_udbg_bkpt_ck_sc(rs_uDbg_Bkpt_CK_T *argp, Sc_CLIENT *clnt);


#ifdef __cplusplus
}
#endif

#endif      /* RS_SCMSG_H */

