/* rs_uDbg_events.h
 * Remote Services Debug Library - Callback (event) definitions
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui
 * revisions:
 * $History: rs_uDbg_events.h $
 * 
 * *****************  Version 15  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:40
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 */ 

#ifndef RS_UDBG_EVENTS_H
#define RS_UDBG_EVENTS_H

#include "ostype.h"
#include "rs_udbg_status.h"

#if (OS == WIN_32)
#include <OncRpc32.h>
#include <pmap_clnt.h>
#else   /* not WIN_32 */
#if (OS != UCOS)
#include <rpc/rpc.h>
#else   /* UCOS only */
#define u_int32 unsigned int
#define	bool_t	int
#define u_char unsigned char 
#define u_int unsigned int
#define u_short unsigned short
#define u_long unsigned int
#ifndef FALSE
#define FALSE (0)
#define TRUE  (1)
#endif
#endif  /* UCOS only */
#endif  /* not WIN_32 */

#if (OS != UCOS)
#define uDbg_CALLBK ((u_long)1692)
#ifndef SA1200VERSION
#define SA1200VERSION ((u_long)1)
#endif
#endif

struct rs_uDbg_Bkpt_CK_T {
	u_short bkptId;
	u_char ueng;
	u_char ctx;
	u_int usrData;
};
typedef struct rs_uDbg_Bkpt_CK_T rs_uDbg_Bkpt_CK_T;
bool_t xdr_rs_uDbg_Bkpt_CK_T();


/* Client/Server function identifiers */

#define RS_uDbg_Bkpt_CK ((u_long)1)

#endif      /* RS_UDBG_EVENTS_H */
