/* rs_uDbg_events_xdr.c
 * Remote Services Debug Library - RPC callback (event) argument packaging
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui
 * revisions:
 * $History: rs_uDbg_events_xdr.c $
 * 
 * *****************  Version 9  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:40
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 */ 

#include <stdio.h>

#include "rs_uDbg_events.h"

static const char __copyright[] =
"Copyright Intel Corp, 1998-2000. All rights reserved";

bool_t
xdr_rs_uDbg_Bkpt_CK_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Bkpt_CK_T *objp;
{
	if (!xdr_u_short(xdrs, &objp->bkptId)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->ueng)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->ctx)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->usrData)) {
		return (FALSE);
	}
	return (TRUE);
}


