/* rs_udbg.h
 * Remote Services Debug Library - Remote Debug base class definitions
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: Remote Services Debug Library
 *  author: lwh, 12/2/98  Initial version
 *  revisions:
 *  $History: rs_udbg.h $
 * 
 * *****************  Version 36  *****************
 * User: Ewalker      Date: 11/30/00   Time: 7:06p
 * Updated in $/dev_1200/share/rs_udebug
 * Trying to allow multiple concurrent hardware connections. Not there
 * yet.
 * 
 * *****************  Version 35  *****************
 * User: Ewalker      Date: 11/28/00   Time: 3:40p
 * Updated in $/dev_1200/share/rs_udebug
 * Elimintated unused class members
 * 
 * *****************  Version 33  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:40
 * Updated in $/dev_1200/share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 * *****************  Version 32  *****************
 * User: Ewalker      Date: 8/28/00    Time: 16:15
 * Updated in $/dev_1200/share/rs_udebug
 * Cleanup and added support for PCI debug connection
 * 
 * *****************  Version 31  *****************
 * User: Ewalker      Date: 8/07/00    Time: 9:39
 * Updated in $/dev_1200/Share/rs_udebug
 * Eliminated compile time bzero and bcopy macro redefinition warnings by
 * including host.h prior to oncrpc32.h.
 * 
 * *****************  Version 30  *****************
 * User: Dmwhite      Date: 4/05/00    Time: 4:37p
 * Updated in $/dev_1200/Share/rs_udebug
 * took out some unwanted comments
 * 
 * *****************  Version 27  *****************
 * User: Lhui         Date: 1/27/00    Time: 4:18p
 * Updated in $/dev_1200/Share/rs_udebug
 * Rewrite CNTL_InitUof_T function to allow sending multiple packets to
 * SCOMM
 * 
 * *****************  Version 25  *****************
 * User: Lhui         Date: 1/12/00    Time: 4:14p
 * Updated in $/Beta4_Interim/Share/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 24  *****************
 * User: Lhui         Date: 1/06/00    Time: 6:07p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for VxWorks serial port 
 * 
 * *****************  Version 23  *****************
 * User: Lhui         Date: 10/19/99   Time: 5:19p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for uDbg_GetSysMemSize()
 * 
 * *****************  Version 22  *****************
 * User: Lhui         Date: 10/06/99   Time: 4:21p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for new fifo read/write functions
 * 
 * *****************  Version 21  *****************
 * User: Lhui         Date: 10/04/99   Time: 4:42p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for the new dbg_reset prototype
 * 
 * *****************  Version 19  *****************
 * User: Lhui         Date: 7/23/99    Time: 8:31p
 * Updated in $/dev_1200/Share/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 18  *****************
 * User: Lhui         Date: 7/16/99    Time: 4:15p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for uDbg_UpdateFreeUstore & uDbg_DefineFreeUstore
 * 
 * *****************  Version 16  *****************
 * User: Lhui         Date: 6/29/99    Time: 7:17p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for uDbg_ClrReset
 * 
 * *****************  Version 15  *****************
 * User: Lhui         Date: 6/18/99    Time: 6:27p
 * Updated in $/dev_1200/Share/rs_udebug
 * Update Control API
 * 
 * *****************  Version 13  *****************
 * User: Qabuild      Date: 4/29/99    Time: 1:49p
 * Updated in $/dev_1200/Share/rs_udebug
 * Update
 * 
 * *****************  Version 12  *****************
 * User: Lhui         Date: 4/22/99    Time: 5:41p
 * Updated in $/development/rs_udebug
 * Add a delay parameter to  rs_udebug/control  hop functions. 
 * 
 * *****************  Version 11  *****************
 * User: Lhui         Date: 4/08/99    Time: 5:51p
 * Updated in $/development/rs_udebug
 * Change rs_cntl_pause prototypes
 * 
 * *****************  Version 10  *****************
 * User: Lhui         Date: 4/07/99    Time: 5:08p
 * Updated in $/development/rs_udebug
 * Fix bugs in rs_uDbg_GetUengPCs and rs_uDbg_InitLib 
 * 
 * *****************  Version 9  *****************
 * User: Lhui         Date: 3/29/99    Time: 6:04p
 * Updated in $/development/rs_udebug
 * Add supports for debug control functions (start & hop)
 * 
 * *****************  Version 8  *****************
 * User: Lhui         Date: 3/23/99    Time: 6:37p
 * Updated in $/development/rs_udebug
 * Code cleanup and bug fixing
 * 
 * *****************  Version 7  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 3:48p
 * Updated in $/development/rs_udebug
 * update COPYRIGHT
 * 
 * *****************  Version 6  *****************
 * User: Qabuild      Date: 3/19/99    Time: 4:12p
 * Updated in $/development/rs_udebug
 * update makefile dependencies
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 3/19/99    Time: 1:17p
 * Updated in $/development/rs_udebug
 * Add supports for Scomm.lib
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 3/18/99    Time: 5:48p
 * Updated in $/development/rs_udebug
 * Add supports for SA1200 debug control functions
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 3/12/99    Time: 2:04p
 * Created in $/development/rs_udebug
 */ 
#ifndef RS_UDBG_H
#define RS_UDBG_H

#include "utils.h"
#include "debug_1200.h"
#include "rs_udbg_status.h"


typedef struct {
	 void (*callback) (unsigned short bkptId, unsigned char ueng, unsigned char ctx, void *usrData);
	}BreakP_CK_T;

#ifdef __cplusplus
class RS_Debug{
public:
	RS_Debug(int config);
	~RS_Debug();
	virtual int ResetUeng(unsigned int uEngMask, int clrReg)=0;
	virtual int UpdateFreeUstore(unsigned int uEngMask)=0;
    virtual int DefineFreeUstore(unsigned int uEngMask, unsigned int freeUaddr, unsigned int freeSize)=0;
	virtual int ClrResetUeng(unsigned int uEngMask)=0;
	virtual int StartUeng(unsigned int uEngMask)=0;
	virtual int PauseUeng(unsigned int uEngMask, unsigned int delay)=0;
	virtual int ResumeUeng(unsigned int uEngMask)=0;
	virtual int GetActiveUengs(unsigned int uEngMask)=0;
	virtual int GetUthreadPC(unsigned char uEng, unsigned char ctx, unsigned int *upc)=0;
	virtual int SetUthreadsPC(unsigned int uEngMask, unsigned int ctxMask, unsigned int upc)=0;
	virtual int SetUengPCs(unsigned char uEng, unsigned int *upc)=0;
	virtual int GetUengPCs(unsigned char uEng, unsigned int *upc)=0;
	virtual int IsUengActive(unsigned int uEngMask)=0;
	virtual int GetUword(unsigned char uEng, unsigned int uWordAddr, unsigned int *uWord)=0;
	virtual int SetUword(unsigned int uEngMask, unsigned int uWordAddr, unsigned int uWord)=0;
	virtual int GetNumUword(unsigned char uEng, unsigned int uWordAddr, unsigned short numWords,unsigned int *uWord)=0;
	virtual int SetNumUword(unsigned int uEngMask, unsigned int uWordAddr, unsigned short numWords, unsigned int *uWord)=0;
	virtual int GetCSR(unsigned int csrAddr, unsigned int *csrData)=0;
	virtual int SetCSR(unsigned int csrAddr, unsigned int csrData)=0;
	virtual int SetBreakpoint(uDbg_Bkpt_T *breakpoint)=0;
	virtual int ShowBreakpoints(unsigned int uEngMask, uDbg_BkptArray_T *breakpoints)=0;
	virtual int ClearAllBreakpoints(unsigned int uEngMask)=0;
	virtual int ClearBreakpoint(short breakPointId)=0;
	virtual int WriteMem32(unsigned int addr, unsigned int *data, unsigned count)=0;
	virtual int ReadMem32(unsigned int addr, unsigned int *data, unsigned count)=0;
	virtual int WriteMem64(unsigned int addr, unsigned int *data, unsigned count)=0;
	virtual int ReadMem64(unsigned int addr, unsigned int *data, unsigned count)=0;
	virtual int PutRelGPR(unsigned char uEng, unsigned char ctx, uDbg_Bank_T bankType,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int GetRelGPR(unsigned char uEng, unsigned char ctx, uDbg_Bank_T bankType,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int GetRelSRAM_RdXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int PutRelSRAM_RdXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int GetRelSRAM_WrXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int PutRelSRAM_WrXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int GetRelSDRAM_RdXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int PutRelSDRAM_RdXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int PutRelSDRAM_WrXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int GetRelSDRAM_WrXfer(unsigned char uEng, unsigned char ctx,
			  unsigned int regNum, unsigned int *regData, unsigned count)=0;
	virtual int HopUeng(unsigned int *uEngMask, unsigned int delay)=0;
	virtual int GetUengStatus(unsigned char uEng, uDbg_uEngStatus_T *uEngStatus)=0;
	virtual int WriteFIFO_Tx(unsigned char uEng, unsigned int fifoAddr,unsigned int *regData, unsigned int count, int setValid)=0;
	virtual int ReadFIFO_Rx(unsigned char uEng, unsigned int fifoAddr, unsigned int *regData, unsigned int count)=0;
	virtual int GetSysMemSize(unsigned int* sys, unsigned int* sys_all, unsigned int* sdram,
				 unsigned int* sram,unsigned int* flash)=0;
	virtual int CNTL_InitUof(char* buf, int buflen)=0;
	virtual int CNTL_Reset(unsigned int uEngMask,unsigned int PortMask, int clrReg)=0;
	virtual int CNTL_Hop(unsigned int *uEngMask, unsigned int PortMask, unsigned int delay)=0;

	virtual int CNTL_Pause(unsigned int uEngMask, unsigned int PortMask, unsigned int delay)=0;
	virtual int CNTL_Resume(unsigned int uEngMask,unsigned int PortMask)=0;
	virtual int CNTL_Start(unsigned int uEngMask,unsigned int PortMask)=0; 

    int GetuDbg_Handle()	const {return uDbg_Handle_svr;};
	void SetuDbg_Handle(const int huDbg) {uDbg_Handle_svr = huDbg;};

    int IsValid()	const {return Valid;};
	void SetValid(int val)	{Valid = val;};

    int CheckStatus(int *result)  
	   {
	   Status = RS_SUCCESS;
	   if (result == NULL)
	   /* An error occurred while calling the server. */
		   Status = RS_TIMEOUT;
	   return Status;
	};
	int GetStatus()	 const {return Status;};

    /* break callback functions */
	void SetCkRtn(const int id, void (ckRtn)(unsigned short bkptId, unsigned char ueng, unsigned char ctx, void *usrData))
	{
        if (id >= 0 && id < UDBG_MAX_BREAKPOINTS)
            bkCkPts[id].callback = ckRtn;
    };
	BreakP_CK_T *GetCkRtn(const int id)	
    {
        if (id < 0 || id >= UDBG_MAX_BREAKPOINTS) return NULL;
        if (bkCkPts[id].callback == NULL) return NULL;
        return &bkCkPts[id];
    };

    int GetConfig()	{return config;};

    void data_copy(unsigned int *dest, unsigned int *src, unsigned int cnt)
	{
		unsigned int *s = src, i;
		unsigned int *d = dest;
		for(i=0; i<cnt; i++, d++, s++)
			*d = *s;
	};

    thread_T GetBKThreadID() {return bkPtThreadId;};
	void SetBKThreadID(thread_T bkID) {bkPtThreadId=bkID;};

    void SetMyTarget(void *pTarget)	{myTarget = pTarget;};
    void *GetMyTarget() {return myTarget;};

protected:
    int bkPtThread_shutdown_flag;

private:
   BreakP_CK_T bkCkPts[UDBG_MAX_BREAKPOINTS];
   int uDbg_Handle_svr;
   thread_T  bkPtThreadId;
   int	  Valid;			 
   int	  Status;
   int    config;
   void   *myTarget;
};

#endif          /* __cplusplus */
#endif			/* RS_UDBG_H */
