/* rs_udbg_main.cpp
 * Remote Services Debug Library - Test program
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug library
 * author: Lai-Wah Hui 12/2/98
 * revisions:
 * $History: rs_udbg_main.cpp $
 * 
 * *****************  Version 45  *****************
 * User: Ewalker      Date: 12/11/00   Time: 12:20p
 * Updated in $/dev_1200/Share/rs_udebug
 * Pause just before deleting library
 * 
 * *****************  Version 44  *****************
 * User: Ewalker      Date: 12/11/00   Time: 11:34a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added pause and clrreset so that program can be rerun more reliably
 * 
 * *****************  Version 43  *****************
 * User: Ewalker      Date: 12/11/00   Time: 10:50a
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 42  *****************
 * User: Ewalker      Date: 11/30/00   Time: 6:42p
 * Updated in $/dev_1200/Share/rs_udebug
 * Count repetitions.
 * 
 * *****************  Version 41  *****************
 * User: Ewalker      Date: 11/02/00   Time: 9:03a
 * Updated in $/dev_1200/Share/rs_udebug
 * Fixed SCR/Bug #1222. The serial form of rs_udbg_resetueng was crashing
 * the  target. A typographical error present since pre-V1.0 was
 * corrected.
 * 
 * *****************  Version 40  *****************
 * User: Ewalker      Date: 10/31/00   Time: 11:53a
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 39  *****************
 * User: Ewalker      Date: 10/31/00   Time: 11:44a
 * Updated in $/dev_1200/Share/rs_udebug
 * Free ustore changes for C0
 * 
 * *****************  Version 38  *****************
 * User: Ewalker      Date: 10/30/00   Time: 11:49a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added some tests and cleaned up some logging 
 * 
 * *****************  Version 36  *****************
 * User: Ewalker      Date: 9/20/00    Time: 8:01a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added performance/throughput test to test cases
 * 
 * *****************  Version 35  *****************
 * User: Ewalker      Date: 9/07/00    Time: 16:25
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 34  *****************
 * User: Ewalker      Date: 9/07/00    Time: 13:55
 * Updated in $/dev_1200/Share/rs_udebug
 * Changed embedded uof data
 * 
 * *****************  Version 33  *****************
 * User: Ewalker      Date: 9/05/00    Time: 16:34
 * Updated in $/dev_1200/Share/rs_udebug
 * Cleanup
 * 
 * *****************  Version 32  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:40
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 * *****************  Version 31  *****************
 * User: Ewalker      Date: 8/31/00    Time: 17:36
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 30  *****************
 * User: Ewalker      Date: 8/29/00    Time: 17:43
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 29  *****************
 * User: Ewalker      Date: 8/28/00    Time: 16:16
 * Updated in $/dev_1200/Share/rs_udebug
 * Cleanup and added support for PCI debug connection
 * 
 * *****************  Version 27  *****************
 * User: Lhui         Date: 1/27/00    Time: 4:18p
 * Updated in $/dev_1200/Share/rs_udebug
 * Rewrite CNTL_InitUof_T function to allow sending multiple packets to
 * SCOMM
 * 
 * *****************  Version 27  *****************
 * User: Lhui         Date: 1/26/00    Time: 6:02p
 * Updated in $/Beta4_Interim/Share/rs_udebug
 * Fix the build errors
 * 
 * *****************  Version 26  *****************
 * User: Lhui         Date: 1/17/00    Time: 10:46a
 * Updated in $/Beta4_Interim/Share/rs_udebug
 * 
 * *****************  Version 26  *****************
 * User: Lhui         Date: 1/17/00    Time: 10:45a
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 24  *****************
 * User: Lhui         Date: 1/06/00    Time: 6:15p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for VxWorks serial port
 * 
 * *****************  Version 22  *****************
 * User: Drjohns1     Date: 7/22/99    Time: 4:00p
 * Updated in $/dev_1200/Share/rs_udebug
 * Removed sdram-write from uof -- dangerous if export-var is not bind
 * 
 * *****************  Version 21  *****************
 * User: Lhui         Date: 7/16/99    Time: 4:15p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add support for uDbg_UpdateFreeUstore & uDbg_DefineFreeUstore
 * 
 * *****************  Version 20  *****************
 * User: Lhui         Date: 6/29/99    Time: 9:06p
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 19  *****************
 * User: Lhui         Date: 6/28/99    Time: 7:33p
 * Updated in $/dev_1200/Share/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 18  *****************
 * User: Lhui         Date: 6/25/99    Time: 7:40p
 * Updated in $/dev_1200/Share/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 17  *****************
 * User: Lhui         Date: 6/23/99    Time: 5:12p
 * Updated in $/dev_1200/Share/rs_udebug
 * Add hardware test cases
 * 
 * *****************  Version 12  *****************
 * User: Lhui         Date: 4/22/99    Time: 5:40p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add a delay parameter to  rs_udebug/control  hop functions. 
 * 
 * *****************  Version 11  *****************
 * User: Lhui         Date: 4/22/99    Time: 5:38p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add a delay parameter to  rs_udebug/control  hop functions. 
 * 
 * *****************  Version 10  *****************
 * User: Lhui         Date: 4/07/99    Time: 5:10p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add test cases for uDbg_InitLib and uDbg_GetUengPC
 * 
 * *****************  Version 9  *****************
 * User: Lhui         Date: 4/01/99    Time: 6:25p
 * Updated in $/development/qa-test/rsdbg_tests
 * Fix bugs
 * 
 * *****************  Version 8  *****************
 * User: Lhui         Date: 3/29/99    Time: 6:07p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add test cases
 * 
 * *****************  Version 7  *****************
 * User: Qabuild      Date: 3/22/99    Time: 11:57a
 * Updated in $/development/qa-test/rsdbg_tests
 * 
 * *****************  Version 6  *****************
 * User: Qabuild      Date: 3/22/99    Time: 11:19a
 * Updated in $/development/qa-test/rsdbg_tests
 * Updated debug.h to debug_1200.h
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 3/19/99    Time: 1:21p
 * Updated in $/development/qa-test/rsdbg_tests
 * Update for the new debug SA1200 path
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 3/18/99    Time: 5:52p
 * Updated in $/development/qa-test/rsdbg_tests
 * change "udbg_lib.h" to "debug.h"
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 3/15/99    Time: 12:07p
 * Updated in $/development/qa-test/rsdbg_tests
 * Link with rs_udbg_client_dll
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 3/09/99    Time: 6:23p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add test cases
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <assert.h>
#include "debug_1200.h"
#include "rs_udbg_lib.h"
#include "rs_udbg_test.h"
#include "rs_connection.h"

#if 0
#ifdef _DEBUG
#include <crtdbg.h>
#endif
#endif

static const char __copyright[] =
"Copyright Intel Corp, 1998-2000. All rights reserved";

char Rs_TargetName[100];
uDbg_uStoreFree_T freeU;
unsigned int *HexUof;
unsigned int HexUofSize;
   unsigned int HexUof__cliptest[] = {
      0xc6c2,0xc3cc,0x20002,0x5f464f55,0x534a424f,0x82b0,0x34,0x418,0x5f474244,0x534a424f,
      0x14e3,0x44c,0xb6c,0xffffffff,0xf0000,0x9000a,0x0,0x0,0x5f464f55,0x44495447,
      0xb4,0x14,0x5f464f55,0x54525453,0xc8,0x28,0x5f464f55,0x4745534d,0xf0,0x1c,
      0x5f464f55,0x47414d49,0x10c,0x78,0x5f464f55,0x47414d49,0x184,0x7c,0x5f464f55,0x47414d49,
      0x200,0x80,0x5f464f55,0x47414d49,0x280,0x84,0x5f464f55,0x47414d49,0x304,0x88,
      0x5f464f55,0x47414d49,0x38c,0x8c,0xcd29e4,0xcd29e4,0x0,0x0,0x646c6355,0x20202020,
      0xb,0x0,0x0,0x24,0x70696c63,0x6c630035,0x347069,0x70696c63,0x6c630033,0x327069,
      0x70696c63,0x6c630031,0x307069,0x1,0x1,0x0,0x0,0x0,0x0,0x0,
      0x1e,0xe00c0004,0x0,0x0,0xffffffff,0xf,0x1001,0x10000,0x340004,0x40004,
      0x178,0x17c,0x144,0x180,0xb,0x0,0xf0000187,0xe00c0104,0xf8000087,0xd8000000,
      0xda000000,0xd8200000,0xe00c0104,0xbe,0x2200102e,0x2010be,0xf8000307,0x0,0x0,0x0,
      0x18,0xe00c0004,0x0,0x0,0xffffffff,0xf,0x1002,0x10000,0x380004,0x40004,
      0x1f4,0x1f8,0x1bc,0x1fc,0xc,0x0,0xf0000187,0xe00c0104,0xf8000087,0xd8000000,
      0xda000000,0xd8200000,0xe00c0104,0xbe,0x2200102e,0x2010be,0xde000000,0xf8000307,0x0,0x0,
      0x0,0x12,0xe00c0004,0x0,0x0,0xffffffff,0xf,0x1004,0x10000,0x3c0004,
      0x40004,0x274,0x278,0x238,0x27c,0xd,0x0,0xf0000187,0xe00c0104,0xf8000087,
      0xd8000000,0xda000000,0xd8200000,0xe00c0104,0xbe,0x2200102e,0x2010be,0xde000000,0xde000000,0xf8000307,
      0x0,0x0,0x0,0xc,0xe00c0004,0x0,0x0,0xffffffff,0xf,0x1008,
      0x10000,0x400004,0x40004,0x2f8,0x2fc,0x2b8,0x300,0xe,0x0,0xf0000187,
      0xe00c0104,0xf8000087,0xd8000000,0xda000000,0xd8200000,0xe00c0104,0xbe,0x2200102e,0x2010be,0xde000000,
      0xde000000,0xde000000,0xf8000307,0x0,0x0,0x0,0x6,0xe00c0004,0x0,0x0,
      0xffffffff,0xf,0x1010,0x10000,0x440004,0x40004,0x380,0x384,0x33c,0x388,
      0xf,0x0,0xf0000187,0xe00c0104,0xf8000087,0xd8000000,0xda000000,0xd8200000,0xe00c0104,0xbe,
      0x2200102e,0x2010be,0xde000000,0xde000000,0xde000000,0xde000000,0xf8000307,0x0,0x0,0x0,
      0x0,0xe00c0004,0x0,0x0,0xffffffff,0xf,0x1020,0x10000,0x480004,0x40004,
      0x40c,0x410,0x3c4,0x414,0x10,0x0,0xf0000187,0xe00c0104,0xf8000087,0xd8000000,
      0xda000000,0xd8200000,0xe00c0104,0xbe,0x2200102e,0x2010be,0xde000000,0xde000000,0xde000000,0xde000000,
      0xde000000,0xf8000307,0x0,0x0,0x0,0xd05030,0xd050e0,0x70007,0x0,0x0,
      0x5f474244,0x54525453,0x84,0x2be,0x5f474244,0x47414d49,0x344,0x134,0x5f474244,0x47414d49,
      0x478,0x144,0x5f474244,0x47414d49,0x5bc,0x154,0x5f474244,0x47414d49,0x710,0x164,
      0x5f474244,0x47414d49,0x874,0x174,0x5f474244,0x47414d49,0x9e8,0x184,0x2ba,0x72617473,
      0xa3a2374,0x61747300,0x237472,0x72003272,0x30720031,0x6f6f6c00,0xa3a2370,0x6f6f6c00,0x6b002370,0x5f6c6c69,
      0x706f6f6c,0xa3a23,0x6c6c696b,0x6f6f6c5f,0x46002370,0x73755c3a,0x65726f74,0x7365745f,0x635c7374,0x7470696c,
      0x5c747365,0x70696c63,0x63752e35,0x5c3a4600,0x6f747375,0x745f6572,0x73747365,0x696c635c,0x73657470,0x6c635c74,
      0x2e347069,0x46006375,0x73755c3a,0x65726f74,0x7365745f,0x635c7374,0x7470696c,0x5c747365,0x70696c63,0x63752e33,
      0x5c3a4600,0x6f747375,0x745f6572,0x73747365,0x696c635c,0x73657470,0x6c635c74,0x2e327069,0x46006375,0x73755c3a,
      0x65726f74,0x7365745f,0x635c7374,0x7470696c,0x5c747365,0x70696c63,0x63752e31,0x5c3a4600,0x6f747375,0x745f6572,
      0x73747365,0x696c635c,0x73657470,0x6c635c74,0x2e307069,0x3b006375,0x44203b0a,0x6e6f6d65,0x61727473,0x74206574,
      0x20746168,0x20656874,0x7473616c,0x64646f20,0x6f777520,0x69206472,0x6c632073,0x65707069,0x72652064,0x656e6f72,
      0x6c73756f,0x75642079,0x676e6972,0x65687420,0x75203b0a,0x726f7473,0x6f6c2065,0x3b0a6461,0x7262090a,0x7874633d,
      0x202c305b,0x72617473,0xa5d2374,0x635c2e00,0x3570696c,0x73696c2e,0x5c2e0074,0x70696c63,0x696c2e34,0x2e007473,
      0x696c635c,0x6c2e3370,0x747369,0x6c635c2e,0x2e327069,0x7473696c,0x635c2e00,0x3170696c,0x73696c2e,0x5c2e0074,
      0x70696c63,0x696c2e30,0x20007473,0x69202020,0x64656d6d,0x2c32725b,0x30783020,0x20000a5d,0x69202020,0x64656d6d,
      0x2c31725b,0x30783020,0x20000a5d,0x69202020,0x64656d6d,0x2c30725b,0x30783020,0x20000a5d,0x63202020,0x615f7874,
      0x765b6272,0x6e756c6f,0x79726174,0x20000a5d,0x62202020,0x6f6c5b72,0x5d23706f,0x2020000a,0x6c612020,0x68735f75,
      0x69725f66,0x31725b5f,0x3172202c,0x2c2b202c,0x202c3120,0xa5d30,0x20202020,0x5f756c61,0x5f666873,0x725b6972,
      0x72202c32,0x2b202c32,0x2c31202c,0xa5d3020,0x20202000,0x756c6120,0x6668735f,0x5b69725f,0x202c3072,0x202c3072,
      0x31202c2b,0x5d30202c,0x6e09000a,0xa706f,0x78746309,0x6272615f,0x6c6f765b,0x61746e75,0xa5d7972,0x72620900,
      0x6c696b5b,0x6f6c5f6c,0x5d23706f,0xa,0x1ba,0x1c0001,0xe4001c,0x35c,0x378,0x394,
      0x78030003,0x13,0xd00001,0x10,0xc10000,0x16,0xc00000,0x78030003,0x34,0x78030001,
      0x21,0x78030006,0x9,0x78030003,0x7803000e,0xe9,0x10b,0x6,0x78030001,0xe9,
      0x27,0x10008,0x78030001,0xe9,0x294,0x10009,0x78030001,0xe9,0x2a9,0x2000a,
      0x78030001,0xe9,0x0,0x3000c,0x78030001,0xe9,0x1ef,0x3000d,0x78030001,0xe9,
      0x1db,0x4000e,0x78030001,0xe9,0x1c7,0x5000f,0x78030001,0xe9,0x19,0x60011,
      0x78030001,0xe9,0x203,0x60012,0x78030001,0xe9,0x26d,0x70013,0x78030001,0xe9,
      0x22a,0x80014,0x78030001,0xe9,0x24c,0x90015,0x78030001,0xe9,0x21b,0xa0016,
      0x78030001,0x1ad,0x1c0002,0xf4001c,0x490,0x4ac,0x4c8,0x78030003,0x13,0xd00001,
      0x10,0xc10000,0x16,0xc00000,0x78030003,0x34,0x78030001,0x21,0x78030006,0x9,
      0x78030003,0x7803000f,0xc7,0x10b,0x6,0x78030001,0xc7,0x27,0x10008,0x78030001,
      0xc7,0x294,0x10009,0x78030001,0xc7,0x2a9,0x2000a,0x78030001,0xc7,0x0,
      0x3000c,0x78030001,0xc7,0x1ef,0x3000d,0x78030001,0xc7,0x1db,0x4000e,0x78030001,
      0xc7,0x1c7,0x5000f,0x78030001,0xc7,0x19,0x60011,0x78030001,0xc7,0x203,
      0x60012,0x78030001,0xc7,0x26d,0x70013,0x78030001,0xc7,0x22a,0x80014,0x78030001,
      0xc7,0x24c,0x90015,0x78030001,0xc7,0x28e,0xa0016,0x78030001,0xc7,0x21b,
      0xb0017,0x78030001,0x1a0,0x1c0004,0x104001c,0x5d4,0x5f0,0x60c,0x78030003,0x13,
      0xd00001,0x10,0xc10000,0x16,0xc00000,0x78030003,0x34,0x78030001,0x21,0x78030006,
      0x9,0x78030003,0x78030010,0xa5,0x10b,0x6,0x78030001,0xa5,0x27,0x10008,
      0x78030001,0xa5,0x294,0x10009,0x78030001,0xa5,0x2a9,0x2000a,0x78030001,0xa5,
      0x0,0x3000c,0x78030001,0xa5,0x1ef,0x3000d,0x78030001,0xa5,0x1db,0x4000e,
      0x78030001,0xa5,0x1c7,0x5000f,0x78030001,0xa5,0x19,0x60011,0x78030001,0xa5,
      0x203,0x60012,0x78030001,0xa5,0x26d,0x70013,0x78030001,0xa5,0x22a,0x80014,
      0x78030001,0xa5,0x24c,0x90015,0x78030001,0xa5,0x28e,0xa0016,0x78030001,0xa5,
      0x28e,0xb0017,0x78030001,0xa5,0x21b,0xc0018,0x78030001,0x193,0x1c0008,0x114001c,
      0x728,0x744,0x760,0x78030003,0x13,0xd00001,0x10,0xc10000,0x16,0xc00000,
      0x78030003,0x34,0x78030001,0x21,0x78030006,0x9,0x78030003,0x78030011,0x83,0x10b,
      0x6,0x78030001,0x83,0x27,0x10008,0x78030001,0x83,0x294,0x10009,0x78030001,
      0x83,0x2a9,0x2000a,0x78030001,0x83,0x0,0x3000c,0x78030001,0x83,0x1ef,
      0x3000d,0x78030001,0x83,0x1db,0x4000e,0x78030001,0x83,0x1c7,0x5000f,0x78030001,
      0x83,0x19,0x60011,0x78030001,0x83,0x203,0x60012,0x78030001,0x83,0x26d,
      0x70013,0x78030001,0x83,0x22a,0x80014,0x78030001,0x83,0x24c,0x90015,0x78030001,
      0x83,0x28e,0xa0016,0x78030001,0x83,0x28e,0xb0017,0x78030001,0x83,0x28e,
      0xc0018,0x78030001,0x83,0x21b,0xd0019,0x78030001,0x186,0x1c0010,0x124001c,0x88c,
      0x8a8,0x8c4,0x78030003,0x13,0xd00001,0x10,0xc10000,0x16,0xc00000,0x78030003,
      0x34,0x78030001,0x21,0x78030006,0x9,0x78030003,0x78030012,0x61,0x10b,0x6,
      0x78030001,0x61,0x27,0x10008,0x78030001,0x61,0x294,0x10009,0x78030001,0x61,
      0x2a9,0x2000a,0x78030001,0x61,0x0,0x3000c,0x78030001,0x61,0x1ef,0x3000d,
      0x78030001,0x61,0x1db,0x4000e,0x78030001,0x61,0x1c7,0x5000f,0x78030001,0x61,
      0x19,0x60011,0x78030001,0x61,0x203,0x60012,0x78030001,0x61,0x26d,0x70013,
      0x78030001,0x61,0x22a,0x80014,0x78030001,0x61,0x24c,0x90015,0x78030001,0x61,
      0x28e,0xa0016,0x78030001,0x61,0x28e,0xb0017,0x78030001,0x61,0x28e,0xc0018,
      0x78030001,0x61,0x28e,0xd0019,0x78030001,0x61,0x21b,0xe001a,0x78030001,0x179,
      0x1c0020,0x134001c,0xa00,0xa1c,0xa38,0x78030003,0x13,0xd00001,0x10,0xc10000,
      0x16,0xc00000,0x78030003,0x34,0x78030001,0x21,0x78030006,0x9,0x78030003,0x78030013,
      0x3f,0x10b,0x6,0x78030001,0x3f,0x27,0x10008,0x78030001,0x3f,0x294,
      0x10009,0x78030001,0x3f,0x2a9,0x2000a,0x78030001,0x3f,0x0,0x3000c,0x78030001,
      0x3f,0x1ef,0x3000d,0x78030001,0x3f,0x1db,0x4000e,0x78030001,0x3f,0x1c7,
      0x5000f,0x78030001,0x3f,0x19,0x60011,0x78030001,0x3f,0x203,0x60012,0x78030001,
      0x3f,0x26d,0x70013,0x78030001,0x3f,0x22a,0x80014,0x78030001,0x3f,0x24c,
      0x90015,0x78030001,0x3f,0x28e,0xa0016,0x78030001,0x3f,0x28e,0xb0017,0x78030001,
      0x3f,0x28e,0xc0018,0x78030001,0x3f,0x28e,0xd0019,0x78030001,0x3f,0x28e,
      0xe001a,0x78030001,0x3f,0x21b,0xf001b,0x78030001};
   unsigned int HexUofSize__cliptest = sizeof(HexUof__cliptest);


//**********************
#ifdef WIN32
void main(int argc, char **argv)
#else
int udbg_main()
#endif
{
   int test_fail, any_fail = FALSE;
   char *TargetName, mode, testcase;
   int i, outer_iterations = 1, inner_iterations = 1;
   int Ret;
   unsigned int sys, sys_all, sdram, sram, flash;
   hRS_Conn_T dbgH;

   if (argc < 3) {
		fprintf(stderr, "usage: %s -v|-s|-e|-p target [testcase] [iterations]\n", argv[0]);
		exit(1);
	}

    // look for help request
   for(i = 1; i < argc; i++ )
	{
		if ( strcmp( argv[i], "-h") == 0 )
		{
			printf(" 1  Set/Get uWord Test\n");
			printf(" 2  Set/Get NumuWord Test\n");
			printf(" 3  Read/Write Mem32 Test\n");
			printf(" 4  Read/Write Mem64 Test\n");
			printf(" 5  Read/Write CSR Test\n");
			printf(" 6  Read/Write GPR Test\n");
			printf(" 7  BreakPoint Test\n");
			printf(" 8  Read/Write SRAM Test\n");
			printf(" 9  Read/Write SDRAM Test\n");
			printf(" a  Set/Get PC Test\n");
			printf(" b  Pause/Resume/Start Test\n");
			printf(" c  Get uEngStatus Test\n");
			printf(" t  Throughput Test\n");
            printf(" else perform all tests\n");
			exit(0);
        }
    }

    if (strcmp(argv[1], "-e") == 0) mode = 'e';
    else if (strcmp(argv[1], "-v") == 0 ) mode = 'v';
    else if (strcmp(argv[1], "-s") == 0) mode = 's';
    else if (strcmp(argv[1], "-p") == 0) mode = 'p';
    else{
		fprintf(stderr, "usage: %s -v|-s|-e|-p target [testcase] [iterations]\n", argv[0]);
        exit(1);
    }
    
    strcpy(Rs_TargetName, argv[2]);
	TargetName = &Rs_TargetName[0];

    if (argc > 3) testcase = *argv[3]; 
    else testcase = '0';

    if (argc > 4){
        inner_iterations = atoi(argv[4]);
        if (inner_iterations < 1 || inner_iterations > 32000) inner_iterations = 1;
    }

    if (argc > 5){
        outer_iterations = atoi(argv[5]);
        if (outer_iterations < 1 || outer_iterations > 32000) outer_iterations = 1;
    }

#if 0
#ifdef _DEBUG
int tmpFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
_CrtMemState memState;

tmpFlag |= _CRTDBG_LEAK_CHECK_DF;
tmpFlag |= _CRTDBG_CHECK_ALWAYS_DF;
tmpFlag &= ~_CRTDBG_CHECK_CRT_DF;
_CrtSetDbgFlag(tmpFlag);

_CrtSetReportMode( _CRT_WARN, _CRTDBG_MODE_FILE );
_CrtSetReportFile( _CRT_WARN, _CRTDBG_FILE_STDOUT );
_CrtSetReportMode( _CRT_ERROR, _CRTDBG_MODE_FILE );
_CrtSetReportFile( _CRT_ERROR, _CRTDBG_FILE_STDOUT );
_CrtSetReportMode( _CRT_ASSERT, _CRTDBG_MODE_FILE );
_CrtSetReportFile( _CRT_ASSERT, _CRTDBG_FILE_STDOUT );

printf("\nDUMPING MEMORY STATISTICS\n");
_CrtMemCheckpoint(&memState);
_CrtMemDumpStatistics(&memState);
printf("\nDUMPING ALL OBJECTS\n");
_CrtMemDumpAllObjectsSince(NULL);
#endif
#endif

REPEAT_ALL:  // outer loop
// create a remote connection

    if (mode == 'e') Ret = Open_EtherNet_Connection(TargetName, &dbgH);
    else if (mode == 'v') Ret = Open_VxWorks_Connection(TargetName, &dbgH);
    else if (mode == 's') Ret = Open_Serial_Connection(TargetName, &dbgH);
    else if (mode == 'p') Ret = Open_PCI_Connection(TargetName, &dbgH);
    else exit(1);

    if (Ret != RS_SUCCESS){
        printf("Unable to open connection with target %s\n", TargetName);
        exit(0);
    }

#if 0
#ifdef _DEBUG
void* testPtr = malloc(1000);
printf("\nDUMPING MEMORY STATISTICS\n");
//_CrtMemCheckpoint(&memState);
_CrtMemDumpStatistics(&memState);
printf("\nDUMPING ALL OBJECTS\n");
_CrtMemDumpAllObjectsSince(NULL);
#endif
#endif

// Create debug sesstion
printf("\nInitialize the remote debug library...\n");

	freeU.freeUpc[0] = 48;
	freeU.freeUpc[1] = 48;
	freeU.freeUpc[2] = 48;
	freeU.freeUpc[3] = 48;
	freeU.freeUpc[4] = 48;
	freeU.freeUpc[5] = 48;

	freeU.freeSize[0] = 724;
	freeU.freeSize[1] = 724;
	freeU.freeSize[2] = 724;
	freeU.freeSize[3] = 724;
	freeU.freeSize[4] = 724;
	freeU.freeSize[5] = 724;

	freeU.seg2FreeUpc[0] = 1024;
	freeU.seg2FreeUpc[1] = 1024;
	freeU.seg2FreeUpc[2] = 1024;
	freeU.seg2FreeUpc[3] = 1024;
	freeU.seg2FreeUpc[4] = 1024;
	freeU.seg2FreeUpc[5] = 1024;

	freeU.seg2FreeSize[0] = 1024;
	freeU.seg2FreeSize[1] = 1024;
	freeU.seg2FreeSize[2] = 1024;
	freeU.seg2FreeSize[3] = 1024;
	freeU.seg2FreeSize[4] = 1024;
	freeU.seg2FreeSize[5] = 1024;

//Ret = RS_uDbg_InitLib(dbgH, &freeU);
printf("\nuDbg_InitLib\n");
Ret = RS_uDbg_InitLib(dbgH, NULL);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: uDbg_InitLib\n");
} else {
	printf("FAIL: uDbg_InitLib\n");
	exit(0);
}

// get mem sizes
printf("\nuDbg_GetSysMemSize\n");
Ret = RS_uDbg_GetSysMemSize(dbgH, &sys, &sys_all, &sdram, &sram, &flash);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: uDbg_GetSysMemSize - %u %u %u %u %u\n", sys, sys_all, sdram, sram, flash);
} else {
	printf("FAIL: uDbg_GetSysMemSize returned %d\n", Ret);
	any_fail = TRUE;
}

// pause microengines in case they are active
Ret = pause(dbgH, UDEBUG_UENG_ALL, 1200);
if (Ret == UDBG_SUCCESS) {
 	printf("PASS: uDbg_PauseUeng\n");
} else {
 	printf("FAIL: uDbg_PauseUeng\n");
 	any_fail = TRUE;
}

// clear reset in case engines are in reset state - required to load microcode
Ret = clrreset(dbgH, UDEBUG_UENG_ALL);
if (Ret == UDBG_SUCCESS) {
 	printf("PASS: uDbg_ClrResetUeng\n");
} else {
 	printf("FAIL: uDbg_ClrResetUeng\n");
 	any_fail = TRUE;
}

// load ucode

HexUof = HexUof__cliptest;
HexUofSize = HexUofSize__cliptest;

printf("\nuDbg_CNTL_InitUof\n");
Ret = RS_CNTL_InitUof(dbgH, (char *)HexUof, HexUofSize);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: CNTL_InitUof\n");
} else {
	printf("FAIL: CNTL_InitUof returned %d\n", Ret);
	any_fail = TRUE;
}

//printf("\nuDbg_DefineFreeUstore\n");
//Ret = RS_uDbg_DefineFreeUstore(dbgH, UDEBUG_UENG_ALL, 48, 724);
//if (Ret == UDBG_SUCCESS) {
//	printf("PASS: uDbg_DefineFreeUstore\n");
//} else {
//	printf("FAIL: uDbg_DefineFreeUstore returned %d\n", Ret);
//	any_fail = TRUE;
//}

printf("\nuDbg_UpdateFreeUstore\n");
Ret = RS_uDbg_UpdateFreeUstore(dbgH, UDEBUG_UENG_ALL);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: uDbg_UpdateFreeUstore\n");
} else {
	printf("FAIL: uDbg_UpdateFreeUstore returned %d\n", Ret);
	any_fail = TRUE;
}

// reset all uEng 
Ret = reset(dbgH, UDEBUG_UENG_ALL);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: uDbg_ResetUeng\n");
} else {
	printf("FAIL: uDbg_ResetUeng returned %d\n", Ret);
	any_fail = TRUE;
}

// Start uEng 
Ret = start(dbgH, UDEBUG_UENG_ALL);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: Start all microengines\n");
} else {
	printf("FAIL: Start all microengines returned %d\n", Ret);
	any_fail = TRUE;
}

// are engines active?
printf("\nChecking activity status...\n");
if (isActive(dbgH, UDEBUG_UENG_0)) {
	printf("PASS: Microengine 0 is active\n");
} else {
	printf("FAIL: Microengine 0 is stopped - should be running\n");
	any_fail = TRUE;
}

if (isActive(dbgH, UDEBUG_UENG_1)) {
	printf("PASS: Microengine 1 is active\n");
} else {
	printf("FAIL: Microengine 1 is stopped - should be running\n");
	any_fail = TRUE;
}

if (isActive(dbgH, UDEBUG_UENG_2)) {
	printf("PASS: Microengine 2 is active\n");
} else {
	printf("FAIL: Microengine 2 is stopped - should be running\n");
	any_fail = TRUE;
}
if (isActive(dbgH, UDEBUG_UENG_3)) {
	printf("PASS: Microengine 3 is active\n");
} else {
	printf("FAIL: Microengine 3 is stopped - should be running\n");
	any_fail = TRUE;
}
if (isActive(dbgH, UDEBUG_UENG_4)) {
	printf("PASS: Microengine 4 is active\n");
} else {
	printf("FAIL: Microengine 4 is stopped - should be running\n");
	any_fail = TRUE;
}
if (isActive(dbgH, UDEBUG_UENG_5)) {
	printf("PASS: Microengine 5 is active\n");
} else {
	printf("FAIL: Microengine 5 is stopped - should be running\n");
	any_fail = TRUE;
}

for (i = 0; i < inner_iterations; i++){  // inner loop
    switch (testcase){
    case '1': 
        if ((any_fail = Set_uWord_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set_uWord tests passed\n");
        else
            printf("\nFAILFAIL: One or more Set_uWord tests failed\n");
        break;
    case '2': 
        if ((any_fail = NumuWord_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set/Get NumuWord tests passed\n");
        else
            printf("\nFAILFAIL: One or more Set/Get NumuWord tests failed\n");
        break;
    case '3': 
        if ((any_fail = RW_mem32_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write Mem32 tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write Mem32 tests failed\n");
        break;
    case '4': 
        if ((any_fail = RW_mem64_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write Mem64 tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write Mem64 tests failed\n");
        break;
    case '5': 
        if ((any_fail = RW_csr_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write CSR tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write CSR tests failed\n");
        break;
    case '6': 
        if ((any_fail = RW_GPR_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write GPR tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write GPR tests failed\n");
        break;
    case '7': 
        if ((any_fail = BreakPoints_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All BreakPoints tests passed\n");
        else
            printf("\nFAILFAIL: One or more BreakPoints tests failed\n");
        break;
    case '8': 
        if ((any_fail = RW_SRAM_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write SRAM tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write SRAM tests failed\n");
        break;
    case '9': 
        if ((any_fail = RW_SDRAM_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write SDRAM tests passed\n");
        else
            printf("\nFAILFAIL: One or more Read/Write SDRAM tests failed\n");
        break;
    case 'a': 
        if ((any_fail = SG_PCtest(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set/Get PC tests passed\n");
        else
            printf("\nFAILFAIL: One or more Set/Get PC tests failed\n");
        break;
    case 'b': 
        if ((any_fail = ControlEngine_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Pause/Resume/Start tests passed\n");
        else
            printf("\nFAILFAIL: One or more Pause/Resume/Start tests failed\n");
        break;
    case 'c': 
        if ((any_fail = Get_uEngStatus_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Get_uEngStatus tests passed\n");
        else
            printf("\nFAILFAIL: One or more Get_uEngStatus tests failed\n");
        break;
    case 't': 
        if ((any_fail = Throughput_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: Throughput test passed\n");
        else
            printf("\nFAILFAIL: Throughput test failed\n");
        break;
    default:
        printf("\n=============================================\n");
        if ((test_fail = RW_mem32_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write Mem32 tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write Mem32 tests failed\n");
            any_fail = TRUE;
            //		    	break;
        }
        printf("\n=============================================\n");
        if ((test_fail = RW_mem64_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write Mem64 tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write Mem64 tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = RW_csr_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write CSR tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write CSR tests failed\n");
            any_fail = TRUE;
            //				break;
        }
        printf("\n=============================================\n");
        if ((test_fail = RW_GPR_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write GPR tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write GPR tests failed\n");
            any_fail = TRUE;
            //    			break;
        }
        printf("\n=============================================\n");
        if ((test_fail = RW_SRAM_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write SRAM tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write SRAM tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = RW_SDRAM_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Read/Write SDRAM tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Read/Write SDRAM tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = Get_uEngStatus_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Get_uEngStatus tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Get_uEngStatus tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = SG_PCtest(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set/Get PC tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Set/Get PC tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = BreakPoints_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All BreakPoints tests passed\n");
        else{
            printf("\nFAILFAIL: One or more BreakPoints tests failed\n");
            any_fail = TRUE;
            //			    break;
        }
        printf("\n=============================================\n");
        if ((test_fail = Set_uWord_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set_uWord tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Set_uWord tests failed\n");
            any_fail = TRUE;
            //				break;
        }
        printf("\n=============================================\n");
        if ((test_fail = NumuWord_test(dbgH)) == FALSE)
            printf("\nSUCCESSSUCCESS: All Set/Get NumuWord tests passed\n");
        else{
            printf("\nFAILFAIL: One or more Set/Get NumuWord tests failed\n");
            any_fail = TRUE;
            //	    		break;
        }
        break;  // switch
} // switch
} // inner loop

#if 0
#ifdef _DEBUG
printf("\nDUMPING MEMORY STATISTICS\n");
//_CrtMemCheckpoint(&memState);
_CrtMemDumpStatistics(&memState);
printf("\nDUMPING ALL OBJECTS\n");
_CrtMemDumpAllObjectsSince(NULL);
#endif
#endif

// reset all uEng 
//Ret = reset(dbgH, UDEBUG_UENG_ALL);
//if (Ret == UDBG_SUCCESS) {
//	printf("PASS: uDbg_ResetUeng\n");
//} else {
//    printf("FAIL: uDbg_ResetUeng returned %d\n", Ret);
//	any_fail = TRUE;
//}

// pause microengines in case they are active
Ret = pause(dbgH, UDEBUG_UENG_ALL, 1200);
if (Ret == UDBG_SUCCESS) {
 	printf("PASS: uDbg_PauseUeng\n");
} else {
 	printf("FAIL: uDbg_PauseUeng\n");
 	any_fail = TRUE;
}

// pause microengines in case they are active
Ret = pause(dbgH, UDEBUG_UENG_ALL, 1200);
if (Ret == UDBG_SUCCESS) {
 	printf("PASS: uDbg_PauseUeng\n");
} else {
 	printf("FAIL: uDbg_PauseUeng\n");
 	any_fail = TRUE;
}

Ret = RS_uDbg_DeleLib(dbgH);
if (Ret == UDBG_SUCCESS) {
	printf("PASS: uDbg_DeleLib\n");
} else {
	printf("FAIL: uDbg_DeleLib\n");
	exit(0);
}

#if 0
#ifdef _DEBUG
printf("\nDUMPING MEMORY STATISTICS\n");
//_CrtMemCheckpoint(&memState);
_CrtMemDumpStatistics(&memState);
printf("\nDUMPING ALL OBJECTS\n");
_CrtMemDumpAllObjectsSince(NULL);
free(testPtr);
#endif
#endif

if (mode == 'e') Close_EtherNet_Connection(dbgH);
else if (mode == 'v') Close_VxWorks_Connection(dbgH);
else if (mode == 's') Close_Serial_Connection(dbgH);
else if (mode == 'p') Close_PCI_Connection(dbgH);

if (any_fail){
    printf("\n@@@@@@@@@@@@@@@@@@@@@@@@\n");
    printf(  "One or more tests failed\n");
    printf(  "@@@@@@@@@@@@@@@@@@@@@@@@\n\n");
}

outer_iterations--;
if (outer_iterations > 0){
	printf("Repeating everything - %d remaining...\n", outer_iterations);
	goto REPEAT_ALL;
}

if (!any_fail){
    printf("\n!!!!!!!!!!!!!!!!\n");
    printf(  "All tests passed\n");
    printf(  "!!!!!!!!!!!!!!!!\n");
}

return;
}



