/* rs_udbg_test.h
 * Remote Services Debug Library - Test case routine definitions
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: Remote Services Debug Library
 *  author: lwh, 12/2/98  Initial version
 *  revisions:
 *  $History: rs_udbg_test.h $
 * 
 * *****************  Version 28  *****************
 * User: Ewalker      Date: 12/11/00   Time: 11:34a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added pause and clrreset so that program can be rerun more reliably
 * 
 * *****************  Version 27  *****************
 * User: Ewalker      Date: 10/31/00   Time: 11:53a
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 26  *****************
 * User: Ewalker      Date: 10/30/00   Time: 11:49a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added some tests and cleaned up some logging 
 * 
 * *****************  Version 24  *****************
 * User: Ewalker      Date: 9/20/00    Time: 8:02a
 * Updated in $/dev_1200/Share/rs_udebug
 * Added performance/throughput test to test cases
 * 
 * *****************  Version 23  *****************
 * User: Ewalker      Date: 9/07/00    Time: 16:25
 * Updated in $/dev_1200/Share/rs_udebug
 * 
 * *****************  Version 22  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:41
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 * *****************  Version 21  *****************
 * User: Ewalker      Date: 8/28/00    Time: 16:16
 * Updated in $/dev_1200/Share/rs_udebug
 * Cleanup and added support for PCI debug connection
 * 
 * *****************  Version 19  *****************
 * User: Lhui         Date: 1/27/00    Time: 4:18p
 * Updated in $/dev_1200/Share/rs_udebug
 * Rewrite CNTL_InitUof_T function to allow sending multiple packets to
 * SCOMM
 * 
 * *****************  Version 19  *****************
 * User: Lhui         Date: 1/17/00    Time: 10:46a
 * Updated in $/Beta4_Interim/Share/rs_udebug
 * 
 * *****************  Version 16  *****************
 * User: Lhui         Date: 6/25/99    Time: 7:40p
 * Updated in $/dev_1200/Share/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 15  *****************
 * User: Lhui         Date: 5/04/99    Time: 12:04p
 * Updated in $/dev_1200/Share/rs_udebug
 * Update for the new tree
 * 
 * *****************  Version 10  *****************
 * User: Lhui         Date: 3/29/99    Time: 6:07p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add test cases
 * 
 * *****************  Version 9  *****************
 * User: Qabuild      Date: 3/22/99    Time: 11:57a
 * Updated in $/development/qa-test/rsdbg_tests
 * 
 * *****************  Version 8  *****************
 * User: Qabuild      Date: 3/22/99    Time: 11:19a
 * Updated in $/development/qa-test/rsdbg_tests
 * Updated debug.h to debug_1200.h
 * 
 * *****************  Version 7  *****************
 * User: Lhui         Date: 3/19/99    Time: 1:21p
 * Updated in $/development/qa-test/rsdbg_tests
 * Update for the new debug SA1200 path
 * 
 * *****************  Version 6  *****************
 * User: Lhui         Date: 3/18/99    Time: 5:52p
 * Updated in $/development/qa-test/rsdbg_tests
 * change "udbg_lib.h" to "debug.h"
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 3/15/99    Time: 12:07p
 * Updated in $/development/qa-test/rsdbg_tests
 * Link with rs_udbg_client_dll
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 3/09/99    Time: 6:25p
 * Updated in $/development/qa-test/rsdbg_tests
 * Add test cases
 * 
 * *****************  Version 3  *****************
 * User: Lhui         Date: 2/25/99    Time: 8:54p
 * Updated in $/development/qa-test/rsdbg_tests
 * Updated for the latest version of udebug related changes
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 2/22/99    Time: 7:54p
 * Updated in $/development/qa-test/rsdbg_tests
 * Updated for udebug related changes
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 1/28/99    Time: 6:31p
 * Created in $/development/qa-test/rsdbg_tests
 * 
 * *****************  Version 7  *****************
 * User: Lhui         Date: 12/18/98   Time: 5:23p
 * Updated in $/development/rs_udebug
 * Fix bugs
 * 
 * *****************  Version 6  *****************
 * User: Lhui         Date: 12/09/98   Time: 7:17p
 * Updated in $/development/rs_udebug
 * Modify udebug calls to reflect udebug's API changes
 * 
 * *****************  Version 5  *****************
 * User: Lhui         Date: 12/07/98   Time: 3:04p
 * Updated in $/development/rs_udebug
 * Fix misc. bugs
 * 
 * *****************  Version 4  *****************
 * User: Lhui         Date: 12/03/98   Time: 10:18p
 * Updated in $/development/rs_udebug
 * fix bugs
 * 
 * *****************  Version 2  *****************
 * User: Lhui         Date: 12/03/98   Time: 5:49p
 * Updated in $/users/Hui/SA-1200/rs_udebug
 * Move files to development area
 * 
 * *****************  Version 1  *****************
 * User: Lhui         Date: 12/03/98   Time: 1:56p
 * Created in $/users/Hui/SA-1200/rs_udebug
 */
#ifndef RS_UDBG_TEST_H
#define RS_UDBG_TEST_H

#include "debug_1200.h"
#include "rs_udbg_lib.h"

#define FALSE  0
#define TRUE   1

#define UDEBUG_UENG_ALL			0x3f
#define UDEBUG_UENG_0			0x1
#define UDEBUG_UENG_1			0x2
#define UDEBUG_UENG_2			0x4
#define UDEBUG_UENG_3			0x8	
#define UDEBUG_UENG_4			0x10	
#define UDEBUG_UENG_5			0x20
#define UDEBUG_UENG_INVALID		0x0

#ifdef __cplusplus
extern "C" {
#endif
int Set_uWord_test(hRS_Conn_T dbgH);
int Get_uWord_test(hRS_Conn_T dbgH);
int NumuWord_test(hRS_Conn_T dbgH);
int RW_mem32_test(hRS_Conn_T dbgH);
int RW_mem64_test(hRS_Conn_T dbgH);
int RW_csr_test(hRS_Conn_T dbgH);
int RW_GPR_test(hRS_Conn_T dbgH);
int BreakPoints_test(hRS_Conn_T dbgH);
int RW_SRAM_test(hRS_Conn_T dbgH);
int RW_SDRAM_test(hRS_Conn_T dbgH);
int SG_PCtest(hRS_Conn_T dbgH);
int ControlEngine_test(hRS_Conn_T dbgH);
int start(hRS_Conn_T handle, unsigned int uEngMask);
int reset(hRS_Conn_T handle, unsigned int uEngMask);
int clrreset(hRS_Conn_T handle, unsigned int uEngMask);
int pause(hRS_Conn_T handle, unsigned int uEngMask, unsigned int delay);
int isActive(hRS_Conn_T handle, unsigned int uEngMask);
int Get_uEngStatus_test(hRS_Conn_T dbgH);
int Throughput_test(hRS_Conn_T dbgH);
#ifdef __cplusplus
}
#endif

#endif			/* RS_UDBG_TEST_H */