/* RS_udebug.x: 
 *      SA1200 remote udebug function definitions
 *
 * ------------------------------------------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *------------------------------------------------------------
 *
 *
 * system: SA1200
 * subsystem: Remote Services
 * author: Lai-Wah Hui 11/30/98
 * revisions:
 * $History: rs_udebug.x $
 */ 

struct rs_string_T
{
   char msg<>;
};

struct rs_uDbg_uEngStatus_T
{
   char state; 				/* active, inactive, break */
   char activeCtx; 			/* contex enable */
   char enables;			/* cc<7:6>, csrWrite<5>, sram-journal<4>, ctx<3:0> */
   char breakId;			/* breakpint ID */
   short activePC;			/* active PC */
};


struct rs_uDbg_GetuEngStatus_T		/* uEngine Status */
{
	int res;
	rs_uDbg_uEngStatus_T uEngStatus;
};

struct rs_uDbg_GetMemSize_T
{
	int     res;                    /* return status from udebug library */
	u_int	sys;     		/* Size of memory mapped at zero for OS */
	u_int	sys_all; 		/* Size of memory mapped at zero and usable by the OS */
	u_int	sdram;   		/* Size of memory mapped at C0000000 and usable by HW */
	u_int	sram;    		/* Size of sram */
	u_int	flash;   		/* Size of Flash */
};

struct rs_uDbg_Handle_T
{
	int uDbg_Handle;
};


struct rs_uDbg_Bkpt_T
{
	int     callback;
	u_short	id;
	u_short ctx;
	u_short uAddr;
	u_char  uEng;
	u_int	userData;
        u_int	breakIfCtx;		
        u_int   stpOnBrkUengMask;	
};

struct rs_uDbg_BPoint_T
{
    int callback;
    u_int usrData;
    u_int   uword;					
    short   id;
    u_short upc;
    u_short ctxBreak;		
    u_short brUpc;
    u_char  state;
    u_char  ueng;
    u_int   breakIfCtx;
    u_int   stpUengMask;
};

struct rs_uDbg_BreakPoint_T
{
    rs_uDbg_Handle_T hRs_uDbg;
    rs_uDbg_Bkpt_T pBpoint;
};


struct rs_uDbg_BkptArray_T{
   u_short len;				
   rs_uDbg_Bkpt_T bkpts<>;		
};


struct rs_uDbg_uStoreFree_T
{
   string  ClientName<>;
   u_short freeUpc<>;
   u_short freeSize<>;
};

struct rs_uDbg_One_uint_T
{
    rs_uDbg_Handle_T hRs_uDbg;
    u_int arg1;
};

struct rs_uDbg_Two_uint_T
{
    rs_uDbg_Handle_T hRs_uDbg;
	u_int arg1;
	u_int arg2;
};

struct rs_uDbg_Three_uint_T
{
    rs_uDbg_Handle_T hRs_uDbg;
	u_int arg1;
	u_int arg2;
	u_int arg3;
};


struct rs_uDbg_uWord_T
{
    rs_uDbg_Handle_T hRs_uDbg;
	u_int   uEng;
	u_int uWordAddr;
	u_short numWords;
	u_int u_Word<>;
};

struct rs_uDbg_Mem_T
{
        rs_uDbg_Handle_T hRs_uDbg;
	u_int   addr;
	u_int	data<>;
};

struct rs_uDbg_CSR_T
{
	rs_uDbg_Handle_T hRs_uDbg;
	u_int   csrAddr;
	u_int	csrData<>;
};


struct rs_uDbg_Reg_T
{
	rs_uDbg_Handle_T hRs_uDbg;
	u_char  uEng;
	u_char	ctx;
	u_int	bankType;
	u_int	regAddr;
	u_int	regData<>;
};



struct rs_uDbg_GetThPC_T
{
	rs_uDbg_Handle_T hRs_uDbg;
	u_char  uEng;
	u_char	ctx;
	u_int	regData<>;
};


struct rs_uDbg_Status_T
{
	int res;
	u_int resData<>;
};


struct rs_uDbg_FiFo_T
{
	rs_uDbg_Handle_T hRs_uDbg;
	u_char  uEng;
	u_int	fifoAddr;
	u_int	data64<>;
	u_int	count;
	u_int	setValid;
};
 
struct rs_uDbg_ShowBreakpts_T{
   int  res;
   rs_uDbg_BkptArray_T BkptArray;
};


struct rs_CNTL_InitUof_T
{
	char UofData<>;
};

program SA1200TARGET {
   version SA1200VERSION {
   int RS_UDBG_INITLIB(rs_uDbg_uStoreFree_T)=1;
   int RS_UDBG_DELELIB(rs_uDbg_Handle_T)=2;
   int RS_UDBG_RESETUENG(rs_uDbg_Two_uint_T) = 3;
   int RS_UDBG_STARTUENG(rs_uDbg_One_uint_T) = 4;
   int RS_UDBG_PAUSEUENG(rs_uDbg_Two_uint_T)=5;
   int RS_UDBG_RESUMEUENG(rs_uDbg_One_uint_T)=6;
   int RS_UDBG_ISUENGACTIVE(rs_uDbg_One_uint_T)=7;
   int RS_UDBG_GETACTIVEUENGS(rs_uDbg_One_uint_T)=8;
   rs_uDbg_Status_T RS_UDBG_GETUTHREADPC(rs_uDbg_GetThPC_T)=9;
   int RS_UDBG_SETUTHREADSPC(rs_uDbg_Three_uint_T)=10;
   int RS_UDBG_SETUENGPC(rs_uDbg_Mem_T)=11;
   rs_uDbg_Status_T RS_UDBG_GETUENGPC(rs_uDbg_One_uint_T)=12;
   rs_uDbg_Status_T RS_UDBG_GETUWORD(rs_uDbg_uWord_T)=13;
   int RS_UDBG_SETUWORD(rs_uDbg_uWord_T)=14;
   rs_uDbg_Status_T RS_UDBG_GETNUMUWORD(rs_uDbg_uWord_T)=15;
   int RS_UDBG_SETNUMUWORD(rs_uDbg_uWord_T)=16;
   int RS_UDBG_WRITEMEM32(rs_uDbg_Mem_T)=17;
   rs_uDbg_Status_T  RS_UDBG_READMEM32(rs_uDbg_Mem_T)=18;
   int RS_UDBG_WRITEMEM64(rs_uDbg_Mem_T)=19;
   rs_uDbg_Status_T RS_UDBG_READMEM64(rs_uDbg_Mem_T)=20; 
   rs_uDbg_Status_T RS_UDBG_SETBREAKPOINT(rs_uDbg_BreakPoint_T)=21;
   rs_uDbg_ShowBreakpts_T RS_UDBG_SHOWBREAKPOINTS(rs_uDbg_One_uint_T)=22;
   int RS_UDBG_CLEARALLBREAKPOINTS(rs_uDbg_One_uint_T)=23;
   int RS_UDBG_CLEARBREAKPOINT(rs_uDbg_One_uint_T)=24;
/*  int RS_UDBG_CONTINUE(rs_uDbg_One_uint_T)=24; */
   rs_uDbg_Status_T RS_UDBG_GETCSR(rs_uDbg_CSR_T)=25;
   int RS_UDBG_SETCSR(rs_uDbg_CSR_T)=26;
   int RS_UDBG_PUTRELGPR(rs_uDbg_Reg_T)=27;
   rs_uDbg_Status_T RS_UDBG_GETRELGPR(rs_uDbg_Reg_T)=28;
   int RS_UDBG_PUTRELSRAM_WRXFER(rs_uDbg_Reg_T)=29;
   int RS_UDBG_PUTRELSDRAM_WRXFER(rs_uDbg_Reg_T)=30;
   int RS_UDBG_PUTRELSRAM_RDXFER(rs_uDbg_Reg_T)=31;
   int RS_UDBG_PUTRELSDRAM_RDXFER(rs_uDbg_Reg_T)=32;
   rs_uDbg_Status_T RS_UDBG_GETRELSRAM_WRXFER(rs_uDbg_Reg_T)=33;
   rs_uDbg_Status_T RS_UDBG_GETRELSDRAM_WRXFER(rs_uDbg_Reg_T)=34;
   rs_uDbg_Status_T RS_UDBG_GETRELSRAM_RDXFER(rs_uDbg_Reg_T)=35;
   rs_uDbg_Status_T RS_UDBG_GETRELSDRAM_RDXFER(rs_uDbg_Reg_T)=36;
   rs_uDbg_GetuEngStatus_T RS_UDBG_GETUENGSTATUS(rs_uDbg_One_uint_T)=37;
   rs_uDbg_Status_T RS_UDBG_HOPUENG(rs_uDbg_Two_uint_T)= 38;
   int RS_XACT_COMMAND(rs_string_T)=39;
   int RS_CNTL_INITUOF(rs_CNTL_InitUof_T)=40;
   int RS_CNTL_RESET(rs_uDbg_Three_uint_T)=41;
   int RS_CNTL_PAUSE(rs_uDbg_Three_uint_T)=42;
   int RS_CNTL_RESUME(rs_uDbg_Two_uint_T)=43;
   int RS_CNTL_START(rs_uDbg_Two_uint_T)=44;
   rs_uDbg_Status_T RS_CNTL_HOP(rs_uDbg_Three_uint_T)=45;
   int RS_UDBG_CLRRESETUENG(rs_uDbg_One_uint_T)=46;
   int RS_UDBG_DEFINEFREEUSTORE(rs_uDbg_Three_uint_T)=47;
   int RS_UDBG_UPDATEFREEUSTORE(rs_uDbg_One_uint_T)=48;
   int RS_UDBG_WRITEFIFO_TX(rs_uDbg_FiFo_T)=49;
   rs_uDbg_Status_T RS_UDBG_READFIFO_RX(rs_uDbg_FiFo_T)=50;
   rs_uDbg_GetMemSize_T RS_UDBG_GETSYSMEMSIZE(rs_uDbg_Handle_T)=51;
  } = 1;
} = 1691;

