/* rs_udebug_clnt.h
 * Remote Services Debug Library - Remote debug RPC client stub definitions
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui
 * revisions:
 * $History: rs_udebug_clnt.h $
 * 
 * *****************  Version 3  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:41
 * Updated in $/dev_1200/share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 */ 

#ifndef RS_UDEBUG_CLNT_H
#define RS_UDEBUG_CLNT_H

#include "rs_udebug.h"

#ifdef  __cplusplus
extern "C"
{
#endif

/* client functions */

int *rs_udbg_initlib_c(rs_uDbg_uStoreFree_T *argp, CLIENT *clnt);
int *rs_udbg_delelib_c(rs_uDbg_Handle_T *argp, CLIENT *clnt);
int *rs_udbg_resetueng_c(rs_uDbg_Two_uint_T *argp, CLIENT *clnt);
int *rs_udbg_clrresetueng_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_definefreeustore_c(rs_uDbg_Three_uint_T *argp, CLIENT *clnt);
int *rs_udbg_updatefreeustore_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_startueng_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_pauseueng_c(rs_uDbg_Two_uint_T *argp, CLIENT *clnt);
int *rs_udbg_resumeueng_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_isuengactive_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_getactiveuengs_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuthreadpc_c(rs_uDbg_GetThPC_T *argp, CLIENT *clnt);
int *rs_udbg_setuthreadspc_c(rs_uDbg_Three_uint_T *argp, CLIENT *clnt);
int *rs_udbg_setuengpc_c(rs_uDbg_Mem_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuengpc_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getuword_c(rs_uDbg_uWord_T *argp, CLIENT *clnt);
int *rs_udbg_setuword_c(rs_uDbg_uWord_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getnumuword_c(rs_uDbg_uWord_T *argp, CLIENT *clnt);
int *rs_udbg_setnumuword_c(rs_uDbg_uWord_T *argp, CLIENT *clnt);
int *rs_udbg_writemem32_c(rs_uDbg_Mem_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readmem32_c(rs_uDbg_Mem_T *argp, CLIENT *clnt);
int *rs_udbg_writemem64_c(rs_uDbg_Mem_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readmem64_c(rs_uDbg_Mem_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_setbreakpoint_c(rs_uDbg_BreakPoint_T *argp, CLIENT *clnt);
rs_uDbg_ShowBreakpts_T *rs_udbg_showbreakpoints_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_clearallbreakpoints_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
int *rs_udbg_clearbreakpoint_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getcsr_c(rs_uDbg_CSR_T *argp, CLIENT *clnt);
int *rs_udbg_setcsr_c(rs_uDbg_CSR_T *argp, CLIENT *clnt);
int *rs_udbg_putrelgpr_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelgpr_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
int *rs_udbg_putrelsram_wrxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
int *rs_udbg_putrelsdram_wrxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
int *rs_udbg_putrelsram_rdxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
int *rs_udbg_putrelsdram_rdxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsram_wrxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsdram_wrxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsram_rdxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_getrelsdram_rdxfer_c(rs_uDbg_Reg_T *argp, CLIENT *clnt);
rs_uDbg_GetuEngStatus_T *rs_udbg_getuengstatus_c(rs_uDbg_One_uint_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_hopueng_c(rs_uDbg_Two_uint_T *argp, CLIENT *clnt);
int *rs_xact_command_c(rs_string_T *argp, CLIENT *clnt);
int *rs_cntl_inituof_c(rs_CNTL_InitUof_T *argp, CLIENT *clnt);
int *rs_cntl_reset_c(rs_uDbg_Three_uint_T *argp, CLIENT *clnt);
int *rs_cntl_pause_c(rs_uDbg_Three_uint_T *argp, CLIENT *clnt);
int *rs_cntl_resume_c(rs_uDbg_Two_uint_T *argp, CLIENT *clnt);
int *rs_cntl_start_c(rs_uDbg_Two_uint_T *argp, CLIENT *clnt);
rs_uDbg_Status_T *rs_cntl_hop_c(rs_uDbg_Three_uint_T *argp, CLIENT *clnt);
int *rs_udbg_writefifo_tx_c(rs_uDbg_FiFo_T *argp,CLIENT *clnt);
rs_uDbg_Status_T *rs_udbg_readfifo_rx_c(rs_uDbg_FiFo_T *argp,CLIENT *clnt);
rs_uDbg_GetMemSize_T *rs_udbg_getsysmemsize_c(rs_uDbg_Handle_T *argp, CLIENT *clnt);

#ifdef __cplusplus
}
#endif

#endif      /* RS_UDEBUG_CLNT_H */
