/* rs_udebug_svc.h
 * Remote Services Debug Library - Definitions for RPC server entry points
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui
 * revisions:
 * $History: rs_udebug_svc.h $
 * 
 * *****************  Version 3  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:41
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 */ 

#ifndef RS_UDEBUG_SVC_H
#define RS_UDEBUG_SVC_H

#include "rs_udebug.h"

#ifdef  __cplusplus
extern "C"
{
#endif

int *rs_udbg_initlib_1(rs_uDbg_uStoreFree_T *argp);
int *rs_udbg_delelib_1(rs_uDbg_Handle_T *argp);
int *rs_udbg_resetueng_1(rs_uDbg_Two_uint_T *argp);
int *rs_udbg_startueng_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_pauseueng_1(rs_uDbg_Two_uint_T *argp);
int *rs_udbg_resumeueng_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_isuengactive_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_getactiveuengs_1(rs_uDbg_One_uint_T *argp);
rs_uDbg_Status_T *rs_udbg_getuthreadpc_1(rs_uDbg_GetThPC_T *argp);
int *rs_udbg_setuthreadspc_1(rs_uDbg_Three_uint_T *argp);
int *rs_udbg_setuengpc_1(rs_uDbg_Mem_T *argp);
rs_uDbg_Status_T *rs_udbg_getuengpc_1(rs_uDbg_One_uint_T *argp);
rs_uDbg_Status_T *rs_udbg_getuword_1(rs_uDbg_uWord_T *argp);
int *rs_udbg_setuword_1(rs_uDbg_uWord_T *argp);
rs_uDbg_Status_T *rs_udbg_getnumuword_1(rs_uDbg_uWord_T *argp);
int *rs_udbg_setnumuword_1(rs_uDbg_uWord_T *argp);
int *rs_udbg_writemem32_1(rs_uDbg_Mem_T *argp);
rs_uDbg_Status_T *rs_udbg_readmem32_1(rs_uDbg_Mem_T *argp);
int *rs_udbg_writemem64_1(rs_uDbg_Mem_T *argp);
rs_uDbg_Status_T *rs_udbg_readmem64_1(rs_uDbg_Mem_T *argp);
rs_uDbg_Status_T *rs_udbg_setbreakpoint_1(rs_uDbg_BreakPoint_T *argp);
rs_uDbg_ShowBreakpts_T *rs_udbg_showbreakpoints_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_clearallbreakpoints_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_clearbreakpoint_1(rs_uDbg_One_uint_T *argp);
rs_uDbg_Status_T *rs_udbg_getcsr_1(rs_uDbg_CSR_T *argp);
int *rs_udbg_setcsr_1(rs_uDbg_CSR_T *argp);
int *rs_udbg_putrelgpr_1(rs_uDbg_Reg_T *argp);
rs_uDbg_Status_T *rs_udbg_getrelgpr_1(rs_uDbg_Reg_T *argp);
int *rs_udbg_putrelsram_wrxfer_1(rs_uDbg_Reg_T *argp);
int *rs_udbg_putrelsdram_wrxfer_1(rs_uDbg_Reg_T *argp);
int *rs_udbg_putrelsram_rdxfer_1(rs_uDbg_Reg_T *argp);
int *rs_udbg_putrelsdram_rdxfer_1(rs_uDbg_Reg_T *argp);
rs_uDbg_Status_T *rs_udbg_getrelsram_wrxfer_1(rs_uDbg_Reg_T *argp);
rs_uDbg_Status_T *rs_udbg_getrelsdram_wrxfer_1(rs_uDbg_Reg_T *argp);
rs_uDbg_Status_T *rs_udbg_getrelsram_rdxfer_1(rs_uDbg_Reg_T *argp);
rs_uDbg_Status_T *rs_udbg_getrelsdram_rdxfer_1(rs_uDbg_Reg_T *argp);
rs_uDbg_GetuEngStatus_T *rs_udbg_getuengstatus_1(rs_uDbg_One_uint_T *argp);
rs_uDbg_Status_T *rs_udbg_hopueng_1(rs_uDbg_Two_uint_T *argp);
int *rs_xact_command_1(rs_string_T *argp);
int *rs_cntl_inituof_1(rs_CNTL_InitUof_T *argp);
int *rs_cntl_reset_1(rs_uDbg_Three_uint_T *argp);
int *rs_cntl_pause_1(rs_uDbg_Three_uint_T *argp);
int *rs_cntl_resume_1(rs_uDbg_Two_uint_T *argp);
int *rs_cntl_start_1(rs_uDbg_Two_uint_T *argp);
rs_uDbg_Status_T *rs_cntl_hop_1(rs_uDbg_Three_uint_T *argp);
int *rs_udbg_clrresetueng_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_definefreeustore_1(rs_uDbg_Three_uint_T *argp);
int *rs_udbg_updatefreeustore_1(rs_uDbg_One_uint_T *argp);
int *rs_udbg_writefifo_tx_1(rs_uDbg_FiFo_T *argp);
rs_uDbg_Status_T *rs_udbg_readfifo_rx_1(rs_uDbg_FiFo_T *argp);
rs_uDbg_GetMemSize_T *rs_udbg_getsysmemsize_1(rs_uDbg_Handle_T *argp);

#ifdef __cplusplus
}
#endif

#endif      /* RS_UDEBUG_SVC_H */
