/* rs_udebug_xdr.c
 * Remote Services Debug Library - RPC argument packaging
 *
 * --------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-2000 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 * system: SA1200
 * subsystem: Remote Services Debug Library
 * author: Lai-Wah Hui
 * revisions:
 * $History: rs_udebug_xdr.c $
 * 
 * *****************  Version 16  *****************
 * User: Ewalker      Date: 9/05/00    Time: 11:41
 * Updated in $/dev_1200/Share/rs_udebug
 * Add missing copyright comment block and static declaration
 * 
 */ 

#include <stdio.h>

#include "rs_udebug.h"

static const char __copyright[] =
"Copyright Intel Corp, 1998-2000. All rights reserved";

bool_t
xdr_rs_string_T(xdrs, objp)
	XDR *xdrs;
	rs_string_T *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->msg.msg_val, (u_int *)&objp->msg.msg_len, ~0, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_uEngStatus_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_uEngStatus_T *objp;
{
	if (!xdr_char(xdrs, &objp->state)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->activeCtx)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->enables)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->breakId)) {
		return (FALSE);
	}
	if (!xdr_short(xdrs, &objp->activePC)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_GetuEngStatus_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_GetuEngStatus_T *objp;
{
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	if (!xdr_rs_uDbg_uEngStatus_T(xdrs, &objp->uEngStatus)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_GetMemSize_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_GetMemSize_T *objp;
{
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->sys)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->sys_all)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->sdram)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->sram)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->flash)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Handle_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Handle_T *objp;
{
	if (!xdr_int(xdrs, &objp->uDbg_Handle)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Bkpt_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Bkpt_T *objp;
{
	if (!xdr_int(xdrs, &objp->callback)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->id)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->ctx)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->uAddr)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->uEng)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->userData)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->breakIfCtx)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->stpOnBrkUengMask)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_BPoint_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_BPoint_T *objp;
{
	if (!xdr_int(xdrs, &objp->callback)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->usrData)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->uword)) {
		return (FALSE);
	}
	if (!xdr_short(xdrs, &objp->id)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->upc)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->ctxBreak)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->brUpc)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->state)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->ueng)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->breakIfCtx)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->stpUengMask)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_BreakPoint_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_BreakPoint_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_rs_uDbg_Bkpt_T(xdrs, &objp->pBpoint)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_BkptArray_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_BkptArray_T *objp;
{
	if (!xdr_u_short(xdrs, &objp->len)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->bkpts.bkpts_val, (u_int *)&objp->bkpts.bkpts_len, ~0, sizeof(rs_uDbg_Bkpt_T), xdr_rs_uDbg_Bkpt_T)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_uStoreFree_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_uStoreFree_T *objp;
{
	if (!xdr_string(xdrs, &objp->ClientName, ~0)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->freeUpc.freeUpc_val, (u_int *)&objp->freeUpc.freeUpc_len, ~0, sizeof(u_short), xdr_u_short)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->freeSize.freeSize_val, (u_int *)&objp->freeSize.freeSize_len, ~0, sizeof(u_short), xdr_u_short)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_One_uint_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_One_uint_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg1)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Two_uint_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Two_uint_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg1)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg2)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Three_uint_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Three_uint_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg1)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg2)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->arg3)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_uWord_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_uWord_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->uEng)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->uWordAddr)) {
		return (FALSE);
	}
	if (!xdr_u_short(xdrs, &objp->numWords)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->u_Word.u_Word_val, (u_int *)&objp->u_Word.u_Word_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Mem_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Mem_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->addr)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->data.data_val, (u_int *)&objp->data.data_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_CSR_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_CSR_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->csrAddr)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->csrData.csrData_val, (u_int *)&objp->csrData.csrData_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Reg_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Reg_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->uEng)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->ctx)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->bankType)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->regAddr)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->regData.regData_val, (u_int *)&objp->regData.regData_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_GetThPC_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_GetThPC_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->uEng)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->ctx)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->regData.regData_val, (u_int *)&objp->regData.regData_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_Status_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_Status_T *objp;
{
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->resData.resData_val, (u_int *)&objp->resData.resData_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_FiFo_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_FiFo_T *objp;
{
	if (!xdr_rs_uDbg_Handle_T(xdrs, &objp->hRs_uDbg)) {
		return (FALSE);
	}
	if (!xdr_u_char(xdrs, &objp->uEng)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->fifoAddr)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->data64.data64_val, (u_int *)&objp->data64.data64_len, ~0, sizeof(u_int), xdr_u_int)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->count)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->setValid)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_uDbg_ShowBreakpts_T(xdrs, objp)
	XDR *xdrs;
	rs_uDbg_ShowBreakpts_T *objp;
{
	if (!xdr_int(xdrs, &objp->res)) {
		return (FALSE);
	}
	if (!xdr_rs_uDbg_BkptArray_T(xdrs, &objp->BkptArray)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rs_CNTL_InitUof_T(xdrs, objp)
	XDR *xdrs;
	rs_CNTL_InitUof_T *objp;
{
	if (!xdr_array(xdrs, (char **)&objp->UofData.UofData_val, (u_int *)&objp->UofData.UofData_len, ~0, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	return (TRUE);
}


