CPU	= ARMSA110
TOOL	= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g -D_DBG_PRINT
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

LIB	= $(LIB_DIR)\rs_udebug.a
LIB_OBJS = rs_uDbg_events_clnt.o rs_uDbg_events_xdr.o rs_udbg_interface.o \
	   rs_udebug_svc.o rs_udebug_xdr.o \
           rsSC_udebug_svc.o rs_SCudbg_xdr.o rs_udebug_comm.o \
           rs_udbg_init.o

INCLUDE = \
	-I../../utils \
	-I../../osApi \
	-I../../include \
	-I../../BoardSupport/VxWorks/ixp1200eb \
	-I../../SA1_CoreLibs/core_utils \
	-I../../SA1_CoreLibs/debug_1200 \
	-I../../SA1_CoreLibs/msgq

ADDED_C++FLAGS  = -w -Wall -pedantic -DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS \
 -D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

.SUFFIXES: .o .cpp .c .h .hxx

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe : $(LIB)

$(LIB) : $(LIB_OBJS)
	@ if not exist "$(LIB_DIR)/$(NULL)" mkdir "$(LIB_DIR)"
	$(AR) -rc $(LIB) $(LIB_OBJS)

clean	: 
	$(RM) $(LIB_OBJS) $(LIB)

