/* scommdev.h
 * Serial port communication
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Serial Communication Library
 *  author: drj March 1, 99 Initial version
 *  revisions:
 *  $History: scommdev.h $
 * 
 * *****************  Version 9  *****************
 * User: Drjohns1     Date: 8/30/00    Time: 2:06p
 * Updated in $/dev_1200/Share/scomm
 * 
 * *****************  Version 8  *****************
 * User: Drjohns1     Date: 6/29/00    Time: 3:18p
 * Updated in $/dev_1200/Share/scomm
 * Updated for HPC and to handle multiple devices
 * 
 * *****************  Version 7  *****************
 * User: Drjohns1     Date: 3/27/00    Time: 5:12p
 * Updated in $/dev_1200/Share/scomm
 * Fixed bug...missing time function on hardware (ARM lib)
 * 
 * *****************  Version 2  *****************
 * User: C-tclancy    Date: 3/23/99    Time: 4:17p
 * Updated in $/development/scomm
 * update COPYRIGHT
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 3/05/99    Time: 9:06p
 * Created in $/users/Johnson/SA1200/scomm
 * 
 * ---------------------------------------------------------------------
 */
#ifndef _SCOMMDEV_H
#define _SCOMMDEV_H

enum{NULL_DEV = -1};

enum {BR_300=300, BR_1200=1200, BR_2400=2400, BR_4800=4800,
	  BR_9600=9600, BR_14400=14400, BR_19200=19200, BR_38400=38400,
	  BR_57600=57600, BR_115200=115200, BR_230400=230400, BR_OTHER};

enum {ONE_STOPBIT=0, TWO_STOPBITS};

enum{BYTE_SIZE5=0, BYTE_SIZE6, BYTE_SIZE7, BYTE_SIZE8};
enum{NO_PARITY=0, ODD_PARITY, EVEN_PARITY};

#define MAX_DEVICE_NAME	32

typedef struct DevCtlBlk{
   char		byteSize;
   char		parity;
   char		stopBits;
   char		enableDev;
   unsigned short status;
   unsigned int baudRate;
} DevCtlBlk_T;


class Device{
public:
	Device(void){}
	~Device(){}

	virtual int get(char *buf, unsigned int len) = 0;
    virtual int put(char *buf, unsigned int len) = 0;
	virtual int created(void) = 0;
	virtual void enableDev(void) = 0;
	virtual void disableDev(void)= 0;

	virtual int setBaud(int baudrate){return(baudrate);}
	virtual int getBaud(void){return(BR_OTHER);}
	virtual int setDevCtlBlk(DevCtlBlk_T *devCtlBlk){
		if(devCtlBlk->enableDev) enableDev(); else disableDev();
		return(0);
	}
	virtual int getDevCtlBlk(DevCtlBlk_T *devCtlBlk){return(0);}
    virtual void acceptConn(void){};

	virtual inline void enableIntTx(){};
	virtual inline void enableIntRx(){};
	virtual inline void disableIntTx(){};
	virtual inline void disableIntRx(){};
    virtual inline void clearInterrupt(){};

private:
	int status;
};

#endif		/* _SCOMMDEV_H */
