#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "ostype.h"
#include "scomm.h"
#include "utils.h"

#define MAX_MSGLEN 1024

const unsigned int SRAM_BASE = 0x10000000;
static sem_T SramPrintSem;

typedef struct {
	unsigned int numStr;
	char *firstStr, *lastStr;
}SramPrint_T;

SramPrint_T *SramPrint;

int sramPrint(char *format,...)
{
   static char	msg[MAX_MSGLEN];
   int msgLen;
   va_list ap;

   //Sem_Wait(SramPrintSem, SEM_WAITFOREVER);
   va_start(ap, format);
   msgLen = vsprintf(msg, format, ap);
   va_end(ap);
   if(msgLen < 0) return(msgLen);

#if (OS == UCOS)
   memmove(SramPrint->lastStr, msg, msgLen+1);
   SramPrint->lastStr += msgLen;
   SramPrint->numStr++;
#else
   printf("%s", msg); fflush(stdout);
#endif
   //Sem_Post(SramPrintSem);
   return(msgLen);
}

void sramDump(void)
{
#if (OS == UCOS)

	unsigned int i;
	char *s = SramPrint->firstStr;

	for(i=0; i < SramPrint->numStr; i++){
	   printf("%s\n", s);
	   s = (char *)s + strlen(s);
	}
#endif
    return;
}

void initSramPrint(int restart)
{
#if (OS == UCOS)
	SramPrint = (SramPrint_T *)SRAM_BASE;
    SramPrintSem = Sem_Init(1);
	if(restart){
	   SramPrint->firstStr = SramPrint->lastStr = (char *)(SRAM_BASE+sizeof(SramPrint_T));
	   SramPrint->numStr = 0;
	}
#endif
   return;
}
