/* VxWrkHpcDev.h
 * Vxworks Host PCI Communication
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: IXP1200
 *  subsystem:Vxworks HPC Library
 *  author: drj June 27, 2000 Initial version
 *  revisions:
 *  $History: vxWrkHpcDev.h $
 * 
 * *****************  Version 2  *****************
 * User: Drjohns1     Date: 6/29/00    Time: 3:18p
 * Updated in $/dev_1200/Share/scomm
 * Updated for HPC and to handle multiple devices
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 6/28/00    Time: 1:09p
 * Created in $/dev_1200/Share/scomm
 * 
 * ---------------------------------------------------------------------
 */
#ifndef __VXWRKHPCDEV_H
#define __VXWRKHPCDEV_H

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "hpcIf.h"

#include "scommdev.h"

class HpcDev : public Device{
public:
	HpcDev(char *devName);

	~HpcDev();

	int get(char *buf, unsigned int len);
	int put(char *buf, unsigned int len);

	virtual int setBaud(int baudrate){return(baudrate);}
	virtual int getBaud(void){return(BR_OTHER);}
	virtual int setDevCtlBlk(DevCtlBlk_T *devCtlBlk){
		if(devCtlBlk->enableDev) enableDev(); else disableDev();
		return(0);
	}
	virtual int getDevCtlBlk(DevCtlBlk_T *devCtlBlk){return(0);}

	void enableDev(){devEn = 1;}
	void disableDev(){devEn = 0;}
	inline int created(){return((status >= 0));}

private:
	int status, devEn;
	int chanNum;
	unsigned long rxLen, txLen;
	HPC_IRP asyncRead, asyncWrite;
	unsigned int readTimeout, writeTimeout;

	int getDevChan(char *devName);

};

#endif			// __VXWRKHPCDEV_H
