CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../debug_1200 \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils \
-I../msgQ


ADDED_C++FLAGS  = -w -Wall -pedantic -DVxWorkTest \
-DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DVXWORKS \
-D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

HPCTST_OBJS = vxHpcTst.o
VX_HPCTST = $(LIB_DIR)/VxWorks_hpcTst.o

LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/osApi.a


.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe: $(VX_HPCTST)


$(VX_HPCTST) : $(HPCTST_OBJS)
	ldarm --whole-archive -r -o hpcTstx.o $(HPCTST_OBJS) $(LIBRARIES)
	nmarm hpcTstx.o | munch > __CtorDtorx.c
	$(CC)  -c -traditional __CtorDtorx.c
	ldarm -o $@ -r __CtorDtorx.o hpcTstx.o
	@$(RM) __CtorDtorx.o hpcTstx.o

clean : 
	@$(RM) $(VX_HPCTST) $(HPCTST_OBJS)

clean_all: clean
	@make -s -f vxworks_CoreLibs.mak CCMODE=$(CCMODE) clean
