CPU		= ARMSA110
TOOL		= gnu

ifneq ($(CCMODE),DEBUG)
DBG_FLAG =
LIB_DIR	= ..\..\VxWorks_Lib
else
DBG_FLAG = -g
LIB_DIR	= ..\..\VxWorks_Lib\debug
endif

INCLUDE = \
-I../../utils \
-I../../osApi \
-I../../include \
-I../debug_1200 \
-I../../BoardSupport/VxWorks/ixp1200eb \
-I../core_utils \
-I../msgQ


ADDED_C++FLAGS  = -w -Wall -pedantic -DVxWorkTest \
-DOS=VXWORKS -DIOSTYLE=HARDWARE -DVX_WORKS -DVXWORKS \
-D__unix $(INCLUDE)

TGT_DIR=$(WIND_BASE)/target
include $(TGT_DIR)/h/make/defs.bsp
include $(TGT_DIR)/h/make/make.$(CPU)$(TOOL)
include $(TGT_DIR)/h/make/defs.$(WIND_HOST_TYPE)

SRV_OBJS = scommTest_srv.o
CLNT_OBJS = scommTest_clnt.o
SCOMMTEST_SRV = $(LIB_DIR)/VxScommTest_srv.o
SCOMMTEST_CLNT = $(LIB_DIR)/VxScommTest_clnt.o

LIBRARIES = $(LIB_DIR)/core_utils.a \
	  $(LIB_DIR)/osApi.a \
	  $(LIB_DIR)/scomm.a \
	  $(LIB_DIR)/utils.a

.SUFFIXES : .o .cpp .c .h .hxx .list .uc

.cpp.o :
	$(CXX) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

.c.o :
	$(CC) $(DBG_FLAG) $(C++FLAGS) -c $?
	@ echo ""

exe: $(SCOMMTEST_SRV) $(SCOMMTEST_CLNT)

srv : $(SCOMMTEST_SRV)
clnt : $(SCOMMTEST_CLNT)

$(SCOMMTEST_SRV) : $(SRV_OBJS)
	ldarm --whole-archive -r -o scommTstSrv.o $(SRV_OBJS) $(LIBRARIES)
	nmarm scommTstSrv.o | munch > __CtorDtorx.c
	$(CC)  -c -traditional __CtorDtorx.c
	ldarm -o $@ -r __CtorDtorx.o scommTstSrv.o
	@$(RM) __CtorDtorx.o scommTstSrv.o

$(SCOMMTEST_CLNT) : $(CLNT_OBJS)
	ldarm --whole-archive -r -o scommTstClnt.o $(CLNT_OBJS) $(LIBRARIES)
	nmarm scommTstClnt.o | munch > __CtorDtorx.c
	$(CC)  -c -traditional __CtorDtorx.c
	ldarm -o $@ -r __CtorDtorx.o scommTstClnt.o
	@$(RM) __CtorDtorx.o scommTstClnt.o

clean : 
	@$(RM) $(SCOMMTEST_SRV) $(SCOMMTEST_CLNT) $(SRV_OBJS) $(CLNT_OBJS)

clean_all: clean
	@make -s -f vxworks_CoreLibs.mak CCMODE=$(CCMODE) clean
