/* win32ComDev.h
 * Windows32 serial port communication
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Win32 Serial Communication Library
 *  author: drj March 1, 99 Initial version
 *  revisions:
 *  $History: win32ComDev.h $
 * 
 * *****************  Version 18  *****************
 * User: Drjohns1     Date: 6/29/00    Time: 3:18p
 * Updated in $/dev_1200/Share/scomm
 * Updated for HPC and to handle multiple devices
 * 
 * ---------------------------------------------------------------------
 */
#ifndef __WINCOMDEV_H
#define __WINCOMDEV_H

#include <stdio.h>
#include <wtypes.h>
#include <winbase.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "scommdev.h"

class Win32ComDev : public Device{
public:
	Win32ComDev(char *devName);

	~Win32ComDev();

	int get(char *buf, unsigned int len);
	int put(char *buf, unsigned int len);
	int setBaud(int baudrate);
	int getBaud(void);
	int setDevCtlBlk(DevCtlBlk_T *devCtlBlk);
	int getDevCtlBlk(DevCtlBlk_T *devCtlBlk);

	void enableDev(){devEn = 1;}
	void disableDev(){devEn = 0;}
	inline int created(){return((status >= 0));}

private:
	int status, devEn;
	HANDLE fh;
	unsigned long rxLen, txLen;
	DCB ctlBlk;
	OVERLAPPED asyncRead, asyncWrite;
	COMMTIMEOUTS commTimeOuts;

};

#endif			// __WIN32COMDEV_H