/* win32HpcDev.h
 * Windows32 HPC Communication
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: HPC Communication Library
 *  author: drj June 21, 2000 Initial version
 *  revisions:
 *  $History: win32HpcDev.h $
 * 
 * *****************  Version 2  *****************
 * User: Qabuild      Date: 8/10/00    Time: 1:38p
 * Updated in $/dev_1200/Share/scomm
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 6/28/00    Time: 1:09p
 * Created in $/dev_1200/Share/scomm
 * 
 * ---------------------------------------------------------------------
 */
#ifndef __WIN32HPCDEV_H
#define __WIN32HPCDEV_H

#include <stdio.h>
#include <wtypes.h>
#include <winbase.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "scommdev.h"

// device name should be HPC01 -- where the first digit indicates the device number (0 in this case),
// and the other digit is the channel number 
class WinHpcDev : public Device {
public:
	WinHpcDev(char *devName);

	~WinHpcDev();
	int get(char *buf, unsigned int len);
	int put(char *buf, unsigned int len);
	inline void enableDev(){devEn = 1;}
	inline void disableDev(){devEn = 0;}
	inline int created(){return((status >= 0));}

private:
	int status, devEn;
	HANDLE hpc_fh;
	unsigned long rxLen, txLen, readTimeout, writeTimeout;
	OVERLAPPED asyncRead, asyncWrite;
	COMMTIMEOUTS commTimeOuts;

	//dj: hpc device status
	//struct stIOCTLMsgStatus stDriverStatus;
};


#endif			// __WIN32HPCDEV_H