/* win32SockDev.h
 * Windows32 Socket communication
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *  system: SA1200
 *  subsystem: Serial Communication Library
 *  author: drj March 1, 99 Initial version
 *  revisions:
 *  $History: win32SockDev.h $
 * 
 * *****************  Version 5  *****************
 * User: Drjohns1     Date: 8/30/00    Time: 2:06p
 * Updated in $/dev_1200/Share/scomm
 * 
 * *****************  Version 4  *****************
 * User: Drjohns1     Date: 6/29/00    Time: 3:18p
 * Updated in $/dev_1200/Share/scomm
 * Updated for HPC and to handle multiple devices
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 12/03/99   Time: 1:15p
 * Created in $/dev_1200/Share/scomm
 * 
 * 
 * ---------------------------------------------------------------------
 */
#ifndef __WIN32SOCKDEV_H
#define __WIN32SOCKDEV_H

#include <stdio.h>
#include <iostream.h>
#include <winsock.h>
#include <stdlib.h>
#include <errno.h>

#include "scommdev.h"

const unsigned short MAXHOSTNAME = 128;

class WinSockDev : public Device{
public:
	WinSockDev(char *devName);

	~WinSockDev();

    void acceptConn(void);
	int get(char *buf, unsigned int len);
    int put(char *buf, unsigned int len);

	inline int created(){return((status >= 0));}
	inline void enableDev(){devEn = 1;}
	inline void disableDev(){devEn = 0;}

private:
	SOCKET sd, sconn;
	struct sockaddr_in mySockAddr, fromSockAddr;
	struct hostent *hp;
	char   hostName[MAXHOSTNAME];	
	int    status, devEn;
	sem_T  connSem;
};

#endif			// __WIN32SOCKDEV_H