/*
 * ---------------------------------------------------------------------	
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 * ---------------------------------------------------------------------
 *
 */

#if !defined(__TRANSACTORINTERFACE_H)
#define __TRANSACTORINTERFACE_H

#include "xact.h"

class CXactInterface
{
public:
    CXactInterface();
    ~CXactInterface();
    void ExecuteCommand(const CString& CommandLine);
    void PromptCallback(char *pPrompt);
    void OutputCallback(const char *pMessage);
    char *CommandCallback();
    DWORD ThreadFunction();
    void SetOutputWindow(HWND hOutputWindow);

private:
    void LogCommand(const CString& CommandLine);
    bool StartThread(int ThreadPriority = THREAD_PRIORITY_NORMAL);

    CRITICAL_SECTION m_Critical;

    HWND m_hOutputWindow;
    CString m_CommandLine;
    CString m_Prompt;
    HANDLE m_hThreadSignal;
    HANDLE m_hThread;
};

extern CXactInterface theXactInterface;

#define WM_REPORT_TRANSACTOR_OUTPUT             (WM_USER + 101)
#define WM_REPORT_TRANSACTOR_PROMPT             (WM_USER + 102)

#endif      // #if !defined(__TRANSACTORINTERFACE_H)
