/* delay.c
 * Common Library
 *
 *---------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998-1999 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 *---------------------------------------------------------------------------
 *
 *
 *  system: SA1200
 *  subsystem: Debug Library
 *  author: drj, Dec 2,98  Initial version
 *  revisions:
 *  $History: delay.c $
 * 
 * *****************  Version 1  *****************
 * User: Drjohns1     Date: 7/24/00    Time: 5:42p
 * Created in $/dev_1200/osApi
 * 
 * *****************  Version 11  *****************
 * User: Drjohns1     Date: 4/04/00    Time: 6:18p
 * Updated in $/dev_1200/Utils
 * OS type check and cleanup
 * 
 * 
 * ---------------------------------------------------------------------
 */
#include "delay.h"
#if (OS == UNIX)
#include <pthread.h>
#endif

static const char __copyright[] =
"Copyright Intel Corp, 1998. All rights reserved";

/*-----------------------------------------------------------------------------
   Function: 	delayMs
   Description: Suspends the process for the specified milli-seconds
   Returns:		
   Uses:
   Modifies:
-----------------------------------------------------------------------------*/
#if (OS == UNIX)
void delayMs(unsigned int msec)
{
   struct timespec req, rem;
   unsigned int t;

   if(msec >= 1000) req.tv_sec = msec/1000;
   else req.tv_sec = 0;

   t = msec - (req.tv_sec * 1000);
   req.tv_nsec = t * 1000000;
#if (defined(__DECC) || defined(__DECCXX))
   pthread_delay_np(&req);
#else
   nanosleep(&req, &rem);
#endif
   return;
}

void delayTick(unsigned int tick)
{
   struct timespec req, rem;
   req.tv_sec = 0;
   req.tv_nsec = tick;
#if (defined(__DECC) || defined(__DECCXX))
   pthread_delay_np(&req);
#else
   nanosleep(&req, &rem);
#endif
   return;
}

#endif

