/*----------------------------------------------------------------------------
 *                                                                      
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  1998 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 ***************************************************************************
 * $Log: /dev_1200/osApi/ostype.h $
 * 
 * 1     7/24/00 5:42p Drjohns1
 * 
 * 8     4/05/00 4:37p Dmwhite
 * took out some unwanted comments
 * 
 * 7     4/04/00 5:24p Jdguilfo
 * I forgot to change something before
 * 
 * 
 * 2     7/08/99 12:59p Drjohns1
 * Defined NT OS type
 * 
 * 1     5/24/99 3:53p Jdguilfo
 * Initial version, untested
 * 
*/
#ifndef OSTYPE_H
#define OSTYPE_H

/*************************************************************************
 * This file is used to define two Operating System types:
 * VXWORKS
 * UCOS
 *
 * Files that depend on the type of the OS should include this file and
 * conditionalize their code along the lines of:
 * 
 * #if (OS == VXWORKS)
 * ...
 * #elif (OS == UCOS)
 * ...
 * #endif
 *
 * Then the command line for the module should include something to 
 * the effect:
 *
 *      ... -DOS=VXWORKS ...
 * or   ... -DOS=UCOS ...
 * etc.
 * 
 **********************************************************************/

#define VXWORKS   1
#define UCOS      2
#define WIN_32	  3
#define UNIX      4

/* try default settings */
#ifndef OS
 #if defined(WIN32)
 #define OS WIN_32
 #elif defined(__unix) || defined(__unix__)
 #define OS UNIX
 #endif
#endif

#ifndef OS
#error OS must be defined on the command line
#endif
#if ((OS != VXWORKS) && (OS != UCOS) && (OS != WIN_32) && (OS != UNIX))
#error "OS" contains an invalid value: OS
#endif

#endif
/* ifdef OSTYPE_H, leave blank line at end of this file, please */
