/***********************************************************
*	StrongArm Version Network Processor Load Balancer  *
*	                                                   *
*	microengine.cpp l4lbadm.cpp l4lbadm.h npvs_sim.h   *
*	                                                   *
*	version 0.9                                        *
*	                                                   *
*	Author: Bala                                       *
*	                                                   *
*	Date : 2001/Jun                                    *
*	                                                   *
***********************************************************/

#include <vxWorks.h>
#include <string.h>
#include <timers.h>
#include <stdio.h>
#include <stdlib.h>
#include <inetLib.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <wdLib.h>
#include <taskLib.h>
#include <semLib.h>
#include <sysLib.h>

#define SRAM_BASE 0x10000000
#define SCRATCH_MEMORY_BASE 0xB0044000
#define VIP "128.198.60.130"

extern void test_main(void);
extern void probe_test(void);
extern void PethDrvInit(void);
int set_timeout_para(void);
int sem_scan(void);
void set_tab_zero();
void count();
void initial();
int scan();
unsigned long npvs_con_hash_key( unsigned long _saddr, unsigned short _sport);
unsigned long npvs_tcp_state_idx(struct tcphdr * tcp_hdr);
void dr_mac(struct ether_header *__ethdr, struct con_table_entry *entry_ptr);
struct con_table_entry *npvs_con_add_hash(struct ip *_iphdr, unsigned short rs);
struct con_table_entry *npvs_con_hash_lookup(struct ip *_iphdr);
void npvs_microengine(struct ether_header *_ethdr);
void gsd(unsigned long id);
void start_npvs(void);

//void start_scan();
//void start_hash();
//void start_sim();
//int hash();
//int sem_hash(void);


//int sp_hash_in();

struct abc
{
	unsigned char timer:5,
	              state:2,
		      valid:1;
};
struct con_table_entry
{
	unsigned long s_addr;
	union {
	unsigned char flag;
	struct abc xyz;
	} flags;
	unsigned char rs_nd;
	unsigned short s_port;
};
struct con_table_key
{
	struct con_table_entry con_table_key_base[8];
};
struct con_table
{
	struct con_table_key con_table_base[16*1024];
};
/*************************************************************/
union con_mac_entry
{
	unsigned char dmac[8];
	unsigned long lmac[2];
};
struct con_mac_table
{
	union con_mac_entry rs_mac[256];
};
/*************************************************************/
struct ser_con_setup_num
{
	unsigned long increase[256];
};
struct ser_con_release_num
{
	unsigned long decrease[256];
};
/*************************************************************/
struct ser_list
{
	unsigned long list[8192];
};
/*************************************************************/
enum {
	NPVS_S_SYN_RECV=1,
	NPVS_S_ESTABLISHED,
	NPVS_S_CLOSE_WAIT
};
/*************************************************************/

