/**
 * Longhua Nov. 18th, 2001
 * Define wrap around functions for Linux functions gethostbyaddr(), gethostbyname()
 **/

/*The hostent structure is defined in <netdb.h> as follows:
struct hostent 
{
	char    *h_name;        // official name of host
	char    **h_aliases;    // alias list 
	int     h_addrtype;     // host address type 
	int     h_length;       // length of address 
	char    **h_addr_list;  // list of addresses 
}
*/
#include <netdb.h>
#include <sys/socket.h>

struct hostent *gethostbyaddr(const char *addr, int len, int type);
struct hostent *gethostbyname(const char *name);
struct servent *getservbyname(const char *name, const char *proto);


