#include <stdio.h> 
#include <string.h> 
#include "core_io.h"  
#include "hal_sram.h"
#include "hal_sdram.h"
#include "hal_fbi.h"
#define SRAM_SIZE           0x00200000  /* 2 Meg Bytes */
#define SDRAM_SIZE           0x01800000  /* 32 Meg Bytes */
#define SCRAPTCH_SIZE         1024        /* 1k longwork*/

#define IXP1200_PCI_CSR_BASE 0x42000000 /* Base of PCI Unit CSR's */
#define IXP1200_RESET                 (IXP1200_PCI_CSR_BASE + 0x07C)

#define IXP1200_REG_WRITE(a,val) (*(volatile UINT32 *)(a) = (val))


extern "C" {
          int OctalMACResetAll(int mac/*=0*/);
          int GigMACResetAll();
          }

void MemClr(void)    
{
 unsigned int  i ;
 /* Clear the SDRAM memory 32MB*/
/* for(i=0; i< ( SDRAM_SIZE >> 2) ;i++)
  SDRAM_Write(i,0); */
 
 /* Clear the SRAM memory 2MB  */
 for(i=0; i< ( SRAM_SIZE >> 2) ; i++)
   SRAM_Write(i, 0);

 /*Clear the scraptch memory 1K longword */
 for(i=0; i< SCRAPTCH_SIZE ; i++)
   Scratch_Write(i,0);
}

void IXP1200_Reset(void)
{
   
   IXP1200_REG_WRITE(IXP1200_RESET,0xffffffff);
  //  IXP1200_REG_WRITE(IXP1200_RESET,0x1003f);
   OctalMACResetAll(0);  
   GigMACResetAll();
 

}