#ifndef _DISPATCHER_H
#define _DISPATCHER_H
#include <wdLib.h>
#include <semLib.h>


#define SRAM_BASE    0x10000000
#define SERVER_LIST1 0x4000
#define SERVER_LIST2 0x6000
#define SER_LIST_PTR 0x280
#define MAX_SER_LIST_LEN 8192 /*Maximum dispatch list entry */
#define SER_LIST_ENTRY_WIDTH 1

/* Weight Index */
#define DEFAULT_WGHT		0
#define RESPONSE_WGHT		1
#define CONNECTION_WGHT 	2
#define RESPONSE_RATIO		3
#define CONNECTION_RATIO	4
 
/*Schedule Method */
#define RR	0
#define WRR	1
#define LC	2
#define WLC	3
#define FR	4
#define	WFR	5
#define CUSTOM	99


#define DISPATCH_STOP 0
#define DISPATCH_HALT 1
#define DISPATCH_RUN  99

/*Mapping to the upper define, may reference the equation "weight_calculate
	for the usage of these parameters"*/
struct server_weight
{	int def_wght;
 	int rspnd_wght;
	int con_wght;
 	double rspnd_ratio;
 	double con_ratio;
};

/* use for passing the related info after create a sub server list */
struct cycle_info
{	int min;
	long sum;
	int more_cycle; /* 1: requre more cycle to calculate, 0: no more*/
};

/*struct server_mac
{	unsigned long mac1;
	unsigned short mac2;
};*/

/* weight for form the dispatching list */
struct cycle_weight
{	int wght;
	int srv_id;
	struct cycle_weight *next;
};

/* The second row bit allocation in server list 
struct  row2
{	unsigned short	mac_val;
	unsigned short	srv_no;
};*/
/* structure for representing the combination of four assignment for real servers
struct sequence
{	unsigned long mac1;
	struct  row2 mac2;
};*/

/* use to pass the value of weight to set */
union weight
{	int intgr;
	double dbl;
};

/*use for watchdog program to identify the parameters*/
struct dispatch_config
{	WDOG_ID wid_dispatch;
	SEM_ID dispatch_wait;
	int dispatch_period; /*msec*/
	int action;/* 0: stop, 1: halt, others: keep on*/
};
 
extern struct prb_cnfg config[MAX_CLUSTER];
extern unsigned long srv_ip_addr[NPVS_REAL_SERVER_MAX];
extern double srv_rspnd_tm[NPVS_REAL_SERVER_MAX];
extern int con_num[NPVS_REAL_SERVER_MAX];

/* forward declarations */
void weight_modify(struct cycle_weight * head, int second_min, int max_sum );
void sem_dispatch(int cluster_id);
int dispatch_action(int clstr_id, int value);
int dispatch_list(int * result, int rs_num, unsigned long * seq);
void loop_dispatch_start(int c_id, int * result, int rs_num);
int weight_calculate(struct server_weight * srv_wght, double srv_rspnd, int con_num);
int cluster_calculate(int * result, struct server_weight * srv_wght, double * srv_rspnd, int * con_num, int rs_num);
int config_srv_wght(int item_id, union weight * value, struct server_weight * srv_wght);
int config_clstr_wght(int item_id, union weight * value, struct server_weight * srv_wght, int srv_num);
void print_clstr_wght(struct server_weight *srv_wght, int srv_num);
void print_srv_wght(struct server_weight * srv_wght);
int set_scheduler(int type, struct server_weight * srv_wght, int srv_num);
void print_srv_dsptch_lst(unsigned long * head);
#endif