#ifndef _SRVPRB_H
#define _SRVPRB_H

/* defines */
#define MAX_RESPONSE_SIZE 560
#define PORT_NO 80
#define MAX_CLUSTER 10
#define MAX_SOCKET_PER_PROCESS 8

/* typedefs */
typedef int SOCK_FD;

/* forward declarations */
void error (char* str);
int server_probing(SOCK_FD sock_fd, struct sockaddr_in * srv_addr, char* request_message, struct timespec * time_diff );
void probe_main(struct prb_cnfg * config, double * srv_rspnd_tm, struct server_address * clstr_addr);
void probing_action(int id, int new_value);
void config_rqst_msg(int id, char * msg);
int smooth_time_calc(double * prev, struct timespec * new_value, double pre_weight);
void print_clstr_rspnd_tm(double * rspnd_tm);

/*parameters related to the probing action */
struct prb_cnfg
{
 /* used for starting the probing action, 0: stop, others:atction */
int prb_id;
int prb_run;
char * request_message;
double history_weight;
int (* probing_function)(SOCK_FD, struct sockaddr_in *, char * , struct timespec * );
int (* weight_calc)(double * , struct timespec * , double );
}; 


struct server_address
{	unsigned long ip;
	int port;
};


/*extern struct prb_cnfg config[MAX_CLUSTER];

 value = 0 for end of list, 1 for temporally remove the entry 
extern unsigned long srv_ip_addr[NPVS_REAL_SERVER_MAX];


 for server average response time
used for smoothing the integer time vlaue  
extern double srv_rspnd_tm[NPVS_REAL_SERVER_MAX];  first 0 for end of cluster, -1 for temporaly remove from list */


#endif