/***********************************************************
*	StrongArm Version Network Processor Load Balancer  *
*	                                                   *
*	microengine.cpp l4lbadm.cpp l4lbadm.h npvs_sim.h   *
*	                                                   *
*	version 0.9                                        *
*	                                                   *
*	Author: Bala                                       *
*	                                                   *
*	Date : 2001/Jun                                    *
*	                                                   *
***********************************************************/


#include "npvs_sim.h"

//#define balaDBG
/*************************************************************/

struct con_table *con_tab_ptr;
struct con_mac_table *con_mac_tab_ptr;
struct ser_con_setup_num *con_setup_ptr;
struct ser_con_release_num *con_release_ptr;
struct ser_con_release_num *arm_con_release_ptr;
struct ser_list *ser_list0_ptr;
struct ser_list *ser_list1_ptr;
struct ser_list **ser_list_ptr;
//unsigned long *ser_list_ptr;
unsigned long *ser_list_counter;
unsigned long sr_timeout, es_timeout, cw_timeout;
WDOG_ID  wid_scan=wdCreate();
//WDOG_ID  wid_gsd=wdCreate();
//WDOG_ID  wid_hash=wdCreate();
SEM_ID syncSem_scan;
//SEM_ID syncSem_gsd;
//SEM_ID syncSem_hash;
extern struct id_ip_table
{
	unsigned long ip[256];
} *id_ip_tab_ptr;
/*************************************************************/


#define mES NPVS_S_ESTABLISHED
#define mSR NPVS_S_SYN_RECV
#define mCW NPVS_S_CLOSE_WAIT

struct npvs_tcp_state_t {
	int next_state[3];
};

struct npvs_tcp_state_t npvs_tcp_state_table [] = {
/*        mSR, mES, mCW */
/*syn*/ {{mSR, mES, mSR}},
/*fin*/ {{mCW, mCW, mCW}},
/*ack*/ {{mES, mES, mCW}},
};

/*************************************************************/
//	this function set the NPVS state timeout value.
//	SR 1~31 sec	ES 1~31 min	CW 1~31 (10sec)
//	this function can dynamic change timeout value

int set_timeout_para(void)
{
	struct timespec aa,bb;
	aa.tv_sec=10;
	aa.tv_nsec=0;
	bb.tv_sec=0;
	bb.tv_nsec=0;
	printf("\nthere are three kind of state in our NPVS:\n");
	//taskDelay(sysClkRateGet()*10);
	nanosleep(&aa,&bb);
	printf("1.syn receive, 2.establish, 3.close wait\n");
	
	printf("please set the timeout value you wish\n");
	do
	{printf("SR 1~31  sec=");
	scanf("%d",&sr_timeout);}
	while(sr_timeout>32);
	printf("\n");
	do
	{printf("ES 1~31  min=");
	scanf("%d",&es_timeout);}
	while(es_timeout>32);
	printf("\n");
	do
	{printf("CW 1~31 (10sec)=");
	scanf("%d",&cw_timeout);}
	while(cw_timeout>32);
	printf("\nsr=%d sec, es=%d min, cw=%d*(10sec)\n", sr_timeout, es_timeout, cw_timeout);
}

/*************************************************************/


/*************************************************************/
int sem_scan(void)
{
	semGive(syncSem_scan);
	wdStart (wid_scan, sysClkRateGet()*1, (FUNCPTR)sem_scan, 0);
}
/*************************************************************/
/* int sem_hash(void)
 * {
 * 	semGive(syncSem_hash);
 * 	wdStart (wid_hash, sysClkRateGet()/60, (FUNCPTR)sem_hash, 0);
 * }
 */
/*************************************************************/
void set_tab_zero()
{
	bzero((char *)con_tab_ptr,1024*1024);
}
/*************************************************************/
//	this function calculate the number of valid entry of hash table
void count()
{
unsigned long counter;
unsigned long i,j,b;
counter=0;
for (i=0; i<=(16*1024)-1; i++)
{
	for (j=0; j<=7; j++)
	{
		b=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz.valid;
		if (b==0)
		continue;
		else
		{
			counter=counter+1;
			
		}
	}	
}
printf("valid entry is = %d\n",counter);
}

/*************************************************************/
/* 	void start_hash()
 * 	{
 * 		wdStart (wid_hash, sysClkRateGet()/60, (FUNCPTR)sem_hash, 0);
 * 	}
 */
/*************************************************************/

/*************************************************************/
//	we use this function to start "Watch Dog", which can 
//	run every fix time, just like " sysClkRateGet()*1 = 60 tick "
//	because watch dog is ISR, ISR can't be interrupt by other function
//	so the watch dog only to one thing "give the semaphore to TASK"

void start_scan()
{
	wdStart (wid_scan, sysClkRateGet()*1, (FUNCPTR)sem_scan, 0);

}
/*************************************************************/
//	this function must be run before any other function run
//	we setup every memory allocate and clear to zero

void initial()
{
	unsigned long i, j;
	syncSem_scan = semBCreate (SEM_Q_FIFO, SEM_EMPTY);
//	syncSem_hash = semBCreate (SEM_Q_FIFO, SEM_EMPTY);
	con_tab_ptr = (struct con_table *)(SRAM_BASE + 0x40000*4);
	con_mac_tab_ptr = (struct con_mac_table *)(SRAM_BASE + 0x2500*4);
	con_setup_ptr = (struct ser_con_setup_num *)(SCRATCH_MEMORY_BASE + 0x100*4);
	con_release_ptr = (struct ser_con_release_num *)(SCRATCH_MEMORY_BASE + 0x300*4);
	ser_list0_ptr = (struct ser_list *)(SRAM_BASE + 0x4000*4);
	ser_list1_ptr = (struct ser_list *)(SRAM_BASE + 0x6000*4);
	ser_list_ptr =  (struct ser_list **)(SRAM_BASE + 0x280*4);
	*ser_list_ptr = ser_list0_ptr;
	ser_list_counter = (unsigned long *)(SRAM_BASE + 0x290*4);
	id_ip_tab_ptr = (struct id_ip_table *)malloc(256*4);
	arm_con_release_ptr = (struct ser_con_release_num *)malloc(256*4);
	
	bzero((char *)con_tab_ptr,1024*1024);
	bzero((char *)con_setup_ptr,256*4);
	bzero((char *)con_release_ptr,256*4);
	bzero((char *)ser_list_counter,4);
	bzero((char *)con_mac_tab_ptr,256*2*4);
	bzero((char *)id_ip_tab_ptr,256*4);
	bzero((char *)arm_con_release_ptr,256*4);
//	bzero((char *)ser_list0_ptr,8192*4);
//	bzero((char *)ser_list1_ptr,8192*4);

//	here is for test dispatch real server
//	fill the real server to the ser_list0_ptr
//	quoquo will implement this
/*
	for (i=0; i<8192; i++)
	{	j=i%3;
		switch (j)
		{
		case 0:
			ser_list0_ptr->list[i]=3;
			ser_list1_ptr->list[i]=3;
			break;
		case 1:
			ser_list0_ptr->list[i]=1;
			ser_list1_ptr->list[i]=1;
			break;
		case 2:
			ser_list0_ptr->list[i]=2;
			ser_list1_ptr->list[i]=2;
			break;
		default : 
			printf("error!!\n");
			break;
		}
	}
*/
//	this is initial the real server MAC address to mac table
//	i will implement the user interface to management this table
	
/* longhua
	id_ip_tab_ptr->ip[0]=inet_addr("140.96.115.31");
	(con_mac_tab_ptr->rs_mac[0]).lmac[0]=0x0050bab3;
	(con_mac_tab_ptr->rs_mac[0]).lmac[1]=0x0000c77e;
 longhua */
/* 128.198.60.194 is gandalf*/

	id_ip_tab_ptr->ip[0]=inet_addr("128.198.60.194");
	// Gandalf mac eth1
	(con_mac_tab_ptr->rs_mac[0]).lmac[0]=0x0800097a;
	(con_mac_tab_ptr->rs_mac[0]).lmac[1]=0x0000a390;

	// Gandalf mac eth0
/*	(con_mac_tab_ptr->rs_mac[0]).lmac[0]=0x00b0d0ce;
	(con_mac_tab_ptr->rs_mac[0]).lmac[1]=0x0000f961;
*/

/*	(con_mac_tab_ptr->rs_mac[0]).dmac[0]=0x00;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[1]=0x50;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[2]=0x56;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[3]=0xbf;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[4]=0xff;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[6]=0x73;
*	(con_mac_tab_ptr->rs_mac[0]).dmac[7]=0xf3;
*/	
/* longhua
	id_ip_tab_ptr->ip[1]=inet_addr("140.96.115.73");
	(con_mac_tab_ptr->rs_mac[1]).lmac[0]=0x00a0c967;
	(con_mac_tab_ptr->rs_mac[1]).lmac[1]=0x0000893c;
 longhua */
/* 128.198.60.193 is vinci*/

	id_ip_tab_ptr->ip[1]=inet_addr("128.198.60.193");
	//frodo (vinci) mac eth1
	/*(con_mac_tab_ptr->rs_mac[1]).lmac[0]=0x0800097a;
	(con_mac_tab_ptr->rs_mac[1]).lmac[1]=0x0000a394;*/
	// frodo (vinci) mac eth0
	(con_mac_tab_ptr->rs_mac[1]).lmac[0]=0x00b0d0cf;
	(con_mac_tab_ptr->rs_mac[1]).lmac[1]=0x00000505;

	// wait mac
	/*(con_mac_tab_ptr->rs_mac[1]).lmac[0]=0x00b0d0cf;
	(con_mac_tab_ptr->rs_mac[1]).lmac[1]=0x0000052a;
	*/


/*	(con_mac_tab_ptr->rs_mac[1]).dmac[0]=0x00;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[1]=0x50;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[2]=0xba;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[3]=0xb3;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[4]=0xff;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[6]=0xc7;
*	(con_mac_tab_ptr->rs_mac[1]).dmac[7]=0x7e;
*/	

/* longhua
	id_ip_tab_ptr->ip[2]=inet_addr("140.96.115.5");
	(con_mac_tab_ptr->rs_mac[2]).lmac[0]=0x005056bf;
	(con_mac_tab_ptr->rs_mac[2]).lmac[1]=0x000073f6;
 longhua */

/*	(con_mac_tab_ptr->rs_mac[2]).dmac[0]=0x00;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[1]=0xa0;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[2]=0xc9;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[3]=0x67;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[4]=0xff;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[6]=0x89;
*	(con_mac_tab_ptr->rs_mac[2]).dmac[7]=0x3c;
*/

/* longhua
	id_ip_tab_ptr->ip[3]=inet_addr("140.96.115.235");
	(con_mac_tab_ptr->rs_mac[3]).lmac[0]=0x005056ab;
	(con_mac_tab_ptr->rs_mac[3]).lmac[1]=0x000073f6;
 longhua */

//	i spawn the task to scan the connection table for timeout value
//	but the task "scan" can't run immediate, it must get the semaphore
//	form "watch dog". watch dog will give the semaphore to TASK_SCAN 
//	every fix time.

//taskSpawn("TASK_HASH", 0, 0, 10000, (FUNCPTR)hash, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	printf("initial ok....!!!!!\n");
}
void start_npvs(void)
{
PethDrvInit();
//taskSpawn("TASK_PROBE", 100, 0, 10000, (FUNCPTR)probe_test, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
taskSpawn("TASK_DISPATCH", 100, 0, 10000, (FUNCPTR)test_main, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
taskSpawn("TASK_SCAN", 255, 0, 10000, (FUNCPTR)scan, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
sr_timeout=6;
es_timeout=6;
cw_timeout=6;
start_scan();

}
/*************************************************************/
/*	int hash() 
 *	{
 *		register unsigned long i, j;
 *		register struct abc aaa;
 *		unsigned long k;
 *		while(1)
 *		{
 *		semTake(syncSem_hash, WAIT_FOREVER);
 *		for (i=0; i<=16*1024-1; i++)
 *			{
 *			for (j=0; j<=7; j++)
 *				{
 *				k=rand()%10;
 *				if(k!=1)
 *				break;
 *				aaa=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz;
 *				aaa.valid=1;
 *				aaa.state=rand()%3;
 *				aaa.timer=0;
 *				(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz=aaa;
 *				}
 *	 		}	
 *	//	semClear(syncSem_hash);	
 *		}
 *	}
 */
 
/*************************************************************/

void gsd(unsigned long id)
{
	register unsigned long i, j;
	register struct abc aaa;
	unsigned long gsd_count;
	while(1)
	{
		gsd_count=0;
		for (i=0; i<=16*1024-1; i++)
		{
			for (j=0; j<=7; j++)
			{
				aaa=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz;
				if (aaa.valid==0)
				continue;
				else
				if(id==(con_tab_ptr->con_table_base[i]).con_table_key_base[j].rs_nd);
				gsd_count++;
			}
		}
	
		if(gsd_count==0)
		{
			id_ip_tab_ptr->ip[id]=0;
			bzero( (char *) &(con_mac_tab_ptr->rs_mac[id]),8);
			printf("hash table has no real server %d entry\n",id);
			printf("gracefully shutdown real server %d success\n",id);
			return;
		}
	taskDelay(sysClkRateGet()*3);
	}
}

/*************************************************************/
//	this function is the main part to scan the total connection table entry
//	because we design to set three kind of different scale to count down the entry
//	


int scan()
{
register unsigned long i, j;
register struct abc aaa;
unsigned long temp1, temp2, temp3;
unsigned long scale_es=60, scale_cw=10;
unsigned char rsnd;
struct timespec aa;
while(1)
{
semTake(syncSem_scan, WAIT_FOREVER);
scale_es=scale_es-1;
scale_cw=scale_cw-1;

#ifdef balaDBG
printf("\n");
printf("es=%d,cw=%d\n",scale_es,scale_cw);
clock_gettime(CLOCK_REALTIME,&aa);
temp1=aa.tv_nsec;
printf("sec=%d\n",aa.tv_sec);
printf("nsec=%d\n",aa.tv_nsec);
#endif balaDBG

for (i=0; i<=16*1024-1; i++)
{
	for (j=0; j<=7; j++)
	{
		aaa=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz;
		if (aaa.valid==0)
		continue;
		else
		{
		switch (aaa.state)
		{
		case 1:
			if(aaa.timer==sr_timeout-1)
			{aaa.valid=0;
			rsnd=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].rs_nd;
			
			arm_con_release_ptr->decrease[rsnd]=(arm_con_release_ptr->decrease[rsnd])++;}
			else
			{(aaa.timer)++;}
			(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz=aaa;
			break;
		case 2:
			if(scale_es!=0)
			break;
			if(aaa.timer==es_timeout-1)
			{aaa.valid=0;
			rsnd=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].rs_nd;
			arm_con_release_ptr->decrease[rsnd]=(arm_con_release_ptr->decrease[rsnd])++;}
			else
			{(aaa.timer)++;}
			(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz=aaa;
			break;
		case 3:
			if(scale_cw!=0)
			break;
			if(aaa.timer==cw_timeout-1)
			{aaa.valid=0;
			rsnd=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].rs_nd;
			arm_con_release_ptr->decrease[rsnd]=(arm_con_release_ptr->decrease[rsnd])++;}
			else
			{(aaa.timer)++;}
			(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz=aaa;
			break;
		default :
			aaa.valid=0;
			rsnd=(con_tab_ptr->con_table_base[i]).con_table_key_base[j].rs_nd;
			arm_con_release_ptr->decrease[rsnd]=(arm_con_release_ptr->decrease[rsnd])++;;
			(con_tab_ptr->con_table_base[i]).con_table_key_base[j].flags.xyz=aaa;
			break;
		}
		}
	}
}
if(scale_es==0)
{scale_es=60;}
if(scale_cw==0)
{scale_cw=10;}

#ifdef balaDBG
clock_gettime(CLOCK_REALTIME,&aa);
printf("sec=%d\n",aa.tv_sec);
printf("nsec=%d\n",aa.tv_nsec);
temp2=aa.tv_nsec;
temp3=(temp2-temp1)/16666666;
printf("tick number = %d\n", temp3);
#endif balaDBG
//semClear(syncSem_scan);
}
}

/*************************************************************/
unsigned long npvs_con_hash_key( unsigned long _saddr, unsigned short _sport)
{
 	return ((_saddr)^(_sport)) & (0x00003fff);
}
/*************************************************************/
unsigned long npvs_tcp_state_idx(struct tcphdr * tcp_hdr)
{
	if(((tcp_hdr->th_flags)&TH_SYN))
		{return 1;}
	else if(((tcp_hdr->th_flags)&TH_FIN))
		{return 2;}
//	else if(((tcp_hdr->th_flags)&TH_ACK))
	else {return 3;}
//	else return NULL;
}
/*************************************************************/
void dr_mac(struct ether_header *__ethdr, struct con_table_entry *entry_ptr)
{
	union con_mac_entry *mac_entry;
	unsigned char rs_temp;
	unsigned char mac;
	rs_temp=entry_ptr->rs_nd;
//	mac=(con_mac_tab_ptr->rs_mac[rs_temp]).dmac[4];
	mac_entry= &(con_mac_tab_ptr->rs_mac[rs_temp]);
//	if (mac!=255)
//	{
//		printf("arp resolving not yet!\n");
//		return;
//	}
	__ethdr->ether_dhost[0]=mac_entry->dmac[3];
	__ethdr->ether_dhost[1]=mac_entry->dmac[2];
	__ethdr->ether_dhost[2]=mac_entry->dmac[1];
	__ethdr->ether_dhost[3]=mac_entry->dmac[0];
	__ethdr->ether_dhost[4]=mac_entry->dmac[5];
	__ethdr->ether_dhost[5]=mac_entry->dmac[4];
	__ethdr->ether_shost[0]=0x00;
	__ethdr->ether_shost[1]=0x00;
	__ethdr->ether_shost[2]=0xca;
	__ethdr->ether_shost[3]=0xfe;
	__ethdr->ether_shost[4]=0xba;
	__ethdr->ether_shost[5]=0xbe;
	
	return;
}
/*************************************************************/
struct con_table_entry *npvs_con_add_hash(struct ip *_iphdr, unsigned short rs)
{
 unsigned long saddr;
 unsigned short sport;
 unsigned long hash,i;
 struct con_table_key *key_ptr;
 struct con_table_entry *entry_ptr;

	saddr = ntohl((_iphdr->ip_src).s_addr);
	sport = ntohs( ((struct tcphdr *)(((char *)_iphdr) + (_iphdr->ip_hl)*4))->th_sport);
	hash = npvs_con_hash_key( saddr, sport);
	key_ptr = (struct con_table_key *) ( (((unsigned long)hash<<6)) + (unsigned char *)con_tab_ptr);
	entry_ptr=(struct con_table_entry *)key_ptr;
	for ( i=0; i<8; i++)
	{
		if ( (entry_ptr->flags).xyz.valid==0)
		{
			entry_ptr->s_addr=saddr;
			entry_ptr->s_port=sport;
			entry_ptr->rs_nd=rs;
			(entry_ptr->flags).xyz.valid=1;
			(entry_ptr->flags).xyz.state=0;
//			clock_gettime(CLOCK_REALTIME,&time);
			(entry_ptr->flags).xyz.timer=0;
//			printf("hash add success!!\n");
			return entry_ptr;
		}
		entry_ptr=entry_ptr + 1;
//		entry_ptr=(struct con_table_entry *)((unsigned char *)entry_ptr + (unsigned char *)8);
	}
	printf("hash table key is full!!\n");
	return NULL;
}
/*************************************************************/	

struct con_table_entry *npvs_con_hash_lookup(struct ip *_iphdr)
{
 unsigned long saddr;
 unsigned short sport;
 unsigned long hash,i;
 struct con_table_key *key_ptr;
 struct con_table_entry *entry_ptr;

	saddr = ntohl((_iphdr->ip_src).s_addr);
	sport = ntohs( ((struct tcphdr *)(((char *)_iphdr) + (_iphdr->ip_hl)*4))->th_sport);
	hash = npvs_con_hash_key( saddr, sport);
	key_ptr = (struct con_table_key *) ( (((unsigned long)hash<<6)) + (unsigned char *)con_tab_ptr);
//	key_ptr = (struct con_table_key *) ( (unsigned char *)(hash<<6) + (unsigned char *)con_tab_ptr);
	entry_ptr=(struct con_table_entry *)key_ptr;

#ifdef balaDBG	
	printf("hash key = %d\n",hash);
	printf("hash key = %d\n",(hash<<6));
	printf("con_tab_ptr address=%x\n",con_tab_ptr);
	printf("key_ptr address=%x\n",key_ptr);
	printf("entry_ptr address=%x\n",entry_ptr);
#endif balaDBG
	for ( i=0; i<8; i++)
	{
		if ( ( (entry_ptr->flags).xyz.valid==1) && ( (entry_ptr->s_addr) == saddr ) && ( (entry_ptr->s_port) == sport ) )
		{
			return (entry_ptr);
		}
		entry_ptr=entry_ptr + 1;
//		entry_ptr=(struct con_table_entry *)((unsigned char *)entry_ptr + (unsigned char *)8);
	}
	return NULL;
}
/*************************************************************/
//	this function is process the IXP 1200 microengine's job


void npvs_microengine(struct ether_header *_ethdr)
{
struct ip *iphdr;
struct tcphdr *thdr;
unsigned long vip, sec_hit, idx;
struct con_table_entry *hash_temp;
unsigned short new_state, real_server, k;


	iphdr = (struct ip *)( ((char *)_ethdr) + 14);
	vip = inet_addr(VIP);
	if (((iphdr->ip_dst).s_addr)!=vip)
	{
		printf("this packet is not match vip!!\n");
		return;
	}
	else 
	{
		printf("match vip!!\n");
		printf("Source	    MAC = %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n",_ethdr->ether_shost[0],_ethdr->ether_shost[1],_ethdr->ether_shost[2],_ethdr->ether_shost[3],_ethdr->ether_shost[4],_ethdr->ether_shost[5]);
	        printf("Destination   MAC = %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n",_ethdr->ether_dhost[0],_ethdr->ether_dhost[1],_ethdr->ether_dhost[2],_ethdr->ether_dhost[3],_ethdr->ether_dhost[4],_ethdr->ether_dhost[5]);
	}
	if ((iphdr->ip_p)!=6)
	{	
		printf("this packet is not match protocol!!\n");
		return;
	}
	else 
	{
		printf("match protocol!!\n");
	}

	thdr = (struct tcphdr *)( ((char *)iphdr) + (iphdr->ip_hl)*4);
//	printf("iphdr->ip_p=%d\n",iphdr->ip_p);
//	printf("port=%d\n",ntohs(thdr->th_dport));
	
	if ( (ntohs(thdr->th_dport)) != 80 )
	{	
//		printf("this packet is quoquo's!!\n");
		return;
	}
	else 
	{
		printf("match port!!\n");
	}

#ifdef balaDBG
	printf("this packet's sip  =%s\n", inet_ntoa( (iphdr->ip_src).s_addr ));
	printf("this packet's dip  =%s\n", inet_ntoa( (iphdr->ip_dst).s_addr ));
	printf("this packet's sport=%x\n", ntohs(thdr->th_sport));
	printf("this packet's dport=%x\n", ntohs(thdr->th_dport));
	printf("this packet's proto=%d\n", iphdr->ip_p);
#endif balaDBG

	hash_temp=npvs_con_hash_lookup(iphdr);
	printf("1.hash_temp = %x\n",hash_temp);
	
if(hash_temp!=NULL)
{

	if( (thdr->th_flags == (TH_FIN|TH_ACK) ) || (thdr->th_flags ==  TH_RST) )
	{
		((hash_temp->flags).xyz).valid=0;
		(con_release_ptr->decrease[hash_temp->rs_nd])++;
	}
	else
	{
		if( (idx=npvs_tcp_state_idx(thdr))==NULL)
		{
		printf("error for npvs_tcp_state_idx!!\n");
		return;
		}
		new_state = (npvs_tcp_state_table[(idx-1)]).next_state[((hash_temp->flags).xyz).state];
		((hash_temp->flags).xyz).state=new_state;
		((hash_temp->flags).xyz).timer=0;
	}
}
else
{
	if ( (thdr->th_flags) != TH_SYN )
	{return;}
	real_server =(unsigned long)( (*ser_list_ptr)->list[*ser_list_counter]);
	if(real_server==0)
	{*ser_list_counter=0;
	real_server =(unsigned long)( (*ser_list_ptr)->list[*ser_list_counter]);
	*ser_list_counter = *ser_list_counter + 1;
	}
	else
	{
//	printf("1.real_server=%d\n",real_server);
	if((*ser_list_counter+1)<8192)
	{*ser_list_counter = *ser_list_counter + 1;}
	else
	{*ser_list_counter=0;}
	}
	real_server=real_server-1;
	hash_temp=npvs_con_add_hash(iphdr, real_server);
//	printf("2.hash_temp = %x\n",hash_temp);
//	printf("2.real_server=%d\n",real_server);
	(con_setup_ptr->increase[real_server])++;
//	printf("3.real_server=%d\n",real_server);
}
	dr_mac(_ethdr, hash_temp);
	return;
//	printf("this packet is process complete!!!\n");
}