/*
** minimal SSLProxy server for content switch project
** pieces of code taken from modssl which is protected under the below licence
 *			ganesh kumar godavari (gkgodava@archie.uccs.edu)
 *
 * modified: Longhua Li  01/22/02
*/

/* general libraries */
/*#include <setjmp.h>*/

#include "msock.h"
#include "misc.h"
/*#include "prefork.h"*/

#define MIN(a,b) 		(a>b) ? b : a

static SSL *ssl=(SSL *) NULL;
static SSL_CTX  *ctx;

/* contants definition for access from path */
char *log_file;
char *ca_file;
char *ca_path;
char *key_file;
char *cert_file;
char *rand_file;

union semun {
  int val;
  struct semid_ds *buf;
  ushort *array;
};

int semID;           			/* ID of the semaphore set.       	*/
union semun sem_val;  			/* semaphore value, for semctl(). 	*/

#if 0
static int long_jumped=0;
static sigjmp_buf jmpbuf;
static volatile sig_atomic_t canjump;
static FILE *log_fp = (FILE *) NULL;
#endif

static int sslVerifyCallback(int ok,X509 *xs,X509 *xi,int depth,int error,char *arg);
static void serveRequest(int fd,struct front_server *remote_ip);

void fatalError(char *format,...)
{
    va_list  args;

    va_start(args,format);
    (void) fprintf (stderr,"Error: ");
    vfprintf(stderr,format,args);
    va_end(args);
    exit(ERROR);
}

/*
** write all the junk!!  which u think may be useful to Administrator
**
*/
void logPrint(FILE * log_fp,char * format,...)
{
     va_list  args;
    time_t   now;


   char   *time_string;

    if(log_fp == NULL) {
	(void) fprintf(stderr,"unable to identify how the log file %s closed \n",LOG_FILE);
	return;
    }

    now=time(NULL);

    time_string=ctime(&now);
    time_string[strlen(time_string)-1]='\0';

    va_start(args,format);

    (void) fprintf(log_fp,"[%s]",time_string);
    (void) vfprintf(log_fp,format,args);

    va_end(args);
    fflush(log_fp);
    return;

}

#if 0
static void sigAlarm(int sigtype)
{
    if (canjump == 0)
    {
        return;
    }
    canjump=1;
    long_jumped=1;
    siglongjmp(jmpbuf,1);
}
#endif

static u_long pow(int a, int b)
{
u_long temp=0;

if (b == 0) return 1;

if (b == 1) return a;

for ( ;b>1; b--)
  temp = temp + (a*a);

return temp;
}

/*
** function converts hexadecimal string to a decimal integer.
*/
static u_long Hex(char *s)
{
int pos=0;
u_long value=0;
int len = strlen(s)-2; /* skipping the \r\n characters here*/
#if 0
fprintf(stderr,"the string to be converted to decimal from hexadecimal is %s",s);
#endif

for(pos = 0, s += (len-1),value=0 ;pos<len ;s--,pos++)
{
  switch(*s)
  {
  case 'a':
  case 'A':
           value = value + (pow(16,pos) * 10);
           break;


  case 'b':
  case 'B':
           value = value + (pow(16,pos) * 11);
           break;

  case 'c':
  case 'C':
           value = value + (pow(16,pos) * 12);
           break;


  case 'd':
  case 'D':
           value = value + (pow(16,pos) * 13);
           break;

  case 'e':
  case 'E':
           value = value + (pow(16,pos) * 14);
           break;

  case 'f':
  case 'F':
           value = value + (pow(16,pos) * 15);
           break;

  case '0':
  case '1':
  case '2':
  case '3':
  case '4':
  case '5':
  case '6':
  case '7':
  case '8':
  case '9':
           value = value + (pow(16,pos) * (*s - '0'));
           break;
 default:
         return value;
         break;
  }
}

#if 0
fprintf(stderr,"\n\n value to be returned is %d\n\n ",value);
#endif

return value;
}

#if 0 /*longhua*/
void make_absolute_path(void)
{
if (
(log_file =
     (char *) malloc (sizeof (SERVER_ROOT) + sizeof (LOG_FILE) + 1)) == NULL
    ||
    (sess_file  = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(SESS_FILE) + 1)) == NULL ||
    (ca_file    = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(CA_FILE) + 1)) == NULL ||
    (ca_path    = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(CA_PATH) + 1)) == NULL ||
    (key_file   = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(KEY_FILE) + 1)) == NULL ||
    (cert_file  = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(CERT_FILE) + 1)) == NULL ||
    (rand_file  = (char *) malloc( sizeof(SERVER_ROOT) + sizeof(RAND_FILE) + 1)) == NULL )
  {
   (void) fprintf(stderr," unable to allocate memory for converting relative paths to absolute paths");
   exit(1);
  }
(void) sprintf(log_file,"%s/%s",SERVER_ROOT,LOG_FILE);
(void) sprintf(sess_file,"%s/%s",SERVER_ROOT,SESS_FILE);
(void) sprintf(ca_file,"%s/%s",SERVER_ROOT,CA_FILE);
(void) sprintf(ca_path,"%s/%s",SERVER_ROOT,CA_PATH);
(void) sprintf(key_file,"%s/%s",SERVER_ROOT,KEY_FILE);
(void) sprintf(cert_file,"%s/%s",SERVER_ROOT,CERT_FILE);
(void) sprintf(rand_file,"%s/%s",SERVER_ROOT,RAND_FILE);
 return;
}
#endif
/*
** borrowed from mod_ssl
*/
int SSL_smart_shutdown(SSL *ssl)
{
    int i;
    int rc;

    /*
     * Repeat the calls, because SSL_shutdown internally dispatches through a
     * little state machine. Usually only one or two interation should be
     * needed, so we restrict the total number of restrictions in order to
     * avoid process hangs in case the client played bad with the socket
     * connection and OpenSSL cannot recognize it.
     */

    rc = 0;
    for (i = 0; i < 4 /* max 2x pending + 2x data = 4 */; i++) {
        if ((rc = SSL_shutdown(ssl)))
            break;
    }

    return rc;
}

int count=0;
int child_function(int sock_fd)
{
    struct front_server szclient;
    char buf[512];
    int err;

    /*
    ** get name, IP adress, and port number of the client
    */
    (void) fprintf(stderr, "In child_function\n");

    getPeerInfo(sock_fd,&szclient);

#if 0
    alarm(CLIENT_TIMEOUT);


    sigsetjmp(jmpbuf,1);
    if (long_jumped == 1)
    {
        /*
        ** back from a long jump, alarm timer expired
        */
        long_jumped=0;
        canjump=1;
        goto ExitProcessing;
    }
#endif

     ssl=SSL_new(ctx);
     if (ssl == NULL)
         fatalError("Failed in SSL_new()!\n");

     SSL_set_fd(ssl,sock_fd);


     /*
     ** session handling functions
     */
#if 0
     SSL_CTX_flush_sessions(ctx,SSL_SESSION_CACHE_TIMEOUT);
     SSL_CTX_sess_set_new_cb(ctx, ssl_callback_NewSessionCacheEntry);
     SSL_CTX_sess_set_get_cb(ctx, ssl_callback_GetSessionCacheEntry);
     SSL_CTX_sess_set_remove_cb(ctx, ssl_callback_DelSessionCacheEntry);
#endif

    /*
    ** cleanup the structures
    */
    SSL_clear(ssl);
    SSL_set_session(ssl,NULL);
    SSL_set_accept_state(ssl);

   printf("before the loop\n");
   while(!SSL_is_init_finished(ssl))
   {
       printf("inside the loop\n");
     err=SSL_accept(ssl);

     printf("after ssl_accept\n");

     if (SSL_get_error(ssl, err) == SSL_ERROR_ZERO_RETURN)
      {
       /*
       ** case where the connection was closed before any data was transferred
       */
       (void) fprintf(stderr, "SSL handshake stopped: connection was closed");
       goto ExitProcessing;

      }
     else if (ERR_GET_REASON(ERR_peek_error()) == SSL_R_HTTP_REQUEST)
          {
                /*
                ** case where OpenSSL has recognized a HTTP request => client speaks plain HTTP on our HTTPS
                */
		(void)fprintf(stderr, "SSL handshake failed: HTTP spoken on HTTPS port; ");
		goto ExitProcessing;

          }
     else if (SSL_get_error(ssl, err) == SSL_ERROR_SYSCALL)
          {
                if (errno > 0)
                    (void) fprintf(stderr,"SSL handshake interrupted by system "
                            "[Hint: Stop button pressed in browser?!]\n");
                else

                    (void) fprintf(stderr, "Spurious SSL handshake interrupt"
                            "[Hint: Usually just one of those OpenSSL confusions!?]\n");

		goto ExitProcessing;

          }
	else if (err == -1)
              {
	        fatalError("Error :%d unknown error in SSL_accept() %s\n",taskName(taskIdSelf()), ERR_error_string(ERR_get_error(),buf));
		goto ExitProcessing;

	      }
    }

    serveRequest(sock_fd,&szclient);
ExitProcessing:
    SSL_set_shutdown(ssl,SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
    SSL_smart_shutdown(ssl);
    SSL_free(ssl);
    /*ssl_mutex_file_close(); */
    close(sock_fd);
    printf("child task done\n");
    return OK;

}


/**
 * starts the ssl server listen to port 443 by default
 **/
int preforkServer(u_short port)
{
 int sockd,sockd2,len,
     one = 1;
 int taskNum =0, taskPriority;
 char taskName[16];
 struct sockaddr_in mysocket, peer;
 struct linger   li;

 bzero((char *)&mysocket,sizeof(mysocket));

 mysocket.sin_port = htons(port);
 mysocket.sin_addr.s_addr = INADDR_ANY;
 mysocket.sin_family = AF_INET;


 if((sockd = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
 {
   fprintf(stderr,"socket creation error socket\n");
   return ERROR;
 }
    /*
    ** we will resuse port
    */

 setsockopt(sockd,SOL_SOCKET,SO_REUSEADDR,(char *) &one, sizeof(int));

  /*
  ** we will set keep alive.  read Steven, Network Prog. 2nd edition, p186
  */
   one=1;
   setsockopt(sockd,SOL_SOCKET,SO_KEEPALIVE,(char *) &one, sizeof(int));

    li.l_onoff=1;
    li.l_linger=30;
    setsockopt(sockd,SOL_SOCKET,SO_LINGER,(char *) &li, sizeof(struct linger));

  if(bind(sockd,(struct sockaddr *)&mysocket,sizeof(mysocket)) < 0)
  {
  	fprintf(stderr,"unable to bind\n");
	perror("bind");
	close(sockd);
  	return ERROR;
  }

  if(listen(sockd,SERVER_MAX_CONNECTIONS) == ERROR)
  {
        perror ("listen");
        close (sockd);
        return ERROR;
  }
  len = sizeof(mysocket);
  if(getsockname(sockd,(struct sockaddr *)&mysocket,&len) < 0)
  {
        perror("getsockname");
        return ERROR;
  }
  printf("bound to %d\n",ntohs(mysocket.sin_port));
  fflush(stdout);
  printf("this is getting used ...\n");
  fflush(stdout);
  printf("sockd = %d\n",sockd);


  /*init_daemon("SSL_PROXY",(int) StartServers,(int) MaxClients,(int) MaxRequestsPerChild,(int) MaxSpareServers,(int) MinSpareServers,child_function,(int)sockd);  exit(0);
*/
/*longhua */
	taskPriorityGet(taskIdSelf(),&taskPriority);
	printf("taskPriority is %d\n", taskPriority);

	while(1)
	{
		if((sockd2 = accept(sockd,(struct sockaddr *)&peer,sizeof(struct sockaddr_in))) == ERROR)  {
  			fprintf(stderr,"accept: %s",strerror(errno));
			perror("accept");
			close(sockd);
  	    		return ERROR;
    		}
		/*child_function(sockd2);*/

		sprintf (taskName, "tSSLProxy%d", ++taskNum);
		if(taskSpawn(taskName,100,0,20000,(FUNCPTR)child_function,sockd2,0,0,0,0,0,0,0,0,0) == ERROR)
		{
			/* if taskSpawn fails, close fd and return to top of loop */
	  		perror ("taskSpawn");
     		        close (sockd2);
		}
		printf("spawn a task %d\n",taskNum);

	}

/*longhua*/
return OK;

}


/* main entrance function */
int sslproxy(int argc, char **argv)
{
    int err;

    char
         szbuf[BUFSIZ],
         issuer[256];

    /* Changed from SSLv23_server_method to SSLv2_server_method */

    SSL_METHOD *method=SSLv2_server_method(); /*for sslv2 and sslv3*/

    X509 *ca_cert, *client_cert;

    FILE *ca_fp=(FILE *) NULL;

    SSL_load_error_strings();
    OpenSSL_add_ssl_algorithms();
    /*longhua (void)make_absolute_path();     /* convert relative to absolute path */
    /*sess_file  = SESS_FILE;*/
    ca_file    = CA_FILE;
    ca_path    = CA_PATH;
    key_file   = KEY_FILE;
    cert_file  = CERT_FILE;
    rand_file  = RAND_FILE;
    log_file   = LOG_FILE;
    /*longhua ends	*/


    ctx=(SSL_CTX *) SSL_CTX_new(method);

    if (ctx == (SSL_CTX *) NULL)
    {
      fatalError("Unable to create new SSL CTX\n");
      SSL_set_shutdown(ssl,SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
      SSL_smart_shutdown(ssl);
      SSL_free(ssl);
      return ERROR;
    }

    if (!SSL_CTX_load_verify_locations(ctx,ca_file,ca_path))
        fatalError("Failed in SSL_CTX_load_verify_locations()!\n");

    /*
     * Load Private Key
     */
    if (SSL_CTX_use_RSAPrivateKey_file(ctx, key_file, SSL_FILETYPE_PEM) == ERROR)
    {
       	(void) fprintf(stderr,"Error reading private key\n");
	SSL_CTX_free(ctx);
        return ERROR;
    }

   /*
    * Load Certificate
    */
   if (SSL_CTX_use_certificate_file(ctx, cert_file, SSL_FILETYPE_PEM) == ERROR)
    {
        (void) fprintf(stderr,"Error reading certificate\n");
	SSL_CTX_free(ctx);
        return ERROR;
    }

   /**
    * check if the certificate and private key match
    **/
   if (SSL_CTX_check_private_key(ctx) == ERROR)
    {
       	(void) fprintf(stderr,"Error cerificate and private key do not match \n");
	SSL_CTX_free(ctx);
       	return ERROR;
    }else {
	printf("verifying the private key succesful\n");

	}



    /**
     * Load randomness
     **/
    if (!RAND_load_file(rand_file,1024*1024))
    {
         (void) fprintf(stderr,"Unable to load Randomness for generating Entropy :-( \n");
    }

    /*
    ** read the ca certificate and save the issuer string, we'll compare
    ** the client's issuer with this one, if they match allow connection
    ** or zap him
    */
    ca_fp=fopen(ca_file,"r");
    if (ca_fp == (FILE *) NULL)
        fatalError("Failed to open Trusted CA certificate file: %s\n", ca_file);

    ca_cert=NULL;
    ca_cert=X509_new();
    if (!PEM_read_X509(ca_fp,&ca_cert,NULL,NULL))
        fatalError("Error reading trusted CA certificate fie: %s\n",ca_file);

     X509_NAME_oneline(X509_get_issuer_name(ca_cert),issuer,256);
    if (issuer == (char *) NULL)
        fatalError("No issuer for trusted CA certificate file!\n");


    if (ca_cert != NULL)
        X509_free(ca_cert);


   (void) fclose(ca_fp);

/*
#define     CIPHER_LIST "ALL:!ADH:!LOW:!EXP:!MD5:@STRENGTH"

   SSL_CTX_set_cipher_list(ctx,CIPHER_LIST);
*/

#if 0

    printf("opening log file=%s\n", log_file);
    /* open the log file */
    if((log_fp=fopen(log_file,"a+"))== NULL)
	(void) fprintf(stderr, "unable to open the log file");

   	logPrint(log_fp,"log file opened...\n");
    shm_id = shmget(IPC_PRIVATE, sizeof(struct load), IPC_CREAT | IPC_EXCL | 0600);

    if (shm_id == -1)
    {
        (void) fprintf(stderr,"Unable to allocate shared memory\n");
        exit(1);
    }

    /* attach the shared memory segment to our process's address space. */
    shm_addr = shmat(shm_id, NULL, 0);
    if (!shm_addr)  /* operation failed. */
    {
        (void) fprintf(stderr,"Error: unable to attach the shared memory to our process's address space\n ");
        exit(1);
    }

    /* create a semaphore */
    semID = semget(IPC_PRIVATE, 1, IPC_CREAT | 0600);
    if (semID == -1) {
        (void) fprintf(stderr,"Error: unable to create a semaphore\n");
        exit(1);
    }

    /* intialize the semaphore to '1'. */
    sem_val.val = 1;
    err = semctl(semID, 0, SETVAL, sem_val);

    if (err == -1)
    {
        (void) fprintf(stderr,"Error: unable to initialize the semaphore");
        exit(1);
    }

    scoreboard = (struct load *) shm_addr;

    /*
    ** store the Session FIlename and file descriptors
    */
    ssl_mutex_file_open(sess_file);
    open_critical_lock();

    /*
    ** most cool Unix will take care of Zombies if we ignore SIGCHLD
    */
    signal(SIGCHLD,SIG_IGN);
    signal(SIGPIPE,SIG_IGN);
    signal(SIGALRM,sigAlarm);

    noCoredump();
    daemonize();
#endif

    /*
    ** open the server socket
    */
	return (preforkServer((u_short) SERVER_PORT));



 }

/*
** here i am fixing the method and protocol name field to 10 bytes. i feel allocating  10 bytes is waste of "resource"
*/
static int parseRequest(char *req,char *method,char *url,char *proto,char *args,int len)
{
    char
        *chp,
        *m,
        *u,
        *p;

    if (req == NULL || *req == '\0')
        return (-1);

    /*
    ** Method
    */
    m=strtok(req,"\t ");
    if (m == NULL)
        return(-1);
    (void) strncpy(method,m,10);
    method[10]='\0';

    /*
    ** Url
    ** Url can't have any spaces
    */
    u=strtok(NULL,"\t\r ");
    if (u == NULL)
        return(-1);
    chp=strchr(u,'?');
    if (chp)
    {
        *chp++ = '\0';
        (void) strncpy(args,chp,len);
    }

    (void) strncpy(url,u,len);
    url[len]='\0';

    /*
    ** HTTP Protocol version
    */
    p=strtok(NULL,"\r ");
    if (p == NULL)
        return(-1);
    (void) strncpy(proto,p,10);
    proto[10]='\0';

    return (0); /* OK */
}


/*
** borrwed from thttpd
*/

static int hexDigit(char c)
{
    if (strchr("0123456789abcdefABCDEF",c) != (char *) NULL)
        return (1);

    return (0);
}

/*
** find a substring from a string
** case insensitive
*/
int stristr(char *haystack,char *needle)
{
    int
        i, j, k, l;

    for (i = 0; haystack[i]; i++)
    {
        for (j = 0, l = k = i; haystack[k] && needle[j] &&
            tolower(haystack[k]) == tolower(needle[j]); j++, k++)
                ;
        if (needle[j] == '\0')
            return (i);
    }
    return -1;
}

/*
** returns the formated text i.e replacing the text containing source with dest
** none of the arguments are modified
*/

char *replace(char *text, char *source, char *dest)
{
  char *nh,newtext[1024];
  int start=0,end=0;


  if((start=stristr(text,source)) == -1)
  {
    (void) fprintf(stderr," unable to locate substring\n");/* %s in the string %s\n",text,source);*/
     return NULL; /*longhua */
  }

  nh = NULL;
  if((nh = (char *) malloc(1024))== NULL)
  {
   (void) fprintf(stderr, "unable to allocate memory for the header\n");
   return NULL;
  }

  strncpy(nh,text,start);
  nh[start]='\0';

  end = strlen(source);

strcpy(newtext,nh);
strcat(newtext,dest);
strcat(newtext,(text+start+end));
strcpy(text,newtext);

/*
** when i am freeing the memory occupied by headers and nh it is causing SIGSEGV(Segmentation Fault) only for I.E not for netscape
** damn these browers / damn my coding as one of these is wrong
** free(header);
** free(nh);
*/

/*longhua adds*/
#if 1
  free(nh);
#endif
/*longhua ends*/

 return text;
}


void demoResponse(char *url)
{
 char body[1024];
 char content_length[64];
 sprintf(body," <!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">
                   <HTML><HEAD>
                   <TITLE>404 Not Found</TITLE>
                   </HEAD><BODY>
                   <H1>Not Found</H1>
                   The requested URL %s was not found on this server.<P>
                   <HR>
                   <ADDRESS>Apache/1.3.14 Server at %s  Port 80</ADDRESS>
                   </BODY></HTML>",url,SERVER_NAME);

 sprintf(content_length,"Content-Length: %d\r\n",strlen(body));

 sockPutsSSL(ssl,"HTTP/1.0 404 OK\r\n");
 sockPutsSSL(ssl,"MIME-version: 1.0\r\n");
 sockPutsSSL(ssl,content_length);
 sockPutsSSL(ssl,"Content-Type: text/html\r\n\r\n");


 sockPutsSSL(ssl,body);

/* return;*/
}

/*
** serverRequest is currently clumsy -- fix it and make it readable(gkgodava@archie.uccs.edu)
*/
static void serveRequest(int fd,struct front_server  *remote_ip)
{
  char
     header[1024],
     chunked_body[1024],
     *val,
     szcontent_type[BUFSIZ],
     ruleheader[BUFSIZ],
     szmethod[10],
     szurl[BUFSIZ],
     szproto[10],
     szargs[BUFSIZ],
     body[IOBUFFSIZE],
     TargetServer[128],
     szbuf[BUFSIZ],
     *serverName,
     *temp;


  int
     maxfd,
     nready,
     close_connection,
     chunked,
     content_length,
     server_sock_fd,
     chunk_size,
     status_code,
     data_read;

  float version;


  struct timeval  tv;
  Connection *conn_rec = NULL;
  u_long ret_addr;
  fd_set   readfds;


  printf("In servRequest\n");

KEEPALIVE:
  /* if the client does not respond within the timeout limit, zap it  */
   FD_ZERO(&readfds);

   maxfd=SSL_get_fd(ssl)+1;
   FD_SET(SSL_get_fd(ssl),&readfds);


  content_length=0;
  data_read=0;
  *szcontent_type='\0';
  *szmethod='\0';
  *szurl='\0';
  *szproto='\0';
  *szargs='\0';
  *szbuf='\0';

   tv.tv_sec=CLIENT_TIMEOUT;
   tv.tv_usec=0;

    nready=select(maxfd,&readfds,NULL,NULL,&tv);
    if (nready == 0)
    {
        (void) fprintf(stderr," *** task id %d Timed out in %d seconds ***\n",taskIdSelf(),CLIENT_TIMEOUT);
        goto  GracefulExit;
    }

 /*
 ** get request
 */

 if (FD_ISSET(SSL_get_fd(ssl),&readfds))
  {
     /*alarm(0);*/
    /* check whether the packet sent after the connection established has no data -- if so reject it */
     if((sockGetsSSL(ssl,szbuf,sizeof(szbuf)-1)) <= 0)
        goto   disGracefulExit;
   }

  /*
  ** now we can allocate memory for the connection structue as we know it is not a junk request!!
  */
  conn_rec = NULL;
  if( ((conn_rec = (struct Connection *) malloc(sizeof(Connection))) == NULL) ||
       ((conn_rec->cli_ser = (struct front_server *) malloc(sizeof(struct front_server))) == NULL) ||
       ((conn_rec->req = (struct Request *) malloc(sizeof(Request)))  == NULL) )
   {

   	/*logPrint(log_fp,"Unable to create allocate memory for the connection structure !!\n");longhua*/
	printf("Unable to allocate mem for the connection structure!\n");
        goto  GracefulExit;
   }

  memset(conn_rec,0,sizeof(conn_rec));

  conn_rec->req->header=NULL;

  strcpy(header, mystrdup(szbuf));

  if(parseRequest(szbuf,szmethod,szurl,szproto,szargs,BUFSIZ-1) != 0)
  {
	(void) fprintf(stderr," unable to process the request %s \n",szbuf);
        goto  GracefulExit;
  }

   /* logPrint(log_fp," request %s %s %s from %d \n",szmethod, szurl, szproto,remote_ip->addr); longhua */

   while(sockGetsSSL(ssl,szbuf,sizeof(szbuf)-1) > 0)
        {

        strcpy(szargs,szbuf);

        val=strchr(szargs,':');
        if (val)
        {
            /**val++ = '\0';*/
	    *val++;
            if (strncmp("Content-Length",szbuf,strlen("content-length")) == 0)
                content_length=atoi(val);
            if (strncmp("Content-Type",szbuf,strlen("content-type")) == 0)
                (void) strcpy(szcontent_type,val);
            if (strncmp("Host",szbuf,strlen("Host")) == 0)
	    {

		(void) sprintf(szbuf,"%s %s\r\n","Host:",SERVER_NAME);
	    }


        }
        strcat(header,szbuf);
    }
    printf("Header: %s\n", header);

   if((conn_rec->req->header = (char *) malloc(strlen(header)+1)) == NULL)
    {
       (void) fprintf(stderr,"unable to allocate memory for conn->req->header\n");
	printf("unable to allocate memory for conn->req->content_type \n");
        goto  GracefulExit;
    }

   (void) strcpy(conn_rec->req->header,header);

   if(content_length != 0)
   {
     if((conn_rec->req->body = (char *) malloc(content_length+1)) == NULL)
       {
        (void) fprintf(stderr,"unable to allocate memory for conn->req->body\n");
	printf("unable to allocate memory for conn->req->body \n");
        goto  GracefulExit;
       }
      sockReadSSL(ssl,conn_rec->req->body,content_length);
      printf("sockReadSSL conn_rec->req->body: %s\n",conn_rec->req->body);
    }
     else
        conn_rec->req->body=NULL;

    /*
    ** store the connection information as i need to perform rule matching
    */
    memcpy(conn_rec->cli_ser,remote_ip,sizeof(struct front_server));
    strcpy(conn_rec->req->method,szmethod);

    if ((conn_rec->req->url = (char *) malloc(strlen(szurl)+1)) == NULL)
     {
      (void) fprintf(stderr,"unable to allocate memory for conn->req->url\n");
	printf("unable to allocate memory for conn->req->content_type \n");
        goto  GracefulExit;
     }

    (void) strcpy(conn_rec->req->url,szurl);

    if((conn_rec->req->content_type = (char *) malloc(strlen(szcontent_type)+1)) == NULL)
     {
       (void) fprintf(stderr,"unable to allocate memory for conn->req->content_type \r\n");
	printf("unable to allocate memory for conn->req->content_type \n");
        goto  GracefulExit;
     }

    (void) strcpy(conn_rec->req->content_type,szcontent_type);

    /*
    ** performing the rule matching
    */
   if((server_sock_fd=connectTo(RULE_SERVER_NAME,RULE_SERVER_PORT)) == -1) {
     (void) fprintf(stderr,"Failed to connect to the rule module server %s\n",RULE_SERVER_NAME);
     printf("connecting to backup rule module server... \n");
     if((server_sock_fd=connectTo(DEFAULT_RULE_SERVER_NAME,DEFAULT_RULE_SERVER_PORT )) == -1) {
       (void) fprintf(stderr,"Failed to connect to the rule module %s\n",DEFAULT_RULE_SERVER_NAME);
	printf("Failed to connect to the rule module server %s\n",DEFAULT_RULE_SERVER_NAME);

     goto  GracefulExit;
   }

   }

  (void) sprintf(ruleheader,"Port: %d\r\nClientAddr: %d\r\nMethod: %s\r\nUrl: %s\r\nContent-Type: %sContent-Length: %d\r\n\r\n", conn_rec->cli_ser->port, conn_rec->cli_ser->addr, conn_rec->req->method, conn_rec->req->url,conn_rec->req->content_type, content_length);


  /* send the request to the Rule Module */
  sockWrite(server_sock_fd,ruleheader,strlen(ruleheader));
  if(strcmp(conn_rec->req->method, "POST") == 0) {
    printf("Method = POST sockWrite to Rule Module:\n %s \n", conn_rec->req->body);
    sockWrite(server_sock_fd,conn_rec->req->body,content_length);
  }

 while(sockGets(server_sock_fd,szbuf,sizeof(szbuf)-1) > 0)
        {
        val=strchr(szbuf,':');
        if (val)
        {
            /**val++ = '\0';*/
	    *val++;
            if (strncmp("ServerAddress",szbuf,strlen("ServerAddress")) == 0)                ret_addr=atol(val);
            if (strncmp("ServerName",szbuf,strlen("ServerName")) == 0)
		{
			 (void) strcpy(TargetServer,val);
			printf("TargetServer: %s\n", TargetServer);
		}
        }
    }




close(server_sock_fd) ;
TargetServer[strlen(TargetServer)-2] = '\0';

    /*
    ** done with the rule matching
    */


    if(szbuf == NULL)
    {
    (void) fprintf(stderr, "looks like server list has been modified\n");
    goto  GracefulExit;
    }

     conn_rec->req->header = mystrdup(replace(conn_rec->req->header,SERVER_NAME,TargetServer));


   if((server_sock_fd=connectTo(TargetServer,80 )) == -1)
   {
     (void) fprintf(stderr,"Failed to connect to %s\n",TargetServer);
     goto  GracefulExit;
   }
    printf("connected to target server...\n");

  /* send the request to the real server */
  sockPuts(server_sock_fd, conn_rec->req->header);
  sockPuts(server_sock_fd,"\r\n");

  if(strcmp(conn_rec->req->method, "POST") == 0) {
    printf("Method = POST, sockPuts: \n%s\n", conn_rec->req->body);
    sockPuts(server_sock_fd,conn_rec->req->body);
  }

  /* freeing & initializing the values*/
  content_length = 0;
  chunked = 0;
  close_connection = 0;
  status_code = 0;

 if((sockGets(server_sock_fd,szbuf,sizeof(szbuf)-1)) <= 0)
    goto  GracefulExit;
 printf("Response from Target Server:\n%s\n",szbuf);

 /* check for the status code */
  sscanf(szbuf,"HTTP/%f %d \n",&version, &status_code);

  strcpy(header, mystrdup(szbuf));

  while(sockGets(server_sock_fd,szbuf,sizeof(szbuf)-1) > 0)
  {
   strcpy(szargs,szbuf);
   val=strchr(szbuf,':');

   if(val)
    {
     /**val++ = '\0';*/
     *val++;
     if(strncmp("Content-Length",szbuf,strlen("Content-length")) == 0) {
       printf("Content-Length: %d\n",atoi(val));
       content_length=atoi(val);
     }

     if(strncmp("Connection",szbuf,strlen("Connection")) == 0)
	if( strncmp(val," close",strlen(" close")) == 0){
          printf("Connection: %s\n",val);
          close_connection = 1;
        }

    /*
    **  trying to make sure we follow rfc 2616 section 19.4.6
    **  HTTP/1.1 introduces the Transfer-Encoding header field.
    **  Proxies/gateways MUST remove any transfer-coding prior to
    **  forwarding a message via a MIME-compliant protocol.
    */

     if(strncmp("Transfer-Encoding",szbuf,strlen("Transfer-Encoding")) == 0)
     {
      if( strncmp(val," chunked",strlen(" chunked")) == 0)
       {
	printf("%s\n",szbuf);
        chunked = 1;
        strcpy(szcontent_type,szargs);

       }
     }

    /*
    ** RFC 2616 sec 13.5.2
    ** A transparent proxy MUST NOT modify any of the following fields in a
    ** request or response, and it MUST NOT add any of these fields if not
    ** already present:
    **
    **  - Content-Location
    **
    **  - Content-MD5
    **
    **  - ETag
    **
    **  - Last-Modified
    **
    */
     /* i am violating this rule */
     if(strncmp("Location",szbuf,strlen("Location")) == 0)
     {
     strcpy(szargs,replace(szargs,TargetServer,SERVER_NAME));
     strcpy(szargs,replace(szargs,"http","https"));
     (void) fprintf(stderr,"\nthe new location bar is %s\n",szargs);
     }
    }

   strcat(header,szargs);
   }
  printf("Header\n%s\n",header);

  if(status_code > 400 )
  {
   demoResponse(szurl);
  }
  else if(chunked == 1)
  {
   chunk_size=0;
   *chunked_body='\0';
   content_length=0; /* chunked had more preference than content_length */
   if ( sockGets(server_sock_fd,body,IOBUFFSIZE-1) < 0 )

       fprintf(stderr, "unable to read chunked data");
   printf("sockGets body: %s\n",body);

   while((chunk_size=Hex(body)) != 0)
   {

    fprintf(stderr, "szbuf %s chunk size %d \n",szbuf,chunk_size);

    content_length = content_length + chunk_size;

    while ((chunk_size > 0) && ((data_read=sockRead(server_sock_fd,body,MIN(IOBUFFSIZE-1,chunk_size))) > 0 ))
    {
     temp = strrchr(body,'>');
     if(temp != NULL) {
      temp++;
      *temp = '\0';
     }
     chunk_size = chunk_size - data_read;
     strcat(chunked_body,body);
    }

    if (sockGets(server_sock_fd,body,IOBUFFSIZE-1) < 0 )
       fprintf(stderr, "unable to read chunked data\n");
   }

   /* making changes to the header */
   sprintf(szbuf,"Content-Length: %d\r\n",content_length);
   strcpy(szargs, replace(header,szcontent_type,szbuf));

   strcpy(header,szargs);
 }


 if(status_code < 400)
 {
  /*
  ** sending headers to the client
  */
  strcat(header,"\r\n\0");
  printf("sending headers to the client... \n");

  sockWriteSSL(ssl,header,strlen(header));

  /*
  **sending the chunked data as body if the header contains Tansfer-Encoding: chunked\r\n
  */
  if(chunked == 1)
  {
   printf("sending body to client...\n");
   sockWriteSSL(ssl,chunked_body,content_length);
 /*  (void) fprintf(stderr," body is %s\n",chunked_body); */
   content_length =0;
  }

  for(data_read=0; content_length > 0;data_read=0 )
  {
   if ((data_read = iread(server_sock_fd,body,IOBUFFSIZE-1)) < 0)
    {
      if (errno == ECONNRESET)
         (void) fprintf(stderr,"\nconnection was reset by the server\n");
      else
         (void) fprintf(stderr,"\nunable to read data from the socket\n");

      goto  disGracefulExit;
     }
     content_length -= data_read;
     if(data_read != sockWriteSSL(ssl,body,data_read))
     {
       (void) fprintf(stderr,"pid %d unable to pump more data on content length\n",taskIdSelf());
       goto  disGracefulExit;
     }
  }
 }

  if(close_connection == 1)
    goto GracefulExit;
  else
  {
	if(conn_rec != NULL)
	{
	/*
	if(conn_rec->req != NULL)
	{
	if(conn_rec->req->url != NULL)
	 free(conn_rec->req->url);
	if(conn_rec->req->header != NULL)
	 free(conn_rec->req->header);
	if(conn_rec->req->content_type != NULL)
	 free(conn_rec->req->content_type);

	if(conn_rec->req->body != NULL)
	 free(conn_rec->req->body);

	free(conn_rec->req);
	}

	if(conn_rec->cli_ser != NULL)
	 free(conn_rec->cli_ser);
	*/

	free(conn_rec);

	}
	(void) close(server_sock_fd);
	goto KEEPALIVE;
  }

#if 0
   (void) demoResponse();
#endif

GracefulExit:
	if(conn_rec != NULL)
	{

	/*if(conn_rec->req != NULL)
	{

	if(conn_rec->req->header != NULL)
	{
         printf("free conn_rec->header\n");
	 free(conn_rec->req->header);
	}
	if(conn_rec->req->url != NULL)
	{
         printf("free conn_rec->req->url\n");
	 free(conn_rec->req->url);
	}
	if(conn_rec->req->body != NULL)
	{
         printf("free conn_rec->req_body\n");
	 free(conn_rec->req->body);
	}
	if(conn_rec->req->content_type != NULL)
	{
         printf("free conn_rec->req->content_type\n");
	 free(conn_rec->req->content_type);
	}
	printf("free conn_rec->req\n");
	free(conn_rec->req);
	}

	if(conn_rec->cli_ser != NULL)
	{
         printf("free conn_rec->cli_ser\n");
	 free(conn_rec->cli_ser);
	}
	*/
        printf("free conn_rec\n");
	free(conn_rec);
	}

disGracefulExit:

	(void) close(server_sock_fd);
	(void) close(SSL_get_fd(ssl)); /* closing the connection*/
#if 0
	(void) fprintf(stderr,"\n\n closing the ssl context bye bye %d ..\n",taskIdSelf());
#endif
	printf("\n Closing the ssl context bye bye %d ...\n", taskIdSelf());
/*	return; longhua*/
}

static int sslVerifyCallback(int ok,X509 *xs,X509 *xi,int depth,int error, char *arg)
{
    char
        *cip, *issuer_ca, s[256];

    X509_NAME_oneline(X509_get_subject_name(xs),s,256);
    if (s != (char *) NULL)
    {
        if (ok)
        {
            (void) fprintf(stderr,"ok depth=%d,subject=%s\n",depth,s);
	    printf("ok depth=%d,subject=%s\n",depth,s);
        }
        else
            (void) fprintf (stderr,"depth=%d error=%d,subject=%s\n",
                            depth,error,s);
/*	printf("free... s...\n");
        free(s); */
    }
    X509_NAME_oneline(X509_get_issuer_name(xs),s,256);
    if (s == (char *) NULL)
    {
        (void) fprintf (stderr,"verify error\n");
        ok=0;
    }

    (void) fprintf(stderr,"Issuer=%s\n",s);
    printf("Issuer=%s\n",s);
    ok=1;

    return (ok);
}



