
#include "rulemodule.h"


/*
** test fuction to see everything required is there or not should not be in the prototype--gkgodava@archie.uccs.edu
*/
void printRule(Rule *rule)
{

  (void) fprintf(stderr, "Routing details are Port %d ClientAddress %x content-length %d Method %s URL %s content_type %s body %s \n%",rule->port, rule->clientaddr,rule->content_length,rule->method, rule->url,rule->content_type,rule->body);


}

int main(int argc, char **argv) 
{
   char* shm_addr;           		/* address of shared memory segment.  	*/
   int shm_id;               		/* ID of the shared memory segment.   	*/
   short int port;
   int fd;
   int listeningSocket;



/* variables for data transfer */
  int maxfd, nready;
  struct timeval  tv;
  Rule *rule;
  u_long ret_addr;
  fd_set   readfds;
  char  szbuf[BUFSIZ], szurl[BUFSIZ], szcontenttype[BUFSIZ], *val,szargs[BUFSIZ] ;

 
   if (argc != 3) {
      fprintf(stderr,"Syntax : rulemodule -port <portno>\n \t portno cannot be zero\n ");
      return 0;
   }

   if (strcmp(*(++argv),"-port") == 0) {
         port=atoi(*(++argv));
         if (port == 0) fprintf(stderr,"Syntax : rulemodule -port <portno>\n \t portno cannot be zero\n ");
     }

    shm_id = shmget(IPC_PRIVATE, (STICKY_SIZE * sizeof(struct ip_sticky)), IPC_CREAT | IPC_EXCL | 0600);

    if (shm_id == -1)
    {
        (void) fprintf(stderr,"Unable to allocate shared memory\n");
        exit(1);
    }

    /* attach the shared memory segment to our process's address space. */
    shm_addr = shmat(shm_id, NULL, 0);
    if (!shm_addr)  /* operation failed. */
    { 
        (void) fprintf(stderr,"Error: unable to attach the shared memory to our process's address space\n ");
        exit(1);
    }

    sticky_num = (int*) shm_addr;
    *sticky_num = 0;
    sticky = (ip_sticky *) ((void*)shm_addr+sizeof(int));

    open_critical_lock();

    /*
    ** most cool Unix will take care of Zombies if we ignore SIGCHLD
    */
    signal(SIGCHLD,SIG_IGN);
    signal(SIGPIPE,SIG_IGN);

    noCoredump(); 
    daemonize(); 

    /*
    ** open the server socket
    */

    if ((listeningSocket = RuleSocket((u_short) port,1000)) == -1) {
        (void) fprintf(stderr,"Failed to create rulemodule server \n");
        return 0;
    }
 
   for ( ; ; ) {
      fd=accept(listeningSocket,NULL,NULL);
      if (fd < 0)
       {
        /*
        ** either a real error occured or blocking was
        ** interrupted for some reason. only abort execution
        ** if a real error occured
                */
                if (errno != EINTR)
                {
                    (void) fprintf (stderr,"unable to accept!\n");
                    perror("accept");
                    close (listeningSocket);
                    return (-1);
                }
                else
                  continue;
            }


  /* if the client does not respond within the timeout limit, zap it  */
   FD_ZERO(&readfds);

   FD_SET(fd, &readfds);
   maxfd = fd + 1;

   tv.tv_sec=150;
   tv.tv_usec=0;

   nready=select(maxfd,&readfds,NULL,NULL,&tv);
   if (nready == 0)
    {
      (void) fprintf(stderr," *** pid %d Timed out in 150 seconds ***\n",getpid());
      continue; 
    }

 /*
 ** get request
 */
 if(FD_ISSET(fd,&readfds))
  {
    /* check whether the packet sent after the connection established has no data -- if so reject it */
 #if 0
    if((sockGets(fd,szbuf,sizeof(szbuf)-1)) <= 0)
        continue;
 #endif
   }

  /*
  ** now we can allocate memory for the Rule  structue as we know it is not a junk request!!
  */
  if ((rule = (struct Rule *) malloc(sizeof(Rule))) == NULL)  continue;

  
  rule->content_length = 0;

  while(sockGets(fd,szbuf,sizeof(szbuf)-1) > 0) {

        val=strchr(szbuf,':');

        if (val)
        {
            *val++ = '\0';

            if (strncasecmp("Port",szbuf,strlen("Port")) == 0)
                rule->port = atoi(val);

            if (strncasecmp("ClientAddr",szbuf,strlen("ClientAddr")) == 0)
                rule->clientaddr = atol(val);

            if (strncasecmp("Method",szbuf,strlen("Method")) == 0)
                (void) strcpy(rule->method,val);

            if (strncasecmp("Url",szbuf,strlen("url")) == 0)
                (void) strcpy(szurl,val);

            if (strncasecmp("Content-Type",szbuf,strlen("Content-Type")) == 0)
                (void) strcpy(szcontenttype,val);

            if (strncasecmp("Content-Length",szbuf,strlen("Content-Length")) == 0)
                rule->content_length=atoi(val);
        }
    }

   if(rule->content_length != 0)
   {
     if((rule->body = (char *) malloc(rule->content_length+1)) == NULL)
       {
        (void) fprintf(stderr,"unable to allocate memory for rule->body\n");
        continue;
       }
      sockRead(fd,rule->body,rule->content_length);
    }
     else
       rule->body=NULL;


    if ((rule->url = (char *) malloc(strlen(szurl)+1)) == NULL)
     {
      (void) fprintf(stderr,"unable to allocate memory for rule->url \n");
       continue;
     }

    (void) strcpy(rule->url,szurl);


    if((rule->content_type = (char *) malloc(strlen(szcontenttype)+1)) == NULL)
     {
       (void) fprintf(stderr,"unable to allocate memory for rule->content_type \n");
       continue;
     }

    (void) strcpy(rule->content_type,szcontenttype);


   (void) printRule(rule);
   ret_addr = ruleMatching(rule);

  (void) sprintf(szbuf,"ServerAddress: %d\r\nServerName:%s\r\n\r\n",ret_addr,getRealServerName(ret_addr));
  (void)  fprintf(stderr," the return data is  %s",szbuf);


   sockPuts(fd,szbuf);
 close(fd);


 } /* end of the iterative loop */


}

